/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/network","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/api/common/extHostTunnelService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/base/common/stopwatch","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/lazy","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/symbols","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/base/common/hash","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],ke=function(ie){for(var e=[],r=0,k=ie.length;r<k;r++)e[r]=Ce[ie[r]];return e};define(Ce[62],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function r(S,O){const y=Object.create(null);for(const T of S){const N=O(T);let E=y[N];E||(E=y[N]=[]),E.push(T)}return y}e.groupBy=r;function k(S,O){const y=[],T=[];for(const N of S)O.has(N)||y.push(N);for(const N of O)S.has(N)||T.push(N);return{removed:y,added:T}}e.diffSets=k;function D(S,O){const y=[],T=[];for(const[N,E]of S)O.has(N)||y.push(E);for(const[N,E]of O)S.has(N)||T.push(E);return{removed:y,added:T}}e.diffMaps=D;class M{constructor(){this.a=new Map}add(O,y){let T=this.a.get(O);T||(T=new Set,this.a.set(O,T)),T.add(y)}delete(O,y){const T=this.a.get(O);!T||(T.delete(y),T.size===0&&this.a.delete(O))}forEach(O,y){const T=this.a.get(O);!T||T.forEach(y)}}e.SetMap=M}),define(Ce[63],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function r(S){return(O,y,T)=>{let N=null,E=null;if(typeof T.value=="function"?(N="value",E=T.value):typeof T.get=="function"&&(N="get",E=T.get),!E)throw new Error("not supported");T[N]=S(E,y)}}function k(S,O,y){let T=null,N=null;if(typeof y.value=="function"?(T="value",N=y.value,N.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(T="get",N=y.get),!N)throw new Error("not supported");const E=`$memoize$${O}`;y[T]=function(...f){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:N.apply(this,f)}),this[E]}}e.memoize=k;function D(S,O,y){return r((T,N)=>{const E=`$debounce$${N}`,f=`$debounce$result$${N}`;return function(...b){this[f]||(this[f]=y?y():void 0),clearTimeout(this[E]),O&&(this[f]=O(this[f],...b),b=[this[f]]),this[E]=setTimeout(()=>{T.apply(this,b),this[f]=y?y():void 0},S)}})}e.debounce=D;function M(S,O,y){return r((T,N)=>{const E=`$throttle$timer$${N}`,f=`$throttle$result$${N}`,b=`$throttle$lastRun$${N}`,m=`$throttle$pending$${N}`;return function(...o){if(this[f]||(this[f]=y?y():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),O&&(this[f]=O(this[f],...o)),this[m])return;const s=this[b]+S;s<=Date.now()?(this[b]=Date.now(),T.apply(this,[this[f]]),this[f]=y?y():void 0):(this[m]=!0,this[E]=setTimeout(()=>{this[m]=!1,this[b]=Date.now(),T.apply(this,[this[f]]),this[f]=y?y():void 0},s-Date.now()))}})}e.throttle=M}),define(Ce[83],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class r{constructor(D){this.a=D,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=r,e.defaultGenerator=new r("id#")}),define(Ce[111],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var r;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(r=e.ScanError||(e.ScanError={}));var k;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(k=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(i){i.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function S(i,d=!1){let n=0;const a=i.length;let t="",g=0,c=16,u=0;function l(B){let P=0,F=0;for(;P<B;){const H=i.charCodeAt(n);if(H>=48&&H<=57)F=F*16+H-48;else if(H>=65&&H<=70)F=F*16+H-65+10;else if(H>=97&&H<=102)F=F*16+H-97+10;else break;n++,P++}return P<B&&(F=-1),F}function C(B){n=B,t="",g=0,c=16,u=0}function R(){const B=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&T(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&T(i.charCodeAt(n)))for(n++;n<i.length&&T(i.charCodeAt(n));)n++;else return u=3,i.substring(B,n);let P=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&T(i.charCodeAt(n))){for(n++;n<i.length&&T(i.charCodeAt(n));)n++;P=n}else u=3;return i.substring(B,P)}function V(){let B="",P=n;for(;;){if(n>=a){B+=i.substring(P,n),u=2;break}const F=i.charCodeAt(n);if(F===34){B+=i.substring(P,n),n++;break}if(F===92){if(B+=i.substring(P,n),n++,n>=a){u=2;break}switch(i.charCodeAt(n++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const j=l(4);j>=0?B+=String.fromCharCode(j):u=4;break}default:u=5}P=n;continue}if(F>=0&&F<=31)if(y(F)){B+=i.substring(P,n),u=2;break}else u=6;n++}return B}function ee(){if(t="",u=0,g=n,n>=a)return g=a,c=17;let B=i.charCodeAt(n);if(O(B)){do n++,t+=String.fromCharCode(B),B=i.charCodeAt(n);while(O(B));return c=15}if(y(B))return n++,t+=String.fromCharCode(B),B===13&&i.charCodeAt(n)===10&&(n++,t+=`
`),c=14;switch(B){case 123:return n++,c=1;case 125:return n++,c=2;case 91:return n++,c=3;case 93:return n++,c=4;case 58:return n++,c=6;case 44:return n++,c=5;case 34:return n++,t=V(),c=10;case 47:{const P=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<a&&!y(i.charCodeAt(n));)n++;return t=i.substring(P,n),c=12}if(i.charCodeAt(n+1)===42){n+=2;const F=a-1;let H=!1;for(;n<F;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,H=!0;break}n++}return H||(n++,u=1),t=i.substring(P,n),c=13}return t+=String.fromCharCode(B),n++,c=16}case 45:if(t+=String.fromCharCode(B),n++,n===a||!T(i.charCodeAt(n)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=R(),c=11;default:for(;n<a&&K(B);)n++,B=i.charCodeAt(n);if(g!==n){switch(t=i.substring(g,n),t){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return t+=String.fromCharCode(B),n++,c=16}}function K(B){if(O(B)||y(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function L(){let B;do B=ee();while(B>=12&&B<=15);return B}return{setPosition:C,getPosition:()=>n,scan:d?L:ee,getToken:()=>c,getTokenValue:()=>t,getTokenOffset:()=>g,getTokenLength:()=>n-g,getTokenError:()=>u}}e.createScanner=S;function O(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function y(i){return i===10||i===13||i===8232||i===8233}function T(i){return i>=48&&i<=57}var N;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(N||(N={}));function E(i,d){const n=[],a=new Object;let t;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function u(l,C,R,V){g.value=l,g.offset=C,g.length=R,g.type=V,g.colonOffset=void 0,t=g}try{w(i,{onObjectBegin:(l,C)=>{if(d<=l)throw a;t=void 0,c=d>l,n.push("")},onObjectProperty:(l,C,R)=>{if(d<C||(u(l,C,R,"property"),n[n.length-1]=l,d<=C+R))throw a},onObjectEnd:(l,C)=>{if(d<=l)throw a;t=void 0,n.pop()},onArrayBegin:(l,C)=>{if(d<=l)throw a;t=void 0,n.push(0)},onArrayEnd:(l,C)=>{if(d<=l)throw a;t=void 0,n.pop()},onLiteralValue:(l,C,R)=>{if(d<C||(u(l,C,R,v(l)),d<=C+R))throw a},onSeparator:(l,C,R)=>{if(d<=C)throw a;if(l===":"&&t&&t.type==="property")t.colonOffset=C,c=!1,t=void 0;else if(l===","){const V=n[n.length-1];typeof V=="number"?n[n.length-1]=V+1:(c=!0,n[n.length-1]=""),t=void 0}}})}catch(l){if(l!==a)throw l}return{path:n,previousNode:t,isAtPropertyKey:c,matches:l=>{let C=0;for(let R=0;C<l.length&&R<n.length;R++)if(l[C]===n[R]||l[C]==="*")C++;else if(l[C]!=="**")return!1;return C===l.length}}}e.getLocation=E;function f(i,d=[],n=M.DEFAULT){let a=null,t=[];const g=[];function c(l){Array.isArray(t)?t.push(l):a!==null&&(t[a]=l)}return w(i,{onObjectBegin:()=>{const l={};c(l),g.push(t),t=l,a=null},onObjectProperty:l=>{a=l},onObjectEnd:()=>{t=g.pop()},onArrayBegin:()=>{const l=[];c(l),g.push(t),t=l,a=null},onArrayEnd:()=>{t=g.pop()},onLiteralValue:c,onError:(l,C,R)=>{d.push({error:l,offset:C,length:R})}},n),t[0]}e.parse=f;function b(i,d=[],n=M.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(l){a.type==="property"&&(a.length=l-a.offset,a=a.parent)}function g(l){return a.children.push(l),l}w(i,{onObjectBegin:l=>{a=g({type:"object",offset:l,length:-1,parent:a,children:[]})},onObjectProperty:(l,C,R)=>{a=g({type:"property",offset:C,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:l,offset:C,length:R,parent:a})},onObjectEnd:(l,C)=>{a.length=l+C-a.offset,a=a.parent,t(l+C)},onArrayBegin:(l,C)=>{a=g({type:"array",offset:l,length:-1,parent:a,children:[]})},onArrayEnd:(l,C)=>{a.length=l+C-a.offset,a=a.parent,t(l+C)},onLiteralValue:(l,C,R)=>{g({type:v(l),offset:C,length:R,parent:a,value:l}),t(C+R)},onSeparator:(l,C,R)=>{a.type==="property"&&(l===":"?a.colonOffset=C:l===","&&t(C))},onError:(l,C,R)=>{d.push({error:l,offset:C,length:R})}},n);const u=a.children[0];return u&&delete u.parent,u}e.parseTree=b;function m(i,d){if(!i)return;let n=i;for(const a of d)if(typeof a=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const g of n.children)if(Array.isArray(g.children)&&g.children[0].value===a){n=g.children[1],t=!0;break}if(!t)return}else{const t=a;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}e.findNodeAtLocation=m;function o(i){if(!i.parent||!i.parent.children)return[];const d=o(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;d.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&d.push(n)}return d}e.getNodePath=o;function s(i){switch(i.type){case"array":return i.children.map(s);case"object":{const d=Object.create(null);for(const n of i.children){const a=n.children[1];a&&(d[n.children[0].value]=s(a))}return d}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=s;function h(i,d,n=!1){return d>=i.offset&&d<i.offset+i.length||n&&d===i.offset+i.length}e.contains=h;function p(i,d,n=!1){if(h(i,d,n)){const a=i.children;if(Array.isArray(a))for(let t=0;t<a.length&&a[t].offset<=d;t++){const g=p(a[t],d,n);if(g)return g}return i}}e.findNodeAtOffset=p;function w(i,d,n=M.DEFAULT){const a=S(i,!1);function t(se){return se?()=>se(a.getTokenOffset(),a.getTokenLength()):()=>!0}function g(se){return se?J=>se(J,a.getTokenOffset(),a.getTokenLength()):()=>!0}const c=t(d.onObjectBegin),u=g(d.onObjectProperty),l=t(d.onObjectEnd),C=t(d.onArrayBegin),R=t(d.onArrayEnd),V=g(d.onLiteralValue),ee=g(d.onSeparator),K=t(d.onComment),L=g(d.onError),B=n&&n.disallowComments,P=n&&n.allowTrailingComma;function F(){for(;;){const se=a.scan();switch(a.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:B||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(se){case 12:case 13:B?H(10):K();break;case 16:H(1);break;case 15:case 14:break;default:return se}}}function H(se,J=[],X=[]){if(L(se),J.length+X.length>0){let Z=a.getToken();for(;Z!==17;){if(J.indexOf(Z)!==-1){F();break}else if(X.indexOf(Z)!==-1)break;Z=F()}}}function j(se){const J=a.getTokenValue();return se?V(J):u(J),F(),!0}function le(){switch(a.getToken()){case 11:{let se=0;try{se=JSON.parse(a.getTokenValue()),typeof se!="number"&&(H(2),se=0)}catch{H(2)}V(se);break}case 7:V(null);break;case 8:V(!0);break;case 9:V(!1);break;default:return!1}return F(),!0}function _(){return a.getToken()!==10?(H(3,[],[2,5]),!1):(j(!1),a.getToken()===6?(ee(":"),F(),ue()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function be(){c(),F();let se=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(se||H(4,[],[]),ee(","),F(),a.getToken()===2&&P)break}else se&&H(6,[],[]);_()||H(4,[],[2,5]),se=!0}return l(),a.getToken()!==2?H(7,[2],[]):F(),!0}function de(){C(),F();let se=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(se||H(4,[],[]),ee(","),F(),a.getToken()===4&&P)break}else se&&H(6,[],[]);ue()||H(4,[],[4,5]),se=!0}return R(),a.getToken()!==4?H(8,[4],[]):F(),!0}function ue(){switch(a.getToken()){case 3:return de();case 1:return be();case 10:return j(!0);default:return le()}}return F(),a.getToken()===17?n.allowEmptyContent?!0:(H(4,[],[]),!1):ue()?(a.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=w;function A(i,d){const n=S(i),a=[];let t,g=0,c;do switch(c=n.getPosition(),t=n.scan(),t){case 12:case 13:case 17:g!==c&&a.push(i.substring(g,c)),d!==void 0&&a.push(n.getTokenValue().replace(/[^\r\n]/g,d)),g=n.getPosition();break}while(t!==17);return a.join("")}e.stripComments=A;function v(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(Ce[28],ke([1,0]),function(ie,e){"use strict";var r,k,D;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function M(m,o,s){let h=m.get(o);return h===void 0&&(h=s,m.set(o,h)),h}e.getOrSet=M;function S(m){const o=[];return m.forEach((s,h)=>{o.push(`${h} => ${s}`)}),`Map(${m.size}) {${o.join(", ")}}`}e.mapToString=S;function O(m){const o=[];return m.forEach(s=>{o.push(s)}),`Set(${m.size}) {${o.join(", ")}}`}e.setToString=O;class y{constructor(o,s){this.uri=o,this.value=s}}class T{constructor(o,s){this[r]="ResourceMap",o instanceof T?(this.b=new Map(o.b),this.c=s??T.a):(this.b=new Map,this.c=o??T.a)}set(o,s){return this.b.set(this.c(o),new y(o,s)),this}get(o){return this.b.get(this.c(o))?.value}has(o){return this.b.has(this.c(o))}get size(){return this.b.size}clear(){this.b.clear()}delete(o){return this.b.delete(this.c(o))}forEach(o,s){typeof s<"u"&&(o=o.bind(s));for(const[h,p]of this.b)o(p.value,p.uri,this)}*values(){for(const o of this.b.values())yield o.value}*keys(){for(const o of this.b.values())yield o.uri}*entries(){for(const o of this.b.values())yield[o.uri,o.value]}*[(r=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.b)yield[o.uri,o.value]}}e.ResourceMap=T,T.a=m=>m.toString();class N{constructor(o,s){this[k]="ResourceSet",!o||typeof o=="function"?this.a=new T(o):(this.a=new T(s),o.forEach(this.add,this))}get size(){return this.a.size}add(o){return this.a.set(o,o),this}clear(){this.a.clear()}delete(o){return this.a.delete(o)}forEach(o,s){this.a.forEach((h,p)=>o.call(s,p,p,this))}has(o){return this.a.has(o)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=N;var E;(function(m){m[m.None=0]="None",m[m.AsOld=1]="AsOld",m[m.AsNew=2]="AsNew"})(E=e.Touch||(e.Touch={}));class f{constructor(){this[D]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(o){return this.a.has(o)}get(o,s=0){const h=this.a.get(o);if(!!h)return s!==0&&this.j(h,s),h.value}set(o,s,h=0){let p=this.a.get(o);if(p)p.value=s,h!==0&&this.j(p,h);else{switch(p={key:o,value:s,next:void 0,previous:void 0},h){case 0:this.h(p);break;case 1:this.g(p);break;case 2:this.h(p);break;default:this.h(p);break}this.a.set(o,p),this.d++}return this}delete(o){return!!this.remove(o)}remove(o){const s=this.a.get(o);if(!!s)return this.a.delete(o),this.i(s),this.d--,s.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const o=this.b;return this.a.delete(o.key),this.i(o),this.d--,o.value}forEach(o,s){const h=this.e;let p=this.b;for(;p;){if(s?o.bind(s)(p.value,p.key,this):o(p.value,p.key,this),this.e!==h)throw new Error("LinkedMap got modified during iteration.");p=p.next}}keys(){const o=this,s=this.e;let h=this.b;const p={[Symbol.iterator](){return p},next(){if(o.e!==s)throw new Error("LinkedMap got modified during iteration.");if(h){const w={value:h.key,done:!1};return h=h.next,w}else return{value:void 0,done:!0}}};return p}values(){const o=this,s=this.e;let h=this.b;const p={[Symbol.iterator](){return p},next(){if(o.e!==s)throw new Error("LinkedMap got modified during iteration.");if(h){const w={value:h.value,done:!1};return h=h.next,w}else return{value:void 0,done:!0}}};return p}entries(){const o=this,s=this.e;let h=this.b;const p={[Symbol.iterator](){return p},next(){if(o.e!==s)throw new Error("LinkedMap got modified during iteration.");if(h){const w={value:[h.key,h.value],done:!1};return h=h.next,w}else return{value:void 0,done:!0}}};return p}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(o){if(o>=this.size)return;if(o===0){this.clear();return}let s=this.b,h=this.size;for(;s&&h>o;)this.a.delete(s.key),s=s.next,h--;this.b=s,this.d=h,s&&(s.previous=void 0),this.e++}g(o){if(!this.b&&!this.c)this.c=o;else if(this.b)o.next=this.b,this.b.previous=o;else throw new Error("Invalid list");this.b=o,this.e++}h(o){if(!this.b&&!this.c)this.b=o;else if(this.c)o.previous=this.c,this.c.next=o;else throw new Error("Invalid list");this.c=o,this.e++}i(o){if(o===this.b&&o===this.c)this.b=void 0,this.c=void 0;else if(o===this.b){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.b=o.next}else if(o===this.c){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.c=o.previous}else{const s=o.next,h=o.previous;if(!s||!h)throw new Error("Invalid list");s.previous=h,h.next=s}o.next=void 0,o.previous=void 0,this.e++}j(o,s){if(!this.b||!this.c)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(o===this.b)return;const h=o.next,p=o.previous;o===this.c?(p.next=void 0,this.c=p):(h.previous=p,p.next=h),o.previous=void 0,o.next=this.b,this.b.previous=o,this.b=o,this.e++}else if(s===2){if(o===this.c)return;const h=o.next,p=o.previous;o===this.b?(h.previous=void 0,this.b=h):(h.previous=p,p.next=h),o.next=void 0,o.previous=this.c,this.c.next=o,this.c=o,this.e++}}}toJSON(){const o=[];return this.forEach((s,h)=>{o.push([h,s])}),o}fromJSON(o){this.clear();for(const[s,h]of o)this.set(s,h)}}e.LinkedMap=f;class b extends f{constructor(o,s=1){super(),this.k=o,this.l=Math.min(Math.max(0,s),1)}get limit(){return this.k}set limit(o){this.k=o,this.m()}get ratio(){return this.l}set ratio(o){this.l=Math.min(Math.max(0,o),1),this.m()}get(o,s=2){return super.get(o,s)}peek(o){return super.get(o,0)}set(o,s){return super.set(o,s,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=b}),function(ie,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Ce[112],ke([0]),e):(ie=typeof globalThis<"u"?globalThis:ie||self,e(ie.marked={}))}(this,function(ie){"use strict";function e(Pe,Se){for(var Ie=0;Ie<Se.length;Ie++){var oe=Se[Ie];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(Pe,oe.key,oe)}}function r(Pe,Se,Ie){return Se&&e(Pe.prototype,Se),Ie&&e(Pe,Ie),Object.defineProperty(Pe,"prototype",{writable:!1}),Pe}function k(Pe,Se){if(!!Pe){if(typeof Pe=="string")return D(Pe,Se);var Ie=Object.prototype.toString.call(Pe).slice(8,-1);if(Ie==="Object"&&Pe.constructor&&(Ie=Pe.constructor.name),Ie==="Map"||Ie==="Set")return Array.from(Pe);if(Ie==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ie))return D(Pe,Se)}}function D(Pe,Se){(Se==null||Se>Pe.length)&&(Se=Pe.length);for(var Ie=0,oe=new Array(Se);Ie<Se;Ie++)oe[Ie]=Pe[Ie];return oe}function M(Pe,Se){var Ie=typeof Symbol<"u"&&Pe[Symbol.iterator]||Pe["@@iterator"];if(Ie)return(Ie=Ie.call(Pe)).next.bind(Ie);if(Array.isArray(Pe)||(Ie=k(Pe))||Se&&Pe&&typeof Pe.length=="number"){Ie&&(Pe=Ie);var oe=0;return function(){return oe>=Pe.length?{done:!0}:{done:!1,value:Pe[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function S(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ie.defaults=S();function O(Pe){ie.defaults=Pe}var y=/[&<>"']/,T=/[&<>"']/g,N=/[<>"']|&(?!#?\w+;)/,E=/[<>"']|&(?!#?\w+;)/g,f={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(Se){return f[Se]};function m(Pe,Se){if(Se){if(y.test(Pe))return Pe.replace(T,b)}else if(N.test(Pe))return Pe.replace(E,b);return Pe}var o=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function s(Pe){return Pe.replace(o,function(Se,Ie){return Ie=Ie.toLowerCase(),Ie==="colon"?":":Ie.charAt(0)==="#"?Ie.charAt(1)==="x"?String.fromCharCode(parseInt(Ie.substring(2),16)):String.fromCharCode(+Ie.substring(1)):""})}var h=/(^|[^\[])\^/g;function p(Pe,Se){Pe=typeof Pe=="string"?Pe:Pe.source,Se=Se||"";var Ie={replace:function(ce,Y){return Y=Y.source||Y,Y=Y.replace(h,"$1"),Pe=Pe.replace(ce,Y),Ie},getRegex:function(){return new RegExp(Pe,Se)}};return Ie}var w=/[^\w:]/g,A=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function v(Pe,Se,Ie){if(Pe){var oe;try{oe=decodeURIComponent(s(Ie)).replace(w,"").toLowerCase()}catch{return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}Se&&!A.test(Ie)&&(Ie=t(Se,Ie));try{Ie=encodeURI(Ie).replace(/%25/g,"%")}catch{return null}return Ie}var i={},d=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,a=/^([^:]+:\/*[^/]*)[\s\S]*$/;function t(Pe,Se){i[" "+Pe]||(d.test(Pe)?i[" "+Pe]=Pe+"/":i[" "+Pe]=l(Pe,"/",!0)),Pe=i[" "+Pe];var Ie=Pe.indexOf(":")===-1;return Se.substring(0,2)==="//"?Ie?Se:Pe.replace(n,"$1")+Se:Se.charAt(0)==="/"?Ie?Se:Pe.replace(a,"$1")+Se:Pe+Se}var g={exec:function(){}};function c(Pe){for(var Se=1,Ie,oe;Se<arguments.length;Se++){Ie=arguments[Se];for(oe in Ie)Object.prototype.hasOwnProperty.call(Ie,oe)&&(Pe[oe]=Ie[oe])}return Pe}function u(Pe,Se){var Ie=Pe.replace(/\|/g,function(Y,I,$){for(var W=!1,q=I;--q>=0&&$[q]==="\\";)W=!W;return W?"|":" |"}),oe=Ie.split(/ \|/),ce=0;if(oe[0].trim()||oe.shift(),oe.length>0&&!oe[oe.length-1].trim()&&oe.pop(),oe.length>Se)oe.splice(Se);else for(;oe.length<Se;)oe.push("");for(;ce<oe.length;ce++)oe[ce]=oe[ce].trim().replace(/\\\|/g,"|");return oe}function l(Pe,Se,Ie){var oe=Pe.length;if(oe===0)return"";for(var ce=0;ce<oe;){var Y=Pe.charAt(oe-ce-1);if(Y===Se&&!Ie)ce++;else if(Y!==Se&&Ie)ce++;else break}return Pe.slice(0,oe-ce)}function C(Pe,Se){if(Pe.indexOf(Se[1])===-1)return-1;for(var Ie=Pe.length,oe=0,ce=0;ce<Ie;ce++)if(Pe[ce]==="\\")ce++;else if(Pe[ce]===Se[0])oe++;else if(Pe[ce]===Se[1]&&(oe--,oe<0))return ce;return-1}function R(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function V(Pe,Se){if(Se<1)return"";for(var Ie="";Se>1;)Se&1&&(Ie+=Pe),Se>>=1,Pe+=Pe;return Ie+Pe}function ee(Pe,Se,Ie,oe){var ce=Se.href,Y=Se.title?m(Se.title):null,I=Pe[1].replace(/\\([\[\]])/g,"$1");if(Pe[0].charAt(0)!=="!"){oe.state.inLink=!0;var $={type:"link",raw:Ie,href:ce,title:Y,text:I,tokens:oe.inlineTokens(I)};return oe.state.inLink=!1,$}return{type:"image",raw:Ie,href:ce,title:Y,text:m(I)}}function K(Pe,Se){var Ie=Pe.match(/^(\s+)(?:```)/);if(Ie===null)return Se;var oe=Ie[1];return Se.split(`
`).map(function(ce){var Y=ce.match(/^\s+/);if(Y===null)return ce;var I=Y[0];return I.length>=oe.length?ce.slice(oe.length):ce}).join(`
`)}var L=function(){function Pe(Ie){this.options=Ie||ie.defaults}var Se=Pe.prototype;return Se.space=function(oe){var ce=this.rules.block.newline.exec(oe);if(ce&&ce[0].length>0)return{type:"space",raw:ce[0]}},Se.code=function(oe){var ce=this.rules.block.code.exec(oe);if(ce){var Y=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?Y:l(Y,`
`)}}},Se.fences=function(oe){var ce=this.rules.block.fences.exec(oe);if(ce){var Y=ce[0],I=K(Y,ce[3]||"");return{type:"code",raw:Y,lang:ce[2]?ce[2].trim():ce[2],text:I}}},Se.heading=function(oe){var ce=this.rules.block.heading.exec(oe);if(ce){var Y=ce[2].trim();if(/#$/.test(Y)){var I=l(Y,"#");(this.options.pedantic||!I||/ $/.test(I))&&(Y=I.trim())}return{type:"heading",raw:ce[0],depth:ce[1].length,text:Y,tokens:this.lexer.inline(Y)}}},Se.hr=function(oe){var ce=this.rules.block.hr.exec(oe);if(ce)return{type:"hr",raw:ce[0]}},Se.blockquote=function(oe){var ce=this.rules.block.blockquote.exec(oe);if(ce){var Y=ce[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(Y,[]),text:Y}}},Se.list=function(oe){var ce=this.rules.block.list.exec(oe);if(ce){var Y,I,$,W,q,te,fe,ye,ae,ve,Ee,We,He=ce[1].trim(),tt=He.length>1,Xe={type:"list",raw:"",ordered:tt,start:tt?+He.slice(0,-1):"",loose:!1,items:[]};He=tt?"\\d{1,9}\\"+He.slice(-1):"\\"+He,this.options.pedantic&&(He=tt?He:"[*+-]");for(var et=new RegExp("^( {0,3}"+He+")((?:[	 ][^\\n]*)?(?:\\n|$))");oe&&(We=!1,!(!(ce=et.exec(oe))||this.rules.block.hr.test(oe)));){if(Y=ce[0],oe=oe.substring(Y.length),ye=ce[2].split(`
`,1)[0],ae=oe.split(`
`,1)[0],this.options.pedantic?(W=2,Ee=ye.trimLeft()):(W=ce[2].search(/[^ ]/),W=W>4?1:W,Ee=ye.slice(W),W+=ce[1].length),te=!1,!ye&&/^ *$/.test(ae)&&(Y+=ae+`
`,oe=oe.substring(ae.length+1),We=!0),!We)for(var it=new RegExp("^ {0,"+Math.min(3,W-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),dt=new RegExp("^ {0,"+Math.min(3,W-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Fe=new RegExp("^ {0,"+Math.min(3,W-1)+"}(?:```|~~~)"),ot=new RegExp("^ {0,"+Math.min(3,W-1)+"}#");oe&&(ve=oe.split(`
`,1)[0],ye=ve,this.options.pedantic&&(ye=ye.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Fe.test(ye)||ot.test(ye)||it.test(ye)||dt.test(oe)));){if(ye.search(/[^ ]/)>=W||!ye.trim())Ee+=`
`+ye.slice(W);else if(!te)Ee+=`
`+ye;else break;!te&&!ye.trim()&&(te=!0),Y+=ve+`
`,oe=oe.substring(ve.length+1)}Xe.loose||(fe?Xe.loose=!0:/\n *\n *$/.test(Y)&&(fe=!0)),this.options.gfm&&(I=/^\[[ xX]\] /.exec(Ee),I&&($=I[0]!=="[ ] ",Ee=Ee.replace(/^\[[ xX]\] +/,""))),Xe.items.push({type:"list_item",raw:Y,task:!!I,checked:$,loose:!1,text:Ee}),Xe.raw+=Y}Xe.items[Xe.items.length-1].raw=Y.trimRight(),Xe.items[Xe.items.length-1].text=Ee.trimRight(),Xe.raw=Xe.raw.trimRight();var Q=Xe.items.length;for(q=0;q<Q;q++){this.lexer.state.top=!1,Xe.items[q].tokens=this.lexer.blockTokens(Xe.items[q].text,[]);var x=Xe.items[q].tokens.filter(function(Me){return Me.type==="space"}),pe=x.every(function(Me){for(var ze=Me.raw.split(""),Ve=0,_e=M(ze),nt;!(nt=_e()).done;){var vt=nt.value;if(vt===`
`&&(Ve+=1),Ve>1)return!0}return!1});!Xe.loose&&x.length&&pe&&(Xe.loose=!0,Xe.items[q].loose=!0)}return Xe}},Se.html=function(oe){var ce=this.rules.block.html.exec(oe);if(ce){var Y={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};if(this.options.sanitize){var I=this.options.sanitizer?this.options.sanitizer(ce[0]):m(ce[0]);Y.type="paragraph",Y.text=I,Y.tokens=this.lexer.inline(I)}return Y}},Se.def=function(oe){var ce=this.rules.block.def.exec(oe);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var Y=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Y,raw:ce[0],href:ce[2],title:ce[3]}}},Se.table=function(oe){var ce=this.rules.block.table.exec(oe);if(ce){var Y={type:"table",header:u(ce[1]).map(function(fe){return{text:fe}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]&&ce[3].trim()?ce[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(Y.header.length===Y.align.length){Y.raw=ce[0];var I=Y.align.length,$,W,q,te;for($=0;$<I;$++)/^ *-+: *$/.test(Y.align[$])?Y.align[$]="right":/^ *:-+: *$/.test(Y.align[$])?Y.align[$]="center":/^ *:-+ *$/.test(Y.align[$])?Y.align[$]="left":Y.align[$]=null;for(I=Y.rows.length,$=0;$<I;$++)Y.rows[$]=u(Y.rows[$],Y.header.length).map(function(fe){return{text:fe}});for(I=Y.header.length,W=0;W<I;W++)Y.header[W].tokens=this.lexer.inline(Y.header[W].text);for(I=Y.rows.length,W=0;W<I;W++)for(te=Y.rows[W],q=0;q<te.length;q++)te[q].tokens=this.lexer.inline(te[q].text);return Y}}},Se.lheading=function(oe){var ce=this.rules.block.lheading.exec(oe);if(ce)return{type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:this.lexer.inline(ce[1])}},Se.paragraph=function(oe){var ce=this.rules.block.paragraph.exec(oe);if(ce){var Y=ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1];return{type:"paragraph",raw:ce[0],text:Y,tokens:this.lexer.inline(Y)}}},Se.text=function(oe){var ce=this.rules.block.text.exec(oe);if(ce)return{type:"text",raw:ce[0],text:ce[0],tokens:this.lexer.inline(ce[0])}},Se.escape=function(oe){var ce=this.rules.inline.escape.exec(oe);if(ce)return{type:"escape",raw:ce[0],text:m(ce[1])}},Se.tag=function(oe){var ce=this.rules.inline.tag.exec(oe);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):m(ce[0]):ce[0]}},Se.link=function(oe){var ce=this.rules.inline.link.exec(oe);if(ce){var Y=ce[2].trim();if(!this.options.pedantic&&/^</.test(Y)){if(!/>$/.test(Y))return;var I=l(Y.slice(0,-1),"\\");if((Y.length-I.length)%2===0)return}else{var $=C(ce[2],"()");if($>-1){var W=ce[0].indexOf("!")===0?5:4,q=W+ce[1].length+$;ce[2]=ce[2].substring(0,$),ce[0]=ce[0].substring(0,q).trim(),ce[3]=""}}var te=ce[2],fe="";if(this.options.pedantic){var ye=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(te);ye&&(te=ye[1],fe=ye[3])}else fe=ce[3]?ce[3].slice(1,-1):"";return te=te.trim(),/^</.test(te)&&(this.options.pedantic&&!/>$/.test(Y)?te=te.slice(1):te=te.slice(1,-1)),ee(ce,{href:te&&te.replace(this.rules.inline._escapes,"$1"),title:fe&&fe.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},Se.reflink=function(oe,ce){var Y;if((Y=this.rules.inline.reflink.exec(oe))||(Y=this.rules.inline.nolink.exec(oe))){var I=(Y[2]||Y[1]).replace(/\s+/g," ");if(I=ce[I.toLowerCase()],!I||!I.href){var $=Y[0].charAt(0);return{type:"text",raw:$,text:$}}return ee(Y,I,Y[0],this.lexer)}},Se.emStrong=function(oe,ce,Y){Y===void 0&&(Y="");var I=this.rules.inline.emStrong.lDelim.exec(oe);if(!!I&&!(I[3]&&Y.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var $=I[1]||I[2]||"";if(!$||$&&(Y===""||this.rules.inline.punctuation.exec(Y))){var W=I[0].length-1,q,te,fe=W,ye=0,ae=I[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ae.lastIndex=0,ce=ce.slice(-1*oe.length+W);(I=ae.exec(ce))!=null;)if(q=I[1]||I[2]||I[3]||I[4]||I[5]||I[6],!!q){if(te=q.length,I[3]||I[4]){fe+=te;continue}else if((I[5]||I[6])&&W%3&&!((W+te)%3)){ye+=te;continue}if(fe-=te,!(fe>0)){if(te=Math.min(te,te+fe+ye),Math.min(W,te)%2){var ve=oe.slice(1,W+I.index+te);return{type:"em",raw:oe.slice(0,W+I.index+te+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}var Ee=oe.slice(2,W+I.index+te-1);return{type:"strong",raw:oe.slice(0,W+I.index+te+1),text:Ee,tokens:this.lexer.inlineTokens(Ee)}}}}}},Se.codespan=function(oe){var ce=this.rules.inline.code.exec(oe);if(ce){var Y=ce[2].replace(/\n/g," "),I=/[^ ]/.test(Y),$=/^ /.test(Y)&&/ $/.test(Y);return I&&$&&(Y=Y.substring(1,Y.length-1)),Y=m(Y,!0),{type:"codespan",raw:ce[0],text:Y}}},Se.br=function(oe){var ce=this.rules.inline.br.exec(oe);if(ce)return{type:"br",raw:ce[0]}},Se.del=function(oe){var ce=this.rules.inline.del.exec(oe);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2])}},Se.autolink=function(oe,ce){var Y=this.rules.inline.autolink.exec(oe);if(Y){var I,$;return Y[2]==="@"?(I=m(this.options.mangle?ce(Y[1]):Y[1]),$="mailto:"+I):(I=m(Y[1]),$=I),{type:"link",raw:Y[0],text:I,href:$,tokens:[{type:"text",raw:I,text:I}]}}},Se.url=function(oe,ce){var Y;if(Y=this.rules.inline.url.exec(oe)){var I,$;if(Y[2]==="@")I=m(this.options.mangle?ce(Y[0]):Y[0]),$="mailto:"+I;else{var W;do W=Y[0],Y[0]=this.rules.inline._backpedal.exec(Y[0])[0];while(W!==Y[0]);I=m(Y[0]),Y[1]==="www."?$="http://"+I:$=I}return{type:"link",raw:Y[0],text:I,href:$,tokens:[{type:"text",raw:I,text:I}]}}},Se.inlineText=function(oe,ce){var Y=this.rules.inline.text.exec(oe);if(Y){var I;return this.lexer.state.inRawBlock?I=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):m(Y[0]):Y[0]:I=m(this.options.smartypants?ce(Y[0]):Y[0]),{type:"text",raw:Y[0],text:I}}},Pe}(),B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:g,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=p(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.listItemStart=p(/^( *)(bull) */).replace("bull",B.bullet).getRegex(),B.list=p(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=p(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=p(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.blockquote=p(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=c({},B),B.gfm=c({},B.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.table=p(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.gfm.paragraph=p(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",B.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.pedantic=c({},B.normal,{html:p(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:g,paragraph:p(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var P={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:g,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:g,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};P._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",P.punctuation=p(P.punctuation).replace(/punctuation/g,P._punctuation).getRegex(),P.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,P.escapedEmSt=/\\\*|\\_/g,P._comment=p(B._comment).replace("(?:-->|$)","-->").getRegex(),P.emStrong.lDelim=p(P.emStrong.lDelim).replace(/punct/g,P._punctuation).getRegex(),P.emStrong.rDelimAst=p(P.emStrong.rDelimAst,"g").replace(/punct/g,P._punctuation).getRegex(),P.emStrong.rDelimUnd=p(P.emStrong.rDelimUnd,"g").replace(/punct/g,P._punctuation).getRegex(),P._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,P._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,P._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,P.autolink=p(P.autolink).replace("scheme",P._scheme).replace("email",P._email).getRegex(),P._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,P.tag=p(P.tag).replace("comment",P._comment).replace("attribute",P._attribute).getRegex(),P._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,P._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,P._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,P.link=p(P.link).replace("label",P._label).replace("href",P._href).replace("title",P._title).getRegex(),P.reflink=p(P.reflink).replace("label",P._label).replace("ref",B._label).getRegex(),P.nolink=p(P.nolink).replace("ref",B._label).getRegex(),P.reflinkSearch=p(P.reflinkSearch,"g").replace("reflink",P.reflink).replace("nolink",P.nolink).getRegex(),P.normal=c({},P),P.pedantic=c({},P.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:p(/^!?\[(label)\]\((.*?)\)/).replace("label",P._label).getRegex(),reflink:p(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",P._label).getRegex()}),P.gfm=c({},P.normal,{escape:p(P.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),P.gfm.url=p(P.gfm.url,"i").replace("email",P.gfm._extended_email).getRegex(),P.breaks=c({},P.gfm,{br:p(P.br).replace("{2,}","*").getRegex(),text:p(P.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function H(Pe){var Se="",Ie,oe,ce=Pe.length;for(Ie=0;Ie<ce;Ie++)oe=Pe.charCodeAt(Ie),Math.random()>.5&&(oe="x"+oe.toString(16)),Se+="&#"+oe+";";return Se}var j=function(){function Pe(Ie){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ie||ie.defaults,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var oe={block:B.normal,inline:P.normal};this.options.pedantic?(oe.block=B.pedantic,oe.inline=P.pedantic):this.options.gfm&&(oe.block=B.gfm,this.options.breaks?oe.inline=P.breaks:oe.inline=P.gfm),this.tokenizer.rules=oe}Pe.lex=function(oe,ce){var Y=new Pe(ce);return Y.lex(oe)},Pe.lexInline=function(oe,ce){var Y=new Pe(ce);return Y.inlineTokens(oe)};var Se=Pe.prototype;return Se.lex=function(oe){oe=oe.replace(/\r\n|\r/g,`
`),this.blockTokens(oe,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},Se.blockTokens=function(oe,ce){var Y=this;ce===void 0&&(ce=[]),this.options.pedantic?oe=oe.replace(/\t/g,"    ").replace(/^ +$/gm,""):oe=oe.replace(/^( *)(\t+)/gm,function(fe,ye,ae){return ye+"    ".repeat(ae.length)});for(var I,$,W,q;oe;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(fe){return(I=fe.call({lexer:Y},oe,ce))?(oe=oe.substring(I.raw.length),ce.push(I),!0):!1}))){if(I=this.tokenizer.space(oe)){oe=oe.substring(I.raw.length),I.raw.length===1&&ce.length>0?ce[ce.length-1].raw+=`
`:ce.push(I);continue}if(I=this.tokenizer.code(oe)){oe=oe.substring(I.raw.length),$=ce[ce.length-1],$&&($.type==="paragraph"||$.type==="text")?($.raw+=`
`+I.raw,$.text+=`
`+I.text,this.inlineQueue[this.inlineQueue.length-1].src=$.text):ce.push(I);continue}if(I=this.tokenizer.fences(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.heading(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.hr(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.blockquote(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.list(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.html(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.def(oe)){oe=oe.substring(I.raw.length),$=ce[ce.length-1],$&&($.type==="paragraph"||$.type==="text")?($.raw+=`
`+I.raw,$.text+=`
`+I.raw,this.inlineQueue[this.inlineQueue.length-1].src=$.text):this.tokens.links[I.tag]||(this.tokens.links[I.tag]={href:I.href,title:I.title});continue}if(I=this.tokenizer.table(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.lheading(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(W=oe,this.options.extensions&&this.options.extensions.startBlock&&function(){var fe=1/0,ye=oe.slice(1),ae=void 0;Y.options.extensions.startBlock.forEach(function(ve){ae=ve.call({lexer:this},ye),typeof ae=="number"&&ae>=0&&(fe=Math.min(fe,ae))}),fe<1/0&&fe>=0&&(W=oe.substring(0,fe+1))}(),this.state.top&&(I=this.tokenizer.paragraph(W))){$=ce[ce.length-1],q&&$.type==="paragraph"?($.raw+=`
`+I.raw,$.text+=`
`+I.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$.text):ce.push(I),q=W.length!==oe.length,oe=oe.substring(I.raw.length);continue}if(I=this.tokenizer.text(oe)){oe=oe.substring(I.raw.length),$=ce[ce.length-1],$&&$.type==="text"?($.raw+=`
`+I.raw,$.text+=`
`+I.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$.text):ce.push(I);continue}if(oe){var te="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(te);break}else throw new Error(te)}}return this.state.top=!0,ce},Se.inline=function(oe,ce){return ce===void 0&&(ce=[]),this.inlineQueue.push({src:oe,tokens:ce}),ce},Se.inlineTokens=function(oe,ce){var Y=this;ce===void 0&&(ce=[]);var I,$,W,q=oe,te,fe,ye;if(this.tokens.links){var ae=Object.keys(this.tokens.links);if(ae.length>0)for(;(te=this.tokenizer.rules.inline.reflinkSearch.exec(q))!=null;)ae.includes(te[0].slice(te[0].lastIndexOf("[")+1,-1))&&(q=q.slice(0,te.index)+"["+V("a",te[0].length-2)+"]"+q.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(te=this.tokenizer.rules.inline.blockSkip.exec(q))!=null;)q=q.slice(0,te.index)+"["+V("a",te[0].length-2)+"]"+q.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(te=this.tokenizer.rules.inline.escapedEmSt.exec(q))!=null;)q=q.slice(0,te.index)+"++"+q.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;)if(fe||(ye=""),fe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ee){return(I=Ee.call({lexer:Y},oe,ce))?(oe=oe.substring(I.raw.length),ce.push(I),!0):!1}))){if(I=this.tokenizer.escape(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.tag(oe)){oe=oe.substring(I.raw.length),$=ce[ce.length-1],$&&I.type==="text"&&$.type==="text"?($.raw+=I.raw,$.text+=I.text):ce.push(I);continue}if(I=this.tokenizer.link(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(I.raw.length),$=ce[ce.length-1],$&&I.type==="text"&&$.type==="text"?($.raw+=I.raw,$.text+=I.text):ce.push(I);continue}if(I=this.tokenizer.emStrong(oe,q,ye)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.codespan(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.br(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.del(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.autolink(oe,H)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(!this.state.inLink&&(I=this.tokenizer.url(oe,H))){oe=oe.substring(I.raw.length),ce.push(I);continue}if(W=oe,this.options.extensions&&this.options.extensions.startInline&&function(){var Ee=1/0,We=oe.slice(1),He=void 0;Y.options.extensions.startInline.forEach(function(tt){He=tt.call({lexer:this},We),typeof He=="number"&&He>=0&&(Ee=Math.min(Ee,He))}),Ee<1/0&&Ee>=0&&(W=oe.substring(0,Ee+1))}(),I=this.tokenizer.inlineText(W,F)){oe=oe.substring(I.raw.length),I.raw.slice(-1)!=="_"&&(ye=I.raw.slice(-1)),fe=!0,$=ce[ce.length-1],$&&$.type==="text"?($.raw+=I.raw,$.text+=I.text):ce.push(I);continue}if(oe){var ve="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(ve);break}else throw new Error(ve)}}return ce},r(Pe,null,[{key:"rules",get:function(){return{block:B,inline:P}}}]),Pe}(),le=function(){function Pe(Ie){this.options=Ie||ie.defaults}var Se=Pe.prototype;return Se.code=function(oe,ce,Y){var I=(ce||"").match(/\S*/)[0];if(this.options.highlight){var $=this.options.highlight(oe,I);$!=null&&$!==oe&&(Y=!0,oe=$)}return oe=oe.replace(/\n$/,"")+`
`,I?'<pre><code class="'+this.options.langPrefix+m(I,!0)+'">'+(Y?oe:m(oe,!0))+`</code></pre>
`:"<pre><code>"+(Y?oe:m(oe,!0))+`</code></pre>
`},Se.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},Se.html=function(oe){return oe},Se.heading=function(oe,ce,Y,I){if(this.options.headerIds){var $=this.options.headerPrefix+I.slug(Y);return"<h"+ce+' id="'+$+'">'+oe+"</h"+ce+`>
`}return"<h"+ce+">"+oe+"</h"+ce+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(oe,ce,Y){var I=ce?"ol":"ul",$=ce&&Y!==1?' start="'+Y+'"':"";return"<"+I+$+`>
`+oe+"</"+I+`>
`},Se.listitem=function(oe){return"<li>"+oe+`</li>
`},Se.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(oe){return"<p>"+oe+`</p>
`},Se.table=function(oe,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+ce+`</table>
`},Se.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},Se.tablecell=function(oe,ce){var Y=ce.header?"th":"td",I=ce.align?"<"+Y+' align="'+ce.align+'">':"<"+Y+">";return I+oe+("</"+Y+`>
`)},Se.strong=function(oe){return"<strong>"+oe+"</strong>"},Se.em=function(oe){return"<em>"+oe+"</em>"},Se.codespan=function(oe){return"<code>"+oe+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(oe){return"<del>"+oe+"</del>"},Se.link=function(oe,ce,Y){if(oe=v(this.options.sanitize,this.options.baseUrl,oe),oe===null)return Y;var I='<a href="'+m(oe)+'"';return ce&&(I+=' title="'+ce+'"'),I+=">"+Y+"</a>",I},Se.image=function(oe,ce,Y){if(oe=v(this.options.sanitize,this.options.baseUrl,oe),oe===null)return Y;var I='<img src="'+oe+'" alt="'+Y+'"';return ce&&(I+=' title="'+ce+'"'),I+=this.options.xhtml?"/>":">",I},Se.text=function(oe){return oe},Pe}(),_=function(){function Pe(){}var Se=Pe.prototype;return Se.strong=function(oe){return oe},Se.em=function(oe){return oe},Se.codespan=function(oe){return oe},Se.del=function(oe){return oe},Se.html=function(oe){return oe},Se.text=function(oe){return oe},Se.link=function(oe,ce,Y){return""+Y},Se.image=function(oe,ce,Y){return""+Y},Se.br=function(){return""},Pe}(),be=function(){function Pe(){this.seen={}}var Se=Pe.prototype;return Se.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(oe,ce){var Y=oe,I=0;if(this.seen.hasOwnProperty(Y)){I=this.seen[oe];do I++,Y=oe+"-"+I;while(this.seen.hasOwnProperty(Y))}return ce||(this.seen[oe]=I,this.seen[Y]=0),Y},Se.slug=function(oe,ce){ce===void 0&&(ce={});var Y=this.serialize(oe);return this.getNextSafeSlug(Y,ce.dryrun)},Pe}(),de=function(){function Pe(Ie){this.options=Ie||ie.defaults,this.options.renderer=this.options.renderer||new le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new _,this.slugger=new be}Pe.parse=function(oe,ce){var Y=new Pe(ce);return Y.parse(oe)},Pe.parseInline=function(oe,ce){var Y=new Pe(ce);return Y.parseInline(oe)};var Se=Pe.prototype;return Se.parse=function(oe,ce){ce===void 0&&(ce=!0);var Y="",I,$,W,q,te,fe,ye,ae,ve,Ee,We,He,tt,Xe,et,it,dt,Fe,ot,Q=oe.length;for(I=0;I<Q;I++){if(Ee=oe[I],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ee.type]&&(ot=this.options.extensions.renderers[Ee.type].call({parser:this},Ee),ot!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ee.type))){Y+=ot||"";continue}switch(Ee.type){case"space":continue;case"hr":{Y+=this.renderer.hr();continue}case"heading":{Y+=this.renderer.heading(this.parseInline(Ee.tokens),Ee.depth,s(this.parseInline(Ee.tokens,this.textRenderer)),this.slugger);continue}case"code":{Y+=this.renderer.code(Ee.text,Ee.lang,Ee.escaped);continue}case"table":{for(ae="",ye="",q=Ee.header.length,$=0;$<q;$++)ye+=this.renderer.tablecell(this.parseInline(Ee.header[$].tokens),{header:!0,align:Ee.align[$]});for(ae+=this.renderer.tablerow(ye),ve="",q=Ee.rows.length,$=0;$<q;$++){for(fe=Ee.rows[$],ye="",te=fe.length,W=0;W<te;W++)ye+=this.renderer.tablecell(this.parseInline(fe[W].tokens),{header:!1,align:Ee.align[W]});ve+=this.renderer.tablerow(ye)}Y+=this.renderer.table(ae,ve);continue}case"blockquote":{ve=this.parse(Ee.tokens),Y+=this.renderer.blockquote(ve);continue}case"list":{for(We=Ee.ordered,He=Ee.start,tt=Ee.loose,q=Ee.items.length,ve="",$=0;$<q;$++)et=Ee.items[$],it=et.checked,dt=et.task,Xe="",et.task&&(Fe=this.renderer.checkbox(it),tt?et.tokens.length>0&&et.tokens[0].type==="paragraph"?(et.tokens[0].text=Fe+" "+et.tokens[0].text,et.tokens[0].tokens&&et.tokens[0].tokens.length>0&&et.tokens[0].tokens[0].type==="text"&&(et.tokens[0].tokens[0].text=Fe+" "+et.tokens[0].tokens[0].text)):et.tokens.unshift({type:"text",text:Fe}):Xe+=Fe),Xe+=this.parse(et.tokens,tt),ve+=this.renderer.listitem(Xe,dt,it);Y+=this.renderer.list(ve,We,He);continue}case"html":{Y+=this.renderer.html(Ee.text);continue}case"paragraph":{Y+=this.renderer.paragraph(this.parseInline(Ee.tokens));continue}case"text":{for(ve=Ee.tokens?this.parseInline(Ee.tokens):Ee.text;I+1<Q&&oe[I+1].type==="text";)Ee=oe[++I],ve+=`
`+(Ee.tokens?this.parseInline(Ee.tokens):Ee.text);Y+=ce?this.renderer.paragraph(ve):ve;continue}default:{var x='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error(x);return}else throw new Error(x)}}}return Y},Se.parseInline=function(oe,ce){ce=ce||this.renderer;var Y="",I,$,W,q=oe.length;for(I=0;I<q;I++){if($=oe[I],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[$.type]&&(W=this.options.extensions.renderers[$.type].call({parser:this},$),W!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes($.type))){Y+=W||"";continue}switch($.type){case"escape":{Y+=ce.text($.text);break}case"html":{Y+=ce.html($.text);break}case"link":{Y+=ce.link($.href,$.title,this.parseInline($.tokens,ce));break}case"image":{Y+=ce.image($.href,$.title,$.text);break}case"strong":{Y+=ce.strong(this.parseInline($.tokens,ce));break}case"em":{Y+=ce.em(this.parseInline($.tokens,ce));break}case"codespan":{Y+=ce.codespan($.text);break}case"br":{Y+=ce.br();break}case"del":{Y+=ce.del(this.parseInline($.tokens,ce));break}case"text":{Y+=ce.text($.text);break}default:{var te='Token with "'+$.type+'" type was not found.';if(this.options.silent){console.error(te);return}else throw new Error(te)}}}return Y},Pe}();function ue(Pe,Se,Ie){if(typeof Pe>"u"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof Se=="function"&&(Ie=Se,Se=null),Se=c({},ue.defaults,Se||{}),R(Se),Ie){var oe=Se.highlight,ce;try{ce=j.lex(Pe,Se)}catch(q){return Ie(q)}var Y=function(te){var fe;if(!te)try{Se.walkTokens&&ue.walkTokens(ce,Se.walkTokens),fe=de.parse(ce,Se)}catch(ye){te=ye}return Se.highlight=oe,te?Ie(te):Ie(null,fe)};if(!oe||oe.length<3||(delete Se.highlight,!ce.length))return Y();var I=0;ue.walkTokens(ce,function(q){q.type==="code"&&(I++,setTimeout(function(){oe(q.text,q.lang,function(te,fe){if(te)return Y(te);fe!=null&&fe!==q.text&&(q.text=fe,q.escaped=!0),I--,I===0&&Y()})},0))}),I===0&&Y();return}function $(q){if(q.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+m(q.message+"",!0)+"</pre>";throw q}try{var W=j.lex(Pe,Se);if(Se.walkTokens){if(Se.async)return Promise.all(ue.walkTokens(W,Se.walkTokens)).then(function(){return de.parse(W,Se)}).catch($);ue.walkTokens(W,Se.walkTokens)}return de.parse(W,Se)}catch(q){$(q)}}ue.options=ue.setOptions=function(Pe){return c(ue.defaults,Pe),O(ue.defaults),ue},ue.getDefaults=S,ue.defaults=ie.defaults,ue.use=function(){for(var Pe=arguments.length,Se=new Array(Pe),Ie=0;Ie<Pe;Ie++)Se[Ie]=arguments[Ie];var oe=c.apply(void 0,[{}].concat(Se)),ce=ue.defaults.extensions||{renderers:{},childTokens:{}},Y;Se.forEach(function(I){if(I.extensions&&(Y=!0,I.extensions.forEach(function(W){if(!W.name)throw new Error("extension name required");if(W.renderer){var q=ce.renderers?ce.renderers[W.name]:null;q?ce.renderers[W.name]=function(){for(var te=arguments.length,fe=new Array(te),ye=0;ye<te;ye++)fe[ye]=arguments[ye];var ae=W.renderer.apply(this,fe);return ae===!1&&(ae=q.apply(this,fe)),ae}:ce.renderers[W.name]=W.renderer}if(W.tokenizer){if(!W.level||W.level!=="block"&&W.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ce[W.level]?ce[W.level].unshift(W.tokenizer):ce[W.level]=[W.tokenizer],W.start&&(W.level==="block"?ce.startBlock?ce.startBlock.push(W.start):ce.startBlock=[W.start]:W.level==="inline"&&(ce.startInline?ce.startInline.push(W.start):ce.startInline=[W.start]))}W.childTokens&&(ce.childTokens[W.name]=W.childTokens)})),I.renderer&&function(){var W=ue.defaults.renderer||new le,q=function(ye){var ae=W[ye];W[ye]=function(){for(var ve=arguments.length,Ee=new Array(ve),We=0;We<ve;We++)Ee[We]=arguments[We];var He=I.renderer[ye].apply(W,Ee);return He===!1&&(He=ae.apply(W,Ee)),He}};for(var te in I.renderer)q(te);oe.renderer=W}(),I.tokenizer&&function(){var W=ue.defaults.tokenizer||new L,q=function(ye){var ae=W[ye];W[ye]=function(){for(var ve=arguments.length,Ee=new Array(ve),We=0;We<ve;We++)Ee[We]=arguments[We];var He=I.tokenizer[ye].apply(W,Ee);return He===!1&&(He=ae.apply(W,Ee)),He}};for(var te in I.tokenizer)q(te);oe.tokenizer=W}(),I.walkTokens){var $=ue.defaults.walkTokens;oe.walkTokens=function(W){var q=[];return q.push(I.walkTokens.call(this,W)),$&&(q=q.concat($.call(this,W))),q}}Y&&(oe.extensions=ce),ue.setOptions(oe)})},ue.walkTokens=function(Pe,Se){for(var Ie=[],oe=function(){var $=Y.value;switch(Ie=Ie.concat(Se.call(ue,$)),$.type){case"table":{for(var W=M($.header),q;!(q=W()).done;){var te=q.value;Ie=Ie.concat(ue.walkTokens(te.tokens,Se))}for(var fe=M($.rows),ye;!(ye=fe()).done;)for(var ae=ye.value,ve=M(ae),Ee;!(Ee=ve()).done;){var We=Ee.value;Ie=Ie.concat(ue.walkTokens(We.tokens,Se))}break}case"list":{Ie=Ie.concat(ue.walkTokens($.items,Se));break}default:ue.defaults.extensions&&ue.defaults.extensions.childTokens&&ue.defaults.extensions.childTokens[$.type]?ue.defaults.extensions.childTokens[$.type].forEach(function(He){Ie=Ie.concat(ue.walkTokens($[He],Se))}):$.tokens&&(Ie=Ie.concat(ue.walkTokens($.tokens,Se)))}},ce=M(Pe),Y;!(Y=ce()).done;)oe();return Ie},ue.parseInline=function(Pe,Se){if(typeof Pe>"u"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");Se=c({},ue.defaults,Se||{}),R(Se);try{var Ie=j.lexInline(Pe,Se);return Se.walkTokens&&ue.walkTokens(Ie,Se.walkTokens),de.parseInline(Ie,Se)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+m(oe.message+"",!0)+"</pre>";throw oe}},ue.Parser=de,ue.parser=de.parse,ue.Renderer=le,ue.TextRenderer=_,ue.Lexer=j,ue.lexer=j.lex,ue.Tokenizer=L,ue.Slugger=be,ue.parse=ue;var se=ue.options,J=ue.setOptions,X=ue.use,Z=ue.walkTokens,he=ue.parseInline,Te=ue,Ne=de.parse,Ke=j.lex;ie.Lexer=j,ie.Parser=de,ie.Renderer=le,ie.Slugger=be,ie.TextRenderer=_,ie.Tokenizer=L,ie.getDefaults=S,ie.lexer=Ke,ie.marked=ue,ie.options=se,ie.parse=Te,ie.parseInline=he,ie.parser=Ne,ie.setOptions=J,ie.use=X,ie.walkTokens=Z,Object.defineProperty(ie,"__esModule",{value:!0})}),define(Ce[113],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function r(O,y,T){return Math.min(Math.max(O,y),T)}e.clamp=r;function k(O,y){return(y+O%y)%y}e.rot=k;class D{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=D;class M{constructor(){this.a=1,this.b=0}update(y){return this.b=this.b+(y-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=M;class S{constructor(y){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(y),this.c.fill(0,0,y)}update(y){const T=this.c[this.d];return this.c[this.d]=y,this.d=(this.d+1)%this.c.length,this.e-=T,this.e+=y,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=S}),function(){function ie(D){const M=[];typeof D=="number"&&M.push("code/timeOrigin",D);function S(y){M.push(y,Date.now())}function O(){const y=[];for(let T=0;T<M.length;T+=2)y.push({name:M[T],startTime:M[T+1]});return y}return{mark:S,getMarks:O}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const S of performance.getEntriesByType("mark"))M.push({name:S.name,startTime:Math.round(D+S.startTime)});return M}};if(typeof process=="object"){const D=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function r(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var k;typeof global=="object"?k=global:typeof self=="object"?k=self:k={},typeof define=="function"?define("vs/base/common/performance",[],function(){return r(k)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=r(k):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),k.perf=r(k))}(),function(ie,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var r=e();for(var k in r)(typeof exports=="object"?exports:ie)[k]=r[k]}}(typeof self<"u"?self:this,function(){return function(ie){var e={};function r(k){if(e[k])return e[k].exports;var D=e[k]={i:k,l:!1,exports:{}};return ie[k].call(D.exports,D,D.exports,r),D.l=!0,D.exports}return r.m=ie,r.c=e,r.d=function(k,D,M){r.o(k,D)||Object.defineProperty(k,D,{enumerable:!0,get:M})},r.r=function(k){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(k,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(k,"__esModule",{value:!0})},r.t=function(k,D){if(1&D&&(k=r(k)),8&D||4&D&&typeof k=="object"&&k&&k.__esModule)return k;var M=Object.create(null);if(r.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:k}),2&D&&typeof k!="string")for(var S in k)r.d(M,S,function(O){return k[O]}.bind(null,S));return M},r.n=function(k){var D=k&&k.__esModule?function(){return k.default}:function(){return k};return r.d(D,"a",D),D},r.o=function(k,D){return Object.prototype.hasOwnProperty.call(k,D)},r.p="",r(r.s=0)}([function(ie,e,r){(function(k){var D;e=ie.exports=X,D=typeof k=="object"&&k.env&&k.env.NODE_DEBUG&&/\bsemver\b/i.test(k.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,S=Number.MAX_SAFE_INTEGER||9007199254740991,O=e.re=[],y=e.src=[],T=0,N=T++;y[N]="0|[1-9]\\d*";var E=T++;y[E]="[0-9]+";var f=T++;y[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=T++;y[b]="("+y[N]+")\\.("+y[N]+")\\.("+y[N]+")";var m=T++;y[m]="("+y[E]+")\\.("+y[E]+")\\.("+y[E]+")";var o=T++;y[o]="(?:"+y[N]+"|"+y[f]+")";var s=T++;y[s]="(?:"+y[E]+"|"+y[f]+")";var h=T++;y[h]="(?:-("+y[o]+"(?:\\."+y[o]+")*))";var p=T++;y[p]="(?:-?("+y[s]+"(?:\\."+y[s]+")*))";var w=T++;y[w]="[0-9A-Za-z-]+";var A=T++;y[A]="(?:\\+("+y[w]+"(?:\\."+y[w]+")*))";var v=T++,i="v?"+y[b]+y[h]+"?"+y[A]+"?";y[v]="^"+i+"$";var d="[v=\\s]*"+y[m]+y[p]+"?"+y[A]+"?",n=T++;y[n]="^"+d+"$";var a=T++;y[a]="((?:<|>)?=?)";var t=T++;y[t]=y[E]+"|x|X|\\*";var g=T++;y[g]=y[N]+"|x|X|\\*";var c=T++;y[c]="[v=\\s]*("+y[g]+")(?:\\.("+y[g]+")(?:\\.("+y[g]+")(?:"+y[h]+")?"+y[A]+"?)?)?";var u=T++;y[u]="[v=\\s]*("+y[t]+")(?:\\.("+y[t]+")(?:\\.("+y[t]+")(?:"+y[p]+")?"+y[A]+"?)?)?";var l=T++;y[l]="^"+y[a]+"\\s*"+y[c]+"$";var C=T++;y[C]="^"+y[a]+"\\s*"+y[u]+"$";var R=T++;y[R]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var V=T++;y[V]="(?:~>?)";var ee=T++;y[ee]="(\\s*)"+y[V]+"\\s+",O[ee]=new RegExp(y[ee],"g");var K=T++;y[K]="^"+y[V]+y[c]+"$";var L=T++;y[L]="^"+y[V]+y[u]+"$";var B=T++;y[B]="(?:\\^)";var P=T++;y[P]="(\\s*)"+y[B]+"\\s+",O[P]=new RegExp(y[P],"g");var F=T++;y[F]="^"+y[B]+y[c]+"$";var H=T++;y[H]="^"+y[B]+y[u]+"$";var j=T++;y[j]="^"+y[a]+"\\s*("+d+")$|^$";var le=T++;y[le]="^"+y[a]+"\\s*("+i+")$|^$";var _=T++;y[_]="(\\s*)"+y[a]+"\\s*("+d+"|"+y[c]+")",O[_]=new RegExp(y[_],"g");var be=T++;y[be]="^\\s*("+y[c]+")\\s+-\\s+("+y[c]+")\\s*$";var de=T++;y[de]="^\\s*("+y[u]+")\\s+-\\s+("+y[u]+")\\s*$";var ue=T++;y[ue]="(<|>)?=?\\s*\\*";for(var se=0;se<35;se++)D(se,y[se]),O[se]||(O[se]=new RegExp(y[se]));function J(ae,ve){if(ae instanceof X)return ae;if(typeof ae!="string"||ae.length>M||!(ve?O[n]:O[v]).test(ae))return null;try{return new X(ae,ve)}catch{return null}}function X(ae,ve){if(ae instanceof X){if(ae.loose===ve)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof X))return new X(ae,ve);D("SemVer",ae,ve),this.loose=ve;var Ee=ae.trim().match(ve?O[n]:O[v]);if(!Ee)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+Ee[1],this.minor=+Ee[2],this.patch=+Ee[3],this.major>S||this.major<0)throw new TypeError("Invalid major version");if(this.minor>S||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>S||this.patch<0)throw new TypeError("Invalid patch version");Ee[4]?this.prerelease=Ee[4].split(".").map(function(We){if(/^[0-9]+$/.test(We)){var He=+We;if(He>=0&&He<S)return He}return We}):this.prerelease=[],this.build=Ee[5]?Ee[5].split("."):[],this.format()}e.parse=J,e.valid=function(ae,ve){var Ee=J(ae,ve);return Ee?Ee.version:null},e.clean=function(ae,ve){var Ee=J(ae.trim().replace(/^[=v]+/,""),ve);return Ee?Ee.version:null},e.SemVer=X,X.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},X.prototype.toString=function(){return this.version},X.prototype.compare=function(ae){return D("SemVer.compare",this.version,this.loose,ae),ae instanceof X||(ae=new X(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},X.prototype.compareMain=function(ae){return ae instanceof X||(ae=new X(ae,this.loose)),he(this.major,ae.major)||he(this.minor,ae.minor)||he(this.patch,ae.patch)},X.prototype.comparePre=function(ae){if(ae instanceof X||(ae=new X(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var ve=0;do{var Ee=this.prerelease[ve],We=ae.prerelease[ve];if(D("prerelease compare",ve,Ee,We),Ee===void 0&&We===void 0)return 0;if(We===void 0)return 1;if(Ee===void 0)return-1;if(Ee!==We)return he(Ee,We)}while(++ve)},X.prototype.inc=function(ae,ve){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ve);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ve);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ve),this.inc("pre",ve);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ve),this.inc("pre",ve);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ee=this.prerelease.length;--Ee>=0;)typeof this.prerelease[Ee]=="number"&&(this.prerelease[Ee]++,Ee=-2);Ee===-1&&this.prerelease.push(0)}ve&&(this.prerelease[0]===ve?isNaN(this.prerelease[1])&&(this.prerelease=[ve,0]):this.prerelease=[ve,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,ve,Ee,We){typeof Ee=="string"&&(We=Ee,Ee=void 0);try{return new X(ae,Ee).inc(ve,We).version}catch{return null}},e.diff=function(ae,ve){if(Pe(ae,ve))return null;var Ee=J(ae),We=J(ve);if(Ee.prerelease.length||We.prerelease.length){for(var He in Ee)if((He==="major"||He==="minor"||He==="patch")&&Ee[He]!==We[He])return"pre"+He;return"prerelease"}for(var He in Ee)if((He==="major"||He==="minor"||He==="patch")&&Ee[He]!==We[He])return He},e.compareIdentifiers=he;var Z=/^[0-9]+$/;function he(ae,ve){var Ee=Z.test(ae),We=Z.test(ve);return Ee&&We&&(ae=+ae,ve=+ve),Ee&&!We?-1:We&&!Ee?1:ae<ve?-1:ae>ve?1:0}function Te(ae,ve,Ee){return new X(ae,Ee).compare(new X(ve,Ee))}function Ne(ae,ve,Ee){return Te(ae,ve,Ee)>0}function Ke(ae,ve,Ee){return Te(ae,ve,Ee)<0}function Pe(ae,ve,Ee){return Te(ae,ve,Ee)===0}function Se(ae,ve,Ee){return Te(ae,ve,Ee)!==0}function Ie(ae,ve,Ee){return Te(ae,ve,Ee)>=0}function oe(ae,ve,Ee){return Te(ae,ve,Ee)<=0}function ce(ae,ve,Ee,We){var He;switch(ve){case"===":typeof ae=="object"&&(ae=ae.version),typeof Ee=="object"&&(Ee=Ee.version),He=ae===Ee;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof Ee=="object"&&(Ee=Ee.version),He=ae!==Ee;break;case"":case"=":case"==":He=Pe(ae,Ee,We);break;case"!=":He=Se(ae,Ee,We);break;case">":He=Ne(ae,Ee,We);break;case">=":He=Ie(ae,Ee,We);break;case"<":He=Ke(ae,Ee,We);break;case"<=":He=oe(ae,Ee,We);break;default:throw new TypeError("Invalid operator: "+ve)}return He}function Y(ae,ve){if(ae instanceof Y){if(ae.loose===ve)return ae;ae=ae.value}if(!(this instanceof Y))return new Y(ae,ve);D("comparator",ae,ve),this.loose=ve,this.parse(ae),this.semver===I?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ae,ve){return he(ve,ae)},e.major=function(ae,ve){return new X(ae,ve).major},e.minor=function(ae,ve){return new X(ae,ve).minor},e.patch=function(ae,ve){return new X(ae,ve).patch},e.compare=Te,e.compareLoose=function(ae,ve){return Te(ae,ve,!0)},e.rcompare=function(ae,ve,Ee){return Te(ve,ae,Ee)},e.sort=function(ae,ve){return ae.sort(function(Ee,We){return e.compare(Ee,We,ve)})},e.rsort=function(ae,ve){return ae.sort(function(Ee,We){return e.rcompare(Ee,We,ve)})},e.gt=Ne,e.lt=Ke,e.eq=Pe,e.neq=Se,e.gte=Ie,e.lte=oe,e.cmp=ce,e.Comparator=Y;var I={};function $(ae,ve){if(ae instanceof $)return ae.loose===ve?ae:new $(ae.raw,ve);if(ae instanceof Y)return new $(ae.value,ve);if(!(this instanceof $))return new $(ae,ve);if(this.loose=ve,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(Ee){return this.parseRange(Ee.trim())},this).filter(function(Ee){return Ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function W(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function q(ae,ve,Ee,We,He,tt,Xe,et,it,dt,Fe,ot,Q){return((ve=W(Ee)?"":W(We)?">="+Ee+".0.0":W(He)?">="+Ee+"."+We+".0":">="+ve)+" "+(et=W(it)?"":W(dt)?"<"+(+it+1)+".0.0":W(Fe)?"<"+it+"."+(+dt+1)+".0":ot?"<="+it+"."+dt+"."+Fe+"-"+ot:"<="+et)).trim()}function te(ae,ve){for(var Ee=0;Ee<ae.length;Ee++)if(!ae[Ee].test(ve))return!1;if(ve.prerelease.length){for(Ee=0;Ee<ae.length;Ee++)if(D(ae[Ee].semver),ae[Ee].semver!==I&&ae[Ee].semver.prerelease.length>0){var We=ae[Ee].semver;if(We.major===ve.major&&We.minor===ve.minor&&We.patch===ve.patch)return!0}return!1}return!0}function fe(ae,ve,Ee){try{ve=new $(ve,Ee)}catch{return!1}return ve.test(ae)}function ye(ae,ve,Ee,We){var He,tt,Xe,et,it;switch(ae=new X(ae,We),ve=new $(ve,We),Ee){case">":He=Ne,tt=oe,Xe=Ke,et=">",it=">=";break;case"<":He=Ke,tt=Ie,Xe=Ne,et="<",it="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(fe(ae,ve,We))return!1;for(var dt=0;dt<ve.set.length;++dt){var Fe=ve.set[dt],ot=null,Q=null;if(Fe.forEach(function(x){x.semver===I&&(x=new Y(">=0.0.0")),ot=ot||x,Q=Q||x,He(x.semver,ot.semver,We)?ot=x:Xe(x.semver,Q.semver,We)&&(Q=x)}),ot.operator===et||ot.operator===it||(!Q.operator||Q.operator===et)&&tt(ae,Q.semver)||Q.operator===it&&Xe(ae,Q.semver))return!1}return!0}Y.prototype.parse=function(ae){var ve=this.loose?O[j]:O[le],Ee=ae.match(ve);if(!Ee)throw new TypeError("Invalid comparator: "+ae);this.operator=Ee[1],this.operator==="="&&(this.operator=""),Ee[2]?this.semver=new X(Ee[2],this.loose):this.semver=I},Y.prototype.toString=function(){return this.value},Y.prototype.test=function(ae){return D("Comparator.test",ae,this.loose),this.semver===I||(typeof ae=="string"&&(ae=new X(ae,this.loose)),ce(ae,this.operator,this.semver,this.loose))},Y.prototype.intersects=function(ae,ve){if(!(ae instanceof Y))throw new TypeError("a Comparator is required");var Ee;if(this.operator==="")return Ee=new $(ae.value,ve),fe(this.value,Ee,ve);if(ae.operator==="")return Ee=new $(this.value,ve),fe(ae.semver,Ee,ve);var We=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),He=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),tt=this.semver.version===ae.semver.version,Xe=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),et=ce(this.semver,"<",ae.semver,ve)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),it=ce(this.semver,">",ae.semver,ve)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return We||He||tt&&Xe||et||it},e.Range=$,$.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},$.prototype.toString=function(){return this.range},$.prototype.parseRange=function(ae){var ve=this.loose;ae=ae.trim(),D("range",ae,ve);var Ee=ve?O[de]:O[be];ae=ae.replace(Ee,q),D("hyphen replace",ae),ae=ae.replace(O[_],"$1$2$3"),D("comparator trim",ae,O[_]),ae=(ae=(ae=ae.replace(O[ee],"$1~")).replace(O[P],"$1^")).split(/\s+/).join(" ");var We=ve?O[j]:O[le],He=ae.split(" ").map(function(tt){return function(Xe,et){return D("comp",Xe),Xe=function(it,dt){return it.trim().split(/\s+/).map(function(Fe){return function(ot,Q){D("caret",ot,Q);var x=Q?O[H]:O[F];return ot.replace(x,function(pe,Me,ze,Ve,_e){var nt;return D("caret",ot,pe,Me,ze,Ve,_e),W(Me)?nt="":W(ze)?nt=">="+Me+".0.0 <"+(+Me+1)+".0.0":W(Ve)?nt=Me==="0"?">="+Me+"."+ze+".0 <"+Me+"."+(+ze+1)+".0":">="+Me+"."+ze+".0 <"+(+Me+1)+".0.0":_e?(D("replaceCaret pr",_e),_e.charAt(0)!=="-"&&(_e="-"+_e),nt=Me==="0"?ze==="0"?">="+Me+"."+ze+"."+Ve+_e+" <"+Me+"."+ze+"."+(+Ve+1):">="+Me+"."+ze+"."+Ve+_e+" <"+Me+"."+(+ze+1)+".0":">="+Me+"."+ze+"."+Ve+_e+" <"+(+Me+1)+".0.0"):(D("no pr"),nt=Me==="0"?ze==="0"?">="+Me+"."+ze+"."+Ve+" <"+Me+"."+ze+"."+(+Ve+1):">="+Me+"."+ze+"."+Ve+" <"+Me+"."+(+ze+1)+".0":">="+Me+"."+ze+"."+Ve+" <"+(+Me+1)+".0.0"),D("caret return",nt),nt})}(Fe,dt)}).join(" ")}(Xe,et),D("caret",Xe),Xe=function(it,dt){return it.trim().split(/\s+/).map(function(Fe){return function(ot,Q){var x=Q?O[L]:O[K];return ot.replace(x,function(pe,Me,ze,Ve,_e){var nt;return D("tilde",ot,pe,Me,ze,Ve,_e),W(Me)?nt="":W(ze)?nt=">="+Me+".0.0 <"+(+Me+1)+".0.0":W(Ve)?nt=">="+Me+"."+ze+".0 <"+Me+"."+(+ze+1)+".0":_e?(D("replaceTilde pr",_e),_e.charAt(0)!=="-"&&(_e="-"+_e),nt=">="+Me+"."+ze+"."+Ve+_e+" <"+Me+"."+(+ze+1)+".0"):nt=">="+Me+"."+ze+"."+Ve+" <"+Me+"."+(+ze+1)+".0",D("tilde return",nt),nt})}(Fe,dt)}).join(" ")}(Xe,et),D("tildes",Xe),Xe=function(it,dt){return D("replaceXRanges",it,dt),it.split(/\s+/).map(function(Fe){return function(ot,Q){ot=ot.trim();var x=Q?O[C]:O[l];return ot.replace(x,function(pe,Me,ze,Ve,_e,nt){D("xRange",ot,pe,Me,ze,Ve,_e,nt);var vt=W(ze),wt=vt||W(Ve),Ct=wt||W(_e);return Me==="="&&Ct&&(Me=""),vt?pe=Me===">"||Me==="<"?"<0.0.0":"*":Me&&Ct?(wt&&(Ve=0),Ct&&(_e=0),Me===">"?(Me=">=",wt?(ze=+ze+1,Ve=0,_e=0):Ct&&(Ve=+Ve+1,_e=0)):Me==="<="&&(Me="<",wt?ze=+ze+1:Ve=+Ve+1),pe=Me+ze+"."+Ve+"."+_e):wt?pe=">="+ze+".0.0 <"+(+ze+1)+".0.0":Ct&&(pe=">="+ze+"."+Ve+".0 <"+ze+"."+(+Ve+1)+".0"),D("xRange return",pe),pe})}(Fe,dt)}).join(" ")}(Xe,et),D("xrange",Xe),Xe=function(it,dt){return D("replaceStars",it,dt),it.trim().replace(O[ue],"")}(Xe,et),D("stars",Xe),Xe}(tt,ve)}).join(" ").split(/\s+/);return this.loose&&(He=He.filter(function(tt){return!!tt.match(We)})),He=He.map(function(tt){return new Y(tt,ve)})},$.prototype.intersects=function(ae,ve){if(!(ae instanceof $))throw new TypeError("a Range is required");return this.set.some(function(Ee){return Ee.every(function(We){return ae.set.some(function(He){return He.every(function(tt){return We.intersects(tt,ve)})})})})},e.toComparators=function(ae,ve){return new $(ae,ve).set.map(function(Ee){return Ee.map(function(We){return We.value}).join(" ").trim().split(" ")})},$.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new X(ae,this.loose));for(var ve=0;ve<this.set.length;ve++)if(te(this.set[ve],ae))return!0;return!1},e.satisfies=fe,e.maxSatisfying=function(ae,ve,Ee){var We=null,He=null;try{var tt=new $(ve,Ee)}catch{return null}return ae.forEach(function(Xe){tt.test(Xe)&&(We&&He.compare(Xe)!==-1||(He=new X(We=Xe,Ee)))}),We},e.minSatisfying=function(ae,ve,Ee){var We=null,He=null;try{var tt=new $(ve,Ee)}catch{return null}return ae.forEach(function(Xe){tt.test(Xe)&&(We&&He.compare(Xe)!==1||(He=new X(We=Xe,Ee)))}),We},e.validRange=function(ae,ve){try{return new $(ae,ve).range||"*"}catch{return null}},e.ltr=function(ae,ve,Ee){return ye(ae,ve,"<",Ee)},e.gtr=function(ae,ve,Ee){return ye(ae,ve,">",Ee)},e.outside=ye,e.prerelease=function(ae,ve){var Ee=J(ae,ve);return Ee&&Ee.prerelease.length?Ee.prerelease:null},e.intersects=function(ae,ve,Ee){return ae=new $(ae,Ee),ve=new $(ve,Ee),ae.intersects(ve)},e.coerce=function(ae){if(ae instanceof X)return ae;if(typeof ae!="string")return null;var ve=ae.match(O[R]);return ve==null?null:J((ve[1]||"0")+"."+(ve[2]||"0")+"."+(ve[3]||"0"))}}).call(this,r(1))},function(ie,e){var r,k,D=ie.exports={};function M(){throw new Error("setTimeout has not been defined")}function S(){throw new Error("clearTimeout has not been defined")}function O(s){if(r===setTimeout)return setTimeout(s,0);if((r===M||!r)&&setTimeout)return r=setTimeout,setTimeout(s,0);try{return r(s,0)}catch{try{return r.call(null,s,0)}catch{return r.call(this,s,0)}}}(function(){try{r=typeof setTimeout=="function"?setTimeout:M}catch{r=M}try{k=typeof clearTimeout=="function"?clearTimeout:S}catch{k=S}})();var y,T=[],N=!1,E=-1;function f(){N&&y&&(N=!1,y.length?T=y.concat(T):E=-1,T.length&&b())}function b(){if(!N){var s=O(f);N=!0;for(var h=T.length;h;){for(y=T,T=[];++E<h;)y&&y[E].run();E=-1,h=T.length}y=null,N=!1,function(p){if(k===clearTimeout)return clearTimeout(p);if((k===S||!k)&&clearTimeout)return k=clearTimeout,clearTimeout(p);try{k(p)}catch{try{return k.call(null,p)}catch{return k.call(this,p)}}}(s)}}function m(s,h){this.fun=s,this.array=h}function o(){}D.nextTick=function(s){var h=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)h[p-1]=arguments[p];T.push(new m(s,h)),T.length!==1||N||O(b)},m.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=o,D.addListener=o,D.once=o,D.off=o,D.removeListener=o,D.removeAllListeners=o,D.emit=o,D.prependListener=o,D.prependOnceListener=o,D.listeners=function(s){return[]},D.binding=function(s){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(s){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(Ce[114],ke([1,0,12,6]),function(ie,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(A){const v=A;return v?typeof v.read=="function":!1}e.isReadable=D;function M(A){const v=A;return v?[v.on,v.pause,v.resume,v.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=M;function S(A){const v=A;return v?M(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}e.isReadableBufferedStream=S;function O(A,v){return new y(A,v)}e.newWriteableStream=O;class y{constructor(v,i){this.e=v,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(v){if(!this.a.destroyed){if(this.a.flowing)this.g(v);else if(this.b.data.push(v),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(v){this.a.destroyed||(this.a.flowing?this.h(v):this.b.error.push(v))}end(v){this.a.destroyed||(typeof v<"u"&&this.write(v),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(v){this.c.data.slice(0).forEach(i=>i(v))}h(v){this.c.error.length===0?(0,r.onUnexpectedError)(v):this.c.error.slice(0).forEach(i=>i(v))}i(){this.c.end.slice(0).forEach(v=>v())}on(v,i){if(!this.a.destroyed)switch(v){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(v,i){if(this.a.destroyed)return;let d;switch(v){case"data":d=this.c.data;break;case"end":d=this.c.end;break;case"error":d=this.c.error;break}if(d){const n=d.indexOf(i);n>=0&&d.splice(n,1)}}j(){if(this.b.data.length>0){const v=this.e(this.b.data);this.g(v),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(d=>d())}}k(){if(this.c.error.length>0){for(const v of this.b.error)this.h(v);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function T(A,v){const i=[];let d;for(;(d=A.read())!==null;)i.push(d);return v(i)}e.consumeReadable=T;function N(A,v,i){const d=[];let n;for(;(n=A.read())!==null&&d.length<i;)d.push(n);return n===null&&d.length>0?v(d):{read:()=>{if(d.length>0)return d.shift();if(typeof n<"u"){const a=n;return n=void 0,a}return A.read()}}}e.peekReadable=N;function E(A,v){return new Promise((i,d)=>{const n=[];f(A,{onData:a=>{v&&n.push(a)},onError:a=>{v?d(a):i(void 0)},onEnd:()=>{i(v?v(n):void 0)}})})}e.consumeStream=E;function f(A,v){let i=!1;return A.on("error",d=>{i||v.onError(d)}),A.on("end",()=>{i||v.onEnd()}),A.on("data",d=>{i||v.onData(d)}),(0,k.toDisposable)(()=>i=!0)}e.listenStream=f;function b(A,v){return new Promise((i,d)=>{const n=new k.DisposableStore,a=[],t=u=>{if(a.push(u),a.length>v)return n.dispose(),A.pause(),i({stream:A,buffer:a,ended:!1})},g=u=>d(u),c=()=>i({stream:A,buffer:a,ended:!0});n.add((0,k.toDisposable)(()=>A.removeListener("error",g))),A.on("error",g),n.add((0,k.toDisposable)(()=>A.removeListener("end",c))),A.on("end",c),n.add((0,k.toDisposable)(()=>A.removeListener("data",t))),A.on("data",t)})}e.peekStream=b;function m(A,v){const i=O(v);return i.end(A),i}e.toStream=m;function o(){const A=O(()=>{throw new Error("not supported")});return A.end(),A}e.emptyStream=o;function s(A){let v=!1;return{read:()=>v?null:(v=!0,A)}}e.toReadable=s;function h(A,v,i){const d=O(i);return f(A,{onData:n=>d.write(v.data(n)),onError:n=>d.error(v.error?v.error(n):n),onEnd:()=>d.end()}),d}e.transform=h;function p(A,v,i){let d=!1;return{read:()=>{const n=v.read();return d?n:(d=!0,n!==null?i([A,n]):A)}}}e.prefixedReadable=p;function w(A,v,i){let d=!1;const n=O(i);return f(v,{onData:a=>d?n.write(a):(d=!0,n.write(i([A,a]))),onError:a=>n.error(a),onEnd:()=>{d||(d=!0,n.write(A)),n.end()}}),n}e.prefixedStream=w}),define(Ce[23],ke([1,0,114]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const k=typeof Buffer<"u";let D,M;class S{static alloc(u){return k?new S(Buffer.allocUnsafe(u)):new S(new Uint8Array(u))}static wrap(u){return k&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new S(u)}static fromString(u,l){return!(l?.dontUseNodeBuffer||!1)&&k?new S(Buffer.from(u)):(D||(D=new TextEncoder),new S(D.encode(u)))}static fromByteArray(u){const l=S.alloc(u.length);for(let C=0,R=u.length;C<R;C++)l.buffer[C]=u[C];return l}static concat(u,l){if(typeof l>"u"){l=0;for(let V=0,ee=u.length;V<ee;V++)l+=u[V].byteLength}const C=S.alloc(l);let R=0;for(let V=0,ee=u.length;V<ee;V++){const K=u[V];C.set(K,R),R+=K.byteLength}return C}constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}clone(){const u=S.alloc(this.byteLength);return u.set(this),u}toString(){return k?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(u,l){return new S(this.buffer.subarray(u,l))}set(u,l){if(u instanceof S)this.buffer.set(u.buffer,l);else if(u instanceof Uint8Array)this.buffer.set(u,l);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),l);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),l);else throw new Error("Unknown argument 'array'")}readUInt32BE(u){return T(this.buffer,u)}writeUInt32BE(u,l){N(this.buffer,u,l)}readUInt32LE(u){return E(this.buffer,u)}writeUInt32LE(u,l){f(this.buffer,u,l)}readUInt8(u){return b(this.buffer,u)}writeUInt8(u,l){m(this.buffer,u,l)}}e.VSBuffer=S;function O(c,u){return c[u+0]<<0>>>0|c[u+1]<<8>>>0}e.readUInt16LE=O;function y(c,u,l){c[l+0]=u&255,u=u>>>8,c[l+1]=u&255}e.writeUInt16LE=y;function T(c,u){return c[u]*2**24+c[u+1]*2**16+c[u+2]*2**8+c[u+3]}e.readUInt32BE=T;function N(c,u,l){c[l+3]=u,u=u>>>8,c[l+2]=u,u=u>>>8,c[l+1]=u,u=u>>>8,c[l]=u}e.writeUInt32BE=N;function E(c,u){return c[u+0]<<0>>>0|c[u+1]<<8>>>0|c[u+2]<<16>>>0|c[u+3]<<24>>>0}e.readUInt32LE=E;function f(c,u,l){c[l+0]=u&255,u=u>>>8,c[l+1]=u&255,u=u>>>8,c[l+2]=u&255,u=u>>>8,c[l+3]=u&255}e.writeUInt32LE=f;function b(c,u){return c[u]}e.readUInt8=b;function m(c,u,l){c[l]=u}e.writeUInt8=m;function o(c){return r.consumeReadable(c,u=>S.concat(u))}e.readableToBuffer=o;function s(c){return r.toReadable(c)}e.bufferToReadable=s;function h(c){return r.consumeStream(c,u=>S.concat(u))}e.streamToBuffer=h;async function p(c){return c.ended?S.concat(c.buffer):S.concat([...c.buffer,await h(c.stream)])}e.bufferedStreamToBuffer=p;function w(c){return r.toStream(c,u=>S.concat(u))}e.bufferToStream=w;function A(c){return r.transform(c,{data:u=>typeof u=="string"?S.fromString(u):S.wrap(u)},u=>S.concat(u))}e.streamToBufferReadableStream=A;function v(c){return r.newWriteableStream(u=>S.concat(u),c)}e.newWriteableBufferStream=v;function i(c,u){return r.prefixedReadable(c,u,l=>S.concat(l))}e.prefixedBufferReadable=i;function d(c,u){return r.prefixedStream(c,u,l=>S.concat(l))}e.prefixedBufferStream=d;function n(c){let u=0,l=0,C=0;const R=new Uint8Array(Math.floor(c.length/4*3)),V=K=>{switch(l){case 3:R[C++]=u|K,l=0;break;case 2:R[C++]=u|K>>>2,u=K<<6,l=3;break;case 1:R[C++]=u|K>>>4,u=K<<4,l=2;break;default:u=K<<2,l=1}};for(let K=0;K<c.length;K++){const L=c.charCodeAt(K);if(L>=65&&L<=90)V(L-65);else if(L>=97&&L<=122)V(L-97+26);else if(L>=48&&L<=57)V(L-48+52);else if(L===43||L===45)V(62);else if(L===47||L===95)V(63);else{if(L===61)break;throw new SyntaxError(`Unexpected base64 character ${c[K]}`)}}const ee=C;for(;l>0;)V(0);return S.wrap(R).slice(0,ee)}e.decodeBase64=n;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function g({buffer:c},u=!0,l=!1){const C=l?t:a;let R="";const V=c.byteLength%3;let ee=0;for(;ee<c.byteLength-V;ee+=3){const K=c[ee+0],L=c[ee+1],B=c[ee+2];R+=C[K>>>2],R+=C[(K<<4|L>>>4)&63],R+=C[(L<<2|B>>>6)&63],R+=C[B&63]}if(V===1){const K=c[ee+0];R+=C[K>>>2],R+=C[K<<4&63],u&&(R+="==")}else if(V===2){const K=c[ee+0],L=c[ee+1];R+=C[K>>>2],R+=C[(K<<4|L>>>4)&63],R+=C[L<<2&63],u&&(R+="=")}return R}e.encodeBase64=g}),define(Ce[115],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Ce[38],ke([1,0,84]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var k;(function(S){function O(y){return y&&typeof y=="object"&&typeof y.id=="string"}S.isThemeColor=O})(k=e.ThemeColor||(e.ThemeColor={}));function D(S){return{id:S}}e.themeColorFromId=D;var M;(function(S){S.iconNameSegment="[A-Za-z0-9]+",S.iconNameExpression="[A-Za-z0-9-]+",S.iconModifierExpression="~[A-Za-z]+",S.iconNameCharacter="[A-Za-z0-9~-]";const O=new RegExp(`^(${S.iconNameExpression})(${S.iconModifierExpression})?$`);function y(p){const w=O.exec(p.id);if(!w)return y(r.Codicon.error);const[,A,v]=w,i=["codicon","codicon-"+A];return v&&i.push("codicon-modifier-"+v.substring(1)),i}S.asClassNameArray=y;function T(p){return y(p).join(" ")}S.asClassName=T;function N(p){return"."+y(p).join(".")}S.asCSSSelector=N;function E(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(typeof p.color>"u"||k.isThemeColor(p.color))}S.isThemeIcon=E;const f=new RegExp(`^\\$\\((${S.iconNameExpression}(?:${S.iconModifierExpression})?)\\)$`);function b(p){const w=f.exec(p);if(!w)return;const[,A]=w;return{id:A}}S.fromString=b;function m(p){return{id:p}}S.fromId=m;function o(p,w){let A=p.id;const v=A.lastIndexOf("~");return v!==-1&&(A=A.substring(0,v)),w&&(A=`${A}~${w}`),{id:A}}S.modify=o;function s(p){const w=p.id.lastIndexOf("~");if(w!==-1)return p.id.substring(w+1)}S.getModifier=s;function h(p,w){return p.id===w.id&&p.color?.id===w.color?.id}S.isEqual=h})(M=e.ThemeIcon||(e.ThemeIcon={}))}),define(Ce[34],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const r=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(D){return r.test(D)}e.isUUID=k,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(O){for(let y=0;y<O.length;y++)O[y]=Math.floor(Math.random()*256);return O};const M=new Uint8Array(16),S=[];for(let O=0;O<256;O++)S.push(O.toString(16).padStart(2,"0"));return function(){D(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let y=0,T="";return T+=S[M[y++]],T+=S[M[y++]],T+=S[M[y++]],T+=S[M[y++]],T+="-",T+=S[M[y++]],T+=S[M[y++]],T+="-",T+=S[M[y++]],T+=S[M[y++]],T+="-",T+=S[M[y++]],T+=S[M[y++]],T+="-",T+=S[M[y++]],T+=S[M[y++]],T+=S[M[y++]],T+=S[M[y++]],T+=S[M[y++]],T+=S[M[y++]],T}}()}),define(Ce[116],ke([1,0,18,34]),function(ie,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function D(O){return{id:(0,k.generateUuid)(),asString:async()=>O,asFile:()=>{},value:typeof O=="string"?O:void 0}}e.createStringDataTransferItem=D;function M(O,y,T){return{id:(0,k.generateUuid)(),asString:async()=>"",asFile:()=>({name:O,uri:y,data:T}),value:void 0}}e.createFileDataTransferItem=M;class S{constructor(){this.a=new Map}get size(){return this.a.size}has(y){return this.a.has(this.b(y))}get(y){return this.a.get(this.b(y))?.[0]}append(y,T){const N=this.a.get(y);N?N.push(T):this.a.set(this.b(y),[T])}replace(y,T){this.a.set(this.b(y),[T])}delete(y){this.a.delete(this.b(y))}*entries(){for(const[y,T]of this.a.entries())for(const N of T)yield[y,N]}values(){return Array.from(this.a.values()).flat()}forEach(y){for(const[T,N]of this.entries())y(N,T)}b(y){return y.toLowerCase()}}e.VSDataTransfer=S,e.UriList=Object.freeze({create:O=>(0,r.distinct)(O.map(y=>y.toString())).join(`\r
`),split:O=>O.split(`\r
`),parse:O=>e.UriList.split(O).filter(y=>!y.startsWith("#"))})}),define(Ce[117],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[118],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var r;(function(S){S[S.None=0]="None",S[S.Indent=1]="Indent",S[S.IndentOutdent=2]="IndentOutdent",S[S.Outdent=3]="Outdent"})(r=e.IndentAction||(e.IndentAction={}));class k{constructor(O){if(this.e=null,this.f=!1,this.open=O.open,this.close=O.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(O.notIn))for(let y=0,T=O.notIn.length;y<T;y++)switch(O.notIn[y]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(O){switch(O){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(O,y){if(O.getTokenCount()===0)return!0;const T=O.findTokenIndexAtOffset(y-2),N=O.getStandardTokenType(T);return this.isOK(N)}g(O,y){for(let T=O;T<=y;T++){const N=String.fromCharCode(T);if(!this.open.includes(N)&&!this.close.includes(N))return N}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=k;class D{constructor(O){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of O)M(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),M(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),M(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),M(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&M(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=D;function M(S,O,y){S.has(O)?S.get(O).push(y):S.set(O,[y])}}),define(Ce[119],ke([13,14]),function(ie,e){return ie.create("vs/base/common/actions",e)}),define(Ce[120],ke([13,14]),function(ie,e){return ie.create("vs/base/common/date",e)}),define(Ce[121],ke([1,0,120]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const k=60,D=k*60,M=D*24,S=M*7,O=M*30,y=M*365;function T(E,f,b,m){typeof E!="number"&&(E=E.getTime());const o=Math.round((new Date().getTime()-E)/1e3);if(o<-30)return(0,r.localize)(0,null,T(new Date().getTime()+o*1e3,!1));if(!m&&o<30)return(0,r.localize)(1,null);let s;return o<k?(s=o,f?s===1?b?(0,r.localize)(2,null,s):(0,r.localize)(3,null,s):b?(0,r.localize)(4,null,s):(0,r.localize)(5,null,s):s===1?b?(0,r.localize)(6,null,s):(0,r.localize)(7,null,s):b?(0,r.localize)(8,null,s):(0,r.localize)(9,null,s)):o<D?(s=Math.floor(o/k),f?s===1?b?(0,r.localize)(10,null,s):(0,r.localize)(11,null,s):b?(0,r.localize)(12,null,s):(0,r.localize)(13,null,s):s===1?b?(0,r.localize)(14,null,s):(0,r.localize)(15,null,s):b?(0,r.localize)(16,null,s):(0,r.localize)(17,null,s)):o<M?(s=Math.floor(o/D),f?s===1?b?(0,r.localize)(18,null,s):(0,r.localize)(19,null,s):b?(0,r.localize)(20,null,s):(0,r.localize)(21,null,s):s===1?b?(0,r.localize)(22,null,s):(0,r.localize)(23,null,s):b?(0,r.localize)(24,null,s):(0,r.localize)(25,null,s)):o<S?(s=Math.floor(o/M),f?s===1?(0,r.localize)(26,null,s):(0,r.localize)(27,null,s):s===1?(0,r.localize)(28,null,s):(0,r.localize)(29,null,s)):o<O?(s=Math.floor(o/S),f?s===1?b?(0,r.localize)(30,null,s):(0,r.localize)(31,null,s):b?(0,r.localize)(32,null,s):(0,r.localize)(33,null,s):s===1?b?(0,r.localize)(34,null,s):(0,r.localize)(35,null,s):b?(0,r.localize)(36,null,s):(0,r.localize)(37,null,s)):o<y?(s=Math.floor(o/O),f?s===1?b?(0,r.localize)(38,null,s):(0,r.localize)(39,null,s):b?(0,r.localize)(40,null,s):(0,r.localize)(41,null,s):s===1?b?(0,r.localize)(42,null,s):(0,r.localize)(43,null,s):b?(0,r.localize)(44,null,s):(0,r.localize)(45,null,s)):(s=Math.floor(o/y),f?s===1?b?(0,r.localize)(46,null,s):(0,r.localize)(47,null,s):b?(0,r.localize)(48,null,s):(0,r.localize)(49,null,s):s===1?b?(0,r.localize)(50,null,s):(0,r.localize)(51,null,s):b?(0,r.localize)(52,null,s):(0,r.localize)(53,null,s))}e.fromNow=T;function N(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=N}),define(Ce[122],ke([13,14]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(Ce[39],ke([1,0,18,9,122]),function(ie,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function M(E,f){return f&&(E.stack||E.stacktrace)?D.localize(0,null,O(E),S(E.stack)||S(E.stacktrace)):O(E)}function S(E){return Array.isArray(E)?E.join(`
`):E}function O(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?D.localize(1,null,E.message):E.message||D.localize(2,null)}function y(E=null,f=!1){if(!E)return D.localize(3,null);if(Array.isArray(E)){const b=r.coalesce(E),m=y(b[0],f);return b.length>1?D.localize(4,null,m,b.length):m}if(k.isString(E))return E;if(E.detail){const b=E.detail;if(b.error)return M(b.error,f);if(b.exception)return M(b.exception,f)}return E.stack?M(E,f):E.message?E.message:D.localize(5,null)}e.toErrorMessage=y;function T(E){const f=E;return f instanceof Error&&Array.isArray(f.actions)}e.isErrorWithActions=T;function N(E,f){let b;return typeof E=="string"?b=new Error(E):b=E,b.actions=f,b}e.createErrorWithActions=N}),define(Ce[123],ke([1,0,85,19]),function(ie,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new r.Lazy(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),M=new r.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),S=new r.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function O(u,l,C=!1){const R=u||"",V=l||"",ee=D.value.collator.compare(R,V);return D.value.collatorIsNumeric&&ee===0&&R!==V?R<V?-1:1:ee}e.compareFileNames=O;function y(u,l){const C=M.value.collator;return u=u||"",l=l||"",A(C,u,l)}e.compareFileNamesDefault=y;function T(u,l){const C=M.value.collator;return u=u||"",l=l||"",n(u,l)||A(C,u,l)}e.compareFileNamesUpper=T;function N(u,l){const C=M.value.collator;return u=u||"",l=l||"",d(u,l)||A(C,u,l)}e.compareFileNamesLower=N;function E(u,l){return u=u||"",l=l||"",u===l?0:u<l?-1:1}e.compareFileNamesUnicode=E;function f(u,l){const[C,R]=p(u),[V,ee]=p(l);let K=D.value.collator.compare(R,ee);if(K===0){if(D.value.collatorIsNumeric&&R!==ee)return R<ee?-1:1;if(K=D.value.collator.compare(C,V),D.value.collatorIsNumeric&&K===0&&C!==V)return C<V?-1:1}return K}e.compareFileExtensions=f;function b(u,l){u=u||"",l=l||"";const C=w(u),R=w(l),V=M.value.collator,ee=S.value.collator;return A(ee,C,R)||A(V,u,l)}e.compareFileExtensionsDefault=b;function m(u,l){u=u||"",l=l||"";const C=w(u),R=w(l),V=M.value.collator,ee=S.value.collator;return A(ee,C,R)||n(u,l)||A(V,u,l)}e.compareFileExtensionsUpper=m;function o(u,l){u=u||"",l=l||"";const C=w(u),R=w(l),V=M.value.collator,ee=S.value.collator;return A(ee,C,R)||d(u,l)||A(V,u,l)}e.compareFileExtensionsLower=o;function s(u,l){u=u||"",l=l||"";const C=w(u).toLowerCase(),R=w(l).toLowerCase();return C!==R?C<R?-1:1:u!==l?u<l?-1:1:0}e.compareFileExtensionsUnicode=s;const h=/^(.*?)(\.([^.]*))?$/;function p(u,l=!1){const C=u?h.exec(u):[];let R=[C&&C[1]||"",C&&C[3]||""];return l&&(!R[0]&&R[1]||R[0]&&R[0].charAt(0)===".")&&(R=[R[0]+"."+R[1],""]),R}function w(u){const l=u?h.exec(u):[];return l&&l[1]&&l[1].charAt(0)!=="."&&l[3]||""}function A(u,l,C){const R=u.compare(l,C);return R!==0?R:l.length!==C.length?l.length<C.length?-1:1:0}function v(u){const l=u.charAt(0);return l.toLocaleUpperCase()!==l}function i(u){const l=u.charAt(0);return l.toLocaleLowerCase()!==l}function d(u,l){return v(u)&&i(l)?-1:i(u)&&v(l)?1:0}function n(u,l){return i(u)&&v(l)?-1:v(u)&&i(l)?1:0}function a(u,l,C=!1){return C||(u=u&&u.toLowerCase(),l=l&&l.toLowerCase()),u===l?0:u<l?-1:1}function t(u,l,C=!1){const R=u.split(k.sep),V=l.split(k.sep),ee=R.length-1,K=V.length-1;let L,B;for(let P=0;;P++){if(L=ee===P,B=K===P,L&&B)return O(R[P],V[P],C);if(L)return-1;if(B)return 1;const F=a(R[P],V[P],C);if(F!==0)return F}}e.comparePaths=t;function g(u,l,C){const R=u.toLowerCase(),V=l.toLowerCase(),ee=c(u,l,C);if(ee)return ee;const K=R.endsWith(C),L=V.endsWith(C);if(K!==L)return K?-1:1;const B=O(R,V);return B!==0?B:R.localeCompare(V)}e.compareAnything=g;function c(u,l,C){const R=u.toLowerCase(),V=l.toLowerCase(),ee=R.startsWith(C),K=V.startsWith(C);if(ee!==K)return ee?-1:1;if(ee&&K){if(R.length<V.length)return-1;if(R.length>V.length)return 1}return 0}e.compareByPrefix=c}),define(Ce[64],ke([1,0,19]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const k={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(N){const E=(0,r.extname)(N),f=k[E.toLowerCase()];return f!==void 0?f:S(N)}e.getMediaOrTextMime=M;function S(N){const E=(0,r.extname)(N);return D[E.toLowerCase()]}e.getMediaMime=S;function O(N){for(const E in D)if(D[E]===N)return E}e.getExtensionForMimeType=O;const y=/^(.+)\/(.+?)(;.+)?$/;function T(N,E){const f=y.exec(N);return f?`${f[1].toLowerCase()}/${f[2].toLowerCase()}${f[3]??""}`:E?void 0:N}e.normalizeMimeType=T}),define(Ce[124],ke([1,0,4,6,119]),function(ie,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class M extends k.Disposable{constructor(f,b="",m="",o=!0,s){super(),this.h=this.B(new r.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=f,this.m=b,this.u=m,this.w=o,this.C=s}get id(){return this.j}get label(){return this.m}set label(f){this.D(f)}D(f){this.m!==f&&(this.m=f,this.h.fire({label:f}))}get tooltip(){return this.n||""}set tooltip(f){this.F(f)}F(f){this.n!==f&&(this.n=f,this.h.fire({tooltip:f}))}get class(){return this.u}set class(f){this.G(f)}G(f){this.u!==f&&(this.u=f,this.h.fire({class:f}))}get enabled(){return this.w}set enabled(f){this.H(f)}H(f){this.w!==f&&(this.w=f,this.h.fire({enabled:f}))}get checked(){return this.z}set checked(f){this.I(f)}I(f){this.z!==f&&(this.z=f,this.h.fire({checked:f}))}async run(f,b){this.C&&await this.C(f)}}e.Action=M;class S extends k.Disposable{constructor(){super(...arguments),this.f=this.B(new r.Emitter),this.onWillRun=this.f.event,this.h=this.B(new r.Emitter),this.onDidRun=this.h.event}async run(f,b){if(!f.enabled)return;this.f.fire({action:f});let m;try{await this.runAction(f,b)}catch(o){m=o}this.h.fire({action:f,error:m})}async runAction(f,b){await f.run(b)}}e.ActionRunner=S;class O{constructor(){this.id=O.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...f){let b=[];for(const m of f)m.length&&(b.length?b=[...b,new O,...m]:b=m);return b}async run(){}}e.Separator=O,O.ID="vs.actions.separator";class y{get actions(){return this.a}constructor(f,b,m,o){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=f,this.label=b,this.class=o,this.a=m}async run(){}}e.SubmenuAction=y;class T extends M{constructor(){super(T.ID,D.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=T,T.ID="vs.actions.empty";function N(E){return{id:E.id,label:E.label,class:void 0,enabled:E.enabled??!0,checked:E.checked??!1,run:async()=>E.run(),tooltip:E.label}}e.toAction=N}),define(Ce[40],ke([1,0,19,20,10,9]),function(ie,e,r,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function S(t){return t===47||t===92}e.isPathSeparator=S;function O(t){return t.replace(/[\\/]/g,r.posix.sep)}e.toSlashes=O;function y(t){return t.indexOf("/")===-1&&(t=O(t)),/^[a-zA-Z]:(\/|$)/.test(t)&&(t="/"+t),t}e.toPosixPath=y;function T(t,g=r.posix.sep){if(!t)return"";const c=t.length,u=t.charCodeAt(0);if(S(u)){if(S(t.charCodeAt(1))&&!S(t.charCodeAt(2))){let C=3;const R=C;for(;C<c&&!S(t.charCodeAt(C));C++);if(R!==C&&!S(t.charCodeAt(C+1))){for(C+=1;C<c;C++)if(S(t.charCodeAt(C)))return t.slice(0,C+1).replace(/[\\/]/g,g)}}return g}else if(h(u)&&t.charCodeAt(1)===58)return S(t.charCodeAt(2))?t.slice(0,2)+g:t.slice(0,2);let l=t.indexOf("://");if(l!==-1){for(l+=3;l<c;l++)if(S(t.charCodeAt(l)))return t.slice(0,l+1)}return""}e.getRoot=T;function N(t){if(!k.isWindows||!t||t.length<5)return!1;let g=t.charCodeAt(0);if(g!==92||(g=t.charCodeAt(1),g!==92))return!1;let c=2;const u=c;for(;c<t.length&&(g=t.charCodeAt(c),g!==92);c++);return!(u===c||(g=t.charCodeAt(c+1),isNaN(g)||g===92))}e.isUNC=N;const E=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(t,g=k.isWindows){const c=g?E:f;return!(!t||t.length===0||/^\s+$/.test(t)||(c.lastIndex=0,c.test(t))||g&&b.test(t)||t==="."||t===".."||g&&t[t.length-1]==="."||g&&t.length!==t.trim().length||t.length>255)}e.isValidBasename=m;function o(t,g,c){const u=t===g;return!c||u?u:!t||!g?!1:(0,D.equalsIgnoreCase)(t,g)}e.isEqual=o;function s(t,g,c,u=r.sep){if(t===g)return!0;if(!t||!g||g.length>t.length)return!1;if(c){if(!(0,D.startsWithIgnoreCase)(t,g))return!1;if(g.length===t.length)return!0;let C=g.length;return g.charAt(g.length-1)===u&&C--,t.charAt(C)===u}return g.charAt(g.length-1)!==u&&(g+=u),t.indexOf(g)===0}e.isEqualOrParent=s;function h(t){return t>=65&&t<=90||t>=97&&t<=122}e.isWindowsDriveLetter=h;function p(t,g){return k.isWindows&&t.endsWith(":")&&(t+=r.sep),(0,r.isAbsolute)(t)||(t=(0,r.join)(g,t)),t=(0,r.normalize)(t),k.isWindows?(t=(0,D.rtrim)(t,r.sep),t.endsWith(":")&&(t+=r.sep)):(t=(0,D.rtrim)(t,r.sep),t||(t=r.sep)),t}e.sanitizeFilePath=p;function w(t){const g=(0,r.normalize)(t);return k.isWindows?t.length>3?!1:A(g)&&(t.length===2||g.charCodeAt(2)===92):g===r.posix.sep}e.isRootOrDriveLetter=w;function A(t,g=k.isWindows){return g?h(t.charCodeAt(0))&&t.charCodeAt(1)===58:!1}e.hasDriveLetter=A;function v(t){return A(t)?t[0]:void 0}e.getDriveLetter=v;function i(t,g,c){return g.length>t.length?-1:t===g?0:(c&&(t=t.toLowerCase(),g=g.toLowerCase()),t.indexOf(g))}e.indexOfPath=i;function d(t){const g=t.split(":");let c,u,l;for(const C of g){const R=Number(C);(0,M.isNumber)(R)?u===void 0?u=R:l===void 0&&(l=R):c=c?[c,C].join(":"):C}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:u!==void 0?u:void 0,column:l!==void 0?l:u!==void 0?1:void 0}}e.parseLineAndColumnAware=d;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function a(t,g,c=8){let u="";for(let C=0;C<c;C++)u+=n.charAt(Math.floor(Math.random()*n.length));let l;return g?l=`${g}-${u}`:l=u,t?(0,r.join)(t,l):l}e.randomPath=a}),define(Ce[125],ke([1,0,28,10]),function(ie,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...Y){return function(I,$){for(let W=0,q=Y.length;W<q;W++){const te=Y[W](I,$);if(te)return te}return null}}e.or=D,e.matchesStrictPrefix=M.bind(void 0,!1),e.matchesPrefix=M.bind(void 0,!0);function M(Y,I,$){if(!$||$.length<I.length)return null;let W;return Y?W=k.startsWithIgnoreCase($,I):W=$.indexOf(I)===0,W?I.length>0?[{start:0,end:I.length}]:[]:null}function S(Y,I){const $=I.toLowerCase().indexOf(Y.toLowerCase());return $===-1?null:[{start:$,end:$+Y.length}]}e.matchesContiguousSubString=S;function O(Y,I){return y(Y.toLowerCase(),I.toLowerCase(),0,0)}e.matchesSubString=O;function y(Y,I,$,W){if($===Y.length)return[];if(W===I.length)return null;if(Y[$]===I[W]){let q=null;return(q=y(Y,I,$+1,W+1))?h({start:W,end:W+1},q):null}return y(Y,I,$,W+1)}function T(Y){return 97<=Y&&Y<=122}function N(Y){return 65<=Y&&Y<=90}e.isUpper=N;function E(Y){return 48<=Y&&Y<=57}function f(Y){return Y===32||Y===9||Y===10||Y===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Y=>b.add(Y.charCodeAt(0)));function m(Y){return f(Y)||b.has(Y)}function o(Y,I){return Y===I||m(Y)&&m(I)}function s(Y){return T(Y)||N(Y)||E(Y)}function h(Y,I){return I.length===0?I=[Y]:Y.end===I[0].start?I[0].start=Y.start:I.unshift(Y),I}function p(Y,I){for(let $=I;$<Y.length;$++){const W=Y.charCodeAt($);if(N(W)||E(W)||$>0&&!s(Y.charCodeAt($-1)))return $}return Y.length}function w(Y,I,$,W){if($===Y.length)return[];if(W===I.length)return null;if(Y[$]!==I[W].toLowerCase())return null;{let q=null,te=W+1;for(q=w(Y,I,$+1,W+1);!q&&(te=p(I,te))<I.length;)q=w(Y,I,$+1,te),te++;return q===null?null:h({start:W,end:W+1},q)}}function A(Y){let I=0,$=0,W=0,q=0,te=0;for(let Ee=0;Ee<Y.length;Ee++)te=Y.charCodeAt(Ee),N(te)&&I++,T(te)&&$++,s(te)&&W++,E(te)&&q++;const fe=I/Y.length,ye=$/Y.length,ae=W/Y.length,ve=q/Y.length;return{upperPercent:fe,lowerPercent:ye,alphaPercent:ae,numericPercent:ve}}function v(Y){const{upperPercent:I,lowerPercent:$}=Y;return $===0&&I>.6}function i(Y){const{upperPercent:I,lowerPercent:$,alphaPercent:W,numericPercent:q}=Y;return $>.2&&I<.8&&W>.6&&q<.2}function d(Y){let I=0,$=0,W=0,q=0;for(let te=0;te<Y.length;te++)W=Y.charCodeAt(te),N(W)&&I++,T(W)&&$++,f(W)&&q++;return(I===0||$===0)&&q===0?Y.length<=30:I<=5}function n(Y,I){if(!I||(I=I.trim(),I.length===0)||!d(Y)||I.length>60)return null;const $=A(I);if(!i($)){if(!v($))return null;I=I.toLowerCase()}let W=null,q=0;for(Y=Y.toLowerCase();q<I.length&&(W=w(Y,I,0,q))===null;)q=p(I,q+1);return W}e.matchesCamelCase=n;function a(Y,I,$=!1){if(!I||I.length===0)return null;let W=null,q=0;for(Y=Y.toLowerCase(),I=I.toLowerCase();q<I.length&&(W=t(Y,I,0,q,$))===null;)q=g(I,q+1);return W}e.matchesWords=a;function t(Y,I,$,W,q){if($===Y.length)return[];if(W===I.length)return null;if(o(Y.charCodeAt($),I.charCodeAt(W))){let te=null,fe=W+1;if(te=t(Y,I,$+1,W+1,q),!q)for(;!te&&(fe=g(I,fe))<I.length;)te=t(Y,I,$+1,fe,q),fe++;return te?Y.charCodeAt($)!==I.charCodeAt(W)?te:h({start:W,end:W+1},te):null}else return null}function g(Y,I){for(let $=I;$<Y.length;$++)if(m(Y.charCodeAt($))||$>0&&m(Y.charCodeAt($-1)))return $;return Y.length}const c=D(e.matchesPrefix,n,S),u=D(e.matchesPrefix,n,O),l=new r.LRUCache(1e4);function C(Y,I,$=!1){if(typeof Y!="string"||typeof I!="string")return null;let W=l.get(Y);W||(W=new RegExp(k.convertSimple2RegExpPattern(Y),"i"),l.set(Y,W));const q=W.exec(I);return q?[{start:q.index,end:q.index+q[0].length}]:$?u(Y,I):c(Y,I)}e.matchesFuzzy=C;function R(Y,I){const $=Ne(Y,Y.toLowerCase(),0,I,I.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return $?ee($):null}e.matchesFuzzy2=R;function V(Y,I,$,W,q,te){const fe=Math.min(13,Y.length);for(;$<fe;$++){const ye=Ne(Y,I,$,W,q,te,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ye)return ye}return[0,te]}e.anyScore=V;function ee(Y){if(typeof Y>"u")return[];const I=[],$=Y[1];for(let W=Y.length-1;W>1;W--){const q=Y[W]+$,te=I[I.length-1];te&&te.end===q?te.end=q+1:I.push({start:q,end:q+1})}return I}e.createMatches=ee;const K=128;function L(){const Y=[],I=[];for(let $=0;$<=K;$++)I[$]=0;for(let $=0;$<=K;$++)Y.push(I.slice(0));return Y}function B(Y){const I=[];for(let $=0;$<=Y;$++)I[$]=0;return I}const P=B(2*K),F=B(2*K),H=L(),j=L(),le=L(),_=!1;function be(Y,I,$,W,q){function te(ye,ae,ve=" "){for(;ye.length<ae;)ye=ve+ye;return ye}let fe=` |   |${W.split("").map(ye=>te(ye,3)).join("|")}
`;for(let ye=0;ye<=$;ye++)ye===0?fe+=" |":fe+=`${I[ye-1]}|`,fe+=Y[ye].slice(0,q+1).map(ae=>te(ae.toString(),3)).join("|")+`
`;return fe}function de(Y,I,$,W){Y=Y.substr(I),$=$.substr(W),console.log(be(j,Y,Y.length,$,$.length)),console.log(be(le,Y,Y.length,$,$.length)),console.log(be(H,Y,Y.length,$,$.length))}function ue(Y,I){if(I<0||I>=Y.length)return!1;const $=Y.codePointAt(I);switch($){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!k.isEmojiImprecise($)}}function se(Y,I){if(I<0||I>=Y.length)return!1;switch(Y.charCodeAt(I)){case 32:case 9:return!0;default:return!1}}function J(Y,I,$){return I[Y]!==$[Y]}function X(Y,I,$,W,q,te,fe=!1){for(;I<$&&q<te;)Y[I]===W[q]&&(fe&&(P[I]=q),I+=1),q+=1;return I===$}e.isPatternInWord=X;var Z;(function(Y){Y[Y.Diag=1]="Diag",Y[Y.Left=2]="Left",Y[Y.LeftLeft=3]="LeftLeft"})(Z||(Z={}));var he;(function(Y){Y.Default=[-100,0];function I($){return!$||$.length===2&&$[0]===-100&&$[1]===0}Y.isDefault=I})(he=e.FuzzyScore||(e.FuzzyScore={}));class Te{constructor(I,$){this.firstMatchCanBeWeak=I,this.boostFullMatch=$}}e.FuzzyScoreOptions=Te,Te.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Ne(Y,I,$,W,q,te,fe=Te.default){const ye=Y.length>K?K:Y.length,ae=W.length>K?K:W.length;if($>=ye||te>=ae||ye-$>ae-te||!X(I,$,ye,q,te,ae,!0))return;Ke(ye,ae,$,te,I,q);let ve=1,Ee=1,We=$,He=te;const tt=[!1];for(ve=1,We=$;We<ye;ve++,We++){const Fe=P[We],ot=F[We],Q=We+1<ye?F[We+1]:ae;for(Ee=Fe-te+1,He=Fe;He<Q;Ee++,He++){let x=Number.MIN_SAFE_INTEGER,pe=!1;He<=ot&&(x=Pe(Y,I,We,$,W,q,He,ae,te,H[ve-1][Ee-1]===0,tt));let Me=0;x!==Number.MAX_SAFE_INTEGER&&(pe=!0,Me=x+j[ve-1][Ee-1]);const ze=He>Fe,Ve=ze?j[ve][Ee-1]+(H[ve][Ee-1]>0?-5:0):0,_e=He>Fe+1&&H[ve][Ee-1]>0,nt=_e?j[ve][Ee-2]+(H[ve][Ee-2]>0?-5:0):0;if(_e&&(!ze||nt>=Ve)&&(!pe||nt>=Me))j[ve][Ee]=nt,le[ve][Ee]=3,H[ve][Ee]=0;else if(ze&&(!pe||Ve>=Me))j[ve][Ee]=Ve,le[ve][Ee]=2,H[ve][Ee]=0;else if(pe)j[ve][Ee]=Me,le[ve][Ee]=1,H[ve][Ee]=H[ve-1][Ee-1]+1;else throw new Error("not possible")}}if(_&&de(Y,$,W,te),!tt[0]&&!fe.firstMatchCanBeWeak)return;ve--,Ee--;const Xe=[j[ve][Ee],te];let et=0,it=0;for(;ve>=1;){let Fe=Ee;do{const ot=le[ve][Fe];if(ot===3)Fe=Fe-2;else if(ot===2)Fe=Fe-1;else break}while(Fe>=1);et>1&&I[$+ve-1]===q[te+Ee-1]&&!J(Fe+te-1,W,q)&&et+1>H[ve][Fe]&&(Fe=Ee),Fe===Ee?et++:et=1,it||(it=Fe),ve--,Ee=Fe-1,Xe.push(Ee)}ae===ye&&fe.boostFullMatch&&(Xe[0]+=2);const dt=it-ye;return Xe[0]-=dt,Xe}e.fuzzyScore=Ne;function Ke(Y,I,$,W,q,te){let fe=Y-1,ye=I-1;for(;fe>=$&&ye>=W;)q[fe]===te[ye]&&(F[fe]=ye,fe--),ye--}function Pe(Y,I,$,W,q,te,fe,ye,ae,ve,Ee){if(I[$]!==te[fe])return Number.MIN_SAFE_INTEGER;let We=1,He=!1;return fe===$-W?We=Y[$]===q[fe]?7:5:J(fe,q,te)&&(fe===0||!J(fe-1,q,te))?(We=Y[$]===q[fe]?7:5,He=!0):ue(te,fe)&&(fe===0||!ue(te,fe-1))?We=5:(ue(te,fe-1)||se(te,fe-1))&&(We=5,He=!0),We>1&&$===W&&(Ee[0]=!0),He||(He=J(fe,q,te)||ue(te,fe-1)||se(te,fe-1)),$===W?fe>ae&&(We-=He?3:5):ve?We+=He?2:0:We+=He?0:1,fe+1===ye&&(We-=He?3:5),We}function Se(Y,I,$,W,q,te,fe){return oe(Y,I,$,W,q,te,!0,fe)}e.fuzzyScoreGracefulAggressive=Se;function Ie(Y,I,$,W,q,te,fe){return oe(Y,I,$,W,q,te,!1,fe)}e.fuzzyScoreGraceful=Ie;function oe(Y,I,$,W,q,te,fe,ye){let ae=Ne(Y,I,$,W,q,te,ye);if(ae&&!fe)return ae;if(Y.length>=3){const ve=Math.min(7,Y.length-1);for(let Ee=$+1;Ee<ve;Ee++){const We=ce(Y,Ee);if(We){const He=Ne(We,We.toLowerCase(),$,W,q,te,ye);He&&(He[0]-=3,(!ae||He[0]>ae[0])&&(ae=He))}}}return ae}function ce(Y,I){if(I+1>=Y.length)return;const $=Y[I],W=Y[I+1];if($!==W)return Y.slice(0,I)+W+$+Y.slice(I+2)}}),define(Ce[126],ke([1,0,125,10,38]),function(ie,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const M="$(",S=new RegExp(`\\$\\(${D.ThemeIcon.iconNameExpression}(?:${D.ThemeIcon.iconModifierExpression})?\\)`,"g"),O=new RegExp(`(\\\\)?${S.source}`,"g");function y(h){return h.replace(O,(p,w)=>w?p:`\\${p}`)}e.escapeIcons=y;const T=new RegExp(`\\\\${S.source}`,"g");function N(h){return h.replace(T,p=>`\\${p}`)}e.markdownEscapeEscapedIcons=N;const E=new RegExp(`(\\s)?(\\\\)?${S.source}(\\s)?`,"g");function f(h){return h.indexOf(M)===-1?h:h.replace(E,(p,w,A,v)=>A?p:w||v||"")}e.stripIcons=f;function b(h){return h?h.replace(/\$\((.*?)\)/g,(p,w)=>` ${w} `).trim():""}e.getCodiconAriaLabel=b;const m=new RegExp(`\\$\\(${D.ThemeIcon.iconNameCharacter}+\\)`,"g");function o(h){m.lastIndex=0;let p="";const w=[];let A=0;for(;;){const v=m.lastIndex,i=m.exec(h),d=h.substring(v,i?.index);if(d.length>0){p+=d;for(let n=0;n<d.length;n++)w.push(A)}if(!i)break;A+=i[0].length}return{text:p,iconOffsets:w}}e.parseLabelWithIcons=o;function s(h,p,w=!1){const{text:A,iconOffsets:v}=p;if(!v||v.length===0)return(0,r.matchesFuzzy)(h,A,w);const i=(0,k.ltrim)(A," "),d=A.length-i.length,n=(0,r.matchesFuzzy)(h,i,w);if(n)for(const a of n){const t=v[a.start+d]+d;a.start+=t,a.end+=t}return n}e.matchesFuzzyIconAware=s}),define(Ce[29],ke([1,0,10]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var k;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(k||(k={})),function(D){const M="error",S="warning",O="warn",y="info",T="ignore";function N(f){return f?r.equalsIgnoreCase(M,f)?D.Error:r.equalsIgnoreCase(S,f)||r.equalsIgnoreCase(O,f)?D.Warning:r.equalsIgnoreCase(y,f)?D.Info:D.Ignore:D.Ignore}D.fromValue=N;function E(f){switch(f){case D.Error:return M;case D.Warning:return S;case D.Info:return y;default:return T}}D.toString=E}(k||(k={})),e.default=k}),define(Ce[47],ke([1,0,18,10]),function(ie,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class D{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const m=b.charCodeAt(0),o=this.b.charCodeAt(this.c);return m-o}value(){return this.b[this.c]}}e.StringIterator=D;class M{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,k.compareSubstring)(b,this.b,0,b.length,this.c,this.d):(0,k.compareSubstringIgnoreCase)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=M;class S{constructor(b=!0,m=!0){this.f=b,this.g=m}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let m=b.length-1;m>=0;m--,this.c--){const o=this.b.charCodeAt(m);if(!(o===47||this.f&&o===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,k.compareSubstring)(b,this.b,0,b.length,this.d,this.e):(0,k.compareSubstringIgnoreCase)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=S;var O;(function(f){f[f.Scheme=1]="Scheme",f[f.Authority=2]="Authority",f[f.Path=3]="Path",f[f.Query=4]="Query",f[f.Fragment=5]="Fragment"})(O||(O={}));class y{constructor(b,m){this.f=b,this.g=m,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new S(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,k.compareIgnoreCase)(b,this.c.scheme);if(this.d[this.e]===2)return(0,k.compareIgnoreCase)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,k.compare)(b,this.c.query);if(this.d[this.e]===5)return(0,k.compare)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=y;class T{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var N;(function(f){f[f.Left=-1]="Left",f[f.Mid=0]="Mid",f[f.Right=1]="Right"})(N||(N={}));class E{static forUris(b=()=>!1,m=()=>!1){return new E(new y(b,m))}static forPaths(b=!1){return new E(new S(void 0,!b))}static forStrings(){return new E(new D)}static forConfigKeys(){return new E(new M)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,m){if(m){const o=m.slice(0);(0,r.shuffle)(o);for(const s of o)this.set(s,b)}else{const o=b.slice(0);(0,r.shuffle)(o);for(const s of o)this.set(s[0],s[1])}}set(b,m){const o=this.b.reset(b);let s;this.c||(this.c=new T,this.c.segment=o.value());const h=[];for(s=this.c;;){const w=o.cmp(s.segment);if(w>0)s.left||(s.left=new T,s.left.segment=o.value()),h.push([-1,s]),s=s.left;else if(w<0)s.right||(s.right=new T,s.right.segment=o.value()),h.push([1,s]),s=s.right;else if(o.hasNext())o.next(),s.mid||(s.mid=new T,s.mid.segment=o.value()),h.push([0,s]),s=s.mid;else break}const p=s.value;s.value=m,s.key=b;for(let w=h.length-1;w>=0;w--){const A=h[w][1];A.updateHeight();const v=A.balanceFactor();if(v<-1||v>1){const i=h[w][0],d=h[w+1][0];if(i===1&&d===1)h[w][1]=A.rotateLeft();else if(i===-1&&d===-1)h[w][1]=A.rotateRight();else if(i===1&&d===-1)A.right=h[w+1][1]=h[w+1][1].rotateRight(),h[w][1]=A.rotateLeft();else if(i===-1&&d===1)A.left=h[w+1][1]=h[w+1][1].rotateLeft(),h[w][1]=A.rotateRight();else throw new Error;if(w>0)switch(h[w-1][0]){case-1:h[w-1][1].left=h[w][1];break;case 1:h[w-1][1].right=h[w][1];break;case 0:h[w-1][1].mid=h[w][1];break}else this.c=h[0][1]}}return p}get(b){return this.d(b)?.value}d(b){const m=this.b.reset(b);let o=this.c;for(;o;){const s=m.cmp(o.segment);if(s>0)o=o.left;else if(s<0)o=o.right;else if(m.hasNext())m.next(),o=o.mid;else break}return o}has(b){const m=this.d(b);return!(m?.value===void 0&&m?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,m){const o=this.b.reset(b),s=[];let h=this.c;for(;h;){const p=o.cmp(h.segment);if(p>0)s.push([-1,h]),h=h.left;else if(p<0)s.push([1,h]),h=h.right;else if(o.hasNext())o.next(),s.push([0,h]),h=h.mid;else break}if(!!h){if(m?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const p=this.f(h.right);if(p.key){const{key:w,value:A,segment:v}=p;this.e(p.key,!1),h.key=w,h.value=A,h.segment=v}}else{const p=h.left??h.right;if(s.length>0){const[w,A]=s[s.length-1];switch(w){case-1:A.left=p;break;case 0:A.mid=p;break;case 1:A.right=p;break}}else this.c=p}for(let p=s.length-1;p>=0;p--){const w=s[p][1];w.updateHeight();const A=w.balanceFactor();if(A>1?(w.right.balanceFactor()>=0||(w.right=w.right.rotateRight()),s[p][1]=w.rotateLeft()):A<-1&&(w.left.balanceFactor()<=0||(w.left=w.left.rotateLeft()),s[p][1]=w.rotateRight()),p>0)switch(s[p-1][0]){case-1:s[p-1][1].left=s[p][1];break;case 1:s[p-1][1].right=s[p][1];break;case 0:s[p-1][1].mid=s[p][1];break}else this.c=s[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const m=this.b.reset(b);let o=this.c,s;for(;o;){const h=m.cmp(o.segment);if(h>0)o=o.left;else if(h<0)o=o.right;else if(m.hasNext())m.next(),s=o.value||s,o=o.mid;else break}return o&&o.value||s}findSuperstr(b){return this.g(b,!1)}g(b,m){const o=this.b.reset(b);let s=this.c;for(;s;){const h=o.cmp(s.segment);if(h>0)s=s.left;else if(h<0)s=s.right;else if(o.hasNext())o.next(),s=s.mid;else return s.mid?this.h(s.mid):m?s.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[m,o]of this)b(o,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const m=[];return this.j(b,m),m[Symbol.iterator]()}j(b,m){!b||(b.left&&this.j(b.left,m),b.value&&m.push([b.key,b.value]),b.mid&&this.j(b.mid,m),b.right&&this.j(b.right,m))}_isBalanced(){const b=m=>{if(!m)return!0;const o=m.balanceFactor();return o<-1||o>1?!1:b(m.left)&&b(m.right)};return b(this.c)}}e.TernarySearchTree=E}),define(Ce[65],ke([1,0,23,10,2]),function(ie,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function M(T){return JSON.stringify(T,O)}e.stringify=M;function S(T){let N=JSON.parse(T);return N=y(N),N}e.parse=S;function O(T,N){return N instanceof RegExp?{$mid:2,source:N.source,flags:(0,k.regExpFlags)(N)}:N}function y(T,N=0){if(!T||N>200)return T;if(typeof T=="object"){switch(T.$mid){case 1:return D.URI.revive(T);case 2:return new RegExp(T.source,T.flags);case 16:return new Date(T.source)}if(T instanceof r.VSBuffer||T instanceof Uint8Array)return T;if(Array.isArray(T))for(let E=0;E<T.length;++E)T[E]=y(T[E],N+1);else for(const E in T)Object.hasOwnProperty.call(T,E)&&(T[E]=y(T[E],N+1))}return T}e.revive=y}),define(Ce[15],ke([1,0,12,20,2]),function(ie,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var M;(function(T){T.inMemory="inmemory",T.vscode="vscode",T.internal="private",T.walkThrough="walkThrough",T.walkThroughSnippet="walkThroughSnippet",T.http="http",T.https="https",T.file="file",T.mailto="mailto",T.untitled="untitled",T.data="data",T.command="command",T.vscodeRemote="vscode-remote",T.vscodeRemoteResource="vscode-remote-resource",T.vscodeUserData="vscode-userdata",T.vscodeCustomEditor="vscode-custom-editor",T.vscodeNotebook="vscode-notebook",T.vscodeNotebookCell="vscode-notebook-cell",T.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",T.vscodeNotebookCellOutput="vscode-notebook-cell-output",T.vscodeInteractive="vscode-interactive",T.vscodeInteractiveInput="vscode-interactive-input",T.vscodeSettings="vscode-settings",T.vscodeWorkspaceTrust="vscode-workspace-trust",T.vscodeTerminal="vscode-terminal",T.webviewPanel="webview-panel",T.vscodeWebview="vscode-webview",T.extension="extension",T.vscodeFileResource="vscode-file",T.tmp="tmp",T.vsls="vsls",T.vscodeSourceControl="vscode-scm"})(M=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class S{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(N){this.d=N}setDelegate(N){this.e=N}setServerRootPath(N){this.f=`${N}/${M.vscodeRemoteResource}`}set(N,E,f){this.a[N]=E,this.b[N]=f}setConnectionToken(N,E){this.c[N]=E}getPreferredWebSchema(){return this.d}rewrite(N){if(this.e)try{return this.e(N)}catch(s){return r.onUnexpectedError(s),N}const E=N.authority;let f=this.a[E];f&&f.indexOf(":")!==-1&&f.indexOf("[")===-1&&(f=`[${f}]`);const b=this.b[E],m=this.c[E];let o=`path=${encodeURIComponent(N.path)}`;return typeof m=="string"&&(o+=`&${e.connectionTokenQueryName}=${encodeURIComponent(m)}`),D.URI.from({scheme:k.isWeb?this.d:M.vscodeRemoteResource,authority:`${f}:${b}`,path:this.f,query:o})}}e.RemoteAuthorities=new S,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class O{asBrowserUri(N){const E=this.b(N,ie);return this.uriToBrowserUri(E)}uriToBrowserUri(N){return N.scheme===M.vscodeRemote?e.RemoteAuthorities.rewrite(N):N.scheme===M.file&&(k.isNative||k.isWebWorker&&k.globals.origin===`${M.vscodeFileResource}://${O.a}`)?N.with({scheme:M.vscodeFileResource,authority:N.authority||O.a,query:null,fragment:null}):N}asFileUri(N){const E=this.b(N,ie);return this.uriToFileUri(E)}uriToFileUri(N){return N.scheme===M.vscodeFileResource?N.with({scheme:M.file,authority:N.authority!==O.a?N.authority:null,query:null,fragment:null}):N}b(N,E){return D.URI.isUri(N)?N:D.URI.parse(E.toUrl(N))}}O.a="vscode-app",e.FileAccess=new O;var y;(function(T){const N=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);T.CoopAndCoep=Object.freeze(N.get("3"));const E="vscode-coi";function f(m){let o;typeof m=="string"?o=new URL(m).searchParams:m instanceof URL?o=m.searchParams:D.URI.isUri(m)&&(o=new URL(m.toString(!0)).searchParams);const s=o?.get(E);if(!!s)return N.get(s)}T.getHeadersFromQuery=f;function b(m,o,s){if(!globalThis.crossOriginIsolated)return;const h=o&&s?"3":s?"2":"1";m instanceof URLSearchParams?m.set(E,h):m[E]=h}T.addSearchParam=b})(y=e.COI||(e.COI={}))}),define(Ce[24],ke([1,0,40,15,19,20,10,2]),function(ie,e,r,k,D,M,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(b){return(0,O.uriToFsPath)(b,!0)}e.originalFSPath=y;class T{constructor(m){this.a=m}compare(m,o,s=!1){return m===o?0:(0,S.compare)(this.getComparisonKey(m,s),this.getComparisonKey(o,s))}isEqual(m,o,s=!1){return m===o?!0:!m||!o?!1:this.getComparisonKey(m,s)===this.getComparisonKey(o,s)}getComparisonKey(m,o=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,o,s=!1){if(m.scheme===o.scheme){if(m.scheme===k.Schemas.file)return r.isEqualOrParent(y(m),y(o),this.a(m))&&m.query===o.query&&(s||m.fragment===o.fragment);if((0,e.isEqualAuthority)(m.authority,o.authority))return r.isEqualOrParent(m.path,o.path,this.a(m),"/")&&m.query===o.query&&(s||m.fragment===o.fragment)}return!1}joinPath(m,...o){return O.URI.joinPath(m,...o)}basenameOrAuthority(m){return(0,e.basename)(m)||m.authority}basename(m){return D.posix.basename(m.path)}extname(m){return D.posix.extname(m.path)}dirname(m){if(m.path.length===0)return m;let o;return m.scheme===k.Schemas.file?o=O.URI.file(D.dirname(y(m))).path:(o=D.posix.dirname(m.path),m.authority&&o.length&&o.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),o="/")),m.with({path:o})}normalizePath(m){if(!m.path.length)return m;let o;return m.scheme===k.Schemas.file?o=O.URI.file(D.normalize(y(m))).path:o=D.posix.normalize(m.path),m.with({path:o})}relativePath(m,o){if(m.scheme!==o.scheme||!(0,e.isEqualAuthority)(m.authority,o.authority))return;if(m.scheme===k.Schemas.file){const p=D.relative(y(m),y(o));return M.isWindows?r.toSlashes(p):p}let s=m.path||"/";const h=o.path||"/";if(this.a(m)){let p=0;for(const w=Math.min(s.length,h.length);p<w&&!(s.charCodeAt(p)!==h.charCodeAt(p)&&s.charAt(p).toLowerCase()!==h.charAt(p).toLowerCase());p++);s=h.substr(0,p)+s.substr(p)}return D.posix.relative(s,h)}resolvePath(m,o){if(m.scheme===k.Schemas.file){const s=O.URI.file(D.resolve(y(m),o));return m.with({authority:s.authority,path:s.path})}return o=r.toPosixPath(o),m.with({path:D.posix.resolve(m.path,o)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,o){return m===o||m!==void 0&&o!==void 0&&(0,S.equalsIgnoreCase)(m,o)}hasTrailingPathSeparator(m,o=D.sep){if(m.scheme===k.Schemas.file){const s=y(m);return s.length>r.getRoot(s).length&&s[s.length-1]===o}else{const s=m.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,o=D.sep){return(0,e.hasTrailingPathSeparator)(m,o)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,o=D.sep){let s=!1;if(m.scheme===k.Schemas.file){const h=y(m);s=h!==void 0&&h.length===r.getRoot(h).length&&h[h.length-1]===o}else{o="/";const h=m.path;s=h.length===1&&h.charCodeAt(h.length-1)===47}return!s&&!(0,e.hasTrailingPathSeparator)(m,o)?m.with({path:m.path+"/"}):m}}e.ExtUri=T,e.extUri=new T(()=>!1),e.extUriBiasedIgnorePathCase=new T(b=>b.scheme===k.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new T(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function N(b,m){const o=[];for(let s=0;s<b.length;s++){const h=m(b[s]);b.some((p,w)=>w===s?!1:(0,e.isEqualOrParent)(h,m(p)))||o.push(b[s])}return o}e.distinctParents=N;var E;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function m(o){const s=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(w=>{const[A,v]=w.split(":");A&&v&&s.set(A,v)});const p=o.path.substring(0,o.path.indexOf(";"));return p&&s.set(b.META_DATA_MIME,p),s}b.parseMetaData=m})(E=e.DataUri||(e.DataUri={}));function f(b,m,o){if(m){let s=b.path;return s&&s[0]!==D.posix.sep&&(s=D.posix.sep+s),b.with({scheme:o,authority:m,path:s})}return b.with({scheme:o})}e.toLocalResource=f}),define(Ce[16],ke([1,0,21,12,4,6,24,20,115]),function(ie,e,r,k,D,M,S,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function T(X){return!!X&&typeof X.then=="function"}e.isThenable=T;function N(X){const Z=new r.CancellationTokenSource,he=X(Z.token),Te=new Promise((Ne,Ke)=>{const Pe=Z.token.onCancellationRequested(()=>{Pe.dispose(),Z.dispose(),Ke(new k.CancellationError)});Promise.resolve(he).then(Se=>{Pe.dispose(),Z.dispose(),Ne(Se)},Se=>{Pe.dispose(),Z.dispose(),Ke(Se)})});return new class{cancel(){Z.cancel()}then(Ne,Ke){return Te.then(Ne,Ke)}catch(Ne){return this.then(void 0,Ne)}finally(Ne){return Te.finally(Ne)}}}e.createCancelablePromise=N;function E(X,Z,he){return new Promise((Te,Ne)=>{const Ke=Z.onCancellationRequested(()=>{Ke.dispose(),Te(he)});X.then(Te,Ne).finally(()=>Ke.dispose())})}e.raceCancellation=E;function f(X,Z){return new Promise((he,Te)=>{const Ne=Z.onCancellationRequested(()=>{Ne.dispose(),Te(new k.CancellationError)});X.then(he,Te).finally(()=>Ne.dispose())})}e.raceCancellationError=f;async function b(X){let Z=-1;const he=X.map((Ne,Ke)=>Ne.then(Pe=>(Z=Ke,Pe))),Te=await Promise.race(he);return X.forEach((Ne,Ke)=>{Ke!==Z&&Ne.cancel()}),Te}e.raceCancellablePromises=b;function m(X,Z,he){let Te;const Ne=setTimeout(()=>{Te?.(void 0),he?.()},Z);return Promise.race([X.finally(()=>clearTimeout(Ne)),new Promise(Ke=>Te=Ke)])}e.raceTimeout=m;function o(X){return new Promise((Z,he)=>{const Te=X();T(Te)?Te.then(Z,he):Z(Te)})}e.asPromise=o;class s{constructor(){this.a=null,this.b=null,this.d=null}queue(Z){if(this.a){if(this.d=Z,!this.b){const he=()=>{this.b=null;const Te=this.queue(this.d);return this.d=null,Te};this.b=new Promise(Te=>{this.a.then(he,he).then(Te)})}return new Promise((he,Te)=>{this.b.then(he,Te)})}return this.a=Z(),new Promise((he,Te)=>{this.a.then(Ne=>{this.a=null,he(Ne)},Ne=>{this.a=null,Te(Ne)})})}}e.Throttler=s;class h{constructor(){this.a=Promise.resolve(null)}queue(Z){return this.a=this.a.then(()=>Z(),()=>Z())}}e.Sequencer=h;class p{constructor(){this.a=new Map}queue(Z,he){const Ne=(this.a.get(Z)??Promise.resolve()).catch(()=>{}).then(he).finally(()=>{this.a.get(Z)===Ne&&this.a.delete(Z)});return this.a.set(Z,Ne),Ne}}e.SequencerByKey=p;const w=(X,Z)=>{let he=!0;const Te=setTimeout(()=>{he=!1,Z()},X);return{isTriggered:()=>he,dispose:()=>{clearTimeout(Te),he=!1}}},A=X=>{let Z=!0;return queueMicrotask(()=>{Z&&(Z=!1,X())}),{isTriggered:()=>Z,dispose:()=>{Z=!1}}};class v{constructor(Z){this.defaultDelay=Z,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Z,he=this.defaultDelay){this.g=Z,this.h(),this.b||(this.b=new Promise((Ne,Ke)=>{this.d=Ne,this.f=Ke}).then(()=>{if(this.b=null,this.d=null,this.g){const Ne=this.g;return this.g=null,Ne()}}));const Te=()=>{this.a=null,this.d?.(null)};return this.a=he===y.MicrotaskDelay?A(Te):w(he,Te),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new k.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=v;class i{constructor(Z){this.a=new v(Z),this.b=new s}trigger(Z,he){return this.a.trigger(()=>this.b.queue(Z),he)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=i;class d{constructor(){this.a=!1,this.b=new Promise((Z,he)=>{this.d=Z})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=d;class n extends d{constructor(Z){super(),this.f=setTimeout(()=>this.open(),Z)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=n;function a(X,Z){return Z?new Promise((he,Te)=>{const Ne=setTimeout(()=>{Ke.dispose(),he()},X),Ke=Z.onCancellationRequested(()=>{clearTimeout(Ne),Ke.dispose(),Te(new k.CancellationError)})}):N(he=>a(X,he))}e.timeout=a;function t(X,Z=0){const he=setTimeout(X,Z);return(0,M.toDisposable)(()=>clearTimeout(he))}e.disposableTimeout=t;function g(X){const Z=[];let he=0;const Te=X.length;function Ne(){return he<Te?X[he++]():null}function Ke(Pe){Pe!=null&&Z.push(Pe);const Se=Ne();return Se?Se.then(Ke):Promise.resolve(Z)}return Promise.resolve(null).then(Ke)}e.sequence=g;function c(X,Z=Te=>!!Te,he=null){let Te=0;const Ne=X.length,Ke=()=>{if(Te>=Ne)return Promise.resolve(he);const Pe=X[Te++];return Promise.resolve(Pe()).then(Ie=>Z(Ie)?Promise.resolve(Ie):Ke())};return Ke()}e.first=c;function u(X,Z=Te=>!!Te,he=null){if(X.length===0)return Promise.resolve(he);let Te=X.length;const Ne=()=>{Te=-1;for(const Ke of X)Ke.cancel?.()};return new Promise((Ke,Pe)=>{for(const Se of X)Se.then(Ie=>{--Te>=0&&Z(Ie)?(Ne(),Ke(Ie)):Te===0&&Ke(he)}).catch(Ie=>{--Te>=0&&(Ne(),Pe(Ie))})})}e.firstParallel=u;class l{constructor(Z){this.a=0,this.d=Z,this.f=[],this.b=0,this.g=new D.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(Z){return this.a++,new Promise((he,Te)=>{this.f.push({factory:Z,c:he,e:Te}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const Z=this.f.shift();this.b++;const he=Z.factory();he.then(Z.c,Z.e),he.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=l;class C extends l{constructor(){super(1)}}e.Queue=C;class R{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const Z=new _;return this.b.add(Z),Z.p}d(){for(const[,Z]of this.a)if(Z.size>0)return!1;return!0}queueFor(Z,he=S.extUri){const Te=he.getComparisonKey(Z);let Ne=this.a.get(Te);return Ne||(Ne=new C,D.Event.once(Ne.onDrained)(()=>{Ne?.dispose(),this.a.delete(Te),this.f()}),this.a.set(Te,Ne)),Ne}f(){!this.d()||this.g()}g(){for(const Z of this.b)Z.complete();this.b.clear()}dispose(){for(const[,Z]of this.a)Z.dispose();this.a.clear(),this.g()}}e.ResourceQueue=R;class V{constructor(Z,he){this.a=-1,typeof Z=="function"&&typeof he=="number"&&this.setIfNotSet(Z,he)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Z,he){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Z()},he)}setIfNotSet(Z,he){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Z()},he))}}e.TimeoutTimer=V;class ee{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(Z,he){this.cancel(),this.a=setInterval(()=>{Z()},he)}}e.IntervalTimer=ee;class K{constructor(Z,he){this.b=-1,this.a=Z,this.d=he,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Z=this.d){this.cancel(),this.b=setTimeout(this.f,Z)}get delay(){return this.d}set delay(Z){this.d=Z}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=K;class L{constructor(Z,he){he%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${he}ms is not a multiple of 1000ms.`),this.a=Z,this.b=he,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Z=this.b){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Z/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=L;class B extends K{constructor(Z,he){super(Z,he),this.j=[]}work(Z){this.j.push(Z),this.isScheduled()||this.schedule()}h(){const Z=this.j;this.j=[],this.a?.(Z)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=B;class P extends M.Disposable{constructor(Z,he){super(),this.g=Z,this.h=he,this.a=[],this.b=this.B(new M.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(Z){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Z.length>this.g.maxBufferedWork)return!1}else if(this.pending+Z.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const he of Z)this.a.push(he);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new K(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=P,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=X=>{(0,O.setTimeout0)(()=>{if(Z)return;const he=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let Z=!1;return{dispose(){Z||(Z=!0)}}}:e.runWhenIdle=(X,Z)=>{const he=requestIdleCallback(X,typeof Z=="number"?{timeout:Z}:void 0);let Te=!1;return{dispose(){Te||(Te=!0,cancelIdleCallback(he))}}}}();class F{constructor(Z){this.d=!1,this.a=()=>{try{this.f=Z()}catch(he){this.g=he}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=F;async function H(X,Z,he){let Te;for(let Ne=0;Ne<he;Ne++)try{return await X()}catch(Ke){Te=Ke,await a(Z)}throw Te}e.retry=H;class j{hasPending(Z){return this.a?typeof Z=="number"?this.a.taskId===Z:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(Z,he,Te){return this.a={taskId:Z,cancel:()=>Te?.(),promise:he},he.then(()=>this.d(Z),()=>this.d(Z)),he}d(Z){this.a&&Z===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Z=this.b;this.b=void 0,Z.run().then(Z.promiseResolve,Z.promiseReject)}}setNext(Z){if(this.b)this.b.run=Z;else{let he,Te;const Ne=new Promise((Ke,Pe)=>{he=Ke,Te=Pe});this.b={run:Z,promise:Ne,promiseResolve:he,promiseReject:Te}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=j;class le{constructor(Z,he=()=>Date.now()){this.d=Z,this.f=he,this.a=0,this.b=0}increment(){const Z=this.f();return Z-this.a>this.d&&(this.a=Z,this.b=0),this.b++,this.b}}e.IntervalCounter=le;class _{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((Z,he)=>{this.a=Z,this.b=he})}complete(Z){return new Promise(he=>{this.a(Z),this.f=!0,he()})}error(Z){return new Promise(he=>{this.b(Z),this.d=!0,he()})}cancel(){new Promise(Z=>{this.b(new k.CancellationError),this.d=!0,Z()})}}e.DeferredPromise=_;var be;(function(X){async function Z(Te){let Ne;const Ke=await Promise.all(Te.map(Pe=>Pe.then(Se=>Se,Se=>{Ne||(Ne=Se)})));if(typeof Ne<"u")throw Ne;return Ke}X.settled=Z;function he(Te){return new Promise(async(Ne,Ke)=>{try{await Te(Ne,Ke)}catch(Pe){Ke(Pe)}})}X.withAsyncBody=he})(be=e.Promises||(e.Promises={}));var de;(function(X){X[X.Initial=0]="Initial",X[X.DoneOK=1]="DoneOK",X[X.DoneError=2]="DoneError"})(de||(de={}));class ue{static fromArray(Z){return new ue(he=>{he.emitMany(Z)})}static fromPromise(Z){return new ue(async he=>{he.emitMany(await Z)})}static fromPromises(Z){return new ue(async he=>{await Promise.all(Z.map(async Te=>he.emitOne(await Te)))})}static merge(Z){return new ue(async he=>{await Promise.all(Z.map(async Te=>{for await(const Ne of Te)he.emitOne(Ne)}))})}constructor(Z){this.a=0,this.b=[],this.d=null,this.f=new D.Emitter,queueMicrotask(async()=>{const he={emitOne:Te=>this.g(Te),emitMany:Te=>this.h(Te),reject:Te=>this.k(Te)};try{await Promise.resolve(Z(he)),this.j()}catch(Te){this.k(Te)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let Z=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Z<this.b.length)return{done:!1,value:this.b[Z++]};if(this.a===1)return{done:!0,value:void 0};await D.Event.toPromise(this.f.event)}while(!0)}}}static map(Z,he){return new ue(async Te=>{for await(const Ne of Z)Te.emitOne(he(Ne))})}map(Z){return ue.map(this,Z)}static filter(Z,he){return new ue(async Te=>{for await(const Ne of Z)he(Ne)&&Te.emitOne(Ne)})}filter(Z){return ue.filter(this,Z)}static coalesce(Z){return ue.filter(Z,he=>!!he)}coalesce(){return ue.coalesce(this)}static async toPromise(Z){const he=[];for await(const Te of Z)he.push(Te);return he}toPromise(){return ue.toPromise(this)}g(Z){this.a===0&&(this.b.push(Z),this.f.fire())}h(Z){this.a===0&&(this.b=this.b.concat(Z),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(Z){this.a===0&&(this.a=2,this.d=Z,this.f.fire())}}e.AsyncIterableObject=ue,ue.EMPTY=ue.fromArray([]);class se extends ue{constructor(Z,he){super(he),this.l=Z}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=se;function J(X){const Z=new r.CancellationTokenSource,he=X(Z.token);return new se(Z,async Te=>{const Ne=Z.token.onCancellationRequested(()=>{Ne.dispose(),Z.dispose(),Te.reject(new k.CancellationError)});try{for await(const Ke of he){if(Z.token.isCancellationRequested)return;Te.emitOne(Ke)}Ne.dispose(),Z.dispose()}catch(Ke){Ne.dispose(),Z.dispose(),Te.reject(Ke)}})}e.createCancelableAsyncIterable=J}),define(Ce[35],ke([1,0,18,16,40,28,19,20,10]),function(ie,e,r,k,D,M,S,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function T(){return Object.create(null)}e.getEmptyExpression=T,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const N="[/\\\\]",E="[^/\\\\]",f=/\//g;function b(le,_){switch(le){case 0:return"";case 1:return`${E}*?`;default:return`(?:${N}|${E}+${N}${_?`|${N}${E}+`:""})*?`}}function m(le,_){if(!le)return[];const be=[];let de=!1,ue=!1,se="";for(const J of le){switch(J){case _:if(!de&&!ue){be.push(se),se="";continue}break;case"{":de=!0;break;case"}":de=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}se+=J}return se&&be.push(se),be}e.splitGlobAware=m;function o(le){if(!le)return"";let _="";const be=m(le,e.GLOB_SPLIT);if(be.every(de=>de===e.GLOBSTAR))_=".*";else{let de=!1;be.forEach((ue,se)=>{if(ue===e.GLOBSTAR){if(de)return;_+=b(2,se===be.length-1)}else{let J=!1,X="",Z=!1,he="";for(const Te of ue){if(Te!=="}"&&J){X+=Te;continue}if(Z&&(Te!=="]"||!he)){let Ne;Te==="-"?Ne=Te:(Te==="^"||Te==="!")&&!he?Ne="^":Te===e.GLOB_SPLIT?Ne="":Ne=(0,y.escapeRegExpCharacters)(Te),he+=Ne;continue}switch(Te){case"{":J=!0;continue;case"[":Z=!0;continue;case"}":{_+=`(?:${m(X,",").map(Pe=>o(Pe)).join("|")})`,J=!1,X="";break}case"]":{_+="["+he+"]",Z=!1,he="";break}case"?":_+=E;continue;case"*":_+=b(1);continue;default:_+=(0,y.escapeRegExpCharacters)(Te)}}se<be.length-1&&(be[se+1]!==e.GLOBSTAR||se+2<be.length)&&(_+=N)}de=ue===e.GLOBSTAR})}return _}const s=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,w=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,A=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new M.LRUCache(1e4),d=function(){return!1},n=function(){return null};function a(le,_){if(!le)return n;let be;typeof le!="string"?be=le.pattern:be=le,be=be.trim();const de=`${be}_${!!_.trimForExclusions}`;let ue=i.get(de);if(ue)return t(ue,le);let se;return s.test(be)?ue=c(be.substr(4),be):(se=h.exec(g(be,_)))?ue=u(se[1],be):(_.trimForExclusions?w:p).test(be)?ue=l(be,_):(se=A.exec(g(be,_)))?ue=C(se[1].substr(1),be,!0):(se=v.exec(g(be,_)))?ue=C(se[1],be,!1):ue=R(be),i.set(de,ue),t(ue,le)}function t(le,_){if(typeof _=="string")return le;const be=function(de,ue){return(0,D.isEqualOrParent)(de,_.base,!O.isLinux)?le((0,y.ltrim)(de.substr(_.base.length),S.sep),ue):null};return be.allBasenames=le.allBasenames,be.allPaths=le.allPaths,be.basenames=le.basenames,be.patterns=le.patterns,be}function g(le,_){return _.trimForExclusions&&le.endsWith("/**")?le.substr(0,le.length-2):le}function c(le,_){return function(be,de){return typeof be=="string"&&be.endsWith(le)?_:null}}function u(le,_){const be=`/${le}`,de=`\\${le}`,ue=function(J,X){return typeof J!="string"?null:X?X===le?_:null:J===le||J.endsWith(be)||J.endsWith(de)?_:null},se=[le];return ue.basenames=se,ue.patterns=[_],ue.allBasenames=se,ue}function l(le,_){const be=H(le.slice(1,-1).split(",").map(X=>a(X,_)).filter(X=>X!==n),le),de=be.length;if(!de)return n;if(de===1)return be[0];const ue=function(X,Z){for(let he=0,Te=be.length;he<Te;he++)if(be[he](X,Z))return le;return null},se=be.find(X=>!!X.allBasenames);se&&(ue.allBasenames=se.allBasenames);const J=be.reduce((X,Z)=>Z.allPaths?X.concat(Z.allPaths):X,[]);return J.length&&(ue.allPaths=J),ue}function C(le,_,be){const de=S.sep===S.posix.sep,ue=de?le:le.replace(f,S.sep),se=S.sep+ue,J=S.posix.sep+le;let X;return be?X=function(Z,he){return typeof Z=="string"&&(Z===ue||Z.endsWith(se)||!de&&(Z===le||Z.endsWith(J)))?_:null}:X=function(Z,he){return typeof Z=="string"&&(Z===ue||!de&&Z===le)?_:null},X.allPaths=[(be?"*/":"./")+le],X}function R(le){try{const _=new RegExp(`^${o(le)}$`);return function(be){return _.lastIndex=0,typeof be=="string"&&_.test(be)?le:null}}catch{return n}}function V(le,_,be){return!le||typeof _!="string"?!1:ee(le)(_,void 0,be)}e.match=V;function ee(le,_={}){if(!le)return d;if(typeof le=="string"||K(le)){const be=a(le,_);if(be===n)return d;const de=function(ue,se){return!!be(ue,se)};return be.allBasenames&&(de.allBasenames=be.allBasenames),be.allPaths&&(de.allPaths=be.allPaths),de}return P(le,_)}e.parse=ee;function K(le){const _=le;return _?typeof _.base=="string"&&typeof _.pattern=="string":!1}e.isRelativePattern=K;function L(le){return le.allBasenames||[]}e.getBasenameTerms=L;function B(le){return le.allPaths||[]}e.getPathTerms=B;function P(le,_){const be=H(Object.getOwnPropertyNames(le).map(X=>F(X,le[X],_)).filter(X=>X!==n)),de=be.length;if(!de)return n;if(!be.some(X=>!!X.requiresSiblings)){if(de===1)return be[0];const X=function(Te,Ne){let Ke;for(let Pe=0,Se=be.length;Pe<Se;Pe++){const Ie=be[Pe](Te,Ne);if(typeof Ie=="string")return Ie;(0,k.isThenable)(Ie)&&(Ke||(Ke=[]),Ke.push(Ie))}return Ke?(async()=>{for(const Pe of Ke){const Se=await Pe;if(typeof Se=="string")return Se}return null})():null},Z=be.find(Te=>!!Te.allBasenames);Z&&(X.allBasenames=Z.allBasenames);const he=be.reduce((Te,Ne)=>Ne.allPaths?Te.concat(Ne.allPaths):Te,[]);return he.length&&(X.allPaths=he),X}const ue=function(X,Z,he){let Te,Ne;for(let Ke=0,Pe=be.length;Ke<Pe;Ke++){const Se=be[Ke];Se.requiresSiblings&&he&&(Z||(Z=(0,S.basename)(X)),Te||(Te=Z.substr(0,Z.length-(0,S.extname)(X).length)));const Ie=Se(X,Z,Te,he);if(typeof Ie=="string")return Ie;(0,k.isThenable)(Ie)&&(Ne||(Ne=[]),Ne.push(Ie))}return Ne?(async()=>{for(const Ke of Ne){const Pe=await Ke;if(typeof Pe=="string")return Pe}return null})():null},se=be.find(X=>!!X.allBasenames);se&&(ue.allBasenames=se.allBasenames);const J=be.reduce((X,Z)=>Z.allPaths?X.concat(Z.allPaths):X,[]);return J.length&&(ue.allPaths=J),ue}function F(le,_,be){if(_===!1)return n;const de=a(le,be);if(de===n)return n;if(typeof _=="boolean")return de;if(_){const ue=_.when;if(typeof ue=="string"){const se=(J,X,Z,he)=>{if(!he||!de(J,X))return null;const Te=ue.replace("$(basename)",()=>Z),Ne=he(Te);return(0,k.isThenable)(Ne)?Ne.then(Ke=>Ke?le:null):Ne?le:null};return se.requiresSiblings=!0,se}}return de}function H(le,_){const be=le.filter(X=>!!X.basenames);if(be.length<2)return le;const de=be.reduce((X,Z)=>{const he=Z.basenames;return he?X.concat(he):X},[]);let ue;if(_){ue=[];for(let X=0,Z=de.length;X<Z;X++)ue.push(_)}else ue=be.reduce((X,Z)=>{const he=Z.patterns;return he?X.concat(he):X},[]);const se=function(X,Z){if(typeof X!="string")return null;if(!Z){let Te;for(Te=X.length;Te>0;Te--){const Ne=X.charCodeAt(Te-1);if(Ne===47||Ne===92)break}Z=X.substr(Te)}const he=de.indexOf(Z);return he!==-1?ue[he]:null};se.basenames=de,se.patterns=ue,se.allBasenames=de;const J=le.filter(X=>!X.basenames);return J.push(se),J}function j(le,_){return(0,r.equals)(le,_,(be,de)=>typeof be=="string"&&typeof de=="string"?be===de:typeof be!="string"&&typeof de!="string"?be.base===de.base&&be.pattern===de.pattern:!1)}e.patternsEquals=j}),define(Ce[86],ke([1,0,12,126,24,10,2]),function(ie,e,r,k,D,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var O;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(O=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(h="",p=!1){if(this.value=h,typeof this.value!="string")throw(0,r.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=p.isTrusted??void 0,this.supportThemeIcons=p.supportThemeIcons??!1,this.supportHtml=p.supportHtml??!1)}appendText(h,p=0){return this.value+=f(this.supportThemeIcons?(0,k.escapeIcons)(h):h).replace(/([ \t]+)/g,(w,A)=>"&nbsp;".repeat(A.length)).replace(/\>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,p){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}appendLink(h,p,w){return this.value+="[",this.value+=this.c(p,"]"),this.value+="](",this.value+=this.c(String(h),")"),w&&(this.value+=` "${this.c(this.c(w,'"'),")")}"`),this.value+=")",this}c(h,p){const w=new RegExp((0,M.escapeRegExpCharacters)(p),"g");return h.replace(w,(A,v)=>h.charAt(v-1)!=="\\"?`\\${A}`:A)}}e.MarkdownString=y;function T(s){return N(s)?!s.value:Array.isArray(s)?s.every(T):!0}e.isEmptyMarkdownString=T;function N(s){return s instanceof y?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}e.isMarkdownString=N;function E(s,h){return s===h?!0:!s||!h?!1:s.value===h.value&&s.isTrusted===h.isTrusted&&s.supportThemeIcons===h.supportThemeIcons&&s.supportHtml===h.supportHtml&&(s.baseUri===h.baseUri||!!s.baseUri&&!!h.baseUri&&(0,D.isEqual)(S.URI.from(s.baseUri),S.URI.from(h.baseUri)))}e.markdownStringEqual=E;function f(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=f;function b(s){return s.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=b;function m(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=m;function o(s){const h=[],p=s.split("|").map(A=>A.trim());s=p[0];const w=p[1];if(w){const A=/height=(\d+)/.exec(w),v=/width=(\d+)/.exec(w),i=A?A[1]:"",d=v?v[1]:"",n=isFinite(parseInt(d)),a=isFinite(parseInt(i));n&&h.push(`width="${d}"`),a&&h.push(`height="${i}"`)}return{href:s,dimensions:h}}e.parseHrefAndDimensions=o}),define(Ce[87],ke([1,0,18,40,19,20,24,10]),function(ie,e,r,k,D,M,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(n,a){const{os:t,tildify:g,relative:c}=a;if(c){const C=T(n,c,t);if(typeof C=="string")return C}let u=n.fsPath;if(t===1&&!M.isWindows?u=u.replace(/\//g,"\\"):t!==1&&M.isWindows&&(u=u.replace(/\\/g,"/")),t!==1&&g?.userHome){const C=g.userHome.fsPath;let R;n.scheme!==g.userHome.scheme&&n.path.startsWith(D.posix.sep)?R=g.userHome.with({path:n.path}).fsPath:R=n.fsPath,u=f(R,C,t)}return(t===1?D.win32:D.posix).normalize(N(u,t===1))}e.getPathLabel=y;function T(n,a,t){const g=t===1?D.win32:D.posix,c=t===3?S.extUri:S.extUriIgnorePathCase,u=a.getWorkspace(),l=(0,r.firstOrDefault)(u.folders);if(!l)return;n.scheme!==l.uri.scheme&&n.path.startsWith(D.posix.sep)&&(n=l.uri.with({path:n.path}));const C=a.getWorkspaceFolder(n);if(!C)return;let R;if(c.isEqual(C.uri,n)?R="":R=c.relativePath(C.uri,n)??"",R&&(R=g.normalize(R)),u.folders.length>1&&!a.noPrefix){const V=C.name?C.name:c.basenameOrAuthority(C.uri);R=R?`${V} \u2022 ${R}`:V}return R}function N(n,a=M.isWindows){return(0,k.hasDriveLetter)(n,a)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=N;let E=Object.create(null);function f(n,a,t=M.OS){if(t===1||!n||!a)return n;let g=E.original===a?E.normalized:void 0;g||(g=a,M.isWindows&&(g=(0,k.toSlashes)(g)),g=`${(0,O.rtrim)(g,D.posix.sep)}${D.posix.sep}`,E={original:a,normalized:g});let c=n;return M.isWindows&&(c=(0,k.toSlashes)(c)),(t===3?c.startsWith(g):(0,O.startsWithIgnoreCase)(c,g))?`~/${c.substr(g.length)}`:n}e.tildify=f;function b(n,a){return n.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=b;const m="\u2026",o="\\\\",s="~";function h(n,a=D.sep){const t=new Array(n.length);let g=!1;for(let c=0;c<n.length;c++){const u=n[c];if(u===""){t[c]=`.${a}`;continue}if(!u){t[c]=u;continue}g=!0;let l="",C=u;C.indexOf(o)===0?(l=C.substr(0,C.indexOf(o)+o.length),C=C.substr(C.indexOf(o)+o.length)):C.indexOf(a)===0?(l=C.substr(0,C.indexOf(a)+a.length),C=C.substr(C.indexOf(a)+a.length)):C.indexOf(s)===0&&(l=C.substr(0,C.indexOf(s)+s.length),C=C.substr(C.indexOf(s)+s.length));const R=C.split(a);for(let V=1;g&&V<=R.length;V++)for(let ee=R.length-V;g&&ee>=0;ee--){g=!1;let K=R.slice(ee,ee+V).join(a);for(let L=0;!g&&L<n.length;L++)if(L!==c&&n[L]&&n[L].indexOf(K)>-1){const B=ee+V===R.length,P=ee>0&&n[L].indexOf(a)>-1?a+K:K,F=n[L].endsWith(P);g=!B||F}if(!g){let L="";(R[0].endsWith(":")||l!=="")&&(ee===1&&(ee=0,V++,K=R[0]+a+K),ee>0&&(L=R[0]+a),L=l+L),ee>0&&(L=L+m+a),L=L+K,ee+V<R.length&&(L=L+a+m),t[c]=L}}g&&(t[c]=u)}return t}e.shorten=h;var p;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function w(n,a=Object.create(null)){const t=[];let g=!1,c="";for(const u of n)if(u==="$"||g&&u==="{")c&&t.push({value:c,type:p.TEXT}),c="",g=!0;else if(u==="}"&&g){const l=a[c];if(typeof l=="string")l.length&&t.push({value:l,type:p.VARIABLE});else if(l){const C=t[t.length-1];(!C||C.type!==p.SEPARATOR)&&t.push({value:l.label,type:p.SEPARATOR})}c="",g=!1}else c+=u;return c&&!g&&t.push({value:c,type:p.TEXT}),t.filter((u,l)=>{if(u.type===p.SEPARATOR){const C=t[l-1],R=t[l+1];return[C,R].every(V=>V&&(V.type===p.VARIABLE||V.type===p.TEXT)&&V.value.length>0)}return!0}).map(u=>u.value).join("")}e.template=w;function A(n,a){return M.isMacintosh||a?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):n.replace(/&&|&/g,t=>t==="&"?"&&":"&")}e.mnemonicMenuLabel=A;function v(n,a){return M.isMacintosh||a?n.replace(/\(&&\w\)|&&/g,""):M.isWindows?n.replace(/&&|&/g,t=>t==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=v;function i(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=i;function d(n){const a=n.indexOf("/")!==-1?D.posix:D.win32,t=a.basename(n),g=a.dirname(n);return t.length?{name:t,parentPath:g}:{name:g,parentPath:""}}e.splitName=d}),define(Ce[127],ke([1,0,23,2]),function(ie,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function D(E){return E.toJSON()}class M{constructor(f){this.a=f}transformIncoming(f){const b=this.a.transformIncoming(f);return b===f?f:D(k.URI.from(b))}transformOutgoing(f){const b=this.a.transformOutgoing(f);return b===f?f:D(k.URI.from(b))}transformOutgoingURI(f){const b=this.a.transformOutgoing(f);return b===f?f:k.URI.from(b)}transformOutgoingScheme(f){return this.a.transformOutgoingScheme(f)}}e.URITransformer=M,e.DefaultURITransformer=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function S(E,f,b){if(!E||b>200)return null;if(typeof E=="object"){if(E instanceof k.URI)return f.transformOutgoing(E);for(const m in E)if(Object.hasOwnProperty.call(E,m)){const o=S(E[m],f,b+1);o!==null&&(E[m]=o)}}return null}function O(E,f){const b=S(E,f,0);return b===null?E:b}e.transformOutgoingURIs=O;function y(E,f,b,m){if(!E||m>200)return null;if(typeof E=="object"){if(E.$mid===1)return b?k.URI.revive(f.transformIncoming(E)):f.transformIncoming(E);if(E instanceof r.VSBuffer)return null;for(const o in E)if(Object.hasOwnProperty.call(E,o)){const s=y(E[o],f,b,m+1);s!==null&&(E[o]=s)}}return null}function T(E,f){const b=y(E,f,!1,0);return b===null?E:b}e.transformIncomingURIs=T;function N(E,f){const b=y(E,f,!0,0);return b===null?E:b}e.transformAndReviveIncomingURIs=N}),define(Ce[128],ke([1,0,35,19]),function(ie,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(M,S,O,y,T,N){if(Array.isArray(M)){let E=0;for(const f of M){const b=D(f,S,O,y,T,N);if(b===10)return b;b>E&&(E=b)}return E}else{if(typeof M=="string")return y?M==="*"?5:M===O?10:0:0;if(M){const{language:E,pattern:f,scheme:b,hasAccessToAllModels:m,notebookType:o}=M;if(!y&&!m)return 0;o&&T&&(S=T);let s=0;if(b)if(b===S.scheme)s=10;else if(b==="*")s=5;else return 0;if(E)if(E===O)s=10;else if(E==="*")s=Math.max(s,5);else return 0;if(o)if(o===N)s=10;else if(o==="*"&&N!==void 0)s=Math.max(s,5);else return 0;if(f){let h;if(typeof f=="string"?h=f:h={...f,base:(0,k.normalize)(f.base)},h===S.fsPath||(0,r.match)(h,S.fsPath))s=10;else return 0}return s}else return 0}}e.score=D}),define(Ce[88],ke([1,0,23,20]),function(ie,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(E){E[E.Full=1]="Full",E[E.Delta=2]="Delta"})(D||(D={}));function M(E){for(let f=0,b=E.length;f<b;f+=4){const m=E[f+0],o=E[f+1],s=E[f+2],h=E[f+3];E[f+0]=h,E[f+1]=s,E[f+2]=o,E[f+3]=m}}function S(E){const f=new Uint8Array(E.buffer,E.byteOffset,E.length*4);return k.isLittleEndian()||M(f),r.VSBuffer.wrap(f)}function O(E){const f=E.buffer;if(k.isLittleEndian()||M(f),f.byteOffset%4===0)return new Uint32Array(f.buffer,f.byteOffset,f.length/4);{const b=new Uint8Array(f.byteLength);return b.set(f),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function y(E){const f=new Uint32Array(T(E));let b=0;if(f[b++]=E.id,E.type==="full")f[b++]=1,f[b++]=E.data.length,f.set(E.data,b),b+=E.data.length;else{f[b++]=2,f[b++]=E.deltas.length;for(const m of E.deltas)f[b++]=m.start,f[b++]=m.deleteCount,m.data?(f[b++]=m.data.length,f.set(m.data,b),b+=m.data.length):f[b++]=0}return S(f)}e.encodeSemanticTokensDto=y;function T(E){let f=0;if(f+=1+1,E.type==="full")f+=1+E.data.length;else{f+=1,f+=(1+1+1)*E.deltas.length;for(const b of E.deltas)b.data&&(f+=b.data.length)}return f}function N(E){const f=O(E);let b=0;const m=f[b++];if(f[b++]===1){const p=f[b++],w=f.subarray(b,b+p);return b+=p,{id:m,type:"full",data:w}}const s=f[b++],h=[];for(let p=0;p<s;p++){const w=f[b++],A=f[b++],v=f[b++];let i;v>0&&(i=f.subarray(b,b+v),b+=v),h[p]={start:w,deleteCount:A,data:i}}return{id:m,type:"delta",deltas:h}}e.decodeSemanticTokensDto=N}),define(Ce[129],ke([13,14]),function(ie,e){return ie.create("vs/editor/common/config/editorOptions",e)}),define(Ce[130],ke([1,0,129,20,131,18,22,117]),function(ie,e,r,k,D,M,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(Q){Q[Q.None=0]="None",Q[Q.Keep=1]="Keep",Q[Q.Brackets=2]="Brackets",Q[Q.Advanced=3]="Advanced",Q[Q.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class T{constructor(x){this.c=x}hasChanged(x){return this.c[x]}}e.ConfigurationChangedEvent=T;class N{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=N;class E{constructor(x,pe,Me,ze){this.id=x,this.name=pe,this.defaultValue=Me,this.schema=ze}applyUpdate(x,pe){return b(x,pe)}compute(x,pe,Me){return Me}}class f{constructor(x,pe){this.newValue=x,this.didChange=pe}}e.ApplyUpdateResult=f;function b(Q,x){if(typeof Q!="object"||typeof x!="object"||!Q||!x)return new f(x,Q!==x);if(Array.isArray(Q)||Array.isArray(x)){const Me=Array.isArray(Q)&&Array.isArray(x)&&M.equals(Q,x);return new f(x,!Me)}let pe=!1;for(const Me in x)if(x.hasOwnProperty(Me)){const ze=b(Q[Me],x[Me]);ze.didChange&&(Q[Me]=ze.newValue,pe=!0)}return new f(Q,pe)}class m{constructor(x){this.schema=void 0,this.id=x,this.name="_never_",this.defaultValue=void 0}applyUpdate(x,pe){return b(x,pe)}validate(x){return this.defaultValue}}class o{constructor(x,pe,Me,ze){this.id=x,this.name=pe,this.defaultValue=Me,this.schema=ze}applyUpdate(x,pe){return b(x,pe)}validate(x){return typeof x>"u"?this.defaultValue:x}compute(x,pe,Me){return Me}}function s(Q,x){return typeof Q>"u"?x:Q==="false"?!1:Boolean(Q)}e.boolean=s;class h extends o{constructor(x,pe,Me,ze=void 0){typeof ze<"u"&&(ze.type="boolean",ze.default=Me),super(x,pe,Me,ze)}validate(x){return s(x,this.defaultValue)}}function p(Q,x,pe,Me){if(typeof Q>"u")return x;let ze=parseInt(Q,10);return isNaN(ze)?x:(ze=Math.max(pe,ze),ze=Math.min(Me,ze),ze|0)}e.clampedInt=p;class w extends o{static clampedInt(x,pe,Me,ze){return p(x,pe,Me,ze)}constructor(x,pe,Me,ze,Ve,_e=void 0){typeof _e<"u"&&(_e.type="integer",_e.default=Me,_e.minimum=ze,_e.maximum=Ve),super(x,pe,Me,_e),this.minimum=ze,this.maximum=Ve}validate(x){return w.clampedInt(x,this.defaultValue,this.minimum,this.maximum)}}class A extends o{static clamp(x,pe,Me){return x<pe?pe:x>Me?Me:x}static float(x,pe){if(typeof x=="number")return x;if(typeof x>"u")return pe;const Me=parseFloat(x);return isNaN(Me)?pe:Me}constructor(x,pe,Me,ze,Ve){typeof Ve<"u"&&(Ve.type="number",Ve.default=Me),super(x,pe,Me,Ve),this.validationFn=ze}validate(x){return this.validationFn(A.float(x,this.defaultValue))}}class v extends o{static string(x,pe){return typeof x!="string"?pe:x}constructor(x,pe,Me,ze=void 0){typeof ze<"u"&&(ze.type="string",ze.default=Me),super(x,pe,Me,ze)}validate(x){return v.string(x,this.defaultValue)}}function i(Q,x,pe){return typeof Q!="string"||pe.indexOf(Q)===-1?x:Q}e.stringSet=i;class d extends o{constructor(x,pe,Me,ze,Ve=void 0){typeof Ve<"u"&&(Ve.type="string",Ve.enum=ze,Ve.default=Me),super(x,pe,Me,Ve),this.c=ze}validate(x){return i(x,this.defaultValue,this.c)}}class n extends E{constructor(x,pe,Me,ze,Ve,_e,nt=void 0){typeof nt<"u"&&(nt.type="string",nt.enum=Ve,nt.default=ze),super(x,pe,Me,nt),this.c=Ve,this.d=_e}validate(x){return typeof x!="string"?this.defaultValue:this.c.indexOf(x)===-1?this.defaultValue:this.d(x)}}function a(Q){switch(Q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class t extends E{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[r.localize(0,null),r.localize(1,null),r.localize(2,null)],default:"auto",tags:["accessibility"],description:r.localize(3,null)})}validate(x){switch(x){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(x,pe,Me){return Me===0?x.accessibilitySupport:Me}}class g extends E{constructor(){const x={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",x,{"editor.comments.insertSpace":{type:"boolean",default:x.insertSpace,description:r.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:x.ignoreEmptyLines,description:r.localize(5,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{insertSpace:s(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:s(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var c;(function(Q){Q[Q.Hidden=0]="Hidden",Q[Q.Blink=1]="Blink",Q[Q.Smooth=2]="Smooth",Q[Q.Phase=3]="Phase",Q[Q.Expand=4]="Expand",Q[Q.Solid=5]="Solid"})(c=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function u(Q){switch(Q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var l;(function(Q){Q[Q.Line=1]="Line",Q[Q.Block=2]="Block",Q[Q.Underline=3]="Underline",Q[Q.LineThin=4]="LineThin",Q[Q.BlockOutline=5]="BlockOutline",Q[Q.UnderlineThin=6]="UnderlineThin"})(l=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function C(Q){switch(Q){case l.Line:return"line";case l.Block:return"block";case l.Underline:return"underline";case l.LineThin:return"line-thin";case l.BlockOutline:return"block-outline";case l.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=C;function R(Q){switch(Q){case"line":return l.Line;case"block":return l.Block;case"underline":return l.Underline;case"line-thin":return l.LineThin;case"block-outline":return l.BlockOutline;case"underline-thin":return l.UnderlineThin}}class V extends m{constructor(){super(135)}compute(x,pe,Me){const ze=["monaco-editor"];return pe.get(36)&&ze.push(pe.get(36)),x.extraEditorClassName&&ze.push(x.extraEditorClassName),pe.get(70)==="default"?ze.push("mouse-default"):pe.get(70)==="copy"&&ze.push("mouse-copy"),pe.get(105)&&ze.push("showUnused"),pe.get(133)&&ze.push("showDeprecated"),ze.join(" ")}}class ee extends h{constructor(){super(34,"emptySelectionClipboard",!0,{description:r.localize(6,null)})}compute(x,pe,Me){return Me&&x.emptySelectionClipboard}}class K extends E{constructor(){const x={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",x,{"editor.find.cursorMoveOnType":{type:"boolean",default:x.cursorMoveOnType,description:r.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:x.seedSearchStringFromSelection,enumDescriptions:[r.localize(8,null),r.localize(9,null),r.localize(10,null)],description:r.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:x.autoFindInSelection,enumDescriptions:[r.localize(12,null),r.localize(13,null),r.localize(14,null)],description:r.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:x.globalFindClipboard,description:r.localize(16,null),included:k.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:x.addExtraSpaceOnTop,description:r.localize(17,null)},"editor.find.loop":{type:"boolean",default:x.loop,description:r.localize(18,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{cursorMoveOnType:s(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof x.seedSearchStringFromSelection=="boolean"?x.seedSearchStringFromSelection?"always":"never":i(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof x.autoFindInSelection=="boolean"?x.autoFindInSelection?"always":"never":i(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:s(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:s(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:s(pe.loop,this.defaultValue.loop)}}}class L extends E{constructor(){super(48,"fontLigatures",L.OFF,{anyOf:[{type:"boolean",description:r.localize(19,null)},{type:"string",description:r.localize(20,null)}],description:r.localize(21,null),default:!1})}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x==="false"?L.OFF:x==="true"?L.ON:x:Boolean(x)?L.ON:L.OFF}}e.EditorFontLigatures=L,L.OFF='"liga" off, "calt" off',L.ON='"liga" on, "calt" on';class B extends E{constructor(){super(51,"fontVariations",B.OFF,{anyOf:[{type:"boolean",description:r.localize(22,null)},{type:"string",description:r.localize(23,null)}],description:r.localize(24,null),default:!1})}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x==="false"?B.OFF:x==="true"?B.TRANSLATE:x:Boolean(x)?B.TRANSLATE:B.OFF}compute(x,pe,Me){return x.fontInfo.fontVariationSettings}}e.EditorFontVariations=B,B.OFF="normal",B.TRANSLATE="translate";class P extends m{constructor(){super(47)}compute(x,pe,Me){return x.fontInfo}}class F extends o{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:r.localize(25,null)})}validate(x){const pe=A.float(x,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:A.clamp(pe,6,100)}compute(x,pe,Me){return x.fontInfo.fontSize}}class H extends E{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:H.d,maximum:H.e,errorMessage:r.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:H.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:r.localize(27,null)})}validate(x){return x==="normal"||x==="bold"?x:String(w.clampedInt(x,e.EDITOR_FONT_DEFAULTS.fontWeight,H.d,H.e))}}H.c=["normal","bold","100","200","300","400","500","600","700","800","900"],H.d=1,H.e=1e3;class j extends E{constructor(){const x={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:x.multiple,enumDescriptions:[r.localize(28,null),r.localize(29,null),r.localize(30,null)]},Me=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",x,{"editor.gotoLocation.multiple":{deprecationMessage:r.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:r.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:r.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:r.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:r.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:r.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:x.alternativeDefinitionCommand,enum:Me,description:r.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:x.alternativeTypeDefinitionCommand,enum:Me,description:r.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:x.alternativeDeclarationCommand,enum:Me,description:r.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:x.alternativeImplementationCommand,enum:Me,description:r.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:x.alternativeReferenceCommand,enum:Me,description:r.localize(41,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{multiple:i(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??i(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??i(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??i(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??i(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??i(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:v.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:v.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:v.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:v.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:v.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class le extends E{constructor(){const x={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",x,{"editor.hover.enabled":{type:"boolean",default:x.enabled,description:r.localize(42,null)},"editor.hover.delay":{type:"number",default:x.delay,minimum:0,maximum:1e4,description:r.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:x.sticky,description:r.localize(44,null)},"editor.hover.above":{type:"boolean",default:x.above,description:r.localize(45,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:s(pe.enabled,this.defaultValue.enabled),delay:w.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:s(pe.sticky,this.defaultValue.sticky),above:s(pe.above,this.defaultValue.above)}}}var _;(function(Q){Q[Q.None=0]="None",Q[Q.Text=1]="Text",Q[Q.Blocks=2]="Blocks"})(_=e.RenderMinimap||(e.RenderMinimap={}));class be extends m{constructor(){super(138)}compute(x,pe,Me){return be.computeLayout(pe,{memory:x.memory,outerWidth:x.outerWidth,outerHeight:x.outerHeight,isDominatedByLongLines:x.isDominatedByLongLines,lineHeight:x.fontInfo.lineHeight,viewLineCount:x.viewLineCount,lineNumbersDigitCount:x.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:x.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:x.fontInfo.maxDigitWidth,pixelRatio:x.pixelRatio})}static computeContainedMinimapLineCount(x){const pe=x.height/x.lineHeight,Me=Math.floor(x.paddingTop/x.lineHeight);let ze=Math.floor(x.paddingBottom/x.lineHeight);x.scrollBeyondLastLine&&(ze=Math.max(ze,pe-1));const Ve=(Me+x.viewLineCount+ze)/(x.pixelRatio*x.height),_e=Math.floor(x.viewLineCount/Ve);return{typicalViewportLineCount:pe,extraLinesBeforeFirstLine:Me,extraLinesBeyondLastLine:ze,desiredRatio:Ve,minimapLineCount:_e}}static c(x,pe){const Me=x.outerWidth,ze=x.outerHeight,Ve=x.pixelRatio;if(!x.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ve*ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ze};const _e=pe.stableMinimapLayoutInput,nt=_e&&x.outerHeight===_e.outerHeight&&x.lineHeight===_e.lineHeight&&x.typicalHalfwidthCharacterWidth===_e.typicalHalfwidthCharacterWidth&&x.pixelRatio===_e.pixelRatio&&x.scrollBeyondLastLine===_e.scrollBeyondLastLine&&x.paddingTop===_e.paddingTop&&x.paddingBottom===_e.paddingBottom&&x.minimap.enabled===_e.minimap.enabled&&x.minimap.side===_e.minimap.side&&x.minimap.size===_e.minimap.size&&x.minimap.showSlider===_e.minimap.showSlider&&x.minimap.renderCharacters===_e.minimap.renderCharacters&&x.minimap.maxColumn===_e.minimap.maxColumn&&x.minimap.scale===_e.minimap.scale&&x.verticalScrollbarWidth===_e.verticalScrollbarWidth&&x.isViewportWrapping===_e.isViewportWrapping,vt=x.lineHeight,wt=x.typicalHalfwidthCharacterWidth,Ct=x.scrollBeyondLastLine,jt=x.minimap.renderCharacters;let rt=Ve>=2?Math.round(x.minimap.scale*2):x.minimap.scale;const mt=x.minimap.maxColumn,Ft=x.minimap.size,xt=x.minimap.side,Pt=x.verticalScrollbarWidth,ht=x.viewLineCount,kt=x.remainingWidth,$t=x.isViewportWrapping,Ot=jt?2:3;let xe=Math.floor(Ve*ze);const Nt=xe/Ve;let Mt=!1,zt=!1,ft=Ot*rt,De=rt/Ve,Ae=1;if(Ft==="fill"||Ft==="fit"){const{typicalViewportLineCount:Ze,extraLinesBeforeFirstLine:ct,extraLinesBeyondLastLine:Tt,desiredRatio:bt,minimapLineCount:Et}=be.computeContainedMinimapLineCount({viewLineCount:ht,scrollBeyondLastLine:Ct,paddingTop:x.paddingTop,paddingBottom:x.paddingBottom,height:ze,lineHeight:vt,pixelRatio:Ve});if(ht/Et>1)Mt=!0,zt=!0,rt=1,ft=1,De=rt/Ve;else{let St=!1,yt=rt+1;if(Ft==="fit"){const qt=Math.ceil((ct+ht+Tt)*ft);$t&&nt&&kt<=pe.stableFitRemainingWidth?(St=!0,yt=pe.stableFitMaxMinimapScale):St=qt>xe}if(Ft==="fill"||St){Mt=!0;const qt=rt;ft=Math.min(vt*Ve,Math.max(1,Math.floor(1/bt))),$t&&nt&&kt<=pe.stableFitRemainingWidth&&(yt=pe.stableFitMaxMinimapScale),rt=Math.min(yt,Math.max(1,Math.floor(ft/Ot))),rt>qt&&(Ae=Math.min(2,rt/qt)),De=rt/Ve/Ae,xe=Math.ceil(Math.max(Ze,ct+ht+Tt)*ft),$t?(pe.stableMinimapLayoutInput=x,pe.stableFitRemainingWidth=kt,pe.stableFitMaxMinimapScale=rt):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const ge=Math.floor(mt*De),G=Math.min(ge,Math.max(0,Math.floor((kt-Pt-2)*De/(wt+De)))+e.MINIMAP_GUTTER_WIDTH);let Re=Math.floor(Ve*G);const $e=Re/Ve;Re=Math.floor(Re*Ae);const Qe=jt?1:2,Be=xt==="left"?0:Me-G-Pt;return{renderMinimap:Qe,minimapLeft:Be,minimapWidth:G,minimapHeightIsEditorHeight:Mt,minimapIsSampling:zt,minimapScale:rt,minimapLineHeight:ft,minimapCanvasInnerWidth:Re,minimapCanvasInnerHeight:xe,minimapCanvasOuterWidth:$e,minimapCanvasOuterHeight:Nt}}static computeLayout(x,pe){const Me=pe.outerWidth|0,ze=pe.outerHeight|0,Ve=pe.lineHeight|0,_e=pe.lineNumbersDigitCount|0,nt=pe.typicalHalfwidthCharacterWidth,vt=pe.maxDigitWidth,wt=pe.pixelRatio,Ct=pe.viewLineCount,jt=x.get(130),rt=jt==="inherit"?x.get(129):jt,mt=rt==="inherit"?x.get(125):rt,Ft=x.get(128),xt=pe.isDominatedByLongLines,Pt=x.get(54),ht=x.get(64).renderType!==0,kt=x.get(65),$t=x.get(99),Ot=x.get(80),xe=x.get(69),Nt=x.get(97),Mt=Nt.verticalScrollbarSize,zt=Nt.verticalHasArrows,ft=Nt.arrowSize,De=Nt.horizontalScrollbarSize,Ae=x.get(40),ge=x.get(104)!=="never";let G=x.get(62);Ae&&ge&&(G+=16);let Re=0;if(ht){const pt=Math.max(_e,kt);Re=Math.round(pt*vt)}let $e=0;Pt&&($e=Ve);let Qe=0,Be=Qe+$e,Ze=Be+Re,ct=Ze+G;const Tt=Me-$e-Re-G;let bt=!1,Et=!1,It=-1;rt==="inherit"&&xt?(bt=!0,Et=!0):mt==="on"||mt==="bounded"?Et=!0:mt==="wordWrapColumn"&&(It=Ft);const St=be.c({outerWidth:Me,outerHeight:ze,lineHeight:Ve,typicalHalfwidthCharacterWidth:nt,pixelRatio:wt,scrollBeyondLastLine:$t,paddingTop:Ot.top,paddingBottom:Ot.bottom,minimap:xe,verticalScrollbarWidth:Mt,viewLineCount:Ct,remainingWidth:Tt,isViewportWrapping:Et},pe.memory||new N);St.renderMinimap!==0&&St.minimapLeft===0&&(Qe+=St.minimapWidth,Be+=St.minimapWidth,Ze+=St.minimapWidth,ct+=St.minimapWidth);const yt=Tt-St.minimapWidth,qt=Math.max(1,Math.floor((yt-Mt-2)/nt)),Jt=zt?ft:0;return Et&&(It=Math.max(1,qt),mt==="bounded"&&(It=Math.min(It,Ft))),{width:Me,height:ze,glyphMarginLeft:Qe,glyphMarginWidth:$e,lineNumbersLeft:Be,lineNumbersWidth:Re,decorationsLeft:Ze,decorationsWidth:G,contentLeft:ct,contentWidth:yt,minimap:St,viewportColumn:qt,isWordWrapMinified:bt,isViewportWrapping:Et,wrappingColumn:It,verticalScrollbarWidth:Mt,horizontalScrollbarHeight:De,overviewRuler:{top:Jt,width:Mt,height:ze-2*Jt,right:0}}}}e.EditorLayoutInfoComputer=be;class de extends E{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[r.localize(46,null),r.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:r.localize(48,null)}})}validate(x){return i(x,"simple",["simple","advanced"])}compute(x,pe,Me){return pe.get(2)===2?"advanced":Me}}class ue extends E{constructor(){const x={enabled:!0};super(61,"lightbulb",x,{"editor.lightbulb.enabled":{type:"boolean",default:x.enabled,description:r.localize(49,null)}})}validate(x){return!x||typeof x!="object"?this.defaultValue:{enabled:s(x.enabled,this.defaultValue.enabled)}}}class se extends E{constructor(){const x={enabled:!1,maxLineCount:5};super(109,"stickyScroll",x,{"editor.stickyScroll.enabled":{type:"boolean",default:x.enabled,description:r.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:x.maxLineCount,minimum:1,maximum:10,description:r.localize(51,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:s(pe.enabled,this.defaultValue.enabled),maxLineCount:w.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class J extends E{constructor(){const x={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",x,{"editor.inlayHints.enabled":{type:"string",default:x.enabled,description:r.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[r.localize(53,null),r.localize(54,null,k.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),r.localize(55,null,k.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),r.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:x.fontSize,markdownDescription:r.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:x.fontFamily,markdownDescription:r.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:x.padding,description:r.localize(59,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:i(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:w.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:v.string(pe.fontFamily,this.defaultValue.fontFamily),padding:s(pe.padding,this.defaultValue.padding)}}}class X extends E{constructor(){super(62,"lineDecorationsWidth",10)}validate(x){return typeof x=="string"&&/^\d+(\.\d+)?ch$/.test(x)?-parseFloat(x.substring(0,x.length-2)):w.clampedInt(x,this.defaultValue,0,1e3)}compute(x,pe,Me){return Me<0?w.clampedInt(-Me*x.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Me}}class Z extends A{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,x=>A.clamp(x,0,150),{markdownDescription:r.localize(60,null)})}compute(x,pe,Me){return x.fontInfo.lineHeight}}class he extends E{constructor(){const x={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",x,{"editor.minimap.enabled":{type:"boolean",default:x.enabled,description:r.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:x.autohide,description:r.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[r.localize(63,null),r.localize(64,null),r.localize(65,null)],default:x.size,description:r.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:x.side,description:r.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:x.showSlider,description:r.localize(68,null)},"editor.minimap.scale":{type:"number",default:x.scale,minimum:1,maximum:3,enum:[1,2,3],description:r.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:x.renderCharacters,description:r.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:x.maxColumn,description:r.localize(71,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:s(pe.enabled,this.defaultValue.enabled),autohide:s(pe.autohide,this.defaultValue.autohide),size:i(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:i(pe.side,this.defaultValue.side,["right","left"]),showSlider:i(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:s(pe.renderCharacters,this.defaultValue.renderCharacters),scale:w.clampedInt(pe.scale,1,1,3),maxColumn:w.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Te(Q){return Q==="ctrlCmd"?k.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Ne extends E{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:r.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:r.localize(73,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{top:w.clampedInt(pe.top,0,0,1e3),bottom:w.clampedInt(pe.bottom,0,0,1e3)}}}class Ke extends E{constructor(){const x={enabled:!0,cycle:!0};super(81,"parameterHints",x,{"editor.parameterHints.enabled":{type:"boolean",default:x.enabled,description:r.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:x.cycle,description:r.localize(75,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:s(pe.enabled,this.defaultValue.enabled),cycle:s(pe.cycle,this.defaultValue.cycle)}}}class Pe extends m{constructor(){super(136)}compute(x,pe,Me){return x.pixelRatio}}class Se extends E{constructor(){const x={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[r.localize(76,null),r.localize(77,null),r.localize(78,null)]}];super(84,"quickSuggestions",x,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:x.strings,description:r.localize(79,null)},comments:{anyOf:pe,default:x.comments,description:r.localize(80,null)},other:{anyOf:pe,default:x.other,description:r.localize(81,null)}},default:x,markdownDescription:r.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=x}validate(x){if(typeof x=="boolean"){const wt=x?"on":"off";return{comments:wt,strings:wt,other:wt}}if(!x||typeof x!="object")return this.defaultValue;const{other:pe,comments:Me,strings:ze}=x,Ve=["on","inline","off"];let _e,nt,vt;return typeof pe=="boolean"?_e=pe?"on":"off":_e=i(pe,this.defaultValue.other,Ve),typeof Me=="boolean"?nt=Me?"on":"off":nt=i(Me,this.defaultValue.comments,Ve),typeof ze=="boolean"?vt=ze?"on":"off":vt=i(ze,this.defaultValue.strings,Ve),{other:_e,comments:nt,strings:vt}}}var Ie;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval",Q[Q.Custom=4]="Custom"})(Ie=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class oe extends E{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[r.localize(83,null),r.localize(84,null),r.localize(85,null),r.localize(86,null)],default:"on",description:r.localize(87,null)})}validate(x){let pe=this.defaultValue.renderType,Me=this.defaultValue.renderFn;return typeof x<"u"&&(typeof x=="function"?(pe=4,Me=x):x==="interval"?pe=3:x==="relative"?pe=2:x==="on"?pe=1:pe=0),{renderType:pe,renderFn:Me}}}function ce(Q){const x=Q.get(92);return x==="editable"?Q.get(86):x!=="on"}e.filterValidationDecorations=ce;class Y extends E{constructor(){const x=[],pe={type:"number",description:r.localize(88,null)};super(96,"rulers",x,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:r.localize(89,null),format:"color-hex"}}}]},default:x,description:r.localize(90,null)})}validate(x){if(Array.isArray(x)){const pe=[];for(const Me of x)if(typeof Me=="number")pe.push({column:w.clampedInt(Me,0,0,1e4),color:null});else if(Me&&typeof Me=="object"){const ze=Me;pe.push({column:w.clampedInt(ze.column,0,0,1e4),color:ze.color})}return pe.sort((Me,ze)=>Me.column-ze.column),pe}return this.defaultValue}}function I(Q,x){if(typeof Q!="string")return x;switch(Q){case"hidden":return 2;case"visible":return 3;default:return 1}}class $ extends E{constructor(){const x={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",x,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[r.localize(91,null),r.localize(92,null),r.localize(93,null)],default:"auto",description:r.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[r.localize(95,null),r.localize(96,null),r.localize(97,null)],default:"auto",description:r.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:x.verticalScrollbarSize,description:r.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:x.horizontalScrollbarSize,description:r.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:x.scrollByPage,description:r.localize(101,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x,Me=w.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ze=w.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:w.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:I(pe.vertical,this.defaultValue.vertical),horizontal:I(pe.horizontal,this.defaultValue.horizontal),useShadows:s(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:s(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:s(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:s(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:s(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Me,horizontalSliderSize:w.clampedInt(pe.horizontalSliderSize,Me,0,1e3),verticalScrollbarSize:ze,verticalSliderSize:w.clampedInt(pe.verticalSliderSize,ze,0,1e3),scrollByPage:s(pe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class W extends E{constructor(){const x={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",x,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.nonBasicASCII,description:r.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:x.invisibleCharacters,description:r.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:x.ambiguousCharacters,description:r.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.includeComments,description:r.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.includeStrings,description:r.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:x.allowedCharacters,description:r.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:x.allowedLocales,description:r.localize(108,null)}})}applyUpdate(x,pe){let Me=!1;pe.allowedCharacters&&x&&(S.equals(x.allowedCharacters,pe.allowedCharacters)||(x={...x,allowedCharacters:pe.allowedCharacters},Me=!0)),pe.allowedLocales&&x&&(S.equals(x.allowedLocales,pe.allowedLocales)||(x={...x,allowedLocales:pe.allowedLocales},Me=!0));const ze=super.applyUpdate(x,pe);return Me?new f(ze.newValue,!0):ze}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{nonBasicASCII:ye(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:s(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:s(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ye(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ye(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(x.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(x.allowedLocales,this.defaultValue.allowedLocales)}}c(x,pe){if(typeof x!="object"||!x)return pe;const Me={};for(const[ze,Ve]of Object.entries(x))Ve===!0&&(Me[ze]=!0);return Me}}class q extends E{constructor(){const x={enabled:!0,mode:"subwordSmart",useExperimentalHints:!1,hideHints:!1};super(59,"inlineSuggest",x,{"editor.inlineSuggest.enabled":{type:"boolean",default:x.enabled,description:r.localize(109,null)},"editor.inlineSuggest.useExperimentalHints":{type:"boolean",default:x.useExperimentalHints,description:r.localize(110,null)},"editor.inlineSuggest.hideHints":{type:"boolean",default:x.hideHints,description:r.localize(111,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:s(pe.enabled,this.defaultValue.enabled),mode:i(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),useExperimentalHints:s(pe.useExperimentalHints,this.defaultValue.useExperimentalHints),hideHints:s(pe.hideHints,this.defaultValue.hideHints)}}}class te extends E{constructor(){const x={enabled:O.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:O.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",x,{"editor.bracketPairColorization.enabled":{type:"boolean",default:x.enabled,markdownDescription:r.localize(112,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:x.independentColorPoolPerBracketType,description:r.localize(113,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:s(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:s(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class fe extends E{constructor(){const x={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",x,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[r.localize(114,null),r.localize(115,null),r.localize(116,null)],default:x.bracketPairs,description:r.localize(117,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[r.localize(118,null),r.localize(119,null),r.localize(120,null)],default:x.bracketPairsHorizontal,description:r.localize(121,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:x.highlightActiveBracketPair,description:r.localize(122,null)},"editor.guides.indentation":{type:"boolean",default:x.indentation,description:r.localize(123,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[r.localize(124,null),r.localize(125,null),r.localize(126,null)],default:x.highlightActiveIndentation,description:r.localize(127,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{bracketPairs:ye(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ye(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:s(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:s(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:ye(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ye(Q,x,pe){const Me=pe.indexOf(Q);return Me===-1?x:pe[Me]}class ae extends E{constructor(){const x={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",x,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[r.localize(128,null),r.localize(129,null)],default:x.insertMode,description:r.localize(130,null)},"editor.suggest.filterGraceful":{type:"boolean",default:x.filterGraceful,description:r.localize(131,null)},"editor.suggest.localityBonus":{type:"boolean",default:x.localityBonus,description:r.localize(132,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:x.shareSuggestSelections,markdownDescription:r.localize(133,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[r.localize(134,null),r.localize(135,null),r.localize(136,null),r.localize(137,null)],default:x.selectionMode,markdownDescription:r.localize(138,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:x.snippetsPreventQuickSuggestions,description:r.localize(139,null)},"editor.suggest.showIcons":{type:"boolean",default:x.showIcons,description:r.localize(140,null)},"editor.suggest.showStatusBar":{type:"boolean",default:x.showStatusBar,description:r.localize(141,null)},"editor.suggest.preview":{type:"boolean",default:x.preview,description:r.localize(142,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:x.showInlineDetails,description:r.localize(143,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:r.localize(144,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:r.localize(145,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:r.localize(146,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:r.localize(147,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:r.localize(148,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:r.localize(149,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:r.localize(150,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:r.localize(151,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:r.localize(152,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:r.localize(153,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:r.localize(154,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:r.localize(155,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:r.localize(156,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:r.localize(157,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:r.localize(158,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:r.localize(159,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:r.localize(160,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:r.localize(161,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:r.localize(162,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:r.localize(163,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:r.localize(164,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:r.localize(165,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:r.localize(166,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:r.localize(167,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:r.localize(168,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:r.localize(169,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:r.localize(170,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:r.localize(171,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:r.localize(172,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:r.localize(173,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:r.localize(174,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:r.localize(175,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{insertMode:i(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:s(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:s(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:s(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:s(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:i(pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:s(pe.showIcons,this.defaultValue.showIcons),showStatusBar:s(pe.showStatusBar,this.defaultValue.showStatusBar),preview:s(pe.preview,this.defaultValue.preview),previewMode:i(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:s(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:s(pe.showMethods,this.defaultValue.showMethods),showFunctions:s(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:s(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:s(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:s(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:s(pe.showFields,this.defaultValue.showFields),showVariables:s(pe.showVariables,this.defaultValue.showVariables),showClasses:s(pe.showClasses,this.defaultValue.showClasses),showStructs:s(pe.showStructs,this.defaultValue.showStructs),showInterfaces:s(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:s(pe.showModules,this.defaultValue.showModules),showProperties:s(pe.showProperties,this.defaultValue.showProperties),showEvents:s(pe.showEvents,this.defaultValue.showEvents),showOperators:s(pe.showOperators,this.defaultValue.showOperators),showUnits:s(pe.showUnits,this.defaultValue.showUnits),showValues:s(pe.showValues,this.defaultValue.showValues),showConstants:s(pe.showConstants,this.defaultValue.showConstants),showEnums:s(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:s(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:s(pe.showKeywords,this.defaultValue.showKeywords),showWords:s(pe.showWords,this.defaultValue.showWords),showColors:s(pe.showColors,this.defaultValue.showColors),showFiles:s(pe.showFiles,this.defaultValue.showFiles),showReferences:s(pe.showReferences,this.defaultValue.showReferences),showFolders:s(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:s(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:s(pe.showSnippets,this.defaultValue.showSnippets),showUsers:s(pe.showUsers,this.defaultValue.showUsers),showIssues:s(pe.showIssues,this.defaultValue.showIssues)}}}class ve extends E{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:r.localize(176,null),default:!0,type:"boolean"}})}validate(x){return!x||typeof x!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:s(x.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Ee extends m{constructor(){super(137)}compute(x,pe,Me){return pe.get(86)?!0:x.tabFocusMode}}var We;(function(Q){Q[Q.None=0]="None",Q[Q.Same=1]="Same",Q[Q.Indent=2]="Indent",Q[Q.DeepIndent=3]="DeepIndent"})(We=e.WrappingIndent||(e.WrappingIndent={}));class He extends E{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[r.localize(177,null),r.localize(178,null),r.localize(179,null),r.localize(180,null)],description:r.localize(181,null),default:"same"}})}validate(x){switch(x){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(x,pe,Me){return pe.get(2)===2?0:Me}}class tt extends m{constructor(){super(139)}compute(x,pe,Me){const ze=pe.get(138);return{isDominatedByLongLines:x.isDominatedByLongLines,isWordWrapMinified:ze.isWordWrapMinified,isViewportWrapping:ze.isViewportWrapping,wrappingColumn:ze.wrappingColumn}}}class Xe extends E{constructor(){const x={enabled:!0};super(33,"dropIntoEditor",x,{"editor.dropIntoEditor.enabled":{type:"boolean",default:x.enabled,markdownDescription:r.localize(182,null)}})}validate(x){return!x||typeof x!="object"?this.defaultValue:{enabled:s(x.enabled,this.defaultValue.enabled)}}}const et="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",dt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:k.isMacintosh?it:k.isLinux?dt:et,fontWeight:"normal",fontSize:k.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Fe(Q){return e.editorOptionsRegistry[Q.id]=Q,Q}var ot;(function(Q){Q[Q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Q[Q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Q[Q.accessibilitySupport=2]="accessibilitySupport",Q[Q.accessibilityPageSize=3]="accessibilityPageSize",Q[Q.ariaLabel=4]="ariaLabel",Q[Q.autoClosingBrackets=5]="autoClosingBrackets",Q[Q.autoClosingDelete=6]="autoClosingDelete",Q[Q.autoClosingOvertype=7]="autoClosingOvertype",Q[Q.autoClosingQuotes=8]="autoClosingQuotes",Q[Q.autoIndent=9]="autoIndent",Q[Q.automaticLayout=10]="automaticLayout",Q[Q.autoSurround=11]="autoSurround",Q[Q.bracketPairColorization=12]="bracketPairColorization",Q[Q.guides=13]="guides",Q[Q.codeLens=14]="codeLens",Q[Q.codeLensFontFamily=15]="codeLensFontFamily",Q[Q.codeLensFontSize=16]="codeLensFontSize",Q[Q.colorDecorators=17]="colorDecorators",Q[Q.colorDecoratorsLimit=18]="colorDecoratorsLimit",Q[Q.columnSelection=19]="columnSelection",Q[Q.comments=20]="comments",Q[Q.contextmenu=21]="contextmenu",Q[Q.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",Q[Q.cursorBlinking=23]="cursorBlinking",Q[Q.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",Q[Q.cursorStyle=25]="cursorStyle",Q[Q.cursorSurroundingLines=26]="cursorSurroundingLines",Q[Q.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",Q[Q.cursorWidth=28]="cursorWidth",Q[Q.disableLayerHinting=29]="disableLayerHinting",Q[Q.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",Q[Q.domReadOnly=31]="domReadOnly",Q[Q.dragAndDrop=32]="dragAndDrop",Q[Q.dropIntoEditor=33]="dropIntoEditor",Q[Q.emptySelectionClipboard=34]="emptySelectionClipboard",Q[Q.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",Q[Q.extraEditorClassName=36]="extraEditorClassName",Q[Q.fastScrollSensitivity=37]="fastScrollSensitivity",Q[Q.find=38]="find",Q[Q.fixedOverflowWidgets=39]="fixedOverflowWidgets",Q[Q.folding=40]="folding",Q[Q.foldingStrategy=41]="foldingStrategy",Q[Q.foldingHighlight=42]="foldingHighlight",Q[Q.foldingImportsByDefault=43]="foldingImportsByDefault",Q[Q.foldingMaximumRegions=44]="foldingMaximumRegions",Q[Q.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",Q[Q.fontFamily=46]="fontFamily",Q[Q.fontInfo=47]="fontInfo",Q[Q.fontLigatures=48]="fontLigatures",Q[Q.fontSize=49]="fontSize",Q[Q.fontWeight=50]="fontWeight",Q[Q.fontVariations=51]="fontVariations",Q[Q.formatOnPaste=52]="formatOnPaste",Q[Q.formatOnType=53]="formatOnType",Q[Q.glyphMargin=54]="glyphMargin",Q[Q.gotoLocation=55]="gotoLocation",Q[Q.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",Q[Q.hover=57]="hover",Q[Q.inDiffEditor=58]="inDiffEditor",Q[Q.inlineSuggest=59]="inlineSuggest",Q[Q.letterSpacing=60]="letterSpacing",Q[Q.lightbulb=61]="lightbulb",Q[Q.lineDecorationsWidth=62]="lineDecorationsWidth",Q[Q.lineHeight=63]="lineHeight",Q[Q.lineNumbers=64]="lineNumbers",Q[Q.lineNumbersMinChars=65]="lineNumbersMinChars",Q[Q.linkedEditing=66]="linkedEditing",Q[Q.links=67]="links",Q[Q.matchBrackets=68]="matchBrackets",Q[Q.minimap=69]="minimap",Q[Q.mouseStyle=70]="mouseStyle",Q[Q.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",Q[Q.mouseWheelZoom=72]="mouseWheelZoom",Q[Q.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",Q[Q.multiCursorModifier=74]="multiCursorModifier",Q[Q.multiCursorPaste=75]="multiCursorPaste",Q[Q.multiCursorLimit=76]="multiCursorLimit",Q[Q.occurrencesHighlight=77]="occurrencesHighlight",Q[Q.overviewRulerBorder=78]="overviewRulerBorder",Q[Q.overviewRulerLanes=79]="overviewRulerLanes",Q[Q.padding=80]="padding",Q[Q.parameterHints=81]="parameterHints",Q[Q.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",Q[Q.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",Q[Q.quickSuggestions=84]="quickSuggestions",Q[Q.quickSuggestionsDelay=85]="quickSuggestionsDelay",Q[Q.readOnly=86]="readOnly",Q[Q.renameOnType=87]="renameOnType",Q[Q.renderControlCharacters=88]="renderControlCharacters",Q[Q.renderFinalNewline=89]="renderFinalNewline",Q[Q.renderLineHighlight=90]="renderLineHighlight",Q[Q.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",Q[Q.renderValidationDecorations=92]="renderValidationDecorations",Q[Q.renderWhitespace=93]="renderWhitespace",Q[Q.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",Q[Q.roundedSelection=95]="roundedSelection",Q[Q.rulers=96]="rulers",Q[Q.scrollbar=97]="scrollbar",Q[Q.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",Q[Q.scrollBeyondLastLine=99]="scrollBeyondLastLine",Q[Q.scrollPredominantAxis=100]="scrollPredominantAxis",Q[Q.selectionClipboard=101]="selectionClipboard",Q[Q.selectionHighlight=102]="selectionHighlight",Q[Q.selectOnLineNumbers=103]="selectOnLineNumbers",Q[Q.showFoldingControls=104]="showFoldingControls",Q[Q.showUnused=105]="showUnused",Q[Q.snippetSuggestions=106]="snippetSuggestions",Q[Q.smartSelect=107]="smartSelect",Q[Q.smoothScrolling=108]="smoothScrolling",Q[Q.stickyScroll=109]="stickyScroll",Q[Q.stickyTabStops=110]="stickyTabStops",Q[Q.stopRenderingLineAfter=111]="stopRenderingLineAfter",Q[Q.suggest=112]="suggest",Q[Q.suggestFontSize=113]="suggestFontSize",Q[Q.suggestLineHeight=114]="suggestLineHeight",Q[Q.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",Q[Q.suggestSelection=116]="suggestSelection",Q[Q.tabCompletion=117]="tabCompletion",Q[Q.tabIndex=118]="tabIndex",Q[Q.unicodeHighlighting=119]="unicodeHighlighting",Q[Q.unusualLineTerminators=120]="unusualLineTerminators",Q[Q.useShadowDOM=121]="useShadowDOM",Q[Q.useTabStops=122]="useTabStops",Q[Q.wordBreak=123]="wordBreak",Q[Q.wordSeparators=124]="wordSeparators",Q[Q.wordWrap=125]="wordWrap",Q[Q.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",Q[Q.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",Q[Q.wordWrapColumn=128]="wordWrapColumn",Q[Q.wordWrapOverride1=129]="wordWrapOverride1",Q[Q.wordWrapOverride2=130]="wordWrapOverride2",Q[Q.wrappingIndent=131]="wrappingIndent",Q[Q.wrappingStrategy=132]="wrappingStrategy",Q[Q.showDeprecated=133]="showDeprecated",Q[Q.inlayHints=134]="inlayHints",Q[Q.editorClassName=135]="editorClassName",Q[Q.pixelRatio=136]="pixelRatio",Q[Q.tabFocusMode=137]="tabFocusMode",Q[Q.layoutInfo=138]="layoutInfo",Q[Q.wrappingInfo=139]="wrappingInfo"})(ot=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Fe(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:r.localize(183,null)})),acceptSuggestionOnEnter:Fe(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",r.localize(184,null),""],markdownDescription:r.localize(185,null)})),accessibilitySupport:Fe(new t),accessibilityPageSize:Fe(new w(3,"accessibilityPageSize",10,1,1073741824,{description:r.localize(186,null),tags:["accessibility"]})),ariaLabel:Fe(new v(4,"ariaLabel",r.localize(187,null))),autoClosingBrackets:Fe(new d(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",r.localize(188,null),r.localize(189,null),""],description:r.localize(190,null)})),autoClosingDelete:Fe(new d(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",r.localize(191,null),""],description:r.localize(192,null)})),autoClosingOvertype:Fe(new d(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",r.localize(193,null),""],description:r.localize(194,null)})),autoClosingQuotes:Fe(new d(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",r.localize(195,null),r.localize(196,null),""],description:r.localize(197,null)})),autoIndent:Fe(new n(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],a,{enumDescriptions:[r.localize(198,null),r.localize(199,null),r.localize(200,null),r.localize(201,null),r.localize(202,null)],description:r.localize(203,null)})),automaticLayout:Fe(new h(10,"automaticLayout",!1)),autoSurround:Fe(new d(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[r.localize(204,null),r.localize(205,null),r.localize(206,null),""],description:r.localize(207,null)})),bracketPairColorization:Fe(new te),bracketPairGuides:Fe(new fe),stickyTabStops:Fe(new h(110,"stickyTabStops",!1,{description:r.localize(208,null)})),codeLens:Fe(new h(14,"codeLens",!0,{description:r.localize(209,null)})),codeLensFontFamily:Fe(new v(15,"codeLensFontFamily","",{description:r.localize(210,null)})),codeLensFontSize:Fe(new w(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:r.localize(211,null)})),colorDecorators:Fe(new h(17,"colorDecorators",!0,{description:r.localize(212,null)})),colorDecoratorsLimit:Fe(new w(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:r.localize(213,null)})),columnSelection:Fe(new h(19,"columnSelection",!1,{description:r.localize(214,null)})),comments:Fe(new g),contextmenu:Fe(new h(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Fe(new h(22,"copyWithSyntaxHighlighting",!0,{description:r.localize(215,null)})),cursorBlinking:Fe(new n(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],u,{description:r.localize(216,null)})),cursorSmoothCaretAnimation:Fe(new d(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[r.localize(217,null),r.localize(218,null),r.localize(219,null)],description:r.localize(220,null)})),cursorStyle:Fe(new n(25,"cursorStyle",l.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],R,{description:r.localize(221,null)})),cursorSurroundingLines:Fe(new w(26,"cursorSurroundingLines",0,0,1073741824,{description:r.localize(222,null)})),cursorSurroundingLinesStyle:Fe(new d(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[r.localize(223,null),r.localize(224,null)],description:r.localize(225,null)})),cursorWidth:Fe(new w(28,"cursorWidth",0,0,1073741824,{markdownDescription:r.localize(226,null)})),disableLayerHinting:Fe(new h(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Fe(new h(30,"disableMonospaceOptimizations",!1)),domReadOnly:Fe(new h(31,"domReadOnly",!1)),dragAndDrop:Fe(new h(32,"dragAndDrop",!0,{description:r.localize(227,null)})),emptySelectionClipboard:Fe(new ee),dropIntoEditor:Fe(new Xe),stickyScroll:Fe(new se),experimentalWhitespaceRendering:Fe(new d(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[r.localize(228,null),r.localize(229,null),r.localize(230,null)],description:r.localize(231,null)})),extraEditorClassName:Fe(new v(36,"extraEditorClassName","")),fastScrollSensitivity:Fe(new A(37,"fastScrollSensitivity",5,Q=>Q<=0?5:Q,{markdownDescription:r.localize(232,null)})),find:Fe(new K),fixedOverflowWidgets:Fe(new h(39,"fixedOverflowWidgets",!1)),folding:Fe(new h(40,"folding",!0,{description:r.localize(233,null)})),foldingStrategy:Fe(new d(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[r.localize(234,null),r.localize(235,null)],description:r.localize(236,null)})),foldingHighlight:Fe(new h(42,"foldingHighlight",!0,{description:r.localize(237,null)})),foldingImportsByDefault:Fe(new h(43,"foldingImportsByDefault",!1,{description:r.localize(238,null)})),foldingMaximumRegions:Fe(new w(44,"foldingMaximumRegions",5e3,10,65e3,{description:r.localize(239,null)})),unfoldOnClickAfterEndOfLine:Fe(new h(45,"unfoldOnClickAfterEndOfLine",!1,{description:r.localize(240,null)})),fontFamily:Fe(new v(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:r.localize(241,null)})),fontInfo:Fe(new P),fontLigatures2:Fe(new L),fontSize:Fe(new F),fontWeight:Fe(new H),fontVariations:Fe(new B),formatOnPaste:Fe(new h(52,"formatOnPaste",!1,{description:r.localize(242,null)})),formatOnType:Fe(new h(53,"formatOnType",!1,{description:r.localize(243,null)})),glyphMargin:Fe(new h(54,"glyphMargin",!0,{description:r.localize(244,null)})),gotoLocation:Fe(new j),hideCursorInOverviewRuler:Fe(new h(56,"hideCursorInOverviewRuler",!1,{description:r.localize(245,null)})),hover:Fe(new le),inDiffEditor:Fe(new h(58,"inDiffEditor",!1)),letterSpacing:Fe(new A(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Q=>A.clamp(Q,-5,20),{description:r.localize(246,null)})),lightbulb:Fe(new ue),lineDecorationsWidth:Fe(new X),lineHeight:Fe(new Z),lineNumbers:Fe(new oe),lineNumbersMinChars:Fe(new w(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Fe(new h(66,"linkedEditing",!1,{description:r.localize(247,null)})),links:Fe(new h(67,"links",!0,{description:r.localize(248,null)})),matchBrackets:Fe(new d(68,"matchBrackets","always",["always","near","never"],{description:r.localize(249,null)})),minimap:Fe(new he),mouseStyle:Fe(new d(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Fe(new A(71,"mouseWheelScrollSensitivity",1,Q=>Q===0?1:Q,{markdownDescription:r.localize(250,null)})),mouseWheelZoom:Fe(new h(72,"mouseWheelZoom",!1,{markdownDescription:r.localize(251,null)})),multiCursorMergeOverlapping:Fe(new h(73,"multiCursorMergeOverlapping",!0,{description:r.localize(252,null)})),multiCursorModifier:Fe(new n(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Te,{markdownEnumDescriptions:[r.localize(253,null),r.localize(254,null)],markdownDescription:r.localize(255,null)})),multiCursorPaste:Fe(new d(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[r.localize(256,null),r.localize(257,null)],markdownDescription:r.localize(258,null)})),multiCursorLimit:Fe(new w(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:r.localize(259,null)})),occurrencesHighlight:Fe(new h(77,"occurrencesHighlight",!0,{description:r.localize(260,null)})),overviewRulerBorder:Fe(new h(78,"overviewRulerBorder",!0,{description:r.localize(261,null)})),overviewRulerLanes:Fe(new w(79,"overviewRulerLanes",3,0,3)),padding:Fe(new Ne),parameterHints:Fe(new Ke),peekWidgetDefaultFocus:Fe(new d(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[r.localize(262,null),r.localize(263,null)],description:r.localize(264,null)})),definitionLinkOpensInPeek:Fe(new h(83,"definitionLinkOpensInPeek",!1,{description:r.localize(265,null)})),quickSuggestions:Fe(new Se),quickSuggestionsDelay:Fe(new w(85,"quickSuggestionsDelay",10,0,1073741824,{description:r.localize(266,null)})),readOnly:Fe(new h(86,"readOnly",!1)),renameOnType:Fe(new h(87,"renameOnType",!1,{description:r.localize(267,null),markdownDeprecationMessage:r.localize(268,null)})),renderControlCharacters:Fe(new h(88,"renderControlCharacters",!0,{description:r.localize(269,null),restricted:!0})),renderFinalNewline:Fe(new d(89,"renderFinalNewline",k.isLinux?"dimmed":"on",["off","on","dimmed"],{description:r.localize(270,null)})),renderLineHighlight:Fe(new d(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",r.localize(271,null)],description:r.localize(272,null)})),renderLineHighlightOnlyWhenFocus:Fe(new h(91,"renderLineHighlightOnlyWhenFocus",!1,{description:r.localize(273,null)})),renderValidationDecorations:Fe(new d(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Fe(new d(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",r.localize(274,null),r.localize(275,null),r.localize(276,null),""],description:r.localize(277,null)})),revealHorizontalRightPadding:Fe(new w(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Fe(new h(95,"roundedSelection",!0,{description:r.localize(278,null)})),rulers:Fe(new Y),scrollbar:Fe(new $),scrollBeyondLastColumn:Fe(new w(98,"scrollBeyondLastColumn",4,0,1073741824,{description:r.localize(279,null)})),scrollBeyondLastLine:Fe(new h(99,"scrollBeyondLastLine",!0,{description:r.localize(280,null)})),scrollPredominantAxis:Fe(new h(100,"scrollPredominantAxis",!0,{description:r.localize(281,null)})),selectionClipboard:Fe(new h(101,"selectionClipboard",!0,{description:r.localize(282,null),included:k.isLinux})),selectionHighlight:Fe(new h(102,"selectionHighlight",!0,{description:r.localize(283,null)})),selectOnLineNumbers:Fe(new h(103,"selectOnLineNumbers",!0)),showFoldingControls:Fe(new d(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[r.localize(284,null),r.localize(285,null),r.localize(286,null)],description:r.localize(287,null)})),showUnused:Fe(new h(105,"showUnused",!0,{description:r.localize(288,null)})),showDeprecated:Fe(new h(133,"showDeprecated",!0,{description:r.localize(289,null)})),inlayHints:Fe(new J),snippetSuggestions:Fe(new d(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[r.localize(290,null),r.localize(291,null),r.localize(292,null),r.localize(293,null)],description:r.localize(294,null)})),smartSelect:Fe(new ve),smoothScrolling:Fe(new h(108,"smoothScrolling",!1,{description:r.localize(295,null)})),stopRenderingLineAfter:Fe(new w(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Fe(new ae),inlineSuggest:Fe(new q),suggestFontSize:Fe(new w(113,"suggestFontSize",0,0,1e3,{markdownDescription:r.localize(296,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Fe(new w(114,"suggestLineHeight",0,0,1e3,{markdownDescription:r.localize(297,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Fe(new h(115,"suggestOnTriggerCharacters",!0,{description:r.localize(298,null)})),suggestSelection:Fe(new d(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[r.localize(299,null),r.localize(300,null),r.localize(301,null)],description:r.localize(302,null)})),tabCompletion:Fe(new d(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[r.localize(303,null),r.localize(304,null),r.localize(305,null)],description:r.localize(306,null)})),tabIndex:Fe(new w(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Fe(new W),unusualLineTerminators:Fe(new d(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[r.localize(307,null),r.localize(308,null),r.localize(309,null)],description:r.localize(310,null)})),useShadowDOM:Fe(new h(121,"useShadowDOM",!0)),useTabStops:Fe(new h(122,"useTabStops",!0,{description:r.localize(311,null)})),wordBreak:Fe(new d(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[r.localize(312,null),r.localize(313,null)],description:r.localize(314,null)})),wordSeparators:Fe(new v(124,"wordSeparators",D.USUAL_WORD_SEPARATORS,{description:r.localize(315,null)})),wordWrap:Fe(new d(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[r.localize(316,null),r.localize(317,null),r.localize(318,null),r.localize(319,null)],description:r.localize(320,null)})),wordWrapBreakAfterCharacters:Fe(new v(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Fe(new v(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Fe(new w(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:r.localize(321,null)})),wordWrapOverride1:Fe(new d(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Fe(new d(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Fe(new V),pixelRatio:Fe(new Pe),tabFocusMode:Fe(new Ee),layoutInfo:Fe(new be),wrappingInfo:Fe(new tt),wrappingIndent:Fe(new He),wrappingStrategy:Fe(new de)}}),define(Ce[132],ke([13,14]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[133],ke([13,14]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[134],ke([13,14]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[135],ke([13,14]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(Ce[136],ke([13,14]),function(ie,e){return ie.create("vs/platform/markers/common/markers",e)}),define(Ce[137],ke([13,14]),function(ie,e){return ie.create("vs/platform/theme/common/iconRegistry",e)}),define(Ce[138],ke([13,14]),function(ie,e){return ie.create("vs/platform/workspace/common/workspace",e)}),define(Ce[139],ke([13,14]),function(ie,e){return ie.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[140],ke([13,14]),function(ie,e){return ie.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[141],ke([13,14]),function(ie,e){return ie.create("vs/workbench/api/common/extHostProgress",e)}),define(Ce[142],ke([13,14]),function(ie,e){return ie.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[143],ke([13,14]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[144],ke([13,14]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[145],ke([13,14]),function(ie,e){return ie.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[146],ke([13,14]),function(ie,e){return ie.create("vs/workbench/common/editor",e)}),define(Ce[147],ke([13,14]),function(ie,e){return ie.create("vs/workbench/common/views",e)}),define(Ce[148],ke([13,14]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[149],ke([13,14]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[150],ke([13,14]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[151],ke([13,14]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[152],ke([13,14]),function(ie,e){return ie.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[153],ke([13,14]),function(ie,e){return ie.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[154],ke([13,14]),function(ie,e){return ie.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[155],ke([1,0,12]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class k{constructor(){this.a=new Map}register(M,S){this.a.set(M,S)}updateManifest(M){if(!(typeof M.main>"u"&&typeof M.browser>"u")&&(M.activationEvents===void 0&&Object.assign(M,{activationEvents:[]}),!(!Array.isArray(M.activationEvents)||!M.contributes)))for(const S in M.contributes){const O=this.a.get(S);if(!O)continue;const y=M.contributes[S],T=Array.isArray(y)?y:[y];try{O(T,M.activationEvents)}catch(N){(0,r.onUnexpectedError)(N)}}}}e.ImplicitActivationEventsImpl=k,e.ImplicitActivationEvents=new k}),define(Ce[156],ke([1,0,24,29,134,256]),function(ie,e,r,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const S=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,O=/^-(\d{4})(\d{2})(\d{2})$/;function y(h){return h=h.trim(),h==="*"||S.test(h)}e.isValidVersionStr=y;function T(h){if(!y(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=h.match(S);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=T;function N(h){if(!h)return null;const p=h.majorBase,w=h.majorMustEqual,A=h.minorBase;let v=h.minorMustEqual;const i=h.patchBase;let d=h.patchMustEqual;h.hasCaret&&(p===0||(v=!1),d=!1);let n=0;if(h.preRelease){const a=O.exec(h.preRelease);if(a){const[,t,g,c]=a;n=Date.UTC(Number(t),Number(g)-1,Number(c))}}return{majorBase:p,majorMustEqual:w,minorBase:A,minorMustEqual:v,patchBase:i,patchMustEqual:d,isMinimum:h.hasGreaterEquals,notBefore:n}}e.normalizeVersion=N;function E(h,p,w){let A;typeof h=="string"?A=N(T(h)):A=h;let v;p instanceof Date?v=p.getTime():typeof p=="string"&&(v=new Date(p).getTime());let i;if(typeof w=="string"?i=N(T(w)):i=w,!A||!i)return!1;const d=A.majorBase,n=A.minorBase,a=A.patchBase;let t=i.majorBase,g=i.minorBase,c=i.patchBase;const u=i.notBefore;let l=i.majorMustEqual,C=i.minorMustEqual,R=i.patchMustEqual;return i.isMinimum?d>t?!0:d<t?!1:n>g?!0:n<g||v&&v<u?!1:a>=c:(d===1&&t===0&&(!l||!C||!R)&&(t=1,g=0,c=0,l=!0,C=!1,R=!1),d<t?!1:d>t?!l:n<g?!1:n>g?!C:a<c?!1:a>c?!R:!(v&&v<u))}e.isValidVersion=E;function f(h,p,w,A,v){const i=[];if(typeof A.publisher<"u"&&typeof A.publisher!="string")return i.push([k.default.Error,D.localize(0,null)]),i;if(typeof A.name!="string")return i.push([k.default.Error,D.localize(1,null,"name")]),i;if(typeof A.version!="string")return i.push([k.default.Error,D.localize(2,null,"version")]),i;if(!A.engines)return i.push([k.default.Error,D.localize(3,null,"engines")]),i;if(typeof A.engines.vscode!="string")return i.push([k.default.Error,D.localize(4,null,"engines.vscode")]),i;if(typeof A.extensionDependencies<"u"&&!s(A.extensionDependencies))return i.push([k.default.Error,D.localize(5,null,"extensionDependencies")]),i;if(typeof A.activationEvents<"u"){if(!s(A.activationEvents))return i.push([k.default.Error,D.localize(6,null,"activationEvents")]),i;if(typeof A.main>"u"&&typeof A.browser>"u")return i.push([k.default.Error,D.localize(7,null,"activationEvents","main")]),i}if(typeof A.extensionKind<"u"&&typeof A.main>"u"&&i.push([k.default.Warning,D.localize(8,null,"extensionKind")]),typeof A.main<"u"){if(typeof A.main!="string")return i.push([k.default.Error,D.localize(9,null,"main")]),i;{const a=(0,r.joinPath)(w,A.main);(0,r.isEqualOrParent)(a,w)||i.push([k.default.Warning,D.localize(10,null,a.path,w.path)])}if(typeof A.activationEvents>"u")return i.push([k.default.Error,D.localize(11,null,"activationEvents","main")]),i}if(typeof A.browser<"u"){if(typeof A.browser!="string")return i.push([k.default.Error,D.localize(12,null,"browser")]),i;{const a=(0,r.joinPath)(w,A.browser);(0,r.isEqualOrParent)(a,w)||i.push([k.default.Warning,D.localize(13,null,a.path,w.path)])}if(typeof A.activationEvents>"u")return i.push([k.default.Error,D.localize(14,null,"activationEvents","browser")]),i}if(!M.valid(A.version))return i.push([k.default.Error,D.localize(15,null)]),i;const d=[];if(!b(h,p,A,v,d))for(const a of d)i.push([k.default.Error,a]);return i}e.validateExtensionManifest=f;function b(h,p,w,A,v){return A||typeof w.main>"u"&&typeof w.browser>"u"?!0:o(h,p,w.engines.vscode,v)}e.isValidExtensionVersion=b;function m(h,p,w){return h==="*"||o(p,w,h)}e.isEngineValid=m;function o(h,p,w,A=[]){const v=N(T(w));if(!v)return A.push(D.localize(16,null,w)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return A.push(D.localize(17,null,w)),!1}else if(!v.majorMustEqual)return A.push(D.localize(18,null,w)),!1;return E(h,p,v)?!0:(A.push(D.localize(19,null,h,w)),!1)}function s(h){if(!Array.isArray(h))return!1;for(let p=0,w=h.length;p<w;p++)if(typeof h[p]!="string")return!1;return!0}}),define(Ce[89],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class r{constructor(D,M=[],S=!1){this.ctor=D,this.staticArguments=M,this.supportsDelayedInstantiation=S}}e.SyncDescriptor=r}),define(Ce[66],ke([1,0,89]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const k=[];var D;(function(O){O[O.Eager=0]="Eager",O[O.Delayed=1]="Delayed"})(D=e.InstantiationType||(e.InstantiationType={}));function M(O,y,T){y instanceof r.SyncDescriptor||(y=new r.SyncDescriptor(y,[],Boolean(T))),k.push([O,y])}e.registerSingleton=M;function S(){return k}e.getSingletonServiceDescriptors=S}),define(Ce[157],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class r{constructor(M,S){this.key=M,this.data=S,this.incoming=new Map,this.outgoing=new Map}}e.Node=r;class k{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const S of this.a.values())S.outgoing.size===0&&M.push(S);return M}insertEdge(M,S){const O=this.lookupOrInsertNode(M),y=this.lookupOrInsertNode(S);O.outgoing.set(y.key,y),y.incoming.set(O.key,O)}removeNode(M){const S=this.b(M);this.a.delete(S);for(const O of this.a.values())O.outgoing.delete(S),O.incoming.delete(S)}lookupOrInsertNode(M){const S=this.b(M);let O=this.a.get(S);return O||(O=new r(S,M),this.a.set(S,O)),O}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[S,O]of this.a)M.push(`${S}
	(-> incoming)[${[...O.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...O.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,S]of this.a){const O=new Set([M]),y=this.c(S,O);if(y)return y}}c(M,S){for(const[O,y]of M.outgoing){if(S.has(O))return[...S,O].join(" -> ");S.add(O);const T=this.c(y,S);if(T)return T;S.delete(O)}}}e.Graph=k}),define(Ce[3],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var r;(function(S){S.serviceIds=new Map,S.DI_TARGET="$di$target",S.DI_DEPENDENCIES="$di$dependencies";function O(y){return y[S.DI_DEPENDENCIES]||[]}S.getServiceDependencies=O})(r=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function k(S,O,y){O[r.DI_TARGET]===O?O[r.DI_DEPENDENCIES].push({id:S,index:y}):(O[r.DI_DEPENDENCIES]=[{id:S,index:y}],O[r.DI_TARGET]=O)}function D(S){if(r.serviceIds.has(S))return r.serviceIds.get(S);const O=function(y,T,N){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(O,y,N)};return O.toString=()=>S,r.serviceIds.set(S,O),O}e.createDecorator=D;function M(S){return S}e.refineServiceDecorator=M}),define(Ce[41],ke([1,0,9,2,3]),function(ie,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function M(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof k.URI)}e.isConfigurationOverrides=M;function S(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof k.URI)}e.isConfigurationUpdateOverrides=S;var O;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(O=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function T(s,h){const p=Object.create(null);for(const w in s)N(p,w,s[w],h);return p}e.toValuesTree=T;function N(s,h,p,w){const A=h.split("."),v=A.pop();let i=s;for(let d=0;d<A.length;d++){const n=A[d];let a=i[n];switch(typeof a){case"undefined":a=i[n]=Object.create(null);break;case"object":break;default:w(`Ignoring ${h} as ${A.slice(0,d+1).join(".")} is ${JSON.stringify(a)}`);return}i=a}if(typeof i=="object"&&i!==null)try{i[v]=p}catch{w(`Ignoring ${h} as ${A.join(".")} is ${JSON.stringify(i)}`)}else w(`Ignoring ${h} as ${A.join(".")} is ${JSON.stringify(i)}`)}e.addToValueTree=N;function E(s,h){const p=h.split(".");f(s,p)}e.removeFromValueTree=E;function f(s,h){const p=h.shift();if(h.length===0){delete s[p];return}if(Object.keys(s).indexOf(p)!==-1){const w=s[p];typeof w=="object"&&!Array.isArray(w)&&(f(w,h),Object.keys(w).length===0&&delete s[p])}}function b(s,h,p){function w(i,d){let n=i;for(const a of d){if(typeof n!="object"||n===null)return;n=n[a]}return n}const A=h.split("."),v=w(s,A);return typeof v>"u"?p:v}e.getConfigurationValue=b;function m(s,h,p){Object.keys(h).forEach(w=>{w!=="__proto__"&&(w in s?r.isObject(s[w])&&r.isObject(h[w])?m(s[w],h[w],p):p&&(s[w]=h[w]):s[w]=h[w])})}e.merge=m;function o(s){return s.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=o}),define(Ce[42],ke([1,0,20,10,3]),function(ie,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const M=new Map;M.set("false",!1),M.set("true",!0),M.set("isMac",r.isMacintosh),M.set("isLinux",r.isLinux),M.set("isWindows",r.isWindows),M.set("isWeb",r.isWeb),M.set("isMacNative",r.isMacintosh&&!r.isWeb),M.set("isEdge",r.isEdge),M.set("isFirefox",r.isFirefox),M.set("isChrome",r.isChrome),M.set("isSafari",r.isSafari);const S=Object.prototype.hasOwnProperty;var O;(function(K){K[K.False=0]="False",K[K.True=1]="True",K[K.Defined=2]="Defined",K[K.Not=3]="Not",K[K.Equals=4]="Equals",K[K.NotEquals=5]="NotEquals",K[K.And=6]="And",K[K.Regex=7]="Regex",K[K.NotRegex=8]="NotRegex",K[K.Or=9]="Or",K[K.In=10]="In",K[K.NotIn=11]="NotIn",K[K.Greater=12]="Greater",K[K.GreaterEquals=13]="GreaterEquals",K[K.Smaller=14]="Smaller",K[K.SmallerEquals=15]="SmallerEquals"})(O=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return E.INSTANCE}static true(){return f.INSTANCE}static has(L){return b.create(L)}static equals(L,B){return m.create(L,B)}static notEquals(L,B){return h.create(L,B)}static regex(L,B){return n.create(L,B)}static in(L,B){return o.create(L,B)}static notIn(L,B){return s.create(L,B)}static not(L){return p.create(L)}static and(...L){return g.create(L,null,!0)}static or(...L){return c.create(L,null,!0)}static greater(L,B){return A.create(L,B)}static greaterEquals(L,B){return v.create(L,B)}static smaller(L,B){return i.create(L,B)}static smallerEquals(L,B){return d.create(L,B)}static deserialize(L,B=!1){if(!!L)return this.c(L,B)}static c(L,B){const P=L.split("||");return c.create(P.map(F=>this.d(F,B)),null,!0)}static d(L,B){const P=L.split("&&");return g.create(P.map(F=>this.f(F,B)),null,!0)}static f(L,B){if(L=L.trim(),L.indexOf("!=")>=0){const P=L.split("!=");return h.create(P[0].trim(),this.g(P[1],B))}if(L.indexOf("==")>=0){const P=L.split("==");return m.create(P[0].trim(),this.g(P[1],B))}if(L.indexOf("=~")>=0){const P=L.split("=~");return n.create(P[0].trim(),this.h(P[1],B))}if(L.indexOf(" not in ")>=0){const P=L.split(" not in ");return s.create(P[0].trim(),this.g(P[1],B))}if(L.indexOf(" in ")>=0){const P=L.split(" in ");return o.create(P[0].trim(),this.g(P[1],B))}if(/^[^<=>]+>=[^<=>]+$/.test(L)){const P=L.split(">=");return v.create(P[0].trim(),P[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(L)){const P=L.split(">");return A.create(P[0].trim(),P[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(L)){const P=L.split("<=");return d.create(P[0].trim(),P[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(L)){const P=L.split("<");return i.create(P[0].trim(),P[1].trim())}return/^\!\s*/.test(L)?p.create(L.substr(1).trim()):b.create(L)}static g(L,B){if(L=L.trim(),L==="true")return!0;if(L==="false")return!1;const P=/^'([^']*)'$/.exec(L);return P?P[1].trim():L}static h(L,B){if((0,k.isFalsyOrWhitespace)(L)){if(B)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const P=L.indexOf("/"),F=L.lastIndexOf("/");if(P===F||P<0){if(B)throw new Error(`bad regexp-value '${L}', missing /-enclosure`);return console.warn(`bad regexp-value '${L}', missing /-enclosure`),null}const H=L.slice(P+1,F),j=L[F+1]==="i"?"i":"";try{return new RegExp(H,j)}catch(le){if(B)throw new Error(`bad regexp-value '${L}', parse error: ${le}`);return console.warn(`bad regexp-value '${L}', parse error: ${le}`),null}}}e.ContextKeyExpr=y;function T(K,L){const B=K?K.substituteConstants():void 0,P=L?L.substituteConstants():void 0;return!B&&!P?!0:!B||!P?!1:B.equals(P)}e.expressionsAreEqualWithConstantSubstitution=T;function N(K,L){return K.cmp(L)}class E{constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return f.INSTANCE}}e.ContextKeyFalseExpr=E,E.INSTANCE=new E;class f{constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return E.INSTANCE}}e.ContextKeyTrueExpr=f,f.INSTANCE=new f;class b{static create(L,B=null){const P=M.get(L);return typeof P=="boolean"?P?f.INSTANCE:E.INSTANCE:new b(L,B)}constructor(L,B){this.key=L,this.c=B,this.type=2}cmp(L){return L.type!==this.type?this.type-L.type:l(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=M.get(this.key);return typeof L=="boolean"?L?f.INSTANCE:E.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.c||(this.c=p.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=b;class m{static create(L,B,P=null){if(typeof B=="boolean")return B?b.create(L,P):p.create(L,P);const F=M.get(L);return typeof F=="boolean"?B===(F?"true":"false")?f.INSTANCE:E.INSTANCE:new m(L,B,P)}constructor(L,B,P){this.c=L,this.d=B,this.f=P,this.type=4}cmp(L){return L.type!==this.type?this.type-L.type:C(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=M.get(this.c);if(typeof L=="boolean"){const B=L?"true":"false";return this.d===B?f.INSTANCE:E.INSTANCE}return this}evaluate(L){return L.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(L){return L.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=m;class o{static create(L,B){return new o(L,B)}constructor(L,B){this.d=L,this.f=B,this.type=10,this.c=null}cmp(L){return L.type!==this.type?this.type-L.type:C(this.d,this.f,L.d,L.f)}equals(L){return L.type===this.type?this.d===L.d&&this.f===L.f:!1}substituteConstants(){return this}evaluate(L){const B=L.getValue(this.f),P=L.getValue(this.d);return Array.isArray(B)?B.includes(P):typeof P=="string"&&typeof B=="object"&&B!==null?S.call(B,P):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(L){return L.mapIn(this.d,this.f)}negate(){return this.c||(this.c=s.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=o;class s{static create(L,B){return new s(L,B)}constructor(L,B){this.d=L,this.f=B,this.type=11,this.c=o.create(L,B)}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(L){return L.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=s;class h{static create(L,B,P=null){if(typeof B=="boolean")return B?p.create(L,P):b.create(L,P);const F=M.get(L);return typeof F=="boolean"?B===(F?"true":"false")?E.INSTANCE:f.INSTANCE:new h(L,B,P)}constructor(L,B,P){this.c=L,this.d=B,this.f=P,this.type=5}cmp(L){return L.type!==this.type?this.type-L.type:C(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=M.get(this.c);if(typeof L=="boolean"){const B=L?"true":"false";return this.d===B?E.INSTANCE:f.INSTANCE}return this}evaluate(L){return L.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(L){return L.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=m.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=h;class p{static create(L,B=null){const P=M.get(L);return typeof P=="boolean"?P?E.INSTANCE:f.INSTANCE:new p(L,B)}constructor(L,B){this.c=L,this.d=B,this.type=3}cmp(L){return L.type!==this.type?this.type-L.type:l(this.c,L.c)}equals(L){return L.type===this.type?this.c===L.c:!1}substituteConstants(){const L=M.get(this.c);return typeof L=="boolean"?L?E.INSTANCE:f.INSTANCE:this}evaluate(L){return!L.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(L){return L.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.ContextKeyNotExpr=p;function w(K,L){if(typeof K=="string"){const B=parseFloat(K);isNaN(B)||(K=B)}return typeof K=="string"||typeof K=="number"?L(K):E.INSTANCE}class A{static create(L,B,P=null){return w(B,F=>new A(L,F,P))}constructor(L,B,P){this.c=L,this.d=B,this.f=P,this.type=12}cmp(L){return L.type!==this.type?this.type-L.type:C(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=d.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=A;class v{static create(L,B,P=null){return w(B,F=>new v(L,F,P))}constructor(L,B,P){this.c=L,this.d=B,this.f=P,this.type=13}cmp(L){return L.type!==this.type?this.type-L.type:C(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=i.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=v;class i{static create(L,B,P=null){return w(B,F=>new i(L,F,P))}constructor(L,B,P){this.c=L,this.d=B,this.f=P,this.type=14}cmp(L){return L.type!==this.type?this.type-L.type:C(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=i;class d{static create(L,B,P=null){return w(B,F=>new d(L,F,P))}constructor(L,B,P){this.c=L,this.d=B,this.f=P,this.type=15}cmp(L){return L.type!==this.type?this.type-L.type:C(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=d;class n{static create(L,B){return new n(L,B)}constructor(L,B){this.d=L,this.f=B,this.type=7,this.c=null}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.d<L.d)return-1;if(this.d>L.d)return 1;const B=this.f?this.f.source:"",P=L.f?L.f.source:"";return B<P?-1:B>P?1:0}equals(L){if(L.type===this.type){const B=this.f?this.f.source:"",P=L.f?L.f.source:"";return this.d===L.d&&B===P}return!1}substituteConstants(){return this}evaluate(L){const B=L.getValue(this.d);return this.f?this.f.test(B):!1}serialize(){const L=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${L}`}keys(){return[this.d]}map(L){return L.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=a.create(this)),this.c}}e.ContextKeyRegexExpr=n;class a{static create(L){return new a(L)}constructor(L){this.c=L,this.type=8}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(L){return new a(this.c.map(L))}negate(){return this.c}}e.ContextKeyNotRegexExpr=a;function t(K){let L=null;for(let B=0,P=K.length;B<P;B++){const F=K[B].substituteConstants();if(K[B]!==F&&L===null){L=[];for(let H=0;H<B;H++)L[H]=K[H]}L!==null&&(L[B]=F)}return L===null?K:L}class g{static create(L,B,P){return g.d(L,B,P)}constructor(L,B){this.expr=L,this.c=B,this.type=6}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let B=0,P=this.expr.length;B<P;B++){const F=N(this.expr[B],L.expr[B]);if(F!==0)return F}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let B=0,P=this.expr.length;B<P;B++)if(!this.expr[B].equals(L.expr[B]))return!1;return!0}return!1}substituteConstants(){const L=t(this.expr);return L===this.expr?this:g.create(L,this.c,!1)}evaluate(L){for(let B=0,P=this.expr.length;B<P;B++)if(!this.expr[B].evaluate(L))return!1;return!0}static d(L,B,P){const F=[];let H=!1;for(const j of L)if(!!j){if(j.type===1){H=!0;continue}if(j.type===0)return E.INSTANCE;if(j.type===6){F.push(...j.expr);continue}F.push(j)}if(F.length===0&&H)return f.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(N);for(let j=1;j<F.length;j++)F[j-1].equals(F[j])&&(F.splice(j,1),j--);if(F.length===1)return F[0];for(;F.length>1;){const j=F[F.length-1];if(j.type!==9)break;F.pop();const le=F.pop(),_=F.length===0,be=c.create(j.expr.map(de=>g.create([de,le],null,P)),null,_);be&&(F.push(be),F.sort(N))}if(F.length===1)return F[0];if(P){for(let j=0;j<F.length;j++)for(let le=j+1;le<F.length;le++)if(F[j].negate().equals(F[le]))return E.INSTANCE;if(F.length===1)return F[0]}return new g(F,B)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(const B of this.expr)L.push(...B.keys());return L}map(L){return new g(this.expr.map(B=>B.map(L)),null)}negate(){if(!this.c){const L=[];for(const B of this.expr)L.push(B.negate());this.c=c.create(L,this,!0)}return this.c}}class c{static create(L,B,P){return c.d(L,B,P)}constructor(L,B){this.expr=L,this.c=B,this.type=9}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let B=0,P=this.expr.length;B<P;B++){const F=N(this.expr[B],L.expr[B]);if(F!==0)return F}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let B=0,P=this.expr.length;B<P;B++)if(!this.expr[B].equals(L.expr[B]))return!1;return!0}return!1}substituteConstants(){const L=t(this.expr);return L===this.expr?this:c.create(L,this.c,!1)}evaluate(L){for(let B=0,P=this.expr.length;B<P;B++)if(this.expr[B].evaluate(L))return!0;return!1}static d(L,B,P){let F=[],H=!1;if(L){for(let j=0,le=L.length;j<le;j++){const _=L[j];if(!!_){if(_.type===0){H=!0;continue}if(_.type===1)return f.INSTANCE;if(_.type===9){F=F.concat(_.expr);continue}F.push(_)}}if(F.length===0&&H)return E.INSTANCE;F.sort(N)}if(F.length!==0){if(F.length===1)return F[0];for(let j=1;j<F.length;j++)F[j-1].equals(F[j])&&(F.splice(j,1),j--);if(F.length===1)return F[0];if(P){for(let j=0;j<F.length;j++)for(let le=j+1;le<F.length;le++)if(F[j].negate().equals(F[le]))return f.INSTANCE;if(F.length===1)return F[0]}return new c(F,B)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(const B of this.expr)L.push(...B.keys());return L}map(L){return new c(this.expr.map(B=>B.map(L)),null)}negate(){if(!this.c){const L=[];for(const B of this.expr)L.push(B.negate());for(;L.length>1;){const B=L.shift(),P=L.shift(),F=[];for(const H of ee(B))for(const j of ee(P))F.push(g.create([H,j],null,!1));L.unshift(c.create(F,null,!1))}this.c=c.create(L,this,!0)}return this.c}}class u extends b{static all(){return u.d.values()}constructor(L,B,P){super(L,null),this.f=B,typeof P=="object"?u.d.push({...P,key:L}):P!==!0&&u.d.push({key:L,description:P,type:B!=null?typeof B:void 0})}bindTo(L){return L.createKey(this.key,this.f)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return m.create(this.key,L)}notEqualsTo(L){return h.create(this.key,L)}}e.RawContextKey=u,u.d=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService");function l(K,L){return K<L?-1:K>L?1:0}function C(K,L,B,P){return K<B?-1:K>B?1:L<P?-1:L>P?1:0}function R(K,L){if(K.type===0||L.type===1)return!0;if(K.type===9)return L.type===9?V(K.expr,L.expr):!1;if(L.type===9){for(const B of L.expr)if(R(K,B))return!0;return!1}if(K.type===6){if(L.type===6)return V(L.expr,K.expr);for(const B of K.expr)if(R(B,L))return!0;return!1}return K.equals(L)}e.implies=R;function V(K,L){let B=0,P=0;for(;B<K.length&&P<L.length;){const F=K[B].cmp(L[P]);if(F<0)return!1;F===0&&B++,P++}return B===K.length}function ee(K){return K.type===9?K.expr:[K]}}),define(Ce[158],ke([1,0,3]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,r.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,r.refineServiceDecorator)(e.IEnvironmentService)}),define(Ce[90],ke([1,0,133,3]),function(ie,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough";function D(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function M(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=M;function S(h,p){switch(h){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=S;function O(h,p){return p==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=O;function y(h,p,w){return O(p,w)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===w?!0:T(w).includes(h)}e.isTargetPlatformCompatible=y;function T(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=T;function N(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=N;var E;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var f;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(f=e.SortOrder||(e.SortOrder={}));var b;(function(h){h.Install="install",h.Uninstall="uninstall"})(b=e.StatisticType||(e.StatisticType={}));var m;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(m=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService");var o;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Internal="Internal",h.Signature="Signature"})(o=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class s extends Error{constructor(p,w){super(p),this.code=w,this.name=w}}e.ExtensionManagementError=s,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,r.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,r.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Ce[43],ke([1,0,47,19,10,9,2,135,3,20]),function(ie,e,r,k,D,M,S,O,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function N(_){return _.create===!0}e.isFileOpenForWriteOptions=N;var E;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(E=e.FileType||(e.FileType={}));var f;(function(_){_[_.Readonly=1]="Readonly"})(f=e.FilePermission||(e.FilePermission={}));var b;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileClone=32768]="FileClone"})(b=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(_){return!!(_.capabilities&2)}e.hasReadWriteCapability=m;function o(_){return!!(_.capabilities&8)}e.hasFileFolderCopyCapability=o;function s(_){return!!(_.capabilities&32768)}e.hasFileCloneCapability=s;function h(_){return!!(_.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function p(_){return!!(_.capabilities&16)}e.hasFileReadStreamCapability=p;function w(_){return m(_)?!!(_.capabilities&16384):!1}e.hasFileAtomicReadCapability=w;var A;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(A=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class v extends Error{constructor(be,de){super(be),this.code=de}}e.FileSystemProviderError=v;function i(_,be){const de=new v(_.toString(),be);return n(de,be),de}e.createFileSystemProviderError=i;function d(_){return _||i((0,O.localize)(0,null),A.Unknown)}e.ensureFileSystemProviderError=d;function n(_,be){return _.name=be?`${be} (FileSystemError)`:"FileSystemError",_}e.markAsFileSystemProviderError=n;function a(_){if(!_)return A.Unknown;if(_ instanceof v)return _.code;const be=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!be)return A.Unknown;switch(be[1]){case A.FileExists:return A.FileExists;case A.FileIsADirectory:return A.FileIsADirectory;case A.FileNotADirectory:return A.FileNotADirectory;case A.FileNotFound:return A.FileNotFound;case A.FileExceedsMemoryLimit:return A.FileExceedsMemoryLimit;case A.FileTooLarge:return A.FileTooLarge;case A.FileWriteLocked:return A.FileWriteLocked;case A.NoPermissions:return A.NoPermissions;case A.Unavailable:return A.Unavailable}return A.Unknown}e.toFileSystemProviderErrorCode=a;function t(_){if(_ instanceof R)return _.fileOperationResult;switch(a(_)){case A.FileNotFound:return 1;case A.FileIsADirectory:return 0;case A.FileNotADirectory:return 10;case A.FileWriteLocked:return 5;case A.NoPermissions:return 6;case A.FileExists:return 4;case A.FileExceedsMemoryLimit:return 9;case A.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var g;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(g=e.FileOperation||(e.FileOperation={}));class c{constructor(be,de,ue){this.resource=be,this.operation=de,this.target=ue}isOperation(be){return this.operation===be}}e.FileOperationEvent=c;var u;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class l{constructor(be,de){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ue=new Map;for(const se of be){const J=ue.get(se.type);switch(J?J.push([se.resource,se]):ue.set(se.type,[[se.resource,se]]),se.type){case 1:this.rawAdded.push(se.resource);break;case 0:this.rawUpdated.push(se.resource);break;case 2:this.rawDeleted.push(se.resource);break}}for(const[se,J]of ue)switch(se){case 1:this.a=r.TernarySearchTree.forUris(()=>de),this.a.fill(J);break;case 0:this.b=r.TernarySearchTree.forUris(()=>de),this.b.fill(J);break;case 2:this.c=r.TernarySearchTree.forUris(()=>de),this.c.fill(J);break}}contains(be,...de){return this.d(be,{includeChildren:!1},...de)}affects(be,...de){return this.d(be,{includeChildren:!0},...de)}d(be,de,...ue){if(!be)return!1;const se=ue.length>0;return!!((!se||ue.includes(1))&&(this.a?.get(be)||de.includeChildren&&this.a?.findSuperstr(be))||(!se||ue.includes(0))&&(this.b?.get(be)||de.includeChildren&&this.b?.findSuperstr(be))||(!se||ue.includes(2))&&(this.c?.findSubstr(be)||de.includeChildren&&this.c?.findSuperstr(be)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=l;function C(_,be,de){return!_||!be||_===be||be.length>_.length?!1:(be.charAt(be.length-1)!==k.sep&&(be+=k.sep),de?(0,D.startsWithIgnoreCase)(_,be):_.indexOf(be)===0)}e.isParent=C;class R extends Error{constructor(be,de,ue){super(be),this.fileOperationResult=de,this.options=ue}}e.FileOperationError=R;class V extends R{constructor(be,de,ue,se){super(be,de,se),this.fileOperationResult=de,this.size=ue}}e.TooLargeFileOperationError=V;class ee extends R{constructor(be,de,ue){super(be,2,ue),this.stat=de}}e.NotModifiedSinceFileOperationError=ee;var K;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",_[_.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(K=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var L;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(L=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function B(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.etag=B;async function P(_,be){if(!be.hasProvider(S.URI.from({scheme:_.scheme})))return new Promise(de=>{const ue=be.onDidChangeFileSystemProviderRegistrations(se=>{se.scheme===_.scheme&&se.added&&(ue.dispose(),de())})})}e.whenProviderRegistered=P,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(be){return(0,M.isNumber)(be)||(be=0),be<F.KB?(0,O.localize)(1,null,be.toFixed(0)):be<F.MB?(0,O.localize)(2,null,(be/F.KB).toFixed(2)):be<F.GB?(0,O.localize)(3,null,(be/F.MB).toFixed(2)):be<F.TB?(0,O.localize)(4,null,(be/F.GB).toFixed(2)):(0,O.localize)(5,null,(be/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;var H;(function(_){_[_.IA32=0]="IA32",_[_.OTHER=1]="OTHER"})(H=e.Arch||(e.Arch={}));function j(_){return{maxFileSize:_===0?300*F.MB:16*F.GB,maxHeapSize:_===0?700*F.MB:2*700*F.MB}}e.getPlatformFileLimits=j;function le(_){return T.isWeb?_?10*F.MB:50*F.MB:_?100*F.MB:1024*F.MB}e.getLargeFileConfirmationLimit=le}),define(Ce[67],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class r{constructor(...D){this.a=new Map;for(const[M,S]of D)this.set(M,S)}set(D,M){const S=this.a.get(D);return this.a.set(D,M),S}has(D){return this.a.has(D)}get(D){return this.a.get(D)}}e.ServiceCollection=r}),define(Ce[159],ke([1,0,16,12,6,89,157,3,67,160]),function(ie,e,r,k,D,M,S,O,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const N=!1;class E extends Error{constructor(s){super("cyclic dependency between services"),this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class f{constructor(s=new y.ServiceCollection,h=!1,p,w=N){this.f=s,this.g=h,this.h=p,this.i=w,this.o=new Set,this.f.set(O.IInstantiationService,this),this._globalGraph=w?p?._globalGraph??new S.Graph(A=>A):void 0}createChild(s){return new f(s,this.g,this,this.i)}invokeFunction(s,...h){const p=m.traceInvocation(this.i,s);let w=!1;try{return s({get:v=>{if(w)throw(0,k.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(v,p);if(!i)throw new Error(`[invokeFunction] unknown service '${v}'`);return i}},...h)}finally{w=!0,p.stop()}}createInstance(s,...h){let p,w;return s instanceof M.SyncDescriptor?(p=m.traceCreation(this.i,s.ctor),w=this.j(s.ctor,s.staticArguments.concat(h),p)):(p=m.traceCreation(this.i,s),w=this.j(s,h,p)),p.stop(),w}j(s,h=[],p){const w=O._util.getServiceDependencies(s).sort((i,d)=>i.index-d.index),A=[];for(const i of w){const d=this.m(i.id,p);d||this.u(`[createInstance] ${s.name} depends on UNKNOWN service ${i.id}.`,!1),A.push(d)}const v=w.length>0?w[0].index:h.length;if(h.length!==v){console.trace(`[createInstance] First service dependency of ${s.name} at position ${v+1} conflicts with ${h.length} static arguments`);const i=v-h.length;i>0?h=h.concat(new Array(i)):h=h.slice(0,v)}return Reflect.construct(s,h.concat(A))}k(s,h){if(this.f.get(s)instanceof M.SyncDescriptor)this.f.set(s,h);else if(this.h)this.h.k(s,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l(s){const h=this.f.get(s);return!h&&this.h?this.h.l(s):h}m(s,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(s));const p=this.l(s);return p instanceof M.SyncDescriptor?this.q(s,p,h.branch(s,!0)):(h.branch(s,!1),p)}q(s,h,p){if(this.o.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this.o.add(s);try{return this.r(s,h,p)}finally{this.o.delete(s)}}r(s,h,p){const w=new S.Graph(i=>i.id.toString());let A=0;const v=[{id:s,desc:h,_trace:p}];for(;v.length;){const i=v.pop();if(w.lookupOrInsertNode(i),A++>1e3)throw new E(w);for(const d of O._util.getServiceDependencies(i.desc.ctor)){const n=this.l(d.id);if(n||this.u(`[createInstance] ${s} depends on ${d.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(d.id)),n instanceof M.SyncDescriptor){const a={id:d.id,desc:n,_trace:i._trace.branch(d.id,!0)};w.insertEdge(i,a),v.push(a)}}}for(;;){const i=w.roots();if(i.length===0){if(!w.isEmpty())throw new E(w);break}for(const{data:d}of i){if(this.l(d.id)instanceof M.SyncDescriptor){const a=this.s(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this.k(d.id,a)}w.removeNode(d)}}return this.l(s)}s(s,h,p=[],w,A){if(this.f.get(s)instanceof M.SyncDescriptor)return this.t(s,h,p,w,A);if(this.h)return this.h.s(s,h,p,w,A);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t(s,h,p=[],w,A){if(w){const v=new f(void 0,this.g,this,this.i);v.c=String(s);const i=new Map,d=new r.IdleValue(()=>{const n=v.j(h,p,A);for(const[a,t]of i){const g=n[a];if(typeof g=="function")for(const c of t)g.apply(n,c)}return i.clear(),n});return new Proxy(Object.create(null),{get(n,a){if(!d.isInitialized&&typeof a=="string"&&(a.startsWith("onDid")||a.startsWith("onWill"))){let c=i.get(a);return c||(c=new T.LinkedList,i.set(a,c)),(l,C,R)=>{const V=c.push([l,C,R]);return(0,D.toDisposable)(V)}}if(a in n)return n[a];const t=d.value;let g=t[a];return typeof g!="function"||(g=g.bind(t),n[a]=g),g},set(n,a,t){return d.value[a]=t,!0},getPrototypeOf(n){return h.prototype}})}else return this.j(h,p,A)}u(s,h){if(h&&console.warn(s),this.g)throw new Error(s)}}e.InstantiationService=f;var b;(function(o){o[o.None=0]="None",o[o.Creation=1]="Creation",o[o.Invocation=2]="Invocation",o[o.Branch=3]="Branch"})(b||(b={}));class m{static traceInvocation(s,h){return s?new m(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(s,h){return s?new m(1,h.name):m.c}constructor(s,h){this.type=s,this.name=h,this.g=Date.now(),this.h=[]}branch(s,h){const p=new m(3,s.toString());return this.h.push([s,h,p]),p}stop(){const s=Date.now()-this.g;m.f+=s;let h=!1;function p(A,v){const i=[],d=new Array(A+1).join("	");for(const[n,a,t]of v.h)if(a&&t){h=!0,i.push(`${d}CREATES -> ${n}`);const g=p(A+1,t);g&&i.push(g)}else i.push(`${d}uses -> ${n}`);return i.join(`
`)}const w=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(s>2||h)&&m.all.add(w.join(`
`))}}e.Trace=m,m.all=new Set,m.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}},m.f=0}),define(Ce[11],ke([1,0,39,4,6,28,20,9,2,3]),function(ie,e,r,k,D,M,S,O,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.setLogLevel=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function N(){return new Date().toISOString()}function E(u){return(0,O.isNumber)(u)}e.isLogLevel=E;var f;(function(u){u[u.Off=0]="Off",u[u.Trace=1]="Trace",u[u.Debug=2]="Debug",u[u.Info=3]="Info",u[u.Warning=4]="Warning",u[u.Error=5]="Error"})(f=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=f.Info;function b(u,l,C){switch(l){case f.Trace:u.trace(C);break;case f.Debug:u.debug(C);break;case f.Info:u.info(C);break;case f.Warning:u.warn(C);break;case f.Error:u.error(C);break;case f.Off:break;default:throw new Error(`Invalid log level ${l}`)}}e.log=b;function m(u){let l="";for(let C=0;C<u.length;C++){let R=u[C];if(typeof R=="object")try{R=JSON.stringify(R)}catch{}l+=(C>0?" ":"")+R}return l}e.format=m;class o extends D.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new k.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(l){this.b!==l&&(this.b=l,this.c.fire(this.b))}getLevel(){return this.b}f(l){return this.b!==f.Off&&this.b<=l}}e.AbstractLogger=o;class s extends o{constructor(l){super(),this.h=l}f(l){return this.h||super.f(l)}trace(l,...C){this.f(f.Trace)&&this.g(f.Trace,m([l,...C]))}debug(l,...C){this.f(f.Debug)&&this.g(f.Debug,m([l,...C]))}info(l,...C){this.f(f.Info)&&this.g(f.Info,m([l,...C]))}warn(l,...C){this.f(f.Warning)&&this.g(f.Warning,m([l,...C]))}error(l,...C){if(this.f(f.Error))if(l instanceof Error){const R=Array.prototype.slice.call(arguments);R[0]=l.stack,this.g(f.Error,m(R))}else this.g(f.Error,m([l,...C]))}flush(){}}e.AbstractMessageLogger=s;class h extends o{constructor(l=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(l),this.g=!S.isWindows}trace(l,...C){this.f(f.Trace)&&(this.g?console.log(`\x1B[90m[main ${N()}]\x1B[0m`,l,...C):console.log(`[main ${N()}]`,l,...C))}debug(l,...C){this.f(f.Debug)&&(this.g?console.log(`\x1B[90m[main ${N()}]\x1B[0m`,l,...C):console.log(`[main ${N()}]`,l,...C))}info(l,...C){this.f(f.Info)&&(this.g?console.log(`\x1B[90m[main ${N()}]\x1B[0m`,l,...C):console.log(`[main ${N()}]`,l,...C))}warn(l,...C){this.f(f.Warning)&&(this.g?console.warn(`\x1B[93m[main ${N()}]\x1B[0m`,l,...C):console.warn(`[main ${N()}]`,l,...C))}error(l,...C){this.f(f.Error)&&(this.g?console.error(`\x1B[91m[main ${N()}]\x1B[0m`,l,...C):console.error(`[main ${N()}]`,l,...C))}dispose(){}flush(){}}e.ConsoleMainLogger=h;class p extends o{constructor(l=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(l)}trace(l,...C){this.f(f.Trace)&&console.log("%cTRACE","color: #888",l,...C)}debug(l,...C){this.f(f.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",l,...C)}info(l,...C){this.f(f.Info)&&console.log("%c INFO","color: #33f",l,...C)}warn(l,...C){this.f(f.Warning)&&console.log("%c WARN","color: #993",l,...C)}error(l,...C){this.f(f.Error)&&console.log("%c  ERR","color: #f33",l,...C)}dispose(){}flush(){}}e.ConsoleLogger=p;class w extends o{constructor(l,C=e.DEFAULT_LOG_LEVEL){super(),this.g=l,this.setLevel(C)}trace(l,...C){this.f(f.Trace)&&this.g.log(f.Trace,[this.h(l),...C])}debug(l,...C){this.f(f.Debug)&&this.g.log(f.Debug,[this.h(l),...C])}info(l,...C){this.f(f.Info)&&this.g.log(f.Info,[this.h(l),...C])}warn(l,...C){this.f(f.Warning)&&this.g.log(f.Warning,[this.h(l),...C])}error(l,...C){this.f(f.Error)&&this.g.log(f.Error,[this.h(l),...C])}h(l){return typeof l=="string"?l:(0,r.toErrorMessage)(l,this.f(f.Trace))}dispose(){}flush(){}}e.AdapterLogger=w;class A extends o{constructor(l){super(),this.g=l,l.length&&this.setLevel(l[0].getLevel())}setLevel(l){for(const C of this.g)C.setLevel(l);super.setLevel(l)}trace(l,...C){for(const R of this.g)R.trace(l,...C)}debug(l,...C){for(const R of this.g)R.debug(l,...C)}info(l,...C){for(const R of this.g)R.info(l,...C)}warn(l,...C){for(const R of this.g)R.warn(l,...C)}error(l,...C){for(const R of this.g)R.error(l,...C)}flush(){for(const l of this.g)l.flush()}dispose(){for(const l of this.g)l.dispose()}}e.MultiplexLogger=A;class v extends D.Disposable{constructor(l,C){if(super(),this.j=l,this.b=new M.ResourceMap,this.c=new M.ResourceMap,this.f=this.B(new k.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new k.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new k.Emitter),this.onDidChangeVisibility=this.h.event,C)for(const R of C)this.c.set(R.resource,R)}getLogger(l){return this.b.get(l)}createLogger(l,C){let R=this.b.get(l);const V=C?.logLevel==="always"?f.Trace:C?.logLevel;return R||(R=this.k(l,V??this.getLogLevel(l)??this.j,C),this.b.set(l,R)),this.registerLogger({resource:l,id:C?.id??l.toString(),logLevel:V,name:C?.name,hidden:C?.hidden,extensionId:C?.extensionId}),R}setLogLevel(l,C){if(y.URI.isUri(l)){const R=l,V=C,ee=this.c.get(R);ee&&V!==ee.logLevel&&(ee.logLevel=V===this.j?void 0:V,this.b.get(R)?.setLevel(V),this.c.set(ee.resource,ee),this.g.fire([R,V]))}else{this.j=l;for(const[R,V]of this.b.entries())this.c.get(R)?.logLevel===void 0&&V.setLevel(this.j);this.g.fire(this.j)}}setVisibility(l,C){const R=this.c.get(l);R&&C!==!R.hidden&&(R.hidden=!C,this.c.set(R.resource,R),this.h.fire([l,C]))}getLogLevel(l){let C;return l&&(C=this.c.get(l)?.logLevel),C??this.j}registerLogger(l){const C=this.c.get(l.resource);C?C.hidden!==l.hidden&&this.setVisibility(l.resource,!l.hidden):(this.c.set(l.resource,l),this.f.fire({added:[l],removed:[]}))}deregisterLogger(l){const C=this.c.get(l);if(C){this.c.delete(l);const R=this.b.get(l);R&&(this.b.delete(l),R.dispose()),this.f.fire({added:[],removed:[C]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(l){return this.c.get(l)}dispose(){this.b.forEach(l=>l.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=v;class i{constructor(){this.onDidChangeLogLevel=new k.Emitter().event}setLevel(l){}getLevel(){return f.Info}trace(l,...C){}debug(l,...C){}info(l,...C){}warn(l,...C){}error(l,...C){}critical(l,...C){}dispose(){}flush(){}}e.NullLogger=i;class d extends i{}e.NullLogService=d;class n extends v{constructor(){super(f.Info)}k(l,C,R){return new i}}e.NullLoggerService=n;function a(u){if(u.verbose)return f.Trace;if(typeof u.logLevel=="string"){const l=g(u.logLevel.toLowerCase());if(l!==void 0)return l}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function t(u){switch(u){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}e.LogLevelToString=t;function g(u){switch(u){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.parseLogLevel=g;function c(u,l){E(l)?u.setLogLevel(l):u.setLogLevel(l[0],l[1])}e.setLogLevel=c}),define(Ce[161],ke([1,0,6,11]),function(ie,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class D extends r.Disposable{constructor(S,O=[]){super(),this.a=new k.MultiplexLogger([S,...O]),this.B(S.onDidChangeLogLevel(y=>this.setLevel(y)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(S){this.a.setLevel(S)}getLevel(){return this.a.getLevel()}trace(S,...O){this.a.trace(S,...O)}debug(S,...O){this.a.debug(S,...O)}info(S,...O){this.a.info(S,...O)}warn(S,...O){this.a.warn(S,...O)}error(S,...O){this.a.error(S,...O)}flush(){this.a.flush()}}e.LogService=D}),define(Ce[91],ke([1,0,29,136,3]),function(ie,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(M=e.MarkerTag||(e.MarkerTag={}));var S;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(S=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function T(m,o){return o-m}y.compare=T;const N=Object.create(null);N[y.Error]=(0,k.localize)(0,null),N[y.Warning]=(0,k.localize)(1,null),N[y.Info]=(0,k.localize)(2,null);function E(m){return N[m]||""}y.toString=E;function f(m){switch(m){case r.default.Error:return y.Error;case r.default.Warning:return y.Warning;case r.default.Info:return y.Info;case r.default.Ignore:return y.Hint}}y.fromSeverity=f;function b(m){switch(m){case y.Error:return r.default.Error;case y.Warning:return r.default.Warning;case y.Info:return r.default.Info;case y.Hint:return r.default.Ignore}}y.toSeverity=b}(S=e.MarkerSeverity||(e.MarkerSeverity={}));var O;(function(y){const T="";function N(f){return E(f,!0)}y.makeKey=N;function E(f,b){const m=[T];return f.source?m.push(f.source.replace("\xA6","\\\xA6")):m.push(T),f.code?typeof f.code=="string"?m.push(f.code.replace("\xA6","\\\xA6")):m.push(f.code.value.replace("\xA6","\\\xA6")):m.push(T),f.severity!==void 0&&f.severity!==null?m.push(S.toString(f.severity)):m.push(T),f.message&&b?m.push(f.message.replace("\xA6","\\\xA6")):m.push(T),f.startLineNumber!==void 0&&f.startLineNumber!==null?m.push(f.startLineNumber.toString()):m.push(T),f.startColumn!==void 0&&f.startColumn!==null?m.push(f.startColumn.toString()):m.push(T),f.endLineNumber!==void 0&&f.endLineNumber!==null?m.push(f.endLineNumber.toString()):m.push(T),f.endColumn!==void 0&&f.endColumn!==null?m.push(f.endColumn.toString()):m.push(T),m.push(T),m.join("\xA6")}y.makeKeyOptionalMessage=E})(O=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,D.createDecorator)("markerService")}),define(Ce[162],ke([1,0,4,29,3]),function(ie,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=k.default,e.INotificationService=(0,D.createDecorator)("notificationService");var M;(function(T){T[T.WORKSPACE=0]="WORKSPACE",T[T.PROFILE=1]="PROFILE",T[T.APPLICATION=2]="APPLICATION"})(M=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var S;(function(T){T[T.OFF=0]="OFF",T[T.SILENT=1]="SILENT",T[T.ERROR=2]="ERROR"})(S=e.NotificationsFilter||(e.NotificationsFilter={}));class O{constructor(){this.progress=new y,this.onDidClose=r.Event.None,this.onDidChangeVisibility=r.Event.None}updateSeverity(N){}updateMessage(N){}updateActions(N){}close(){}}e.NoOpNotification=O;class y{infinite(){}done(){}total(N){}worked(N){}}e.NoOpProgress=y}),define(Ce[92],ke([1,0,10,2,3]),function(ie,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,D.createDecorator)("openerService");function M(T,N){return k.URI.isUri(T)?(0,r.equalsIgnoreCase)(T.scheme,N):(0,r.startsWithIgnoreCase)(T,N+":")}e.matchesScheme=M;function S(T,...N){return N.some(E=>M(T,E))}e.matchesSomeScheme=S;function O(T,N){return T.with({fragment:`${N.startLineNumber},${N.startColumn}${N.endLineNumber?`-${N.endLineNumber}${N.endColumn?`,${N.endColumn}`:""}`:""}`})}e.withSelection=O;function y(T){let N;const E=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(T.fragment);return E&&(N={startLineNumber:parseInt(E[1]),startColumn:E[2]?parseInt(E[2]):1,endLineNumber:E[4]?parseInt(E[4]):void 0,endColumn:E[4]?E[5]?parseInt(E[5]):1:void 0},T=T.with({fragment:""})),{selection:N,uri:T}}e.extractSelection=y}),define(Ce[163],ke([1,0,3]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,r.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var qe=this&&this.__decorate||function(ie,e,r,k){var D=arguments.length,M=D<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,r):k,S;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(ie,e,r,k);else for(var O=ie.length-1;O>=0;O--)(S=ie[O])&&(M=(D<3?S(M):D>3?S(e,r,M):S(e,r))||M);return D>3&&M&&Object.defineProperty(e,r,M),M},je=this&&this.__param||function(ie,e){return function(r,k){e(r,k,ie)}};define(Ce[164],ke([1,0,16,21,6,3]),function(ie,e,r,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,M.createDecorator)("progressService");var S;(function(N){N[N.Explorer=1]="Explorer",N[N.Scm=3]="Scm",N[N.Extensions=5]="Extensions",N[N.Window=10]="Window",N[N.Notification=15]="Notification",N[N.Dialog=20]="Dialog"})(S=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class O{get value(){return this.a}constructor(E){this.b=E}report(E){this.a=E,this.b(this.a)}}e.Progress=O,O.None=Object.freeze({report(){}});let y=class extends D.Disposable{constructor(E,f){super(),this.a=new r.DeferredPromise,f.withProgress(E,b=>(this.b=b,this.c&&b.report(this.c),this.a.p)),this.B((0,D.toDisposable)(()=>this.a.complete()))}report(E){this.b?this.b.report(E):this.c=E}};y=qe([je(1,e.IProgressService)],y),e.UnmanagedProgress=y;class T extends D.Disposable{constructor(E){super(),this.g=E,this.a=0,this.b=this.B(new D.DisposableStore)}start(E){this.stop();const f=++this.a,b=new k.CancellationTokenSource;return this.f=setTimeout(()=>{f===this.a&&(this.c=this.g.show(!0))},E),this.b.add((0,D.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,D.toDisposable)(()=>b.cancel())),this.b.add((0,D.toDisposable)(()=>this.c?this.c.done():void 0)),{id:f,token:b.token,stop:()=>this.h(f),isCurrent:()=>this.a===f}}stop(){this.h(this.a)}h(E){this.a===E&&this.b.clear()}}e.LongRunningOperation=T,e.IEditorProgressService=(0,M.createDecorator)("editorProgressService")}),define(Ce[30],ke([1,0,48,9]),function(ie,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.a=new Map}add(S,O){r.ok(k.isString(S)),r.ok(k.isObject(O)),r.ok(!this.a.has(S),"There is already an extension with this id"),this.a.set(S,O)}knows(S){return this.a.has(S)}as(S){return this.a.get(S)||null}}e.Registry=new D}),define(Ce[68],ke([1,0,4,30]),function(ie,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(O){return O.length>0&&O.charAt(O.length-1)==="#"?O.substring(0,O.length-1):O}class M{constructor(){this.b=new r.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(y,T){this.a[D(y)]=T,this.b.fire(y)}notifySchemaChanged(y){this.b.fire(y)}getSchemaContributions(){return{schemas:this.a}}}const S=new M;k.Registry.add(e.Extensions.JSONContribution,S)}),define(Ce[93],ke([1,0,18,4,9,132,41,68,30]),function(ie,e,r,k,D,M,S,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var T;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(T=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var N;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(N=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const E=y.Registry.as(O.Extensions.JSONContribution);class f{constructor(){this.h=new Set,this.i=new k.Emitter,this.onDidSchemaChange=this.i.event,this.j=new k.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(i,d=!0){this.registerConfigurations([i],d)}registerConfigurations(i,d=!0){const n=new Set;this.n(i,d,n),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(i){const d=new Set;this.o(i,d),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:d})}updateConfigurations({add:i,remove:d}){const n=new Set;this.o(d,n),this.n(i,!1,n),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(i){const d=new Set;this.k(i,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:!0})}k(i,d){const n=[];for(const{overrides:a,source:t}of i)for(const g in a)if(d.add(g),e.OVERRIDE_PROPERTY_REGEX.test(g)){const c=this.a.get(g),u=c?.valuesSources??new Map;if(t)for(const V of Object.keys(a[g]))u.set(V,t);const l={...c?.value||{},...a[g]};this.a.set(g,{source:t,value:l,valuesSources:u});const C=(0,S.getLanguageTagSettingPlainKey)(g),R={type:"object",default:l,description:M.localize(1,null,C),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:l,source:D.isString(t)?void 0:t,defaultValueSource:t};n.push(...o(g)),this.d[g]=R,this.b.properties[g]=R}else{this.a.set(g,{value:a[g],source:t});const c=this.d[g];c&&(this.w(g,c),this.r(g,c))}this.m(n)}deregisterDefaultConfigurations(i){const d=new Set;this.l(i,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:!0})}l(i,d){for(const{overrides:n,source:a}of i)for(const t in n){const g=this.a.get(t),c=D.isString(a)?a:a?.id,u=D.isString(g?.source)?g?.source:g?.source?.id;if(c===u)if(d.add(t),this.a.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.d[t],delete this.b.properties[t];else{const l=this.d[t];l&&(this.w(t,l),this.r(t,l))}}this.u()}deltaConfiguration(i){let d=!1;const n=new Set;i.removedDefaults&&(this.l(i.removedDefaults,n),d=!0),i.addedDefaults&&(this.k(i.addedDefaults,n),d=!0),i.removedConfigurations&&this.o(i.removedConfigurations,n),i.addedConfigurations&&this.n(i.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:d})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const d of i)this.h.add(d);this.u()}n(i,d,n){i.forEach(a=>{this.p(a,d,a.extensionInfo,a.restrictedProperties,void 0,n),this.c.push(a),this.q(a)})}o(i,d){const n=a=>{if(a.properties)for(const t in a.properties){d.add(t);const g=this.d[t];g?.policy?.name&&this.e.delete(g.policy.name),delete this.d[t],this.s(t,a.properties[t])}a.allOf?.forEach(t=>n(t))};for(const a of i){n(a);const t=this.c.indexOf(a);t!==-1&&this.c.splice(t,1)}}p(i,d=!0,n,a,t=3,g){t=D.isUndefinedOrNull(i.scope)?t:i.scope;const c=i.properties;if(c)for(const l in c){const C=c[l];if(d&&w(l,C)){delete c[l];continue}if(C.source=n,C.defaultDefaultValue=c[l].default,this.w(l,C),e.OVERRIDE_PROPERTY_REGEX.test(l)?C.scope=void 0:(C.scope=D.isUndefinedOrNull(C.scope)?t:C.scope,C.restricted=D.isUndefinedOrNull(C.restricted)?!!a?.includes(l):C.restricted),c[l].hasOwnProperty("included")&&!c[l].included){this.f[l]=c[l],delete c[l];continue}else this.d[l]=c[l],c[l].policy?.name&&this.e.set(c[l].policy.name,l);!c[l].deprecationMessage&&c[l].markdownDeprecationMessage&&(c[l].deprecationMessage=c[l].markdownDeprecationMessage),g.add(l)}const u=i.allOf;if(u)for(const l of u)this.p(l,d,n,a,t,g)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const d=n=>{const a=n.properties;if(a)for(const g in a)this.r(g,a[g]);n.allOf?.forEach(d)};d(i)}r(i,d){switch(e.allSettings.properties[i]=d,d.scope){case 1:e.applicationSettings.properties[i]=d;break;case 2:e.machineSettings.properties[i]=d;break;case 6:e.machineOverridableSettings.properties[i]=d;break;case 3:e.windowSettings.properties[i]=d;break;case 4:e.resourceSettings.properties[i]=d;break;case 5:e.resourceSettings.properties[i]=d,this.g.properties[i]=d;break}}s(i,d){switch(delete e.allSettings.properties[i],d.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const d=`[${i}]`,n={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(d,n),e.allSettings.properties[d]=n,e.applicationSettings.properties[d]=n,e.machineSettings.properties[d]=n,e.machineOverridableSettings.properties[d]=n,e.windowSettings.properties[d]=n,e.resourceSettings.properties[d]=n}}v(){const i={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}w(i,d){const n=this.a.get(i);let a=n?.value,t=n?.source;D.isUndefined(a)&&(a=d.defaultDefaultValue,t=void 0),D.isUndefined(a)&&(a=h(d.type)),d.default=a,d.defaultValueSource=t}}const b="\\[([^\\]]+)\\]",m=new RegExp(b,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${b})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function o(v){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(v)){let d=m.exec(v);for(;d?.length;){const n=d[1].trim();n&&i.push(n),d=m.exec(v)}}return(0,r.distinct)(i)}e.overrideIdentifiersFromKey=o;function s(v){return v.reduce((i,d)=>`${i}[${d}]`,"")}e.keyFromOverrideIdentifiers=s;function h(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const p=new f;y.Registry.add(e.Extensions.Configuration,p);function w(v,i){return v.trim()?e.OVERRIDE_PROPERTY_REGEX.test(v)?M.localize(7,null,v):p.getConfigurationProperties()[v]!==void 0?M.localize(8,null,v):i.policy?.name&&p.getPolicyConfigurations().get(i.policy?.name)!==void 0?M.localize(9,null,v,i.policy?.name,p.getPolicyConfigurations().get(i.policy?.name)):null:M.localize(6,null)}e.validateProperty=w;function A(){const v=[],i=p.getConfigurationProperties();for(const d of Object.keys(i))v.push([d,i[d].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.getScopes=A}),define(Ce[165],ke([1,0,18,4,111,6,28,22,9,2,41,93,30]),function(ie,e,r,k,D,M,S,O,y,T,N,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function b(d){return Object.isFrozen(d)?d:O.deepFreeze(d)}class m{constructor(n={},a=[],t=[],g){this.b=n,this.c=a,this.d=t,this.raw=g,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(a=>{if(a instanceof m)return a;const t=new o("");return t.parseRaw(a),t.configurationModel});this.f=n.reduce((a,t)=>t===a?t:a.merge(t),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,N.getConfigurationValue)(this.contents,n):this.contents}inspect(n,a){const t=this.rawConfiguration.getValue(n),g=a?this.rawConfiguration.getOverrideValue(n,a):void 0,c=a?this.rawConfiguration.override(a).getValue(n):t;return{value:t,override:g,merged:c}}getOverrideValue(n,a){const t=this.i(a);return t?n?(0,N.getConfigurationValue)(t,n):t:void 0}getKeysForOverrideIdentifier(n){const a=[];for(const t of this.overrides)t.identifiers.includes(n)&&a.push(...t.keys);return r.distinct(a)}getAllOverrideIdentifiers(){const n=[];for(const a of this.overrides)n.push(...a.identifiers);return r.distinct(n)}override(n){let a=this.a.get(n);return a||(a=this.g(n),this.a.set(n,a)),a}merge(...n){const a=O.deepClone(this.contents),t=O.deepClone(this.overrides),g=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const u of n)if(c.push(...u.raw?.length?u.raw:[u]),!u.isEmpty()){this.h(a,u.contents);for(const l of u.overrides){const[C]=t.filter(R=>r.equals(R.identifiers,l.identifiers));C?(this.h(C.contents,l.contents),C.keys.push(...l.keys),C.keys=r.distinct(C.keys)):t.push(O.deepClone(l))}for(const l of u.keys)g.indexOf(l)===-1&&g.push(l)}return new m(a,g,t,c.every(u=>u instanceof m)?void 0:c)}g(n){const a=this.i(n);if(!a||typeof a!="object"||!Object.keys(a).length)return this;const t={};for(const g of r.distinct([...Object.keys(this.contents),...Object.keys(a)])){let c=this.contents[g];const u=a[g];u&&(typeof c=="object"&&typeof u=="object"?(c=O.deepClone(c),this.h(c,u)):c=u),t[g]=c}return new m(t,this.keys,this.overrides)}h(n,a){for(const t of Object.keys(a)){if(t in n&&y.isObject(n[t])&&y.isObject(a[t])){this.h(n[t],a[t]);continue}n[t]=O.deepClone(a[t])}}i(n){let a=null,t=null;const g=c=>{c&&(t?this.h(t,c):t=O.deepClone(c))};for(const c of this.overrides)r.equals(c.identifiers,[n])?a=c.contents:c.identifiers.includes(n)&&g(c.contents);return g(a),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,a){this.j(n,a,!0)}setValue(n,a){this.j(n,a,!1)}removeValue(n){const a=this.keys.indexOf(n);a!==-1&&(this.keys.splice(a,1),(0,N.removeFromValueTree)(this.contents,n),E.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.splice(this.overrides.findIndex(t=>r.equals(t.identifiers,(0,E.overrideIdentifiersFromKey)(n))),1))}j(n,a,t){(0,N.addToValueTree)(this.contents,n,a,g=>console.error(g)),t=t||this.keys.indexOf(n)===-1,t&&this.keys.push(n),E.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.push({identifiers:(0,E.overrideIdentifiersFromKey)(n),keys:Object.keys(this.contents[n]),contents:(0,N.toValuesTree)(this.contents[n],g=>console.error(g))})}}e.ConfigurationModel=m;class o{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new m}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,a){if(!y.isUndefinedOrNull(n)){const t=this.g(n);this.parseRaw(t,a)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,a){this.a=n;const{contents:t,keys:g,overrides:c,restricted:u,hasExcludedProperties:l}=this.h(n,a);this.b=new m(t,g,c,l?[n]:void 0),this.c=u||[]}g(n){let a={},t=null,g=[];const c=[],u=[];function l(R){Array.isArray(g)?g.push(R):t!==null&&(g[t]=R)}const C={onObjectBegin:()=>{const R={};l(R),c.push(g),g=R,t=null},onObjectProperty:R=>{t=R},onObjectEnd:()=>{g=c.pop()},onArrayBegin:()=>{const R=[];l(R),c.push(g),g=R,t=null},onArrayEnd:()=>{g=c.pop()},onLiteralValue:l,onError:(R,V,ee)=>{u.push({error:R,offset:V,length:ee})}};if(n)try{D.visit(n,C),a=g[0]||{}}catch(R){console.error(`Error while parsing settings file ${this.f}: ${R}`),this.d=[R]}return a}h(n,a){const t=f.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),g=this.i(n,t,!0,a);n=g.raw;const c=(0,N.toValuesTree)(n,C=>console.error(`Conflict in settings file ${this.f}: ${C}`)),u=Object.keys(n),l=this.j(n,C=>console.error(`Conflict in settings file ${this.f}: ${C}`));return{contents:c,keys:u,overrides:l,restricted:g.restricted,hasExcludedProperties:g.hasExcludedProperties}}i(n,a,t,g){let c=!1;if(!g?.scopes&&!g?.skipRestricted)return{raw:n,restricted:[],hasExcludedProperties:c};const u={},l=[];for(const C in n)if(E.OVERRIDE_PROPERTY_REGEX.test(C)&&t){const R=this.i(n[C],a,!1,g);u[C]=R.raw,c=c||R.hasExcludedProperties,l.push(...R.restricted)}else{const R=a[C],V=R?typeof R.scope<"u"?R.scope:3:void 0;R?.restricted&&l.push(C),(V===void 0||g.scopes===void 0||g.scopes.includes(V))&&!(g.skipRestricted&&R?.restricted)?u[C]=n[C]:c=!0}return{raw:u,restricted:l,hasExcludedProperties:c}}j(n,a){const t=[];for(const g of Object.keys(n))if(E.OVERRIDE_PROPERTY_REGEX.test(g)){const c={};for(const u in n[g])c[u]=n[g][u];t.push({identifiers:(0,E.overrideIdentifiersFromKey)(g),keys:Object.keys(c),contents:(0,N.toValuesTree)(c,a)})}return t}}e.ConfigurationModelParser=o;class s extends M.Disposable{constructor(n,a,t,g){super(),this.f=n,this.g=a,this.h=g,this.c=this.B(new k.Emitter),this.onDidChange=this.c.event,this.a=new o(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(t.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(k.Event.any(k.Event.filter(this.h.onDidFilesChange,c=>c.contains(this.f)),k.Event.filter(this.h.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&t.isEqual(c.resource,n)))(()=>this.c.fire()))}async loadConfiguration(){try{const n=await this.h.readFile(this.f);return this.a.parse(n.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new m}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=s;class h{constructor(n,a,t,g,c,u,l,C,R,V,ee,K,L){this.a=n,this.b=a,this.c=t,this.overrideIdentifiers=g,this.d=c,this.f=u,this.g=l,this.h=C,this.i=R,this.j=V,this.k=ee,this.l=K,this.m=L}get value(){return b(this.c)}n(n,a,t){const g=n.inspect(a,t);return{get value(){return b(g.value)},get override(){return b(g.override)},get merged(){return b(g.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class p{constructor(n,a,t,g,c=new m,u=new m,l=new S.ResourceMap,C=new m,R=new S.ResourceMap){this.c=n,this.d=a,this.f=t,this.g=g,this.h=c,this.i=u,this.j=l,this.l=C,this.m=R,this.a=null,this.b=new S.ResourceMap,this.n=null}getValue(n,a,t){return this.q(n,a,t).getValue(n)}updateValue(n,a,t={}){let g;t.resource?(g=this.m.get(t.resource),g||(g=new m,this.m.set(t.resource,g))):g=this.l,a===void 0?g.removeValue(n):g.setValue(n,a),t.resource||(this.a=null)}inspect(n,a,t){const g=this.q(n,a,t),c=this.u(a.resource,t),u=a.resource?this.m.get(a.resource)||this.l:this.l,l=new Set;for(const C of g.overrides)for(const R of C.identifiers)g.getOverrideValue(n,R)!==void 0&&l.add(R);return new h(n,a,g.getValue(n),l.size?[...l]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this.i:void 0,c||void 0,u)}keys(n){const a=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:a?a.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,a){this.j.set(n,a),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,a){const t=[];if(!a){const{added:g,updated:c,removed:u}=v(this.c,n);a=[...g,...c,...u]}for(const g of a)for(const c of(0,E.overrideIdentifiersFromKey)(g)){const u=this.c.getKeysForOverrideIdentifier(c),l=n.getKeysForOverrideIdentifier(c),C=[...l.filter(R=>u.indexOf(R)===-1),...u.filter(R=>l.indexOf(R)===-1),...u.filter(R=>!O.equals(this.c.override(c).getValue(R),n.override(c).getValue(R)))];t.push([c,C])}return this.updateDefaultConfiguration(n),{keys:a,overrides:t}}compareAndUpdatePolicyConfiguration(n){const{added:a,updated:t,removed:g}=v(this.d,n),c=[...a,...t,...g];return c.length&&this.updatePolicyConfiguration(n),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:a,updated:t,removed:g,overrides:c}=v(this.applicationConfiguration,n),u=[...a,...t,...g];return u.length&&this.updateApplicationConfiguration(n),{keys:u,overrides:c}}compareAndUpdateLocalUserConfiguration(n){const{added:a,updated:t,removed:g,overrides:c}=v(this.localUserConfiguration,n),u=[...a,...t,...g];return u.length&&this.updateLocalUserConfiguration(n),{keys:u,overrides:c}}compareAndUpdateRemoteUserConfiguration(n){const{added:a,updated:t,removed:g,overrides:c}=v(this.remoteUserConfiguration,n),u=[...a,...t,...g];return u.length&&this.updateRemoteUserConfiguration(n),{keys:u,overrides:c}}compareAndUpdateWorkspaceConfiguration(n){const{added:a,updated:t,removed:g,overrides:c}=v(this.workspaceConfiguration,n),u=[...a,...t,...g];return u.length&&this.updateWorkspaceConfiguration(n),{keys:u,overrides:c}}compareAndUpdateFolderConfiguration(n,a){const t=this.p.get(n),{added:g,updated:c,removed:u,overrides:l}=v(t,a),C=[...g,...c,...u];return(C.length||!t)&&this.updateFolderConfiguration(n,a),{keys:C,overrides:l}}compareAndDeleteFolderConfiguration(n){const a=this.p.get(n);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:t,updated:g,removed:c,overrides:u}=v(a,void 0);return{keys:[...t,...g,...c],overrides:u}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,a,t){let g=this.r(a,t);return a.overrideIdentifier&&(g=g.override(a.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(g=g.merge(this.d)),g}r({resource:n},a){let t=this.s();if(a&&n){const g=a.getFolder(n);g&&(t=this.t(g.uri)||t);const c=this.m.get(n);c&&(t=t.merge(c))}return t}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let a=this.b.get(n);if(!a){const t=this.s(),g=this.j.get(n);g?(a=t.merge(g),this.b.set(n,a)):a=t}return a}u(n,a){if(a&&n){const t=a.getFolder(n);if(t)return this.j.get(t.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,a)=>{const{contents:t,overrides:g,keys:c}=this.j.get(a);return n.push([a,{contents:t,overrides:g,keys:c}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(a=>n.add(a)),this.userConfiguration.keys.forEach(a=>n.add(a)),this.i.keys.forEach(a=>n.add(a)),this.j.forEach(a=>a.keys.forEach(t=>n.add(t))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(a=>n.add(a)),this.userConfiguration.getAllOverrideIdentifiers().forEach(a=>n.add(a)),this.i.getAllOverrideIdentifiers().forEach(a=>n.add(a)),this.j.forEach(a=>a.getAllOverrideIdentifiers().forEach(t=>n.add(t))),[...n.values()]}w(n){const a=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(t=>a.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>a.add(t)),this.i.getKeysForOverrideIdentifier(n).forEach(t=>a.add(t)),this.j.forEach(t=>t.getKeysForOverrideIdentifier(n).forEach(g=>a.add(g))),[...a.values()]}static parse(n){const a=this.x(n.defaults),t=this.x(n.policy),g=this.x(n.application),c=this.x(n.user),u=this.x(n.workspace),l=n.folders.reduce((C,R)=>(C.set(T.URI.revive(R[0]),this.x(R[1])),C),new S.ResourceMap);return new p(a,t,g,c,new m,u,l,new m,new S.ResourceMap)}static x(n){return new m(n.contents,n.keys,n.overrides)}}e.Configuration=p;function w(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const n=new Set,a=new Map;for(const g of d)g.keys.forEach(c=>n.add(c)),g.overrides.forEach(([c,u])=>{const l=(0,S.getOrSet)(a,c,new Set);u.forEach(C=>l.add(C))});const t=[];return a.forEach((g,c)=>t.push([c,[...g.values()]])),{keys:[...n.values()],overrides:t}}e.mergeChanges=w;class A{constructor(n,a,t,g){this.change=n,this.f=a,this.g=t,this.h=g,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const c of n.keys)this.affectedKeys.add(c);for(const[,c]of n.overrides)for(const u of c)this.affectedKeys.add(u);this.d=this.a;for(const c of this.affectedKeys)this.d+=c+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=p.parse(this.f.data)),this.i}affectsConfiguration(n,a){const t=this.a+n,g=this.d.indexOf(t);if(g<0)return!1;const c=g+t.length;if(c>=this.d.length)return!1;const u=this.d.charCodeAt(c);if(u!==this.b&&u!==this.c)return!1;if(a){const l=this.previousConfiguration?this.previousConfiguration.getValue(n,a,this.f?.workspace):void 0,C=this.g.getValue(n,a,this.h);return!O.equals(l,C)}return!0}}e.ConfigurationChangeEvent=A;function v(d,n){const{added:a,removed:t,updated:g}=i(n?.rawConfiguration,d?.rawConfiguration),c=[],u=d?.getAllOverrideIdentifiers()||[],l=n?.getAllOverrideIdentifiers()||[];if(n){const C=l.filter(R=>!u.includes(R));for(const R of C)c.push([R,n.getKeysForOverrideIdentifier(R)])}if(d){const C=u.filter(R=>!l.includes(R));for(const R of C)c.push([R,d.getKeysForOverrideIdentifier(R)])}if(n&&d){for(const C of u)if(l.includes(C)){const R=i({contents:d.getOverrideValue(void 0,C)||{},keys:d.getKeysForOverrideIdentifier(C)},{contents:n.getOverrideValue(void 0,C)||{},keys:n.getKeysForOverrideIdentifier(C)});c.push([C,[...R.added,...R.removed,...R.updated]])}}return{added:a,removed:t,updated:g,overrides:c}}function i(d,n){const a=d?n?d.keys.filter(c=>n.keys.indexOf(c)===-1):[...d.keys]:[],t=n?d?n.keys.filter(c=>d.keys.indexOf(c)===-1):[...n.keys]:[],g=[];if(d&&n){for(const c of n.keys)if(d.keys.indexOf(c)!==-1){const u=(0,N.getConfigurationValue)(n.contents,c),l=(0,N.getConfigurationValue)(d.contents,c);O.equals(u,l)||g.push(c)}}return{added:a,removed:t,updated:g}}}),define(Ce[94],ke([1,0,12,3]),function(ie,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,k.createDecorator)("remoteAuthorityResolverService");var D;(function(O){O.Unknown="Unknown",O.NotAvailable="NotAvailable",O.TemporarilyNotAvailable="TemporarilyNotAvailable",O.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class M extends r.ErrorNoTelemetry{static isNotAvailable(y){return y instanceof M&&y._code===D.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof M&&y._code===D.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof M&&y._code===D.NoResolverFound}static isHandled(y){return y instanceof M&&y.isHandled}constructor(y,T=D.Unknown,N){super(y),this._message=y,this._code=T,this._detail=N,this.isHandled=T===D.NotAvailable&&N===!0,Object.setPrototypeOf(this,M.prototype)}}e.RemoteAuthorityResolverError=M;function S(O){const y=O.indexOf("+");return y===-1?O:O.substring(0,y)}e.getRemoteAuthorityPrefix=S}),define(Ce[49],ke([1,0,15]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function k(T){return T.scheme===r.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=k;function D(T){if(!T)return;const N=T.indexOf("+");return N<0?T:T.substr(0,N)}e.getRemoteName=D;function M(T){return`/${T.quality??"oss"}-${T.commit??"dev"}`}e.getRemoteServerRootPath=M;function S(T){const{host:N,port:E}=y(T);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:N,port:E}}e.parseAuthorityWithPort=S;function O(T,N){let{host:E,port:f}=y(T);return typeof f>"u"&&(f=N),{host:E,port:f}}e.parseAuthorityWithOptionalPort=O;function y(T){const N=T.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(N)return{host:N[1],port:parseInt(N[2],10)};const E=T.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const f=T.match(/(.*):(\d+)$/);return f?{host:f[1],port:parseInt(f[2],10)}:{host:T,port:void 0}}}),define(Ce[25],ke([1,0,10,3,49]),function(ie,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.getWorkspaceSupportTypeMessage=M;function S(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=S,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var O;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(O=e.ExtensionType||(e.ExtensionType={}));var y;(function(m){m.WIN32_X64="win32-x64",m.WIN32_IA32="win32-ia32",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(y=e.TargetPlatform||(e.TargetPlatform={}));class T{constructor(o){this.value=o,this.c=o.toLowerCase()}static equals(o,s){if(typeof o>"u"||o===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof o=="string"||typeof s=="string"){const h=typeof o=="string"?o:o.value,p=typeof s=="string"?s:s.value;return r.equalsIgnoreCase(h,p)}return o.c===s.c}static toKey(o){return typeof o=="string"?o.toLowerCase():o.c}}e.ExtensionIdentifier=T;function N(m){return E(m)}e.isApplicationScopedExtension=N;function E(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function f(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=f;function b(m,o){if(o){const s=`onResolveRemoteAuthority:${(0,D.getRemoteName)(o)}`;return m.activationEvents?.indexOf(s)!==-1}return!1}e.isResolverExtension=b,e.IBuiltinExtensionsScannerService=(0,k.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ce[166],ke([1,0,20,50,2,34]),function(ie,e,r,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function S(T){if(r.platform===2&&/^penguin(\.|$)/i.test(T))return"chromebook"}async function O(T,N,E,f,b,m,o,s,h,p){const w=Object.create(null);w["common.machineId"]=o,w.sessionID=(0,M.generateUuid)()+Date.now(),w.commitHash=b,w.version=m,w["common.platformVersion"]=(N||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,r.PlatformToString)(r.platform),w["common.nodePlatform"]=k.platform,w["common.nodeArch"]=f,w["common.product"]=p||"desktop",s&&(w["common.msftInternal"]=s);let A=0;const v=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-v,enumerable:!0},"common.sequence":{get:()=>A++,enumerable:!0}}),r.isLinuxSnap&&(w["common.snap"]="true");const i=S(E);i&&(w["common.platformDetail"]=i);try{const d=await T.readFile(D.URI.file(h));w["common.source"]=d.value.toString().slice(0,30)}catch{}return w}e.resolveCommonProperties=O;function y(T){const N=k.env.USERDNSDOMAIN;if(!N)return!1;const E=N.toLowerCase();return T.some(f=>E===f)}e.verifyMicrosoftInternalDomain=y}),define(Ce[167],ke([1,0,3]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,r.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,r.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var k;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(k=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Ce[51],ke([1,0,22,9,4,41,49,166,167]),function(ie,e,r,k,D,M,S,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class T{constructor(c){this.value=c}}e.TelemetryTrustedValue=T;class N{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(c,u){return Promise.resolve(void 0)}publicLog2(c,u){return this.publicLog(c,u)}publicLogError(c,u){return Promise.resolve(void 0)}publicLogError2(c,u){return this.publicLogError(c,u)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=N,e.NullTelemetryService=new N;class E{async publicLog(c,u,l){}async publicLogError(c,u,l){}}e.NullEndpointTelemetryService=E,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function f(g,c){return D.Event.debounce(c.onDidChangeConfiguration,(l,C)=>{const R=l?new Set([...l.affectedKeys,...C.affectedKeys]):C.affectedKeys;return{...C,affectedKeys:R}},1e3,!0)(l=>{l.source!==7&&g.publicLog2("updateConfiguration",{configurationSource:(0,M.ConfigurationTargetToString)(l.source),configurationKeys:A(l.affectedKeys)})})}e.configurationTelemetry=f;function b(g,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!g.enableTelemetry||c.extensionTestsLocationURI)}e.supportsTelemetry=b;function m(g,c){return!(c.isBuilt||c.disableTelemetry||g.enableTelemetry&&g.aiConfig?.ariaKey)}e.isLoggingOnly=m;function o(g){const c=g.getValue(y.TELEMETRY_SETTING_ID),u=g.getValue(y.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(g.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||u===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=o;function s(g){const c={},u={},l={};w(g,l);for(let C in l){C=C.length>150?C.substr(C.length-149):C;const R=l[C];typeof R=="number"?u[C]=R:typeof R=="boolean"?u[C]=R?1:0:typeof R=="string"?(R.length>8192&&console.warn(`Telemetry property: ${C} has been trimmed to 8192, the original length is ${R.length}`),c[C]=R.substring(0,8191)):typeof R<"u"&&R!==null&&(c[C]=R)}return{properties:c,measurements:u}}e.validateTelemetryData=s;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function p(g){if(!g)return"none";const c=(0,S.getRemoteName)(g);return h.has(c)?c:"other"}e.cleanRemoteAuthority=p;function w(g,c,u=0,l){if(!!g)for(const C of Object.getOwnPropertyNames(g)){const R=g[C],V=l?l+C:C;Array.isArray(R)?c[V]=(0,r.safeStringify)(R):R instanceof Date?c[V]=R.toISOString():(0,k.isObject)(R)?u<2?w(R,c,u+1,V+"."):c[V]=(0,r.safeStringify)(R):c[V]=R}}function A(g){if(!g)return[];const c=[];return v(c,"",g),c}function v(g,c,u){u&&typeof u=="object"&&!Array.isArray(u)?Object.keys(u).forEach(l=>v(g,c?`${c}.${l}`:l,u[l])):g.push(c)}function i(g,c){const u=g.msftInternalDomains||[],l=c.getValue("telemetry.internalTesting");return(0,O.verifyMicrosoftInternalDomain)(u)||l}e.isInternalTelemetry=i;function d(g){return[g.appRoot,g.extensionsPath,g.userHome.fsPath,g.tmpDir.fsPath,g.userDataPath]}e.getPiiPathsFromEnvironment=d;function n(g,c){if(!g||!g.includes("/")&&!g.includes("\\"))return g;let u=g;const l=[];for(const ee of c)for(;;){const K=ee.exec(g);if(!K)break;l.push([K.index,ee.lastIndex])}const C=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,R=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let V=0;for(u="";;){const ee=R.exec(g);if(!ee)break;const K=l.some(([L,B])=>ee.index<B&&L<R.lastIndex);!C.test(ee[0])&&!K&&(u+=g.substring(V,ee.index)+"<REDACTED: user-file-path>",V=R.lastIndex)}return V<g.length&&(u+=g.substr(V)),u}function a(g){if(!g)return g;const c=g.toLowerCase(),u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of u)if(l.regex.test(c))return`<REDACTED: ${l.label}>`;return g}function t(g,c){return(0,r.cloneAndChange)(g,u=>{if(u instanceof T)return u.value;if(typeof u=="string"){let l=u.replaceAll("%20"," ");l=n(l,c);for(const C of c)l=l.replace(C,"");return l=a(l),l}})}e.cleanData=t}),define(Ce[168],ke([1,0,10,90,25,20,2,12,50,51]),function(ie,e,r,k,D,M,S,O,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function N(n,a){return n.uuid&&a.uuid?n.uuid===a.uuid:n.id===a.id?!0:(0,r.compareIgnoreCase)(n.id,a.id)===0}e.areSameExtensions=N;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class f{static create(a){const t=a.manifest?a.manifest.version:a.version,g=a.manifest?a.targetPlatform:a.properties.targetPlatform;return new f(a.identifier,t,g)}static parse(a){const t=E.exec(a);return t&&t[1]&&t[2]?new f({id:t[1]},t[2],t[4]||void 0):null}constructor(a,t,g="undefined"){this.version=t,this.targetPlatform=g,this.id=a.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(a){return a instanceof f?N(this,a)&&this.version===a.version&&this.targetPlatform===a.targetPlatform:!1}}e.ExtensionKey=f;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(n){const a=b.exec(n);return a&&a[1]?[s(a[1]),a[2]]:[s(n),void 0]}e.getIdAndVersion=m;function o(n,a){return`${n}.${a}`}e.getExtensionId=o;function s(n){return n.toLocaleLowerCase()}e.adoptToGalleryExtensionId=s;function h(n,a){return s(o(n,a))}e.getGalleryExtensionId=h;function p(n,a){const t=[],g=c=>{for(const u of t)if(u.some(l=>N(a(l),a(c))))return u;return null};for(const c of n){const u=g(c);u?u.push(c):t.push([c])}return t}e.groupByExtension=p;function w(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=w;function A(n){return{id:new T.TelemetryTrustedValue(n.identifier.id),name:new T.TelemetryTrustedValue(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=A,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function v(n,a){const t=[],g=a.manifest.extensionDependencies?.slice(0)??[];for(;g.length;){const c=g.shift();if(c&&t.every(u=>!N(u.identifier,{id:c}))){const u=n.filter(l=>N(l.identifier,{id:c}));u.length===1&&(t.push(u[0]),g.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}e.getExtensionDependencies=v;async function i(n,a){if(!M.isLinux)return!1;let t;try{t=(await n.readFile(S.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await n.readFile(S.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){a.debug("Error while getting the os-release file.",(0,O.getErrorMessage)(c))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=i;async function d(n,a){const t=await i(n,a),g=(0,k.getTargetPlatform)(t?"alpine":M.platform,y.arch);return a.debug("ComputeTargetPlatform:",g),g}e.computeTargetPlatform=d}),define(Ce[169],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function r(S){return[...S.entries()]}e.serializeEnvironmentVariableCollection=r;function k(S){return new Map(S)}e.deserializeEnvironmentVariableCollection=k;function D(S){return Array.from(S.entries()).map(O=>[O[0],r(O[1].map)])}e.serializeEnvironmentVariableCollections=D;function M(S){return new Map(S.map(O=>[O[0],{map:k(O[1])}]))}e.deserializeEnvironmentVariableCollections=M}),define(Ce[170],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class r{constructor(D){this.b=D,this.a=new Map}dispose(){for(const D of this.a.values())D.dispose()}startBuffering(D,M,S=5){const O=M(y=>{const T=typeof y=="string"?y:y.data;let N=this.a.get(D);if(N){N.data.push(T);return}const E=setTimeout(()=>this.flushBuffer(D),S);N={data:[T],timeoutId:E,dispose:()=>{clearTimeout(E),this.flushBuffer(D),O.dispose()}},this.a.set(D,N)});return O}stopBuffering(D){this.a.get(D)?.dispose()}flushBuffer(D){const M=this.a.get(D);M&&(this.a.delete(D),this.b(D,M.data.join("")))}}e.TerminalDataBufferer=r}),define(Ce[171],ke([1,0,16,84,38,4,9,2,137,68,30]),function(ie,e,r,k,D,M,S,O,y,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var E;(function(A){function v(i,d){let n=i.defaults;for(;D.ThemeIcon.isThemeIcon(n);){const a=m.getIcon(n.id);if(!a)return;n=a.defaults}return n}A.getDefinition=v})(E=e.IconContribution||(e.IconContribution={}));var f;(function(A){function v(d){return{weight:d.weight,style:d.style,src:d.src.map(n=>({format:n.format,location:n.location.toString()}))}}A.toJSONObject=v;function i(d){const n=a=>(0,S.isString)(a)?a:void 0;if(d&&Array.isArray(d.src)&&d.src.every(a=>(0,S.isString)(a.format)&&(0,S.isString)(a.location)))return{weight:n(d.weight),style:n(d.style),src:d.src.map(a=>({format:a.format,location:O.URI.parse(a.location)}))}}A.fromJSONObject=i})(f=e.IconFontDefinition||(e.IconFontDefinition={}));class b{constructor(){this.a=new M.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${D.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(v,i,d,n){const a=this.b[v];if(a){if(d&&!a.description){a.description=d,this.d.properties[v].markdownDescription=`${d} $(${v})`;const c=this.e.enum.indexOf(v);c!==-1&&(this.e.enumDescriptions[c]=d),this.a.fire()}return a}const t={id:v,description:d,defaults:i,deprecationMessage:n};this.b[v]=t;const g={$ref:"#/definitions/icons"};return n&&(g.deprecationMessage=n),d&&(g.markdownDescription=`${d}: $(${v})`),this.d.properties[v]=g,this.e.enum.push(v),this.e.enumDescriptions.push(d||""),this.a.fire(),{id:v}}deregisterIcon(v){delete this.b[v],delete this.d.properties[v];const i=this.e.enum.indexOf(v);i!==-1&&(this.e.enum.splice(i,1),this.e.enumDescriptions.splice(i,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(v=>this.b[v])}getIcon(v){return this.b[v]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(v,i){const d=this.f[v];return d||(this.f[v]=i,this.a.fire(),i)}deregisterIconFont(v){delete this.f[v]}getIconFont(v){return this.f[v]}toString(){const v=(a,t)=>a.id.localeCompare(t.id),i=a=>{for(;D.ThemeIcon.isThemeIcon(a.defaults);)a=this.b[a.defaults.id];return`codicon codicon-${a?a.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const n=Object.keys(this.b).map(a=>this.b[a]);for(const a of n.filter(t=>!!t.description).sort(v))d.push(`|<i class="${i(a)}"></i>|${a.id}|${D.ThemeIcon.isThemeIcon(a.defaults)?a.defaults.id:a.id}|${a.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const a of n.filter(t=>!D.ThemeIcon.isThemeIcon(t.defaults)).sort(v))d.push(`|<i class="${i(a)}"></i>|${a.id}|`);return d.join(`
`)}}const m=new b;N.Registry.add(e.Extensions.IconContribution,m);function o(A,v,i,d){return m.registerIcon(A,v,i,d)}e.registerIcon=o;function s(){return m}e.getIconRegistry=s;function h(){const A=(0,k.getCodiconFontCharacters)();for(const v in A){const i="\\"+A[v].toString(16);m.registerIcon(v,{fontCharacter:i})}}h(),e.iconsSchemaId="vscode://schemas/icons";const p=N.Registry.as(T.Extensions.JSONContribution);p.registerSchema(e.iconsSchemaId,m.getIconSchema());const w=new r.RunOnceScheduler(()=>p.notifySchemaChanged(e.iconsSchemaId),200);m.onDidChange(()=>{w.isScheduled()||w.schedule()}),e.widgetClose=o("widget-close",k.Codicon.close,(0,y.localize)(2,null)),e.gotoPreviousLocation=o("goto-previous-location",k.Codicon.arrowUp,(0,y.localize)(3,null)),e.gotoNextLocation=o("goto-next-location",k.Codicon.arrowDown,(0,y.localize)(4,null)),e.syncing=D.ThemeIcon.modify(k.Codicon.sync,"spin"),e.spinningLoading=D.ThemeIcon.modify(k.Codicon.loading,"spin")}),define(Ce[172],ke([1,0,4,41,3,11]),function(ie,e,r,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var S;(function(o){o.Http="http",o.Https="https"})(S=e.TunnelProtocol||(e.TunnelProtocol={}));var O;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})(O=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function T(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(!!s)return{address:s[1],port:+s[2]}}e.extractLocalHostUriMetaDataForPortMapping=T,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function N(o){return e.LOCALHOST_ADDRESSES.indexOf(o)>=0}e.isLocalhost=N,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(o){return e.ALL_INTERFACES_ADDRESSES.indexOf(o)>=0}e.isAllInterfaces=E;function f(o,s,h,p){if(h===1)return!1;if(h===2&&E(s)){const w=/(\d+)\.(\d+)\.(\d+)/g.exec(p);if(w?.length===4&&parseInt(w[1])>=18)return!1}return o<1024}e.isPortPrivileged=f;class b{constructor(s,h,p){this.remoteAddress=s,this.localAddress=h,this.b=p,this.a=new r.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=b;let m=class{constructor(s,h){this.i=s,this.j=h,this.a=new r.Emitter,this.onTunnelOpened=this.a.event,this.b=new r.Emitter,this.onTunnelClosed=this.b.event,this.c=new r.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const s=this.j.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this.e=s,s?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this.f=s.elevation,this.g=s.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const s=[],h=Array.from(this.d.values());for(const p of h){const w=Array.from(p.values());for(const A of w){const v=await A.value;v&&s.push(v)}}return s}async dispose(){for(const s of this.d.values()){for(const{value:h}of s.values())await h.then(p=>p?.dispose());s.clear()}this.d.clear()}setEnvironmentTunnel(s,h,p,w,A){this.o(s,h,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:h,localAddress:p,privacy:w,protocol:A,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,h){(E(s)||N(s))&&(s=e.LOCALHOST_ADDRESSES[0]);const p=this.q(s,h);if(p)return++p.refcount,p.value}openTunnel(s,h,p,w,A,v=!1,i,d){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${p} on local port ${A}.`),!s)return;if(h||(h="localhost"),w||(w=this.k),this.e&&this.h.has(p)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.r(s,h,p,w,A,v,i,d);return n?n.then(a=>{if(!a){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(h,p);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const t=this.m(a);return(a.tunnelRemoteHost!==h||a.tunnelRemotePort!==p)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(t),t}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}m(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const h=this.d.get(s.tunnelRemoteHost);if(h){const p=h.get(s.tunnelRemotePort);p&&(p.refcount--,await this.n(s.tunnelRemoteHost,s.tunnelRemotePort,p))}}}}async n(s,h,p){if(p.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${h}.`);const w=p.value.then(async A=>{A&&(await A.dispose(!0),this.b.fire({host:A.tunnelRemoteHost,port:A.tunnelRemotePort}))});return this.d.has(s)&&this.d.get(s).delete(h),w}}async closeTunnel(s,h){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${h} `);const p=this.d.get(s);if(p&&p.has(h)){const w=p.get(h);w.refcount=0,await this.n(s,h,w)}}o(s,h,p){this.d.has(s)||this.d.set(s,new Map),this.d.get(s).set(h,{refcount:1,value:p})}async p(s,h){const p=this.d.get(s);p&&(await p.get(h)||p.delete(h),p.size===0&&this.d.delete(s))}q(s,h){const p=[s];N(s)?(p.push(...e.LOCALHOST_ADDRESSES),p.push(...e.ALL_INTERFACES_ADDRESSES)):E(s)&&p.push(...e.ALL_INTERFACES_ADDRESSES);const w=p.map(A=>this.d.get(A));for(const A of w){const v=A?.get(h);if(v)return v}}canTunnel(s){return!!T(s)}s(s,h,p,w,A,v,i){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${p} on local port ${w}.`);const d=p;this.h.add(d);const n=w===void 0?p:w,a={elevationRequired:A?this.isPortPrivileged(n):!1},t={remoteAddress:{host:h,port:p},localAddressPort:w,privacy:v,public:v?v!==O.Private:void 0,protocol:i},g=s.forwardPort(t,a);return g?(this.o(h,p,g),g.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(d)})):this.h.delete(d),g}};m=qe([je(0,M.ILogService),je(1,k.IConfigurationService)],m),e.AbstractTunnelService=m}),define(Ce[173],ke([1,0,3]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,r.createDecorator)("editSessionIdentityService");var k;(function(D){D[D.Complete=100]="Complete",D[D.Partial=50]="Partial",D[D.None=0]="None"})(k=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(Ce[174],ke([1,0,15]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function k(y){return y.scheme!==r.Schemas.file&&y.scheme!==r.Schemas.vscodeRemote}e.isVirtualResource=k;function D(y){if(y.folders.length)return y.folders.every(T=>k(T.uri))?y.folders[0].uri:void 0;if(y.configuration&&k(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=D;function M(y){return D(y)?.scheme}e.getVirtualWorkspaceScheme=M;function S(y){return D(y)?.authority}e.getVirtualWorkspaceAuthority=S;function O(y){return D(y)!==void 0}e.isVirtualWorkspace=O}),define(Ce[52],ke([1,0,138,19,47,24,2,3,15]),function(ie,e,r,k,D,M,S,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,O.createDecorator)("contextService");function T(n){const a=n;return typeof a?.id=="string"&&S.URI.isUri(a.uri)}e.isSingleFolderWorkspaceIdentifier=T;function N(n){return typeof n?.id=="string"&&!T(n)&&!f(n)}e.isEmptyWorkspaceIdentifier=N,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function E(n,a){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,k.basename)(n)}:a?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const t=n;return t.configuration?{id:t.id,configPath:t.configuration}:t.folders.length===1?{id:t.id,uri:t.folders[0].uri}:{id:t.id}}e.toWorkspaceIdentifier=E;function f(n){const a=n;return typeof a?.id=="string"&&S.URI.isUri(a.configPath)}e.isWorkspaceIdentifier=f;function b(n){const a=n;if(a?.uri)return{id:a.id,uri:S.URI.revive(a.uri)};const t=n;if(t?.configPath)return{id:t.id,configPath:S.URI.revive(t.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=b;var m;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(m=e.WorkbenchState||(e.WorkbenchState={}));function o(n){const a=n;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}e.isWorkspace=o;function s(n){const a=n;return!!(a&&typeof a=="object"&&S.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}e.isWorkspaceFolder=s;class h{constructor(a,t,g,c,u){this.h=a,this.j=g,this.k=c,this.l=u,this.c=D.TernarySearchTree.forUris(this.l,()=>!0),this.folders=t}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=D.TernarySearchTree.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class p{constructor(a,t){this.raw=t,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,M.joinPath)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function w(n){return new p({uri:n,index:0,name:(0,M.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=w,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,r.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function A(n,a){return M.extUriBiasedIgnorePathCase.isEqualOrParent(n,a.untitledWorkspacesHome)}e.isUntitledWorkspace=A;function v(n){let a;return S.URI.isUri(n)?a=n:a=n.configuration,a?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=v;function i(n,a){return!A(n,a)&&!v(n)}e.isSavedWorkspace=i;function d(n){return(typeof n=="string"?(0,k.extname)(n):(0,M.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=d}),define(Ce[53],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class r{constructor(D){this.d=D,this.b=new Map,this.c=1}add(D){const M=this.c++;return this.b.set(M,D),this.e(),M}get(D,M){return this.b.has(D)?this.b.get(D)[M]:void 0}delete(D){this.b.delete(D),this.e()}e(){!r.a||console.log(`${this.d} cache size - ${this.b.size}`)}}e.Cache=r,r.a=!1}),define(Ce[36],ke([1,0,15,24,3]),function(ie,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class M{constructor(){this.a=new Set(Object.keys(r.Schemas)),this.b=new Map,this.extUri=new k.ExtUri(O=>{const y=this.b.get(O.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(O,y){y===null?this.b.delete(O.scheme):this.b.set(O.scheme,y)}isFreeScheme(O){return!this.b.has(O)&&!this.a.has(O)}getCapabilities(O){return this.b.get(O)}}e.ExtHostFileSystemInfo=M,e.IExtHostFileSystemInfo=(0,D.createDecorator)("IExtHostFileSystemInfo")}),define(Ce[26],ke([1,0,3]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,r.createDecorator)("IExtHostInitDataService")}),define(Ce[175],ke([1,0,11,161,26]),function(ie,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let M=class extends k.LogService{constructor(O,y){super(O.createLogger(y.logFile,{name:y.logName}))}};M=qe([je(0,r.ILoggerService),je(1,D.IExtHostInitDataService)],M),e.ExtHostLogService=M}),define(Ce[176],ke([1,0,16]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class k{constructor(S,O,y){this.h=new Map,this.a=S,this.b=O,this.c=y,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(T=>(this.f=T,this)),this.g=this.c.onDidChangeStorage(T=>{T.shared===this.b&&T.key===this.a&&(this.f=T.value)}),this.i=new r.RunOnceScheduler(()=>{const T=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const N of T.values())N.complete()}catch(N){for(const E of T.values())E.error(N)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,S])=>S!==void 0).map(([S])=>S)}get whenReady(){return this.d}get(S,O){let y=this.f[S];return typeof y>"u"&&(y=O),y}update(S,O){this.f[S]=O;const y=this.h.get(S);if(y!==void 0)return y.p;const T=new r.DeferredPromise;return this.h.set(S,T),this.i.isScheduled()||this.i.schedule(),T.p}dispose(){this.g.dispose()}}e.ExtensionMemento=k;class D extends k{setKeysForSync(S){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},S)}constructor(S,O){super(S.identifier.value,!0,O),this.j=S}}e.ExtensionGlobalMemento=D}),define(Ce[177],ke([1,0,4,2]),function(ie,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class D{constructor(S){this.c=S,this.a=new r.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new r.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(S,O,y,T){const E=this.c.getNotebookDocument(k.URI.revive(S)).acceptModelChanged(O.value,y,T);this.b.fire(E)}$acceptDirtyStateChanged(S,O){this.c.getNotebookDocument(k.URI.revive(S)).acceptDirty(O)}$acceptModelSaved(S){const O=this.c.getNotebookDocument(k.URI.revive(S));this.a.fire(O.apiNotebook)}}e.ExtHostNotebookDocuments=D}),define(Ce[17],ke([1,0,3]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,r.createDecorator)("IExtHostRpcService");class k{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.ExtHostRpcService=k});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!D:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(ie,r):D?D.value=r:e.set(ie,r),r},Le=this&&this.__classPrivateFieldGet||function(ie,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(ie):k?k.value:e.get(ie)};define(Ce[178],ke([1,0,25,4]),function(ie,e,r,k){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class M{constructor(O,y){D.set(this,void 0),this.b=new k.Emitter,this.onDidChange=this.b.event,this.a=r.ExtensionIdentifier.toKey(O.identifier),Je(this,D,y,"f"),Le(this,D,"f").onDidChangePassword(T=>{T.extensionId===this.a&&this.b.fire({key:T.key})})}get(O){return Le(this,D,"f").get(this.a,O)}store(O,y){return Le(this,D,"f").store(this.a,O,y)}delete(O){return Le(this,D,"f").delete(this.a,O)}}e.ExtensionSecrets=M,D=new WeakMap}),define(Ce[69],ke([1,0,3,172,4,17]),function(ie,e,r,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var S;(function(y){function T(E){return{remoteAddress:E.remoteAddress,localAddress:E.localAddress,public:!!E.public,privacy:E.privacy??(E.public?k.TunnelPrivacyId.Public:k.TunnelPrivacyId.Private),protocol:E.protocol}}y.fromApiTunnel=T;function N(E){return{remoteAddress:{host:E.tunnelRemoteHost,port:E.tunnelRemotePort},localAddress:E.localAddress,public:E.privacy!==k.TunnelPrivacyId.ConstantPrivate&&E.privacy!==k.TunnelPrivacyId.ConstantPrivate,privacy:E.privacy,protocol:E.protocol}}y.fromServiceTunnel=N})(S=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,r.createDecorator)("IExtHostTunnelService");let O=class{constructor(T){this.onDidChangeTunnels=new D.Emitter().event}async $applyCandidateFilter(T){return T}async openTunnel(T,N){}async getTunnels(){return[]}async setTunnelFactory(T){return{dispose:()=>{}}}registerPortsAttributesProvider(T,N){return{dispose:()=>{}}}async $providePortAttributes(T,N,E,f,b){return[]}async $forwardPort(T,N){}async $closeTunnel(T){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};O=qe([je(0,M.IExtHostRpcService)],O),e.ExtHostTunnelService=O}),define(Ce[54],ke([1,0,3]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,r.createDecorator)("IURITransformerService");class k{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=S=>S,this.transformOutgoing=S=>S,this.transformOutgoingURI=S=>S,this.transformOutgoingScheme=S=>S)}}e.URITransformerService=k}),define(Ce[179],ke([1,0,23]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class k{constructor(){this.buffers=[]}add(y){let T=this.buffers.indexOf(y);return T<0&&(T=this.buffers.length,this.buffers.push(y)),T}}function D(O,y){if(y.serializeBuffersForPostMessage){const T=new k,N=(b,m)=>{if(m instanceof ArrayBuffer){const o=T.add(m);return{$$vscode_array_buffer_reference$$:!0,index:o}}else if(ArrayBuffer.isView(m)){const o=M(m);if(o){const s=T.add(m.buffer);return{$$vscode_array_buffer_reference$$:!0,index:s,view:{type:o,byteLength:m.byteLength,byteOffset:m.byteOffset}}}}return m},E=JSON.stringify(O,N),f=T.buffers.map(b=>{const m=new Uint8Array(b);return r.VSBuffer.wrap(m)});return{message:E,buffers:f}}else return{message:JSON.stringify(O),buffers:[]}}e.serializeWebviewMessage=D;function M(O){switch(O.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function S(O,y){const T=y.map(f=>{const b=new ArrayBuffer(f.byteLength);return new Uint8Array(b).set(f.buffer),b}),N=y.length?(f,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const m=b,{index:o}=m,s=T[o];if(m.view)switch(m.view.type){case 1:return new Int8Array(s,m.view.byteOffset,m.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(s,m.view.byteOffset,m.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(s,m.view.byteOffset,m.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(s,m.view.byteOffset,m.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(s,m.view.byteOffset,m.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(s,m.view.byteOffset,m.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(s,m.view.byteOffset,m.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(s,m.view.byteOffset,m.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(s,m.view.byteOffset,m.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(s,m.view.byteOffset,m.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(s,m.view.byteOffset,m.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return s}return b}:void 0;return{message:JSON.parse(O,N),arrayBuffers:T}}e.deserializeWebviewMessage=S}),define(Ce[95],ke([1,0,146,9,2,6,3,30,43,15,39,124,29]),function(ie,e,r,k,D,M,S,O,y,T,N,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,r.localize)(0,null),providerDisplayName:(0,r.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var b;(function(J){J[J.PROGRAMMATIC=1]="PROGRAMMATIC",J[J.USER=2]="USER",J[J.EDIT=3]="EDIT",J[J.NAVIGATION=4]="NAVIGATION",J[J.JUMP=5]="JUMP"})(b=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var m;(function(J){J[J.IDENTICAL=1]="IDENTICAL",J[J.SIMILAR=2]="SIMILAR",J[J.DIFFERENT=3]="DIFFERENT"})(m=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function o(J){const X=J;return!!X&&typeof X.getSelection=="function"&&!!X.onDidChangeSelection}e.isEditorPaneWithSelection=o;function s(J,X,Z){for(const he of Z.visibleEditorPanes)if(he.group.id===X&&J.matches(he.input))return he.getViewState()}e.findViewStateForEditor=s;function h(J){if(u(J))return!1;const X=J;return D.URI.isUri(X?.resource)}e.isResourceEditorInput=h;function p(J){if(u(J))return!1;const X=J;return X?.original!==void 0&&X.modified!==void 0}e.isResourceDiffEditorInput=p;function w(J){if(u(J)||p(J))return!1;const X=J;return X?.primary!==void 0&&X.secondary!==void 0}e.isResourceSideBySideEditorInput=w;function A(J){if(u(J))return!1;const X=J;return X?X.resource===void 0||X.resource.scheme===T.Schemas.untitled||X.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=A;const v=/Untitled-\d+/;function i(J){return J.scheme===T.Schemas.untitled&&J.path.length>1&&!v.test(J.path)}e.isUntitledWithAssociatedResource=i;function d(J){if(u(J))return!1;const X=J;return D.URI.isUri(X?.base?.resource)&&D.URI.isUri(X?.input1?.resource)&&D.URI.isUri(X?.input2?.resource)&&D.URI.isUri(X?.result?.resource)}e.isResourceMergeEditorInput=d;var n;(function(J){J[J.SHORT=0]="SHORT",J[J.MEDIUM=1]="MEDIUM",J[J.LONG=2]="LONG"})(n=e.Verbosity||(e.Verbosity={}));var a;(function(J){J[J.EXPLICIT=1]="EXPLICIT",J[J.AUTO=2]="AUTO",J[J.FOCUS_CHANGE=3]="FOCUS_CHANGE",J[J.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a=e.SaveReason||(e.SaveReason={}));class t{constructor(){this.a=new Map}registerSource(X,Z){let he=this.a.get(X);return he||(he={source:X,label:Z},this.a.set(X,he)),he.source}getSourceLabel(X){return this.a.get(X)?.label??X}}e.SaveSourceRegistry=new t;var g;(function(J){J[J.None=0]="None",J[J.Readonly=2]="Readonly",J[J.Untitled=4]="Untitled",J[J.Singleton=8]="Singleton",J[J.RequiresTrust=16]="RequiresTrust",J[J.CanSplitInGroup=32]="CanSplitInGroup",J[J.ForceDescription=64]="ForceDescription",J[J.CanDropIntoEditor=128]="CanDropIntoEditor",J[J.MultipleEditors=256]="MultipleEditors"})(g=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class c extends M.Disposable{}e.AbstractEditorInput=c;function u(J){return J instanceof c}e.isEditorInput=u;function l(J){const X=J;return D.URI.isUri(X?.preferredResource)}function C(J){const X=J;return u(X?.primary)&&u(X?.secondary)}e.isSideBySideEditorInput=C;function R(J){const X=J;return u(X?.modified)&&u(X?.original)}e.isDiffEditorInput=R;function V(J,X,Z,he,Te){return se(he,[(0,E.toAction)({id:"workbench.action.openLargeFile",label:(0,r.localize)(2,null),run:()=>{const Ne={...Z,limits:{size:Number.MAX_VALUE}};J.openEditor(X,Ne)}}),(0,E.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,r.localize)(3,null),run:()=>Te.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:f.default.Warning})}e.createTooLargeFileError=V;function ee(J){return u(J?.editor)}e.isEditorInputWithOptions=ee;function K(J){const X=J;return ee(J)&&X?.group!==void 0}e.isEditorInputWithOptionsAndGroup=K;function L(J){const X=J;return typeof X?.groupId=="number"&&u(X.editor)}e.isEditorIdentifier=L;var B;(function(J){J[J.UNKNOWN=0]="UNKNOWN",J[J.REPLACE=1]="REPLACE",J[J.MOVE=2]="MOVE",J[J.UNPIN=3]="UNPIN"})(B=e.EditorCloseContext||(e.EditorCloseContext={}));var P;(function(J){J[J.GROUP_ACTIVE=0]="GROUP_ACTIVE",J[J.GROUP_INDEX=1]="GROUP_INDEX",J[J.GROUP_LOCKED=2]="GROUP_LOCKED",J[J.EDITOR_OPEN=3]="EDITOR_OPEN",J[J.EDITOR_CLOSE=4]="EDITOR_CLOSE",J[J.EDITOR_MOVE=5]="EDITOR_MOVE",J[J.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",J[J.EDITOR_LABEL=7]="EDITOR_LABEL",J[J.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",J[J.EDITOR_PIN=9]="EDITOR_PIN",J[J.EDITOR_STICKY=10]="EDITOR_STICKY",J[J.EDITOR_DIRTY=11]="EDITOR_DIRTY",J[J.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(P=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var F;(function(J){J[J.PRIMARY=1]="PRIMARY",J[J.SECONDARY=2]="SECONDARY",J[J.BOTH=3]="BOTH",J[J.ANY=4]="ANY"})(F=e.SideBySideEditor||(e.SideBySideEditor={}));class H{getOriginalUri(X,Z){if(!X)return;if(d(X))return e.EditorResourceAccessor.getOriginalUri(X.result,Z);if(Z?.supportSideBySide){const{primary:Te,secondary:Ne}=this.a(X);if(Te&&Ne){if(Z?.supportSideBySide===F.BOTH)return{primary:this.getOriginalUri(Te,{filterByScheme:Z.filterByScheme}),secondary:this.getOriginalUri(Ne,{filterByScheme:Z.filterByScheme})};if(Z?.supportSideBySide===F.ANY)return this.getOriginalUri(Te,{filterByScheme:Z.filterByScheme})??this.getOriginalUri(Ne,{filterByScheme:Z.filterByScheme});X=Z.supportSideBySide===F.PRIMARY?Te:Ne}}if(p(X)||w(X)||d(X))return;const he=l(X)?X.preferredResource:X.resource;return!he||!Z||!Z.filterByScheme?he:this.b(he,Z.filterByScheme)}a(X){return C(X)||w(X)?{primary:X.primary,secondary:X.secondary}:R(X)||p(X)?{primary:X.modified,secondary:X.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(X,Z){if(!X)return;if(d(X))return e.EditorResourceAccessor.getCanonicalUri(X.result,Z);if(Z?.supportSideBySide){const{primary:Te,secondary:Ne}=this.a(X);if(Te&&Ne){if(Z?.supportSideBySide===F.BOTH)return{primary:this.getCanonicalUri(Te,{filterByScheme:Z.filterByScheme}),secondary:this.getCanonicalUri(Ne,{filterByScheme:Z.filterByScheme})};if(Z?.supportSideBySide===F.ANY)return this.getCanonicalUri(Te,{filterByScheme:Z.filterByScheme})??this.getCanonicalUri(Ne,{filterByScheme:Z.filterByScheme});X=Z.supportSideBySide===F.PRIMARY?Te:Ne}}if(p(X)||w(X)||d(X))return;const he=X.resource;return!he||!Z||!Z.filterByScheme?he:this.b(he,Z.filterByScheme)}b(X,Z){if(Array.isArray(Z)){if(Z.some(he=>X.scheme===he))return X}else if(Z===X.scheme)return X}}e.EditorResourceAccessor=new H;var j;(function(J){J[J.LEFT=0]="LEFT",J[J.RIGHT=1]="RIGHT"})(j=e.CloseDirection||(e.CloseDirection={}));class le{constructor(){this.c=new Map,this.d=new Map}start(X){const Z=this.a=X.get(S.IInstantiationService);for(const[he,Te]of this.c)this.e(he,Te,Z);this.c.clear()}e(X,Z,he){const Te=he.createInstance(Z);this.d.set(X,Te)}registerFileEditorFactory(X){if(this.b)throw new Error("Can only register one file editor factory.");this.b=X}getFileEditorFactory(){return(0,k.assertIsDefined)(this.b)}registerEditorSerializer(X,Z){if(this.c.has(X)||this.d.has(X))throw new Error(`A editor serializer with type ID '${X}' was already registered.`);return this.a?this.e(X,Z,this.a):this.c.set(X,Z),(0,M.toDisposable)(()=>{this.c.delete(X),this.d.delete(X)})}getEditorSerializer(X){return this.d.get(typeof X=="string"?X:X.typeId)}}O.Registry.add(e.EditorExtensions.EditorFactory,new le);async function _(J,X,Z){return!J||!J.length?[]:await Promise.all(J.map(async he=>{const Te=D.URI.revive(he.fileUri);if(!Te){Z.info("Cannot resolve the path because it is not valid.",he);return}if(!await X.canHandleResource(Te)){Z.info("Cannot resolve the path because it cannot be handled",he);return}let Ke=he.exists,Pe=he.type;if(typeof Ke!="boolean"||typeof Pe!="number")try{Pe=(await X.stat(Te)).isDirectory?y.FileType.Directory:y.FileType.Unknown,Ke=!0}catch(Ie){Z.error(Ie),Ke=!1}if(!Ke&&he.openOnlyIfExists){Z.info("Cannot resolve the path because it does not exist",he);return}if(Pe===y.FileType.Directory){Z.info("Cannot resolve the path because it is a directory",he);return}const Se={...he.options,pinned:!0};return Ke?{resource:Te,options:Se}:{resource:Te,options:Se,forceUntitled:!0}}))}e.pathsToEditors=_;var be;(function(J){J[J.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",J[J.SEQUENTIAL=1]="SEQUENTIAL"})(be=e.EditorsOrder||(e.EditorsOrder={}));function de(J){const X=J;if(!X)return!1;const Z=X;if(Z.modified)return de(Z.modified);const he=X;return!!(he.contributionsState&&he.viewState&&Array.isArray(he.cursorState))}e.isTextEditorViewState=de;function ue(J){return(0,N.isErrorWithActions)(J)}e.isEditorOpenError=ue;function se(J,X,Z){const he=(0,N.createErrorWithActions)(J,X);return he.forceMessage=Z?.forceMessage,he.forceSeverity=Z?.forceSeverity,he.allowDialog=Z?.allowDialog,he}e.createEditorOpenError=se}),define(Ce[180],ke([1,0,4,147,3,6,28,30,18,62,22,84,171]),function(ie,e,r,k,D,M,S,O,y,T,N,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,f.registerIcon)("default-view-icon",E.Codicon.window,(0,k.localize)(0,null));var b;(function(n){n.ViewContainersRegistry="workbench.registry.view.containers",n.ViewsRegistry="workbench.registry.view"})(b=e.Extensions||(e.Extensions={}));var m;(function(n){n[n.Sidebar=0]="Sidebar",n[n.Panel=1]="Panel",n[n.AuxiliaryBar=2]="AuxiliaryBar"})(m=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function o(n){switch(n){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=o;class s extends M.Disposable{constructor(){super(...arguments),this.c=this.B(new r.Emitter),this.onDidRegister=this.c.event,this.f=this.B(new r.Emitter),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,y.flatten)([...this.g.values()])}registerViewContainer(a,t,g){const c=this.get(a.id);if(c)return c;const u=a;return u.openCommandActionDescriptor=g?.doNotRegisterOpenCommand?void 0:u.openCommandActionDescriptor??{id:u.id},(0,S.getOrSet)(this.g,t,[]).push(u),g?.isDefault&&this.h.push(u),this.c.fire({viewContainer:u,viewContainerLocation:t}),u}deregisterViewContainer(a){for(const t of this.g.keys()){const g=this.g.get(t),c=g?.indexOf(a);if(c!==-1){g?.splice(c,1),g.length===0&&this.g.delete(t),this.f.fire({viewContainer:a,viewContainerLocation:t});return}}}get(a){return this.all.filter(t=>t.id===a)[0]}getViewContainers(a){return[...this.g.get(a)||[]]}getViewContainerLocation(a){return[...this.g.keys()].filter(t=>this.getViewContainers(t).filter(g=>g?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.h.find(t=>this.getViewContainerLocation(t)===a)}}O.Registry.add(b.ViewContainersRegistry,new s);var h;(function(n){n.Open="2_open",n.Debug="4_debug",n.SCM="5_scm",n.More="9_more"})(h=e.ViewContentGroups||(e.ViewContentGroups={}));function p(n,a){const t=n.group??h.More,g=a.group??h.More;return t!==g?t.localeCompare(g):(n.order??5)-(a.order??5)}class w extends M.Disposable{constructor(){super(...arguments),this.c=this.B(new r.Emitter),this.onViewsRegistered=this.c.event,this.f=this.B(new r.Emitter),this.onViewsDeregistered=this.f.event,this.g=this.B(new r.Emitter),this.onDidChangeContainer=this.g.event,this.h=this.B(new r.Emitter),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new T.SetMap}registerViews(a,t){this.registerViews2([{views:a,viewContainer:t}])}registerViews2(a){a.forEach(({views:t,viewContainer:g})=>this.l(t,g)),this.c.fire(a)}deregisterViews(a,t){const g=this.m(a,t);g.length&&this.f.fire({views:g,viewContainer:t})}moveViews(a,t){for(const g of this.j.keys())if(g!==t){const c=this.m(a,g);c.length&&(this.l(c,t),this.g.fire({views:c,from:g,to:t}))}}getViews(a){return this.j.get(a)||[]}getView(a){for(const t of this.i){const g=(this.j.get(t)||[]).filter(c=>c.id===a)[0];if(g)return g}return null}getViewContainer(a){for(const t of this.i)if((this.j.get(t)||[]).filter(c=>c.id===a)[0])return t;return null}registerViewWelcomeContent(a,t){return this.k.add(a,t),this.h.fire(a),(0,M.toDisposable)(()=>{this.k.delete(a,t),this.h.fire(a)})}registerViewWelcomeContent2(a,t){const g=new Map;for(const[c,u]of t)this.k.add(a,u),g.set(c,(0,M.toDisposable)(()=>{this.k.delete(a,u),this.h.fire(a)}));return this.h.fire(a),g}getViewWelcomeContent(a){const t=[];return this.k.forEach(a,g=>t.push(g)),t.sort(p)}l(a,t){let g=this.j.get(t);g||(g=[],this.j.set(t,g),this.i.push(t));for(const c of a){if(this.getView(c.id)!==null)throw new Error((0,k.localize)(1,null,c.id));g.push(c)}}m(a,t){const g=this.j.get(t);if(!g)return[];const c=[],u=[];for(const l of g)a.includes(l)?c.push(l):u.push(l);return c.length&&(u.length?this.j.set(t,u):(this.j.delete(t),this.i.splice(this.i.indexOf(t),1))),c}}O.Registry.add(b.ViewsRegistry,new w),e.IViewsService=(0,D.createDecorator)("viewsService"),e.IViewDescriptorService=(0,D.createDecorator)("viewDescriptorService");var A;(function(n){n[n.Default=0]="Default",n[n.Expand=1]="Expand"})(A=e.ViewVisibilityState||(e.ViewVisibilityState={}));var v;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(v=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(a,t){this.c=!1,this.d=!1,(0,N.mixin)(this,a),this.d=!!t,this.resolve=async g=>{if(t&&!this.c){const c=await t(g);c&&(this.tooltip=this.tooltip??c.tooltip,this.command=this.command??c.command)}g.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i;class d extends Error{constructor(a){super((0,k.localize)(2,null,a))}}e.NoTreeViewError=d}),define(Ce[181],ke([1,0,4,16,148]),function(ie,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class M{constructor(){this.f=new Map,this.k=[],this.m=new r.Emitter,this.n=new r.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(O){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=O}onEvent(O){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=O}onRequest(O){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=O}sendResponse(O){O.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${O.command}`)):this.s("response",O)}sendRequest(O,y,T,N){const E={command:O};if(y&&Object.keys(y).length>0&&(E.arguments=y),this.s("request",E),typeof N=="number"){const f=setTimeout(()=>{clearTimeout(f);const b=this.f.get(E.seq);if(b){this.f.delete(E.seq);const m={type:"response",seq:0,request_seq:E.seq,success:!1,command:O,message:(0,D.localize)(0,null,N,O)};b(m)}},N)}return T&&this.f.set(E.seq,T),E.seq}acceptMessage(O){this.j?this.j(O):(this.k.push(O),this.k.length===1&&this.q())}o(O,y){return O.type!=="event"||y.type!=="event"}async q(){let O;for(;this.k.length;){if((!O||this.o(this.k[0],O))&&await(0,k.timeout)(0),O=this.k.shift(),!O)return;switch(O.type){case"event":this.i?.(O);break;case"request":this.g?.(O);break;case"response":{const y=O,T=this.f.get(y.request_seq);T&&(this.f.delete(y.request_seq),T(y));break}}}}s(O,y){y.type=O,y.seq=this.d++,this.sendMessage(y)}async u(){if(this.f.size===0)return Promise.resolve();const O=new Map;this.f.forEach((y,T)=>O.set(T,y)),await(0,k.timeout)(500),O.forEach((y,T)=>{y({type:"response",seq:0,request_seq:T,success:!1,command:"canceled",message:"canceled"}),this.f.delete(T)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=M}),define(Ce[182],ke([1,0,149,42,3]),function(ie,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new k.RawContextKey("debugType",void 0,{type:"string",description:r.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new k.RawContextKey("debugConfigurationType",void 0,{type:"string",description:r.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new k.RawContextKey("debugState","inactive",{type:"string",description:r.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new k.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:r.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new k.RawContextKey("hasDebugged",!1,{type:"boolean",description:r.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new k.RawContextKey("inDebugMode",!1,{type:"boolean",description:r.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new k.RawContextKey("inDebugRepl",!1,{type:"boolean",description:r.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new k.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:r.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new k.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:r.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new k.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:r.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new k.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:r.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new k.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:r.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new k.RawContextKey("variablesFocused",!0,{type:"boolean",description:r.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new k.RawContextKey("expressionSelected",!1,{type:"boolean",description:r.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new k.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:r.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new k.RawContextKey("callStackItemType",void 0,{type:"string",description:r.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new k.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:r.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new k.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:r.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new k.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:r.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new k.RawContextKey("watchItemType",void 0,{type:"string",description:r.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new k.RawContextKey("canViewMemory",void 0,{type:"boolean",description:r.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new k.RawContextKey("breakpointItemType",void 0,{type:"string",description:r.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new k.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:r.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new k.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:r.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new k.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:r.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new k.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:r.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new k.RawContextKey("stepBackSupported",!1,{type:"boolean",description:r.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new k.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:r.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new k.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:r.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new k.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:r.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new k.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:r.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new k.RawContextKey("breakpointsExist",!1,{type:"boolean",description:r.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new k.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:r.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new k.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:r.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new k.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:r.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new k.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:r.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new k.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:r.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new k.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:r.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new k.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:r.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new k.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:r.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new k.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:r.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new k.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:r.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new k.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:r.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new k.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:r.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new k.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:r.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new k.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:r.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new k.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:r.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new k.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:r.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new k.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:r.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new k.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:r.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new k.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:r.localize(50,null)});const M=f=>r.localize(51,null,f);e.debuggerDisabledMessage=M,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:r.localize(52,null)};var S;(function(f){f[f.Inactive=0]="Inactive",f[f.Initializing=1]="Initializing",f[f.Stopped=2]="Stopped",f[f.Running=3]="Running"})(S=e.State||(e.State={}));function O(f){switch(f){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=O;var y;(function(f){f[f.Valid=0]="Valid",f[f.Unreadable=1]="Unreadable",f[f.Error=2]="Error"})(y=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var T;(function(f){f[f.Initial=1]="Initial",f[f.Dynamic=2]="Dynamic"})(T=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var N;(function(f){f.UnverifiedBreakpoints="unverifiedBreakpoints"})(N=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,D.createDecorator)("debugService");var E;(function(f){f[f.CONDITION=0]="CONDITION",f[f.HIT_COUNT=1]="HIT_COUNT",f[f.LOG_MESSAGE=2]="LOG_MESSAGE"})(E=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ce[183],ke([1,0,10,2,19,22,15]),function(ie,e,r,k,D,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const O=/{([^}]+)}/g;function y(n,a,t){return n.replace(O,function(g,c){return a&&c.length>0&&c[0]!=="_"?g:t&&t.hasOwnProperty(c)?t[c]:g})}e.formatPII=y;function T(n){const a={};for(const t of Object.keys(n))t.startsWith("!")||(a[t]=n[t]);return a}e.filterExceptionsFromTelemetry=T;function N(n){return n.configuration.request==="attach"&&!E(n)&&(!n.parentSession||N(n.parentSession))}e.isSessionAttach=N;function E(n){let a=n.configuration.type;if(!!a)return a==="vslsShare"&&(a=n.configuration.adapterProxy.configuration.type),(0,r.equalsIgnoreCase)(a,"extensionhost")||(0,r.equalsIgnoreCase)(a,"pwa-extensionhost")?n:n.parentSession?E(n.parentSession):void 0}e.getExtensionHostDebugSession=E;function f(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=f;function b(n,a,t){let g,c=0;const u=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let l=null;for(;l=u.exec(n);){const C=l.index+1,R=C+l[0].length;if(C<=a&&R>=t){g=l[0],c=C;break}}if(g){const C=/\w+/g;let R=null;for(;(R=C.exec(g))&&!(R.index+1+c+R[0].length>=t););R&&(g=g.substring(0,C.lastIndex))}return g?{start:c,end:c+g.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=b;const m=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function o(n){return!!(n&&n.match(m))}e.isUri=o;function s(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(o(n.path))return k.URI.parse(n.path);if((0,D.isAbsolute)(n.path))return k.URI.file(n.path)}return n.path}function h(n){if(typeof n.path=="object"){const a=k.URI.revive(n.path);if(a)return a.scheme===S.Schemas.file?a.fsPath:a.toString()}return n.path}function p(n,a){const t=a?s:h,g=(0,M.deepClone)(n);return A(g,(c,u)=>{c&&u&&(u.path=t(u))}),g}e.convertToDAPaths=p;function w(n,a){const t=a?s:h,g=(0,M.deepClone)(n);return A(g,(c,u)=>{!c&&u&&(u.path=t(u))}),g}e.convertToVSCPaths=w;function A(n,a){switch(n.type){case"event":{const t=n;switch(t.event){case"output":a(!1,t.body.source);break;case"loadedSource":a(!1,t.body.source);break;case"breakpoint":a(!1,t.body.breakpoint.source);break;default:break}break}case"request":{const t=n;switch(t.command){case"setBreakpoints":a(!0,t.arguments.source);break;case"breakpointLocations":a(!0,t.arguments.source);break;case"source":a(!0,t.arguments.source);break;case"gotoTargets":a(!0,t.arguments.source);break;case"launchVSCode":t.arguments.args.forEach(g=>a(!1,g));break;default:break}break}case"response":{const t=n;if(t.success&&t.body)switch(t.command){case"stackTrace":t.body.stackFrames.forEach(g=>a(!1,g.source));break;case"loadedSources":t.body.sources.forEach(g=>a(!1,g));break;case"scopes":t.body.scopes.forEach(g=>a(!1,g.source));break;case"setFunctionBreakpoints":t.body.breakpoints.forEach(g=>a(!1,g.source));break;case"setBreakpoints":t.body.breakpoints.forEach(g=>a(!1,g.source));break;case"disassemble":t.body?.instructions.forEach(c=>a(!1,c.location));break;default:break}break}}}function v(n){return n.filter(a=>!a.presentation?.hidden).sort((a,t)=>a.presentation?t.presentation?a.presentation.group?t.presentation.group?a.presentation.group!==t.presentation.group?a.presentation.group.localeCompare(t.presentation.group):i(a.presentation.order,t.presentation.order):-1:t.presentation.group?1:i(a.presentation.order,t.presentation.order):-1:t.presentation?1:0)}e.getVisibleAndSorted=v;function i(n,a){return typeof n!="number"?typeof a!="number"?0:1:typeof a!="number"?-1:n-a}async function d(n,a){const t=n.getValue("debug.saveBeforeStart",{overrideIdentifier:a.activeTextEditorLanguageId});if(t!=="none"&&(await a.saveAll(),t==="allEditorsInActiveGroup")){const g=a.activeEditorPane;g&&g.input.resource?.scheme===S.Schemas.untitled&&await a.save({editor:g.input,groupId:g.group.id})}await n.reloadConfiguration()}e.saveAllBeforeDebugStart=d}),define(Ce[70],ke([1,0,23,35,184,64,15,19,20,42]),function(ie,e,r,k,D,M,S,O,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var N;(function(F){F[F.Markup=1]="Markup",F[F.Code=2]="Code"})(N=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.latex,M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.latex,M.Mimes.markdown,"application/json",M.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var E;(function(F){F[F.Running=1]="Running",F[F.Idle=2]="Idle"})(E=e.NotebookRunState||(e.NotebookRunState={}));var f;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(f=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var b;(function(F){F[F.WithHardKernelDependency=0]="WithHardKernelDependency",F[F.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",F[F.Pure=2]="Pure",F[F.Never=3]="Never"})(b=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var m;(function(F){F.Always="always",F.Never="never",F.Optional="optional"})(m=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var o;(function(F){F[F.ModelChange=1]="ModelChange",F[F.Move=2]="Move",F[F.ChangeCellLanguage=5]="ChangeCellLanguage",F[F.Initialize=6]="Initialize",F[F.ChangeCellMetadata=7]="ChangeCellMetadata",F[F.Output=8]="Output",F[F.OutputItem=9]="OutputItem",F[F.ChangeCellContent=10]="ChangeCellContent",F[F.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",F[F.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",F[F.ChangeCellMime=13]="ChangeCellMime",F[F.Unknown=100]="Unknown"})(o=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var s;(function(F){F[F.Handle=0]="Handle",F[F.Index=1]="Index"})(s=e.SelectionStateType||(e.SelectionStateType={}));var h;(function(F){F[F.Replace=1]="Replace",F[F.Output=2]="Output",F[F.Metadata=3]="Metadata",F[F.CellLanguage=4]="CellLanguage",F[F.DocumentMetadata=5]="DocumentMetadata",F[F.Move=6]="Move",F[F.OutputItems=7]="OutputItems",F[F.PartialMetadata=8]="PartialMetadata",F[F.PartialInternalMetadata=9]="PartialInternalMetadata"})(h=e.CellEditType||(e.CellEditType={}));var p;(function(F){F.scheme=S.Schemas.vscodeNotebookCell;const H=["W","X","Y","Z","a","b","c","d","e","f"],j=new RegExp(`^[${H.join("")}]+`),le=7;function _(X,Z){const he=Z.toString(le),Ne=`${he.length<H.length?H[he.length-1]:"z"}${he}s${(0,r.encodeBase64)(r.VSBuffer.fromString(X.scheme),!0,!0)}`;return X.with({scheme:F.scheme,fragment:Ne})}F.generate=_;function be(X){if(X.scheme!==F.scheme)return;const Z=X.fragment.indexOf("s");if(Z<0)return;const he=parseInt(X.fragment.substring(0,Z).replace(j,""),le),Te=(0,r.decodeBase64)(X.fragment.substring(Z+1)).toString();if(!isNaN(he))return{handle:he,notebook:X.with({scheme:Te,fragment:null})}}F.parse=be;function de(X,Z){return X.with({scheme:S.Schemas.vscodeNotebookCellOutput,fragment:`op${Z??""},${X.scheme!==S.Schemas.file?X.scheme:""}`})}F.generateCellOutputUri=de;function ue(X){if(X.scheme!==S.Schemas.vscodeNotebookCellOutput)return;const Z=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(X.fragment);if(!Z)return;const he=Z[1]&&Z[1]!==""?Z[1]:void 0,Te=Z[2];return{outputId:he,notebook:X.with({scheme:Te||S.Schemas.file,fragment:null})}}F.parseCellOutputUri=ue;function se(X,Z,he){return F.generate(X,Z).with({scheme:he})}F.generateCellPropertyUri=se;function J(X,Z){if(X.scheme===Z)return F.parse(X.with({scheme:F.scheme}))}F.parseCellPropertyUri=J})(p=e.CellUri||(e.CellUri={}));const w=F=>y.isWindows?F.replace(/\//g,"\\"):F;class A{constructor(H=[],j=e.NOTEBOOK_DISPLAY_ORDER){this.e=j,this.d=[...new Set(H)].map(le=>({pattern:le,matches:k.parse(w(le))}))}sort(H){const j=new Map(D.Iterable.map(H,_=>[_,w(_)]));let le=[];for(const{matches:_}of this.d)for(const[be,de]of j)if(_(de)){le.push(be),j.delete(be);break}return j.size&&(le=le.concat([...j.keys()].sort((_,be)=>this.e.indexOf(_)-this.e.indexOf(be)))),le}prioritize(H,j){const le=this.f(H);if(le===-1){this.d.unshift({pattern:H,matches:k.parse(w(H))});return}const _=new Set(j.map(de=>this.f(de,le)));_.delete(-1);const be=Array.from(_).sort();this.d.splice(le+1,0,...be.map(de=>this.d[de]));for(let de=be.length-1;de>=0;de--)this.d.splice(be[de],1)}toArray(){return this.d.map(H=>H.pattern)}f(H,j=this.d.length){const le=w(H);for(let _=0;_<j;_++)if(this.d[_].matches(le))return _;return-1}}e.MimeTypeDisplayOrder=A;function v(F,H,j,le=(_,be)=>_===be){const _=[];function be(se,J,X){if(J===0&&X.length===0)return;const Z=_[_.length-1];Z&&Z.start+Z.deleteCount===se?(Z.deleteCount+=J,Z.toInsert.push(...X)):_.push({start:se,deleteCount:J,toInsert:X})}let de=0,ue=0;for(;;){if(de===F.length){be(de,0,H.slice(ue));break}if(ue===H.length){be(de,F.length-de,[]);break}const se=F[de],J=H[ue];if(le(se,J)){de+=1,ue+=1;continue}j(J)?(be(de,1,[]),de+=1):(be(de,0,[J]),ue+=1)}return _}e.diff=v,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new T.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(F){F.default="default",F.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function d(F){const H=F;return!!((typeof H.include=="string"||k.isRelativePattern(H.include))&&(typeof H.exclude=="string"||k.isRelativePattern(H.exclude)))}e.isDocumentExcludePattern=d;function n(F,H,j){if(Array.isArray(F.viewType)&&F.viewType.indexOf(H)>=0||F.viewType===H)return!0;if(F.filenamePattern){const le=d(F.filenamePattern)?F.filenamePattern.include:F.filenamePattern,_=d(F.filenamePattern)?F.filenamePattern.exclude:void 0;if(k.match(le,(0,O.basename)(j.fsPath).toLowerCase()))return!(_&&k.match(_,(0,O.basename)(j.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=n,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling",logging:"notebook.logging"};var a;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(a=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class t{static create(H){return`${t.d}${H}`}static parse(H){if(H.startsWith(t.d))return H.substring(t.d.length)}}e.NotebookWorkingCopyTypeIdentifier=t,t.d="notebook/";function g(F){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(F)}e.isTextStreamMime=g;const c=new TextDecoder;function u(F){const H=[];let j=!1;for(const le of F)(H.length===0||j)&&(H.push(le),j=!0);return V(H),P(r.VSBuffer.concat(H.map(le=>r.VSBuffer.wrap(le))))}e.compressOutputItemStreams=u;const l=`${String.fromCharCode(27)}[A`,C=l.split("").map(F=>F.charCodeAt(0)),R=10;function V(F){F.forEach((H,j)=>{if(j===0||H.length<l.length)return;const le=F[j-1],_=H.subarray(0,l.length);if(_[0]===C[0]&&_[1]===C[1]&&_[2]===C[2]){const be=le.lastIndexOf(R);if(be===-1)return;F[j-1]=le.subarray(0,be),F[j]=H.subarray(l.length)}})}function ee(F){let H=F;do F=H,H=F.replace(/[^\n]\x08/gm,"");while(H.length<F.length);return F}function K(F){for(F=F.replace(/\r+\n/gm,`
`);F.search(/\r[^$]/g)>-1;){const H=F.match(/^(.*)\r+/m)[1];let j=F.match(/\r+(.*)$/m)[1];j=j+H.slice(j.length,H.length),F=F.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,j)}return F}const L="\b".charCodeAt(0),B="\r".charCodeAt(0);function P(F){return!F.buffer.includes(L)&&!F.buffer.includes(B)?F:r.VSBuffer.fromString(K(ee(c.decode(F.buffer))))}}),define(Ce[185],ke([1,0,3]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var k;(function(D){D[D.Output=1]="Output",D[D.OutputItems=2]="OutputItems",D[D.ExecutionState=3]="ExecutionState"})(k=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,r.createDecorator)("INotebookExecutionService")}),define(Ce[44],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var r;(function(M){M.Delimiter="\0"})(r=e.TestIdPathParts||(e.TestIdPathParts={}));var k;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(k=e.TestPosition||(e.TestPosition={}));class D{static fromExtHostTestItem(S,O,y=S.parent){if(S._isRoot)return new D([O]);const T=[S.id];for(let N=y;N&&N.id!==O;N=N.parent)T.push(N.id);return T.push(O),new D(T.reverse())}static isRoot(S){return!S.includes("\0")}static root(S){const O=S.indexOf("\0");return O===-1?S:S.slice(0,O)}static fromString(S){return new D(S.split("\0"))}static join(S,O){return new D([...S.path,O])}static joinToString(S,O){return S.toString()+"\0"+O}static parentId(S){const O=S.lastIndexOf("\0");return O===-1?void 0:S.slice(0,O)}static localId(S){const O=S.lastIndexOf("\0");return O===-1?S:S.slice(O+1)}static compare(S,O){return S===O?0:O.startsWith(S+"\0")?2:S.startsWith(O+"\0")?3:1}constructor(S,O=S.length){if(this.path=S,this.d=O,S.length===0||O<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new D(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let S=1;S<=this.d;S++)yield new D(this.path,S)}*idsToRoot(){for(let S=this.d;S>0;S--)yield new D(this.path,S)}compare(S){if(typeof S=="string")return D.compare(this.toString(),S);for(let O=0;O<S.d&&O<this.d;O++)if(S.path[O]!==this.path[O])return 1;return S.d>this.d?2:S.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let S=1;S<this.d;S++)this.c+="\0",this.c+=this.path[S]}return this.c}}e.TestId=D}),define(Ce[55],ke([1,0,2,56,44]),function(ie,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var M;(function(c){c[c.Unset=0]="Unset",c[c.Queued=1]="Queued",c[c.Running=2]="Running",c[c.Passed=3]="Passed",c[c.Failed=4]="Failed",c[c.Skipped=5]="Skipped",c[c.Errored=6]="Errored"})(M=e.TestResultState||(e.TestResultState={}));var S;(function(c){c[c.Run=2]="Run",c[c.Debug=4]="Debug",c[c.Coverage=8]="Coverage",c[c.HasNonDefaultProfile=16]="HasNonDefaultProfile",c[c.HasConfigurable=32]="HasConfigurable",c[c.SupportsContinuousRun=64]="SupportsContinuousRun"})(S=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const O=c=>"runIn"in c;e.isStartControllerTests=O;var y;(function(c){c.serialize=u=>({range:u.range.toJSON(),uri:u.uri.toJSON()}),c.deserialize=u=>({range:k.Range.lift(u.range),uri:r.URI.revive(u.uri)})})(y=e.IRichLocation||(e.IRichLocation={}));var T;(function(c){c[c.Error=0]="Error",c[c.Output=1]="Output"})(T=e.TestMessageType||(e.TestMessageType={}));var N;(function(c){c.serialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,location:u.location&&y.serialize(u.location)}),c.deserialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,location:u.location&&y.deserialize(u.location)})})(N=e.ITestErrorMessage||(e.ITestErrorMessage={}));const E=(c,u)=>`${u?"s":"e"}${c}`;e.getMarkId=E;var f;(function(c){c.serialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&y.serialize(u.location)}),c.deserialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&y.deserialize(u.location)})})(f=e.ITestOutputMessage||(e.ITestOutputMessage={}));var b;(function(c){c.serialize=u=>u.type===0?N.serialize(u):f.serialize(u),c.deserialize=u=>u.type===0?N.deserialize(u):f.deserialize(u)})(b=e.ITestMessage||(e.ITestMessage={}));var m;(function(c){c.serializeWithoutMessages=u=>({state:u.state,duration:u.duration,messages:[]}),c.serialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(b.serialize)}),c.deserialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(b.deserialize)})})(m=e.ITestTaskState||(e.ITestTaskState={}));const o="\0",s=(c,u)=>c+o+u;e.namespaceTestTag=s;const h=c=>{const u=c.indexOf(o);return{ctrlId:c.slice(0,u),tagId:c.slice(u+1)}};e.denamespaceTestTag=h;var p;(function(c){c.serialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?.toJSON(),range:u.range?.toJSON()||null,description:u.description,error:u.error,sortText:u.sortText}),c.deserialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?r.URI.revive(u.uri):void 0,range:u.range?k.Range.lift(u.range):null,description:u.description,error:u.error,sortText:u.sortText})})(p=e.ITestItem||(e.ITestItem={}));var w;(function(c){c[c.NotExpandable=0]="NotExpandable",c[c.Expandable=1]="Expandable",c[c.BusyExpanding=2]="BusyExpanding",c[c.Expanded=3]="Expanded"})(w=e.TestItemExpandState||(e.TestItemExpandState={}));var A;(function(c){c.serialize=u=>({expand:u.expand,item:p.serialize(u.item)}),c.deserialize=u=>({controllerId:D.TestId.root(u.item.extId),expand:u.expand,item:p.deserialize(u.item)})})(A=e.InternalTestItem||(e.InternalTestItem={}));var v;(function(c){c.serialize=u=>{let l;return u.item&&(l={},u.item.label!==void 0&&(l.label=u.item.label),u.item.tags!==void 0&&(l.tags=u.item.tags),u.item.busy!==void 0&&(l.busy=u.item.busy),u.item.uri!==void 0&&(l.uri=u.item.uri?.toJSON()),u.item.range!==void 0&&(l.range=u.item.range?.toJSON()),u.item.description!==void 0&&(l.description=u.item.description),u.item.error!==void 0&&(l.error=u.item.error),u.item.sortText!==void 0&&(l.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:l}},c.deserialize=u=>{let l;return u.item&&(l={},u.item.label!==void 0&&(l.label=u.item.label),u.item.tags!==void 0&&(l.tags=u.item.tags),u.item.busy!==void 0&&(l.busy=u.item.busy),u.item.range!==void 0&&(l.range=u.item.range?k.Range.lift(u.item.range):null),u.item.description!==void 0&&(l.description=u.item.description),u.item.error!==void 0&&(l.error=u.item.error),u.item.sortText!==void 0&&(l.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:l}}})(v=e.ITestItemUpdate||(e.ITestItemUpdate={}));const i=(c,u)=>{u.expand!==void 0&&(c.expand=u.expand),u.item!==void 0&&(c.item=c.item?Object.assign(c.item,u.item):u.item)};e.applyTestItemUpdate=i;var d;(function(c){c.serializeWithoutMessages=u=>({...A.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(m.serializeWithoutMessages),retired:u.retired}),c.serialize=u=>({...A.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(m.serialize),retired:u.retired}),c.deserialize=u=>({...A.deserialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(m.deserialize),retired:!0})})(d=e.TestResultItem||(e.TestResultItem={}));var n;(function(c){c[c.Function=0]="Function",c[c.Statement=1]="Statement"})(n=e.DetailType||(e.DetailType={}));var a;(function(c){c[c.Add=0]="Add",c[c.Update=1]="Update",c[c.DocumentSynced=2]="DocumentSynced",c[c.Remove=3]="Remove",c[c.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",c[c.Retire=5]="Retire",c[c.AddTag=6]="AddTag",c[c.RemoveTag=7]="RemoveTag"})(a=e.TestDiffOpType||(e.TestDiffOpType={}));var t;(function(c){c.deserialize=u=>u.op===0?{op:u.op,item:A.deserialize(u.item)}:u.op===1?{op:u.op,item:v.deserialize(u.item)}:u.op===2?{op:u.op,uri:r.URI.revive(u.uri),docv:u.docv}:u,c.serialize=u=>u.op===0?{op:u.op,item:A.serialize(u.item)}:u.op===1?{op:u.op,item:v.serialize(u.item)}:u})(t=e.TestsDiffOp||(e.TestsDiffOp={}));class g{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(u){const l=this.o();for(const C of u)switch(C.op){case 0:this.j(A.deserialize(C.item),l);break;case 1:this.k(v.deserialize(C.item),l);break;case 3:this.l(C.itemId,l);break;case 5:this.m(C.itemId);break;case 4:this.updatePendingRoots(C.amount);break;case 6:this.c.set(C.tag.id,C.tag);break;case 7:this.c.delete(C.id);break}l.complete?.()}j(u,l){const C=D.TestId.parentId(u.item.extId)?.toString();let R;if(!C)R=this.p(u),this.f.add(R),this.d.set(u.item.extId,R);else if(this.d.has(C)){const V=this.d.get(C);V.children.add(u.item.extId),R=this.p(u,V),this.d.set(u.item.extId,R)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(u)}`);return}return l.add?.(R),u.expand===2&&this.g++,R}k(u,l){const C=this.d.get(u.extId);if(!!C)return u.expand!==void 0&&(C.expand===2&&this.g--,u.expand===2&&this.g++),(0,e.applyTestItemUpdate)(C,u),l.update?.(C),C}l(u,l){const C=this.d.get(u);if(!C)return;const R=D.TestId.parentId(C.item.extId)?.toString();R?this.d.get(R).children.delete(C.item.extId):this.f.delete(C);const V=[[u]];for(;V.length;)for(const ee of V.pop()){const K=this.d.get(ee);K&&(V.push(K.children),this.d.delete(ee),l.remove?.(K,K!==C),K.expand===2&&this.g--)}}m(u){}updatePendingRoots(u){this.h+=u}o(){return{}}}e.AbstractIncrementalTestCollection=g}),define(Ce[71],ke([1,0,16,4,6,48,55,44]),function(ie,e,r,k,D,M,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(p){p[p.Upsert=0]="Upsert",p[p.SetTags=1]="SetTags",p[p.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",p[p.RemoveChild=3]="RemoveChild",p[p.SetProp=4]="SetProp",p[p.Bulk=5]="Bulk",p[p.DocumentSynced=6]="DocumentSynced"})(y=e.TestItemEventOp||(e.TestItemEventOp={}));const T=(p,w)=>p===w,E=Object.entries({range:(p,w)=>p===w?!0:!p||!w?!1:p.equalsRange(w),busy:T,label:T,description:T,error:T,sortText:T,tags:(p,w)=>!(p.length!==w.length||p.some(A=>!w.includes(A)))}),f=(p,w)=>{let A;for(const[v,i]of E)i(p[v],w[v])||(A?A[v]=w[v]:A={[v]:w[v]});return A};class b extends D.Disposable{get root(){return this.m.root}constructor(w){super(),this.m=w,this.f=this.B(new r.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new k.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(w){this.h=w;for(const A of this.tree.values())this.G(A)}collectDiff(){const w=this.k;return this.k=[],w}pushDiff(w){switch(w.op){case 2:{for(const A of this.k)if(A.op===2&&A.uri===w.uri){A.docv=w.docv;return}break}case 1:{const A=this.k[this.k.length-1];if(A){if(A.op===1&&A.item.extId===w.item.extId){(0,S.applyTestItemUpdate)(A.item,w.item);return}if(A.op===0&&A.item.item.extId===w.item.extId){(0,S.applyTestItemUpdate)(A.item,w.item);return}}break}}this.k.push(w),this.f.isScheduled()||this.f.schedule()}expand(w,A){const v=this.tree.get(w);if(!!v){if((v.expandLevels===void 0||A>v.expandLevels)&&(v.expandLevels=A),v.expand===1){const i=this.I(v);return i.isOpen()?this.H(v,A-1):i.wait().then(()=>this.H(v,A-1))}else if(v.expand===3)return v.resolveBarrier?.isOpen()===!1?v.resolveBarrier.wait().then(()=>this.H(v,A-1)):this.H(v,A-1)}}dispose(){for(const w of this.tree.values())this.m.getApiFor(w.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(w,A){switch(A.op){case 3:this.L(O.TestId.joinToString(w.fullId,A.id));break;case 0:this.u(A.item,w);break;case 5:for(const v of A.ops)this.p(w,v);break;case 1:this.w(A.new,A.old,w.fullId.toString());break;case 2:this.G(w);break;case 4:this.pushDiff({op:1,item:{extId:w.fullId.toString(),item:A.update}});break;case 6:this.s(w.actual.uri);break;default:(0,M.assertNever)(A)}}s(w){w&&this.pushDiff({op:2,uri:w,docv:this.m.getDocumentVersion(w)})}u(w,A){const v=O.TestId.fromExtHostTestItem(w,this.root.id,A?.actual),i=this.m.getApiFor(w);i.parent&&i.parent!==A?.actual&&this.m.getChildren(i.parent).delete(w.id);let d=this.tree.get(v.toString());if(!d){d={fullId:v,actual:w,expandLevels:A?.expandLevels?A.expandLevels-1:void 0,expand:0},w.tags.forEach(this.y,this),this.tree.set(d.fullId.toString(),d),this.C(w,A),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:d.expand,item:this.m.toITestItem(w)}}),this.F(w,d,A);return}if(d.actual===w){this.D(w,d,A);return}if(d.actual.uri?.toString()!==w.uri?.toString())return this.L(v.toString()),this.u(w,A);const n=this.m.getChildren(d.actual),a=d.actual,t=f(this.m.toITestItem(a),this.m.toITestItem(w));this.m.getApiFor(a).listener=void 0,d.actual=w,d.expand=0,t&&(t.hasOwnProperty("tags")&&(this.w(w.tags,a.tags,v.toString()),delete t.tags),this.p(d,{op:4,update:t})),this.F(w,d,A);for(const[g,c]of n)this.m.getChildren(w).get(c.id)||this.L(O.TestId.joinToString(v,c.id));this.s(d.actual.uri)}w(w,A,v){const i=new Set(A.map(d=>d.id));for(const d of w)i.delete(d.id)||this.y(d);this.pushDiff({op:1,item:{extId:v,item:{tags:w.map(d=>(0,S.namespaceTestTag)(this.m.controllerId,d.id))}}}),i.forEach(this.z,this)}y(w){const A=this.j.get(w.id);A?A.refCount++:(this.j.set(w.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,S.namespaceTestTag)(this.m.controllerId,w.id)}}))}z(w){const A=this.j.get(w);A&&!--A.refCount&&(this.j.delete(w),this.pushDiff({op:7,id:(0,S.namespaceTestTag)(this.m.controllerId,w)}))}C(w,A){this.m.getApiFor(w).parent=A&&A.actual!==this.root?A.actual:void 0}D(w,A,v){this.C(w,v);const i=this.m.getApiFor(w);i.parent=v?.actual,i.listener=d=>this.p(A,d),this.G(A)}F(w,A,v){this.D(w,A,v);for(const[i,d]of this.m.getChildren(w))this.u(d,A)}G(w){let A;this.h?w.resolveBarrier?A=w.resolveBarrier.isOpen()?3:2:A=w.actual.canResolveChildren?1:0:A=0,A!==w.expand&&(w.expand=A,this.pushDiff({op:1,item:{extId:w.fullId.toString(),expand:A}}),A===1&&w.expandLevels!==void 0&&this.I(w))}H(w,A){if(A<0)return;const v=[];for(const[i,d]of this.m.getChildren(w.actual)){const n=this.expand(O.TestId.joinToString(w.fullId,d.id),A);(0,r.isThenable)(n)&&v.push(n)}if(v.length)return Promise.all(v).then(()=>{})}I(w){if(w.resolveBarrier)return w.resolveBarrier;if(!this.h){const d=new r.Barrier;return d.open(),d}w.expand=2,this.J(w);const A=w.resolveBarrier=new r.Barrier,v=d=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,d)};let i;try{i=this.h(w.actual===this.root?void 0:w.actual)}catch(d){v(d)}return(0,r.isThenable)(i)?i.catch(v).then(()=>{A.open(),this.G(w)}):(A.open(),this.G(w)),w.resolveBarrier}J(w){this.pushDiff({op:1,item:{extId:w.fullId.toString(),expand:w.expand}})}L(w){const A=this.tree.get(w);if(!A)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:w});const v=[A];for(;v.length;){const i=v.pop();if(!!i){this.m.getApiFor(i.actual).listener=void 0;for(const d of i.actual.tags)this.z(d.id);this.tree.delete(i.fullId.toString());for(const[d,n]of this.m.getChildren(i.actual))v.push(this.tree.get(O.TestId.joinToString(i.fullId,n.id)))}}}flushDiff(){const w=this.collectDiff();w.length&&this.g.fire(w)}}e.TestItemCollection=b;class m extends Error{constructor(w){super(`Attempted to insert a duplicate test item ID ${w}`)}}e.DuplicateTestItemError=m;class o extends Error{constructor(w){super(`TestItem with ID "${w}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=o;class s extends Error{constructor(w,A,v){super(`TestItem with ID "${w}" is from controller "${A}" and cannot be added as a child of an item from controller "${v}".`)}}e.MixedTestItemController=s;const h=(p,w,A)=>{let v=new Map;return{get size(){return v.size},forEach(i,d){for(const n of v.values())i.call(d,n,this)},[Symbol.iterator](){return v.entries()},replace(i){const d=new Map,n=new Set(v.keys()),a={op:5,ops:[]};for(const t of i){if(!(t instanceof A))throw new o(t.id);const g=w(t).controllerId;if(g!==p.controllerId)throw new s(t.id,g,p.controllerId);if(d.has(t.id))throw new m(t.id);d.set(t.id,t),n.delete(t.id),a.ops.push({op:0,item:t})}for(const t of n.keys())a.ops.push({op:3,id:t});p.listener?.(a),v=d},add(i){if(!(i instanceof A))throw new o(i.id);v.set(i.id,i),p.listener?.({op:0,item:i})},delete(i){v.delete(i)&&p.listener?.({op:3,id:i})},get(i){return v.get(i)},toJSON(){return Array.from(v.values())}}};e.createTestItemChildren=h}),define(Ce[96],ke([1,0,71]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const k=new WeakMap,D=(S,O)=>{const y={controllerId:O};return k.set(S,y),y};e.createPrivateApiFor=D;const M=S=>{const O=k.get(S);if(!O)throw new r.InvalidTestItemError(S?.id||"<unknown>");return O};e.getPrivateApiFor=M}),define(Ce[72],ke([1,0,15,2]),function(ie,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function D(O,y){return O.scheme===r.Schemas.http||O.scheme===r.Schemas.https?O:(y&&y.authority&&y.isRemote&&O.scheme===r.Schemas.file&&(O=k.URI.from({scheme:r.Schemas.vscodeRemote,authority:y.authority,path:O.path})),k.URI.from({scheme:r.Schemas.https,authority:`${O.scheme}+${M(O.authority)}.${e.webviewRootResourceAuthority}`,path:O.path,fragment:O.fragment,query:O.query}))}e.asWebviewUri=D;function M(O){return O.replace(/./g,y=>{const T=y.charCodeAt(0);return T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57?y:"-"+T.toString(16).padStart(4,"0")})}function S(O){return O.replace(/-([0-9a-f]{4})/g,(y,T)=>String.fromCharCode(parseInt(T,16)))}e.decodeAuthority=S}),define(Ce[186],ke([1,0,4,6,72]),function(ie,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class M{constructor(O,y,T){this.d=O,this.e=y,this.f=T,this.a=0,this.b=new k.DisposableStore,this.c=new Map,this.b.add(y.onDidChangeVisibleTextEditors(()=>{const N=y.getVisibleTextEditors();for(const E of this.c.values())N.indexOf(E.editor)<0&&E.inset.dispose()}))}dispose(){this.c.forEach(O=>O.inset.dispose()),this.b.dispose()}createWebviewEditorInset(O,y,T,N,E){let f;for(const w of this.e.getVisibleTextEditors(!0))if(w.value===O){f=w;break}if(!f)throw new Error("not a visible editor");const b=this,m=this.a++,o=new r.Emitter,s=new r.Emitter,h=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(w){return(0,D.asWebviewUri)(w,b.f)}get cspSource(){return D.webviewGenericCspSource}set options(w){this.b=w,b.d.$setOptions(m,w)}get options(){return this.b}set html(w){this.a=w,b.d.$setHtml(m,w)}get html(){return this.a}get onDidReceiveMessage(){return o.event}postMessage(w){return b.d.$postMessage(m,w)}},p=new class{constructor(){this.editor=O,this.line=y,this.height=T,this.webview=h,this.onDidDispose=s.event}dispose(){b.c.has(m)&&(b.c.delete(m),b.d.$disposeEditorInset(m),s.fire(),s.dispose(),o.dispose())}};return this.d.$createEditorInset(m,f.id,f.value.document.uri,y+1,T,N||{},E.identifier,E.extensionLocation),this.c.set(m,{editor:O,inset:p,onDidReceiveMessage:o}),p}$onDidDispose(O){const y=this.c.get(O);y&&y.inset.dispose()}$onDidReceiveMessage(O,y){this.c.get(O)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=M}),define(Ce[187],ke([1,0,3]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,r.createDecorator)("configurationResolverService");var k;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(k=e.VariableKind||(e.VariableKind={}));class D extends Error{constructor(S,O){super(O),this.variable=S}}e.VariableError=D}),define(Ce[188],ke([1,0,19,50,9,22,20,87,152,187,10]),function(ie,e,r,k,D,M,S,O,y,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class E{constructor(b,m,o,s){this.g=new Map,this.a=b,this.b=m,this.d=o,s&&(this.c=s.then(h=>this.h(h)))}h(b){if(S.isWindows){const m=Object.create(null);return Object.keys(b).forEach(o=>{m[o.toLowerCase()]=b[o]}),m}return b}resolveWithEnvironment(b,m,o){return this.j({env:this.h(b),userHome:void 0},m?m.uri:void 0,o)}async resolveAsync(b,m){const o={env:await this.c,userHome:await this.d};return this.j(o,b?b.uri:void 0,m)}async i(b,m,o,s){const h=M.deepClone(m);S.isWindows&&h.windows?Object.keys(h.windows).forEach(w=>h[w]=h.windows[w]):S.isMacintosh&&h.osx?Object.keys(h.osx).forEach(w=>h[w]=h.osx[w]):S.isLinux&&h.linux&&Object.keys(h.linux).forEach(w=>h[w]=h.linux[w]),delete h.windows,delete h.osx,delete h.linux;const p={env:await this.c,userHome:await this.d};return this.j(p,b?b.uri:void 0,h,o,s)}async resolveAnyAsync(b,m,o){return this.i(b,m,o)}async resolveAnyMap(b,m,o){const s=new Map;return{newConfig:await this.i(b,m,o,s),resolvedVariables:s}}resolveWithInteractionReplace(b,m,o,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,m,o,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,m){if(this.g.has(b))throw new Error("Variable "+b+" is contributed twice.");this.g.set(b,m)}async j(b,m,o,s,h){if(D.isString(o))return this.l(b,m,o,s,h);if(Array.isArray(o))return Promise.all(o.map(p=>this.j(b,m,p,s,h)));if(D.isObject(o)){const p=Object.create(null),w=await Promise.all(Object.keys(o).map(async A=>[await this.l(b,m,A,s,h),await this.j(b,m,o[A],s,h)]));for(const[A,v]of w)p[A]=v;return p}return o}l(b,m,o,s,h){return(0,N.replaceAsync)(o,E.VARIABLE_REGEXP,async(p,w)=>{if(w.includes(E.VARIABLE_LHS))return p;let A=await this.n(b,p,w,m,s);return h?.set(w,A),A!==p&&D.isString(A)&&A.match(E.VARIABLE_REGEXP)&&(A=await this.l(b,m,A,s,h)),A})}m(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async n(b,m,o,s,h){let p;const w=o.split(":");w.length>1&&(o=w[0],p=w[1]);const A=d=>{const n=this.a.getFilePath();if(n)return(0,O.normalizeDriveLetter)(n);throw new T.VariableError(d,(0,y.localize)(0,null,m))},v=d=>{const n=A(d);if(this.a.getWorkspaceFolderPathForFile){const a=this.a.getWorkspaceFolderPathForFile();if(a)return(0,O.normalizeDriveLetter)(a)}throw new T.VariableError(d,(0,y.localize)(1,null,m,r.basename(n)))},i=d=>{if(p){const n=this.a.getFolderUri(p);if(n)return n;throw new T.VariableError(d,(0,y.localize)(2,null,m,p))}if(s)return s;throw this.a.getWorkspaceFolderCount()>1?new T.VariableError(d,(0,y.localize)(3,null,m)):new T.VariableError(d,(0,y.localize)(4,null,m))};switch(o){case"env":if(p){if(b.env){const d=b.env[S.isWindows?p.toLowerCase():p];if(D.isString(d))return d}return""}throw new T.VariableError(T.VariableKind.Env,(0,y.localize)(5,null,m));case"config":if(p){const d=this.a.getConfigurationValue(s,p);if(D.isUndefinedOrNull(d))throw new T.VariableError(T.VariableKind.Config,(0,y.localize)(6,null,m,p));if(D.isObject(d))throw new T.VariableError(T.VariableKind.Config,(0,y.localize)(7,null,m,p));return d}throw new T.VariableError(T.VariableKind.Config,(0,y.localize)(8,null,m));case"command":return this.o(T.VariableKind.Command,m,p,h,"command");case"input":return this.o(T.VariableKind.Input,m,p,h,"input");case"extensionInstallFolder":if(p){const d=await this.a.getExtension(p);if(!d)throw new T.VariableError(T.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,m,p));return this.m(d.extensionLocation)}throw new T.VariableError(T.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,m));default:switch(o){case"workspaceRoot":case"workspaceFolder":return(0,O.normalizeDriveLetter)(this.m(i(T.VariableKind.WorkspaceFolder)));case"cwd":return s||p?(0,O.normalizeDriveLetter)(this.m(i(T.VariableKind.Cwd))):k.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,O.normalizeDriveLetter)(r.basename(this.m(i(T.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new T.VariableError(T.VariableKind.UserHome,(0,y.localize)(11,null,m))}case"lineNumber":{const d=this.a.getLineNumber();if(d)return d;throw new T.VariableError(T.VariableKind.LineNumber,(0,y.localize)(12,null,m))}case"selectedText":{const d=this.a.getSelectedText();if(d)return d;throw new T.VariableError(T.VariableKind.SelectedText,(0,y.localize)(13,null,m))}case"file":return A(T.VariableKind.File);case"fileWorkspaceFolder":return v(T.VariableKind.FileWorkspaceFolder);case"relativeFile":return s||p?r.relative(this.m(i(T.VariableKind.RelativeFile)),A(T.VariableKind.RelativeFile)):A(T.VariableKind.RelativeFile);case"relativeFileDirname":{const d=r.dirname(A(T.VariableKind.RelativeFileDirname));if(s||p){const n=r.relative(this.m(i(T.VariableKind.RelativeFileDirname)),d);return n.length===0?".":n}return d}case"fileDirname":return r.dirname(A(T.VariableKind.FileDirname));case"fileExtname":return r.extname(A(T.VariableKind.FileExtname));case"fileBasename":return r.basename(A(T.VariableKind.FileBasename));case"fileBasenameNoExtension":{const d=r.basename(A(T.VariableKind.FileBasenameNoExtension));return d.slice(0,d.length-r.extname(d).length)}case"fileDirnameBasename":return r.basename(r.dirname(A(T.VariableKind.FileDirnameBasename)));case"execPath":{const d=this.a.getExecPath();return d||m}case"execInstallFolder":{const d=this.a.getAppRoot();return d||m}case"pathSeparator":return r.sep;default:try{const d=p?`${o}:${p}`:o;return this.o(T.VariableKind.Unknown,m,d,h,void 0)}catch{return m}}}}o(b,m,o,s,h){if(o&&s){const p=h===void 0?s[o]:s[h+":"+o];if(typeof p=="string")return p;throw new T.VariableError(b,(0,y.localize)(14,null,m))}return m}}e.AbstractVariableResolverService=E,E.VARIABLE_LHS="${",E.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ce[97],ke([1,0,3,95]),function(ie,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,r.createDecorator)("editorGroupsService");var D;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(D=e.GroupDirection||(e.GroupDirection={}));var M;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(M=e.GroupOrientation||(e.GroupOrientation={}));var S;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(S=e.GroupLocation||(e.GroupLocation={}));var O;(function(m){m[m.MAXIMIZE=0]="MAXIMIZE",m[m.EVEN=1]="EVEN",m[m.TOGGLE=2]="TOGGLE"})(O=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function T(m){const o=m;return(0,k.isEditorInput)(o?.editor)&&(0,k.isEditorInput)(o?.replacement)}e.isEditorReplacement=T;var N;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(N=e.GroupsOrder||(e.GroupsOrder={}));var E;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(E=e.OpenEditorContext||(e.OpenEditorContext={}));function f(m){const o=m;return!!o&&typeof o.id=="number"&&Array.isArray(o.editors)}e.isEditorGroup=f;function b(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=b}),define(Ce[189],ke([1,0,3,97]),function(ie,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,r.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function D(M){const S=M;return typeof M=="number"||(0,k.isEditorGroup)(S)}e.isPreferredGroup=D}),define(Ce[190],ke([1,0,3,158]),function(ie,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,r.refineServiceDecorator)(k.IEnvironmentService)}),define(Ce[98],ke([1,0,25,4,19]),function(ie,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class M{constructor(E){this.removedDueToLooping=E}}e.DeltaExtensionsResult=M;class S{static isHostExtension(E,f,b){if(f.getExtensionDescription(E))return!1;const m=b.getExtensionDescription(E);return m?!!((m.main||m.browser)&&m.api==="none"):!1}constructor(E){this.c=new k.Emitter,this.onDidChange=this.c.event,this.d=E,this.h()}h(){this.d.sort(y),this.e=new Map,this.f=[],this.g=new Map;for(const E of this.d){if(this.e.has(r.ExtensionIdentifier.toKey(E.identifier))){console.error("Extension `"+E.identifier.value+"` is already registered");continue}if(this.e.set(r.ExtensionIdentifier.toKey(E.identifier),E),this.f.push(E),Array.isArray(E.activationEvents))for(let f of E.activationEvents)f==="onUri"&&(f=`onUri:${r.ExtensionIdentifier.toKey(E.identifier)}`),this.g.has(f)||this.g.set(f,[]),this.g.get(f).push(E)}}set(E){this.d=E,this.h(),this.c.fire(void 0)}deltaExtensions(E,f){this.d=T(this.d,f),this.d=this.d.concat(E);const b=S.j(this.d);return this.d=T(this.d,b.map(m=>m.identifier)),this.h(),this.c.fire(void 0),new M(b)}static j(E){const f=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(h){this.d.has(h)||(this.d.add(h),this.e.push(h))}addArc(h,p){this.addNode(h),this.addNode(p),this.c.has(h)?this.c.get(h).push(p):this.c.set(h,[p])}getArcs(h){return this.c.has(h)?this.c.get(h):[]}hasOnlyGoodArcs(h,p){const w=f.getArcs(h);for(let A=0;A<w.length;A++)if(!p.has(w[A]))return!1;return!0}getNodes(){return this.e}},b=new Map;for(const h of E){const p=r.ExtensionIdentifier.toKey(h.identifier);if(b.set(p,h),h.extensionDependencies)for(const w of h.extensionDependencies){const A=r.ExtensionIdentifier.toKey(w);f.addArc(p,A)}}const m=new Set;f.getNodes().filter(h=>f.getArcs(h).length===0).forEach(h=>m.add(h));const o=f.getNodes().filter(h=>!m.has(h));let s;do{s=!1;for(let h=0;h<o.length;h++){const p=o[h];f.hasOnlyGoodArcs(p,m)&&(o.splice(h,1),h--,m.add(p),s=!0)}}while(s);return o.map(h=>b.get(h))}containsActivationEvent(E){return this.g.has(E)}containsExtension(E){return this.e.has(r.ExtensionIdentifier.toKey(E))}getExtensionDescriptionsForActivationEvent(E){const f=this.g.get(E);return f?f.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(E){const f=this.e.get(r.ExtensionIdentifier.toKey(E));return f||void 0}getExtensionDescriptionByUUID(E){for(const f of this.f)if(f.uuid===E)return f}getExtensionDescriptionByIdOrUUID(E,f){return this.getExtensionDescription(E)??(f?this.getExtensionDescriptionByUUID(f):void 0)}}e.ExtensionDescriptionRegistry=S;var O;(function(N){N[N.Builtin=0]="Builtin",N[N.User=1]="User",N[N.Dev=2]="Dev"})(O||(O={}));function y(N,E){const f=N.isBuiltin?0:N.isUnderDevelopment?2:1,b=E.isBuiltin?0:E.isUnderDevelopment?2:1;if(f!==b)return f-b;const m=D.posix.basename(N.extensionLocation.path),o=D.posix.basename(E.extensionLocation.path);return m<o?-1:m>o?1:0}function T(N,E){const f=new Set;return E.forEach(b=>f.add(r.ExtensionIdentifier.toKey(b))),N.filter(b=>!f.has(r.ExtensionIdentifier.toKey(b.identifier)))}}),define(Ce[73],ke([1,0,23]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var k;(function(T){T[T.Desktop=1]="Desktop",T[T.Web=2]="Web"})(k=e.UIKind||(e.UIKind={}));var D;(function(T){T[T.VersionMismatch=55]="VersionMismatch",T[T.UnexpectedError=81]="UnexpectedError"})(D=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var M;(function(T){T[T.Initialized=0]="Initialized",T[T.Ready=1]="Ready",T[T.Terminate=2]="Terminate"})(M=e.MessageType||(e.MessageType={}));function S(T){const N=r.VSBuffer.alloc(1);switch(T){case 0:N.writeUInt8(1,0);break;case 1:N.writeUInt8(2,0);break;case 2:N.writeUInt8(3,0);break}return N}e.createMessageOfType=S;function O(T,N){if(T.byteLength!==1)return!1;switch(T.readUInt8(0)){case 1:return N===0;case 2:return N===1;case 3:return N===2;default:return!1}}e.isMessageOfType=O;var y;(function(T){T.Start="START_NATIVE_LOG",T.End="END_NATIVE_LOG"})(y=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ce[74],ke([1,0,3,4,11,26,73,49,51,22,2]),function(ie,e,r,k,D,M,S,O,y,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let E=class{constructor(o,s){this.i=o,this.a=new k.Emitter,this.onDidChangeTelemetryEnabled=this.a.event,this.b=new k.Emitter,this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.d=0,this.f=!1,this.h=new Map,this.g=s.createLogger(N.URI.revive(this.i.environment.extensionTelemetryLogResource),{hidden:!0}),this.g.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.g.info("===========================================================")}getTelemetryConfiguration(){return this.d===3}getTelemetryDetails(){return{isCrashEnabled:this.d>=1,isErrorsEnabled:this.c.error?this.d>=2:!1,isUsageEnabled:this.c.usage?this.d>=3:!1}}instantiateLogger(o,s,h){const p=this.getTelemetryDetails(),w=new f(s,h,o,this.g,this.f,this.getBuiltInCommonProperties(o),{isUsageEnabled:p.isUsageEnabled,isErrorsEnabled:p.isErrorsEnabled});return this.h.set(o.identifier.value,w),w.apiTelemetryLogger}$initializeTelemetryLevel(o,s,h){this.d=o,this.f=s,this.c=h??{usage:!0,error:!0}}getBuiltInCommonProperties(o){const s={};switch(s["common.extname"]=`${o.publisher}.${o.name}`,s["common.extversion"]=o.version,s["common.vscodemachineid"]=this.i.telemetryInfo.machineId,s["common.vscodesessionid"]=this.i.telemetryInfo.sessionId,s["common.vscodeversion"]=this.i.version,s["common.isnewappinstall"]=b(this.i.telemetryInfo.firstSessionDate),s["common.product"]=this.i.environment.appHost,this.i.uiKind){case S.UIKind.Web:s["common.uikind"]="web";break;case S.UIKind.Desktop:s["common.uikind"]="desktop";break;default:s["common.uikind"]="unknown"}return s["common.remotename"]=(0,O.getRemoteName)((0,y.cleanRemoteAuthority)(this.i.remote.authority)),s}$onDidChangeTelemetryLevel(o){this.e=this.getTelemetryConfiguration(),this.d=o;const s=this.getTelemetryDetails();this.h.forEach(h=>{h.updateTelemetryEnablements(s.isUsageEnabled,s.isErrorsEnabled)}),this.e!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails())}onExtensionError(o,s){const h=this.h.get(o.value);return!h||h.ignoreUnhandledExtHostErrors?!1:(h.logError(s),!0)}};E=qe([je(0,M.IExtHostInitDataService),je(1,D.ILoggerService)],E),e.ExtHostTelemetry=E;class f{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,s,h,p,w,A,v){this.g=h,this.h=p,this.i=w,this.j=A,this.b=new k.Emitter,this.ignoreUnhandledExtHostErrors=s?.ignoreUnhandledErrors??!1,this.c=s?.ignoreBuiltInCommonProperties??!1,this.d=s?.additionalCommonProperties,this.a=o,this.e={isUsageEnabled:v.isUsageEnabled,isErrorsEnabled:v.isErrorsEnabled}}updateTelemetryEnablements(o,s){this.f&&(this.e={isUsageEnabled:o,isErrorsEnabled:s},this.b.fire(this.f))}mixInCommonPropsAndCleanData(o){let s=o.properties??o;return s=(0,y.cleanData)(s,[]),this.d&&(s=(0,T.mixin)(s,this.d)),this.c||(s=(0,T.mixin)(s,this.j)),o.properties?o.properties=s:o=s,o}k(o,s){this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,s=this.mixInCommonPropsAndCleanData(s||{}),this.i||this.a.sendEventData(o,s),this.h.trace(o,s)}logUsage(o,s){!this.e.isUsageEnabled||this.k(o,s)}logError(o,s){!this.e.isErrorsEnabled||(typeof o=="string"?this.k(o,s):this.a.sendErrorData(o,s))}get apiTelemetryLogger(){if(!this.f){const o=this,s={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.e.isUsageEnabled},get isErrorsEnabled(){return o.e.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.b.event.bind(o)};this.f=Object.freeze(s)}return this.f}dispose(){this.a?.flush&&this.a.flush()}}e.ExtHostTelemetryLogger=f;function b(m){const o=Date.now()-new Date(m).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.isNewAppInstall=b,e.IExtHostTelemetry=(0,r.createDecorator)("IExtHostTelemetry")}),define(Ce[27],ke([1,0,4,2,3,25,168]),function(ie,e,r,k,D,M,S){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new M.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:k.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,D.createDecorator)("extensionService");class y{constructor(g){this.affinity=g,this.kind=1}equals(g){return this.kind===g.kind&&this.affinity===g.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=y;class T{constructor(g){this.affinity=g,this.kind=2}equals(g){return this.kind===g.kind&&this.affinity===g.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=T;class N{constructor(){this.kind=3,this.affinity=0}equals(g){return this.kind===g.kind}asString(){return"Remote"}}e.RemoteRunningLocation=N;class E{constructor(g){this.dependency=g}}e.MissingExtensionDependency=E;var f;(function(t){t[t.LocalProcess=1]="LocalProcess",t[t.LocalWebWorker=2]="LocalWebWorker",t[t.Remote=3]="Remote"})(f=e.ExtensionHostKind||(e.ExtensionHostKind={}));function b(t){if(t===null)return"None";switch(t){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=b;class m{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(g,c){const u=[],l=[],C=[],R=[],V=h(this.c),ee=h(g),K=(F,H)=>F.extensionLocation.toString()===H.extensionLocation.toString()||F.isBuiltin===H.isBuiltin||F.isUserBuiltin===H.isUserBuiltin||F.isUnderDevelopment===H.isUnderDevelopment;for(const F of this.c){const H=ee.get(M.ExtensionIdentifier.toKey(F.identifier));if(!H){u.push(F.identifier),V.delete(M.ExtensionIdentifier.toKey(F.identifier));continue}if(!K(F,H)){u.push(F.identifier),V.delete(M.ExtensionIdentifier.toKey(F.identifier));continue}}for(const F of g){const H=V.get(M.ExtensionIdentifier.toKey(F.identifier));if(!H){l.push(F);continue}if(!K(H,F)){u.push(H.identifier),V.delete(M.ExtensionIdentifier.toKey(H.identifier));continue}}const L=s(this.d),B=s(c);for(const F of this.d)B.has(M.ExtensionIdentifier.toKey(F))||C.push(F);for(const F of c)L.has(M.ExtensionIdentifier.toKey(F))||R.push(F);const P={toRemove:u,toAdd:l,myToRemove:C,myToAdd:R};return this.delta(P),P}delta(g){const{toRemove:c,toAdd:u,myToRemove:l,myToAdd:C}=g,R=s(c),V=s(l);for(let ee=0;ee<this.c.length;ee++)R.has(M.ExtensionIdentifier.toKey(this.c[ee].identifier))&&(this.c.splice(ee,1),ee--);for(let ee=0;ee<this.d.length;ee++)V.has(M.ExtensionIdentifier.toKey(this.d[ee]))&&(this.d.splice(ee,1),ee--);for(const ee of u)this.c.push(ee);for(const ee of C)this.d.push(ee)}containsExtension(g){for(const c of this.d)if(M.ExtensionIdentifier.equals(c,g))return!0;return!1}}e.ExtensionHostExtensions=m;class o{constructor(g){if(this[O]="ExtensionIdentifierSet",this.c=new Map,this.d=M.ExtensionIdentifier.toKey,g)for(const c of g)this.add(c)}get size(){return this.c.size}add(g){return this.c.set(this.d(g),g),this}clear(){this.c.clear()}delete(g){return this.c.delete(this.d(g))}has(g){return this.c.has(this.d(g))}forEach(g,c){this.c.forEach(u=>g.call(c,u,u,this))}*entries(){for(const[g,c]of this.c)yield[c,c]}keys(){return this.c.values()}values(){return this.c.values()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=o;function s(t){const g=new Set;for(const c of t)g.add(M.ExtensionIdentifier.toKey(c));return g}e.extensionIdentifiersArrayToSet=s;function h(t){const g=new Map;for(const c of t)g.set(M.ExtensionIdentifier.toKey(c.identifier),c);return g}function p(t,g){return t.enabledApiProposals?t.enabledApiProposals.includes(g):!1}e.isProposedApiEnabled=p;function w(t,g){if(!p(t,g))throw new Error(`Extension '${t.identifier.value}' CANNOT use API proposal: ${g}.
Its package.json#enabledApiProposals-property declares: ${t.enabledApiProposals?.join(", ")??"[]"} but NOT ${g}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${t.identifier.value}`)}e.checkProposedApiEnabled=w;class A{constructor(g,c,u,l){this.codeLoadingTime=g,this.activateCallTime=c,this.activateResolvedTime=u,this.activationReason=l}}e.ActivationTimes=A;class v{constructor(g,c){this.description=g,this.value=c}}e.ExtensionPointContribution=v,e.ExtensionHostLogFileName="exthost";var i;(function(t){t[t.Normal=0]="Normal",t[t.Immediate=1]="Immediate"})(i=e.ActivationKind||(e.ActivationKind={}));function d(t){return{type:t.isBuiltin?0:1,isBuiltin:t.isBuiltin||t.isUserBuiltin,identifier:{id:(0,S.getGalleryExtensionId)(t.publisher,t.name),uuid:t.uuid},manifest:t,location:t.extensionLocation,targetPlatform:t.targetPlatform,validations:[],isValid:!0}}e.toExtension=d;function n(t,g){return{identifier:new M.ExtensionIdentifier((0,S.getExtensionId)(t.manifest.publisher,t.manifest.name)),isBuiltin:t.type===0,isUserBuiltin:t.type===1&&t.isBuiltin,isUnderDevelopment:!!g,extensionLocation:t.location,...t.manifest,uuid:t.identifier.uuid,targetPlatform:t.targetPlatform,browserNlsBundleUris:t.browserNlsBundleUris}}e.toExtensionDescription=n;class a{constructor(){this.onDidRegisterExtensions=r.Event.None,this.onDidChangeExtensionsStatus=r.Event.None,this.onDidChangeExtensions=r.Event.None,this.onWillActivateByEvent=r.Event.None,this.onDidChangeResponsiveChange=r.Event.None,this.extensions=[]}activateByEvent(g){return Promise.resolve(void 0)}activationEventIsDone(g){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(g){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(g,c){return Promise.resolve(0)}getInspectPorts(g,c){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(g){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=a}),define(Ce[191],ke([1,0,12,98,25,27,11,16]),function(ie,e,r,k,D,M,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class y{constructor(h,p,w,A){this.startup=h,this.codeLoadingTime=p,this.activateCallTime=w,this.activateResolvedTime=A}}e.ExtensionActivationTimes=y,y.NONE=new y(!1,-1,-1,-1);class T{constructor(h){this.a=h,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(h,p){return h===-1||p===-1?-1:p-h}build(){return new y(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=T;class N{constructor(h,p,w,A,v,i){this.activationFailed=h,this.activationFailedError=p,this.activationTimes=w,this.module=A,this.exports=v,this.subscriptions=i}}e.ActivatedExtension=N;class E extends N{constructor(h){super(!1,null,h,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=E;class f extends N{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=f;class b extends N{constructor(h){super(!0,h,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let m=class{constructor(h,p,w,A){this.g=A,this.a=h,this.b=p,this.c=w,this.d=new Map,this.f=Object.create(null)}dispose(){for(const[h,p]of this.d)p.dispose()}isActivated(h){const p=this.d.get(D.ExtensionIdentifier.toKey(h));return Boolean(p&&p.value)}getActivatedExtension(h){const p=this.d.get(D.ExtensionIdentifier.toKey(h));if(!p||!p.value)throw new Error(`Extension '${h.value}' is not known or not activated`);return p.value}async activateByEvent(h,p){if(this.f[h])return;const w=this.a.getExtensionDescriptionsForActivationEvent(h);await this.h(w.map(A=>({id:A.identifier,reason:{startup:p,extensionId:A.identifier,activationEvent:h}}))),this.f[h]=!0}activateById(h,p){const w=this.a.getExtensionDescription(h);if(!w)throw new Error(`Extension '${h}' is not known`);return this.h([{id:w.identifier,reason:p}])}async h(h){const p=h.filter(w=>!this.isActivated(w.id)).map(w=>this.j(w));await Promise.all(p.map(w=>w.wait()))}j(h){if(this.d.has(D.ExtensionIdentifier.toKey(h.id)))return this.d.get(D.ExtensionIdentifier.toKey(h.id));if(this.l(h.id))return this.k(h,null,[],null);const p=this.a.getExtensionDescription(h.id);if(!p){const v=new Error(`Cannot activate unknown extension '${h.id.value}'`),i=this.k(h,null,[],new b(v));return this.c.onExtensionActivationError(h.id,v,new M.MissingExtensionDependency(h.id.value)),i}const w=[],A=typeof p.extensionDependencies>"u"?[]:p.extensionDependencies;for(const v of A){if(this.m(v))continue;const i=this.d.get(D.ExtensionIdentifier.toKey(v));if(i){w.push(i);continue}if(this.l(v)){w.push(this.j({id:this.b.getExtensionDescription(v).identifier,reason:h.reason}));continue}const d=this.a.getExtensionDescription(v);if(d){if(!d.main&&!d.browser)continue;w.push(this.j({id:d.identifier,reason:h.reason}));continue}const n=p.displayName||p.identifier.value,a=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${v}'`),t=this.k(h,p.displayName,[],new b(a));return this.c.onExtensionActivationError(p.identifier,a,new M.MissingExtensionDependency(v)),t}return this.k(h,p.displayName,w,null)}k(h,p,w,A){const v=new o(h.id,p,h.reason,w,A,this.c,this.g);return this.d.set(D.ExtensionIdentifier.toKey(h.id),v),v}l(h){return k.ExtensionDescriptionRegistry.isHostExtension(h,this.a,this.b)}m(h){const p=this.b.getExtensionDescription(h);return p?!p.main&&!p.browser:!1}};m=qe([je(3,S.ILogService)],m),e.ExtensionsActivator=m;let o=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(h,p,w,A,v,i,d){this.c=h,this.d=p,this.f=w,this.g=A,this.h=v,this.j=i,this.k=d,this.a=new O.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let h=0;h<this.g.length;h++){const p=this.g[h];if(p.value&&!p.value.activationFailed){this.g.splice(h,1),h--;continue}if(p.value&&p.value.activationFailed){const w=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${p.friendlyName}' failed to activate`);w.detail=p.value.activationFailedError,this.h=new b(w),this.j.onExtensionActivationError(this.c,w,null);return}}this.g.length>0&&await Promise.race(this.g.map(h=>h.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(h){const p=new Error;if(h&&h.name&&(p.name=h.name),h&&h.message?p.message=`Activating extension '${this.c.value}' failed: ${h.message}.`:p.message=`Activating extension '${this.c.value}' failed: ${h}.`,h&&h.stack&&(p.stack=h.stack),this.h=new b(p),this.b&&r.isCancellationError(h))return;this.j.onExtensionActivationError(this.c,p,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(h)}}};o=qe([je(6,S.ILogService)],o)});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!D:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(ie,r):D?D.value=r:e.set(ie,r),r},Le=this&&this.__classPrivateFieldGet||function(ie,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(ie):k?k.value:e.get(ie)};define(Ce[7],ke([1,0,18,12,86,28,64,10,9,2,34,43,94,70,27]),function(ie,e,r,k,D,M,S,O,y,T,N,E,f,b,m){"use strict";var o,s,h,p,w,A,v,i,d,n,a,t,g,c,u,l,C,R,V,ee,K,L,B;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function P(z){return Object.assign(z,{apply:function(){const ne=arguments.length===1?[]:arguments[1];return Reflect.construct(z,ne,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(z,[]);{const[ne,...we]=arguments;return Reflect.construct(z,we,ne.constructor)}}})}var F;(function(z){z[z.Top=0]="Top",z[z.Bottom=1]="Bottom"})(F=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var H;(function(z){z[z.Command=0]="Command",z[z.Opener=1]="Opener"})(H=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let j=A=class{static from(...U){let ne=U;return new A(function(){if(ne){for(const we of ne)we&&typeof we.dispose=="function"&&we.dispose();ne=void 0}})}constructor(U){o.set(this,void 0),Je(this,o,U,"f")}dispose(){typeof Le(this,o,"f")=="function"&&(Le(this,o,"f").call(this),Je(this,o,void 0,"f"))}};o=new WeakMap,j=A=qe([P],j),e.Disposable=j;let le=v=class{static Min(...U){if(U.length===0)throw new TypeError;let ne=U[0];for(let we=1;we<U.length;we++){const Ge=U[we];Ge.isBefore(ne)&&(ne=Ge)}return ne}static Max(...U){if(U.length===0)throw new TypeError;let ne=U[0];for(let we=1;we<U.length;we++){const Ge=U[we];Ge.isAfter(ne)&&(ne=Ge)}return ne}static isPosition(U){if(!U)return!1;if(U instanceof v)return!0;const{line:ne,character:we}=U;return typeof ne=="number"&&typeof we=="number"}static of(U){if(U instanceof v)return U;if(this.isPosition(U))return new v(U.line,U.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(U,ne){if(U<0)throw(0,k.illegalArgument)("line must be non-negative");if(ne<0)throw(0,k.illegalArgument)("character must be non-negative");this.c=U,this.e=ne}isBefore(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<U.e}isBeforeOrEqual(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<=U.e}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this.c===U.c&&this.e===U.e}compareTo(U){return this.c<U.c?-1:this.c>U.line?1:this.e<U.e?-1:this.e>U.e?1:0}translate(U,ne=0){if(U===null||ne===null)throw(0,k.illegalArgument)();let we;return typeof U>"u"?we=0:typeof U=="number"?we=U:(we=typeof U.lineDelta=="number"?U.lineDelta:0,ne=typeof U.characterDelta=="number"?U.characterDelta:0),we===0&&ne===0?this:new v(this.line+we,this.character+ne)}with(U,ne=this.character){if(U===null||ne===null)throw(0,k.illegalArgument)();let we;return typeof U>"u"?we=this.line:typeof U=="number"?we=U:(we=typeof U.line=="number"?U.line:this.line,ne=typeof U.character=="number"?U.character:this.character),we===this.line&&ne===this.character?this:new v(we,ne)}toJSON(){return{line:this.line,character:this.character}}};le=v=qe([P],le),e.Position=le;let _=i=class{static isRange(U){return U instanceof i?!0:U?le.isPosition(U.start)&&le.isPosition(U.end):!1}static of(U){if(U instanceof i)return U;if(this.isRange(U))return new i(U.start,U.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(U,ne,we,Ge){let Ye,at;if(typeof U=="number"&&typeof ne=="number"&&typeof we=="number"&&typeof Ge=="number"?(Ye=new le(U,ne),at=new le(we,Ge)):le.isPosition(U)&&le.isPosition(ne)&&(Ye=le.of(U),at=le.of(ne)),!Ye||!at)throw new Error("Invalid arguments");Ye.isBefore(at)?(this.c=Ye,this.e=at):(this.c=at,this.e=Ye)}contains(U){return i.isRange(U)?this.contains(U.start)&&this.contains(U.end):le.isPosition(U)?!(le.of(U).isBefore(this.c)||this.e.isBefore(U)):!1}isEqual(U){return this.c.isEqual(U.c)&&this.e.isEqual(U.e)}intersection(U){const ne=le.Max(U.start,this.c),we=le.Min(U.end,this.e);if(!ne.isAfter(we))return new i(ne,we)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const ne=le.Min(U.start,this.c),we=le.Max(U.end,this.end);return new i(ne,we)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(U,ne=this.end){if(U===null||ne===null)throw(0,k.illegalArgument)();let we;return U?le.isPosition(U)?we=U:(we=U.start||this.start,ne=U.end||this.end):we=this.start,we.isEqual(this.c)&&ne.isEqual(this.end)?this:new i(we,ne)}toJSON(){return[this.start,this.end]}};_=i=qe([P],_),e.Range=_;let be=d=class extends _{static isSelection(U){return U instanceof d?!0:U?_.isRange(U)&&le.isPosition(U.anchor)&&le.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(U,ne,we,Ge){let Ye,at;if(typeof U=="number"&&typeof ne=="number"&&typeof we=="number"&&typeof Ge=="number"?(Ye=new le(U,ne),at=new le(we,Ge)):le.isPosition(U)&&le.isPosition(ne)&&(Ye=le.of(U),at=le.of(ne)),!Ye||!at)throw new Error("Invalid arguments");super(Ye,at),this.f=Ye,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};be=d=qe([P],be),e.Selection=be;class de{constructor(U,ne,we){if(typeof U!="string"||U.length===0)throw(0,k.illegalArgument)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,k.illegalArgument)("port");if(typeof we<"u"&&(typeof we!="string"||we.length===0||!/^[0-9A-Za-z_\-]+$/.test(we)))throw(0,k.illegalArgument)("connectionToken");this.host=U,this.port=Math.round(ne),this.connectionToken=we}}e.ResolvedAuthority=de;class ue extends Error{static NotAvailable(U,ne){return new ue(U,f.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(U){return new ue(U,f.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(U,ne=f.RemoteAuthorityResolverErrorCode.Unknown,we){super(U),this._message=U,this._code=ne,this._detail=we,Object.setPrototypeOf(this,ue.prototype)}}e.RemoteAuthorityResolverError=ue;var se;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(se=e.EndOfLine||(e.EndOfLine={}));var J;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(J=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let X=n=class{static isTextEdit(U){return U instanceof n?!0:U?_.isRange(U)&&typeof U.newText=="string":!1}static replace(U,ne){return new n(U,ne)}static insert(U,ne){return n.replace(new _(U,U),ne)}static delete(U){return n.replace(U,"")}static setEndOfLine(U){const ne=new n(new _(new le(0,0),new le(0,0)),"");return ne.newEol=U,ne}get range(){return this.c}set range(U){if(U&&!_.isRange(U))throw(0,k.illegalArgument)("range");this.c=U}get newText(){return this.e||""}set newText(U){if(U&&typeof U!="string")throw(0,k.illegalArgument)("newText");this.e=U}get newEol(){return this.f}set newEol(U){if(U&&typeof U!="number")throw(0,k.illegalArgument)("newEol");this.f=U}constructor(U,ne){this.c=U,this.e=ne}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};X=n=qe([P],X),e.TextEdit=X;let Z=a=class{static isNotebookCellEdit(U){return U instanceof a?!0:U?Kt.isNotebookRange(U)&&Array.isArray(U.newCells):!1}static replaceCells(U,ne){return new a(U,ne)}static insertCells(U,ne){return new a(new Kt(U,U),ne)}static deleteCells(U){return new a(U,[])}static updateCellMetadata(U,ne){const we=new a(new Kt(U,U),[]);return we.newCellMetadata=ne,we}static updateNotebookMetadata(U){const ne=new a(new Kt(0,0),[]);return ne.newNotebookMetadata=U,ne}constructor(U,ne){this.range=U,this.newCells=ne}};Z=a=qe([P],Z),e.NotebookEdit=Z;class he{static isSnippetTextEdit(U){return U instanceof he?!0:U?_.isRange(U.range)&&Ke.isSnippetString(U.snippet):!1}static replace(U,ne){return new he(U,ne)}static insert(U,ne){return he.replace(new _(U,U),ne)}constructor(U,ne){this.range=U,this.snippet=ne}}e.SnippetTextEdit=he;var Te;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(Te=e.FileEditType||(e.FileEditType={}));let Ne=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(U,ne,we,Ge){this.c.push({_type:1,from:U,to:ne,options:we,metadata:Ge})}createFile(U,ne,we){this.c.push({_type:1,from:void 0,to:U,options:ne,metadata:we})}deleteFile(U,ne,we){this.c.push({_type:1,from:U,to:void 0,options:ne,metadata:we})}e(U,ne,we){this.c.push({_type:3,metadata:we,uri:U,edit:{editType:5,metadata:ne},notebookMetadata:ne})}f(U,ne,we,Ge){const Ye=ne.start,at=ne.end;(Ye!==at||we.length>0)&&this.c.push({_type:5,uri:U,index:Ye,count:at-Ye,cells:we,metadata:Ge})}g(U,ne,we,Ge){this.c.push({_type:3,metadata:Ge,uri:U,edit:{editType:8,index:ne,metadata:we}})}replace(U,ne,we,Ge){this.c.push({_type:2,uri:U,edit:new X(ne,we),metadata:Ge})}insert(U,ne,we,Ge){this.replace(U,new _(ne,ne),we,Ge)}delete(U,ne,we){this.replace(U,ne,"",we)}has(U){return this.c.some(ne=>ne._type===2&&ne.uri.toString()===U.toString())}set(U,ne){if(ne)for(const we of ne){if(!we)continue;let Ge,Ye;Array.isArray(we)?(Ge=we[0],Ye=we[1]):Ge=we,Z.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(U,Ge.range.start,Ge.newCellMetadata,Ye):Ge.newNotebookMetadata?this.e(U,Ge.newNotebookMetadata,Ye):this.f(U,Ge.range,Ge.newCells,Ye):he.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:U,range:Ge.range,edit:Ge.snippet,metadata:Ye}):this.c.push({_type:2,uri:U,edit:Ge,metadata:Ye})}else{for(let we=0;we<this.c.length;we++){const Ge=this.c[we];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===U.toString()&&(this.c[we]=void 0);break}}(0,r.coalesceInPlace)(this.c)}}get(U){const ne=[];for(const we of this.c)we._type===2&&we.uri.toString()===U.toString()&&ne.push(we.edit);return ne}entries(){const U=new M.ResourceMap;for(const ne of this.c)if(ne._type===2){let we=U.get(ne.uri);we||(we=[ne.uri,[]],U.set(ne.uri,we)),we[1].push(ne.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Ne=qe([P],Ne),e.WorkspaceEdit=Ne;let Ke=t=class{static isSnippetString(U){return U instanceof t?!0:U?typeof U.value=="string":!1}static c(U){return U.replace(/\$|}|\\/g,"\\$&")}constructor(U){this.e=1,this.value=U||""}appendText(U){return this.value+=t.c(U),this}appendTabstop(U=this.e++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,ne=this.e++){if(typeof U=="function"){const we=new t;we.e=this.e,U(we),this.e=we.e,U=we.value}else U=t.c(U);return this.value+="${",this.value+=ne,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,ne=this.e++){const we=U.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=we,this.value+="|}",this}appendVariable(U,ne){if(typeof ne=="function"){const we=new t;we.e=this.e,ne(we),this.e=we.e,ne=we.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};Ke=t=qe([P],Ke),e.SnippetString=Ke;var Pe;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(Pe=e.DiagnosticTag||(e.DiagnosticTag={}));var Se;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(Se=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Ie=g=class{static isLocation(U){return U instanceof g?!0:U?_.isRange(U.range)&&T.URI.isUri(U.uri):!1}constructor(U,ne){if(this.uri=U,ne)if(_.isRange(ne))this.range=_.of(ne);else if(le.isPosition(ne))this.range=new _(ne,ne);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};Ie=g=qe([P],Ie),e.Location=Ie;let oe=class{static is(U){return U?typeof U.message=="string"&&U.location&&_.isRange(U.location.range)&&T.URI.isUri(U.location.uri):!1}constructor(U,ne){this.location=U,this.message=ne}static isEqual(U,ne){return U===ne?!0:!U||!ne?!1:U.message===ne.message&&U.location.range.isEqual(ne.location.range)&&U.location.uri.toString()===ne.location.uri.toString()}};oe=qe([P],oe),e.DiagnosticRelatedInformation=oe;let ce=class{constructor(U,ne,we=Se.Error){if(!_.isRange(U))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=U,this.message=ne,this.severity=we}toJSON(){return{severity:Se[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,ne){return U===ne?!0:!U||!ne?!1:U.message===ne.message&&U.severity===ne.severity&&U.code===ne.code&&U.severity===ne.severity&&U.source===ne.source&&U.range.isEqual(ne.range)&&(0,r.equals)(U.tags,ne.tags)&&(0,r.equals)(U.relatedInformation,ne.relatedInformation,oe.isEqual)}};ce=qe([P],ce),e.Diagnostic=ce;let Y=class{constructor(U,ne){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=ne}};Y=qe([P],Y),e.Hover=Y;var I;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(I=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let $=class{constructor(U,ne=I.Text){this.range=U,this.kind=ne}toJSON(){return{range:this.range,kind:I[this.kind]}}};$=qe([P],$),e.DocumentHighlight=$;var W;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(W=e.SymbolKind||(e.SymbolKind={}));var q;(function(z){z[z.Deprecated=1]="Deprecated"})(q=e.SymbolTag||(e.SymbolTag={}));let te=c=class{static validate(U){if(!U.name)throw new Error("name must not be falsy")}constructor(U,ne,we,Ge,Ye){this.name=U,this.kind=ne,this.containerName=Ye,typeof we=="string"&&(this.containerName=we),Ge instanceof Ie?this.location=Ge:we instanceof _&&(this.location=new Ie(Ge,we)),c.validate(this)}toJSON(){return{name:this.name,kind:W[this.kind],location:this.location,containerName:this.containerName}}};te=c=qe([P],te),e.SymbolInformation=te;let fe=u=class{static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children?.forEach(u.validate)}constructor(U,ne,we,Ge,Ye){this.name=U,this.detail=ne,this.kind=we,this.range=Ge,this.selectionRange=Ye,this.children=[],u.validate(this)}};fe=u=qe([P],fe),e.DocumentSymbol=fe;var ye;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(ye=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(U,ne){this.title=U,this.kind=ne}};ae=qe([P],ae),e.CodeAction=ae;let ve=l=class{constructor(U){this.value=U}append(U){return new l(this.value?this.value+l.c+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+l.c)}};ve.c=".",ve=l=qe([P],ve),e.CodeActionKind=ve,ve.Empty=new ve(""),ve.QuickFix=ve.Empty.append("quickfix"),ve.Refactor=ve.Empty.append("refactor"),ve.RefactorExtract=ve.Refactor.append("extract"),ve.RefactorInline=ve.Refactor.append("inline"),ve.RefactorMove=ve.Refactor.append("move"),ve.RefactorRewrite=ve.Refactor.append("rewrite"),ve.Source=ve.Empty.append("source"),ve.SourceOrganizeImports=ve.Source.append("organizeImports"),ve.SourceFixAll=ve.Source.append("fixAll");let Ee=class{constructor(U,ne){if(this.range=U,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Ee=qe([P],Ee),e.SelectionRange=Ee;class We{constructor(U,ne,we,Ge,Ye,at){this.kind=U,this.name=ne,this.detail=we,this.uri=Ge,this.range=Ye,this.selectionRange=at}}e.CallHierarchyItem=We;class He{constructor(U,ne){this.fromRanges=ne,this.from=U}}e.CallHierarchyIncomingCall=He;class tt{constructor(U,ne){this.fromRanges=ne,this.to=U}}e.CallHierarchyOutgoingCall=tt;var Xe;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(Xe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(U,ne){this.range=U,this.command=ne}get isResolved(){return!!this.command}};et=qe([P],et),e.CodeLens=et;let it=C=class{static isMarkdownString(U){return U instanceof C?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}constructor(U,ne=!1){s.set(this,void 0),Je(this,s,new D.MarkdownString(U,{supportThemeIcons:ne}),"f")}get value(){return Le(this,s,"f").value}set value(U){Le(this,s,"f").value=U}get isTrusted(){return Le(this,s,"f").isTrusted}set isTrusted(U){Le(this,s,"f").isTrusted=U}get supportThemeIcons(){return Le(this,s,"f").supportThemeIcons}set supportThemeIcons(U){Le(this,s,"f").supportThemeIcons=U}get supportHtml(){return Le(this,s,"f").supportHtml}set supportHtml(U){Le(this,s,"f").supportHtml=U}get baseUri(){return Le(this,s,"f").baseUri}set baseUri(U){Le(this,s,"f").baseUri=U}appendText(U){return Le(this,s,"f").appendText(U),this}appendMarkdown(U){return Le(this,s,"f").appendMarkdown(U),this}appendCodeblock(U,ne){return Le(this,s,"f").appendCodeblock(ne??"",U),this}};s=new WeakMap,it=C=qe([P],it),e.MarkdownString=it;let dt=class{constructor(U,ne){this.label=U,this.documentation=ne}};dt=qe([P],dt),e.ParameterInformation=dt;let Fe=class{constructor(U,ne){this.label=U,this.documentation=ne,this.parameters=[]}};Fe=qe([P],Fe),e.SignatureInformation=Fe;let ot=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ot=qe([P],ot),e.SignatureHelp=ot;var Q;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(Q=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var x;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(x=e.InlayHintKind||(e.InlayHintKind={}));let pe=class{constructor(U){this.value=U}};pe=qe([P],pe),e.InlayHintLabelPart=pe;let Me=class{constructor(U,ne,we){this.position=U,this.label=ne,this.kind=we}};Me=qe([P],Me),e.InlayHint=Me;var ze;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ze=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ve;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(Ve=e.CompletionItemKind||(e.CompletionItemKind={}));var _e;(function(z){z[z.Deprecated=1]="Deprecated"})(_e=e.CompletionItemTag||(e.CompletionItemTag={}));let nt=class{constructor(U,ne){this.label=U,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&Ve[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};nt=qe([P],nt),e.CompletionItem=nt;let vt=class{constructor(U=[],ne=!1){this.items=U,this.isIncomplete=ne}};vt=qe([P],vt),e.CompletionList=vt;let wt=class{constructor(U,ne,we){this.insertText=U,this.range=ne,this.command=we}};wt=qe([P],wt),e.InlineSuggestion=wt;let Ct=class{constructor(U){this.commands=void 0,this.items=U}};Ct=qe([P],Ct),e.InlineSuggestionList=Ct;var jt;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(jt=e.ViewColumn||(e.ViewColumn={}));var rt;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(rt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var mt;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(mt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ft;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(Ft=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var xt;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(xt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Pt;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(Pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ht;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(ht=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var kt;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(kt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(z){function U(ne){switch(ne){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=U}(Pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let $t=class{constructor(U,ne){if(ne&&!T.URI.isUri(ne))throw(0,k.illegalArgument)("target");if(!_.isRange(U)||U.isEmpty)throw(0,k.illegalArgument)("range");this.range=U,this.target=ne}};$t=qe([P],$t),e.DocumentLink=$t;let Ot=class{constructor(U,ne,we,Ge){this.red=U,this.green=ne,this.blue=we,this.alpha=Ge}};Ot=qe([P],Ot),e.Color=Ot;let xe=class{constructor(U,ne){if(ne&&!(ne instanceof Ot))throw(0,k.illegalArgument)("color");if(!_.isRange(U)||U.isEmpty)throw(0,k.illegalArgument)("range");this.range=U,this.color=ne}};xe=qe([P],xe),e.ColorInformation=xe;let Nt=class{constructor(U){if(!U||typeof U!="string")throw(0,k.illegalArgument)("label");this.label=U}};Nt=qe([P],Nt),e.ColorPresentation=Nt;var Mt;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(Mt=e.ColorFormat||(e.ColorFormat={}));var zt;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(zt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var ft;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(ft=e.TerminalExitReason||(e.TerminalExitReason={}));class De{constructor(U,ne,we){if(this.startIndex=U,this.length=ne,this.tooltip=we,typeof U!="number"||U<0)throw(0,k.illegalArgument)("startIndex");if(typeof ne!="number"||ne<1)throw(0,k.illegalArgument)("length");if(we!==void 0&&typeof we!="string")throw(0,k.illegalArgument)("tooltip")}}e.TerminalLink=De;class Ae{constructor(U){this.uri=U}}e.TerminalQuickFixOpener=Ae;class ge{constructor(U){this.terminalCommand=U}}e.TerminalQuickFixCommand=ge;var G;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})(G=e.TerminalLocation||(e.TerminalLocation={}));class Re{constructor(U){if(this.options=U,typeof U!="object")throw(0,k.illegalArgument)("options")}}e.TerminalProfile=Re;var $e;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})($e=e.TaskRevealKind||(e.TaskRevealKind={}));var Qe;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(Qe=e.TaskPanelKind||(e.TaskPanelKind={}));let Be=R=class{static from(U){switch(U){case"clean":return R.Clean;case"build":return R.Build;case"rebuild":return R.Rebuild;case"test":return R.Test;default:return}}constructor(U,ne){if(this.label=ne,typeof U!="string"||typeof ne!="string")throw(0,k.illegalArgument)("name");this.c=U}get id(){return this.c}};Be.Clean=new R("clean","Clean"),Be.Build=new R("build","Build"),Be.Rebuild=new R("rebuild","Rebuild"),Be.Test=new R("test","Test"),Be=R=qe([P],Be),e.TaskGroup=Be;function Ze(z){let U="";for(let ne=0;ne<z.length;ne++)U+=z[ne].replace(/,/g,",,")+",";return U}let ct=class{constructor(U,ne,we){if(typeof U!="string")throw(0,k.illegalArgument)("process");this.e=[],this.c=U,ne!==void 0&&(Array.isArray(ne)?(this.e=ne,this.f=we):this.f=ne)}get process(){return this.c}set process(U){if(typeof U!="string")throw(0,k.illegalArgument)("process");this.c=U}get args(){return this.e}set args(U){Array.isArray(U)||(U=[]),this.e=U}get options(){return this.f}set options(U){this.f=U}computeId(){const U=[];if(U.push("process"),this.c!==void 0&&U.push(this.c),this.e&&this.e.length>0)for(const ne of this.e)U.push(ne);return Ze(U)}};ct=qe([P],ct),e.ProcessExecution=ct;let Tt=class{constructor(U,ne,we){if(this.f=[],Array.isArray(ne)){if(!U)throw(0,k.illegalArgument)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,k.illegalArgument)("command");this.e=U,this.f=ne,this.g=we}else{if(typeof U!="string")throw(0,k.illegalArgument)("commandLine");this.c=U,this.g=ne}}get commandLine(){return this.c}set commandLine(U){if(typeof U!="string")throw(0,k.illegalArgument)("commandLine");this.c=U}get command(){return this.e?this.e:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,k.illegalArgument)("command");this.e=U}get args(){return this.f}set args(U){this.f=U||[]}get options(){return this.g}set options(U){this.g=U}computeId(){const U=[];if(U.push("shell"),this.c!==void 0&&U.push(this.c),this.e!==void 0&&U.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ne of this.f)U.push(typeof ne=="string"?ne:ne.value);return Ze(U)}};Tt=qe([P],Tt),e.ShellExecution=Tt;var bt;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(bt=e.ShellQuoting||(e.ShellQuoting={}));var Et;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(Et=e.TaskScope||(e.TaskScope={}));class It{constructor(U){this.c=U}computeId(){return"customExecution"+(0,N.generateUuid)()}set callback(U){this.c=U}get callback(){return this.c}}e.CustomExecution=It;let St=V=class{constructor(U,ne,we,Ge,Ye,at){this.j=!1,this.k=this.definition=U;let lt;typeof ne=="string"?(this.m=this.name=ne,this.t=this.source=we,this.execution=Ge,lt=Ye,this.j=!0):ne===Et.Global||ne===Et.Workspace?(this.target=ne,this.m=this.name=we,this.t=this.source=Ge,this.execution=Ye,lt=at):(this.target=ne,this.m=this.name=we,this.t=this.source=Ge,this.execution=Ye,lt=at),typeof lt=="string"?(this.o=[lt],this.q=!0):Array.isArray(lt)?(this.o=lt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(U){this.h=U}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof ct?this.k={type:V.e,id:this.n.computeId()}:this.n instanceof Tt?this.k={type:V.f,id:this.n.computeId()}:this.n instanceof It?this.k={type:V.c,id:this.n.computeId()}:this.k={type:V.g,id:(0,N.generateUuid)()}}get definition(){return this.k}set definition(U){if(U==null)throw(0,k.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=U}get scope(){return this.l}set target(U){this.y(),this.l=U}get name(){return this.m}set name(U){if(typeof U!="string")throw(0,k.illegalArgument)("name");this.y(),this.m=U}get execution(){return this.n}set execution(U){U===null&&(U=void 0),this.y(),this.n=U;const ne=this.k.type;(V.g===ne||V.e===ne||V.f===ne||V.c===ne)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(U){if(Array.isArray(U))this.y(),this.o=U,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.y(),this.r=U}get source(){return this.t}set source(U){if(typeof U!="string"||U.length===0)throw(0,k.illegalArgument)("source must be a string of length > 0");this.y(),this.t=U}get group(){return this.u}set group(U){U===null&&(U=void 0),this.y(),this.u=U}get detail(){return this.x}set detail(U){U===null&&(U=void 0),this.x=U}get presentationOptions(){return this.v}set presentationOptions(U){U==null&&(U=Object.create(null)),this.y(),this.v=U}get runOptions(){return this.w}set runOptions(U){U==null&&(U=Object.create(null)),this.y(),this.w=U}};St.c="customExecution",St.e="process",St.f="shell",St.g="$empty",St=V=qe([P],St),e.Task=St;var yt;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(yt=e.ProgressLocation||(e.ProgressLocation={}));var qt;(function(z){function U(ne){const we=ne;return(0,y.isNumber)(we.value)?we.tooltip&&!(0,y.isString)(we.tooltip)?(console.log("INVALID view badge, invalid tooltip",we.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",we.value),!1)}z.isViewBadge=U})(qt=e.ViewBadge||(e.ViewBadge={}));let Jt=ee=class{static isTreeItem(U,ne){if(U instanceof ee)return!0;const we=U;if(we.label!==void 0&&!(0,y.isString)(we.label)&&!we.label?.label)return console.log("INVALID tree item, invalid label",we.label),!1;if(we.id!==void 0&&!(0,y.isString)(we.id))return console.log("INVALID tree item, invalid id",we.id),!1;if(we.iconPath!==void 0&&!(0,y.isString)(we.iconPath)&&!T.URI.isUri(we.iconPath)&&(!we.iconPath||!(0,y.isString)(we.iconPath.id))){const Ge=we.iconPath;if(!Ge||!(0,y.isString)(Ge.light)&&!T.URI.isUri(Ge.light)&&!(0,y.isString)(Ge.dark)&&!T.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",we.iconPath),!1}if(we.description!==void 0&&!(0,y.isString)(we.description)&&typeof we.description!="boolean")return console.log("INVALID tree item, invalid description",we.description),!1;if(we.resourceUri!==void 0&&!T.URI.isUri(we.resourceUri))return console.log("INVALID tree item, invalid resourceUri",we.resourceUri),!1;if(we.tooltip!==void 0&&!(0,y.isString)(we.tooltip)&&!(we.tooltip instanceof it))return console.log("INVALID tree item, invalid tooltip",we.tooltip),!1;if(we.command!==void 0&&!we.command.command)return console.log("INVALID tree item, invalid command",we.command),!1;if(we.collapsibleState!==void 0&&we.collapsibleState<pt.None&&we.collapsibleState>pt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",we.collapsibleState),!1;if(we.contextValue!==void 0&&!(0,y.isString)(we.contextValue))return console.log("INVALID tree item, invalid contextValue",we.contextValue),!1;if(we.accessibilityInformation!==void 0&&!we.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",we.accessibilityInformation),!1;if(we.checkboxState!==void 0){(0,m.checkProposedApiEnabled)(ne,"treeItemCheckbox");const Ge=(0,y.isNumber)(we.checkboxState)?we.checkboxState:(0,y.isObject)(we.checkboxState)&&(0,y.isNumber)(we.checkboxState.state)?we.checkboxState.state:void 0,Ye=!(0,y.isNumber)(we.checkboxState)&&(0,y.isObject)(we.checkboxState)?we.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==si.Checked&&Ge!==si.Unchecked||Ye!==void 0&&!(0,y.isString)(Ye))return console.log("INVALID tree item, invalid checkboxState",we.checkboxState),!1}return!0}constructor(U,ne=pt.None){this.collapsibleState=ne,T.URI.isUri(U)?this.resourceUri=U:this.label=U}};Jt=ee=qe([P],Jt),e.TreeItem=Jt;var pt;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(pt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var si;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(si=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let oi=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(U,ne){this.value=U,this.id=ne??(0,N.generateUuid)()}};oi=qe([P],oi),e.DataTransferItem=oi;let Zt=class{constructor(U){h.set(this,new Map);for(const[ne,we]of U??[]){const Ge=Le(this,h,"f").get(ne);Ge?Ge.push(we):Le(this,h,"f").set(ne,[we])}}get(U){return Le(this,h,"f").get(U)?.[0]}set(U,ne){Le(this,h,"f").set(U,[ne])}forEach(U,ne){for(const[we,Ge]of Le(this,h,"f"))for(const Ye of Ge)U.call(ne,Ye,we,this)}*[(h=new WeakMap,Symbol.iterator)](){for(const[U,ne]of Le(this,h,"f"))for(const we of ne)yield[U,we]}};Zt=qe([P],Zt),e.DataTransfer=Zt;let vi=class{constructor(U){this.insertText=U}};vi=qe([P],vi),e.DocumentDropEdit=vi;let At=class{constructor(U){this.insertText=U}};At=qe([P],At),e.DocumentPasteEdit=At;let Wt=class{constructor(U,ne){this.id=U,this.color=ne}static isThemeIcon(U){return typeof U.id!="string"?(console.log("INVALID ThemeIcon, invalid id",U.id),!1):!0}};Wt=qe([P],Wt),e.ThemeIcon=Wt,Wt.File=new Wt("file"),Wt.Folder=new Wt("folder");let bi=class{constructor(U){this.id=U}};bi=qe([P],bi),e.ThemeColor=bi;var ai;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(ai=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ei=class{get base(){return this.c}set base(U){this.c=U,this.e=T.URI.file(U)}get baseUri(){return this.e}set baseUri(U){this.e=U,this.c=U.fsPath}constructor(U,ne){if(typeof U!="string"&&(!U||!T.URI.isUri(U)&&!T.URI.isUri(U.uri)))throw(0,k.illegalArgument)("base");if(typeof ne!="string")throw(0,k.illegalArgument)("pattern");typeof U=="string"?this.baseUri=T.URI.file(U):T.URI.isUri(U)?this.baseUri=U:this.baseUri=U.uri,this.pattern=ne}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ei=qe([P],ei),e.RelativePattern=ei;const ut=new WeakMap;function $i(z,U){ut.set(z,U)}e.setBreakpointId=$i;let Ut=class{constructor(U,ne,we,Ge){this.enabled=typeof U=="boolean"?U:!0,typeof ne=="string"&&(this.condition=ne),typeof we=="string"&&(this.hitCondition=we),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this.c||(this.c=ut.get(this)??(0,N.generateUuid)()),this.c}};Ut=qe([P],Ut),e.Breakpoint=Ut;let Qt=class extends Ut{constructor(U,ne,we,Ge,Ye){if(super(ne,we,Ge,Ye),U===null)throw(0,k.illegalArgument)("location");this.location=U}};Qt=qe([P],Qt),e.SourceBreakpoint=Qt;let ci=class extends Ut{constructor(U,ne,we,Ge,Ye){super(ne,we,Ge,Ye),this.functionName=U}};ci=qe([P],ci),e.FunctionBreakpoint=ci;let Ei=class extends Ut{constructor(U,ne,we,Ge,Ye,at,lt){if(super(Ge,Ye,at,lt),!ne)throw(0,k.illegalArgument)("dataId");this.label=U,this.dataId=ne,this.canPersist=we}};Ei=qe([P],Ei),e.DataBreakpoint=Ei;let wi=class{constructor(U,ne,we){this.command=U,this.args=ne||[],this.options=we}};wi=qe([P],wi),e.DebugAdapterExecutable=wi;let ui=class{constructor(U,ne){this.port=U,this.host=ne}};ui=qe([P],ui),e.DebugAdapterServer=ui;let Si=class{constructor(U){this.path=U}};Si=qe([P],Si),e.DebugAdapterNamedPipeServer=Si;let li=class{constructor(U){this.implementation=U}};li=qe([P],li),e.DebugAdapterInlineImplementation=li;let ti=class{constructor(U,ne){this.range=U,this.expression=ne}};ti=qe([P],ti),e.EvaluatableExpression=ti;var Bi;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Bi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let ii=class{constructor(U,ne){this.range=U,this.text=ne}};ii=qe([P],ii),e.InlineValueText=ii;let ni=class{constructor(U,ne,we=!0){this.range=U,this.variableName=ne,this.caseSensitiveLookup=we}};ni=qe([P],ni),e.InlineValueVariableLookup=ni;let yi=class{constructor(U,ne){this.range=U,this.expression=ne}};yi=qe([P],yi),e.InlineValueEvaluatableExpression=yi;let Di=class{constructor(U,ne){this.frameId=U,this.stoppedLocation=ne}};Di=qe([P],Di),e.InlineValueContext=Di;var ri;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(ri=e.FileChangeType||(e.FileChangeType={}));let Ii=K=class extends Error{static FileExists(U){return new K(U,E.FileSystemProviderErrorCode.FileExists,K.FileExists)}static FileNotFound(U){return new K(U,E.FileSystemProviderErrorCode.FileNotFound,K.FileNotFound)}static FileNotADirectory(U){return new K(U,E.FileSystemProviderErrorCode.FileNotADirectory,K.FileNotADirectory)}static FileIsADirectory(U){return new K(U,E.FileSystemProviderErrorCode.FileIsADirectory,K.FileIsADirectory)}static NoPermissions(U){return new K(U,E.FileSystemProviderErrorCode.NoPermissions,K.NoPermissions)}static Unavailable(U){return new K(U,E.FileSystemProviderErrorCode.Unavailable,K.Unavailable)}constructor(U,ne=E.FileSystemProviderErrorCode.Unknown,we){super(T.URI.isUri(U)?U.toString(!0):U),this.code=we?.name??"Unknown",(0,E.markAsFileSystemProviderError)(this,ne),Object.setPrototypeOf(this,K.prototype),typeof Error.captureStackTrace=="function"&&typeof we=="function"&&Error.captureStackTrace(this,we)}};Ii=K=qe([P],Ii),e.FileSystemError=Ii;let Ci=class{constructor(U,ne,we){this.start=U,this.end=ne,this.kind=we}};Ci=qe([P],Ci),e.FoldingRange=Ci;var zi;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(zi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Wi;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(Wi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Hi;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(Hi=e.CommentMode||(e.CommentMode={}));var ki;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(ki=e.CommentThreadState||(e.CommentThreadState={}));class Ri{constructor(U,ne=[]){this.tokenTypes=U,this.tokenModifiers=ne}}e.SemanticTokensLegend=Ri;function Oi(z){return typeof z>"u"||(0,y.isStringArray)(z)}class Ue{constructor(U){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,U){this.l=!0;for(let ne=0,we=U.tokenTypes.length;ne<we;ne++)this.j.set(U.tokenTypes[ne],ne);for(let ne=0,we=U.tokenModifiers.length;ne<we;ne++)this.k.set(U.tokenModifiers[ne],ne)}}push(U,ne,we,Ge,Ye){if(typeof U=="number"&&typeof ne=="number"&&typeof we=="number"&&typeof Ge=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.n(U,ne,we,Ge,Ye);if(_.isRange(U)&&typeof ne=="string"&&Oi(we))return this.m(U,ne,we);throw(0,k.illegalArgument)()}m(U,ne,we){if(!this.l)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ne))throw new Error("`tokenType` is not in the provided legend");const Ge=U.start.line,Ye=U.start.character,at=U.end.character-U.start.character,lt=this.j.get(ne);let Lt=0;if(we)for(const Vt of we){if(!this.k.has(Vt))throw new Error("`tokenModifier` is not in the provided legend");const Gt=this.k.get(Vt);Lt|=1<<Gt>>>0}this.n(Ge,Ye,at,lt,Lt)}n(U,ne,we,Ge,Ye){if(this.f&&(U<this.c||U===this.c&&ne<this.e)){this.f=!1;const Lt=this.g.length/5|0;let Vt=0,Gt=0;for(let Xt=0;Xt<Lt;Xt++){let _t=this.g[5*Xt],Pi=this.g[5*Xt+1];_t===0?(_t=Vt,Pi+=Gt):_t+=Vt,this.g[5*Xt]=_t,this.g[5*Xt+1]=Pi,Vt=_t,Gt=Pi}}let at=U,lt=ne;this.f&&this.h>0&&(at-=this.c,at===0&&(lt-=this.e)),this.g[this.h++]=at,this.g[this.h++]=lt,this.g[this.h++]=we,this.g[this.h++]=Ge,this.g[this.h++]=Ye,this.c=U,this.e=ne}static o(U){const ne=[],we=U.length/5|0;for(let lt=0;lt<we;lt++)ne[lt]=lt;ne.sort((lt,Lt)=>{const Vt=U[5*lt],Gt=U[5*Lt];if(Vt===Gt){const Xt=U[5*lt+1],_t=U[5*Lt+1];return Xt-_t}return Vt-Gt});const Ge=new Uint32Array(U.length);let Ye=0,at=0;for(let lt=0;lt<we;lt++){const Lt=5*ne[lt],Vt=U[Lt+0],Gt=U[Lt+1],Xt=U[Lt+2],_t=U[Lt+3],Pi=U[Lt+4],sn=Vt-Ye,Rn=sn===0?Gt-at:Gt,Ai=5*lt;Ge[Ai+0]=sn,Ge[Ai+1]=Rn,Ge[Ai+2]=Xt,Ge[Ai+3]=_t,Ge[Ai+4]=Pi,Ye=Vt,at=Gt}return Ge}build(U){return this.f?new Ht(new Uint32Array(this.g),U):new Ht(Ue.o(this.g),U)}}e.SemanticTokensBuilder=Ue;class Ht{constructor(U,ne){this.resultId=ne,this.data=U}}e.SemanticTokens=Ht;class Li{constructor(U,ne,we){this.start=U,this.deleteCount=ne,this.data=we}}e.SemanticTokensEdit=Li;class gt{constructor(U,ne){this.resultId=ne,this.edits=U}}e.SemanticTokensEdits=gt;var Vi;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(Vi=e.DebugConsoleMode||(e.DebugConsoleMode={}));let di=class{constructor(){}};di.Back={iconPath:new Wt("arrow-left")},di=qe([P],di),e.QuickInputButtons=di;var Fi;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(Fi=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ji;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})(ji=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var hi;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(hi=e.ExtensionKind||(e.ExtensionKind={}));class qi{static validate(U){if(typeof U.badge=="string"){let ne=(0,O.nextCharLength)(U.badge,0);if(ne<U.badge.length&&(ne+=(0,O.nextCharLength)(U.badge,ne)),U.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}else if(U.badge&&!Wt.isThemeIcon(U.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty");return!0}constructor(U,ne,we){this.badge=U,this.tooltip=ne,this.color=we}}e.FileDecoration=qi;let Ti=class{constructor(U){this.kind=U}};Ti=qe([P],Ti),e.ColorTheme=Ti;var Ki;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(Ki=e.ColorThemeKind||(e.ColorThemeKind={}));class Kt{static isNotebookRange(U){return U instanceof Kt?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(U,ne){if(U<0)throw(0,k.illegalArgument)("start must be positive");if(ne<0)throw(0,k.illegalArgument)("end must be positive");U<=ne?(this.c=U,this.e=ne):(this.c=ne,this.e=U)}with(U){let ne=this.c,we=this.e;return U.start!==void 0&&(ne=U.start),U.end!==void 0&&(we=U.end),ne===this.c&&we===this.e?this:new Kt(ne,we)}}e.NotebookRange=Kt;class fi{static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(ne=>fi.isNotebookCellData(ne))}static isNotebookCellData(U){return!0}constructor(U,ne,we,Ge,Ye,at,lt){this.kind=U,this.value=ne,this.languageId=we,this.mime=Ge,this.outputs=Ye??[],this.metadata=at,this.executionSummary=lt,fi.validate(this)}}e.NotebookCellData=fi;class Gi{constructor(U){this.cells=U}}e.NotebookData=Gi;class Bt{static isNotebookCellOutputItem(U){return U instanceof Bt?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const ne={name:U.name,message:U.message,stack:U.stack};return Bt.json(ne,"application/vnd.code.notebook.error")}static stdout(U){return Bt.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return Bt.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,ne="application/octet-stream"){return new Bt(U,ne)}static text(U,ne=S.Mimes.text){const we=Le(Bt,p,"f",w).encode(String(U));return new Bt(we,ne)}static json(U,ne="text/x-json"){const we=JSON.stringify(U,void 0,"	");return Bt.text(we,ne)}constructor(U,ne){this.data=U,this.mime=ne;const we=(0,S.normalizeMimeType)(ne,!0);if(!we)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=we}}e.NotebookCellOutputItem=Bt,p=Bt,w={value:new TextEncoder};class mi{static isNotebookCellOutput(U){return U instanceof mi?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&Array.isArray(U.items)}static ensureUniqueMimeTypes(U,ne=!1){const we=new Set,Ge=new Set;for(let Ye=0;Ye<U.length;Ye++){const at=U[Ye],lt=(0,S.normalizeMimeType)(at.mime);if(!we.has(lt)||(0,b.isTextStreamMime)(lt)){we.add(lt);continue}Ge.add(Ye),ne&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ge.size===0?U:U.filter((Ye,at)=>!Ge.has(at))}constructor(U,ne,we){this.items=mi.ensureUniqueMimeTypes(U,!0),typeof ne=="string"?(this.id=ne,this.metadata=we):(this.id=(0,N.generateUuid)(),this.metadata=ne??we)}}e.NotebookCellOutput=mi;var xi;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(xi=e.NotebookCellKind||(e.NotebookCellKind={}));var Xi;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(Xi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var re;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(re=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var me;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(me=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Oe{constructor(U,ne){this.text=U,this.alignment=ne}}e.NotebookCellStatusBarItem=Oe;var st;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(st=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var Dt;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred",z[z.Hidden=-1]="Hidden"})(Dt=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class Rt{constructor(U,ne=[]){this.uri=U,this.provides=(0,r.asArray)(ne)}}e.NotebookRendererScript=Rt;class un{constructor(U){this.label=U}}e.NotebookKernelSourceAction=un;let Qi=class{constructor(U,ne){this.label=U,this.timestamp=ne}};Qi=qe([P],Qi),e.TimelineItem=Qi;var ln;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(ln=e.ExtensionMode||(e.ExtensionMode={}));var dn;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(dn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var hn;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(hn=e.StandardTokenType||(e.StandardTokenType={}));class fn{constructor(U,ne){this.ranges=U,this.wordPattern=ne}}e.LinkedEditingRanges=fn;class mn{constructor(U,ne){this.c=U,this.e=ne}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=mn;var gn;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(gn=e.TestResultState||(e.TestResultState={}));var pn;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(pn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Ni=class{constructor(U=void 0,ne=void 0,we=void 0){this.include=U,this.exclude=ne,this.profile=we}};Ni=qe([P],Ni),e.TestRunRequest=Ni;let _i=class extends Ni{constructor(U=void 0,ne=void 0,we=void 0,Ge=!1){super(U,ne,we),this.continuous=Ge}};_i=qe([P],_i),e.TestRunRequest2=_i;let Yi=L=class{static diff(U,ne,we){const Ge=new L(U);return Ge.expectedOutput=ne,Ge.actualOutput=we,Ge}constructor(U){this.message=U}};Yi=L=qe([P],Yi),e.TestMessage=Yi;let Ji=class{constructor(U){this.id=U}};Ji=qe([P],Ji),e.TestTag=Ji;let gi=class{constructor(U,ne){this.covered=U,this.total=ne}};gi=qe([P],gi),e.CoveredCount=gi;let Zi=B=class{static fromDetails(U,ne){const we=new gi(0,0),Ge=new gi(0,0),Ye=new gi(0,0);for(const lt of ne)if("branches"in lt){we.total+=1,we.covered+=lt.executionCount>0?1:0;for(const Lt of lt.branches)Ge.total+=1,Ge.covered+=Lt.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=lt.executionCount>0?1:0;const at=new B(U,we,Ge.total>0?Ge:void 0,Ye.total>0?Ye:void 0);return at.detailedCoverage=ne,at}constructor(U,ne,we,Ge){this.uri=U,this.statementCoverage=ne,this.branchCoverage=we,this.functionCoverage=Ge}};Zi=B=qe([P],Zi),e.FileCoverage=Zi;let en=class{constructor(U,ne,we=[]){this.executionCount=U,this.location=ne,this.branches=we}};en=qe([P],en),e.StatementCoverage=en;let tn=class{constructor(U,ne){this.executionCount=U,this.location=ne}};tn=qe([P],tn),e.BranchCoverage=tn;let nn=class{constructor(U,ne){this.executionCount=U,this.location=ne}};nn=qe([P],nn),e.FunctionCoverage=nn;var vn;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(vn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var bn;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(bn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var En;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(En=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class wn{constructor(U,ne,we,Ge,Ye,at){this.kind=U,this.name=ne,this.detail=we,this.uri=Ge,this.range=Ye,this.selectionRange=at}}e.TypeHierarchyItem=wn;class Sn{constructor(U){this.uri=U}}e.TextTabInput=Sn;class yn{constructor(U,ne){this.original=U,this.modified=ne}}e.TextDiffTabInput=yn;class Dn{constructor(U,ne,we,Ge){this.base=U,this.input1=ne,this.input2=we,this.result=Ge}}e.TextMergeTabInput=Dn;class In{constructor(U,ne){this.uri=U,this.viewType=ne}}e.CustomEditorTabInput=In;class Cn{constructor(U){this.viewType=U}}e.WebviewEditorTabInput=Cn;class kn{constructor(U,ne){this.uri=U,this.notebookType=ne}}e.NotebookEditorTabInput=kn;class Tn{constructor(U,ne,we){this.original=U,this.modified=ne,this.notebookType=we}}e.NotebookDiffEditorTabInput=Tn;class Pn{constructor(){}}e.TerminalEditorTabInput=Pn;class An{constructor(U,ne){this.uri=U,this.inputBoxUri=ne}}e.InteractiveWindowInput=An}),define(Ce[99],ke([1,0,48,15,10,257,131,7,18]),function(ie,e,r,k,D,M,S,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const T=new Map;function N(m,o){o?T.set(m,o):T.delete(m)}e.setWordDefinitionFor=N;function E(m){return T.get(m)}class f extends M.MirrorTextModel{constructor(o,s,h,p,w,A,v,i){super(s,h,p,w),this.m=o,this.p=A,this.q=v,this.notebook=i,this.b=!1}dispose(){(0,r.ok)(!this.b),this.b=!0,this.q=!1}equalLines(o){return(0,y.equals)(this.d,o)}get document(){if(!this.a){const o=this;this.a={get uri(){return o.c},get fileName(){return o.c.fsPath},get isUntitled(){return o.c.scheme===k.Schemas.untitled},get languageId(){return o.p},get version(){return o.g},get isClosed(){return o.b},get isDirty(){return o.q},save(){return o.r()},getText(s){return s?o.s(s):o.getText()},get eol(){return o.f===`
`?O.EndOfLine.LF:O.EndOfLine.CRLF},get lineCount(){return o.d.length},lineAt(s){return o.t(s)},offsetAt(s){return o.u(s)},positionAt(s){return o.v(s)},validateRange(s){return o.w(s)},validatePosition(s){return o.x(s)},getWordRangeAtPosition(s,h){return o.y(s,h)}}}return Object.freeze(this.a)}_acceptLanguageId(o){(0,r.ok)(!this.b),this.p=o}_acceptIsDirty(o){(0,r.ok)(!this.b),this.q=o}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(o){const s=this.w(o);if(s.isEmpty)return"";if(s.isSingleLine)return this.d[s.start.line].substring(s.start.character,s.end.character);const h=this.f,p=s.start.line,w=s.end.line,A=[];A.push(this.d[p].substring(s.start.character));for(let v=p+1;v<w;v++)A.push(this.d[v]);return A.push(this.d[w].substring(0,s.end.character)),A.join(h)}t(o){let s;if(o instanceof O.Position?s=o.line:typeof o=="number"&&(s=o),typeof s!="number"||s<0||s>=this.d.length||Math.floor(s)!==s)throw new Error("Illegal value for `line`");return new b(s,this.d[s],s===this.d.length-1)}u(o){return o=this.x(o),this.k(),this.h.getPrefixSum(o.line-1)+o.character}v(o){o=Math.floor(o),o=Math.max(0,o),this.k();const s=this.h.getIndexOf(o),h=this.d[s.index].length;return new O.Position(s.index,Math.min(s.remainder,h))}w(o){if(!(o instanceof O.Range))throw new Error("Invalid argument");const s=this.x(o.start),h=this.x(o.end);return s===o.start&&h===o.end?o:new O.Range(s.line,s.character,h.line,h.character)}x(o){if(!(o instanceof O.Position))throw new Error("Invalid argument");if(this.d.length===0)return o.with(0,0);let{line:s,character:h}=o,p=!1;if(s<0)s=0,h=0,p=!0;else if(s>=this.d.length)s=this.d.length-1,h=this.d[s].length,p=!0;else{const w=this.d[s].length;h<0?(h=0,p=!0):h>w&&(h=w,p=!0)}return p?new O.Position(s,h):o}y(o,s){const h=this.x(o);if(!s)s=E(this.p);else if((0,D.regExpLeadsToEndlessLoop)(s))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${s.source}' because it matches the empty string.`);const p=(0,S.getWordAtText)(h.character+1,(0,S.ensureValidWordDefinition)(s),this.d[h.line],0);if(p)return new O.Range(h.line,p.startColumn-1,h.line,p.endColumn-1)}}e.ExtHostDocumentData=f;class b{constructor(o,s,h){this.a=o,this.b=s,this.c=h}get lineNumber(){return this.a}get text(){return this.b}get range(){return new O.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new O.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=b}),define(Ce[192],ke([1,0,7,17,4]),function(ie,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let M=class{constructor(O){this.a=new r.ColorTheme(r.ColorThemeKind.Dark),this.b=new D.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(O){let y;switch(O){case"light":y=r.ColorThemeKind.Light;break;case"hcDark":y=r.ColorThemeKind.HighContrast;break;case"hcLight":y=r.ColorThemeKind.HighContrastLight;break;default:y=r.ColorThemeKind.Dark}this.a=new r.ColorTheme(y),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};M=qe([je(0,k.IExtHostRpcService)],M),e.ExtHostTheming=M}),define(Ce[8],ke([1,0,18,23,116,193,86,28,112,65,64,22,9,2,56,75,91,96,95,70,44,55,189,7]),function(ie,e,r,k,D,M,S,O,y,T,N,E,f,b,m,o,s,h,p,w,A,v,i,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var n;(function(De){function Ae(G){const{selectionStartLineNumber:Re,selectionStartColumn:$e,positionLineNumber:Qe,positionColumn:Be}=G,Ze=new d.Position(Re-1,$e-1),ct=new d.Position(Qe-1,Be-1);return new d.Selection(Ze,ct)}De.to=Ae;function ge(G){const{anchor:Re,active:$e}=G;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:$e.line+1,positionColumn:$e.character+1}}De.from=ge})(n=e.Selection||(e.Selection={}));var a;(function(De){function Ae(G){if(!G)return;const{start:Re,end:$e}=G;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:$e.line+1,endColumn:$e.character+1}}De.from=Ae;function ge(G){if(!G)return;const{startLineNumber:Re,startColumn:$e,endLineNumber:Qe,endColumn:Be}=G;return new d.Range(Re-1,$e-1,Qe-1,Be-1)}De.to=ge})(a=e.Range||(e.Range={}));var t;(function(De){function Ae(ge){switch(ge){case 1:return d.StandardTokenType.Comment;case 0:return d.StandardTokenType.Other;case 3:return d.StandardTokenType.RegEx;case 2:return d.StandardTokenType.String}}De.to=Ae})(t=e.TokenType||(e.TokenType={}));var g;(function(De){function Ae(G){return new d.Position(G.lineNumber-1,G.column-1)}De.to=Ae;function ge(G){return{lineNumber:G.line+1,column:G.character+1}}De.from=ge})(g=e.Position||(e.Position={}));var c;(function(De){function Ae(Re,$e){return(0,r.coalesce)((0,r.asArray)(Re).map(Qe=>ge(Qe,$e)))}De.from=Ae;function ge(Re,$e){if(typeof Re=="string")return{$serialized:!0,language:Re};if(Re)return{$serialized:!0,language:Re.language,scheme:G(Re.scheme,$e),pattern:x.from(Re.pattern)??void 0,exclusive:Re.exclusive,notebookType:Re.notebookType}}function G(Re,$e){return $e&&typeof Re=="string"?$e.transformOutgoingScheme(Re):Re}})(c=e.DocumentSelector||(e.DocumentSelector={}));var u;(function(De){function Ae(G){switch(G){case d.DiagnosticTag.Unnecessary:return 1;case d.DiagnosticTag.Deprecated:return 2}}De.from=Ae;function ge(G){switch(G){case 1:return d.DiagnosticTag.Unnecessary;case 2:return d.DiagnosticTag.Deprecated;default:return}}De.to=ge})(u=e.DiagnosticTag||(e.DiagnosticTag={}));var l;(function(De){function Ae(G){let Re;return G.code&&((0,f.isString)(G.code)||(0,f.isNumber)(G.code)?Re=String(G.code):Re={value:String(G.code.value),target:G.code.target}),{...a.from(G.range),message:G.message,source:G.source,code:Re,severity:R.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(C.from),tags:Array.isArray(G.tags)?(0,r.coalesce)(G.tags.map(u.from)):void 0}}De.from=Ae;function ge(G){const Re=new d.Diagnostic(a.to(G),G.message,R.to(G.severity));return Re.source=G.source,Re.code=(0,f.isString)(G.code)?G.code:G.code?.value,Re.relatedInformation=G.relatedInformation&&G.relatedInformation.map(C.to),Re.tags=G.tags&&(0,r.coalesce)(G.tags.map(u.to)),Re}De.to=ge})(l=e.Diagnostic||(e.Diagnostic={}));var C;(function(De){function Ae(G){return{...a.from(G.location.range),message:G.message,resource:G.location.uri}}De.from=Ae;function ge(G){return new d.DiagnosticRelatedInformation(new d.Location(G.resource,a.to(G)),G.message)}De.to=ge})(C=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var R;(function(De){function Ae(G){switch(G){case d.DiagnosticSeverity.Error:return s.MarkerSeverity.Error;case d.DiagnosticSeverity.Warning:return s.MarkerSeverity.Warning;case d.DiagnosticSeverity.Information:return s.MarkerSeverity.Info;case d.DiagnosticSeverity.Hint:return s.MarkerSeverity.Hint}return s.MarkerSeverity.Error}De.from=Ae;function ge(G){switch(G){case s.MarkerSeverity.Info:return d.DiagnosticSeverity.Information;case s.MarkerSeverity.Warning:return d.DiagnosticSeverity.Warning;case s.MarkerSeverity.Error:return d.DiagnosticSeverity.Error;case s.MarkerSeverity.Hint:return d.DiagnosticSeverity.Hint;default:return d.DiagnosticSeverity.Error}}De.to=ge})(R=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var V;(function(De){function Ae(G){return typeof G=="number"&&G>=d.ViewColumn.One?G-1:G===d.ViewColumn.Beside?i.SIDE_GROUP:i.ACTIVE_GROUP}De.from=Ae;function ge(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}De.to=ge})(V=e.ViewColumn||(e.ViewColumn={}));function ee(De){return typeof De.range<"u"}function K(De){return De.length===0?!0:!!ee(De[0])}e.isDecorationOptionsArr=K;var L;(function(De){function Ae(Be){return Be.map(De.from)}De.fromMany=Ae;function ge(Be){return Be&&typeof Be=="object"&&typeof Be.language=="string"&&typeof Be.value=="string"}function G(Be){let Ze;if(ge(Be)){const{language:Et,value:It}=Be;Ze={value:"```"+Et+`
`+It+"\n```\n"}}else d.MarkdownString.isMarkdownString(Be)?Ze={value:Be.value,isTrusted:Be.isTrusted,supportThemeIcons:Be.supportThemeIcons,supportHtml:Be.supportHtml,baseUri:Be.baseUri}:typeof Be=="string"?Ze={value:Be}:Ze={value:""};const ct=Object.create(null);Ze.uris=ct;const Tt=Et=>{try{let It=b.URI.parse(Et,!0);It=It.with({query:Re(It.query,ct)}),ct[Et]=It}catch{}return""},bt=new y.marked.Renderer;return bt.link=Tt,bt.image=Et=>typeof Et=="string"?Tt(S.parseHrefAndDimensions(Et).href):"",(0,y.marked)(Ze.value,{renderer:bt}),Ze}De.from=G;function Re(Be,Ze){if(!Be)return Be;let ct;try{ct=(0,T.parse)(Be)}catch{}if(!ct)return Be;let Tt=!1;return ct=(0,E.cloneAndChange)(ct,bt=>{if(b.URI.isUri(bt)){const Et=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ze[Et]=bt,Tt=!0,Et}else return}),Tt?JSON.stringify(ct):Be}function $e(Be){const Ze=new d.MarkdownString(Be.value,Be.supportThemeIcons);return Ze.isTrusted=Be.isTrusted,Ze.supportHtml=Be.supportHtml,Ze.baseUri=Be.baseUri?b.URI.from(Be.baseUri):void 0,Ze}De.to=$e;function Qe(Be){if(!!Be)return typeof Be=="string"?Be:De.from(Be)}De.fromStrict=Qe})(L=e.MarkdownString||(e.MarkdownString={}));function B(De){return K(De)?De.map(Ae=>({range:a.from(Ae.range),hoverMessage:Array.isArray(Ae.hoverMessage)?L.fromMany(Ae.hoverMessage):Ae.hoverMessage?L.from(Ae.hoverMessage):void 0,renderOptions:Ae.renderOptions})):De.map(Ae=>({range:a.from(Ae)}))}e.fromRangeOrRangeWithMessage=B;function P(De){return typeof De>"u"?De:typeof De=="string"?b.URI.file(De):De}e.pathOrURIToURI=P;var F;(function(De){function Ae(ge){return typeof ge>"u"?ge:{contentText:ge.contentText,contentIconPath:ge.contentIconPath?P(ge.contentIconPath):void 0,border:ge.border,borderColor:ge.borderColor,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,color:ge.color,backgroundColor:ge.backgroundColor,margin:ge.margin,width:ge.width,height:ge.height}}De.from=Ae})(F=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var H;(function(De){function Ae(ge){return typeof ge>"u"?ge:{backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?P(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?F.from(ge.before):void 0,after:ge.after?F.from(ge.after):void 0}}De.from=Ae})(H=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var j;(function(De){function Ae(ge){if(typeof ge>"u")return ge;switch(ge){case d.DecorationRangeBehavior.OpenOpen:return 0;case d.DecorationRangeBehavior.ClosedClosed:return 1;case d.DecorationRangeBehavior.OpenClosed:return 2;case d.DecorationRangeBehavior.ClosedOpen:return 3}}De.from=Ae})(j=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var le;(function(De){function Ae(ge){return{isWholeLine:ge.isWholeLine,rangeBehavior:ge.rangeBehavior?j.from(ge.rangeBehavior):void 0,overviewRulerLane:ge.overviewRulerLane,light:ge.light?H.from(ge.light):void 0,dark:ge.dark?H.from(ge.dark):void 0,backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?P(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?F.from(ge.before):void 0,after:ge.after?F.from(ge.after):void 0}}De.from=Ae})(le=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var _;(function(De){function Ae(G){return{text:G.newText,eol:G.newEol&&it.from(G.newEol),range:a.from(G.range)}}De.from=Ae;function ge(G){const Re=new d.TextEdit(a.to(G.range),G.text);return Re.newEol=typeof G.eol>"u"?void 0:it.to(G.eol),Re}De.to=ge})(_=e.TextEdit||(e.TextEdit={}));var be;(function(De){function Ae(G,Re){const $e={edits:[]};if(G instanceof d.WorkspaceEdit){const Qe=new O.ResourceSet;for(const Be of G._allEntries())Be._type===1&&b.URI.isUri(Be.to)&&Be.from===void 0&&Qe.add(Be.to);for(const Be of G._allEntries())Be._type===1?$e.edits.push({oldResource:Be.from,newResource:Be.to,options:{...Be.options,contentsBase64:Be.options?.contents&&(0,k.encodeBase64)(k.VSBuffer.wrap(Be.options.contents))},metadata:Be.metadata}):Be._type===2?$e.edits.push({resource:Be.uri,textEdit:_.from(Be.edit),versionId:Qe.has(Be.uri)?void 0:Re?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===6?$e.edits.push({resource:Be.uri,textEdit:{range:a.from(Be.range),text:Be.edit.value,insertAsSnippet:!0},versionId:Qe.has(Be.uri)?void 0:Re?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===3?$e.edits.push({metadata:Be.metadata,resource:Be.uri,cellEdit:Be.edit,notebookMetadata:Be.notebookMetadata,notebookVersionId:Re?.getNotebookDocumentVersion(Be.uri)}):Be._type===5&&$e.edits.push({metadata:Be.metadata,resource:Be.uri,notebookVersionId:Re?.getNotebookDocumentVersion(Be.uri),cellEdit:{editType:1,index:Be.index,count:Be.count,cells:Be.cells.map(vt.from)}})}return $e}De.from=Ae;function ge(G){const Re=new d.WorkspaceEdit;for(const $e of G.edits)$e.textEdit?Re.replace(b.URI.revive($e.resource),a.to($e.textEdit.range),$e.textEdit.text):Re.renameFile(b.URI.revive($e.oldResource),b.URI.revive($e.newResource),$e.options);return Re}De.to=ge})(be=e.WorkspaceEdit||(e.WorkspaceEdit={}));var de;(function(De){const Ae=Object.create(null);Ae[d.SymbolKind.File]=0,Ae[d.SymbolKind.Module]=1,Ae[d.SymbolKind.Namespace]=2,Ae[d.SymbolKind.Package]=3,Ae[d.SymbolKind.Class]=4,Ae[d.SymbolKind.Method]=5,Ae[d.SymbolKind.Property]=6,Ae[d.SymbolKind.Field]=7,Ae[d.SymbolKind.Constructor]=8,Ae[d.SymbolKind.Enum]=9,Ae[d.SymbolKind.Interface]=10,Ae[d.SymbolKind.Function]=11,Ae[d.SymbolKind.Variable]=12,Ae[d.SymbolKind.Constant]=13,Ae[d.SymbolKind.String]=14,Ae[d.SymbolKind.Number]=15,Ae[d.SymbolKind.Boolean]=16,Ae[d.SymbolKind.Array]=17,Ae[d.SymbolKind.Object]=18,Ae[d.SymbolKind.Key]=19,Ae[d.SymbolKind.Null]=20,Ae[d.SymbolKind.EnumMember]=21,Ae[d.SymbolKind.Struct]=22,Ae[d.SymbolKind.Event]=23,Ae[d.SymbolKind.Operator]=24,Ae[d.SymbolKind.TypeParameter]=25;function ge(Re){return typeof Ae[Re]=="number"?Ae[Re]:6}De.from=ge;function G(Re){for(const $e in Ae)if(Ae[$e]===Re)return Number($e);return d.SymbolKind.Property}De.to=G})(de=e.SymbolKind||(e.SymbolKind={}));var ue;(function(De){function Ae(G){switch(G){case d.SymbolTag.Deprecated:return 1}}De.from=Ae;function ge(G){switch(G){case 1:return d.SymbolTag.Deprecated}}De.to=ge})(ue=e.SymbolTag||(e.SymbolTag={}));var se;(function(De){function Ae(G){return{name:G.name,kind:de.from(G.kind),tags:G.tags&&G.tags.map(ue.from),containerName:G.containerName,location:Te.from(G.location)}}De.from=Ae;function ge(G){const Re=new d.SymbolInformation(G.name,de.to(G.kind),G.containerName,Te.to(G.location));return Re.tags=G.tags&&G.tags.map(ue.to),Re}De.to=ge})(se=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var J;(function(De){function Ae(G){const Re={name:G.name||"!!MISSING: name!!",detail:G.detail,range:a.from(G.range),selectionRange:a.from(G.selectionRange),kind:de.from(G.kind),tags:G.tags?.map(ue.from)??[]};return G.children&&(Re.children=G.children.map(Ae)),Re}De.from=Ae;function ge(G){const Re=new d.DocumentSymbol(G.name,G.detail,de.to(G.kind),a.to(G.range),a.to(G.selectionRange));return(0,r.isNonEmptyArray)(G.tags)&&(Re.tags=G.tags.map(ue.to)),G.children&&(Re.children=G.children.map(ge)),Re}De.to=ge})(J=e.DocumentSymbol||(e.DocumentSymbol={}));var X;(function(De){function Ae(G){const Re=new d.CallHierarchyItem(de.to(G.kind),G.name,G.detail||"",b.URI.revive(G.uri),a.to(G.range),a.to(G.selectionRange));return Re._sessionId=G._sessionId,Re._itemId=G._itemId,Re}De.to=Ae;function ge(G,Re,$e){if(Re=Re??G._sessionId,$e=$e??G._itemId,Re===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:$e,name:G.name,detail:G.detail,kind:de.from(G.kind),uri:G.uri,range:a.from(G.range),selectionRange:a.from(G.selectionRange),tags:G.tags?.map(ue.from)}}De.from=ge})(X=e.CallHierarchyItem||(e.CallHierarchyItem={}));var Z;(function(De){function Ae(ge){return new d.CallHierarchyIncomingCall(X.to(ge.from),ge.fromRanges.map(G=>a.to(G)))}De.to=Ae})(Z=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var he;(function(De){function Ae(ge){return new d.CallHierarchyOutgoingCall(X.to(ge.to),ge.fromRanges.map(G=>a.to(G)))}De.to=Ae})(he=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Te;(function(De){function Ae(G){return{range:G.range&&a.from(G.range),uri:G.uri}}De.from=Ae;function ge(G){return new d.Location(b.URI.revive(G.uri),a.to(G.range))}De.to=ge})(Te=e.location||(e.location={}));var Ne;(function(De){function Ae(G){const Re=G,$e=G;return{originSelectionRange:Re.originSelectionRange?a.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:$e.uri,range:a.from(Re.targetRange?Re.targetRange:$e.range),targetSelectionRange:Re.targetSelectionRange?a.from(Re.targetSelectionRange):void 0}}De.from=Ae;function ge(G){return{targetUri:b.URI.revive(G.uri),targetRange:a.to(G.range),targetSelectionRange:G.targetSelectionRange?a.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?a.to(G.originSelectionRange):void 0}}De.to=ge})(Ne=e.DefinitionLink||(e.DefinitionLink={}));var Ke;(function(De){function Ae(G){return{range:a.from(G.range),contents:L.fromMany(G.contents)}}De.from=Ae;function ge(G){return new d.Hover(G.contents.map(L.to),a.to(G.range))}De.to=ge})(Ke=e.Hover||(e.Hover={}));var Pe;(function(De){function Ae(G){return{range:a.from(G.range),expression:G.expression}}De.from=Ae;function ge(G){return new d.EvaluatableExpression(a.to(G.range),G.expression)}De.to=ge})(Pe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Se;(function(De){function Ae(G){if(G instanceof d.InlineValueText)return{type:"text",range:a.from(G.range),text:G.text};if(G instanceof d.InlineValueVariableLookup)return{type:"variable",range:a.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof d.InlineValueEvaluatableExpression)return{type:"expression",range:a.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}De.from=Ae;function ge(G){switch(G.type){case"text":return{range:a.to(G.range),text:G.text};case"variable":return{range:a.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:a.to(G.range),expression:G.expression}}}De.to=ge})(Se=e.InlineValue||(e.InlineValue={}));var Ie;(function(De){function Ae(G){return{frameId:G.frameId,stoppedLocation:a.from(G.stoppedLocation)}}De.from=Ae;function ge(G){return new d.InlineValueContext(G.frameId,a.to(G.stoppedLocation))}De.to=ge})(Ie=e.InlineValueContext||(e.InlineValueContext={}));var oe;(function(De){function Ae(G){return{range:a.from(G.range),kind:G.kind}}De.from=Ae;function ge(G){return new d.DocumentHighlight(a.to(G.range),G.kind)}De.to=ge})(oe=e.DocumentHighlight||(e.DocumentHighlight={}));var ce;(function(De){function Ae(ge){switch(ge){case 1:return d.CompletionTriggerKind.TriggerCharacter;case 2:return d.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return d.CompletionTriggerKind.Invoke}}De.to=Ae})(ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Y;(function(De){function Ae(ge){return{triggerKind:ce.to(ge.triggerKind),triggerCharacter:ge.triggerCharacter}}De.to=Ae})(Y=e.CompletionContext||(e.CompletionContext={}));var I;(function(De){function Ae(G){switch(G){case d.CompletionItemTag.Deprecated:return 1}}De.from=Ae;function ge(G){switch(G){case 1:return d.CompletionItemTag.Deprecated}}De.to=ge})(I=e.CompletionItemTag||(e.CompletionItemTag={}));var $;(function(De){const Ae=new Map([[d.CompletionItemKind.Method,0],[d.CompletionItemKind.Function,1],[d.CompletionItemKind.Constructor,2],[d.CompletionItemKind.Field,3],[d.CompletionItemKind.Variable,4],[d.CompletionItemKind.Class,5],[d.CompletionItemKind.Interface,7],[d.CompletionItemKind.Struct,6],[d.CompletionItemKind.Module,8],[d.CompletionItemKind.Property,9],[d.CompletionItemKind.Unit,12],[d.CompletionItemKind.Value,13],[d.CompletionItemKind.Constant,14],[d.CompletionItemKind.Enum,15],[d.CompletionItemKind.EnumMember,16],[d.CompletionItemKind.Keyword,17],[d.CompletionItemKind.Snippet,27],[d.CompletionItemKind.Text,18],[d.CompletionItemKind.Color,19],[d.CompletionItemKind.File,20],[d.CompletionItemKind.Reference,21],[d.CompletionItemKind.Folder,23],[d.CompletionItemKind.Event,10],[d.CompletionItemKind.Operator,11],[d.CompletionItemKind.TypeParameter,24],[d.CompletionItemKind.Issue,26],[d.CompletionItemKind.User,25]]);function ge($e){return Ae.get($e)??9}De.from=ge;const G=new Map([[0,d.CompletionItemKind.Method],[1,d.CompletionItemKind.Function],[2,d.CompletionItemKind.Constructor],[3,d.CompletionItemKind.Field],[4,d.CompletionItemKind.Variable],[5,d.CompletionItemKind.Class],[7,d.CompletionItemKind.Interface],[6,d.CompletionItemKind.Struct],[8,d.CompletionItemKind.Module],[9,d.CompletionItemKind.Property],[12,d.CompletionItemKind.Unit],[13,d.CompletionItemKind.Value],[14,d.CompletionItemKind.Constant],[15,d.CompletionItemKind.Enum],[16,d.CompletionItemKind.EnumMember],[17,d.CompletionItemKind.Keyword],[27,d.CompletionItemKind.Snippet],[18,d.CompletionItemKind.Text],[19,d.CompletionItemKind.Color],[20,d.CompletionItemKind.File],[21,d.CompletionItemKind.Reference],[23,d.CompletionItemKind.Folder],[10,d.CompletionItemKind.Event],[11,d.CompletionItemKind.Operator],[24,d.CompletionItemKind.TypeParameter],[25,d.CompletionItemKind.User],[26,d.CompletionItemKind.Issue]]);function Re($e){return G.get($e)??d.CompletionItemKind.Property}De.to=Re})($=e.CompletionItemKind||(e.CompletionItemKind={}));var W;(function(De){function Ae(ge,G){const Re=new d.CompletionItem(ge.label);return Re.insertText=ge.insertText,Re.kind=$.to(ge.kind),Re.tags=ge.tags?.map(I.to),Re.detail=ge.detail,Re.documentation=S.isMarkdownString(ge.documentation)?L.to(ge.documentation):ge.documentation,Re.sortText=ge.sortText,Re.filterText=ge.filterText,Re.preselect=ge.preselect,Re.commitCharacters=ge.commitCharacters,m.Range.isIRange(ge.range)?Re.range=a.to(ge.range):typeof ge.range=="object"&&(Re.range={inserting:a.to(ge.range.insert),replacing:a.to(ge.range.replace)}),Re.keepWhitespace=typeof ge.insertTextRules>"u"?!1:Boolean(ge.insertTextRules&1),typeof ge.insertTextRules<"u"&&ge.insertTextRules&4?Re.insertText=new d.SnippetString(ge.insertText):(Re.insertText=ge.insertText,Re.textEdit=Re.range instanceof d.Range?new d.TextEdit(Re.range,Re.insertText):void 0),ge.additionalTextEdits&&ge.additionalTextEdits.length>0&&(Re.additionalTextEdits=ge.additionalTextEdits.map($e=>_.to($e))),Re.command=G&&ge.command?G.fromInternal(ge.command):void 0,Re}De.to=Ae})(W=e.CompletionItem||(e.CompletionItem={}));var q;(function(De){function Ae(G){if(typeof G.label!="string"&&!Array.isArray(G.label))throw new TypeError("Invalid label");return{label:G.label,documentation:L.fromStrict(G.documentation)}}De.from=Ae;function ge(G){return{label:G.label,documentation:S.isMarkdownString(G.documentation)?L.to(G.documentation):G.documentation}}De.to=ge})(q=e.ParameterInformation||(e.ParameterInformation={}));var te;(function(De){function Ae(G){return{label:G.label,documentation:L.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(q.from):[],activeParameter:G.activeParameter}}De.from=Ae;function ge(G){return{label:G.label,documentation:S.isMarkdownString(G.documentation)?L.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(q.to):[],activeParameter:G.activeParameter}}De.to=ge})(te=e.SignatureInformation||(e.SignatureInformation={}));var fe;(function(De){function Ae(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(te.from):[]}}De.from=Ae;function ge(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(te.to):[]}}De.to=ge})(fe=e.SignatureHelp||(e.SignatureHelp={}));var ye;(function(De){function Ae(ge,G){const Re=new d.InlayHint(g.to(G.position),typeof G.label=="string"?G.label:G.label.map(ae.to.bind(void 0,ge)),G.kind&&ve.to(G.kind));return Re.textEdits=G.textEdits&&G.textEdits.map(_.to),Re.tooltip=S.isMarkdownString(G.tooltip)?L.to(G.tooltip):G.tooltip,Re.paddingLeft=G.paddingLeft,Re.paddingRight=G.paddingRight,Re}De.to=Ae})(ye=e.InlayHint||(e.InlayHint={}));var ae;(function(De){function Ae(ge,G){const Re=new d.InlayHintLabelPart(G.label);return Re.tooltip=S.isMarkdownString(G.tooltip)?L.to(G.tooltip):G.tooltip,o.Command.is(G.command)&&(Re.command=ge.fromInternal(G.command)),G.location&&(Re.location=Te.to(G.location)),Re}De.to=Ae})(ae=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var ve;(function(De){function Ae(G){return G}De.from=Ae;function ge(G){return G}De.to=ge})(ve=e.InlayHintKind||(e.InlayHintKind={}));var Ee;(function(De){function Ae(G){return{range:a.from(G.range),url:G.target,tooltip:G.tooltip}}De.from=Ae;function ge(G){let Re;if(G.url)try{Re=typeof G.url=="string"?b.URI.parse(G.url,!0):b.URI.revive(G.url)}catch{}return new d.DocumentLink(a.to(G.range),Re)}De.to=ge})(Ee=e.DocumentLink||(e.DocumentLink={}));var We;(function(De){function Ae(G){const Re=new d.ColorPresentation(G.label);return G.textEdit&&(Re.textEdit=_.to(G.textEdit)),G.additionalTextEdits&&(Re.additionalTextEdits=G.additionalTextEdits.map($e=>_.to($e))),Re}De.to=Ae;function ge(G){return{label:G.label,textEdit:G.textEdit?_.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Re=>_.from(Re)):void 0}}De.from=ge})(We=e.ColorPresentation||(e.ColorPresentation={}));var He;(function(De){function Ae(G){return new d.Color(G[0],G[1],G[2],G[3])}De.to=Ae;function ge(G){return[G.red,G.green,G.blue,G.alpha]}De.from=ge})(He=e.Color||(e.Color={}));var tt;(function(De){function Ae(G){return{range:a.from(G.range)}}De.from=Ae;function ge(G){return new d.SelectionRange(a.to(G.range))}De.to=ge})(tt=e.SelectionRange||(e.SelectionRange={}));var Xe;(function(De){function Ae(ge){switch(ge){case 2:return d.TextDocumentSaveReason.AfterDelay;case 1:return d.TextDocumentSaveReason.Manual;case 3:case 4:return d.TextDocumentSaveReason.FocusOut}}De.to=Ae})(Xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var et;(function(De){function Ae(G){switch(G){case d.TextEditorLineNumbersStyle.Off:return 0;case d.TextEditorLineNumbersStyle.Relative:return 2;case d.TextEditorLineNumbersStyle.On:default:return 1}}De.from=Ae;function ge(G){switch(G){case 0:return d.TextEditorLineNumbersStyle.Off;case 2:return d.TextEditorLineNumbersStyle.Relative;case 1:default:return d.TextEditorLineNumbersStyle.On}}De.to=ge})(et=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var it;(function(De){function Ae(G){if(G===d.EndOfLine.CRLF)return 1;if(G===d.EndOfLine.LF)return 0}De.from=Ae;function ge(G){if(G===1)return d.EndOfLine.CRLF;if(G===0)return d.EndOfLine.LF}De.to=ge})(it=e.EndOfLine||(e.EndOfLine={}));var dt;(function(De){function Ae(ge){if(typeof ge=="object")return ge.viewId;switch(ge){case d.ProgressLocation.SourceControl:return 3;case d.ProgressLocation.Window:return 10;case d.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}De.from=Ae})(dt=e.ProgressLocation||(e.ProgressLocation={}));var Fe;(function(De){function Ae(ge){const G={start:ge.start+1,end:ge.end+1};return ge.kind&&(G.kind=ot.from(ge.kind)),G}De.from=Ae})(Fe=e.FoldingRange||(e.FoldingRange={}));var ot;(function(De){function Ae(ge){if(ge)switch(ge){case d.FoldingRangeKind.Comment:return o.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports:return o.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region:return o.FoldingRangeKind.Region}}De.from=Ae})(ot=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Q;(function(De){function Ae(ge){if(ge)return{pinned:typeof ge.preview=="boolean"?!ge.preview:void 0,inactive:ge.background,preserveFocus:ge.preserveFocus,selection:typeof ge.selection=="object"?a.from(ge.selection):void 0,override:typeof ge.override=="boolean"?p.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}De.from=Ae})(Q=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var x;(function(De){function Ae($e){return $e instanceof d.RelativePattern?$e.toJSON():typeof $e=="string"?$e:ge($e)||G($e)?new d.RelativePattern($e.baseUri??$e.base,$e.pattern).toJSON():$e}De.from=Ae;function ge($e){const Qe=$e;return Qe?b.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function G($e){const Qe=$e;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Re($e){return typeof $e=="string"?$e:new d.RelativePattern(b.URI.revive($e.baseUri),$e.pattern)}De.to=Re})(x=e.GlobPattern||(e.GlobPattern={}));var pe;(function(De){function Ae(ge){if(ge){if(Array.isArray(ge))return ge.map(Ae);if(typeof ge=="string")return ge;{const G=ge;return{language:G.language,scheme:G.scheme,pattern:x.from(G.pattern),exclusive:G.exclusive,notebookType:G.notebookType}}}else return}De.from=Ae})(pe=e.LanguageSelector||(e.LanguageSelector={}));var Me;(function(De){function Ae(G){return{start:G.start,end:G.end}}De.from=Ae;function ge(G){return new d.NotebookRange(G.start,G.end)}De.to=ge})(Me=e.NotebookRange||(e.NotebookRange={}));var ze;(function(De){function Ae(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}De.to=Ae;function ge(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}De.from=ge})(ze=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ve;(function(De){function Ae(ge){if(ge===w.NotebookCellExecutionState.Unconfirmed)return d.NotebookCellExecutionState.Pending;if(ge===w.NotebookCellExecutionState.Pending)return;if(ge===w.NotebookCellExecutionState.Executing)return d.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ge}`)}De.to=Ae})(Ve=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var _e;(function(De){function Ae(G){switch(G){case d.NotebookCellKind.Markup:return w.CellKind.Markup;case d.NotebookCellKind.Code:default:return w.CellKind.Code}}De.from=Ae;function ge(G){switch(G){case w.CellKind.Markup:return d.NotebookCellKind.Markup;case w.CellKind.Code:default:return d.NotebookCellKind.Code}}De.to=ge})(_e=e.NotebookCellKind||(e.NotebookCellKind={}));var nt;(function(De){function Ae(G){const Re={metadata:G.metadata??Object.create(null),cells:[]};for(const $e of G.cells)d.NotebookCellData.validate($e),Re.cells.push(vt.from($e));return Re}De.from=Ae;function ge(G){const Re=new d.NotebookData(G.cells.map(vt.to));return(0,f.isEmptyObject)(G.metadata)||(Re.metadata=G.metadata),Re}De.to=ge})(nt=e.NotebookData||(e.NotebookData={}));var vt;(function(De){function Ae(G){return{cellKind:_e.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:ze.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(Ct.from):[]}}De.from=Ae;function ge(G){return new d.NotebookCellData(_e.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(Ct.to):void 0,G.metadata,G.internalMetadata?ze.to(G.internalMetadata):void 0)}De.to=ge})(vt=e.NotebookCellData||(e.NotebookCellData={}));var wt;(function(De){function Ae(G){return{mime:G.mime,valueBytes:k.VSBuffer.wrap(G.data)}}De.from=Ae;function ge(G){return new d.NotebookCellOutputItem(G.valueBytes.buffer,G.mime)}De.to=ge})(wt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ct;(function(De){function Ae(G){return{outputId:G.id,items:G.items.map(wt.from),metadata:G.metadata}}De.from=Ae;function ge(G){const Re=G.items.map(wt.to);return new d.NotebookCellOutput(Re,G.outputId,G.metadata)}De.to=ge})(Ct=e.NotebookCellOutput||(e.NotebookCellOutput={}));var jt;(function(De){function Ae(Re){return G(Re)?{include:(0,f.withNullAsUndefined)(x.from(Re.include)),exclude:(0,f.withNullAsUndefined)(x.from(Re.exclude))}:(0,f.withNullAsUndefined)(x.from(Re))}De.from=Ae;function ge(Re){return G(Re)?{include:x.to(Re.include),exclude:x.to(Re.exclude)}:x.to(Re)}De.to=ge;function G(Re){const $e=Re;return $e?!(0,f.isUndefinedOrNull)($e.include)&&!(0,f.isUndefinedOrNull)($e.exclude):!1}})(jt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var rt;(function(De){function Ae(ge,G,Re){const $e=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{alignment:ge.alignment===d.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal($e,Re),text:ge.text,tooltip:ge.tooltip,accessibilityInformation:ge.accessibilityInformation,priority:ge.priority}}De.from=Ae})(rt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var mt;(function(De){function Ae(ge,G,Re){const $e=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{command:G.toInternal($e,Re),label:ge.label,description:ge.description,detail:ge.detail,documentation:ge.documentation}}De.from=Ae})(mt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Ft;(function(De){function Ae(ge){return{transientOutputs:ge?.transientOutputs??!1,transientCellMetadata:ge?.transientCellMetadata??{},transientDocumentMetadata:ge?.transientDocumentMetadata??{},cellContentMetadata:ge?.cellContentMetadata??{}}}De.from=Ae})(Ft=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var xt;(function(De){function Ae(G){return{uri:G.uri,provides:G.provides}}De.from=Ae;function ge(G){return new d.NotebookRendererScript(b.URI.revive(G.uri),G.provides)}De.to=ge})(xt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Pt;(function(De){function Ae(G){return{message:L.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,location:G.location&&{range:a.from(G.location.range),uri:G.location.uri}}}De.from=Ae;function ge(G){const Re=new d.TestMessage(typeof G.message=="string"?G.message:L.to(G.message));return Re.actualOutput=G.actual,Re.expectedOutput=G.expected,Re.location=G.location?Te.to(G.location):void 0,Re}De.to=ge})(Pt=e.TestMessage||(e.TestMessage={}));var ht;(function(De){De.namespace=v.namespaceTestTag,De.denamespace=v.denamespaceTestTag})(ht=e.TestTag||(e.TestTag={}));var kt;(function(De){function Ae(G){const Re=(0,h.getPrivateApiFor)(G).controllerId;return{extId:A.TestId.fromExtHostTestItem(G,Re).toString(),label:G.label,uri:b.URI.revive(G.uri),busy:G.busy,tags:G.tags.map($e=>ht.namespace(Re,$e.id)),range:m.Range.lift(a.from(G.range)),description:G.description||null,sortText:G.sortText||null,error:G.error&&L.fromStrict(G.error)||null}}De.from=Ae;function ge(G){return{parent:void 0,error:void 0,id:A.TestId.fromString(G.extId).localId,label:G.label,uri:b.URI.revive(G.uri),tags:(G.tags||[]).map(Re=>{const{tagId:$e}=ht.denamespace(Re);return new d.TestTag($e)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:a.to(G.range||void 0),canResolveChildren:!1,busy:G.busy,description:G.description||void 0,sortText:G.sortText||void 0}}De.toPlain=ge})(kt=e.TestItem||(e.TestItem={})),function(De){function Ae(G){return{id:G.id}}De.from=Ae;function ge(G){return new d.TestTag(G.id)}De.to=ge}(ht=e.TestTag||(e.TestTag={}));var $t;(function(De){const Ae=(G,Re)=>{const $e=[];for(const[Be,Ze]of Re)A.TestId.compare(Ze.item.extId,Be)===2&&(Re.delete(Be),$e.push(Ze));const Qe={...kt.toPlain(G.item),parent:void 0,taskStates:G.tasks.map(Be=>({state:Be.state,duration:Be.duration,messages:Be.messages.filter(Ze=>Ze.type===0).map(Pt.to)})),children:$e.map(Be=>Ae(Be,Re))};for(const Be of Qe.children)Be.parent=Qe;return Qe};function ge(G){const Re=[],$e=new Map;for(const Qe of G.items){$e.set(Qe.item.extId,Qe);const Be=A.TestId.root(Qe.item.extId);G.request.targets.some(Ze=>Ze.controllerId===Be&&Ze.testIds.includes(Qe.item.extId))&&Re.push(Qe)}return{completedAt:G.completedAt,results:Re.map(Qe=>Ae(Qe,$e))}}De.to=ge})($t=e.TestResults||(e.TestResults={}));var Ot;(function(De){function Ae($e){return{covered:$e.covered,total:$e.covered}}function ge($e){return"line"in $e?g.from($e):a.from($e)}function G($e){return"branches"in $e?{count:$e.executionCount,location:ge($e.location),type:1,branches:$e.branches.length?$e.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&ge(Qe.location)})):void 0}:{type:0,count:$e.executionCount,location:ge($e.location)}}De.fromDetailed=G;function Re($e){return{uri:$e.uri,statement:Ae($e.statementCoverage),branch:$e.branchCoverage&&Ae($e.branchCoverage),function:$e.functionCoverage&&Ae($e.functionCoverage),details:$e.detailedCoverage?.map(G)}}De.fromFile=Re})(Ot=e.TestCoverage||(e.TestCoverage={}));var xe;(function(De){function Ae(ge){switch(ge){case 1:return d.CodeActionTriggerKind.Invoke;case 2:return d.CodeActionTriggerKind.Automatic}}De.to=Ae})(xe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Nt;(function(De){function Ae(G){const Re=new d.TypeHierarchyItem(de.to(G.kind),G.name,G.detail||"",b.URI.revive(G.uri),a.to(G.range),a.to(G.selectionRange));return Re._sessionId=G._sessionId,Re._itemId=G._itemId,Re}De.to=Ae;function ge(G,Re,$e){if(Re=Re??G._sessionId,$e=$e??G._itemId,Re===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:$e,kind:de.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:a.from(G.range),selectionRange:a.from(G.selectionRange),tags:G.tags?.map(ue.from)}}De.from=ge})(Nt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Mt;(function(De){function Ae(ge){if(!!ge)return{value:ge.value,tooltip:ge.tooltip}}De.from=Ae})(Mt=e.ViewBadge||(e.ViewBadge={}));var zt;(function(De){function Ae($e,Qe,Be){const Ze=Qe.fileData;return Ze?new class extends d.DataTransferItem{asFile(){return{name:Ze.name,uri:b.URI.revive(Ze.uri),data:(0,M.once)(()=>Be())}}}("",Qe.id):$e===N.Mimes.uriList&&Qe.uriListData?new d.DataTransferItem(Re(Qe.uriListData)):new d.DataTransferItem(Qe.asString)}De.to=Ae;async function ge($e,Qe){const Be=await Qe.asString();if($e===N.Mimes.uriList)return{id:Qe.id,asString:"",fileData:void 0,uriListData:G(Be)};const Ze=Qe.asFile();return{id:Qe.id,asString:Be,fileData:Ze?{name:Ze.name,uri:Ze.uri}:void 0}}De.from=ge;function G($e){return D.UriList.split($e).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return b.URI.parse(Qe)}catch{}return Qe})}function Re($e){return D.UriList.create($e.map(Qe=>typeof Qe=="string"?Qe:b.URI.revive(Qe)))}})(zt=e.DataTransferItem||(e.DataTransferItem={}));var ft;(function(De){function Ae(G,Re){const $e=G.items.map(([Qe,Be])=>[Qe,zt.to(Qe,Be,()=>Re(Be.id))]);return new d.DataTransfer($e)}De.toDataTransfer=Ae;async function ge(G){const Re={items:[]},$e=[];return G.forEach((Qe,Be)=>{$e.push((async()=>{Re.items.push([Be,await zt.from(Be,Qe)])})())}),await Promise.all($e),Re}De.toDataTransferDTO=ge})(ft=e.DataTransfer||(e.DataTransfer={}))}),define(Ce[194],ke([1,0,2,12,7,8,160]),function(ie,e,r,k,D,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class O{constructor(T,N,E,f={timeout:1500,errors:3}){this.c=T,this.d=N,this.f=E,this.g=f,this.a=new S.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(T){return(N,E,f)=>{const m={dispose:this.a.push([N,E,T])};return Array.isArray(f)&&f.push(m),m}}async $participateInSave(T,N){const E=r.URI.revive(T);let f=!1;const b=setTimeout(()=>f=!0,this.g.timeout),m=[];try{for(const o of[...this.a]){if(f)break;const s=this.d.getDocument(E),h=await this.h(o,{document:s,reason:M.TextDocumentSaveReason.to(N)});m.push(h)}}finally{clearTimeout(b)}return m}h([T,N,E],f){const b=this.b.get(T);return typeof b=="number"&&b>this.g.errors?Promise.resolve(!1):this.i(E,T,N,f).then(()=>!0,m=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' threw ERROR`),this.c.error(m),!(m instanceof Error)||m.message!=="concurrent_edits"){const o=this.b.get(T);this.b.set(T,o?o+1:1),typeof o=="number"&&o>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(T,N,E,f){const b=[],m=Date.now(),{document:o,reason:s}=f,{version:h}=o,p=Object.freeze({document:o,reason:s,waitUntil(w){if(Object.isFrozen(b))throw(0,k.illegalState)("waitUntil can not be called async");b.push(Promise.resolve(w))}});try{N.apply(E,[p])}catch(w){return Promise.reject(w)}return Object.freeze(b),new Promise((w,A)=>{const v=setTimeout(()=>A(new Error("timeout")),this.g.timeout);return Promise.all(b).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-m}ms`),clearTimeout(v),w(i)}).catch(i=>{clearTimeout(v),A(i)})}).then(w=>{const A={edits:[]};for(const v of w)if(Array.isArray(v)&&v.every(i=>i instanceof D.TextEdit))for(const{newText:i,newEol:d,range:n}of v)A.edits.push({resource:o.uri,versionId:void 0,textEdit:{range:n&&M.Range.from(n),text:i,eol:d&&M.EndOfLine.from(d)}});if(A.edits.length!==0)return h===o.version?this.f.$tryApplyWorkspaceEdit(A):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=O}),define(Ce[195],ke([1,0,15,2,8,7,70]),function(ie,e,r,k,D,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class O{constructor(E,f,b,m){this.start=E,this.deletedCount=f,this.deletedItems=b,this.items=m}asApiEvent(){return{range:new M.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(E=>E.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(E,f){return{EOL:f.eol,lines:f.source,languageId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:E}}constructor(E,f,b){this.notebook=E,this.h=f,this.j=b,this.handle=b.handle,this.uri=k.URI.revive(b.uri),this.cellKind=b.cellKind,this.a=b.outputs.map(D.NotebookCellOutput.to),this.e=b.internalMetadata??{},this.b=Object.freeze(b.metadata??{}),this.d=Object.freeze(D.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const E=this,f=this.h.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return E.notebook.getCellIndex(E)},notebook:E.notebook.apiNotebook,kind:D.NotebookCellKind.to(this.j.cellKind),document:f.document,get mime(){return E.g},set mime(m){E.g=m},get outputs(){return E.a.slice(0)},get metadata(){return E.b},get executionSummary(){return E.d}};this.f=Object.freeze(b)}return this.f}setOutputs(E){this.a=E.map(D.NotebookCellOutput.to)}setOutputItems(E,f,b){const m=b.map(D.NotebookCellOutputItem.to),o=this.a.find(s=>s.id===E);if(o&&(f||(o.items.length=0),o.items.push(...m),o.items.length>1&&o.items.every(s=>S.isTextStreamMime(s.mime)))){const s=new Map,h=[];o.items.forEach(p=>{let w;s.has(p.mime)?w=s.get(p.mime):(w=[],s.set(p.mime,w),h.push(p.mime)),w.push(p.data)}),o.items.length=0,h.forEach(p=>{const w=S.compressOutputItemStreams(s.get(p));o.items.push({mime:p,data:w.buffer})})}}setMetadata(E){this.b=Object.freeze(E)}setInternalMetadata(E){this.e=E,this.d=Object.freeze(D.NotebookCellExecutionSummary.to(E))}setMime(E){}}e.ExtHostCell=y;class T{constructor(E,f,b,m,o){this.k=E,this.l=f,this.m=b,this.uri=m,this.handle=T.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=o.viewType,this.f=Object.freeze(o.metadata??Object.create(null)),this.r([[0,0,o.cells]],!0,void 0),this.g=o.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const E=this,f={get uri(){return E.uri},get version(){return E.g},get notebookType(){return E.d},get isDirty(){return E.h},get isUntitled(){return E.uri.scheme===r.Schemas.untitled},get isClosed(){return E.j},get metadata(){return E.f},get cellCount(){return E.b.length},cellAt(b){return b=E.n(b),E.b[b].apiCell},getCells(b){return(b?E.p(b):E.b).map(o=>o.apiCell)},save(){return E.q()}};this.e=Object.freeze(f)}return this.e}acceptDocumentPropertiesChanged(E){E.metadata&&(this.f=Object.freeze({...this.f,...E.metadata}))}acceptDirty(E){this.h=E}acceptModelChanged(E,f,b){this.g=E.versionId,this.h=f,this.acceptDocumentPropertiesChanged({metadata:b});const m={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},o=[];for(const h of E.rawEvents)h.kind===S.NotebookCellsChangeType.ModelChange?this.r(h.changes,!1,m.contentChanges):h.kind===S.NotebookCellsChangeType.Move?this.s(h.index,h.length,h.newIdx,m.contentChanges):h.kind===S.NotebookCellsChangeType.Output?(this.t(h.index,h.outputs),o.push({cell:this.b[h.index].apiCell,outputs:this.b[h.index].apiCell.outputs})):h.kind===S.NotebookCellsChangeType.OutputItem?(this.u(h.index,h.outputId,h.append,h.outputItems),o.push({cell:this.b[h.index].apiCell,outputs:this.b[h.index].apiCell.outputs})):h.kind===S.NotebookCellsChangeType.ChangeCellLanguage?(this.v(h.index,h.language),o.push({cell:this.b[h.index].apiCell,document:this.b[h.index].apiCell.document})):h.kind===S.NotebookCellsChangeType.ChangeCellContent?o.push({cell:this.b[h.index].apiCell,document:this.b[h.index].apiCell.document}):h.kind===S.NotebookCellsChangeType.ChangeCellMime?this.w(h.index,h.mime):h.kind===S.NotebookCellsChangeType.ChangeCellMetadata?(this.x(h.index,h.metadata),o.push({cell:this.b[h.index].apiCell,metadata:this.b[h.index].apiCell.metadata})):h.kind===S.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(h.index,h.internalMetadata),o.push({cell:this.b[h.index].apiCell,executionSummary:this.b[h.index].apiCell.executionSummary}));const s=new Map;for(let h=0;h<o.length;h++){const p=o[h],w=s.get(p.cell);if(w===void 0){const A=m.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...p});s.set(p.cell,A-1)}else m.cellChanges[w]={...m.cellChanges[w],...p}}return Object.freeze(m),Object.freeze(m.cellChanges),Object.freeze(m.contentChanges),m}n(E){return E=E|0,E<0?0:E>=this.b.length?this.b.length-1:E}o(E){let f=E.start|0,b=E.end|0;return f<0&&(f=0),b>this.b.length&&(b=this.b.length),E.with({start:f,end:b})}p(E){E=this.o(E);const f=[];for(let b=E.start;b<E.end;b++)f.push(this.b[b]);return f}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(E,f,b){if(this.j)return;const m=[],o=[],s=[];if(E.reverse().forEach(h=>{const w=h[2].map(i=>{const d=new y(this,this.l,i);return f||o.push(y.asModelAddData(this.apiNotebook,i)),d}),A=new O(h[0],h[1],[],w),v=this.b.splice(h[0],h[1],...w);for(const i of v)s.push(i.uri),A.deletedItems.push(i.apiCell);m.push(A)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:o,removedDocuments:s}),b)for(const h of m)b.push(h.asApiEvent())}s(E,f,b,m){const o=this.b.splice(E,f);this.b.splice(b,0,...o);const s=[new O(E,f,o.map(h=>h.apiCell),[]),new O(b,0,[],o)];for(const h of s)m.push(h.asApiEvent())}t(E,f){this.b[E].setOutputs(f)}u(E,f,b,m){this.b[E].setOutputItems(f,b,m)}v(E,f){const b=this.b[E];b.apiCell.document.languageId!==f&&this.m.$acceptModelLanguageChanged(b.uri,f)}w(E,f){const b=this.b[E];b.apiCell.mime=f}x(E,f){this.b[E].setMetadata(f)}y(E,f){this.b[E].setInternalMetadata(f)}getCellFromApiCell(E){return this.b.find(f=>f.apiCell===E)}getCellFromIndex(E){return this.b[E]}getCell(E){return this.b.find(f=>f.handle===E)}getCellIndex(E){return this.b.indexOf(E)}}e.ExtHostNotebookDocument=T,T.a=0}),define(Ce[100],ke([1,0,12,8,7]),function(ie,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class M{constructor(O,y,T,N,E,f){this.id=O,this.f=y,this.notebookData=T,this.a=[],this.b=[],this.d=!1,this.a=E,this.b=N,this.c=f}get apiEditor(){if(!this.e){const O=this;this.e={get notebook(){return O.notebookData.apiNotebook},get selection(){return O.a[0]},set selection(y){this.selections=[y]},get selections(){return O.a},set selections(y){if(!Array.isArray(y)||!y.every(D.NotebookRange.isNotebookRange))throw(0,r.illegalArgument)("selections");O.a=y,O.g(y)},get visibleRanges(){return O.b},revealRange(y,T){O.f.$tryRevealRange(O.id,k.NotebookRange.from(y),T??D.NotebookEditorRevealType.Default)},get viewColumn(){return O.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(O){this.d=O}_acceptVisibleRanges(O){this.b=O}_acceptSelections(O){this.a=O}g(O){this.f.$trySetSelections(this.id,O.map(k.NotebookRange.from))}_acceptViewColumn(O){this.c=O}}e.ExtHostNotebookEditor=M,M.apiEditorsToExtHost=new WeakMap}),define(Ce[196],ke([1,0,4,11,8]),function(ie,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let M=class{constructor(O,y){this.c=O,this.d=y,this.a=new r.Emitter,this.b=new r.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(O,y){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",O,y);const T=this.d.getEditorById(O);y.visibleRanges&&T._acceptVisibleRanges(y.visibleRanges.ranges.map(D.NotebookRange.to)),y.selections&&T._acceptSelections(y.selections.selections.map(D.NotebookRange.to)),y.visibleRanges&&this.b.fire({notebookEditor:T.apiEditor,visibleRanges:T.apiEditor.visibleRanges}),y.selections&&this.a.fire(Object.freeze({notebookEditor:T.apiEditor,selections:T.apiEditor.selections}))}$acceptEditorViewColumns(O){for(const y in O)this.d.getEditorById(y)._acceptViewColumn(D.ViewColumn.to(O[y]))}};M=qe([je(0,k.ILogService)],M),e.ExtHostNotebookEditors=M}),define(Ce[197],ke([1,0,8,164,141,21,63,12]),function(ie,e,r,k,D,M,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(f){this.b=0,this.c=new Map,this.a=f}async withProgress(f,b,m){const o=this.b++,{title:s,location:h,cancellable:p}=b,w={label:(0,D.localize)(0,null,f.displayName||f.name),id:f.identifier.value};return this.a.$startProgress(o,{location:r.ProgressLocation.from(h),title:s,source:w,cancellable:p},f.isUnderDevelopment?void 0:f.identifier.value).catch(O.onUnexpectedExternalError),this.d(o,m,!!p)}d(f,b,m){let o;m&&(o=new M.CancellationTokenSource,this.c.set(f,o));const s=p=>{this.a.$progressEnd(p),this.c.delete(p),o?.dispose()};let h;try{h=b(new N(this.a,f),m&&o?o.token:M.CancellationToken.None)}catch(p){throw s(f),p}return h.then(p=>s(f),p=>s(f)),h}$acceptProgressCanceled(f){const b=this.c.get(f);b&&(b.cancel(),this.c.delete(f))}}e.ExtHostProgress=y;function T(E,f){return E.message=f.message,typeof f.increment=="number"&&(typeof E.increment=="number"?E.increment+=f.increment:E.increment=f.increment),E}class N extends k.Progress{constructor(f,b){super(m=>this.throttledReport(m)),this.c=f,this.d=b}throttledReport(f){this.c.$progressReport(this.d,f)}}qe([(0,S.throttle)(100,(E,f)=>T(E,f),()=>Object.create(null))],N.prototype,"throttledReport",null)}),define(Ce[101],ke([1,0,56,96,44,71,55,8,2]),function(ie,e,r,k,D,M,S,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const T=(w,A,v,i)=>{let d=A;return{enumerable:!0,configurable:!1,get(){return d},set(n){if(!v(d,n)){const a=d;d=n,w.listener?.(i(n,a))}}}},N=(w,A)=>w===A,E={range:(w,A)=>w===A?!0:!w||!A?!1:w.isEqual(A),label:N,description:N,sortText:N,busy:N,error:N,canResolveChildren:N,tags:(w,A)=>!(w.length!==A.length||w.some(v=>!A.find(i=>v.id===i.id)))},f=w=>A=>({op:4,update:w(A)}),b=(w,A)=>({range:(()=>{let v;const i=f(d=>({range:r.Range.lift(O.Range.from(d))}));return{enumerable:!0,configurable:!1,get(){return v},set(d){w.listener?.({op:6}),E.range(v,d)||(v=d,w.listener?.(i(d)))}}})(),label:T(w,A,E.label,f(v=>({label:v}))),description:T(w,void 0,E.description,f(v=>({description:v}))),sortText:T(w,void 0,E.sortText,f(v=>({sortText:v}))),canResolveChildren:T(w,!1,E.canResolveChildren,v=>({op:2,state:v})),busy:T(w,!1,E.busy,f(v=>({busy:v}))),error:T(w,void 0,E.error,f(v=>({error:O.MarkdownString.fromStrict(v)||null}))),tags:T(w,[],E.tags,(v,i)=>({op:1,new:v.map(O.TestTag.from),old:i.map(O.TestTag.from)}))}),m=w=>{const A=D.TestId.fromString(w.extId),v=new s(A.controllerId,A.localId,w.label,y.URI.revive(w.uri)||void 0);return v.range=O.Range.to(w.range||void 0),v.description=w.description||void 0,v.sortText=w.sortText||void 0,v.tags=w.tags.map(i=>O.TestTag.to({id:(0,S.denamespaceTestTag)(i).tagId})),v},o=w=>{let A;for(const v of w.tests){const i=m(v.item);(0,k.getPrivateApiFor)(i).parent=A,A=i}return A};e.toItemFromContext=o;class s{constructor(A,v,i,d){if(v.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(v)} symbol`);const n=(0,k.createPrivateApiFor)(this,A);Object.defineProperties(this,{id:{value:v,enumerable:!0,writable:!1},uri:{value:d,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof h?void 0:n.parent}},children:{value:(0,M.createTestItemChildren)(n,k.getPrivateApiFor,s),enumerable:!0,writable:!1},...b(n,i)})}}e.TestItemImpl=s;class h extends s{constructor(A,v){super(A,A,v,void 0),this._isRoot=!0}}e.TestItemRootImpl=h;class p extends M.TestItemCollection{constructor(A,v,i){super({controllerId:A,getDocumentVersion:d=>d&&i.getDocument(d)?.version,getApiFor:k.getPrivateApiFor,getChildren:d=>d.children,root:new h(A,v),toITestItem:O.TestItem.from})}}e.ExtHostTestItemCollection=p}),define(Ce[102],ke([1,0,48,12,83,8,7]),function(ie,e,r,k,D,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class O{constructor(f,b,m){const o=O.c.nextId();f.$registerTextEditorDecorationType(b.identifier,o,M.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:o,dispose(){f.$removeTextEditorDecorationType(o)}})}}e.TextEditorDecorationType=O,O.c=new D.IdGenerator("TextEditorDecorationType");class y{constructor(f,b){this.g=[],this.h=void 0,this.j=!1,this.c=f,this.d=f.version,this.e=b.undoStopBefore,this.f=b.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(f,b){this.k();let m=null;if(f instanceof S.Position)m=new S.Range(f,f);else if(f instanceof S.Range)m=f;else throw new Error("Unrecognized location");this.l(m,b,!1)}insert(f,b){this.k(),this.l(new S.Range(f,f),b,!0)}delete(f){this.k();let b=null;if(f instanceof S.Range)b=f;else throw new Error("Unrecognized location");this.l(b,null,!0)}l(f,b,m){const o=this.c.validateRange(f);this.g.push({range:o,text:b,forceMoveMarkers:m})}setEndOfLine(f){if(this.k(),f!==S.EndOfLine.LF&&f!==S.EndOfLine.CRLF)throw(0,k.illegalArgument)("endOfLine");this.h=f}}class T{constructor(f,b,m,o){this.c=f,this.d=b,this._accept(m),this.e=o;const s=this;this.value={get tabSize(){return s.f},set tabSize(h){s.m(h)},get indentSize(){return s.g},set indentSize(h){s.o(h)},get insertSpaces(){return s.h},set insertSpaces(h){s.q(h)},get cursorStyle(){return s.j},set cursorStyle(h){s.s(h)},get lineNumbers(){return s.k},set lineNumbers(h){s.t(h)}}}_accept(f){this.f=f.tabSize,this.g=f.indentSize,this.h=f.insertSpaces,this.j=f.cursorStyle,this.k=M.TextEditorLineNumbersStyle.to(f.lineNumbers)}l(f){if(f==="auto")return"auto";if(typeof f=="number"){const b=Math.floor(f);return b>0?b:null}if(typeof f=="string"){const b=parseInt(f,10);return isNaN(b)?null:b>0?b:null}return null}m(f){const b=this.l(f);if(b!==null){if(typeof b=="number"){if(this.f===b)return;this.f=b}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:b}))}}n(f){if(f==="tabSize")return"tabSize";if(typeof f=="number"){const b=Math.floor(f);return b>0?b:null}if(typeof f=="string"){const b=parseInt(f,10);return isNaN(b)?null:b>0?b:null}return null}o(f){const b=this.n(f);if(b!==null){if(typeof b=="number"){if(this.g===b)return;this.g=b}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:b}))}}p(f){return f==="auto"?"auto":f==="false"?!1:Boolean(f)}q(f){const b=this.p(f);if(typeof b=="boolean"){if(this.h===b)return;this.h=b}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:b}))}s(f){this.j!==f&&(this.j=f,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:f})))}t(f){this.k!==f&&(this.k=f,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(f)})))}assign(f){const b={};let m=!1;if(typeof f.tabSize<"u"){const o=this.l(f.tabSize);o==="auto"?(m=!0,b.tabSize=o):typeof o=="number"&&this.f!==o&&(this.f=o,m=!0,b.tabSize=o)}if(typeof f.indentSize<"u"){const o=this.n(f.indentSize);o==="tabSize"?(m=!0,b.indentSize=o):typeof o=="number"&&this.g!==o&&(this.g=o,m=!0,b.indentSize=o)}if(typeof f.insertSpaces<"u"){const o=this.p(f.insertSpaces);o==="auto"?(m=!0,b.insertSpaces=o):this.h!==o&&(this.h=o,m=!0,b.insertSpaces=o)}typeof f.cursorStyle<"u"&&this.j!==f.cursorStyle&&(this.j=f.cursorStyle,m=!0,b.cursorStyle=f.cursorStyle),typeof f.lineNumbers<"u"&&this.k!==f.lineNumbers&&(this.k=f.lineNumbers,m=!0,b.lineNumbers=M.TextEditorLineNumbersStyle.from(f.lineNumbers)),m&&this.u("setOptions",this.c.$trySetOptions(this.d,b))}u(f,b){b.catch(m=>{this.e.warn(`ExtHostTextEditorOptions '${f}' failed:'`),this.e.warn(m)})}}e.ExtHostTextEditorOptions=T;class N{constructor(f,b,m,o,s,h,p,w){this.id=f,this.j=b,this.k=m,this.g=!1,this.h=new Set,this.c=s,this.d=new T(this.j,this.id,h,m),this.e=p,this.f=w;const A=this;this.value=Object.freeze({get document(){return o.value},set document(v){throw(0,k.readonly)("document")},get selection(){return A.c&&A.c[0]},set selection(v){if(!(v instanceof S.Selection))throw(0,k.illegalArgument)("selection");A.c=[v],A.l()},get selections(){return A.c},set selections(v){if(!Array.isArray(v)||v.some(i=>!(i instanceof S.Selection)))throw(0,k.illegalArgument)("selections");A.c=v,A.l()},get visibleRanges(){return A.e},set visibleRanges(v){throw(0,k.readonly)("visibleRanges")},get options(){return A.d.value},set options(v){A.g||A.d.assign(v)},get viewColumn(){return A.f},set viewColumn(v){throw(0,k.readonly)("viewColumn")},edit(v,i={undoStopBefore:!0,undoStopAfter:!0}){if(A.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const d=new y(o.value,i);return v(d),A.m(d)},insertSnippet(v,i,d={undoStopBefore:!0,undoStopAfter:!0}){if(A.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!i||Array.isArray(i)&&i.length===0)n=A.c.map(a=>M.Range.from(a));else if(i instanceof S.Position){const{lineNumber:a,column:t}=M.Position.from(i);n=[{startLineNumber:a,startColumn:t,endLineNumber:a,endColumn:t}]}else if(i instanceof S.Range)n=[M.Range.from(i)];else{n=[];for(const a of i)if(a instanceof S.Range)n.push(M.Range.from(a));else{const{lineNumber:t,column:g}=M.Position.from(a);n.push({startLineNumber:t,startColumn:g,endLineNumber:t,endColumn:g})}}return b.$tryInsertSnippet(f,o.value.version,v.value,n,d)},setDecorations(v,i){const d=i.length===0;d&&!A.h.has(v.key)||(d?A.h.delete(v.key):A.h.add(v.key),A.n(()=>{if(M.isDecorationOptionsArr(i))return b.$trySetDecorations(f,v.key,M.fromRangeOrRangeWithMessage(i));{const n=new Array(4*i.length);for(let a=0,t=i.length;a<t;a++){const g=i[a];n[4*a]=g.start.line+1,n[4*a+1]=g.start.character+1,n[4*a+2]=g.end.line+1,n[4*a+3]=g.end.character+1}return b.$trySetDecorationsFast(f,v.key,n)}}))},revealRange(v,i){A.n(()=>b.$tryRevealRange(f,M.Range.from(v),i||S.TextEditorRevealType.Default))},show(v){b.$tryShowEditor(f,M.ViewColumn.from(v))},hide(){b.$tryHideEditor(f)}})}dispose(){(0,r.ok)(!this.g),this.g=!0}_acceptOptions(f){(0,r.ok)(!this.g),this.d._accept(f)}_acceptVisibleRanges(f){(0,r.ok)(!this.g),this.e=f}_acceptViewColumn(f){(0,r.ok)(!this.g),this.f=f}_acceptSelections(f){(0,r.ok)(!this.g),this.c=f}async l(){const f=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,f)),this.value}m(f){const b=f.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const m=b.edits.map(s=>s.range);m.sort((s,h)=>s.end.line===h.end.line?s.end.character===h.end.character?s.start.line===h.start.line?s.start.character-h.start.character:s.start.line-h.start.line:s.end.character-h.end.character:s.end.line-h.end.line);for(let s=0,h=m.length-1;s<h;s++){const p=m[s].end;if(m[s+1].start.isBefore(p))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const o=b.edits.map(s=>({range:M.Range.from(s.range),text:s.text,forceMoveMarkers:s.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,b.documentVersionId,o,{setEndOfLine:typeof b.setEndOfLine=="number"?M.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}n(f){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):f().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this.k.warn(b),null))}}e.ExtHostTextEditor=N}),define(Ce[198],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testContinuousRun:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testContinuousRun.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ce[199],ke([1,0,153,12,29,90,68,30,25,198,163,155]),function(ie,e,r,k,D,M,S,O,y,T,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const f=O.Registry.as(S.Extensions.JSONContribution);class b{constructor(v,i,d){this.a=v,this.b=i,this.c=d}d(v,i){this.a({type:v,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(v){this.d(D.default.Error,v)}warn(v){this.d(D.default.Warning,v)}info(v){this.d(D.default.Info,v)}}e.ExtensionMessageCollector=b;class m{static a(v){const i=new Set;for(let d=0,n=v.length;d<n;d++)i.add(y.ExtensionIdentifier.toKey(v[d].description.identifier));return i}static compute(v,i){if(!v||!v.length)return new m(i,[]);if(!i||!i.length)return new m([],v);const d=this.a(v),n=this.a(i),a=i.filter(g=>!d.has(y.ExtensionIdentifier.toKey(g.description.identifier))),t=v.filter(g=>!n.has(y.ExtensionIdentifier.toKey(g.description.identifier)));return new m(a,t)}constructor(v,i){this.added=v,this.removed=i}}e.ExtensionPointUserDelta=m;class o{constructor(v,i){this.name=v,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(v){if(this.a!==null)throw new Error("Handler already set!");this.a=v,this.d()}acceptUsers(v){this.c=m.compute(this.b,v),this.b=v,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(v){(0,k.onUnexpectedError)(v)}}}e.ExtensionPoint=o;const s={type:"string",enum:["ui","workspace"],enumDescriptions:[r.localize(0,null),r.localize(1,null)]},h="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:r.localize(2,null),properties:{vscode:{type:"string",description:r.localize(3,null),default:"^1.22.0"}}},publisher:{description:r.localize(4,null),type:"string"},displayName:{description:r.localize(5,null),type:"string"},categories:{description:r.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:r.localize(7,null)}]}},galleryBanner:{type:"object",description:r.localize(8,null),properties:{color:{description:r.localize(9,null),type:"string"},theme:{description:r.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:r.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:r.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:r.localize(13,null)},enabledApiProposals:{markdownDescription:r.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(T.allApiProposals),markdownEnumDescriptions:Object.values(T.allApiProposals)}},api:{markdownDescription:r.localize(15,null),type:"string",enum:["none"],enumDescriptions:[r.localize(16,null)]},activationEvents:{description:r.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:r.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:r.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:r.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:r.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:r.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:r.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:r.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:r.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:r.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:r.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:r.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:r.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:r.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:r.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:r.localize(32,null)},{label:"onUri",body:"onUri",description:r.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:r.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:r.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:r.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:r.localize(37,null)},{label:"onRenderer",description:r.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:r.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:r.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:r.localize(41,null)},{label:"*",description:r.localize(42,null),body:"*"}]}},badges:{type:"array",description:r.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:r.localize(44,null)},href:{type:"string",description:r.localize(45,null)},description:{type:"string",description:r.localize(46,null)}}}},markdown:{type:"string",description:r.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:r.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:r.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:r.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:r.localize(51,null),type:"array",items:s,default:["workspace"],defaultSnippets:[{body:["ui"],description:r.localize(52,null)},{body:["workspace"],description:r.localize(53,null)},{body:["ui","workspace"],description:r.localize(54,null)},{body:["workspace","ui"],description:r.localize(55,null)},{body:[],description:r.localize(56,null)}]},capabilities:{description:r.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:r.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:r.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(60,null),r.localize(61,null),r.localize(62,null)]},description:{type:"string",markdownDescription:r.localize(63,null)}}},untrustedWorkspaces:{description:r.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:r.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(66,null),r.localize(67,null),r.localize(68,null)]},restrictedConfigurations:{description:r.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:r.localize(70,null)}}}}},sponsor:{description:r.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:r.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:r.localize(73,null),type:"string"},"vscode:uninstall":{description:r.localize(74,null),type:"string"}}},icon:{type:"string",description:r.localize(75,null)},l10n:{type:"string",description:r.localize(76,null)}}};class p{constructor(){this.a=new Map}registerExtensionPoint(v){if(this.a.has(v.extensionPoint))throw new Error("Duplicate extension point: "+v.extensionPoint);const i=new o(v.extensionPoint,v.defaultExtensionKind);return this.a.set(v.extensionPoint,i),v.activationEventsGenerator&&E.ImplicitActivationEvents.register(v.extensionPoint,v.activationEventsGenerator),e.schema.properties.contributes.properties[v.extensionPoint]=v.jsonSchema,f.registerSchema(h,e.schema),i}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=p;const w={ExtensionsRegistry:"ExtensionsRegistry"};O.Registry.add(w.ExtensionsRegistry,new p),e.ExtensionsRegistry=O.Registry.as(w.ExtensionsRegistry),f.registerSchema(h,e.schema),f.registerSchema(N.productSchemaId,{properties:{extensionEnabledApiProposals:{description:r.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(T.allApiProposals),markdownEnumDescriptions:Object.values(T.allApiProposals)}}]}}}})}),define(Ce[200],ke([1,0,150,9,22,199,42,4]),function(ie,e,r,k,D,M,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:r.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:r.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:r.localize(2,null),default:""}}};var T;(function(f){function b(m,o,s){if(!m)return;const h=k.isString(m.type)?m.type:void 0;if(!h||h.length===0){s.error(r.localize(3,null));return}const p=[];if(Array.isArray(m.required))for(const w of m.required)k.isString(w)&&p.push(w);return{extensionId:o.value,taskType:h,required:p,properties:m.properties?D.deepClone(m.properties):{},when:m.when?S.ContextKeyExpr.deserialize(m.when):void 0}}f.from=b})(T||(T={}));const N=M.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:r.localize(4,null),type:"array",items:y}});class E{constructor(){this.d=new O.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((b,m)=>{N.setHandler((o,s)=>{this.c=void 0;try{for(const h of s.removed){const p=h.value;for(const w of p)this.a&&w.type&&this.a[w.type]&&delete this.a[w.type]}for(const h of s.added){const p=h.value;for(const w of p){const A=T.from(w,h.description.identifier,h.collector);A&&(this.a[A.taskType]=A)}}(s.removed.length>0||s.added.length>0)&&this.d.fire()}catch{}b(void 0)})})}onReady(){return this.b}get(b){return this.a[b]}all(){return Object.keys(this.a).map(b=>this.a[b])}getJsonSchema(){if(this.c===void 0){const b=[];for(const m of this.all()){const o={type:"object",additionalProperties:!1};m.required.length>0&&(o.required=m.required.slice(0)),m.properties!==void 0?o.properties=D.deepClone(m.properties):o.properties=Object.create(null),o.properties.type={type:"string",enum:[m.taskType]},b.push(o)}this.c={oneOf:b}}return this.c}}e.TaskDefinitionRegistry=new E}),define(Ce[201],ke([1,0,151,9,24,22,42,200]),function(ie,e,r,k,D,M,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new S.RawContextKey("taskRunning",!1,r.localize(0,null)),e.TASKS_CATEGORY={value:r.localize(1,null),original:"Tasks"};var y;(function(P){P[P.Escape=1]="Escape",P[P.Strong=2]="Strong",P[P.Weak=3]="Weak"})(y=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(P){function F(H){if(!H)return P.Strong;switch(H.toLowerCase()){case"escape":return P.Escape;case"strong":return P.Strong;case"weak":return P.Weak;default:return P.Strong}}P.from=F}(y=e.ShellQuoting||(e.ShellQuoting={}));var T;(function(P){P.defaults={cwd:"${workspaceFolder}"}})(T=e.CommandOptions||(e.CommandOptions={}));var N;(function(P){P[P.Always=1]="Always",P[P.Silent=2]="Silent",P[P.Never=3]="Never"})(N=e.RevealKind||(e.RevealKind={})),function(P){function F(H){switch(H.toLowerCase()){case"always":return P.Always;case"silent":return P.Silent;case"never":return P.Never;default:return P.Always}}P.fromString=F}(N=e.RevealKind||(e.RevealKind={}));var E;(function(P){P[P.Never=1]="Never",P[P.OnProblem=2]="OnProblem",P[P.Always=3]="Always"})(E=e.RevealProblemKind||(e.RevealProblemKind={})),function(P){function F(H){switch(H.toLowerCase()){case"always":return P.Always;case"never":return P.Never;case"onproblem":return P.OnProblem;default:return P.OnProblem}}P.fromString=F}(E=e.RevealProblemKind||(e.RevealProblemKind={}));var f;(function(P){P[P.Shared=1]="Shared",P[P.Dedicated=2]="Dedicated",P[P.New=3]="New"})(f=e.PanelKind||(e.PanelKind={})),function(P){function F(H){switch(H.toLowerCase()){case"shared":return P.Shared;case"dedicated":return P.Dedicated;case"new":return P.New;default:return P.Shared}}P.fromString=F}(f=e.PanelKind||(e.PanelKind={}));var b;(function(P){P.defaults={echo:!0,reveal:N.Always,revealProblems:E.Never,focus:!1,panel:f.Shared,showReuseMessage:!0,clear:!1}})(b=e.PresentationOptions||(e.PresentationOptions={}));var m;(function(P){P[P.Shell=1]="Shell",P[P.Process=2]="Process",P[P.CustomExecution=3]="CustomExecution"})(m=e.RuntimeType||(e.RuntimeType={})),function(P){function F(j){switch(j.toLowerCase()){case"shell":return P.Shell;case"process":return P.Process;case"customExecution":return P.CustomExecution;default:return P.Process}}P.fromString=F;function H(j){switch(j){case P.Shell:return"shell";case P.Process:return"process";case P.CustomExecution:return"customExecution";default:return"process"}}P.toString=H}(m=e.RuntimeType||(e.RuntimeType={}));var o;(function(P){function F(H){return k.isString(H)?H:H.value}P.value=F})(o=e.CommandString||(e.CommandString={}));var s;(function(P){P.Clean={_id:"clean",isDefault:!1},P.Build={_id:"build",isDefault:!1},P.Rebuild={_id:"rebuild",isDefault:!1},P.Test={_id:"test",isDefault:!1};function F(j){return j===P.Clean._id||j===P.Build._id||j===P.Rebuild._id||j===P.Test._id}P.is=F;function H(j){if(j!==void 0)return k.isString(j)?F(j)?{_id:j,isDefault:!1}:void 0:j}P.from=H})(s=e.TaskGroup||(e.TaskGroup={}));var h;(function(P){P[P.Global=1]="Global",P[P.Workspace=2]="Workspace",P[P.Folder=3]="Folder"})(h=e.TaskScope||(e.TaskScope={}));var p;(function(P){P.Workspace="workspace",P.Extension="extension",P.InMemory="inMemory",P.WorkspaceFile="workspaceFile",P.User="user";function F(H){switch(H){case P.User:return 2;case P.WorkspaceFile:return 5;default:return 6}}P.toConfigurationTarget=F})(p=e.TaskSourceKind||(e.TaskSourceKind={}));var w;(function(P){P.parallel="parallel",P.sequence="sequence"})(w=e.DependsOrder||(e.DependsOrder={}));var A;(function(P){P[P.default=1]="default",P[P.folderOpen=2]="folderOpen"})(A=e.RunOnOptions||(e.RunOnOptions={}));var v;(function(P){P.defaults={reevaluateOnRerun:!0,runOn:A.default,instanceLimit:1}})(v=e.RunOptions||(e.RunOptions={}));class i{constructor(F,H,j,le,_,be){this._label="",this._id=F,H&&(this._label=H),j&&(this.type=j),this.runOptions=le,this.configurationProperties=_,this._source=be}getDefinition(F){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const F={folder:this.d(),id:this._id};return JSON.stringify(F)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(F,H=!1){if(F===void 0)return!1;if(k.isString(F))return F===this._label||F===this.configurationProperties.identifier||H&&F===this._id;const j=this.getDefinition(!0);return j!==void 0&&j._key===F._key}getQualifiedLabel(){const F=this.getWorkspaceFolder();return F?`${this._label} (${F.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(F){this.c===void 0&&(this.c=[]),F&&(this.c=this.c.concat(F))}get taskLoadMessages(){return this.c}}e.CommonTask=i;class d extends i{constructor(F,H,j,le,_,be,de,ue){super(F,j,void 0,de,ue,H),this.command={},this._source=H,this.hasDefinedMatchers=be,_&&(this.command=_)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(F=!1){if(F&&this._source.customizes!==void 0)return this._source.customizes;{let H;switch(this.command?this.command.runtime:void 0){case m.Shell:H="shell";break;case m.Process:H="process";break;case m.CustomExecution:H="customExecution";break;case void 0:H="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:H,_key:this._id,id:this._id}}}static is(F){return F instanceof d}getMapKey(){const F=this._source.config.workspaceFolder;return F?`${F.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===p.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const F=this.d();if(!F)return;let H=this.configurationProperties.identifier;this._source.kind!==p.Workspace&&(H+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:F,id:H};return JSON.stringify(j)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(F){return new d(F._id,F._source,F._label,F.type,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.CustomTask=d;class n extends i{constructor(F,H,j,le,_,be,de){super(F,j,le,be,de,H),this._source=H,this.configures=_}static is(F){return F instanceof n}f(F){return F}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===p.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const F=this.d();if(!F)return;let H=this.configurationProperties.identifier;this._source.kind!==p.Workspace&&(H+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:F,id:H};return JSON.stringify(j)}}e.ConfiguringTask=n;class a extends i{constructor(F,H,j,le,_,be,de,ue,se){super(F,j,le,ue,se,H),this.defines=_,this.hasDefinedMatchers=de,this.command=be,this.icon=se.icon,this.hide=se.hide}clone(){return new a(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(F){return F instanceof a}getMapKey(){const F=this._source.workspaceFolder;return F?`${this._source.scope.toString()}|${F.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const F={type:"contributed",scope:this._source.scope,id:this._id};return F.folder=this.d(),JSON.stringify(F)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(F){return new a(F._id,F._source,F._label,F.type,F.defines,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.ContributedTask=a;class t extends i{constructor(F,H,j,le,_,be){super(F,j,le,_,be,H),this._source=H}clone(){return new t(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(F){return F instanceof t}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(F){return new t(F._id,F._source,F._label,F.type,F.runOptions,F.configurationProperties)}}e.InMemoryTask=t;var g;(function(P){P[P.Process=1]="Process",P[P.Terminal=2]="Terminal"})(g=e.ExecutionEngine||(e.ExecutionEngine={})),function(P){P._default=P.Terminal}(g=e.ExecutionEngine||(e.ExecutionEngine={}));var c;(function(P){P[P.V0_1_0=1]="V0_1_0",P[P.V2_0_0=2]="V2_0_0"})(c=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class u{constructor(F){this.c=new Map;for(let H=0;H<F.length;H++)this.c.set(F[H].uri.toString(),H)}compare(F,H){const j=F.getWorkspaceFolder(),le=H.getWorkspaceFolder();if(j&&le){let _=this.c.get(j.uri.toString());_=_===void 0?0:_+1;let be=this.c.get(le.uri.toString());return be=be===void 0?0:be+1,_===be?F._label.localeCompare(H._label):_-be}else return!j&&le?-1:j&&!le?1:0}}e.TaskSorter=u;var l;(function(P){P.DependsOnStarted="dependsOnStarted",P.AcquiredInput="acquiredInput",P.Start="start",P.ProcessStarted="processStarted",P.Active="active",P.Inactive="inactive",P.Changed="changed",P.Terminated="terminated",P.ProcessEnded="processEnded",P.End="end"})(l=e.TaskEventKind||(e.TaskEventKind={}));var C;(function(P){P.SingleRun="singleRun",P.Background="background"})(C=e.TaskRunType||(e.TaskRunType={}));var R;(function(P){P[P.System=0]="System",P[P.User=1]="User",P[P.FolderOpen=2]="FolderOpen",P[P.ConfigurationChange=3]="ConfigurationChange",P[P.Reconnect=4]="Reconnect"})(R=e.TaskRunSource||(e.TaskRunSource={}));var V;(function(P){function F(H,j,le,_){if(j){const be={kind:H,taskId:j._id,taskName:j.configurationProperties.name,runType:j.configurationProperties.isBackground?"background":"singleRun",group:j.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:le,__task:j};return H==="start"?be.resolvedVariables=_:H==="processStarted"?be.processId=_:H==="processEnded"&&(be.exitCode=_),Object.freeze(be)}else return Object.freeze({kind:"changed"})}P.create=F})(V=e.TaskEvent||(e.TaskEvent={}));var ee;(function(P){function F(j){const le=Object.keys(j).sort();let _="";for(const be of le){let de=j[be];de instanceof Object?de=F(de):typeof de=="string"&&(de=de.replace(/,/g,",,")),_+=be+","+de+","}return _}function H(j){const _={_key:F(j),type:j.taskType};return Object.assign(_,j),_}P.create=H})(ee=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var K;(function(P){P.AutoDetect="task.autoDetect",P.SaveBeforeRun="task.saveBeforeRun",P.ShowDecorations="task.showDecorations",P.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",P.SlowProviderWarning="task.slowProviderWarning",P.QuickOpenHistory="task.quickOpen.history",P.QuickOpenDetail="task.quickOpen.detail",P.QuickOpenSkip="task.quickOpen.skip",P.QuickOpenShowAll="task.quickOpen.showAll",P.AllowAutomaticTasks="task.allowAutomaticTasks",P.Reconnection="task.reconnection"})(K=e.TaskSettingId||(e.TaskSettingId={}));var L;(function(P){P.Tasks="tasks",P.SuppressTaskName="tasks.suppressTaskName",P.Windows="tasks.windows",P.Osx="tasks.osx",P.Linux="tasks.linux",P.ShowOutput="tasks.showOutput",P.IsShellCommand="tasks.isShellCommand",P.ServiceTestSetting="tasks.service.testSetting"})(L=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var B;(function(P){function F(H,j){const le=O.TaskDefinitionRegistry.get(H.type);if(le===void 0){const ue=M.deepClone(H);return delete ue._key,ee.create(ue)}const _=Object.create(null);_.type=le.taskType;const be=new Set;le.required.forEach(ue=>be.add(ue));const de=le.properties;for(const ue of Object.keys(de)){const se=H[ue];if(se!=null)_[ue]=se;else if(be.has(ue)){const J=de[ue];if(J.default!==void 0)_[ue]=M.deepClone(J.default);else switch(J.type){case"boolean":_[ue]=!1;break;case"number":case"integer":_[ue]=0;break;case"string":_[ue]="";break;default:j.error(r.localize(2,null,JSON.stringify(H,void 0,0),ue));return}}}return ee.create(_)}P.createTaskIdentifier=F})(B=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ce[202],ke([1,0,12]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class k{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((S,O)=>{this.b=S,this.d=O,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(S){this.f||this.h||(this.f=!0,this.g=S,this.a&&this.b(S))}resolveErr(S){this.f||this.h||(this.h=!0,this.i=S,this.a?this.d(S):(0,r.onUnexpectedError)(S))}then(S,O){return this.j().then(S,O)}catch(S){return this.j().then(void 0,S)}finally(S){return this.j().finally(S)}}e.LazyPromise=k;class D extends k{constructor(){super(),this.h=!0,this.i=new r.CancellationError}}e.CanceledLazyPromise=D}),define(Ce[45],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class r{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++r.count}}e.ProxyIdentifier=r,r.count=0;const k=[];function D(O){const y=new r(O);return k[y.nid]=y,y}e.createProxyIdentifier=D;function M(O){return k[O].sid}e.getStringIdentifierForProxy=M;class S{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=S}),define(Ce[5],ke([1,0,45]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var k;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(k=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(o){o[o.UnknownInput=0]="UnknownInput",o[o.TextInput=1]="TextInput",o[o.TextDiffInput=2]="TextDiffInput",o[o.TextMergeInput=3]="TextMergeInput",o[o.NotebookInput=4]="NotebookInput",o[o.NotebookDiffInput=5]="NotebookDiffInput",o[o.CustomEditorInput=6]="CustomEditorInput",o[o.WebviewEditorInput=7]="WebviewEditorInput",o[o.TerminalEditorInput=8]="TerminalEditorInput",o[o.InteractiveEditorInput=9]="InteractiveEditorInput"})(D=e.TabInputKind||(e.TabInputKind={}));var M;(function(o){o[o.TAB_OPEN=0]="TAB_OPEN",o[o.TAB_CLOSE=1]="TAB_CLOSE",o[o.TAB_UPDATE=2]="TAB_UPDATE",o[o.TAB_MOVE=3]="TAB_MOVE"})(M=e.TabModelOperationKind||(e.TabModelOperationKind={}));var S;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(S=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var O;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(O=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var y;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(y=e.CellOutputKind||(e.CellOutputKind={}));var T;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(T=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var N;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output"})(N=e.CandidatePortSource||(e.CandidatePortSource={}));class E{static mixin(s){return s._id=E.a++,s}}e.IdObject=E,E.a=0;var f;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.kindModifier="m",o.commandIdent="n",o.commandId="o",o.commandArguments="p"})(f=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var b;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(b=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var m;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(m=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,r.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,r.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,r.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,r.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,r.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,r.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,r.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,r.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,r.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,r.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,r.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,r.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,r.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,r.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,r.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,r.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,r.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,r.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,r.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,r.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,r.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,r.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,r.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,r.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,r.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,r.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,r.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,r.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,r.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,r.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,r.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,r.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,r.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,r.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,r.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,r.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,r.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,r.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,r.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,r.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,r.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,r.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,r.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,r.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,r.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,r.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,r.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,r.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,r.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,r.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,r.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,r.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,r.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,r.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,r.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,r.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,r.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,r.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,r.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,r.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,r.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,r.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,r.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,r.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,r.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,r.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,r.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,r.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,r.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,r.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,r.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,r.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,r.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,r.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,r.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,r.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,r.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,r.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,r.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,r.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,r.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,r.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,r.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,r.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,r.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,r.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,r.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,r.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,r.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,r.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,r.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,r.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,r.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,r.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,r.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,r.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,r.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,r.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,r.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,r.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,r.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,r.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,r.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,r.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,r.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,r.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,r.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,r.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,r.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,r.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,r.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,r.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,r.createProxyIdentifier)("ExtHostLocalization")}}),define(Ce[76],ke([1,0,3,11,5,17]),function(ie,e,r,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,r.createDecorator)("IExtHostApiDeprecationService");let S=class{constructor(y,T){this.c=T,this.a=new Set,this.b=y.getProxy(D.MainContext.MainThreadTelemetry)}report(y,T,N){const E=this.d(y,T);this.a.has(E)||(this.a.add(E),T.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${y}' is deprecated. ${N}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:T.identifier.value,apiId:y}))}d(y,T){return`${y}-${T.identifier.value}`}};S=qe([je(0,M.IExtHostRpcService),je(1,k.ILogService)],S),e.ExtHostApiDeprecationService=S,e.NullApiDeprecationService=Object.freeze(new class{report(O,y,T){}})}),define(Ce[203],ke([1,0,4,5,7,25]),function(ie,e,r,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class S{constructor(y){this.b=new Map,this.c=[],this.d=new r.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=y.getProxy(k.MainContext.MainThreadAuthentication)}$setProviders(y){return this.c=y,Promise.resolve()}async getSession(y,T,N,E={}){const f=M.ExtensionIdentifier.toKey(y.identifier),b=this.f.get(f)||[],m=[...N].sort().join(" ");let o=b.find(s=>s.providerId===T&&s.scopes===m);if(o)return o.result;{const s=this.g(y,f,T,N,E);o={providerId:T,scopes:m,result:s},b.push(o),this.f.set(f,b);try{await s}finally{const h=b.findIndex(p=>p.providerId===T&&p.scopes===m);h>-1&&(b.splice(h),this.f.set(f,b))}return s}}async g(y,T,N,E,f={}){await this.a.$ensureProvider(N);const b=y.displayName||y.name;return this.a.$getSession(N,E,T,b,f)}async removeSession(y,T){const N=this.b.get(y);return N?N.provider.removeSession(T):this.a.$removeSession(y,T)}registerAuthenticationProvider(y,T,N,E){if(this.b.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this.b.set(y,{label:T,provider:N,options:E??{supportsMultipleAccounts:!1}}),this.c.find(b=>b.id===y)||this.c.push({id:y,label:T});const f=N.onDidChangeSessions(b=>{this.a.$sendDidChangeSessions(y,{added:b.added??[],changed:b.changed??[],removed:b.removed??[]})});return this.a.$registerAuthenticationProvider(y,T,E?.supportsMultipleAccounts??!1),new D.Disposable(()=>{f.dispose(),this.b.delete(y);const b=this.c.findIndex(m=>m.id===y);b>-1&&this.c.splice(b),this.a.$unregisterAuthenticationProvider(y)})}$createSession(y,T){const N=this.b.get(y);if(N)return Promise.resolve(N.provider.createSession(T));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,T){const N=this.b.get(y);if(N)return Promise.resolve(N.provider.removeSession(T));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,T){const N=this.b.get(y);if(N)return Promise.resolve(N.provider.getSessions(T));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,T){return this.d.fire({provider:{id:y,label:T}}),Promise.resolve()}}e.ExtHostAuthentication=S}),define(Ce[204],ke([1,0,5,17,8]),function(ie,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let M=class{constructor(O,y){this.a=O.getProxy(r.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:T=>y.getDocument(T)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(O,y,T){const N=D.WorkspaceEdit.from(O,this.b);return this.a.$tryApplyWorkspaceEdit(N,void 0,T?.isRefactoring??!1)}};M=qe([je(0,k.IExtHostRpcService)],M),e.ExtHostBulkEdits=M}),define(Ce[205],ke([1,0,5]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class k{constructor(M){const S=M.getProxy(r.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return S.$readText()},writeText(O){return S.$writeText(O)}})}}e.ExtHostClipboard=k});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!D:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(ie,r):D?D.value=r:e.set(ie,r),r},Le=this&&this.__classPrivateFieldGet||function(ie,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(ie):k?k.value:e.get(ie)};define(Ce[37],ke([1,0,9,7,8,22,5,18,11,65,56,258,2,6,3,17,101,23,45,39,77,51]),function(ie,e,r,k,D,M,S,O,y,T,N,E,f,b,m,o,s,h,p,w,A,v){"use strict";var i,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let n=class{constructor(l,C){i.set(this,void 0),this.b=new Map,this.c=new Map,d.set(this,void 0),Je(this,i,l.getProxy(S.MainContext.MainThreadCommands),"f"),this.d=C,Je(this,d,l.getProxy(S.MainContext.MainThreadTelemetry),"f"),this.converter=new a(this,R=>{const V=this.c.get(R);return V?.result===g.Void?V:void 0},C),this.f=[{processArgument(R){return(0,T.revive)(R)}},{processArgument(R){return(0,M.cloneAndChange)(R,function(V){if(N.Range.isIRange(V))return D.Range.to(V);if(E.Position.isIPosition(V))return D.Position.to(V);if(N.Range.isIRange(V.range)&&f.URI.isUri(V.uri))return D.location.to(V);if(V instanceof h.VSBuffer)return V.buffer.buffer;if(!Array.isArray(V))return V})}}]}registerArgumentProcessor(l){this.f.push(l)}registerApiCommand(l){const C=this.registerCommand(!1,l.id,async(...R)=>{const V=l.args.map((K,L)=>{if(!K.validate(R[L]))throw new Error(`Invalid argument '${K.name}' when running '${l.id}', received: ${R[L]}`);return K.convert(R[L])}),ee=await this.executeCommand(l.internalId,...V);return l.result.convert(ee,R,this.converter)},void 0,{description:l.description,args:l.args,returns:l.result.description});return this.c.set(l.id,l),new k.Disposable(()=>{C.dispose(),this.c.delete(l.id)})}registerCommand(l,C,R,V,ee,K){if(this.d.trace("ExtHostCommands#registerCommand",C),!C.trim().length)throw new Error("invalid id");if(this.b.has(C))throw new Error(`command '${C}' already exists`);return this.b.set(C,{callback:R,thisArg:V,description:ee,extension:K}),l&&Le(this,i,"f").$registerCommand(C),new k.Disposable(()=>{this.b.delete(C)&&l&&Le(this,i,"f").$unregisterCommand(C)})}executeCommand(l,...C){return this.d.trace("ExtHostCommands#executeCommand",l),this.g(l,C,!0)}async g(l,C,R){if(this.b.has(l))return Le(this,i,"f").$fireCommandActivationEvent(l),this.h(l,C,!1);{let V=!1;const ee=(0,M.cloneAndChange)(C,function(K){if(K instanceof k.Position)return D.Position.from(K);if(K instanceof k.Range)return D.Range.from(K);if(K instanceof k.Location)return D.location.from(K);if(k.NotebookRange.isNotebookRange(K))return D.NotebookRange.from(K);if(K instanceof ArrayBuffer)return V=!0,h.VSBuffer.wrap(new Uint8Array(K));if(K instanceof Uint8Array)return V=!0,h.VSBuffer.wrap(K);if(K instanceof h.VSBuffer)return V=!0,K;if(!Array.isArray(K))return K});try{const K=await Le(this,i,"f").$executeCommand(l,V?new p.SerializableObjectWithBuffers(ee):ee,R);return(0,T.revive)(K)}catch(K){if(K instanceof Error&&K.message==="$executeCommand:retry")return this.g(l,C,!1);throw K}}}async h(l,C,R){const V=this.b.get(l);if(!V)throw new Error("Unknown command");const{callback:ee,thisArg:K,description:L}=V;if(L)for(let P=0;P<L.args.length;P++)try{(0,r.validateConstraint)(C[P],L.args[P].constraint)}catch{throw new Error(`Running the contributed command: '${l}' failed. Illegal argument '${L.args[P].name}' - ${L.args[P].description}`)}const B=A.StopWatch.create();try{return await ee.apply(K,C)}catch(P){if(l===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...C);F&&(l=F.command)}throw this.d.error(P,l,V.extension?.identifier),R?new class extends Error{constructor(){super((0,w.toErrorMessage)(P)),this.id=l,this.source=V.extension?.displayName??V.extension?.name}}:P}finally{this.j(V,l,B.elapsed())}}j(l,C,R){!l.extension||Le(this,d,"f").$publicLog2("Extension:ActionExecuted",{extensionId:l.extension.identifier.value,id:new v.TelemetryTrustedValue(C),duration:R})}$executeContributedCommand(l,...C){this.d.trace("ExtHostCommands#$executeContributedCommand",l);const R=this.b.get(l);return R?(C=C.map(V=>this.f.reduce((ee,K)=>K.processArgument(ee,R.extension?.identifier),V)),this.h(l,C,!0)):Promise.reject(new Error(`Contributed command '${l}' does not exist.`))}getCommands(l=!1){return this.d.trace("ExtHostCommands#getCommands",l),Le(this,i,"f").$getCommands().then(C=>(l&&(C=C.filter(R=>R[0]!=="_")),C))}$getContributedCommandHandlerDescriptions(){const l=Object.create(null);for(const[C,R]of this.b){const{description:V}=R;V&&(l[C]=V)}return Promise.resolve(l)}};i=new WeakMap,d=new WeakMap,n=qe([je(0,o.IExtHostRpcService),je(1,y.ILogService)],n),e.ExtHostCommands=n,e.IExtHostCommands=(0,m.createDecorator)("IExtHostCommands");class a{constructor(l,C,R){this.d=l,this.f=C,this.g=R,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(l,C){if(!l)return;const R={$ident:void 0,id:l.command,title:l.title,tooltip:l.tooltip};if(!l.command)return R;const V=this.f(l.command);if(V)R.id=V.internalId,R.arguments=V.args.map((ee,K)=>ee.convert(l.arguments&&l.arguments[K]));else if((0,O.isNonEmptyArray)(l.arguments)){const ee=`${l.command}/${++this.c}`;this.b.set(ee,l),C.add((0,b.toDisposable)(()=>{this.b.delete(ee),this.g.trace("CommandsConverter#DISPOSE",ee)})),R.$ident=ee,R.id=this.delegatingCommandId,R.arguments=[ee],this.g.trace("CommandsConverter#CREATE",l.command,ee)}return R}fromInternal(l){return typeof l.$ident=="string"?this.b.get(l.$ident):{command:l.id,title:l.title,arguments:l.arguments}}getActualCommand(...l){return this.b.get(l[0])}h(...l){const C=this.getActualCommand(...l);return this.g.trace("CommandsConverter#EXECUTE",l[0],C?C.command:"MISSING"),C?this.d.executeCommand(C.command,...C.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${l[0]}`)}}e.CommandsConverter=a;class t{constructor(l,C,R,V){this.name=l,this.description=C,this.validate=R,this.convert=V}optional(){return new t(this.name,`(optional) ${this.description}`,l=>l==null||this.validate(l),l=>l===void 0?void 0:l===null?null:this.convert(l))}with(l,C){return new t(l??this.name,C??this.description,this.validate,this.convert)}}e.ApiCommandArgument=t,t.Uri=new t("uri","Uri of a text document",u=>f.URI.isUri(u),u=>u),t.Position=new t("position","A position in a text document",u=>k.Position.isPosition(u),D.Position.from),t.Range=new t("range","A range in a text document",u=>k.Range.isRange(u),D.Range.from),t.Selection=new t("selection","A selection in a text document",u=>k.Selection.isSelection(u),D.Selection.from),t.Number=new t("number","",u=>typeof u=="number",u=>u),t.String=new t("string","",u=>typeof u=="string",u=>u),t.CallHierarchyItem=new t("item","A call hierarchy item",u=>u instanceof k.CallHierarchyItem,D.CallHierarchyItem.from),t.TypeHierarchyItem=new t("item","A type hierarchy item",u=>u instanceof k.TypeHierarchyItem,D.TypeHierarchyItem.from),t.TestItem=new t("testItem","A VS Code TestItem",u=>u instanceof s.TestItemImpl,D.TestItem.from);class g{constructor(l,C){this.description=l,this.convert=C}}e.ApiCommandResult=g,g.Void=new g("no result",u=>u);class c{constructor(l,C,R,V,ee){this.id=l,this.internalId=C,this.description=R,this.args=V,this.result=ee}}e.ApiCommand=c}),define(Ce[206],ke([1,0,2,8,7,75,37,18,88,92,15]),function(ie,e,r,k,D,M,S,O,y,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const E=[new S.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",b(k.DocumentHighlight.to))),new S.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(o,s)=>{if((0,O.isFalsyOrEmpty)(o))return;class h extends D.SymbolInformation{static to(w){const A=new h(w.name,k.SymbolKind.to(w.kind),w.containerName||"",new D.Location(s[0],k.Range.to(w.range)));return A.detail=w.detail,A.range=A.location.range,A.selectionRange=k.Range.to(w.selectionRange),A.children=w.children?w.children.map(h.to):[],A}}return o.map(h.to)})),new S.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(k.TextEdit.to))),new S.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range,new S.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(k.TextEdit.to))),new S.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,new S.ApiCommandArgument("ch","Trigger character",o=>typeof o=="string",o=>o),new S.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(k.TextEdit.to))),new S.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new S.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new S.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new S.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new S.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location-instances.",b(k.location.to))),new S.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Hover-instances.",b(k.Hover.to))),new S.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("position","A position in a text document",o=>Array.isArray(o)&&o.every(s=>D.Position.isPosition(s)),o=>o.map(k.Position.from))],new S.ApiCommandResult("A promise that resolves to an array of ranges.",o=>o.map(s=>{let h;for(const p of s.reverse())h=new D.SelectionRange(k.Range.to(p),h);return h}))),new S.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[S.ApiCommandArgument.String.with("query","Search string")],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",o=>o.map(k.WorkspaceSymbol.to))),new S.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",o=>o.map(k.CallHierarchyItem.to))),new S.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",o=>o.map(k.CallHierarchyIncomingCall.to))),new S.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",o=>o.map(k.CallHierarchyOutgoingCall.to))),new S.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to a range and placeholder text.",o=>{if(!!o)return{range:k.Range.to(o.range),placeholder:o.text}})),new S.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("newName","The new symbol name")],new S.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",o=>{if(!!o){if(o.rejectReason)throw new Error(o.rejectReason);return k.WorkspaceEdit.to(o)}})),new S.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new S.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",o=>o.map(k.DocumentLink.to))),new S.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",o=>{if(!!o)return new D.SemanticTokensLegend(o.tokenTypes,o.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",o=>{if(!o)return;const s=(0,y.decodeSemanticTokensDto)(o);if(s.type==="full")return new D.SemanticTokens(s.data,void 0)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range.optional()],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",o=>{if(!!o)return new D.SemanticTokensLegend(o.tokenTypes,o.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",o=>{if(!o)return;const s=(0,y.decodeSemanticTokensDto)(o);if(s.type==="full")return new D.SemanticTokens(s.data,void 0)})),new S.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new S.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(o,s,h)=>{if(!o)return new D.CompletionList([]);const p=o.suggestions.map(w=>k.CompletionItem.to(w,h));return new D.CompletionList(p,o.incomplete)})),new S.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new S.ApiCommandResult("A promise that resolves to SignatureHelp.",o=>{if(o)return k.SignatureHelp.to(o)})),new S.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new S.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(o,s,h)=>b(p=>new D.CodeLens(k.Range.to(p.range),p.command&&h.fromInternal(p.command)))(o))),new S.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",o=>D.Range.isRange(o),o=>D.Selection.isSelection(o)?k.Selection.from(o):k.Range.from(o)),S.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new S.ApiCommandResult("A promise that resolves to an array of Command-instances.",(o,s,h)=>b(p=>{if(p._isSynthetic){if(!p.command)throw new Error("Synthetic code actions must have a command");return h.fromInternal(p.command)}else{const w=new D.CodeAction(p.title,p.kind?new D.CodeActionKind(p.kind):void 0);return p.edit&&(w.edit=k.WorkspaceEdit.to(p.edit)),p.command&&(w.command=h.fromInternal(p.command)),w.isPreferred=p.isPreferred,w}})(o))),new S.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",o=>o?o.map(s=>new D.ColorInformation(k.Range.to(s.range),k.Color.to(s.color))):[])),new S.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new S.ApiCommandArgument("color","The color to show and insert",o=>o instanceof D.Color,k.Color.from),new S.ApiCommandArgument("context","Context object with uri and range",o=>!0,o=>({uri:o.uri,range:k.Range.from(o.range)}))],new S.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",o=>o?o.map(k.ColorPresentation.to):[])),new S.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of Inlay objects",(o,s,h)=>o.map(k.InlayHint.to.bind(void 0,h)))),new S.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new S.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",b(o=>({viewType:o.viewType,displayName:o.displayName,options:{transientOutputs:o.options.transientOutputs,transientCellMetadata:o.options.transientCellMetadata,transientDocumentMetadata:o.options.transientDocumentMetadata},filenamePattern:o.filenamePattern.map(s=>k.NotebookExclusiveDocumentPattern.to(s))})))),new S.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineValue objects",o=>o.map(k.InlineValue.to))),new S.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new S.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",o=>r.URI.isUri(o)||typeof o=="string"&&(0,T.matchesSomeScheme)(o,N.Schemas.http,N.Schemas.https),o=>o),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[k.ViewColumn.from(o),void 0]:[k.ViewColumn.from(o.viewColumn),k.TextEditorOpenOptions.from(o)])).optional(),S.ApiCommandArgument.String.with("label","").optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[S.ApiCommandArgument.Uri.with("resource","Resource to open"),S.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[k.ViewColumn.from(o),void 0]:[k.ViewColumn.from(o.viewColumn),k.TextEditorOpenOptions.from(o)])).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[S.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),S.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),S.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="object",o=>o&&[k.ViewColumn.from(o.viewColumn),k.TextEditorOpenOptions.from(o)]).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",o=>o.map(k.TypeHierarchyItem.to))),new S.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[S.ApiCommandArgument.TypeHierarchyItem],new S.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",o=>o.map(k.TypeHierarchyItem.to))),new S.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[S.ApiCommandArgument.TypeHierarchyItem],new S.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",o=>o.map(k.TypeHierarchyItem.to))),new S.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[S.ApiCommandArgument.TestItem],S.ApiCommandResult.Void),new S.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[S.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],S.ApiCommandResult.Void),new S.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[S.ApiCommandArgument.String.with("name","The context key name"),new S.ApiCommandArgument("value","The context key value",()=>!0,o=>o)],S.ApiCommandResult.Void)];class f{static register(s){E.forEach(s.registerApiCommand,s)}}e.ExtHostApiCommands=f;function b(o){return s=>{if(Array.isArray(s))return s.map(o)}}function m(o){if(!Array.isArray(o))return;const s=[];for(const h of o)M.isLocationLink(h)?s.push(k.DefinitionLink.to(h)):s.push(k.location.to(h));return s}}),define(Ce[207],ke([1,0,16,63,4,6,2,75,25,8,7,5]),function(ie,e,r,k,D,M,S,O,y,T,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function f(b,m,o){const s=b.getProxy(E.MainContext.MainThreadComments);class h{constructor(){this.b=new Map,this.c=new Map,m.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const g=this.b.get(t.handle);return g?g.value:t}else if(t&&t.$mid===7){const g=this.b.get(t.commentControlHandle);if(!g)return t;const c=g.getCommentThread(t.commentThreadHandle);return c?c.value:t}else if(t&&(t.$mid===9||t.$mid===8)){const g=this.b.get(t.thread.commentControlHandle);if(!g)return t;const c=g.getCommentThread(t.thread.commentThreadHandle);return c?t.$mid===8?c.value:{thread:c.value,text:t.text}:t}else if(t&&t.$mid===10){const g=this.b.get(t.thread.commentControlHandle);if(!g)return t;const c=g.getCommentThread(t.thread.commentThreadHandle);if(!c)return t;const u=t.commentUniqueId,l=c.getCommentByUniqueId(u);return l||t}else if(t&&t.$mid===11){const g=this.b.get(t.thread.commentControlHandle);if(!g)return t;const c=g.getCommentThread(t.thread.commentThreadHandle);if(!c)return t;const u=t.text,l=t.commentUniqueId,C=c.getCommentByUniqueId(l);return C?(typeof C.body=="string"?C.body=u:C.body=new N.MarkdownString(u),C):t}return t}})}createCommentController(t,g,c){const u=h.a++,l=new w(t,u,g,c);this.b.set(l.handle,l);const C=this.c.get(y.ExtensionIdentifier.toKey(t.identifier))||[];return C.push(l),this.c.set(y.ExtensionIdentifier.toKey(t.identifier),C),l.value}$createCommentThreadTemplate(t,g,c){const u=this.b.get(t);!u||u.$createCommentThreadTemplate(g,c)}async $updateCommentThreadTemplate(t,g,c){const u=this.b.get(t);!u||u.$updateCommentThreadTemplate(g,c)}$deleteCommentThread(t,g){this.b.get(t)?.$deleteCommentThread(g)}$provideCommentingRanges(t,g,c){const u=this.b.get(t);if(!u||!u.commentingRangeProvider)return Promise.resolve(void 0);const l=o.getDocument(S.URI.revive(g));return(0,r.asPromise)(()=>u.commentingRangeProvider.provideCommentingRanges(l,c)).then(C=>C?C.map(R=>T.Range.from(R)):void 0)}$toggleReaction(t,g,c,u,l){const C=this.b.get(t);return!C||!C.reactionHandler?Promise.resolve(void 0):(0,r.asPromise)(()=>{const R=C.getCommentThread(g);if(R){const V=R.getCommentByUniqueId(u.uniqueIdInThread);if(C!==void 0&&V&&C.reactionHandler)return C.reactionHandler(V,i(l))}return Promise.resolve(void 0)})}dispose(){}}h.a=0;class p{set threadId(t){this.n=t}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(t){t.isEqual(this.p)||(this.p=t,this.b.range=t,this.c.fire())}get range(){return this.p}set canReply(t){this.d!==t&&(this.d=t,this.b.canReply=t,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(t){this.e=t,this.b.label=t,this.c.fire()}get contextValue(){return this.f}set contextValue(t){this.f=t,this.b.contextValue=t,this.c.fire()}get comments(){return this.q}set comments(t){this.q=t,this.b.comments=t,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(t){this.g=t,this.b.collapsibleState=t,this.c.fire()}get state(){return this.h}set state(t){this.h=t,this.b.state=t,this.c.fire()}get isDisposed(){return this.j}constructor(t,g,c,u,l,C,R,V){this.m=g,this.n=c,this.o=u,this.p=l,this.q=C,this.extensionDescription=R,this.r=V,this.handle=p.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new D.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.MutableDisposable,this.l.value=new M.DisposableStore,this.n===void 0&&(this.n=`${t}.${this.handle}`),s.$createCommentThread(g,this.handle,this.n,this.o,T.Range.from(this.p),R.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=C,this.i.push({dispose:()=>{s.$deleteCommentThread(g,this.handle)}});const ee=this;this.value={get uri(){return ee.uri},get range(){return ee.range},set range(K){ee.range=K},get comments(){return ee.comments},set comments(K){ee.comments=K},get collapsibleState(){return ee.collapsibleState},set collapsibleState(K){ee.collapsibleState=K},get canReply(){return ee.canReply},set canReply(K){ee.canReply=K},get contextValue(){return ee.contextValue},set contextValue(K){ee.contextValue=K},get label(){return ee.label},set label(K){ee.label=K},get state(){return ee.state},set state(K){ee.state=K},dispose:()=>{ee.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.DisposableStore);const t=c=>Object.prototype.hasOwnProperty.call(this.b,c),g={};t("range")&&(g.range=T.Range.from(this.p)),t("label")&&(g.label=this.label),t("contextValue")&&(g.contextValue=this.contextValue??null),t("comments")&&(g.comments=this.q.map(c=>A(this,c,this.k))),t("collapsibleState")&&(g.collapseState=d(this.g)),t("canReply")&&(g.canReply=this.canReply),t("state")&&(g.state=n(this.h)),t("isTemplate")&&(g.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,g)}getCommentByUniqueId(t){for(const g of this.k){const c=g[0],u=g[1];if(t===u)return c}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(t=>t.dispose())}}p.a=0,qe([(0,k.debounce)(100)],p.prototype,"eventuallyUpdateCommentThread",null);class w{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(t){this.b=t,s.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(t){this.c=t,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this.d}set options(t){this.d=t,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(t,g,c,u){this.f=t,this.g=g,this.h=c,this.i=u,this.a=new Map,s.$registerCommentController(this.handle,c,u);const l=this;this.value=Object.freeze({id:l.id,label:l.label,get options(){return l.options},set options(C){l.options=C},get commentingRangeProvider(){return l.commentingRangeProvider},set commentingRangeProvider(C){l.commentingRangeProvider=C},get reactionHandler(){return l.reactionHandler},set reactionHandler(C){l.reactionHandler=C},createCommentThread(C,R,V){return l.createCommentThread(C,R,V).value},dispose:()=>{l.dispose()}}),this.e=[],this.e.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(t,g,c,u){if(typeof t=="string"){const l=new p(this.id,this.handle,t,g,c,u,this.f,!1);return this.a.set(l.handle,l),l}else{const l=new p(this.id,this.handle,void 0,t,g,c,this.f,!1);return this.a.set(l.handle,l),l}}$createCommentThreadTemplate(t,g){const c=new p(this.id,this.handle,void 0,S.URI.revive(t),T.Range.to(g),[],this.f,!0);return c.collapsibleState=O.CommentThreadCollapsibleState.Expanded,this.a.set(c.handle,c),c}$updateCommentThreadTemplate(t,g){const c=this.a.get(t);c&&(c.range=T.Range.to(g))}$deleteCommentThread(t){this.a.get(t)?.dispose(),this.a.delete(t)}getCommentThread(t){return this.a.get(t)}dispose(){this.a.forEach(t=>{t.dispose()}),this.e.forEach(t=>t.dispose())}}function A(a,t,g){let c=g.get(t);c||(c=++a.commentHandle,g.set(t,c));const u=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:c,body:typeof t.body=="string"?t.body:T.MarkdownString.from(t.body),userName:t.author.name,userIconPath:u,label:t.label,commentReactions:t.reactions?t.reactions.map(l=>v(l)):void 0,timestamp:t.timestamp?.toJSON()}}function v(a){return{label:a.label,iconPath:a.iconPath?T.pathOrURIToURI(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted}}function i(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?S.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1}}function d(a){if(a!==void 0)switch(a){case N.CommentThreadCollapsibleState.Expanded:return O.CommentThreadCollapsibleState.Expanded;case N.CommentThreadCollapsibleState.Collapsed:return O.CommentThreadCollapsibleState.Collapsed}return O.CommentThreadCollapsibleState.Collapsed}function n(a){if(a!==void 0)switch(a){case N.CommentThreadState.Unresolved:return O.CommentThreadState.Unresolved;case N.CommentThreadState.Resolved:return O.CommentThreadState.Resolved}return O.CommentThreadState.Unresolved}return new h}e.createExtHostComments=f}),define(Ce[208],ke([1,0,22,5,26,17]),function(ie,e,r,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let S=class{constructor(N,E){this.a=N.getProxy(k.MainContext.MainThreadConsole),this.b=E.consoleForward.includeStack,this.c=E.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(N,E){const f=this,b=console[N];Object.defineProperty(console,N,{set:()=>{},get:()=>function(){f.e(N,E,b,arguments)}})}e(N,E,f,b){this.a.$logExtensionHostMessage({type:"__$console",severity:E,arguments:y(b,this.b)}),this.c&&this.f(N,f,b)}};S=qe([je(0,M.IExtHostRpcService),je(1,D.IExtHostInitDataService)],S),e.AbstractExtHostConsoleForwarder=S;const O=1e5;function y(T,N){const E=[];if(T.length)for(let f=0;f<T.length;f++){let b=T[f];if(typeof b>"u")b="undefined";else if(b instanceof Error){const m=b;m.stack?b=m.stack:b=m.toString()}E.push(b)}if(N){const f=new Error().stack;f&&E.push({__$stack:f.split(`
`).slice(3).join(`
`)})}try{const f=(0,r.safeStringify)(E);return f.length>O?"Output omitted for a large object that exceeds the limits":f}catch(f){return`Output omitted for an object that cannot be inspected ('${f.toString()}')`}}}),define(Ce[103],ke([1,0,2,5,7,3,17,11,18,10,19,27]),function(ie,e,r,k,D,M,S,O,y,T,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let f=class Mi{constructor(m,o){this.h=o,this.f=new Map,this.g=m.getProxy(k.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,o){const s=Mi.c++;this.f.set(s,{provider:m,extensionDescription:o}),this.g.$registerDecorationProvider(s,o.identifier.value);const h=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(p=>{if(!p){this.g.$onDidChange(s,null);return}const w=(0,y.asArray)(p);if(w.length<=Mi.d){this.g.$onDidChange(s,w);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,w.length);const A=w.map(d=>({uri:d,rank:(0,T.count)(d.path,"/")})),v=(0,y.groupBy)(A,(d,n)=>d.rank-n.rank||(0,T.compare)(d.uri.path,n.uri.path)),i=[];e:for(const d of v){let n;for(const a of d){const t=(0,N.dirname)(a.uri.path);if(n!==t&&(n=t,i.push(a.uri)>=Mi.d))break e}}this.g.$onDidChange(s,i)});return new D.Disposable(()=>{h?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(m,o,s){if(!this.f.has(m))return Object.create(null);const h=Object.create(null),{provider:p,extensionDescription:w}=this.f.get(m);return await Promise.all(o.map(async A=>{try{const{uri:v,id:i}=A,d=await Promise.resolve(p.provideFileDecoration(r.URI.revive(v),s));if(!d)return;try{D.FileDecoration.validate(d),d.badge&&typeof d.badge!="string"&&(0,E.checkProposedApiEnabled)(w,"codiconDecoration"),h[i]=[d.propagate,d.tooltip,d.badge,d.color]}catch(n){this.h.warn(`INVALID decoration from extension '${w}': ${n}`)}}catch(v){this.h.error(v)}})),h}};f.c=0,f.d=250,f=qe([je(0,S.IExtHostRpcService),je(1,O.ILogService)],f),e.ExtHostDecorations=f,e.IExtHostDecorations=(0,M.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!D:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(ie,r):D?D.value=r:e.set(ie,r),r},Le=this&&this.__classPrivateFieldGet||function(ie,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(ie):k?k.value:e.get(ie)};define(Ce[209],ke([1,0,139,91,2,5,7,8,4,11,28,36]),function(ie,e,r,k,D,M,S,O,y,T,N,E){"use strict";var f,b,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class o{constructor(p,w,A,v,i,d,n){this.d=p,this.e=w,this.f=A,this.g=v,f.set(this,void 0),b.set(this,void 0),m.set(this,void 0),this.c=!1,Je(this,m,new N.ResourceMap(a=>i.getComparisonKey(a)),"f"),Je(this,f,d,"f"),Je(this,b,n,"f")}dispose(){this.c||(Le(this,b,"f").fire([...Le(this,m,"f").keys()]),Le(this,f,"f")?.$clear(this.e),Le(this,m,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(p,w){if(!p){this.clear();return}this.h();let A=[];if(D.URI.isUri(p)){if(!w){this.delete(p);return}Le(this,m,"f").set(p,w.slice()),A=[p]}else if(Array.isArray(p)){A=[];let i;p=[...p].sort(o.j);for(const d of p){const[n,a]=d;if((!i||n.toString()!==i.toString())&&(i&&Le(this,m,"f").get(i).length===0&&Le(this,m,"f").delete(i),i=n,A.push(n),Le(this,m,"f").set(n,[])),a)Le(this,m,"f").get(n)?.push(...a);else{const t=Le(this,m,"f").get(n);t&&(t.length=0)}}}if(Le(this,b,"f").fire(A),!Le(this,f,"f"))return;const v=[];for(const i of A){let d=[];const n=Le(this,m,"f").get(i);if(n)if(n.length>this.f){d=[];const a=[S.DiagnosticSeverity.Error,S.DiagnosticSeverity.Warning,S.DiagnosticSeverity.Information,S.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(const g of n)if(g.severity===a[t]&&d.push({...O.Diagnostic.from(g),modelVersionId:this.g(i)})===this.f)break e;d.push({severity:k.MarkerSeverity.Info,message:(0,r.localize)(0,null,n.length-this.f),startLineNumber:d[d.length-1].startLineNumber,startColumn:d[d.length-1].startColumn,endLineNumber:d[d.length-1].endLineNumber,endColumn:d[d.length-1].endColumn})}else d=n.map(a=>({...O.Diagnostic.from(a),modelVersionId:this.g(i)}));v.push([i,d])}Le(this,f,"f").$changeMany(this.e,v)}delete(p){this.h(),Le(this,b,"f").fire([p]),Le(this,m,"f").delete(p),Le(this,f,"f")?.$changeMany(this.e,[[p,void 0]])}clear(){this.h(),Le(this,b,"f").fire([...Le(this,m,"f").keys()]),Le(this,m,"f").clear(),Le(this,f,"f")?.$clear(this.e)}forEach(p,w){this.h();for(const[A,v]of this)p.call(w,A,v,this)}*[(f=new WeakMap,b=new WeakMap,m=new WeakMap,Symbol.iterator)](){this.h();for(const p of Le(this,m,"f").keys())yield[p,this.get(p)]}get(p){this.h();const w=Le(this,m,"f").get(p);return Array.isArray(w)?Object.freeze(w.slice(0)):[]}has(p){return this.h(),Array.isArray(Le(this,m,"f").get(p))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(p,w){return p[0].toString()<w[0].toString()?-1:p[0].toString()>w[0].toString()?1:0}}e.DiagnosticCollection=o;let s=class pi{static _mapper(p){const w=new N.ResourceMap;for(const A of p)w.set(A,A);return{uris:Object.freeze(Array.from(w.values()))}}constructor(p,w,A,v){this.h=w,this.j=A,this.k=v,this.f=new Map,this.g=new y.DebounceEmitter({merge:i=>i.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this.g.event,pi._mapper),this.e=p.getProxy(M.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(p,w){const{f:A,e:v,g:i,h:d,j:n,k:a}=this,t=new class{$changeMany(u,l){v.$changeMany(u,l),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",p.value,u,l.length===0?"CLEARING":l)}$clear(u){v.$clear(u),d.trace("[DiagnosticCollection] remove all (extension, owner)",p.value,u)}dispose(){v.dispose()}};let g;if(!w)w="_generated_diagnostic_collection_name_#"+pi.c++,g=w;else if(!A.has(w))g=w;else{this.h.warn(`DiagnosticCollection with name '${w}' does already exist.`);do g=w+pi.c++;while(A.has(g))}return new class extends o{constructor(){super(w,g,pi.d,u=>a.getDocument(u)?.version,n.extUri,t,i),A.set(g,this)}dispose(){super.dispose(),A.delete(g)}}}getDiagnostics(p){if(p)return this.l(p);{const w=new Map,A=[];for(const v of this.f.values())v.forEach((i,d)=>{let n=w.get(i.toString());typeof n>"u"&&(n=A.length,w.set(i.toString(),n),A.push([i,[]])),A[n][1]=A[n][1].concat(...d)});return A}}l(p){let w=[];for(const A of this.f.values())A.has(p)&&(w=w.concat(A.get(p)));return w}$acceptMarkersChange(p){if(!this.m){const w="_generated_mirror",A=new o(w,w,pi.d,v=>{},this.j.extUri,void 0,this.g);this.f.set(w,A),this.m=A}for(const[w,A]of p)this.m.set(D.URI.revive(w),A.map(O.Diagnostic.to))}};s.c=0,s.d=1e3,s=qe([je(1,T.ILogService),je(2,E.IExtHostFileSystemInfo)],s),e.ExtHostDiagnostics=s}),define(Ce[210],ke([1,0,2,5]),function(ie,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class D{constructor(S){this.a=S.getProxy(k.MainContext.MainThreadDialogs)}showOpenDialog(S){return this.a.$showOpenDialog(S).then(O=>O?O.map(y=>r.URI.revive(y)):void 0)}showSaveDialog(S){return this.a.$showSaveDialog(S).then(O=>O?r.URI.revive(O):void 0)}}e.ExtHostDialogs=D}),define(Ce[211],ke([1,0,12,2,7,5,15,21,10]),function(ie,e,r,k,D,M,S,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class T{constructor(E,f,b){this.d=f,this.e=b,this.b=new Map,this.c=E.getProxy(M.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(E,f){if(Object.keys(S.Schemas).indexOf(E)>=0)throw new Error(`scheme '${E}' already registered`);const b=T.a++;this.b.set(b,f),this.c.$registerTextContentProvider(b,E);let m;return typeof f.onDidChange=="function"&&(m=f.onDidChange(o=>{if(o.scheme!==E){this.e.warn(`Provider for scheme '${E}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}this.d.getDocument(o)&&this.$provideTextDocumentContent(b,o).then(s=>{if(!s&&typeof s!="string")return;const h=this.d.getDocument(o);if(!h)return;const p=(0,y.splitLines)(s);if(!h.equalLines(p))return this.c.$onVirtualDocumentChange(o,s)},r.onUnexpectedError)})),new D.Disposable(()=>{this.b.delete(b)&&this.c.$unregisterTextContentProvider(b),m&&(m.dispose(),m=void 0)})}$provideTextDocumentContent(E,f){const b=this.b.get(E);return b?Promise.resolve(b.provideTextDocumentContent(k.URI.revive(f),O.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${f.scheme}`))}}e.ExtHostDocumentContentProvider=T,T.a=0}),define(Ce[212],ke([1,0,4,6,2,5,99,8,9,22,7]),function(ie,e,r,k,D,M,S,O,y,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class E{constructor(b,m){this.a=new r.Emitter,this.b=new r.Emitter,this.c=new r.Emitter,this.d=new r.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new k.DisposableStore,this.h=new Map,this.f=b.getProxy(M.MainContext.MainThreadDocuments),this.g=m,this.g.onDidRemoveDocuments(o=>{for(const s of o)this.b.fire(s.document)},void 0,this.e),this.g.onDidAddDocuments(o=>{for(const s of o)this.a.fire(s.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(b){if(!b)return;const m=this.g.getDocument(b);if(m)return m}getDocument(b){const m=this.getDocumentData(b);if(!m?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return m.document}ensureDocumentData(b){const m=this.g.getDocument(b);if(m)return Promise.resolve(m);let o=this.h.get(b.toString());return o||(o=this.f.$tryOpenDocument(b).then(s=>{this.h.delete(b.toString());const h=D.URI.revive(s);return(0,y.assertIsDefined)(this.g.getDocument(h))},s=>(this.h.delete(b.toString()),Promise.reject(s))),this.h.set(b.toString(),o)),o}createDocumentData(b){return this.f.$tryCreateDocument(b).then(m=>D.URI.revive(m))}$acceptModelLanguageChanged(b,m){const o=D.URI.revive(b),s=this.g.getDocument(o);if(!s)throw new Error("unknown document");this.b.fire(s.document),s._acceptLanguageId(m),this.a.fire(s.document)}$acceptModelSaved(b){const m=D.URI.revive(b),o=this.g.getDocument(m);if(!o)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this.d.fire(o.document)}$acceptDirtyStateChanged(b,m){const o=D.URI.revive(b),s=this.g.getDocument(o);if(!s)throw new Error("unknown document");s._acceptIsDirty(m),this.c.fire({document:s.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,m,o){const s=D.URI.revive(b),h=this.g.getDocument(s);if(!h)throw new Error("unknown document");h._acceptIsDirty(o),h.onEvents(m);let p;m.isUndoing?p=N.TextDocumentChangeReason.Undo:m.isRedoing&&(p=N.TextDocumentChangeReason.Redo),this.c.fire((0,T.deepFreeze)({document:h.document,contentChanges:m.changes.map(w=>({range:O.Range.to(w.range),rangeOffset:w.rangeOffset,rangeLength:w.rangeLength,text:w.text})),reason:p}))}setWordDefinitionFor(b,m){(0,S.setWordDefinitionFor)(b,m)}}e.ExtHostDocuments=E}),define(Ce[57],ke([1,0,48,4,6,2,3,5,99,17,102,8,11,28,15,184,85]),function(ie,e,r,k,D,M,S,O,y,T,N,E,f,b,m,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class h{constructor(A){this.value=A,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let p=class{constructor(A,v){this.h=A,this.i=v,this.a=null,this.b=new Map,this.c=new b.ResourceMap,this.d=new k.Emitter,this.e=new k.Emitter,this.f=new k.Emitter,this.g=new k.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(A){this.acceptDocumentsAndEditorsDelta(A)}acceptDocumentsAndEditorsDelta(A){const v=[],i=[],d=[];if(A.removedDocuments)for(const n of A.removedDocuments){const a=M.URI.revive(n),t=this.c.get(a);t?.unref()&&(this.c.delete(a),v.push(t.value))}if(A.addedDocuments)for(const n of A.addedDocuments){const a=M.URI.revive(n.uri);let t=this.c.get(a);if(t&&a.scheme!==m.Schemas.vscodeNotebookCell&&a.scheme!==m.Schemas.vscodeInteractiveInput)throw new Error(`document '${a} already exists!'`);t||(t=new h(new y.ExtHostDocumentData(this.h.getProxy(O.MainContext.MainThreadDocuments),a,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this.c.set(a,t),i.push(t.value)),t.ref()}if(A.removedEditors)for(const n of A.removedEditors){const a=this.b.get(n);this.b.delete(n),a&&d.push(a)}if(A.addedEditors)for(const n of A.addedEditors){const a=M.URI.revive(n.documentUri);r.ok(this.c.has(a),`document '${a}' does not exist`),r.ok(!this.b.has(n.id),`editor '${n.id}' already exists!`);const t=this.c.get(a).value,g=new N.ExtHostTextEditor(n.id,this.h.getProxy(O.MainContext.MainThreadTextEditors),this.i,new s.Lazy(()=>t.document),n.selections.map(E.Selection.to),n.options,n.visibleRanges.map(c=>E.Range.to(c)),typeof n.editorPosition=="number"?E.ViewColumn.to(n.editorPosition):void 0);this.b.set(n.id,g)}A.newActiveEditor!==void 0&&(r.ok(A.newActiveEditor===null||this.b.has(A.newActiveEditor),`active editor '${A.newActiveEditor}' does not exist`),this.a=A.newActiveEditor),(0,D.dispose)(v),(0,D.dispose)(d),A.removedDocuments&&this.e.fire(v),A.addedDocuments&&this.d.fire(i),(A.removedEditors||A.addedEditors)&&this.f.fire(this.allEditors().map(n=>n.value)),A.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(A){return this.c.get(A)?.value}allDocuments(){return o.Iterable.map(this.c.values(),A=>A.value)}getEditor(A){return this.b.get(A)}activeEditor(A){if(!this.a)return;const v=this.b.get(this.a);return A?v:v?.value}allEditors(){return[...this.b.values()]}};p=qe([je(0,T.IExtHostRpcService),je(1,f.ILogService)],p),e.ExtHostDocumentsAndEditors=p,e.IExtHostDocumentsAndEditors=(0,S.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ce[58],ke([1,0,8,5,2,4,3,7,17,9,62]),function(ie,e,r,k,D,M,S,O,y,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,S.createDecorator)("IExtHostEditorTabs");class E{constructor(s,h,p){this.e=p,this.d=h,this.acceptDtoUpdate(s)}get apiObject(){if(!this.a){const s=this,h={get isActive(){return s.b.id===s.e()},get label(){return s.b.label},get input(){return s.c},get isDirty(){return s.b.isDirty},get isPinned(){return s.b.isPinned},get isPreview(){return s.b.isPreview},get group(){return s.d.apiObject}};this.a=Object.freeze(h)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(s){this.b=s,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new O.TextTabInput(D.URI.revive(this.b.input.uri));case 2:return new O.TextDiffTabInput(D.URI.revive(this.b.input.original),D.URI.revive(this.b.input.modified));case 3:return new O.TextMergeTabInput(D.URI.revive(this.b.input.base),D.URI.revive(this.b.input.input1),D.URI.revive(this.b.input.input2),D.URI.revive(this.b.input.result));case 6:return new O.CustomEditorTabInput(D.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new O.WebviewEditorTabInput(this.b.input.viewType);case 4:return new O.NotebookEditorTabInput(D.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new O.NotebookDiffEditorTabInput(D.URI.revive(this.b.input.original),D.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new O.TerminalEditorTabInput;case 9:return new O.InteractiveWindowInput(D.URI.revive(this.b.input.uri),D.URI.revive(this.b.input.inputBoxUri));default:return}}}class f{constructor(s,h){this.c=[],this.d="",this.b=s,this.e=h;for(const p of s.tabs)p.isActive&&(this.d=p.id),this.c.push(new E(p,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const s=this,h={get isActive(){return s.b.groupId===s.e()},get viewColumn(){return r.ViewColumn.to(s.b.viewColumn)},get activeTab(){return s.c.find(p=>p.tabId===s.d)?.apiObject},get tabs(){return Object.freeze(s.c.map(p=>p.apiObject))}};this.a=Object.freeze(h)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(s){this.b=s}acceptTabOperation(s){if(s.kind===0){const p=new E(s.tabDto,this,()=>this.activeTabId());return this.c.splice(s.index,0,p),s.tabDto.isActive&&(this.d=p.tabId),p}else if(s.kind===1){const p=this.c.splice(s.index,1)[0];if(!p)throw new Error(`Tab close updated received for index ${s.index} which does not exist`);return p.tabId===this.d&&(this.d=""),p}else if(s.kind===3){if(s.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const p=this.c.splice(s.oldIndex,1)[0];if(!p)throw new Error(`Tab move updated received for index ${s.oldIndex} which does not exist`);return this.c.splice(s.index,0,p),p}const h=this.c.find(p=>p.tabId===s.tabDto.id);if(!h)throw new Error("INVALID tab");return s.tabDto.isActive?this.d=s.tabDto.id:this.d===s.tabDto.id&&!s.tabDto.isActive&&(this.d=""),h.acceptDtoUpdate(s.tabDto),h}activeTabId(){return this.d}}let b=class{constructor(s){this.b=new M.Emitter,this.c=new M.Emitter,this.e=[],this.a=s.getProxy(k.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const s=this,h={onDidChangeTabGroups:s.c.event,onDidChangeTabs:s.b.event,get all(){return Object.freeze(s.e.map(p=>p.apiObject))},get activeTabGroup(){const p=s.d;return(0,T.assertIsDefined)(s.e.find(A=>A.groupId===p)?.apiObject)},close:async(p,w)=>{const A=Array.isArray(p)?p:[p];return A.length?m(A[0])?this.j(A,w):this.i(A,w):!0}};this.f=Object.freeze(h)}return this.f}$acceptEditorTabModel(s){const h=new Set(this.e.map(n=>n.groupId)),p=new Set(s.map(n=>n.groupId)),w=(0,N.diffSets)(h,p),A=this.e.filter(n=>w.removed.includes(n.groupId)).map(n=>n.apiObject),v=[],i=[];this.e=s.map(n=>{const a=new f(n,()=>this.d);return w.added.includes(a.groupId)?v.push(a.apiObject):i.push(a.apiObject),a});const d=(0,T.assertIsDefined)(s.find(n=>n.isActive===!0)?.groupId);d!==void 0&&this.d!==d&&(this.d=d),this.c.fire(Object.freeze({opened:v,closed:A,changed:i}))}$acceptTabGroupUpdate(s){const h=this.e.find(p=>p.groupId===s.groupId);if(!h)throw new Error("Update Group IPC call received before group creation.");h.acceptGroupDtoUpdate(s),s.isActive&&(this.d=s.groupId),this.c.fire(Object.freeze({changed:[h.apiObject],opened:[],closed:[]}))}$acceptTabOperation(s){const h=this.e.find(w=>w.groupId===s.groupId);if(!h)throw new Error("Update Tabs IPC call received before group creation.");const p=h.acceptTabOperation(s);switch(s.kind){case 0:this.b.fire(Object.freeze({opened:[p.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[p.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[p.apiObject]}));return}}g(s){for(const h of this.e)for(const p of h.tabs)if(p.apiObject===s)return p}h(s){return this.e.find(h=>h.apiObject===s)}async i(s,h){const p=[];for(const w of s){const A=this.g(w);if(!A)throw new Error("Tab close: Invalid tab not found!");p.push(A.tabId)}return this.a.$closeTab(p,h)}async j(s,h){const p=[];for(const w of s){const A=this.h(w);if(!A)throw new Error("Group close: Invalid group not found!");p.push(A.groupId)}return this.a.$closeGroup(p,h)}};b=qe([je(0,y.IExtHostRpcService)],b),e.ExtHostEditorTabs=b;function m(o){return o.tabs!==void 0}}),define(Ce[213],ke([1,0,2,5,6,7,8,259,10,23,27]),function(ie,e,r,k,D,M,S,O,y,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class E{constructor(){this.a=[]}add(m){this.b=void 0,this.a.push(m)}delete(m){const o=this.a.indexOf(m);o>=0&&(this.a.splice(o,1),this.b=void 0)}c(){if(!this.b){const m=this.a.sort(),o=[];let s,h,p=14,w=14;for(const A of m){let v=s?(0,y.commonPrefixLength)(s,A):0;for(v===0?h=1:h=w;v<A.length;v++)v+1===A.length?(p=w,w=9):w+=1,o.push([h,A.toUpperCase().charCodeAt(v),w]),o.push([h,A.toLowerCase().charCodeAt(v),w]),h=w;s=A,w=p}o.push([9,58,10]),o.push([10,47,12]),this.b=new O.StateMachine(o)}}provideDocumentLinks(m){this.c();const o=[],s=O.LinkComputer.computeLinks({getLineContent(h){return m.lineAt(h-1).text},getLineCount(){return m.lineCount}},this.b);for(const h of s){const p=S.DocumentLink.to(h);p.target&&o.push(p)}return o}}class f{constructor(m,o){this.i=o,this.b=new E,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=m.getProxy(k.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(m,o,s,h={}){if(this.d.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(m,"*",this.b));const p=this.h++;this.b.add(o),this.d.add(o),this.c.set(p,s);let w=2;h.isCaseSensitive&&(w+=1024),h.isReadonly&&(w+=2048),typeof s.copy=="function"&&(w+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,N.checkProposedApiEnabled)(m,"fsChunks"),w+=4),this.a.$registerFileSystemProvider(p,o,w).catch(v=>{console.error(`FAILED to register filesystem provider of ${m.identifier.value}-extension for the scheme ${o}`),console.error(v)});const A=s.onDidChangeFile(v=>{const i=[];for(const d of v){const{uri:n,type:a}=d;if(n.scheme!==o)continue;let t;switch(a){case M.FileChangeType.Changed:t=0;break;case M.FileChangeType.Created:t=1;break;case M.FileChangeType.Deleted:t=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:n,type:t})}this.a.$onFileSystemChange(p,i)});return(0,D.toDisposable)(()=>{A.dispose(),this.b.delete(o),this.d.delete(o),this.c.delete(p),this.a.$unregisterProvider(p)})}static j(m){const{type:o,ctime:s,mtime:h,size:p,permissions:w}=m;return{type:o,ctime:s,mtime:h,size:p,permissions:w}}$stat(m,o){return Promise.resolve(this.k(m).stat(r.URI.revive(o))).then(s=>f.j(s))}$readdir(m,o){return Promise.resolve(this.k(m).readDirectory(r.URI.revive(o)))}$readFile(m,o){return Promise.resolve(this.k(m).readFile(r.URI.revive(o))).then(s=>T.VSBuffer.wrap(s))}$writeFile(m,o,s,h){return Promise.resolve(this.k(m).writeFile(r.URI.revive(o),s.buffer,h))}$delete(m,o,s){return Promise.resolve(this.k(m).delete(r.URI.revive(o),s))}$rename(m,o,s,h){return Promise.resolve(this.k(m).rename(r.URI.revive(o),r.URI.revive(s),h))}$copy(m,o,s,h){const p=this.k(m);if(!p.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(p.copy(r.URI.revive(o),r.URI.revive(s),h))}$mkdir(m,o){return Promise.resolve(this.k(m).createDirectory(r.URI.revive(o)))}$watch(m,o,s,h){const p=this.k(m).watch(r.URI.revive(s),h);this.f.set(o,p)}$unwatch(m,o){const s=this.f.get(o);s&&(s.dispose(),this.f.delete(o))}$open(m,o,s){const h=this.k(m);if(!h.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(h.open(r.URI.revive(o),s))}$close(m,o){const s=this.k(m);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(o))}$read(m,o,s,h){const p=this.k(m);if(!p.read)throw new Error('FileSystemProvider does not implement "read"');const w=T.VSBuffer.alloc(h);return Promise.resolve(p.read(o,s,w.buffer,0,h)).then(A=>w.slice(0,A))}$write(m,o,s,h){const p=this.k(m);if(!p.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(p.write(o,s,h.buffer,0,h.byteLength))}k(m){const o=this.c.get(m);if(!o){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return o}}e.ExtHostFileSystem=f}),define(Ce[59],ke([1,0,5,43,7,23,3,17,36,6]),function(ie,e,r,k,D,M,S,O,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let N=class Yt{constructor(f,b){this.b=new Map,this.a=f.getProxy(r.MainContext.MainThreadFileSystem);const m=this;this.value=Object.freeze({async stat(o){try{const s=m.b.get(o.scheme);if(!s)return await m.a.$stat(o);await m.a.$ensureActivation(o.scheme);const h=await s.stat(o);return{type:h.type,ctime:h.ctime,mtime:h.mtime,size:h.size,permissions:h.permissions}}catch(s){Yt.c(s)}},async readDirectory(o){try{const s=m.b.get(o.scheme);return s?(await m.a.$ensureActivation(o.scheme),(await s.readDirectory(o)).slice()):await m.a.$readdir(o)}catch(s){return Yt.c(s)}},async createDirectory(o){try{return await m.a.$mkdir(o)}catch(s){return Yt.c(s)}},async readFile(o){try{const s=m.b.get(o.scheme);return s?(await m.a.$ensureActivation(o.scheme),(await s.readFile(o)).slice()):(await m.a.$readFile(o)).buffer}catch(s){return Yt.c(s)}},async writeFile(o,s){try{return await m.a.$writeFile(o,M.VSBuffer.wrap(s))}catch(h){return Yt.c(h)}},async delete(o,s){try{const h=m.b.get(o.scheme);return h?(await m.a.$ensureActivation(o.scheme),await h.delete(o,{recursive:!1,...s})):await m.a.$delete(o,{recursive:!1,useTrash:!1,...s})}catch(h){return Yt.c(h)}},async rename(o,s,h){try{return await m.a.$rename(o,s,{overwrite:!1,...h})}catch(p){return Yt.c(p)}},async copy(o,s,h){try{return await m.a.$copy(o,s,{overwrite:!1,...h})}catch(p){return Yt.c(p)}},isWritableFileSystem(o){const s=b.getCapabilities(o);if(typeof s=="number")return!(s&2048)}})}static c(f){if(f instanceof D.FileSystemError)throw f;if(!(f instanceof Error))throw new D.FileSystemError(String(f));if(f.name==="ENOPRO"||f.message.includes("ENOPRO"))throw D.FileSystemError.Unavailable(f.message);switch(f.name){case k.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(f.message);case k.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(f.message);case k.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(f.message);case k.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(f.message);case k.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(f.message);case k.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(f.message);default:throw new D.FileSystemError(f.message,f.name)}}addFileSystemProvider(f,b){return this.b.set(f,b),(0,T.toDisposable)(()=>this.b.delete(f))}};N=qe([je(0,O.IExtHostRpcService),je(1,y.IExtHostFileSystemInfo)],N),e.ExtHostConsumerFileSystem=N,e.IExtHostConsumerFileSystem=(0,S.createDecorator)("IExtHostConsumerFileSystem")}),define(Ce[214],ke([1,0,4,35,2,5,8,7]),function(ie,e,r,k,D,M,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(E,f,b,m,o,s,h,p){this.a=new r.Emitter,this.b=new r.Emitter,this.c=new r.Emitter;const w=this.h(E,b,o);this.g=0,s&&(this.g+=1),h&&(this.g+=2),p&&(this.g+=4);const A=(0,k.parse)(o),v=typeof o=="string",i=m(d=>{if(!s)for(const n of d.created){const a=D.URI.revive(n);A(a.fsPath)&&(!v||f.getWorkspaceFolder(a))&&this.a.fire(a)}if(!h)for(const n of d.changed){const a=D.URI.revive(n);A(a.fsPath)&&(!v||f.getWorkspaceFolder(a))&&this.b.fire(a)}if(!p)for(const n of d.deleted){const a=D.URI.revive(n);A(a.fsPath)&&(!v||f.getWorkspaceFolder(a))&&this.c.fire(a)}});this.d=O.Disposable.from(w,this.a,this.b,this.c,i)}h(E,f,b){const m=O.Disposable.from();if(typeof b=="string")return m;const o=E.getProxy(M.MainContext.MainThreadFileSystem);let s=!1;(b.pattern.includes(k.GLOBSTAR)||b.pattern.includes(k.GLOB_SPLIT))&&(s=!0);const h=Math.random();return o.$watch(f.identifier.value,h,b.baseUri,{recursive:s,excludes:[]}),O.Disposable.from({dispose:()=>o.$unwatch(h)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class T{constructor(E,f,b){this.j=E,this.k=f,this.l=b,this.a=new r.Emitter,this.b=new r.Emitter,this.c=new r.Emitter,this.d=new r.Emitter,this.g=new r.AsyncEmitter,this.h=new r.AsyncEmitter,this.i=new r.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(E,f,b,m,o,s){return new y(this.j,E,f,this.a.event,S.GlobPattern.from(b),m,o,s)}$onFileEvent(E){this.a.fire(E)}$onDidRunFileOperation(E,f){switch(E){case 2:this.b.fire(Object.freeze({files:f.map(b=>({oldUri:D.URI.revive(b.source),newUri:D.URI.revive(b.target)}))}));break;case 1:this.d.fire(Object.freeze({files:f.map(b=>D.URI.revive(b.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:f.map(b=>D.URI.revive(b.target))}));break;default:}}getOnWillRenameFileEvent(E){return this.m(E,this.g)}getOnWillCreateFileEvent(E){return this.m(E,this.h)}getOnWillDeleteFileEvent(E){return this.m(E,this.i)}m(E,f){return(b,m,o)=>{const s=function(p){b.call(m,p)};return s.extension=E,f.event(s,void 0,o)}}async $onWillRunFileOperation(E,f,b,m){switch(E){case 2:return await this.n(this.g,{files:f.map(o=>({oldUri:D.URI.revive(o.source),newUri:D.URI.revive(o.target)}))},b,m);case 1:return await this.n(this.i,{files:f.map(o=>D.URI.revive(o.target))},b,m);case 0:case 3:return await this.n(this.h,{files:f.map(o=>D.URI.revive(o.target))},b,m)}}async n(E,f,b,m){const o=new Set,s=[];if(await E.fireAsync(f,m,async(p,w)=>{const A=Date.now(),v=await Promise.resolve(p);v instanceof O.WorkspaceEdit&&(s.push([w.extension,v]),o.add(w.extension.displayName??w.extension.identifier.value)),Date.now()-A>b&&this.k.warn("SLOW file-participant",w.extension.identifier)}),m.isCancellationRequested||s.length===0)return;const h={edits:[]};for(const[,p]of s){const{edits:w}=S.WorkspaceEdit.from(p,{getTextDocumentVersion:A=>this.l.getDocument(A)?.version,getNotebookDocumentVersion:()=>{}});h.edits=h.edits.concat(w)}return{edit:h,extensionNames:Array.from(o)}}}e.ExtHostFileSystemEventService=T}),define(Ce[215],ke([1,0,2,37]),function(ie,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class D{constructor(S,O,y,T,N){this.a=O,this.b=y,this.c=T;const E=new k.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new k.ApiCommandArgument("showOptions","Show Options",f=>!0,f=>f),new k.ApiCommandArgument("resource","Interactive resource Uri",f=>!0,f=>f),new k.ApiCommandArgument("controllerId","Notebook controller Id",f=>!0,f=>f),new k.ApiCommandArgument("title","Interactive editor title",f=>!0,f=>f)],new k.ApiCommandResult("Notebook and input URI",f=>{if(N.debug("[ExtHostInteractive] open iw with notebook editor id",f.notebookEditorId),f.notebookEditorId!==void 0){const b=this.a.getEditorById(f.notebookEditorId);return N.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:r.URI.revive(f.notebookUri),inputUri:r.URI.revive(f.inputUri),notebookEditor:b.apiEditor}}return N.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",f.notebookUri,f.inputUri),{notebookUri:r.URI.revive(f.notebookUri),inputUri:r.URI.revive(f.inputUri)}}));this.c.registerApiCommand(E)}$willAddInteractiveDocument(S,O,y,T){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:O,lines:[""],languageId:y,uri:S,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(r.URI.revive(T))?.apiNotebook}]})}$willRemoveInteractiveDocument(S,O){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[S]})}}e.ExtHostInteractive=D}),define(Ce[216],ke([1,0,6,5]),function(ie,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(S){this.b=0,this.a=S.getProxy(k.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(S){const O=this.b++;return this.a.$registerResourceLabelFormatter(O,S),(0,r.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(O)})}}e.ExtHostLabelService=D}),define(Ce[217],ke([1,0,2,22,8,7,75,5,10,56,18,9,260,21,6,88,83,53,77,12,16,27]),function(ie,e,r,k,D,M,S,O,y,T,N,E,f,b,m,o,s,h,p,w,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class i{constructor(I,$){this.d=I,this.e=$}async provideDocumentSymbols(I,$){const W=this.d.getDocument(I),q=await this.e.provideDocumentSymbols(W,$);if(!(0,N.isFalsyOrEmpty)(q))return q[0]instanceof M.DocumentSymbol?q.map(D.DocumentSymbol.from):i.f(q)}static f(I){I=I.slice(0).sort((q,te)=>{let fe=q.location.range.start.compareTo(te.location.range.start);return fe===0&&(fe=te.location.range.end.compareTo(q.location.range.end)),fe});const $=[],W=[];for(const q of I){const te={name:q.name||"!!MISSING: name!!",kind:D.SymbolKind.from(q.kind),tags:q.tags?.map(D.SymbolTag.from)||[],detail:"",containerName:q.containerName,range:D.Range.from(q.location.range),selectionRange:D.Range.from(q.location.range),children:[]};for(;;){if(W.length===0){W.push(te),$.push(te);break}const fe=W[W.length-1];if(T.Range.containsRange(fe.range,te.range)&&!T.Range.equalsRange(fe.range,te.range)){fe.children?.push(te),W.push(te);break}W.pop()}}return $}}class d{constructor(I,$,W){this.g=I,this.h=$,this.j=W,this.e=new h.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(I,$){const W=this.g.getDocument(I),q=await this.j.provideCodeLenses(W,$);if(!q||$.isCancellationRequested)return;const te=this.e.add(q),fe=new m.DisposableStore;this.f.set(te,fe);const ye={cacheId:te,lenses:[]};for(let ae=0;ae<q.length;ae++)ye.lenses.push({cacheId:[te,ae],range:D.Range.from(q[ae].range),command:this.h.toInternal(q[ae].command,fe)});return ye}async resolveCodeLens(I,$){const W=I.cacheId&&this.e.get(...I.cacheId);if(!W)return;let q;if(typeof this.j.resolveCodeLens!="function"||W.isResolved?q=W:q=await this.j.resolveCodeLens(W,$),q||(q=W),$.isCancellationRequested)return;const te=I.cacheId&&this.f.get(I.cacheId[0]);if(!!te)return I.command=this.h.toInternal(q.command??d.d,te),I}releaseCodeLenses(I){this.f.get(I)?.dispose(),this.f.delete(I),this.e.delete(I)}}d.d={command:"missing",title:"!!MISSING: command!!"};function n(Y){return Array.isArray(Y)?Y.map(D.DefinitionLink.from):Y?[D.DefinitionLink.from(Y)]:[]}class a{constructor(I,$){this.d=I,this.e=$}async provideDefinition(I,$,W){const q=this.d.getDocument(I),te=D.Position.to($),fe=await this.e.provideDefinition(q,te,W);return n(fe)}}class t{constructor(I,$){this.d=I,this.e=$}async provideDeclaration(I,$,W){const q=this.d.getDocument(I),te=D.Position.to($),fe=await this.e.provideDeclaration(q,te,W);return n(fe)}}class g{constructor(I,$){this.d=I,this.e=$}async provideImplementation(I,$,W){const q=this.d.getDocument(I),te=D.Position.to($),fe=await this.e.provideImplementation(q,te,W);return n(fe)}}class c{constructor(I,$){this.d=I,this.e=$}async provideTypeDefinition(I,$,W){const q=this.d.getDocument(I),te=D.Position.to($),fe=await this.e.provideTypeDefinition(q,te,W);return n(fe)}}class u{constructor(I,$){this.d=I,this.e=$}async provideHover(I,$,W){const q=this.d.getDocument(I),te=D.Position.to($),fe=await this.e.provideHover(q,te,W);if(!(!fe||(0,N.isFalsyOrEmpty)(fe.contents)))return fe.range||(fe.range=q.getWordRangeAtPosition(te)),fe.range||(fe.range=new M.Range(te,te)),D.Hover.from(fe)}}class l{constructor(I,$){this.d=I,this.e=$}async provideEvaluatableExpression(I,$,W){const q=this.d.getDocument(I),te=D.Position.to($),fe=await this.e.provideEvaluatableExpression(q,te,W);if(fe)return D.EvaluatableExpression.from(fe)}}class C{constructor(I,$){this.d=I,this.e=$}async provideInlineValues(I,$,W,q){const te=this.d.getDocument(I),fe=await this.e.provideInlineValues(te,D.Range.to($),D.InlineValueContext.to(W),q);if(Array.isArray(fe))return fe.map(ye=>D.InlineValue.from(ye))}}class R{constructor(I,$){this.d=I,this.e=$}async provideDocumentHighlights(I,$,W){const q=this.d.getDocument(I),te=D.Position.to($),fe=await this.e.provideDocumentHighlights(q,te,W);if(Array.isArray(fe))return fe.map(D.DocumentHighlight.from)}}class V{constructor(I,$){this.d=I,this.e=$}async provideLinkedEditingRanges(I,$,W){const q=this.d.getDocument(I),te=D.Position.to($),fe=await this.e.provideLinkedEditingRanges(q,te,W);if(fe&&Array.isArray(fe.ranges))return{ranges:(0,N.coalesce)(fe.ranges.map(D.Range.from)),wordPattern:fe.wordPattern}}}class ee{constructor(I,$){this.d=I,this.e=$}async provideReferences(I,$,W,q){const te=this.d.getDocument(I),fe=D.Position.to($),ye=await this.e.provideReferences(te,fe,W,q);if(Array.isArray(ye))return ye.map(D.location.from)}}class K{constructor(I,$,W,q,te,fe,ye){this.g=I,this.h=$,this.j=W,this.k=q,this.l=te,this.m=fe,this.n=ye,this.e=new h.Cache("CodeAction"),this.f=new Map}async provideCodeActions(I,$,W,q){const te=this.g.getDocument(I),fe=f.Selection.isISelection($)?D.Selection.to($):D.Range.to($),ye=[];for(const tt of this.j.getDiagnostics(I))if(fe.intersection(tt.range)&&ye.push(tt)>K.d)break;const ae={diagnostics:ye,only:W.only?new M.CodeActionKind(W.only):void 0,triggerKind:D.CodeActionTriggerKind.to(W.trigger)},ve=await this.k.provideCodeActions(te,fe,ae,q);if(!(0,N.isNonEmptyArray)(ve)||q.isCancellationRequested)return;const Ee=this.e.add(ve),We=new m.DisposableStore;this.f.set(Ee,We);const He=[];for(let tt=0;tt<ve.length;tt++){const Xe=ve[tt];!Xe||(K.o(Xe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),He.push({_isSynthetic:!0,title:Xe.title,command:this.h.toInternal(Xe,We)})):(ae.only&&(Xe.kind?ae.only.contains(Xe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ae.only.value} 'requested but returned code action is of kind '${Xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ae.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),He.push({cacheId:[Ee,tt],title:Xe.title,command:Xe.command&&this.h.toInternal(Xe.command,We),diagnostics:Xe.diagnostics&&Xe.diagnostics.map(D.Diagnostic.from),edit:Xe.edit&&D.WorkspaceEdit.from(Xe.edit,void 0),kind:Xe.kind&&Xe.kind.value,isPreferred:Xe.isPreferred,disabled:Xe.disabled?.reason})))}return{cacheId:Ee,actions:He}}async resolveCodeAction(I,$){const[W,q]=I,te=this.e.get(W,q);if(!te||K.o(te)||!this.k.resolveCodeAction)return;const fe=await this.k.resolveCodeAction(te,$)??te;return fe?.edit?D.WorkspaceEdit.from(fe.edit,void 0):void 0}releaseCodeActions(I){this.f.get(I)?.dispose(),this.f.delete(I),this.e.delete(I)}static o(I){return typeof I.command=="string"&&typeof I.title=="string"}}K.d=1e3;class L{constructor(I,$,W,q){this.d=I,this.e=$,this.f=W,this.g=q}async prepareDocumentPaste(I,$,W,q){if(!this.f.prepareDocumentPaste)return;const te=this.e.getDocument(I),fe=$.map(ae=>D.Range.to(ae)),ye=D.DataTransfer.toDataTransfer(W,()=>{throw new w.NotImplementedError});return await this.f.prepareDocumentPaste(te,fe,ye,q),D.DataTransfer.toDataTransferDTO(ye)}async providePasteEdits(I,$,W,q,te){const fe=this.e.getDocument($),ye=W.map(Ee=>D.Range.to(Ee)),ae=D.DataTransfer.toDataTransfer(q,async Ee=>(await this.d.$resolvePasteFileData(this.g,I,Ee)).buffer),ve=await this.f.provideDocumentPasteEdits(fe,ye,ae,te);if(!!ve)return{insertText:typeof ve.insertText=="string"?ve.insertText:{snippet:ve.insertText.value},additionalEdit:ve.additionalEdit?D.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}}class B{constructor(I,$){this.d=I,this.e=$}async provideDocumentFormattingEdits(I,$,W){const q=this.d.getDocument(I),te=await this.e.provideDocumentFormattingEdits(q,$,W);if(Array.isArray(te))return te.map(D.TextEdit.from)}}class P{constructor(I,$){this.d=I,this.e=$}async provideDocumentRangeFormattingEdits(I,$,W,q){const te=this.d.getDocument(I),fe=D.Range.to($),ye=await this.e.provideDocumentRangeFormattingEdits(te,fe,W,q);if(Array.isArray(ye))return ye.map(D.TextEdit.from)}}class F{constructor(I,$){this.d=I,this.e=$,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(I,$,W,q,te){const fe=this.d.getDocument(I),ye=D.Position.to($),ae=await this.e.provideOnTypeFormattingEdits(fe,ye,W,q,te);if(Array.isArray(ae))return ae.map(D.TextEdit.from)}}class H{constructor(I,$){this.e=I,this.f=$,this.d=new h.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(I,$){const W=await this.e.provideWorkspaceSymbols(I,$);if(!(0,N.isNonEmptyArray)(W))return{symbols:[]};const q=this.d.add(W),te={cacheId:q,symbols:[]};for(let fe=0;fe<W.length;fe++){const ye=W[fe];if(!ye||!ye.name){this.f.warn("INVALID SymbolInformation",ye);continue}te.symbols.push({...D.WorkspaceSymbol.from(ye),cacheId:[q,fe]})}return te}async resolveWorkspaceSymbol(I,$){if(typeof this.e.resolveWorkspaceSymbol!="function"||!I.cacheId)return I;const W=this.d.get(...I.cacheId);if(W){const q=await this.e.resolveWorkspaceSymbol(W,$);return q&&(0,k.mixin)(I,D.WorkspaceSymbol.from(q),!0)}}releaseWorkspaceSymbols(I){this.d.delete(I)}}class j{static supportsResolving(I){return typeof I.prepareRename=="function"}constructor(I,$,W){this.d=I,this.e=$,this.f=W}async provideRenameEdits(I,$,W,q){const te=this.d.getDocument(I),fe=D.Position.to($);try{const ye=await this.e.provideRenameEdits(te,fe,W,q);return ye?D.WorkspaceEdit.from(ye):void 0}catch(ye){const ae=j.g(ye);return ae?{rejectReason:ae,edits:void 0}:Promise.reject(ye)}}async resolveRenameLocation(I,$,W){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const q=this.d.getDocument(I),te=D.Position.to($);try{const fe=await this.e.prepareRename(q,te,W);let ye,ae;if(M.Range.isRange(fe)?(ye=fe,ae=q.getText(fe)):(0,E.isObject)(fe)&&(ye=fe.range,ae=fe.placeholder),!ye||!ae)return;if(ye.start.line>te.line||ye.end.line<te.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from(ye),text:ae}}catch(fe){const ye=j.g(fe);return ye?{rejectReason:ye,range:void 0,text:void 0}:Promise.reject(fe)}}static g(I){return typeof I=="string"?I:I instanceof Error&&typeof I.message=="string"?I.message:void 0}}class le{constructor(I,$){this.resultId=I,this.tokens=$}}class _{constructor(I,$){this.f=I,this.g=$,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(I,$,W){const q=this.f.getDocument(I),te=$!==0?this.d.get($):null;let fe=typeof te?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(q,te.resultId,W):await this.g.provideDocumentSemanticTokens(q,W);return te&&this.d.delete($),fe?(fe=_.h(fe),this.o(_.n(te,fe),fe)):null}async releaseDocumentSemanticColoring(I){this.d.delete(I)}static h(I){return _.j(I)?_.k(I)?I:new M.SemanticTokens(new Uint32Array(I.data),I.resultId):_.l(I)?_.m(I)?I:new M.SemanticTokensEdits(I.edits.map($=>new M.SemanticTokensEdit($.start,$.deleteCount,$.data?new Uint32Array($.data):$.data)),I.resultId):I}static j(I){return I&&!!I.data}static k(I){return I.data instanceof Uint32Array}static l(I){return I&&Array.isArray(I.edits)}static m(I){for(const $ of I.edits)if(!($.data instanceof Uint32Array))return!1;return!0}static n(I,$){if(!_.j($)||!I||!I.tokens)return $;const W=I.tokens,q=W.length,te=$.data,fe=te.length;let ye=0;const ae=Math.min(q,fe);for(;ye<ae&&W[ye]===te[ye];)ye++;if(ye===q&&ye===fe)return new M.SemanticTokensEdits([],$.resultId);let ve=0;const Ee=ae-ye;for(;ve<Ee&&W[q-ve-1]===te[fe-ve-1];)ve++;return new M.SemanticTokensEdits([{start:ye,deleteCount:q-ye-ve,data:te.subarray(ye,fe-ve)}],$.resultId)}o(I,$){if(_.j(I)){const W=this.e++;return this.d.set(W,new le(I.resultId,I.data)),(0,o.encodeSemanticTokensDto)({id:W,type:"full",data:I.data})}if(_.l(I)){const W=this.e++;return _.j($)?this.d.set(W,new le($.resultId,$.data)):this.d.set(W,new le(I.resultId)),(0,o.encodeSemanticTokensDto)({id:W,type:"delta",deltas:(I.edits||[]).map(q=>({start:q.start,deleteCount:q.deleteCount,data:q.data}))})}return null}}class be{constructor(I,$){this.d=I,this.e=$}async provideDocumentRangeSemanticTokens(I,$,W){const q=this.d.getDocument(I),te=await this.e.provideDocumentRangeSemanticTokens(q,D.Range.to($),W);return te?this.f(te):null}f(I){return(0,o.encodeSemanticTokensDto)({id:0,type:"full",data:I.data})}}class de{static supportsResolving(I){return typeof I.resolveCompletionItem=="function"}constructor(I,$,W,q,te){this.f=I,this.g=$,this.h=W,this.j=q,this.k=te,this.d=new h.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(I,$,W,q){const te=this.f.getDocument(I),fe=D.Position.to($),ye=te.getWordRangeAtPosition(fe)||new M.Range(fe,fe),ae=ye.with({end:fe}),ve=new p.StopWatch(!0),Ee=await this.h.provideCompletionItems(te,fe,q,D.CompletionContext.to(W));if(!Ee||q.isCancellationRequested)return;const We=Array.isArray(Ee)?new M.CompletionList(Ee):Ee,He=de.supportsResolving(this.h)?this.d.add(We.items):this.d.add([]),tt=new m.DisposableStore;this.e.set(He,tt);const Xe=[],et={x:He,b:Xe,a:{replace:D.Range.from(ye),insert:D.Range.from(ae)},c:We.isIncomplete||void 0,d:ve.elapsed()};for(let it=0;it<We.items.length;it++){const dt=We.items[it],Fe=this.l(dt,[He,it],ae,ye);Xe.push(Fe)}return et}async resolveCompletionItem(I,$){if(typeof this.h.resolveCompletionItem!="function")return;const W=this.d.get(...I);if(!W)return;const q=await this.h.resolveCompletionItem(W,$);if(!!q)return this.l(q,I)}releaseCompletionItems(I){this.e.get(I)?.dispose(),this.e.delete(I),this.d.delete(I)}l(I,$,W,q){const te=this.e.get($[0]);if(!te)throw Error("DisposableStore is missing...");const fe=this.g.toInternal(I.command,te),ye={x:$,a:I.label,b:I.kind!==void 0?D.CompletionItemKind.from(I.kind):void 0,m:I.tags&&I.tags.map(D.CompletionItemTag.from),c:I.detail,d:typeof I.documentation>"u"?void 0:D.MarkdownString.fromStrict(I.documentation),e:I.sortText!==I.label?I.sortText:void 0,f:I.filterText!==I.label?I.filterText:void 0,g:I.preselect||void 0,i:I.keepWhitespace?1:0,k:I.commitCharacters?.join(""),l:I.additionalTextEdits&&I.additionalTextEdits.map(D.TextEdit.from),n:fe?.$ident,o:fe?.id,p:fe?.$ident?void 0:fe?.arguments};I.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ye.h=I.textEdit.newText):typeof I.insertText=="string"?ye.h=I.insertText:I.insertText instanceof M.SnippetString&&(ye.h=I.insertText.value,ye.i|=4);let ae;return I.textEdit?ae=I.textEdit.range:I.range&&(ae=I.range),M.Range.isRange(ae)?ye.j=D.Range.from(ae):ae&&(!W?.isEqual(ae.inserting)||!q?.isEqual(ae.replacing))&&(ye.j={insert:D.Range.from(ae.inserting),replace:D.Range.from(ae.replacing)}),ye}}class ue{async provideInlineCompletions(I,$,W,q){}disposeCompletions(I){}handleDidShowCompletionItem(I,$){}}class se extends ue{constructor(I,$,W,q){super(),this.f=I,this.g=$,this.h=W,this.j=q,this.d=new J,this.e=(0,v.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[S.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[S.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,v.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&typeof this.h.handleDidShowCompletionItem=="function"}async provideInlineCompletions(I,$,W,q){const te=this.g.getDocument(I),fe=D.Position.to($),ye=await this.h.provideInlineCompletionItems(te,fe,{selectedCompletionInfo:W.selectedSuggestionInfo?{range:D.Range.to(W.selectedSuggestionInfo.range),text:W.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[W.triggerKind]},q);if(!ye||q.isCancellationRequested)return;const ae=Array.isArray(ye)?ye:ye.items,ve=this.e?Array.isArray(ye)?[]:ye.commands||[]:[];let Ee;return{pid:this.d.createReferenceId({dispose(){Ee?.dispose()},items:ae}),items:ae.map((He,tt)=>{let Xe;He.command&&(Ee||(Ee=new m.DisposableStore),Xe=this.j.toInternal(He.command,Ee));const et=He.insertText;return{insertText:typeof et=="string"?et:{snippet:et.value},filterText:He.filterText,range:He.range?D.Range.from(He.range):void 0,command:Xe,idx:tt,completeBracketPairs:this.e?He.completeBracketPairs:!1}}),commands:ve.map(He=>(Ee||(Ee=new m.DisposableStore),this.j.toInternal(He,Ee)))}}disposeCompletions(I){this.d.disposeReferenceId(I)?.dispose()}handleDidShowCompletionItem(I,$){const W=this.d.get(I)?.items[$];W&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(W)}}class J{constructor(){this.d=new Map,this.e=1}createReferenceId(I){const $=this.e++;return this.d.set($,I),$}disposeReferenceId(I){const $=this.d.get(I);return this.d.delete(I),$}get(I){return this.d.get(I)}}class X{constructor(I,$){this.e=I,this.f=$,this.d=new h.Cache("SignatureHelp")}async provideSignatureHelp(I,$,W,q){const te=this.e.getDocument(I),fe=D.Position.to($),ye=this.g(W),ae=await this.f.provideSignatureHelp(te,fe,q,ye);if(ae){const ve=this.d.add([ae]);return{...D.SignatureHelp.from(ae),id:ve}}}g(I){let $;if(I.activeSignatureHelp){const W=D.SignatureHelp.to(I.activeSignatureHelp),q=this.d.get(I.activeSignatureHelp.id,0);q?($=q,$.activeSignature=W.activeSignature,$.activeParameter=W.activeParameter):$=W}return{...I,activeSignatureHelp:$}}releaseSignatureHelp(I){this.d.delete(I)}}class Z{constructor(I,$,W,q,te){this.f=I,this.g=$,this.h=W,this.j=q,this.k=te,this.d=new h.Cache("InlayHints"),this.e=new Map}async provideInlayHints(I,$,W){const q=this.f.getDocument(I),te=D.Range.to($),fe=await this.h.provideInlayHints(q,te,W);if(!Array.isArray(fe)||fe.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${$}`);return}if(W.isCancellationRequested)return;const ye=this.d.add(fe);this.e.set(ye,new m.DisposableStore);const ae={hints:[],cacheId:ye};for(let ve=0;ve<fe.length;ve++)this.l(fe[ve],te)&&ae.hints.push(this.m(fe[ve],[ye,ve]));return this.j.trace(`[InlayHints] ${ae.hints.length} inlay hints from '${this.k.identifier.value}' for ${$}`),ae}async resolveInlayHint(I,$){if(typeof this.h.resolveInlayHint!="function")return;const W=this.d.get(...I);if(!W)return;const q=await this.h.resolveInlayHint(W,$);if(!!q&&!!this.l(q))return this.m(q,I)}releaseHints(I){this.e.get(I)?.dispose(),this.e.delete(I),this.d.delete(I)}l(I,$){return I.label.length===0||Array.isArray(I.label)&&I.label.every(W=>W.value.length===0)?(console.log("INVALID inlay hint, empty label",I),!1):!($&&!$.contains(I.position))}m(I,$){const W=this.e.get($[0]);if(!W)throw Error("DisposableStore is missing...");const q={label:"",cacheId:$,tooltip:D.MarkdownString.fromStrict(I.tooltip),position:D.Position.from(I.position),textEdits:I.textEdits&&I.textEdits.map(D.TextEdit.from),kind:I.kind&&D.InlayHintKind.from(I.kind),paddingLeft:I.paddingLeft,paddingRight:I.paddingRight};return typeof I.label=="string"?q.label=I.label:q.label=I.label.map(te=>{const fe={label:te.value};return fe.tooltip=D.MarkdownString.fromStrict(te.tooltip),M.Location.isLocation(te.location)&&(fe.location=D.location.from(te.location)),te.command&&(fe.command=this.g.toInternal(te.command,W)),fe}),q}}class he{constructor(I,$){this.e=I,this.f=$,this.d=new h.Cache("DocumentLink")}async provideLinks(I,$){const W=this.e.getDocument(I),q=await this.f.provideDocumentLinks(W,$);if(!(!Array.isArray(q)||q.length===0)&&!$.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:q.filter(he.g).map(D.DocumentLink.from)};{const te=this.d.add(q),fe={links:[],cacheId:te};for(let ye=0;ye<q.length;ye++){if(!he.g(q[ye]))continue;const ae=D.DocumentLink.from(q[ye]);ae.cacheId=[te,ye],fe.links.push(ae)}return fe}}}static g(I){return I.target&&I.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(I,$){if(typeof this.f.resolveDocumentLink!="function")return;const W=this.d.get(...I);if(!W)return;const q=await this.f.resolveDocumentLink(W,$);if(!(!q||!he.g(q)))return D.DocumentLink.from(q)}releaseLinks(I){this.d.delete(I)}}class Te{constructor(I,$){this.d=I,this.e=$}async provideColors(I,$){const W=this.d.getDocument(I),q=await this.e.provideDocumentColors(W,$);return Array.isArray(q)?q.map(fe=>({color:D.Color.from(fe.color),range:D.Range.from(fe.range)})):[]}async provideColorPresentations(I,$,W){const q=this.d.getDocument(I),te=D.Range.to($.range),fe=D.Color.to($.color),ye=await this.e.provideColorPresentations(fe,{document:q,range:te},W);if(!!Array.isArray(ye))return ye.map(D.ColorPresentation.from)}}class Ne{constructor(I,$){this.d=I,this.e=$}async provideFoldingRanges(I,$,W){const q=this.d.getDocument(I),te=await this.e.provideFoldingRanges(q,$,W);if(!!Array.isArray(te))return te.map(D.FoldingRange.from)}}class Ke{constructor(I,$,W){this.d=I,this.e=$,this.f=W}async provideSelectionRanges(I,$,W){const q=this.d.getDocument(I),te=$.map(D.Position.to),fe=await this.e.provideSelectionRanges(q,te,W);if(!(0,N.isNonEmptyArray)(fe))return[];if(fe.length!==te.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ye=[];for(let ae=0;ae<te.length;ae++){const ve=[];ye.push(ve);let Ee=te[ae],We=fe[ae];for(;;){if(!We.range.contains(Ee))throw new Error("INVALID selection range, must contain the previous range");if(ve.push(D.SelectionRange.from(We)),!We.parent)break;Ee=We.range,We=We.parent}}return ye}}class Pe{constructor(I,$){this.f=I,this.g=$,this.d=new s.IdGenerator(""),this.e=new Map}async prepareSession(I,$,W){const q=this.f.getDocument(I),te=D.Position.to($),fe=await this.g.prepareCallHierarchy(q,te,W);if(!fe)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(fe)?fe.map(ae=>this.h(ye,ae)):[this.h(ye,fe)]}async provideCallsTo(I,$,W){const q=this.j(I,$);if(!q)throw new Error("missing call hierarchy item");const te=await this.g.provideCallHierarchyIncomingCalls(q,W);if(!!te)return te.map(fe=>({from:this.h(I,fe.from),fromRanges:fe.fromRanges.map(ye=>D.Range.from(ye))}))}async provideCallsFrom(I,$,W){const q=this.j(I,$);if(!q)throw new Error("missing call hierarchy item");const te=await this.g.provideCallHierarchyOutgoingCalls(q,W);if(!!te)return te.map(fe=>({to:this.h(I,fe.to),fromRanges:fe.fromRanges.map(ye=>D.Range.from(ye))}))}releaseSession(I){this.e.delete(I)}h(I,$){const W=this.e.get(I),q=D.CallHierarchyItem.from($,I,W.size.toString(36));return W.set(q._itemId,$),q}j(I,$){return this.e.get(I)?.get($)}}class Se{constructor(I,$){this.f=I,this.g=$,this.d=new s.IdGenerator(""),this.e=new Map}async prepareSession(I,$,W){const q=this.f.getDocument(I),te=D.Position.to($),fe=await this.g.prepareTypeHierarchy(q,te,W);if(!fe)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(fe)?fe.map(ae=>this.h(ye,ae)):[this.h(ye,fe)]}async provideSupertypes(I,$,W){const q=this.j(I,$);if(!q)throw new Error("missing type hierarchy item");const te=await this.g.provideTypeHierarchySupertypes(q,W);if(!!te)return te.map(fe=>this.h(I,fe))}async provideSubtypes(I,$,W){const q=this.j(I,$);if(!q)throw new Error("missing type hierarchy item");const te=await this.g.provideTypeHierarchySubtypes(q,W);if(!!te)return te.map(fe=>this.h(I,fe))}releaseSession(I){this.e.delete(I)}h(I,$){const W=this.e.get(I),q=D.TypeHierarchyItem.from($,I,W.size.toString(36));return W.set(q._itemId,$),q}j(I,$){return this.e.get(I)?.get($)}}class Ie{constructor(I,$,W,q){this.d=I,this.e=$,this.f=W,this.g=q}async provideDocumentOnDropEdits(I,$,W,q,te){const fe=this.e.getDocument($),ye=D.Position.to(W),ae=D.DataTransfer.toDataTransfer(q,async Ee=>(await this.d.$resolveDocumentOnDropFileData(this.g,I,Ee)).buffer),ve=await this.f.provideDocumentDropEdits(fe,ye,ae,te);if(!!ve)return{insertText:typeof ve.insertText=="string"?ve.insertText:{snippet:ve.insertText.value},additionalEdit:ve.additionalEdit?D.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}}class oe{constructor(I,$){this.adapter=I,this.extension=$}}class ce{constructor(I,$,W,q,te,fe,ye,ae){this.g=$,this.h=W,this.j=q,this.k=te,this.l=fe,this.m=ye,this.n=ae,this.f=new Map,this.e=I.getProxy(O.MainContext.MainThreadLanguageFeatures)}o(I){return D.DocumentSelector.from(I,this.g)}p(I){return new M.Disposable(()=>{this.f.delete(I),this.e.$unregister(I)})}q(){return ce.d++}async s(I,$,W,q,te,fe=!1){const ye=this.f.get(I);if(!ye||!(ye.adapter instanceof $))return q;const ae=Date.now();fe||this.l.trace(`[${ye.extension.identifier.value}] INVOKE provider '${W.toString().replace(/[\r\n]/g,"")}'`);const ve=W(ye.adapter,ye.extension);return Promise.resolve(ve).catch(Ee=>{(0,w.isCancellationError)(Ee)||(this.l.error(`[${ye.extension.identifier.value}] provider FAILED`),this.l.error(Ee),this.n.onExtensionError(ye.extension.identifier,Ee))}).finally(()=>{fe||this.l.trace(`[${ye.extension.identifier.value}] provider DONE after ${Date.now()-ae}ms`)}),b.CancellationToken.isCancellationToken(te)?(0,A.raceCancellationError)(ve,te):ve}t(I,$){const W=this.q();return this.f.set(W,new oe(I,$)),W}static u(I){return I.displayName||I.name}registerDocumentSymbolProvider(I,$,W,q){const te=this.t(new i(this.h,W),I),fe=q&&q.label||ce.u(I);return this.e.$registerDocumentSymbolProvider(te,this.o($),fe),this.p(te)}$provideDocumentSymbols(I,$,W){return this.s(I,i,q=>q.provideDocumentSymbols(r.URI.revive($),W),void 0,W)}registerCodeLensProvider(I,$,W){const q=this.q(),te=typeof W.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(q,new oe(new d(this.h,this.j.converter,W),I)),this.e.$registerCodeLensSupport(q,this.o($),te);let fe=this.p(q);if(te!==void 0){const ye=W.onDidChangeCodeLenses(ae=>this.e.$emitCodeLensEvent(te));fe=M.Disposable.from(fe,ye)}return fe}$provideCodeLenses(I,$,W){return this.s(I,d,q=>q.provideCodeLenses(r.URI.revive($),W),void 0,W)}$resolveCodeLens(I,$,W){return this.s(I,d,q=>q.resolveCodeLens($,W),void 0,void 0)}$releaseCodeLenses(I,$){this.s(I,d,W=>Promise.resolve(W.releaseCodeLenses($)),void 0,void 0)}registerDefinitionProvider(I,$,W){const q=this.t(new a(this.h,W),I);return this.e.$registerDefinitionSupport(q,this.o($)),this.p(q)}$provideDefinition(I,$,W,q){return this.s(I,a,te=>te.provideDefinition(r.URI.revive($),W,q),[],q)}registerDeclarationProvider(I,$,W){const q=this.t(new t(this.h,W),I);return this.e.$registerDeclarationSupport(q,this.o($)),this.p(q)}$provideDeclaration(I,$,W,q){return this.s(I,t,te=>te.provideDeclaration(r.URI.revive($),W,q),[],q)}registerImplementationProvider(I,$,W){const q=this.t(new g(this.h,W),I);return this.e.$registerImplementationSupport(q,this.o($)),this.p(q)}$provideImplementation(I,$,W,q){return this.s(I,g,te=>te.provideImplementation(r.URI.revive($),W,q),[],q)}registerTypeDefinitionProvider(I,$,W){const q=this.t(new c(this.h,W),I);return this.e.$registerTypeDefinitionSupport(q,this.o($)),this.p(q)}$provideTypeDefinition(I,$,W,q){return this.s(I,c,te=>te.provideTypeDefinition(r.URI.revive($),W,q),[],q)}registerHoverProvider(I,$,W,q){const te=this.t(new u(this.h,W),I);return this.e.$registerHoverProvider(te,this.o($)),this.p(te)}$provideHover(I,$,W,q){return this.s(I,u,te=>te.provideHover(r.URI.revive($),W,q),void 0,q)}registerEvaluatableExpressionProvider(I,$,W,q){const te=this.t(new l(this.h,W),I);return this.e.$registerEvaluatableExpressionProvider(te,this.o($)),this.p(te)}$provideEvaluatableExpression(I,$,W,q){return this.s(I,l,te=>te.provideEvaluatableExpression(r.URI.revive($),W,q),void 0,q)}registerInlineValuesProvider(I,$,W,q){const te=typeof W.onDidChangeInlineValues=="function"?this.q():void 0,fe=this.t(new C(this.h,W),I);this.e.$registerInlineValuesProvider(fe,this.o($),te);let ye=this.p(fe);if(te!==void 0){const ae=W.onDidChangeInlineValues(ve=>this.e.$emitInlineValuesEvent(te));ye=M.Disposable.from(ye,ae)}return ye}$provideInlineValues(I,$,W,q,te){return this.s(I,C,fe=>fe.provideInlineValues(r.URI.revive($),W,q,te),void 0,te)}registerDocumentHighlightProvider(I,$,W){const q=this.t(new R(this.h,W),I);return this.e.$registerDocumentHighlightProvider(q,this.o($)),this.p(q)}$provideDocumentHighlights(I,$,W,q){return this.s(I,R,te=>te.provideDocumentHighlights(r.URI.revive($),W,q),void 0,q)}registerLinkedEditingRangeProvider(I,$,W){const q=this.t(new V(this.h,W),I);return this.e.$registerLinkedEditingRangeProvider(q,this.o($)),this.p(q)}$provideLinkedEditingRanges(I,$,W,q){return this.s(I,V,async te=>{const fe=await te.provideLinkedEditingRanges(r.URI.revive($),W,q);if(fe)return{ranges:fe.ranges,wordPattern:fe.wordPattern?ce.w(fe.wordPattern):void 0}},void 0,q)}registerReferenceProvider(I,$,W){const q=this.t(new ee(this.h,W),I);return this.e.$registerReferenceSupport(q,this.o($)),this.p(q)}$provideReferences(I,$,W,q,te){return this.s(I,ee,fe=>fe.provideReferences(r.URI.revive($),W,q,te),void 0,te)}registerCodeActionProvider(I,$,W,q){const te=new m.DisposableStore,fe=this.t(new K(this.h,this.j.converter,this.k,W,this.l,I,this.m),I);return this.e.$registerQuickFixSupport(fe,this.o($),{providedKinds:q?.providedCodeActionKinds?.map(ye=>ye.value),documentation:q?.documentation?.map(ye=>({kind:ye.kind.value,command:this.j.converter.toInternal(ye.command,te)}))},ce.u(I),Boolean(W.resolveCodeAction)),te.add(this.p(fe)),te}$provideCodeActions(I,$,W,q,te){return this.s(I,K,fe=>fe.provideCodeActions(r.URI.revive($),W,q,te),void 0,te)}$resolveCodeAction(I,$,W){return this.s(I,K,q=>q.resolveCodeAction($,W),void 0,void 0)}$releaseCodeActions(I,$){this.s(I,K,W=>Promise.resolve(W.releaseCodeActions($)),void 0,void 0)}registerDocumentFormattingEditProvider(I,$,W){const q=this.t(new B(this.h,W),I);return this.e.$registerDocumentFormattingSupport(q,this.o($),I.identifier,I.displayName||I.name),this.p(q)}$provideDocumentFormattingEdits(I,$,W,q){return this.s(I,B,te=>te.provideDocumentFormattingEdits(r.URI.revive($),W,q),void 0,q)}registerDocumentRangeFormattingEditProvider(I,$,W){const q=this.t(new P(this.h,W),I);return this.e.$registerRangeFormattingSupport(q,this.o($),I.identifier,I.displayName||I.name),this.p(q)}$provideDocumentRangeFormattingEdits(I,$,W,q,te){return this.s(I,P,fe=>fe.provideDocumentRangeFormattingEdits(r.URI.revive($),W,q,te),void 0,te)}registerOnTypeFormattingEditProvider(I,$,W,q){const te=this.t(new F(this.h,W),I);return this.e.$registerOnTypeFormattingSupport(te,this.o($),q,I.identifier),this.p(te)}$provideOnTypeFormattingEdits(I,$,W,q,te,fe){return this.s(I,F,ye=>ye.provideOnTypeFormattingEdits(r.URI.revive($),W,q,te,fe),void 0,fe)}registerWorkspaceSymbolProvider(I,$){const W=this.t(new H($,this.l),I);return this.e.$registerNavigateTypeSupport(W,typeof $.resolveWorkspaceSymbol=="function"),this.p(W)}$provideWorkspaceSymbols(I,$,W){return this.s(I,H,q=>q.provideWorkspaceSymbols($,W),{symbols:[]},W)}$resolveWorkspaceSymbol(I,$,W){return this.s(I,H,q=>q.resolveWorkspaceSymbol($,W),void 0,void 0)}$releaseWorkspaceSymbols(I,$){this.s(I,H,W=>W.releaseWorkspaceSymbols($),void 0,void 0)}registerRenameProvider(I,$,W){const q=this.t(new j(this.h,W,this.l),I);return this.e.$registerRenameSupport(q,this.o($),j.supportsResolving(W)),this.p(q)}$provideRenameEdits(I,$,W,q,te){return this.s(I,j,fe=>fe.provideRenameEdits(r.URI.revive($),W,q,te),void 0,te)}$resolveRenameLocation(I,$,W,q){return this.s(I,j,te=>te.resolveRenameLocation(r.URI.revive($),W,q),void 0,q)}registerDocumentSemanticTokensProvider(I,$,W,q){const te=this.t(new _(this.h,W),I),fe=typeof W.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(te,this.o($),q,fe);let ye=this.p(te);if(fe){const ae=W.onDidChangeSemanticTokens(ve=>this.e.$emitDocumentSemanticTokensEvent(fe));ye=M.Disposable.from(ye,ae)}return ye}$provideDocumentSemanticTokens(I,$,W,q){return this.s(I,_,te=>te.provideDocumentSemanticTokens(r.URI.revive($),W,q),null,q)}$releaseDocumentSemanticTokens(I,$){this.s(I,_,W=>W.releaseDocumentSemanticColoring($),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(I,$,W,q){const te=this.t(new be(this.h,W),I);return this.e.$registerDocumentRangeSemanticTokensProvider(te,this.o($),q),this.p(te)}$provideDocumentRangeSemanticTokens(I,$,W,q){return this.s(I,be,te=>te.provideDocumentRangeSemanticTokens(r.URI.revive($),W,q),null,q)}registerCompletionItemProvider(I,$,W,q){const te=this.t(new de(this.h,this.j.converter,W,this.m,I),I);return this.e.$registerCompletionsProvider(te,this.o($),q,de.supportsResolving(W),`${I.identifier.value}(${q.join("")})`),this.p(te)}$provideCompletionItems(I,$,W,q,te){return this.s(I,de,fe=>fe.provideCompletionItems(r.URI.revive($),W,q,te),void 0,te)}$resolveCompletionItem(I,$,W){return this.s(I,de,q=>q.resolveCompletionItem($,W),void 0,W)}$releaseCompletionItems(I,$){this.s(I,de,W=>W.releaseCompletionItems($),void 0,void 0)}registerInlineCompletionsProvider(I,$,W){const q=new se(I,this.h,W,this.j.converter),te=this.t(q,I);return this.e.$registerInlineCompletionsSupport(te,this.o($),q.supportsHandleDidShowCompletionItem),this.p(te)}$provideInlineCompletions(I,$,W,q,te){return this.s(I,ue,fe=>fe.provideInlineCompletions(r.URI.revive($),W,q,te),void 0,te)}$handleInlineCompletionDidShow(I,$,W){this.s(I,ue,async q=>{q.handleDidShowCompletionItem($,W)},void 0,void 0)}$freeInlineCompletionsList(I,$){this.s(I,ue,async W=>{W.disposeCompletions($)},void 0,void 0)}registerSignatureHelpProvider(I,$,W,q){const te=Array.isArray(q)?{triggerCharacters:q,retriggerCharacters:[]}:q,fe=this.t(new X(this.h,W),I);return this.e.$registerSignatureHelpProvider(fe,this.o($),te),this.p(fe)}$provideSignatureHelp(I,$,W,q,te){return this.s(I,X,fe=>fe.provideSignatureHelp(r.URI.revive($),W,q,te),void 0,te)}$releaseSignatureHelp(I,$){this.s(I,X,W=>W.releaseSignatureHelp($),void 0,void 0)}registerInlayHintsProvider(I,$,W){const q=typeof W.onDidChangeInlayHints=="function"?this.q():void 0,te=this.t(new Z(this.h,this.j.converter,W,this.l,I),I);this.e.$registerInlayHintsProvider(te,this.o($),typeof W.resolveInlayHint=="function",q,ce.u(I));let fe=this.p(te);if(q!==void 0){const ye=W.onDidChangeInlayHints(ae=>this.e.$emitInlayHintsEvent(q));fe=M.Disposable.from(fe,ye)}return fe}$provideInlayHints(I,$,W,q){return this.s(I,Z,te=>te.provideInlayHints(r.URI.revive($),W,q),void 0,q)}$resolveInlayHint(I,$,W){return this.s(I,Z,q=>q.resolveInlayHint($,W),void 0,W)}$releaseInlayHints(I,$){this.s(I,Z,W=>W.releaseHints($),void 0,void 0)}registerDocumentLinkProvider(I,$,W){const q=this.t(new he(this.h,W),I);return this.e.$registerDocumentLinkProvider(q,this.o($),typeof W.resolveDocumentLink=="function"),this.p(q)}$provideDocumentLinks(I,$,W){return this.s(I,he,q=>q.provideLinks(r.URI.revive($),W),void 0,W,$.scheme==="output")}$resolveDocumentLink(I,$,W){return this.s(I,he,q=>q.resolveLink($,W),void 0,void 0,!0)}$releaseDocumentLinks(I,$){this.s(I,he,W=>W.releaseLinks($),void 0,void 0,!0)}registerColorProvider(I,$,W){const q=this.t(new Te(this.h,W),I);return this.e.$registerDocumentColorProvider(q,this.o($)),this.p(q)}$provideDocumentColors(I,$,W){return this.s(I,Te,q=>q.provideColors(r.URI.revive($),W),[],W)}$provideColorPresentations(I,$,W,q){return this.s(I,Te,te=>te.provideColorPresentations(r.URI.revive($),W,q),void 0,q)}registerFoldingRangeProvider(I,$,W){const q=this.q(),te=typeof W.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(q,new oe(new Ne(this.h,W),I)),this.e.$registerFoldingRangeProvider(q,this.o($),I.identifier,te);let fe=this.p(q);if(te!==void 0){const ye=W.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(te));fe=M.Disposable.from(fe,ye)}return fe}$provideFoldingRanges(I,$,W,q){return this.s(I,Ne,te=>te.provideFoldingRanges(r.URI.revive($),W,q),void 0,q)}registerSelectionRangeProvider(I,$,W){const q=this.t(new Ke(this.h,W,this.l),I);return this.e.$registerSelectionRangeProvider(q,this.o($)),this.p(q)}$provideSelectionRanges(I,$,W,q){return this.s(I,Ke,te=>te.provideSelectionRanges(r.URI.revive($),W,q),[],q)}registerCallHierarchyProvider(I,$,W){const q=this.t(new Pe(this.h,W),I);return this.e.$registerCallHierarchyProvider(q,this.o($)),this.p(q)}$prepareCallHierarchy(I,$,W,q){return this.s(I,Pe,te=>Promise.resolve(te.prepareSession(r.URI.revive($),W,q)),void 0,q)}$provideCallHierarchyIncomingCalls(I,$,W,q){return this.s(I,Pe,te=>te.provideCallsTo($,W,q),void 0,q)}$provideCallHierarchyOutgoingCalls(I,$,W,q){return this.s(I,Pe,te=>te.provideCallsFrom($,W,q),void 0,q)}$releaseCallHierarchy(I,$){this.s(I,Pe,W=>Promise.resolve(W.releaseSession($)),void 0,void 0)}registerTypeHierarchyProvider(I,$,W){const q=this.t(new Se(this.h,W),I);return this.e.$registerTypeHierarchyProvider(q,this.o($)),this.p(q)}$prepareTypeHierarchy(I,$,W,q){return this.s(I,Se,te=>Promise.resolve(te.prepareSession(r.URI.revive($),W,q)),void 0,q)}$provideTypeHierarchySupertypes(I,$,W,q){return this.s(I,Se,te=>te.provideSupertypes($,W,q),void 0,q)}$provideTypeHierarchySubtypes(I,$,W,q){return this.s(I,Se,te=>te.provideSubtypes($,W,q),void 0,q)}$releaseTypeHierarchy(I,$){this.s(I,Se,W=>Promise.resolve(W.releaseSession($)),void 0,void 0)}registerDocumentOnDropEditProvider(I,$,W){const q=this.q();return this.f.set(q,new oe(new Ie(this.e,this.h,W,q),I)),this.e.$registerDocumentOnDropEditProvider(q,this.o($)),this.p(q)}$provideDocumentOnDropEdits(I,$,W,q,te,fe){return this.s(I,Ie,ye=>Promise.resolve(ye.provideDocumentOnDropEdits($,r.URI.revive(W),q,te,fe)),void 0,void 0)}registerDocumentPasteEditProvider(I,$,W,q){const te=this.q();return this.f.set(te,new oe(new L(this.e,this.h,W,te),I)),this.e.$registerPasteEditProvider(te,this.o($),!!W.prepareDocumentPaste,q.pasteMimeTypes),this.p(te)}$prepareDocumentPaste(I,$,W,q,te){return this.s(I,L,fe=>fe.prepareDocumentPaste(r.URI.revive($),W,q,te),void 0,te)}$providePasteEdits(I,$,W,q,te,fe){return this.s(I,L,ye=>ye.providePasteEdits($,r.URI.revive(W),q,te,fe),void 0,fe)}static w(I){return{pattern:I.source,flags:(0,y.regExpFlags)(I)}}static y(I){return{decreaseIndentPattern:ce.w(I.decreaseIndentPattern),increaseIndentPattern:ce.w(I.increaseIndentPattern),indentNextLinePattern:I.indentNextLinePattern?ce.w(I.indentNextLinePattern):void 0,unIndentedLinePattern:I.unIndentedLinePattern?ce.w(I.unIndentedLinePattern):void 0}}static z(I){return{beforeText:ce.w(I.beforeText),afterText:I.afterText?ce.w(I.afterText):void 0,previousLineText:I.previousLineText?ce.w(I.previousLineText):void 0,action:I.action}}static B(I){return I.map(ce.z)}setLanguageConfiguration(I,$,W){const{wordPattern:q}=W;if(q&&(0,y.regExpLeadsToEndlessLoop)(q))throw new Error(`Invalid language configuration: wordPattern '${q}' is not allowed to match the empty string.`);q?this.h.setWordDefinitionFor($,q):this.h.setWordDefinitionFor($,void 0),W.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",I,"Do not use."),W.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",I,"Do not use.");const te=this.q(),fe={comments:W.comments,brackets:W.brackets,wordPattern:W.wordPattern?ce.w(W.wordPattern):void 0,indentationRules:W.indentationRules?ce.y(W.indentationRules):void 0,onEnterRules:W.onEnterRules?ce.B(W.onEnterRules):void 0,__electricCharacterSupport:W.__electricCharacterSupport,__characterPairSupport:W.__characterPairSupport};return this.e.$setLanguageConfiguration(te,$,fe),this.p(te)}$setWordDefinitions(I){for(const $ of I)this.h.setWordDefinitionFor($.languageId,new RegExp($.regexSource,$.regexFlags))}}e.ExtHostLanguageFeatures=ce,ce.d=0}),define(Ce[218],ke([1,0,5,8,7,29,16,6]),function(ie,e,r,k,D,M,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(N,E,f,b){this.c=E,this.d=f,this.e=b,this.b=[],this.f=0,this.g=new Set,this.a=N.getProxy(r.MainContext.MainThreadLanguages)}$acceptLanguageIds(N){this.b=N}async getLanguages(){return this.b.slice(0)}async changeLanguage(N,E){await this.a.$changeLanguage(N,E);const f=this.c.getDocumentData(N);if(!f)throw new Error(`document '${N.toString()}' NOT found`);return f.document}async tokenAtPosition(N,E){const f=N.version,b=k.Position.from(E),m=await this.a.$tokensAtPosition(N.uri,b),o={type:D.StandardTokenType.Other,range:N.getWordRangeAtPosition(E)??new D.Range(E.line,E.character,E.line,E.character)};if(!m)return o;const s={range:k.Range.to(m.range),type:k.TokenType.to(m.type)};return!s.range.contains(E)||f!==N.version?o:s}createLanguageStatusItem(N,E,f){const b=this.f++,m=this.a,o=this.g,s=`${N.identifier.value}/${E}`;if(o.has(s))throw new Error(`LanguageStatusItem with id '${E}' ALREADY exists`);o.add(s);const h={selector:f,id:E,name:N.displayName??N.name,severity:D.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let p;const w=new O.DisposableStore,A=()=>{p?.dispose(),p=(0,S.disposableTimeout)(()=>{w.clear(),this.a.$setLanguageStatus(b,{id:s,name:h.name??N.displayName??N.name,source:N.displayName??N.name,selector:k.DocumentSelector.from(h.selector,this.e),label:h.text,detail:h.detail??"",severity:h.severity===D.LanguageStatusSeverity.Error?M.default.Error:h.severity===D.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:h.command&&this.d.toInternal(h.command,w),accessibilityInfo:h.accessibilityInformation,busy:h.busy})},0)},v={dispose(){w.dispose(),p?.dispose(),m.$removeLanguageStatus(b),o.delete(s)},get id(){return h.id},get name(){return h.name},set name(i){h.name=i,A()},get selector(){return h.selector},set selector(i){h.selector=i,A()},get text(){return h.text},set text(i){h.text=i,A()},get detail(){return h.detail},set detail(i){h.detail=i,A()},get severity(){return h.severity},set severity(i){h.severity=i,A()},get accessibilityInformation(){return h.accessibilityInformation},set accessibilityInformation(i){h.accessibilityInformation=i,A()},get command(){return h.command},set command(i){h.command=i,A()},get busy(){return h.busy},set busy(i){h.busy=i,A()}};return A(),v}}e.ExtHostLanguages=y}),define(Ce[78],ke([1,0,20,10,2,3,11,5,26,17]),function(ie,e,r,k,D,M,S,O,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let N=class{constructor(f,b,m){this.f=m,this.d=new Map,this.a=b.getProxy(O.MainContext.MainThreadLocalization),this.b=f.environment.appLanguage,this.c=this.b===r.LANGUAGE_DEFAULT}getMessage(f,b){const{message:m,args:o,comment:s}=b;if(this.c)return(0,k.format2)(m,o??{});let h=m;s&&s.length>0&&(h+=`/${Array.isArray(s)?s.join(""):s}`);const p=this.d.get(f)?.contents[h];return p||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${h}`),(0,k.format2)(p??m,o??{})}getBundle(f){return this.d.get(f)?.contents}getBundleUri(f){return this.d.get(f)?.uri}async initializeLocalizedMessages(f){if(this.c||!f.l10n&&!f.isBuiltin||this.d.has(f.identifier.value))return;let b;const m=await this.g(f);if(!m){this.f.error(`No bundle location found for extension ${f.identifier.value}`);return}try{const o=await this.a.$fetchBundleContents(m),s=JSON.parse(o);b=f.isBuiltin?s.contents?.bundle:s}catch(o){this.f.error(`Failed to load translations for ${f.identifier.value} from ${m}: ${o.message}`);return}b&&this.d.set(f.identifier.value,{contents:b,uri:m})}async g(f){if(f.isBuiltin){const b=await this.a.$fetchBuiltInBundleUri(f.identifier.value);return D.URI.revive(b)}return f.l10n?D.URI.joinPath(f.extensionLocation,f.l10n,`bundle.l10n.${this.b}.json`):void 0}};N=qe([je(0,y.IExtHostInitDataService),je(1,T.IExtHostRpcService),je(2,S.ILogService)],N),e.ExtHostLocalizationService=N,e.IExtHostLocalizationService=(0,M.createDecorator)("IExtHostLocalizationService")}),define(Ce[219],ke([1,0,11,5,26,17,2,65]),function(ie,e,r,k,D,M,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let y=class extends r.AbstractLoggerService{constructor(E,f){super(f.logLevel,f.loggers.map(b=>(0,O.revive)(b))),this.l=E.getProxy(k.MainContext.MainThreadLogger)}$setLogLevel(E,f){f?this.setLogLevel(S.URI.revive(f),E):this.setLogLevel(E)}k(E,f,b){return new T(this.l,E,f,b)}};y=qe([je(0,M.IExtHostRpcService),je(1,D.IExtHostInitDataService)],y),e.ExtHostLoggerService=y;class T extends r.AbstractMessageLogger{constructor(E,f,b,m){super(m?.logLevel==="always"),this.m=E,this.n=f,this.k=!1,this.l=[],this.setLevel(b),this.m.$createLogger(f,m).then(()=>{this.r(this.l),this.k=!0})}g(E,f){const b=[[E,f]];this.k?this.r(b):this.l.push(...b)}r(E){this.m.$log(this.n,E)}}}),define(Ce[220],ke([1,0,5,11,27]),function(ie,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function M(O){return O&&O.title}let S=class{constructor(y,T){this.b=T,this.a=y.getProxy(r.MainContext.MainThreadMessageService)}showMessage(y,T,N,E,f){const b={source:{identifier:y.identifier,label:y.displayName||y.name}};let m;typeof E=="string"||M(E)?m=[E,...f]:(b.modal=E?.modal,b.useCustom=E?.useCustom,b.detail=E?.detail,m=f),b.useCustom&&(0,D.checkProposedApiEnabled)(y,"resolvers");const o=[];for(let s=0;s<m.length;s++){const h=m[s];if(typeof h=="string")o.push({title:h,handle:s,isCloseAffordance:!1});else if(typeof h=="object"){const{title:p,isCloseAffordance:w}=h;o.push({title:p,isCloseAffordance:!!w,handle:s})}else this.b.warn("Invalid message item:",h)}return this.a.$showMessage(T,N,b,o).then(s=>{if(typeof s=="number")return m[s]})}};S=qe([je(1,k.ILogService)],S),e.ExtHostMessageService=S}),define(Ce[221],ke([1,0,23,4,6,28,10,9,2,53,5,37,8,7,45,195,100]),function(ie,e,r,k,D,M,S,O,y,T,N,E,f,b,m,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class h{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(w=>w.apiEditor)}constructor(w,A,v,i){this.q=v,this.r=i,this.f=new Map,this.g=new M.ResourceMap,this.h=new Map,this.j=new k.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new k.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new k.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new k.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new T.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=w.getProxy(N.MainContext.MainThreadNotebook),this.c=w.getProxy(N.MainContext.MainThreadNotebookDocuments),this.d=w.getProxy(N.MainContext.MainThreadNotebookEditors),this.i=A.converter,A.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===13){const n=d.notebookEditor?.notebookUri,a=d.cell.handle,g=this.g.get(n)?.getCell(a);if(g)return g.apiCell}if(d&&d.$mid===14){const n=d.uri,a=this.g.get(n);if(a)return a.apiNotebook}return d}}),h.x(A)}getEditorById(w){const A=this.h.get(w);if(!A)throw new Error(`unknown text editor: ${w}. known editors: ${[...this.h.keys()]} `);return A}getIdByEditor(w){for(const[A,v]of this.h)if(v.apiEditor===w)return A}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(w,A){const v=this.g.get(w);if(!v&&!A)throw new Error(`NO notebook document for '${w}'`);return v}static s(w,A){if(!A)return;const v=A.filenamePattern.map(i=>f.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(A.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${A.filenamePattern}`);return}return{extension:w.identifier,providerDisplayName:w.displayName||w.name,displayName:A.displayName,filenamePattern:v,exclusive:A.exclusive||!1}}registerNotebookCellStatusBarItemProvider(w,A,v){const i=h.a++,d=typeof v.onDidChangeCellStatusBarItems=="function"?h.a++:void 0;this.f.set(i,v),this.b.$registerNotebookCellStatusBarItemProvider(i,d,A);let n;return d!==void 0&&(n=v.onDidChangeCellStatusBarItems(a=>this.b.$emitCellStatusBarEvent(d))),new b.Disposable(()=>{this.f.delete(i),this.b.$unregisterNotebookCellStatusBarItemProvider(i,d),n?.dispose()})}async createNotebookDocument(w){const A=await this.c.$tryCreateNotebook({viewType:w.viewType,content:w.content&&f.NotebookData.from(w.content)});return y.URI.revive(A)}async openNotebookDocument(w){const A=this.g.get(w);if(A)return A.apiNotebook;const v=await this.c.$tryOpenNotebook(w),i=this.g.get(y.URI.revive(v));return(0,O.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(w,A){y.URI.isUri(w)&&(w=await this.openNotebookDocument(w));let v;typeof A=="object"?v={position:f.ViewColumn.from(A.viewColumn),preserveFocus:A.preserveFocus,selections:A.selections&&A.selections.map(f.NotebookRange.from),pinned:typeof A.preview=="boolean"?!A.preview:void 0}:v={preserveFocus:!1};const i=await this.d.$tryShowNotebookDocument(w.uri,w.notebookType,v),d=i&&this.h.get(i)?.apiEditor;if(d)return d;throw i?new Error(`Could NOT open editor for "${w.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${w.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(w,A,v,i){const d=this.f.get(w),n=y.URI.revive(A),a=this.g.get(n);if(!a||!d)return;const t=a.getCellFromIndex(v);if(!t)return;const g=await d.provideCellStatusBarItems(t.apiCell,i);if(!g)return;const c=new D.DisposableStore,u=this.p.add([c]),C=(Array.isArray(g)?g:[g]).map(R=>f.NotebookStatusBarItem.from(R,this.i,c));return{cacheId:u,items:C}}$releaseNotebookCellStatusBarItems(w){this.p.delete(w)}registerNotebookSerializer(w,A,v,i,d){if((0,S.isFalsyOrWhitespace)(A))throw new Error("viewType cannot be empty or just whitespace");const n=this.t++;return this.u.set(n,v),this.b.$registerNotebookSerializer(n,{id:w.identifier,location:w.extensionLocation},A,f.NotebookDocumentContentOptions.from(i),h.s(w,d)),(0,D.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(n)})}async $dataToNotebook(w,A,v){const i=this.u.get(w);if(!i)throw new Error("NO serializer found");const d=await i.deserializeNotebook(A.buffer,v);return new m.SerializableObjectWithBuffers(f.NotebookData.from(d))}async $notebookToData(w,A,v){const i=this.u.get(w);if(!i)throw new Error("NO serializer found");const d=await i.serializeNotebook(f.NotebookData.to(A.value),v);return r.VSBuffer.wrap(d)}w(w,A,v){if(this.h.has(A))throw new Error(`editor with id ALREADY EXSIST: ${A}`);const i=new s.ExtHostNotebookEditor(A,this.d,w,v.visibleRanges.map(f.NotebookRange.to),v.selections.map(f.NotebookRange.to),typeof v.viewColumn=="number"?f.ViewColumn.to(v.viewColumn):void 0);this.h.set(A,i)}$acceptDocumentAndEditorsDelta(w){if(w.value.removedDocuments)for(const v of w.value.removedDocuments){const i=y.URI.revive(v),d=this.g.get(i);d&&(d.dispose(),this.g.delete(i),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:d.apiNotebook.getCells().map(n=>n.document.uri)}),this.n.fire(d.apiNotebook));for(const n of this.h.values())n.notebookData.uri.toString()===i.toString()&&this.h.delete(n.id)}if(w.value.addedDocuments){const v=[];for(const i of w.value.addedDocuments){const d=y.URI.revive(i.uri);if(this.g.has(d))throw new Error(`adding EXISTING notebook ${d} `);const n=new o.ExtHostNotebookDocument(this.c,this.q,this.r,d,i);v.push(...i.cells.map(a=>o.ExtHostCell.asModelAddData(n.apiNotebook,a))),this.g.get(d)?.dispose(),this.g.set(d,n),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this.m.fire(n.apiNotebook)}}if(w.value.addedEditors)for(const v of w.value.addedEditors){if(this.h.has(v.id))return;const i=y.URI.revive(v.documentUri),d=this.g.get(i);d&&this.w(d,v.id,v)}const A=[];if(w.value.removedEditors)for(const v of w.value.removedEditors){const i=this.h.get(v);i&&(this.h.delete(v),this.k?.id===i.id&&(this.k=void 0),A.push(i))}if(w.value.visibleEditors){this.l=w.value.visibleEditors.map(i=>this.h.get(i)).filter(i=>!!i);const v=new Set;this.l.forEach(i=>v.add(i.id));for(const i of this.h.values()){const d=v.has(i.id);i._acceptVisibility(d)}this.l=[...this.h.values()].map(i=>i).filter(i=>i.visible),this.o.fire(this.visibleNotebookEditors)}w.value.newActiveEditor===null?this.k=void 0:w.value.newActiveEditor&&(this.k=this.h.get(w.value.newActiveEditor)),w.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(w){const A=E.ApiCommandArgument.String.with("notebookType","A notebook type"),v=new E.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[A,new E.ApiCommandArgument("data","Bytes to convert to data",d=>d instanceof Uint8Array,d=>r.VSBuffer.wrap(d))],new E.ApiCommandResult("Notebook Data",d=>f.NotebookData.to(d.value))),i=new E.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[A,new E.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",d=>!0,d=>new m.SerializableObjectWithBuffers(f.NotebookData.from(d)))],new E.ApiCommandResult("Bytes",d=>d.buffer));w.registerApiCommand(v),w.registerApiCommand(i)}}e.ExtHostNotebookController=h,h.a=0}),define(Ce[222],ke([1,0,18,16,21,4,6,28,2,25,11,53,5,37,8,7,72,185,27,45]),function(ie,e,r,k,D,M,S,O,y,T,N,E,f,b,m,o,s,h,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let A=class{constructor(t,g,c,u,l){this.k=g,this.l=c,this.m=u,this.n=l,this.b=new O.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new E.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=t.getProxy(f.MainContext.MainThreadNotebookKernels);const C=new b.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new b.ApiCommandArgument("options","Select kernel options",R=>!0,R=>{if(R&&"notebookEditor"in R&&"id"in R){const V=this.l.getIdByEditor(R.notebookEditor);return{id:R.id,extension:R.extension,notebookEditorId:V}}else if(R&&"notebookEditor"in R){const V=this.l.getIdByEditor(R.notebookEditor);if(V===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${R.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:V}}return R})],b.ApiCommandResult.Void);this.m.registerApiCommand(C)}createNotebookController(t,g,c,u,l,C){for(const ue of this.h.values())if(ue.controller.id===g&&T.ExtensionIdentifier.equals(t.identifier,ue.extensionId))throw new Error(`notebook controller with id '${g}' ALREADY exist`);const R=this.i++,V=this;this.n.trace(`NotebookController[${R}], CREATED by ${t.identifier.value}, ${g}`);const ee=()=>console.warn(`NO execute handler from notebook controller '${F.id}' of extension: '${t.identifier}'`);let K=!1;const L=new S.DisposableStore,B=new M.Emitter,P=new M.Emitter,F={id:n(t.identifier,g),notebookType:c,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:u||t.identifier.value,preloads:C?C.map(m.NotebookRendererScript.from):[]};let H=l??ee,j;this.a.$addKernel(R,F).catch(ue=>{console.log(ue),K=!0});let le=0;const _=()=>{if(K)return;const ue=++le;Promise.resolve().then(()=>{ue===le&&this.a.$updateKernel(R,F)})},be=new O.ResourceMap,de={get id(){return g},get notebookType(){return F.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return F.label},set label(ue){F.label=ue??t.displayName??t.name,_()},get detail(){return F.detail??""},set detail(ue){F.detail=ue,_()},get description(){return F.description??""},set description(ue){F.description=ue,_()},get kind(){return(0,p.checkProposedApiEnabled)(t,"notebookControllerKind"),F.kind??""},set kind(ue){(0,p.checkProposedApiEnabled)(t,"notebookControllerKind"),F.kind=ue,_()},get supportedLanguages(){return F.supportedLanguages},set supportedLanguages(ue){F.supportedLanguages=ue,_()},get supportsExecutionOrder(){return F.supportsExecutionOrder??!1},set supportsExecutionOrder(ue){F.supportsExecutionOrder=ue,_()},get rendererScripts(){return F.preloads?F.preloads.map(m.NotebookRendererScript.to):[]},get executeHandler(){return H},set executeHandler(ue){H=ue??ee},get interruptHandler(){return j},set interruptHandler(ue){j=ue,F.supportsInterrupt=Boolean(ue),_()},createNotebookCellExecution(ue){if(K)throw new Error("notebook controller is DISPOSED");if(!be.has(ue.notebook.uri))throw V.n.trace(`NotebookController[${R}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(be.keys()).map(se=>se.toString())),new Error(`notebook controller is NOT associated to notebook: ${ue.notebook.uri.toString()}`);return V._createNotebookCellExecution(ue,n(t.identifier,this.id))},dispose:()=>{K||(this.n.trace(`NotebookController[${R}], DISPOSED`),K=!0,this.h.delete(R),L.dispose(),B.dispose(),P.dispose(),this.a.$removeKernel(R))},updateNotebookAffinity(ue,se){se===o.NotebookControllerAffinity2.Hidden&&(0,p.checkProposedApiEnabled)(t,"notebookControllerAffinityHidden"),V.a.$updateNotebookPriority(R,ue.uri,se)},onDidReceiveMessage:P.event,postMessage(ue,se){return(0,p.checkProposedApiEnabled)(t,"notebookMessaging"),V.a.$postMessage(R,se&&V.l.getIdByEditor(se),ue)},asWebviewUri(ue){return(0,p.checkProposedApiEnabled)(t,"notebookMessaging"),(0,s.asWebviewUri)(ue,V.k.remote)}};return this.h.set(R,{extensionId:t.identifier,controller:de,onDidReceiveMessage:P,onDidChangeSelection:B,associatedNotebooks:be}),de}getIdByController(t){for(const[g,c]of this.h)if(c.controller===t)return n(c.extensionId,t.id);return null}createNotebookControllerDetectionTask(t,g){const c=this.d++,u=this;this.n.trace(`NotebookControllerDetectionTask[${c}], CREATED by ${t.identifier.value}`),this.a.$addKernelDetectionTask(c,g);const l={dispose:()=>{this.c.delete(c),u.a.$removeKernelDetectionTask(c)}};return this.c.set(c,l),l}registerKernelSourceActionProvider(t,g,c){const u=this.f++,l=typeof c.onDidChangeNotebookKernelSourceActions=="function"?u:void 0,C=this;this.e.set(u,c),this.n.trace(`NotebookKernelSourceActionProvider[${u}], CREATED by ${t.identifier.value}`),this.a.$addKernelSourceActionProvider(u,u,g);let R;return l!==void 0&&(R=c.onDidChangeNotebookKernelSourceActions(V=>this.a.$emitNotebookKernelSourceActionsChangeEvent(l))),{dispose:()=>{this.e.delete(u),C.a.$removeKernelSourceActionProvider(u,u),R?.dispose()}}}async $provideKernelSourceActions(t,g){const c=this.e.get(t);if(c){const u=new S.DisposableStore;return this.g.add([u]),(await c.provideNotebookKernelSourceActions(g)??[]).map(C=>m.NotebookKernelSourceAction.from(C,this.m.converter,u))}return[]}$acceptNotebookAssociation(t,g,c){const u=this.h.get(t);if(u){const l=this.l.getNotebookDocument(y.URI.revive(g));c?u.associatedNotebooks.set(l.uri,!0):u.associatedNotebooks.delete(l.uri),this.n.trace(`NotebookController[${t}] ASSOCIATE notebook`,l.uri.toString(),c),u.onDidChangeSelection.fire({selected:c,notebook:l.apiNotebook})}}async $executeCells(t,g,c){const u=this.h.get(t);if(!u)return;const l=this.l.getNotebookDocument(y.URI.revive(g)),C=[];for(const R of c){const V=l.getCell(R);V&&C.push(V.apiCell)}try{this.n.trace(`NotebookController[${t}] EXECUTE cells`,l.uri.toString(),C.length),await u.controller.executeHandler.call(u.controller,C,l.apiNotebook,u.controller)}catch(R){this.n.error(`NotebookController[${t}] execute cells FAILED`,R),console.error(R)}}async $cancelCells(t,g,c){const u=this.h.get(t);if(!u)return;const l=this.l.getNotebookDocument(y.URI.revive(g));if(u.controller.interruptHandler)await u.controller.interruptHandler.call(u.controller,l.apiNotebook);else for(const C of c){const R=l.getCell(C);R&&this.b.get(R.uri)?.cancel()}}$acceptKernelMessageFromRenderer(t,g,c){const u=this.h.get(t);if(!u)return;const l=this.l.getEditorById(g);u.onDidReceiveMessage.fire(Object.freeze({editor:l.apiEditor,message:c}))}$cellExecutionChanged(t,g,c){const l=this.l.getNotebookDocument(y.URI.revive(t)).getCell(g);if(l){const C=c?m.NotebookCellExecutionState.to(c):o.NotebookCellExecutionState.Idle;C!==void 0&&this.j.fire({cell:l.apiCell,state:C})}}_createNotebookCellExecution(t,g){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const u=this.l.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!u)throw new Error("invalid cell");if(this.b.has(u.uri))throw new Error(`duplicate execution for ${u.uri}`);const l=new i(g,u,this.a);this.b.set(u.uri,l);const C=l.onDidChangeState(()=>{l.state===v.Resolved&&(l.dispose(),C.dispose(),this.b.delete(u.uri))});return l.asApiObject()}};A=qe([je(4,N.ILogService)],A),e.ExtHostNotebookKernels=A;var v;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(v||(v={}));class i extends S.Disposable{get state(){return this.f}constructor(t,g,c){super(),this.j=g,this.k=c,this.b=i.a++,this.c=new M.Emitter,this.onDidChangeState=this.c.event,this.f=v.Init,this.g=this.B(new D.CancellationTokenSource),this.h=new d(10,u=>this.m(u)),this.i=g.internalMetadata.executionOrder,this.k.$createExecution(this.b,t,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(t){await this.h.addItem(t)}async m(t){const g=Array.isArray(t)?t:[t];return this.k.$updateExecution(this.b,new w.SerializableObjectWithBuffers(g))}n(){if(this.f===v.Init)throw new Error("Must call start before modifying cell output");if(this.f===v.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(t){let g=this.j;if(t&&(g=this.j.notebook.getCellFromApiCell(t)),!g)throw new Error("INVALID cell");return g.handle}s(t){return t.map(g=>{const c=o.NotebookCellOutput.ensureUniqueMimeTypes(g.items,!0);return c===g.items?m.NotebookCellOutput.from(g):m.NotebookCellOutput.from({items:c,id:g.id,metadata:g.metadata})})}async t(t,g,c){const u=this.r(g),l=this.s((0,r.asArray)(t));return this.l({editType:h.CellExecutionUpdateType.Output,cellHandle:u,append:c,outputs:l})}async w(t,g,c){return t=o.NotebookCellOutput.ensureUniqueMimeTypes((0,r.asArray)(t),!0),this.l({editType:h.CellExecutionUpdateType.OutputItems,items:t.map(m.NotebookCellOutputItem.from),outputId:g.id,append:c})}asApiObject(){const t=this;return Object.freeze({get token(){return t.g.token},get cell(){return t.j.apiCell},get executionOrder(){return t.i},set executionOrder(c){t.i=c,t.m([{editType:h.CellExecutionUpdateType.ExecutionState,executionOrder:t.i}])},start(c){if(t.f===v.Resolved||t.f===v.Started)throw new Error("Cannot call start again");t.f=v.Started,t.c.fire(),t.m({editType:h.CellExecutionUpdateType.ExecutionState,runStartTime:c})},end(c,u){if(t.f===v.Resolved)throw new Error("Cannot call resolve twice");t.f=v.Resolved,t.c.fire(),t.h.flush(),t.k.$completeExecution(t.b,new w.SerializableObjectWithBuffers({runEndTime:u,lastRunSuccess:c}))},clearOutput(c){return t.n(),t.t([],c,!1)},appendOutput(c,u){return t.n(),t.t(c,u,!0)},replaceOutput(c,u){return t.n(),t.t(c,u,!1)},appendOutputItems(c,u){return t.n(),t.w(c,u,!0)},replaceOutputItems(c,u){return t.n(),t.w(c,u,!1)}})}}i.a=0;class d{constructor(t,g){this.d=t,this.e=g,this.a=[],this.b=Date.now()}addItem(t){return this.a.push(t),this.c||(this.c=new k.DeferredPromise,this.b=Date.now(),(0,k.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const t=this.c;this.c=void 0;const g=this.a;return this.a=[],this.e(g).finally(()=>t.complete())}}function n(a,t){return`${a.value}/${t}`}e.createKernelId=n}),define(Ce[223],ke([1,0,4,5,100]),function(ie,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class M{constructor(O,y){this.c=y,this.a=new Map,this.b=O.getProxy(k.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(O,y,T){const N=this.c.getEditorById(O);this.a.get(y)?.fire({editor:N.apiEditor,message:T})}createRendererMessaging(O,y){if(!O.contributes?.notebookRenderer?.some(N=>N.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(N,E,f)=>this.d(y).event(N,E,f),postMessage:(N,E)=>{D.ExtHostNotebookEditor.apiEditorsToExtHost.has(N)&&([N,E]=[E,N]);const f=E&&D.ExtHostNotebookEditor.apiEditorsToExtHost.get(E);return this.b.$postMessage(f?.id,y,N)}}}d(O){let y=this.a.get(O);return y||(y=new r.Emitter({onDidRemoveLastListener:()=>{y?.dispose(),this.a.delete(O)}}),this.a.set(O,y),y)}}e.ExtHostNotebookRenderers=M}),define(Ce[224],ke([1,0,6,9,2,27,5]),function(ie,e,r,k,D,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class O{constructor(T){this.b=new Map,this.a=T.getProxy(S.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(T,N,E){if((0,M.checkProposedApiEnabled)(T,"profileContentHandlers"),this.b.has(N))throw new Error(`Handler with id '${N}' already registered`);return this.b.set(N,E),this.a.$registerProfileContentHandler(N,E.name,E.description,T.identifier.value),(0,r.toDisposable)(()=>{this.b.delete(N),this.a.$unregisterProfileContentHandler(N)})}async $saveProfile(T,N,E,f){const b=this.b.get(T);if(!b)throw new Error(`Unknown handler with id: ${T}`);return b.saveProfile(N,E,f)}async $readProfile(T,N,E){const f=this.b.get(T);if(!f)throw new Error(`Unknown handler with id: ${T}`);return f.readProfile((0,k.isString)(N)?N:D.URI.revive(N),E)}}e.ExtHostProfileContentHandlers=O}),define(Ce[225],ke([1,0,2,5,16,8]),function(ie,e,r,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class S{constructor(y,T){this.d=T,this.c=new Map,this.b=y.getProxy(k.MainContext.MainThreadQuickDiff)}$provideOriginalResource(y,T,N){const E=r.URI.revive(T),f=this.c.get(y);return f?(0,D.asPromise)(()=>f.provideOriginalResource(E,N)).then(b=>b||null):Promise.resolve(null)}registerQuickDiffProvider(y,T,N,E){const f=S.a++;return this.c.set(f,T),this.b.$registerQuickDiffProvider(f,M.DocumentSelector.from(y,this.d),N,E),{dispose:()=>this.c.delete(f)}}}e.ExtHostQuickDiff=S,S.a=0}),define(Ce[226],ke([1,0,21,4,6,5,2,7,12,18,29,38]),function(ie,e,r,k,D,M,S,O,y,T,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function f(b,m,o){const s=b.getProxy(M.MainContext.MainThreadQuickOpen);class h{constructor(t,g){this.e=new Map,this.f=0,this.a=t,this.b=g}showQuickPick(t,g,c=r.CancellationToken.None){this.c=void 0;const u=Promise.resolve(t),l=++this.f,C=s.$show(l,{title:g?.title,placeHolder:g?.placeHolder,matchOnDescription:g?.matchOnDescription,matchOnDetail:g?.matchOnDetail,ignoreFocusLost:g?.ignoreFocusOut,canPickMany:g?.canPickMany},c),R={},V=C.then(()=>R);return Promise.race([V,u]).then(ee=>{if(ee!==R)return u.then(K=>{const L=[];for(let B=0;B<K.length;B++){const P=K[B];typeof P=="string"?L.push({label:P,handle:B}):P.kind===O.QuickPickItemKind.Separator?L.push({type:"separator",label:P.label}):L.push({label:P.label,description:P.description,detail:P.detail,picked:P.picked,alwaysShow:P.alwaysShow,handle:B})}return g&&typeof g.onDidSelectItem=="function"&&(this.c=B=>{g.onDidSelectItem(K[B])}),s.$setItems(l,L),C.then(B=>{if(typeof B=="number")return K[B];if(Array.isArray(B))return B.map(P=>K[P])})})}).then(void 0,ee=>{if(!(0,y.isCancellationError)(ee))return s.$setError(l,ee),Promise.reject(ee)})}$onItemSelected(t){this.c?.(t)}showInput(t,g=r.CancellationToken.None){return this.d=t?.validateInput,s.$input(t,typeof this.d=="function",g).then(void 0,c=>{if(!(0,y.isCancellationError)(c))return Promise.reject(c)})}async $validateInput(t){if(!this.d)return;const g=await this.d(t);if(!g||typeof g=="string")return g;let c;switch(g.severity){case O.InputBoxValidationSeverity.Info:c=N.default.Info;break;case O.InputBoxValidationSeverity.Warning:c=N.default.Warning;break;case O.InputBoxValidationSeverity.Error:c=N.default.Error;break;default:c=g.message?N.default.Error:N.default.Ignore;break}return{content:g.message,severity:c}}async showWorkspaceFolderPick(t,g=r.CancellationToken.None){const c=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[t]);if(!c)return;const u=await this.a.getWorkspaceFolders2();if(!!u)return u.find(l=>l.uri.toString()===c.uri.toString())}createQuickPick(t){const g=new d(t,()=>this.e.delete(g._id));return this.e.set(g._id,g),g}createInputBox(t){const g=new n(t,()=>this.e.delete(g._id));return this.e.set(g._id,g),g}$onDidChangeValue(t,g){this.e.get(t)?._fireDidChangeValue(g)}$onDidAccept(t){this.e.get(t)?._fireDidAccept()}$onDidChangeActive(t,g){const c=this.e.get(t);c instanceof d&&c._fireDidChangeActive(g)}$onDidChangeSelection(t,g){const c=this.e.get(t);c instanceof d&&c._fireDidChangeSelection(g)}$onDidTriggerButton(t,g){this.e.get(t)?._fireDidTriggerButton(g)}$onDidTriggerItemButton(t,g,c){const u=this.e.get(t);u instanceof d&&u._fireDidTriggerItemButton(g,c)}$onDidHide(t){this.e.get(t)?._fireDidHide()}}class p{constructor(t,g){this.x=t,this.y=g,this._id=d.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new k.Emitter,this.q=new k.Emitter,this.r=new k.Emitter,this.s=new k.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(t){this.b=t,this.z({title:t})}get step(){return this.c}set step(t){this.c=t,this.z({step:t})}get totalSteps(){return this.d}set totalSteps(t){this.d=t,this.z({totalSteps:t})}get enabled(){return this.g}set enabled(t){this.g=t,this.z({enabled:t})}get busy(){return this.j}set busy(t){this.j=t,this.z({busy:t})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(t){this.k=t,this.z({ignoreFocusOut:t})}get value(){return this.l}set value(t){this.l=t,this.z({value:t})}get placeholder(){return this.m}set placeholder(t){this.m=t,this.z({placeholder:t})}get buttons(){return this.n}set buttons(t){this.n=t.slice(),this.o.clear(),t.forEach((g,c)=>{const u=g===O.QuickInputButtons.Back?-1:c;this.o.set(u,g)}),this.z({buttons:t.map((g,c)=>({...i(g),tooltip:g.tooltip,handle:g===O.QuickInputButtons.Back?-1:c}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(t){this.l=t,this.q.fire(t)}_fireDidTriggerButton(t){const g=this.o.get(t);g&&this.r.fire(g)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,D.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),s.$dispose(this._id))}z(t){if(!this.v){for(const g of Object.keys(t)){const c=t[g];this.u[g]=c===void 0?null:c}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){s.$createOrUpdate(this.u),this.u={id:this._id}}}p.a=1;function w(a){if(a instanceof O.ThemeIcon)return{id:a.id};const t=v(a),g=A(a);return{dark:typeof t=="string"?S.URI.file(t):t,light:typeof g=="string"?S.URI.file(g):g}}function A(a){return typeof a=="object"&&"light"in a?a.light:a}function v(a){return typeof a=="object"&&"dark"in a?a.dark:a}function i(a){const t=w(a.iconPath);let g,c;return"id"in t?c=E.ThemeIcon.asClassName(t):g=t,{iconPath:g,iconClass:c}}class d extends p{constructor(t,g){super(t.identifier,g),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new k.Emitter,this.L=[],this.M=new k.Emitter,this.N=new k.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(t){this.B=t.slice(),this.C.clear(),this.D.clear(),t.forEach((c,u)=>{this.C.set(u,c),this.D.set(c,u)});const g=[];for(let c=0;c<t.length;c++){const u=t[c];u.kind===O.QuickPickItemKind.Separator?g.push({type:"separator",label:u.label}):g.push({handle:c,label:u.label,description:u.description,detail:u.detail,picked:u.picked,alwaysShow:u.alwaysShow,buttons:u.buttons?.map((l,C)=>({...i(l),tooltip:l.tooltip,handle:C}))})}this.z({items:g})}get canSelectMany(){return this.E}set canSelectMany(t){this.E=t,this.z({canSelectMany:t})}get matchOnDescription(){return this.F}set matchOnDescription(t){this.F=t,this.z({matchOnDescription:t})}get matchOnDetail(){return this.G}set matchOnDetail(t){this.G=t,this.z({matchOnDetail:t})}get sortByLabel(){return this.H}set sortByLabel(t){this.H=t,this.z({sortByLabel:t})}get keepScrollPosition(){return this.I}set keepScrollPosition(t){this.I=t,this.z({keepScrollPosition:t})}get activeItems(){return this.J}set activeItems(t){this.J=t.filter(g=>this.D.has(g)),this.z({activeItems:this.J.map(g=>this.D.get(g))})}get selectedItems(){return this.L}set selectedItems(t){this.L=t.filter(g=>this.D.has(g)),this.z({selectedItems:this.L.map(g=>this.D.get(g))})}_fireDidChangeActive(t){const g=(0,T.coalesce)(t.map(c=>this.C.get(c)));this.J=g,this.K.fire(g)}_fireDidChangeSelection(t){const g=(0,T.coalesce)(t.map(c=>this.C.get(c)));this.L=g,this.M.fire(g)}_fireDidTriggerItemButton(t,g){const c=this.C.get(t);if(!c||!c.buttons||!c.buttons.length)return;const u=c.buttons[g];u&&this.N.fire({button:u,item:c})}}class n extends p{constructor(t,g){super(t.identifier,g),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(t){this.B=t,this.z({password:t})}get prompt(){return this.C}set prompt(t){this.C=t,this.z({prompt:t})}get valueSelection(){return this.D}set valueSelection(t){this.D=t,this.z({valueSelection:t})}get validationMessage(){return this.E}set validationMessage(t){this.E=t,t?typeof t=="string"?this.z({validationMessage:t,severity:N.default.Error}):this.z({validationMessage:t.message,severity:t.severity??N.default.Error}):this.z({validationMessage:void 0,severity:N.default.Ignore})}}return new h(m,o)}e.createExtHostQuickOpen=f});var Le=this&&this.__classPrivateFieldGet||function(ie,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(ie):k?k.value:e.get(ie)},Je=this&&this.__classPrivateFieldSet||function(ie,e,r,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!D:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(ie,r):D?D.value=r:e.set(ie,r),r};define(Ce[227],ke([1,0,2,4,63,6,16,5,18,123,11,25,38,8,27]),function(ie,e,r,k,D,M,S,O,y,T,N,E,f,b,m){"use strict";var o,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function h(u){if(u)return typeof u.iconPath=="string"?r.URI.file(u.iconPath):r.URI.isUri(u.iconPath)||f.ThemeIcon.isThemeIcon(u.iconPath)?u.iconPath:void 0}function p(u,l){if(!u.iconPath&&!l.iconPath)return 0;if(u.iconPath){if(!l.iconPath)return 1}else return-1;const C=typeof u.iconPath=="string"?u.iconPath:r.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id,R=typeof l.iconPath=="string"?l.iconPath:r.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id;return(0,T.comparePaths)(C,R)}function w(u,l){let C=0;if(u.strikeThrough!==l.strikeThrough)return u.strikeThrough?1:-1;if(u.faded!==l.faded)return u.faded?1:-1;if(u.tooltip!==l.tooltip)return(u.tooltip||"").localeCompare(l.tooltip||"");if(C=p(u,l),C!==0)return C;if(u.light&&l.light)C=p(u.light,l.light);else{if(u.light)return 1;if(l.light)return-1}if(C!==0)return C;if(u.dark&&l.dark)C=p(u.dark,l.dark);else{if(u.dark)return 1;if(l.dark)return-1}return C}function A(u,l){if(u.command!==l.command)return u.command<l.command?-1:1;if(u.title!==l.title)return u.title<l.title?-1:1;if(u.tooltip!==l.tooltip){if(u.tooltip!==void 0&&l.tooltip!==void 0)return u.tooltip<l.tooltip?-1:1;if(u.tooltip!==void 0)return 1;if(l.tooltip!==void 0)return-1}if(u.arguments===l.arguments)return 0;if(u.arguments)if(l.arguments){if(u.arguments.length!==l.arguments.length)return u.arguments.length-l.arguments.length}else return 1;else return-1;for(let C=0;C<u.arguments.length;C++){const R=u.arguments[C],V=l.arguments[C];if(R!==V)return R<V?-1:1}return 0}function v(u,l){let C=(0,T.comparePaths)(u.resourceUri.fsPath,l.resourceUri.fsPath,!0);if(C!==0)return C;if(u.command&&l.command)C=A(u.command,l.command);else{if(u.command)return 1;if(l.command)return-1}if(C!==0)return C;if(u.decorations&&l.decorations)C=w(u.decorations,l.decorations);else{if(u.decorations)return 1;if(l.decorations)return-1}return C}function i(u,l){for(let C=0;C<u.length;C++)if(u[C]!==l[C])return!1;return!0}function d(u,l){return u.command===l.command&&u.title===l.title&&u.tooltip===l.tooltip&&(u.arguments&&l.arguments?i(u.arguments,l.arguments):u.arguments===l.arguments)}function n(u,l){return(0,y.equals)(u,l,d)}class a{get value(){return this.d}set value(l){l=l??"",Le(this,o,"f").$setInputBoxValue(this.l,l),this.m(l)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(l){Le(this,o,"f").$setInputBoxPlaceholder(this.l,l),this.f=l}get validateInput(){return(0,m.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(l){if((0,m.checkProposedApiEnabled)(this.k,"scmValidation"),l&&typeof l!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=l,Le(this,o,"f").$setValidationProviderIsEnabled(this.l,!!l)}get enabled(){return this.h}set enabled(l){l=!!l,this.h!==l&&(this.h=l,Le(this,o,"f").$setInputBoxEnablement(this.l,l))}get visible(){return this.j}set visible(l){l=!!l,this.j!==l&&(this.j=l,Le(this,o,"f").$setInputBoxVisibility(this.l,l))}constructor(l,C,R){this.k=l,this.l=R,o.set(this,void 0),this.d="",this.e=new k.Emitter,this.f="",this.h=!0,this.j=!0,Je(this,o,C,"f")}showValidationMessage(l,C){(0,m.checkProposedApiEnabled)(this.k,"scmValidation"),Le(this,o,"f").$showValidationMessage(this.l,l,C)}$onInputBoxValueChange(l){this.m(l)}m(l){this.d=l,this.e.fire(l)}}e.ExtHostSCMInputBox=a,o=new WeakMap;class t{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(l){this.v=l,this.q.$updateGroupLabel(this.t,this.handle,l)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(l){this.p=l,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(l){this.f=[...l],this.k.fire()}constructor(l,C,R,V,ee){this.q=l,this.s=C,this.t=R,this.u=V,this.v=ee,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new k.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new k.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=t.d++}getResourceState(l){return this.g.get(l)}$executeResourceCommand(l,C){const R=this.h.get(l);return R?(0,S.asPromise)(()=>this.s.executeCommand(R.command,...R.arguments||[],C)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const l=[...this.f].sort(v),R=(0,y.sortedDiff)(this.o,l,v).map(K=>{const L=K.toInsert.map(B=>{const P=this.e++;this.g.set(P,B);const F=B.resourceUri;let H;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"){const Z=new M.DisposableStore;H=this.s.converter.toInternal(B.command,Z),this.j.set(P,Z)}else this.h.set(P,B.command);const j=h(B.decorations),le=B.decorations&&h(B.decorations.light)||j,_=B.decorations&&h(B.decorations.dark)||j,be=[le,_],de=B.decorations&&B.decorations.tooltip||"",ue=B.decorations&&!!B.decorations.strikeThrough,se=B.decorations&&!!B.decorations.faded,J=B.contextValue||"";return{rawResource:[P,F,be,de,ue,se,J,H],handle:P}});return{start:K.start,deleteCount:K.deleteCount,toInsert:L}}),V=R.map(({start:K,deleteCount:L,toInsert:B})=>[K,L,B.map(P=>P.rawResource)]),ee=R.reverse();for(const{start:K,deleteCount:L,toInsert:B}of ee){const P=B.map(H=>H.handle),F=this.n.splice(K,L,...P);for(const H of F)this.g.delete(H),this.h.delete(H),this.j.get(H)?.dispose(),this.j.delete(H)}return this.o=l,V}dispose(){this.l=!0,this.m.fire()}}t.d=0;class g{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(l){this.g!==l&&(this.g=l,Le(this,s,"f").$updateSourceControl(this.t,{count:l}))}get quickDiffProvider(){return this.h}set quickDiffProvider(l){this.h=l,Le(this,s,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!l})}get commitTemplate(){return this.j}set commitTemplate(l){l!==this.j&&(this.j=l,Le(this,s,"f").$updateSourceControl(this.t,{commitTemplate:l}))}get acceptInputCommand(){return this.l}set acceptInputCommand(l){this.k.value=new M.DisposableStore,this.l=l;const C=this.v.converter.toInternal(l,this.k.value);Le(this,s,"f").$updateSourceControl(this.t,{acceptInputCommand:C})}get actionButton(){return(0,m.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(l){(0,m.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new M.DisposableStore,this.n=l;const C=l!==void 0?{command:this.v.converter.toInternal(l.command,this.m.value),secondaryCommands:l.secondaryCommands?.map(R=>R.map(V=>this.v.converter.toInternal(V,this.m.value))),description:l.description,enabled:l.enabled}:void 0;Le(this,s,"f").$updateSourceControl(this.t,{actionButton:C??null})}get statusBarCommands(){return this.p}set statusBarCommands(l){if(this.p&&l&&n(this.p,l))return;this.o.value=new M.DisposableStore,this.p=l;const C=(l||[]).map(R=>this.v.converter.toInternal(R,this.o.value));Le(this,s,"f").$updateSourceControl(this.t,{statusBarCommands:C})}get selected(){return this.q}constructor(l,C,R,V,ee,K){this.u=l,this.v=R,this.w=V,this.x=ee,this.y=K,s.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new M.MutableDisposable,this.l=void 0,this.m=new M.MutableDisposable,this.o=new M.MutableDisposable,this.p=void 0,this.q=!1,this.s=new k.Emitter,this.onDidChangeSelection=this.s.event,this.t=g.d++,this.z=new Map,this.A=new Set,Je(this,s,C,"f"),this.f=new a(l,Le(this,s,"f"),this.t),Le(this,s,"f").$registerSourceControl(this.t,V,ee,K)}createResourceGroup(l,C){const R=new t(Le(this,s,"f"),this.v,this.t,l,C),V=k.Event.once(R.onDidDispose)(()=>this.z.delete(R));return this.z.set(R,V),this.eventuallyAddResourceGroups(),R}eventuallyAddResourceGroups(){const l=[],C=[];for(const[R,V]of this.z){V.dispose();const ee=R.onDidUpdateResourceStates(()=>{this.A.add(R),this.eventuallyUpdateResourceStates()});k.Event.once(R.onDidDispose)(()=>{this.A.delete(R),ee.dispose(),this.e.delete(R.handle),Le(this,s,"f").$unregisterGroup(this.t,R.handle)}),l.push([R.handle,R.id,R.label,R.features]);const K=R._takeResourceStateSnapshot();K.length>0&&C.push([R.handle,K]),this.e.set(R.handle,R)}Le(this,s,"f").$registerGroups(this.t,l,C),this.z.clear()}eventuallyUpdateResourceStates(){const l=[];this.A.forEach(C=>{const R=C._takeResourceStateSnapshot();R.length!==0&&l.push([C.handle,R])}),l.length>0&&Le(this,s,"f").$spliceResourceStates(this.t,l),this.A.clear()}getResourceGroup(l){return this.e.get(l)}setSelectionState(l){this.q=l,this.s.fire(l)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(l=>l.dispose()),Le(this,s,"f").$unregisterSourceControl(this.t)}}s=new WeakMap,g.d=0,qe([(0,D.debounce)(100)],g.prototype,"eventuallyAddResourceGroups",null),qe([(0,D.debounce)(100)],g.prototype,"eventuallyUpdateResourceStates",null);let c=class on{get onDidChangeActiveProvider(){return this.j.event}constructor(l,C,R){this.l=C,this.m=R,this.g=new Map,this.h=new Map,this.j=new k.Emitter,this.e=l.getProxy(O.MainContext.MainThreadSCM),this.f=l.getProxy(O.MainContext.MainThreadTelemetry),C.registerArgumentProcessor({processArgument:V=>{if(V&&V.$mid===3){const ee=this.g.get(V.sourceControlHandle);if(!ee)return V;const K=ee.getResourceGroup(V.groupHandle);return K?K.getResourceState(V.handle):V}else if(V&&V.$mid===4){const ee=this.g.get(V.sourceControlHandle);return ee?ee.getResourceGroup(V.groupHandle):V}else if(V&&V.$mid===5){const ee=this.g.get(V.handle);return ee||V}return V}})}createSourceControl(l,C,R,V){this.m.trace("ExtHostSCM#createSourceControl",l.identifier.value,C,R,V),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:l.identifier.value});const ee=on.d++,K=new g(l,this.e,this.l,C,R,V);this.g.set(ee,K);const L=this.h.get(E.ExtensionIdentifier.toKey(l.identifier))||[];return L.push(K),this.h.set(E.ExtensionIdentifier.toKey(l.identifier),L),K}getLastInputBox(l){this.m.trace("ExtHostSCM#getLastInputBox",l.identifier.value);const C=this.h.get(E.ExtensionIdentifier.toKey(l.identifier)),R=C&&C[C.length-1];return R&&R.inputBox}$provideOriginalResource(l,C,R){const V=r.URI.revive(C);this.m.trace("ExtHostSCM#$provideOriginalResource",l,V.toString());const ee=this.g.get(l);return!ee||!ee.quickDiffProvider||!ee.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,S.asPromise)(()=>ee.quickDiffProvider.provideOriginalResource(V,R)).then(K=>K||null)}$onInputBoxValueChange(l,C){this.m.trace("ExtHostSCM#$onInputBoxValueChange",l);const R=this.g.get(l);return R&&R.inputBox.$onInputBoxValueChange(C),Promise.resolve(void 0)}$executeResourceCommand(l,C,R,V){this.m.trace("ExtHostSCM#$executeResourceCommand",l,C,R);const ee=this.g.get(l);if(!ee)return Promise.resolve(void 0);const K=ee.getResourceGroup(C);return K?K.$executeResourceCommand(R,V):Promise.resolve(void 0)}$validateInput(l,C,R){this.m.trace("ExtHostSCM#$validateInput",l);const V=this.g.get(l);return!V||!V.inputBox.validateInput?Promise.resolve(void 0):(0,S.asPromise)(()=>V.inputBox.validateInput(C,R)).then(ee=>{if(!ee)return Promise.resolve(void 0);const K=b.MarkdownString.fromStrict(ee.message);return K?Promise.resolve([K,ee.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(l){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",l),l!==void 0&&this.g.get(l)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=l,Promise.resolve(void 0)}};c.d=0,c=qe([je(2,N.ILogService)],c),e.ExtHostSCM=c}),define(Ce[79],ke([1,0,5,4,3]),function(ie,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class M{constructor(O){this.b=new k.Emitter,this.onDidChangePassword=this.b.event,this.a=O.getProxy(r.MainContext.MainThreadSecretState)}async $onDidChangePassword(O){this.b.fire(O)}get(O,y){return this.a.$getPassword(O,y)}store(O,y,T){return this.a.$setPassword(O,y,T)}delete(O,y){return this.a.$deletePassword(O,y)}}e.ExtHostSecretState=M,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!D:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(ie,r):D?D.value=r:e.set(ie,r),r},Le=this&&this.__classPrivateFieldGet||function(ie,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(ie):k?k.value:e.get(ie)};define(Ce[228],ke([1,0,7,5,142,6,8,9]),function(ie,e,r,k,D,M,S,O){"use strict";var y,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class N{constructor(m,o,s,h,p=r.StatusBarAlignment.Left,w){y.set(this,void 0),T.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.q=new M.DisposableStore,Je(this,y,m,"f"),Je(this,T,o,"f"),this.c=N.a++,this.e=s,this.f=h,this.g=p,this.h=this.u(w)}u(m){if(!!(0,O.isNumber)(m))return m===Number.POSITIVE_INFINITY?Number.MAX_VALUE:m===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:m}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(m){this.k=m,this.v()}set name(m){this.m=m,this.v()}set tooltip(m){this.l=m,this.v()}set color(m){this.n=m,this.v()}set backgroundColor(m){m&&!N.b.has(m.id)&&(m=void 0),this.o=m,this.v()}set command(m){this.r?.fromApi!==m&&(this.p&&this.q.add(this.p),this.p=new M.DisposableStore,typeof m=="string"?this.r={fromApi:m,internal:Le(this,T,"f").toInternal({title:"",command:m},this.p)}:m?this.r={fromApi:m,internal:Le(this,T,"f").toInternal(m,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(m){this.t=m,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Le(this,y,"f").$dispose(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let m;this.e?this.f?m=`${this.e.identifier.value}.${this.f}`:m=this.e.identifier.value:m=this.f;let o;this.m?o=this.m:o=(0,D.localize)(0,null,this.e.displayName||this.e.name);let s=this.n;this.o&&(s=N.b.get(this.o.id));const h=S.MarkdownString.fromStrict(this.l);Le(this,y,"f").$setEntry(this.c,m,o,this.k,h,this.r?.internal,s,this.o,this.g===r.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.ExtHostStatusBarEntry=N,y=new WeakMap,T=new WeakMap,N.a=0,N.b=new Map([["statusBarItem.errorBackground",new r.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new r.ThemeColor("statusBarItem.warningForeground")]]);class E{constructor(m){this.b=[],this.a=m.createStatusBarEntry(void 0,"status.extensionMessage",r.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,D.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(m){const o={message:m};return this.b.unshift(o),this.c(),new r.Disposable(()=>{const s=this.b.indexOf(o);s>=0&&(this.b.splice(s,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class f{constructor(m,o){this.a=m.getProxy(k.MainContext.MainThreadStatusBar),this.b=o,this.c=new E(this)}createStatusBarEntry(m,o,s,h){return new N(this.a,this.b,m,o,s,h)}setStatusBarMessage(m,o){const s=this.c.setMessage(m);let h;return typeof o=="number"?h=setTimeout(()=>s.dispose(),o):typeof o<"u"&&o.then(()=>s.dispose(),()=>s.dispose()),new r.Disposable(()=>{s.dispose(),clearTimeout(h)})}}e.ExtHostStatusBar=f}),define(Ce[80],ke([1,0,5,4,3]),function(ie,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class M{constructor(O,y){this.c=y,this.b=new k.Emitter,this.onDidChangeStorage=this.b.event,this.a=O.getProxy(r.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(O,y){this.a.$registerExtensionStorageKeysToSync(O,y)}async initializeExtensionStorage(O,y,T){const N=await this.a.$initializeExtensionStorage(O,y);let E;return N&&(E=this.d(O,y,N)),E||T}setValue(O,y,T){return this.a.$setValue(O,y,T)}$acceptValue(O,y,T){const N=this.d(O,y,T);N&&this.b.fire({shared:O,key:y,value:N})}d(O,y,T){try{return JSON.parse(T)}catch(N){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${O}): ${N}`)}}}e.ExtHostStorage=M,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(Ce[81],ke([1,0,3,26,11,59,2]),function(ie,e,r,k,D,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,r.createDecorator)("IExtensionStoragePaths");let O=class{constructor(T,N,E){this.d=N,this.f=E,this.a=T.workspace??void 0,this.b=T.environment,this.whenReady=this.h().then(f=>this.c=f)}async g(T){return S.URI.joinPath(this.b.workspaceStorageHome,T)}async h(){if(!this.a)return Promise.resolve(void 0);const T=this.a.id,N=await this.g(T);try{return await this.f.value.stat(N),this.d.trace("[ExtHostStorage] storage dir already exists",N),N}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",N),await this.f.value.createDirectory(N),await this.f.value.writeFile(S.URI.joinPath(N,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:S.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),N}catch(E){this.d.error("[ExtHostStorage]",E);return}}workspaceValue(T){if(this.c)return S.URI.joinPath(this.c,T.identifier.value)}globalValue(T){return S.URI.joinPath(this.b.globalStorageHome,T.identifier.value.toLowerCase())}onWillDeactivateAll(){}};O=qe([je(0,k.IExtHostInitDataService),je(1,D.ILogService),je(2,M.IExtHostConsumerFileSystem)],O),e.ExtensionStoragePaths=O}),define(Ce[60],ke([1,0,4,5,3,2,17,6,7,143,12,169,21,34,170,38,9,16,8]),function(ie,e,r,k,D,M,S,O,y,T,N,E,f,b,m,o,s,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class w{constructor(c,u,l,C){this.k=c,this._id=u,this.l=l,this.m=C,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(V=>this.f=V);const R=this;this.value={get name(){return R.m||""},get processId(){return R.b},get creationOptions(){return R.l},get exitStatus(){return R.h},get state(){return R.j},sendText(V,ee=!0){R.o(),R.k.$sendText(R._id,V,ee)},show(V){R.o(),R.k.$show(R._id,V)},hide(){R.o(),R.k.$hide(R._id)},dispose(){R.a||(R.a=!0,R.k.$dispose(R._id))},get dimensions(){if(!(R.d===void 0||R.g===void 0))return{columns:R.d,rows:R.g}}}}async create(c,u){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:c.name,shellPath:(0,s.withNullAsUndefined)(c.shellPath),shellArgs:(0,s.withNullAsUndefined)(c.shellArgs),cwd:(0,s.withNullAsUndefined)(c.cwd),env:(0,s.withNullAsUndefined)(c.env),icon:(0,s.withNullAsUndefined)(a(c.iconPath)),color:o.ThemeColor.isThemeColor(c.color)?c.color.id:void 0,initialText:(0,s.withNullAsUndefined)(c.message),strictEnv:(0,s.withNullAsUndefined)(c.strictEnv),hideFromUser:(0,s.withNullAsUndefined)(c.hideFromUser),isFeatureTerminal:(0,s.withNullAsUndefined)(u?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,s.withNullAsUndefined)(u?.useShellEnvironment),location:u?.location||this.n(c.location,u?.resolvedExtHostIdentifier),isTransient:(0,s.withNullAsUndefined)(c.isTransient)})}async createExtensionTerminal(c,u,l,C){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:l,color:o.ThemeColor.isThemeColor(C)?C.id:void 0,location:this.n(c,u),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(c,u){return typeof c=="object"?"parentTerminal"in c&&c.parentTerminal&&u?{parentTerminal:u}:"viewColumn"in c?{viewColumn:p.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus}:void 0:c}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(c){this.m=c}setExitStatus(c,u){this.h=Object.freeze({code:c,reason:u})}setDimensions(c,u){return c===this.d&&u===this.g||c===0||u===0?!1:(this.d=c,this.g=u,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(c){this.f?(this.f(c),this.f=void 0):this.b.then(u=>{u!==c&&(this.b=Promise.resolve(c))})}}e.ExtHostTerminal=w;class A{get onProcessReady(){return this.b.event}constructor(c){this.g=c,this.id=0,this.shouldPersist=!1,this.a=new r.Emitter,this.onProcessData=this.a.event,this.b=new r.Emitter,this.d=new r.Emitter,this.onDidChangeProperty=this.d.event,this.f=new r.Emitter,this.onProcessExit=this.f.event}refreshProperty(c){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${c}`)}updateProperty(c,u){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${c}, value: ${u}`)}async start(){}shutdown(){this.g.close()}input(c){this.g.handleInput?.(c)}resize(c,u){this.g.setDimensions?.({columns:c,rows:u})}async processBinary(c){}acknowledgeDataEvent(c){}async setUnicodeVersion(c){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(c){this.g.onDidWrite(u=>this.a.fire(u)),this.g.onDidClose?.((u=void 0)=>{this.f.fire(u===void 0?void 0:u)}),this.g.onDidOverrideDimensions?.(u=>{u&&this.d.fire({type:"overrideDimensions",value:{cols:u.columns,rows:u.rows}})}),this.g.onDidChangeName?.(u=>{this.d.fire({type:"title",value:u})}),this.g.open(c||void 0),c&&this.g.setDimensions?.(c),this.b.fire({pid:-1,cwd:""})}}let v=1,i=class extends O.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(c=>c.value)}get onDidWriteTerminalData(){return this.I.event}constructor(c,u){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new r.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new r.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new r.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new r.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new r.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new r.Emitter,this.onDidChangeShell=this.J.event,this.a=u.getProxy(k.MainContext.MainThreadTerminalService),this.s=new m.TerminalDataBufferer(this.a.$sendProcessData),this.I=new r.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(c),this.B({dispose:()=>{for(const[l,C]of this.g)C.shutdown(!0)}})}getDefaultShell(c){return(c?this.n:this.m)?.path||""}getDefaultShellArgs(c){return(c?this.n:this.m)?.args||[]}createExtensionTerminal(c,u){const l=new w(this.a,(0,b.generateUuid)(),c,c.name),C=new A(c.pty);return l.createExtensionTerminal(c.location,this.L(c,u).resolvedExtHostIdentifier,a(c.iconPath),t(c.color)).then(R=>{const V=this.M(R,C);this.h[R]=V}),this.f.push(l),l.value}L(c,u){if(u=u||{},c.location&&typeof c.location=="object"&&"parentTerminal"in c.location){const l=c.location.parentTerminal;if(l){const C=this.f.find(R=>R.value===l);C&&(u.resolvedExtHostIdentifier=C._id)}}else c.location&&typeof c.location!="object"?u.location=c.location:u.location&&typeof u.location=="object"&&"splitActiveTerminal"in u.location&&(u.location={splitActiveTerminal:!0});return u}attachPtyToTerminal(c,u){if(!this.O(c))throw new Error(`Cannot resolve terminal with id ${c} for virtual process`);const C=new A(u),R=this.M(c,C);this.h[c]=R}async $acceptActiveTerminalChanged(c){const u=this.b;if(c===null){this.b=void 0,u!==this.b&&this.F.fire(this.b);return}const l=this.O(c);l&&(this.b=l,u!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(c,u){const l=this.O(c);l&&this.I.fire({terminal:l.value,data:u})}async $acceptTerminalDimensions(c,u,l){const C=this.O(c);C&&C.setDimensions(u,l)&&this.G.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptTerminalMaximumDimensions(c,u,l){this.g.get(c)?.resize(u,l)}async $acceptTerminalTitleChange(c,u){const l=this.O(c);l&&(l.name=u)}async $acceptTerminalClosed(c,u,l){const C=this.Q(this.f,c);if(C!==null){const R=this.f.splice(C,1)[0];R.setExitStatus(u,l),this.C.fire(R.value)}}$acceptTerminalOpened(c,u,l,C){if(u){const ee=this.Q(this.f,u);if(ee!==null){this.f[ee]._id=c,this.D.fire(this.terminals[ee]),this.f[ee].isOpen=!0;return}}const R={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:M.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},V=new w(this.a,c,R,l);this.f.push(V),this.D.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(c,u){this.O(c)?._setProcessId(u)}async $startExtensionTerminal(c,u){const l=this.O(c);if(!l)return{message:(0,T.localize)(0,null,c)};l.isOpen||await new Promise(R=>{const V=this.onDidOpenTerminal(async ee=>{ee===l.value&&(V.dispose(),R())})});const C=this.g.get(c);C?C.startSendingEvents(u):this.j[c]={initialDimensions:u}}M(c,u){const l=new O.DisposableStore;l.add(u.onProcessReady(R=>this.a.$sendProcessReady(c,R.pid,R.cwd))),l.add(u.onDidChangeProperty(R=>this.a.$sendProcessProperty(c,R))),this.s.startBuffering(c,u.onProcessData),l.add(u.onProcessExit(R=>this.N(c,R))),this.g.set(c,u);const C=this.j[c];return C&&u instanceof A&&(u.startSendingEvents(C.initialDimensions),delete this.j[c]),l}$acceptProcessAckDataEvent(c,u){this.g.get(c)?.acknowledgeDataEvent(u)}$acceptProcessInput(c,u){this.g.get(c)?.input(u)}$acceptTerminalInteraction(c){const u=this.O(c);u?.setInteractedWith()&&this.H.fire(u.value)}$acceptProcessResize(c,u,l){try{this.g.get(c)?.resize(u,l)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(c,u){this.g.get(c)?.shutdown(u)}$acceptProcessRequestInitialCwd(c){this.g.get(c)?.getInitialCwd().then(u=>this.a.$sendProcessProperty(c,{type:"initialCwd",value:u}))}$acceptProcessRequestCwd(c){this.g.get(c)?.getCwd().then(u=>this.a.$sendProcessProperty(c,{type:"cwd",value:u}))}$acceptProcessRequestLatency(c){return Promise.resolve(c)}registerLinkProvider(c){return this.u.add(c),this.u.size===1&&this.a.$startLinkProvider(),new y.Disposable(()=>{this.u.delete(c),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(c,u,l){if(this.v.has(u))throw new Error(`Terminal profile provider "${u}" already registered`);return this.v.set(u,l),this.a.$registerProfileProvider(u,c.identifier.value),new y.Disposable(()=>{this.v.delete(u),this.a.$unregisterProfileProvider(u)})}registerTerminalQuickFixProvider(c,u,l){if(this.w.has(c))throw new Error(`Terminal quick fix provider "${c}" is already registered`);return this.w.set(c,l),this.a.$registerQuickFixProvider(c,u),new y.Disposable(()=>{this.w.delete(c),this.a.$unregisterQuickFixProvider(c)})}async $provideTerminalQuickFixes(c,u){const l=new f.CancellationTokenSource().token;if(l.isCancellationRequested)return;const C=this.w.get(c);if(!C)return;const R=await C.provideTerminalQuickFixes(u,l);if(R!==null)return R}async $createContributedProfileTerminal(c,u){const l=new f.CancellationTokenSource().token;let C=await this.v.get(c)?.provideTerminalProfile(l);if(!l.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${c}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,u);return}this.createTerminalFromOptions(C.options,u)}}async $provideLinks(c,u){const l=this.O(c);if(!l)return[];this.y.delete(c),this.z.get(c)?.dispose(!0);const R=new f.CancellationTokenSource;this.z.set(c,R);const V=[],ee={terminal:l.value,line:u},K=[];for(const P of this.u)K.push(h.Promises.withAsyncBody(async F=>{R.token.onCancellationRequested(()=>F({provider:P,links:[]}));const H=await P.provideTerminalLinks(ee,R.token)||[];R.token.isCancellationRequested||F({provider:P,links:H})}));const L=await Promise.all(K);if(R.token.isCancellationRequested)return[];const B=new Map;for(const P of L)P&&P.links.length>0&&V.push(...P.links.map(F=>{const H={id:v++,startIndex:F.startIndex,length:F.length,label:F.tooltip};return B.set(H.id,{provider:P.provider,link:F}),H}));return this.y.set(c,B),V}$activateLink(c,u){const l=this.y.get(c)?.get(u);!l||l.provider.handleTerminalLink(l.link)}N(c,u){this.s.stopBuffering(c),this.g.delete(c),delete this.j[c];const l=this.h[c];l&&(l.dispose(),delete this.h[c]),this.a.$sendProcessExit(c,u)}O(c){return this.P(this.f,c)}P(c,u){const l=this.Q(c,u);return l!==null?c[l]:null}Q(c,u){let l=null;return c.some((C,R)=>C._id===u?(l=R,!0):!1),l}getEnvironmentVariableCollection(c){let u=this.l.get(c.identifier.value);return u||(u=new d,this.S(c.identifier.value,u)),u}R(c,u){const l=(0,E.serializeEnvironmentVariableCollection)(u.map);this.a.$setEnvironmentVariableCollection(c,u.persistent,l.length===0?void 0:l)}$initEnvironmentVariableCollections(c){c.forEach(u=>{const l=u[0],C=new d(u[1]);this.S(l,C)})}$acceptDefaultProfile(c,u){const l=this.m;this.m=c,this.n=u,l?.path!==c.path&&this.J.fire(c.path)}S(c,u){this.l.set(c,u),u.onDidChangeCollection(()=>{this.R(c,u)})}};i=qe([je(1,S.IExtHostRpcService)],i),e.BaseExtHostTerminalService=i;class d{get persistent(){return this.a}set persistent(c){this.a=c,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(c){this.map=new Map,this.a=!0,this.b=new r.Emitter,this.map=new Map(c)}get size(){return this.map.size}replace(c,u){this.d(c,{value:u,type:y.EnvironmentVariableMutatorType.Replace})}append(c,u){this.d(c,{value:u,type:y.EnvironmentVariableMutatorType.Append})}prepend(c,u){this.d(c,{value:u,type:y.EnvironmentVariableMutatorType.Prepend})}d(c,u){const l=this.map.get(c);(!l||l.value!==u.value||l.type!==u.type)&&(this.map.set(c,u),this.b.fire())}get(c){return this.map.get(c)}forEach(c,u){this.map.forEach((l,C)=>c.call(u,C,l,this))}[Symbol.iterator](){return this.map.entries()}delete(c){this.map.delete(c),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let n=class extends i{constructor(c){super(!1,c)}createTerminal(c,u,l){throw new N.NotSupportedError}createTerminalFromOptions(c,u){throw new N.NotSupportedError}};n=qe([je(0,S.IExtHostRpcService)],n),e.WorkerExtHostTerminalService=n;function a(g){if(!(!g||typeof g=="string"))return"id"in g?{id:g.id,color:g.color}:g}function t(g){return o.ThemeColor.isThemeColor(g)?g:void 0}});var Le=this&&this.__classPrivateFieldGet||function(ie,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(ie):k?k.value:e.get(ie)},Je=this&&this.__classPrivateFieldSet||function(ie,e,r,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!D:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(ie,r):D?D.value=r:e.set(ie,r),r};define(Ce[229],ke([1,0,18,16,23,21,4,193,230,6,22,9,34,5,17,101,8,7,44,71,55,27]),function(ie,e,r,k,D,M,S,O,y,T,N,E,f,b,m,o,s,h,p,w,A,v){"use strict";var i,d;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let n=class{constructor(P,F,H){this.j=H,this.c=new S.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=P.getProxy(b.MainContext.MainThreadTesting),this.h=new ee(this.f),this.g=new c(this.f),F.registerArgumentProcessor({processArgument:j=>{if(j?.$mid!==15)return j;const le=j,_=le.tests[le.tests.length-1].item.extId;return this.d.get(p.TestId.root(_))?.collection.tree.get(_)?.actual??(0,o.toItemFromContext)(j)}})}createTestController(P,F,H,j){if(this.d.has(F))throw new Error(`Attempt to insert a duplicate controller with ID "${F}"`);const le=new T.DisposableStore,_=le.add(new o.ExtHostTestItemCollection(F,H,this.j));_.root.label=H;const be=new Map,de=this.f,ue={items:_.root.children,get label(){return H},set label(J){H=J,_.root.label=J,de.$updateController(F,{label:H})},get refreshHandler(){return j},set refreshHandler(J){j=J,de.$updateController(F,{canRefresh:!!J})},get id(){return F},createRunProfile:(J,X,Z,he,Te,Ne)=>{let Ke=(0,y.hash)(J);for(;be.has(Ke);)Ke++;return Ne!==void 0&&(0,v.checkProposedApiEnabled)(P,"testContinuousRun"),new K(this.f,be,F,Ke,J,X,Z,he,Te,Ne)},createTestItem(J,X,Z){return new o.TestItemImpl(F,J,X,Z)},createTestRun:(J,X,Z=!0)=>this.g.createTestRun(F,_,J,X,Z),set resolveHandler(J){_.resolveHandler=J},get resolveHandler(){return _.resolveHandler},dispose:()=>{le.dispose()}};de.$registerTestController(F,H,!!j),le.add((0,T.toDisposable)(()=>de.$unregisterTestController(F)));const se={controller:ue,collection:_,profiles:be};return this.d.set(F,se),le.add((0,T.toDisposable)(()=>this.d.delete(F))),le.add(_.onDidGenerateDiff(J=>de.$publishDiff(F,J.map(A.TestsDiffOp.serialize)))),ue}createTestObserver(){return this.h.checkout()}async runTests(P,F=M.CancellationToken.None){const H=u(P);if(!H)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const j=this.d.get(H.controllerId);if(!j)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:P.include?.map(le=>p.TestId.fromExtHostTestItem(le,j.collection.root.id).toString())??[j.collection.root.id],profileGroup:L[H.kind],profileId:H.profileId,controllerId:H.controllerId}],exclude:P.exclude?.map(le=>le.id)},F)}$syncTests(){for(const{collection:P}of this.d.values())P.flushDiff();return Promise.resolve()}$provideFileCoverage(P,F,H){return(0,r.mapFind)(this.g.trackers,le=>le.id===P?le.getCoverage(F):void 0)?.provideFileCoverage(H)??Promise.resolve([])}$resolveFileCoverage(P,F,H,j){return(0,r.mapFind)(this.g.trackers,_=>_.id===P?_.getCoverage(F):void 0)?.resolveFileCoverage(H,j)??Promise.resolve([])}$configureRunProfile(P,F){this.d.get(P)?.profiles.get(F)?.configureHandler?.()}async $refreshTests(P,F){await this.d.get(P)?.controller.refreshHandler?.(F)}$publishTestResults(P){this.results=Object.freeze(P.map(F=>(0,N.deepFreeze)(s.TestResults.to(F))).concat(this.results).sort((F,H)=>H.completedAt-F.completedAt).slice(0,32)),this.c.fire()}async $expandTest(P,F){const H=this.d.get(p.TestId.fromString(P).controllerId)?.collection;H&&(await H.expand(P,F<0?1/0:F),H.flushDiff())}$acceptDiff(P){this.h.applyDiff(P.map(A.TestsDiffOp.deserialize))}async $runControllerTests(P,F){return Promise.all(P.map(H=>this.k(H,!1,F)))}async $startContinuousRun(P,F){const H=new M.CancellationTokenSource(F),j=await Promise.all(P.map(le=>this.k(le,!0,H.token)));return!F.isCancellationRequested&&!j.some(le=>le.error)&&await new Promise(le=>F.onCancellationRequested(le)),H.dispose(!0),j}async k(P,F,H){const j=this.d.get(P.controllerId);if(!j)return{};const{collection:le,profiles:_}=j,be=_.get(P.profileId);if(!be)return{};const de=P.testIds.map(X=>le.tree.get(X)).filter(E.isDefined),ue=P.excludeExtIds.map(X=>j.collection.tree.get(X)).filter(E.isDefined).filter(X=>de.some(Z=>Z.fullId.compare(X.fullId)===2));if(!de.length)return{};const se=new h.TestRunRequest2(de.some(X=>X.actual instanceof o.TestItemRootImpl)?void 0:de.map(X=>X.actual),ue.map(X=>X.actual),be,F),J=(0,A.isStartControllerTests)(P)&&this.g.prepareForMainThreadTestRun(se,l.fromInternal(P,j.collection),H);try{return await be.runHandler(se,H),{}}catch(X){return{error:String(X)}}finally{J&&(J.hasRunningTasks&&!H.isCancellationRequested&&await S.Event.toPromise(J.onEnd),J.dispose())}}$cancelExtensionTestRun(P){P===void 0?this.g.cancelAllRuns():this.g.cancelRunById(P)}};n=qe([je(0,m.IExtHostRpcService)],n),e.ExtHostTesting=n;const a=1e4;var t;(function(B){B[B.Running=0]="Running",B[B.Cancelling=1]="Cancelling",B[B.Ended=2]="Ended"})(t||(t={}));class g extends T.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(P,F,H){super(),this.k=P,this.l=F,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new S.Emitter),this.onEnd=this.j.event,this.h=this.B(new M.CancellationTokenSource(H));const j=this.B(new k.RunOnceScheduler(()=>this.m(),a));this.B(this.h.token.onCancellationRequested(()=>j.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(P){return this.f.get(P)?.coverage}createRun(P){const F=this.k.id,H=this.k.controllerId,j=(0,f.generateUuid)(),le=new C(this.l,F,j),_=se=>(J,...X)=>{if(de){console.warn(`Setting the state of test "${J.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(J)||(this.s(J),se(J,...X))},be=(se,J)=>{const X=J instanceof Array?J.map(s.TestMessage.from):[s.TestMessage.from(J)];if(se.uri&&se.range){const Z={range:s.Range.from(se.range),uri:se.uri};for(const he of X)he.location=he.location||Z}this.l.$appendTestMessagesInRun(F,j,p.TestId.fromExtHostTestItem(se,H).toString(),X)};let de=!1;const ue={isPersisted:this.k.isPersisted,token:this.h.token,name:P,get coverageProvider(){return le.coverageProvider},set coverageProvider(se){le.coverageProvider=se},enqueued:_(se=>{this.l.$updateTestStateInRun(F,j,p.TestId.fromExtHostTestItem(se,H).toString(),1)}),skipped:_(se=>{this.l.$updateTestStateInRun(F,j,p.TestId.fromExtHostTestItem(se,H).toString(),5)}),started:_(se=>{this.l.$updateTestStateInRun(F,j,p.TestId.fromExtHostTestItem(se,H).toString(),2)}),errored:_((se,J,X)=>{be(se,J),this.l.$updateTestStateInRun(F,j,p.TestId.fromExtHostTestItem(se,H).toString(),6,X)}),failed:_((se,J,X)=>{be(se,J),this.l.$updateTestStateInRun(F,j,p.TestId.fromExtHostTestItem(se,H).toString(),4,X)}),passed:_((se,J)=>{this.l.$updateTestStateInRun(F,j,p.TestId.fromExtHostTestItem(se,this.k.controllerId).toString(),3,J)}),appendOutput:(se,J,X)=>{de||(X&&(this.k.isIncluded(X)?this.s(X):X=void 0),this.l.$appendOutputToRun(F,j,D.VSBuffer.fromString(se),J&&s.location.from(J),X&&p.TestId.fromExtHostTestItem(X,H).toString()))},end:()=>{de||(de=!0,this.l.$finishedTestRunTask(F,j),this.f.delete(j),this.f.size||this.p())}};return this.f.set(j,{run:ue,coverage:le}),this.l.$startedTestRunTask(F,{id:j,name:P,running:!0}),ue}m(){for(const{run:P}of this.f.values())P.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(P){if(!(P instanceof o.TestItemImpl))throw new w.InvalidTestItemError(P.id);if(this.g.has(p.TestId.fromExtHostTestItem(P,this.k.controllerId).toString()))return;const F=[],H=this.k.colllection.root;for(;;){const j=s.TestItem.from(P);if(F.unshift(j),this.g.has(j.extId)||(this.g.add(j.extId),P===H))break;P=P.parent||H}this.l.$addTestsToRun(this.k.controllerId,this.k.id,F)}}class c{get trackers(){return this.c.values()}constructor(P){this.d=P,this.c=new Map}prepareForMainThreadTestRun(P,F,H){return this.f(P,F,H)}cancelRunById(P){for(const F of this.c.values())if(F.id===P){F.cancel();return}}cancelAllRuns(){for(const P of this.c.values())P.cancel()}createTestRun(P,F,H,j,le){const _=this.c.get(H);if(_)return _.createRun(j);const be=l.fromPublic(P,F,H,le),de=u(H);this.d.$startedExtensionTestRun({controllerId:P,continuous:!!H.continuous,profile:de&&{group:L[de.kind],id:de.profileId},exclude:H.exclude?.map(se=>p.TestId.fromExtHostTestItem(se,F.root.id).toString())??[],id:be.id,include:H.include?.map(se=>p.TestId.fromExtHostTestItem(se,F.root.id).toString())??[F.root.id],persist:le});const ue=this.f(H,be);return ue.onEnd(()=>{this.d.$finishedExtensionTestRun(be.id),ue.dispose()}),ue.createRun(j)}f(P,F,H){const j=new g(F,this.d,H);return this.c.set(P,j),j.onEnd(()=>this.c.delete(P)),j}}e.TestRunCoordinator=c;const u=B=>{if(!!B.profile){if(!(B.profile instanceof K))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return B.profile}};class l{static fromPublic(P,F,H,j){return new l(P,(0,f.generateUuid)(),H.include?.map(le=>p.TestId.fromExtHostTestItem(le,P).toString())??[P],H.exclude?.map(le=>p.TestId.fromExtHostTestItem(le,P).toString())??[],j,F)}static fromInternal(P,F){return new l(P.controllerId,P.runId,P.testIds,P.excludeExtIds,!0,F)}constructor(P,F,H,j,le,_){this.controllerId=P,this.id=F,this.isPersisted=le,this.colllection=_,this.c=H.map(be=>be+"\0"),this.d=j.map(be=>be+"\0")}isIncluded(P){const F=p.TestId.fromExtHostTestItem(P,this.controllerId).toString()+"\0";for(const H of this.d)if(F===H||F.startsWith(H))return!1;for(const H of this.c)if(F===H||F.startsWith(H))return!0;return!1}}e.TestRunDto=l;class C{set coverageProvider(P){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!P||(this.c=P,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(P,F,H){this.f=P,this.g=F,this.h=H}async provideFileCoverage(P){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(P))());try{return(await this.d)?.map(s.TestCoverage.fromFile)??[]}catch(F){throw this.d=void 0,F}}async resolveFileCoverage(P,F){const H=await this.d;let j=H?.[P];return!this.c||!H||!j?[]:(j.detailedCoverage||(j=H[P]=await this.c.resolveFileCoverage?.(j,F)??j),j.detailedCoverage?.map(s.TestCoverage.fromDetailed)??[])}}class R{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(P){this.h=P,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(P){this.c.add(P)}update(P){Object.assign(P.revived,s.TestItem.toPlain(P.item)),this.c.has(P)||this.d.add(P)}remove(P){if(this.c.has(P)){this.c.delete(P);return}this.d.delete(P);const F=p.TestId.parentId(P.item.extId);if(F&&this.g.has(F.toString())){this.g.add(P.item.extId);return}this.f.add(P)}getChangeEvent(){const{c:P,d:F,f:H}=this;return{get added(){return[...P].map(j=>j.revived)},get updated(){return[...F].map(j=>j.revived)},get removed(){return[...H].map(j=>j.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class V extends A.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new S.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(P){return this.d.get(P)}getMirroredTestDataByReference(P){return this.d.get(P.id)}p(P,F){return{...P,revived:s.TestItem.toPlain(P.item),depth:F?F.depth+1:0,children:new Set}}o(){return new R(this.q)}}class ee{constructor(P){this.d=P}checkout(){this.c||(this.c=this.f());const P=this.c;return P.observers++,{onDidChangeTest:P.tests.onDidChangeTests,get tests(){return[...P.tests.rootTests].map(F=>F.revived)},dispose:(0,O.once)(()=>{--P.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(P){return this.c?.tests.getMirroredTestDataByReference(P)}applyDiff(P){this.c?.tests.apply(P)}f(){const P=new V;return this.d.$subscribeToDiffs(),{observers:0,tests:P}}}class K{get label(){return this.d}set label(P){P!==this.d&&(this.d=P,Le(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:P}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(P){P!==this.g&&(this.g=P,Le(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:P}))}get isDefault(){return this.f}set isDefault(P){P!==this.f&&(this.f=P,Le(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:P}))}get tag(){return this._tag}set tag(P){P?.id!==this._tag?.id&&(this._tag=P,Le(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:P?s.TestTag.namespace(this.controllerId,P.id):null}))}get configureHandler(){return this.c}set configureHandler(P){P!==this.c&&(this.c=P,Le(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!P}))}constructor(P,F,H,j,le,_,be,de=!1,ue=void 0,se=!1){this.controllerId=H,this.profileId=j,this.d=le,this.kind=_,this.runHandler=be,this.f=de,this._tag=ue,this.g=se,i.set(this,void 0),d.set(this,void 0),Je(this,i,P,"f"),Je(this,d,F,"f"),F.set(j,this);const J=L[_];if(typeof J!="number")throw new Error(`Unknown TestRunProfile.group ${_}`);Le(this,i,"f").$publishTestRunProfile({profileId:j,controllerId:H,tag:ue?s.TestTag.namespace(this.controllerId,ue.id):null,label:le,group:J,isDefault:de,hasConfigurationHandler:!1,supportsContinuousRun:se})}dispose(){Le(this,d,"f")?.delete(this.profileId)&&(Je(this,d,void 0,"f"),Le(this,i,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=K,i=new WeakMap,d=new WeakMap;const L={[h.TestRunProfileKind.Coverage]:8,[h.TestRunProfileKind.Debug]:4,[h.TestRunProfileKind.Run]:2}}),define(Ce[231],ke([1,0,18,4,5,102,8,7]),function(ie,e,r,k,D,M,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(N,E){this.i=E,this.a=new k.Emitter,this.b=new k.Emitter,this.c=new k.Emitter,this.d=new k.Emitter,this.f=new k.Emitter,this.g=new k.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=N.getProxy(D.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(f=>this.g.fire(f)),this.i.onDidChangeActiveTextEditor(f=>this.f.fire(f))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(N){const E=this.i.allEditors();return N?E:E.map(f=>f.value)}async showTextDocument(N,E,f){let b;typeof E=="number"?b={position:S.ViewColumn.from(E),preserveFocus:f}:typeof E=="object"?b={position:S.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus,selection:typeof E.selection=="object"?S.Range.from(E.selection):void 0,pinned:typeof E.preview=="boolean"?!E.preview:void 0}:b={preserveFocus:!1};const m=await this.h.$tryShowTextDocument(N.uri,b),o=m&&this.i.getEditor(m);if(o)return o.value;throw m?new Error(`Could NOT open editor for "${N.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${N.uri.toString()}".`)}createTextEditorDecorationType(N,E){return new M.TextEditorDecorationType(this.h,N,E).value}$acceptEditorPropertiesChanged(N,E){const f=this.i.getEditor(N);if(!f)throw new Error("unknown text editor");if(E.options&&f._acceptOptions(E.options),E.selections){const b=E.selections.selections.map(S.Selection.to);f._acceptSelections(b)}if(E.visibleRanges){const b=r.coalesce(E.visibleRanges.map(S.Range.to));f._acceptVisibleRanges(b)}if(E.options&&this.b.fire({textEditor:f.value,options:{...E.options,lineNumbers:S.TextEditorLineNumbersStyle.to(E.options.lineNumbers)}}),E.selections){const b=O.TextEditorSelectionChangeKind.fromValue(E.selections.source),m=E.selections.selections.map(S.Selection.to);this.a.fire({textEditor:f.value,selections:m,kind:b})}if(E.visibleRanges){const b=r.coalesce(E.visibleRanges.map(S.Range.to));this.c.fire({textEditor:f.value,visibleRanges:b})}}$acceptEditorPositionData(N){for(const E in N){const f=this.i.getEditor(E);if(!f)throw new Error("Unknown text editor");const b=S.ViewColumn.to(N[E]);f.value.viewColumn!==b&&(f._acceptViewColumn(b),this.d.fire({textEditor:f.value,viewColumn:b}))}}getDiffInformation(N){return Promise.resolve(this.h.$getDiffInformation(N))}}e.ExtHostEditors=y}),define(Ce[232],ke([1,0,2,3,5,6,7,8,25,9]),function(ie,e,r,k,D,M,S,O,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,k.createDecorator)("IExtHostTimeline");class N{constructor(b,m){this.b=new Map,this.c=new Map,this.a=b.getProxy(D.MainContext.MainThreadTimeline),m.registerArgumentProcessor({processArgument:(o,s)=>{if(o&&o.$mid===12)if(this.b.get(o.source)&&y.ExtensionIdentifier.equals(s,this.b.get(o.source)?.extension)){const h=o.uri===void 0?void 0:r.URI.revive(o.uri);return this.c.get(o.source)?.get(E(h))?.get(o.handle)}else return;return o}})}async $getTimeline(b,m,o,s){return this.b.get(b)?.provider.provideTimeline(r.URI.revive(m),o,s)}registerTimelineProvider(b,m,o,s){const h=new M.DisposableStore,p=this.d(m.id,s,h).bind(this);let w;m.onDidChange&&(w=m.onDidChange(v=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...v,id:m.id}),this));const A=this.c;return this.f({...m,scheme:b,onDidChange:void 0,async provideTimeline(v,i,d){i?.resetCache&&(h.clear(),A.get(m.id)?.clear());const n=await m.provideTimeline(v,i,d);if(n==null)return;const a=p(v,i);return{...n,source:m.id,items:n.items.map(a)}},dispose(){for(const v of A.values())v.get(m.id)?.clear();w?.dispose(),h.dispose()}},o)}d(b,m,o){return(s,h)=>{let p;if(h?.cacheResults){let w=this.c.get(b);w===void 0&&(w=new Map,this.c.set(b,w));const A=E(s);p=w.get(A),p===void 0&&(p=new Map,w.set(A,p))}return w=>{const{iconPath:A,...v}=w,i=`${b}|${w.id??w.timestamp}`;p?.set(i,w);let d,n,a;w.iconPath&&(A instanceof S.ThemeIcon?a={id:A.id,color:A.color}:r.URI.isUri(A)?(d=A,n=A):{light:d,dark:n}=A);let t;return S.MarkdownString.isMarkdownString(v.tooltip)?t=O.MarkdownString.from(v.tooltip):(0,T.isString)(v.tooltip)?t=v.tooltip:S.MarkdownString.isMarkdownString(v.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),t=O.MarkdownString.from(v.detail)):(0,T.isString)(v.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),t=v.detail),{...v,id:v.id??void 0,handle:i,source:b,command:w.command?m.toInternal(w.command,o):void 0,icon:d,iconDark:n,themeIcon:a,tooltip:t,accessibilityInformation:w.accessibilityInformation}}}}f(b,m){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:m}),(0,M.toDisposable)(()=>{for(const s of this.c.values())s.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.ExtHostTimeline=N;function E(f){return f?.toString()}}),define(Ce[233],ke([1,0,6,15,2,5]),function(ie,e,r,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class S{constructor(y){this.c=new Map,this.b=y.getProxy(M.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,T,N,E){if(this.c.has(T))throw new Error(`Opener with id '${T}' already registered`);const f=E.schemes.find(b=>!S.a.has(b));if(f)throw new Error(`Scheme '${f}' is not supported. Only http and https are currently supported.`);return this.c.set(T,N),this.b.$registerUriOpener(T,E.schemes,y,E.label),(0,r.toDisposable)(()=>{this.c.delete(T),this.b.$unregisterUriOpener(T)})}async $canOpenUri(y,T,N){const E=this.c.get(y);if(!E)throw new Error(`Unknown opener with id: ${y}`);const f=D.URI.revive(T);return E.canOpenExternalUri(f,N)}async $openUri(y,T,N){const E=this.c.get(y);if(!E)throw new Error(`Unknown opener id: '${y}'`);return E.openExternalUri(D.URI.revive(T.resolvedUri),{sourceUri:D.URI.revive(T.sourceUri)},N)}}e.ExtHostUriOpeners=S,S.a=new Set([k.Schemas.http,k.Schemas.https])}),define(Ce[234],ke([1,0,5,2,6,12,25]),function(ie,e,r,k,D,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class O{constructor(T){this.c=new Set,this.d=new Map,this.b=T.getProxy(r.MainContext.MainThreadUrls)}registerUriHandler(T,N){if(this.c.has(S.ExtensionIdentifier.toKey(T)))throw new Error(`Protocol handler already registered for extension ${T}`);const E=O.a++;return this.c.add(S.ExtensionIdentifier.toKey(T)),this.d.set(E,N),this.b.$registerUriHandler(E,T),(0,D.toDisposable)(()=>{this.c.delete(S.ExtensionIdentifier.toKey(T)),this.d.delete(E),this.b.$unregisterUriHandler(E)})}$handleExternalUri(T,N){const E=this.d.get(T);if(!E)return Promise.resolve(void 0);try{E.handleUri(k.URI.revive(N))}catch(f){(0,M.onUnexpectedError)(f)}return Promise.resolve(void 0)}async createAppUri(T){return k.URI.revive(await this.b.$createAppUri(T))}}e.ExtHostUrls=O,O.a=0});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!D:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(ie,r):D?D.value=r:e.set(ie,r),r},Le=this&&this.__classPrivateFieldGet||function(ie,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(ie):k?k.value:e.get(ie)};define(Ce[61],ke([1,0,4,15,22,2,156,179,72,5]),function(ie,e,r,k,D,M,S,O,y,T){"use strict";var N,E,f,b,m,o,s,h,p,w,A,v,i;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class d{constructor(R,V,ee,K,L,B,P){N.set(this,void 0),E.set(this,void 0),f.set(this,void 0),b.set(this,void 0),m.set(this,void 0),o.set(this,void 0),s.set(this,""),h.set(this,void 0),p.set(this,!1),w.set(this,!1),A.set(this,void 0),v.set(this,void 0),this._onMessageEmitter=new r.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,i.set(this,new r.Emitter),this._onDidDispose=Le(this,i,"f").event,Je(this,N,R,"f"),Je(this,E,V,"f"),Je(this,h,ee,"f"),Je(this,b,K,"f"),Je(this,m,L,"f"),Je(this,o,B,"f"),Je(this,A,n(B),"f"),Je(this,v,a(B),"f"),Je(this,f,P,"f")}dispose(){Je(this,p,!0,"f"),Le(this,i,"f").fire(),Le(this,i,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(R){return Je(this,w,!0,"f"),(0,y.asWebviewUri)(R,Le(this,b,"f"))}get cspSource(){const R=Le(this,o,"f").extensionLocation;if(R.scheme===k.Schemas.https||R.scheme===k.Schemas.http){let V=R.toString();return V.endsWith("/")||(V+="/"),V+" "+y.webviewGenericCspSource}return y.webviewGenericCspSource}get html(){return this.a(),Le(this,s,"f")}set html(R){this.a(),Le(this,s,"f")!==R&&(Je(this,s,R,"f"),Le(this,v,"f")&&!Le(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(R)&&(Je(this,w,!0,"f"),Le(this,f,"f").report("Webview vscode-resource: uris",Le(this,o,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Le(this,E,"f").$setHtml(Le(this,N,"f"),this.b(R)))}get options(){return this.a(),Le(this,h,"f")}set options(R){this.a(),D.equals(Le(this,h,"f"),R)||Le(this,E,"f").$setOptions(Le(this,N,"f"),c(Le(this,o,"f"),Le(this,m,"f"),R)),Je(this,h,R,"f")}async postMessage(R){if(Le(this,p,"f"))return!1;const V=(0,O.serializeWebviewMessage)(R,{serializeBuffersForPostMessage:Le(this,A,"f")});return Le(this,E,"f").$postMessage(Le(this,N,"f"),V.message,...V.buffers)}a(){if(Le(this,p,"f"))throw new Error("Webview is disposed")}b(R){if(!Le(this,v,"f"))return R;const V=Le(this,o,"f").extensionLocation?.scheme===k.Schemas.vscodeRemote,ee=Le(this,o,"f").extensionLocation.scheme===k.Schemas.vscodeRemote?Le(this,o,"f").extensionLocation.authority:void 0;return R.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(K,L,B,P,F,H)=>{const j=M.URI.from({scheme:P||"file",path:decodeURIComponent(F)}),le=(0,y.asWebviewUri)(j,{isRemote:V,authority:ee}).toString();return`${L}${le}${H}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(K,L,B,P,F,H)=>{const j=M.URI.from({scheme:P||"file",path:decodeURIComponent(F)}),le=(0,y.asWebviewUri)(j,{isRemote:V,authority:ee}).toString();return`${L}${le}${H}`})}}e.ExtHostWebview=d,N=new WeakMap,E=new WeakMap,f=new WeakMap,b=new WeakMap,m=new WeakMap,o=new WeakMap,s=new WeakMap,h=new WeakMap,p=new WeakMap,w=new WeakMap,A=new WeakMap,v=new WeakMap,i=new WeakMap;function n(C){try{const R=(0,S.normalizeVersion)((0,S.parseVersion)(C.engines.vscode));return!!R&&R.majorBase>=1&&R.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=n;function a(C){try{const R=(0,S.normalizeVersion)((0,S.parseVersion)(C.engines.vscode));return R?R.majorBase<1||R.majorBase===1&&R.minorBase<60:!1}catch{return!1}}class t{constructor(R,V,ee,K,L){this.c=V,this.d=ee,this.e=K,this.f=L,this.b=new Map,this.a=R.getProxy(T.MainContext.MainThreadWebviews)}$onMessage(R,V,ee){const K=this.g(R);if(K){const{message:L}=(0,O.deserializeWebviewMessage)(V,ee.value);K._onMessageEmitter.fire(L)}}$onMissingCsp(R,V){this.e.warn(`${V} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(R,V,ee){const K=new d(R,this.a,u(V),this.c,this.d,ee,this.f);return this.b.set(R,K),K._onDidDispose(()=>{this.b.delete(R)}),K}deleteWebview(R){this.b.delete(R)}g(R){return this.b.get(R)}}e.ExtHostWebviews=t;function g(C){return{id:C.identifier,location:C.extensionLocation}}e.toExtensionData=g;function c(C,R,V){return{enableCommandUris:V.enableCommandUris,enableScripts:V.enableScripts,enableForms:V.enableForms,portMapping:V.portMapping,localResourceRoots:V.localResourceRoots||l(C,R)}}e.serializeWebviewOptions=c;function u(C){return{enableCommandUris:C.enableCommandUris,enableScripts:C.enableScripts,enableForms:C.enableForms,portMapping:C.portMapping,localResourceRoots:C.localResourceRoots?.map(R=>M.URI.from(R))}}function l(C,R){return[...(R?.getWorkspaceFolders()||[]).map(V=>V.uri),C.extensionLocation]}}),define(Ce[235],ke([1,0,21,230,6,15,24,2,8,61,53,5,7]),function(ie,e,r,k,D,M,S,O,y,T,N,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class b{constructor(d,n){this.document=d,this.b=n,this.a=1,this.c=new N.Cache("custom documents")}addEdit(d){return this.c.add([d])}async undo(d,n){await this.f(d).undo(),n||this.disposeBackup()}async redo(d,n){await this.f(d).redo(),n||this.disposeBackup()}disposeEdits(d){for(const n of d)this.c.delete(n)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const d=v(this.document.uri)+this.a++;return(0,S.joinPath)(this.b,d)}updateBackup(d){this.d?.delete(),this.d=d}disposeBackup(){this.d?.delete(),this.d=void 0}f(d){const n=this.c.get(d,0);if(!n)throw new Error("No edit found");return n}}class m{constructor(){this.a=new Map}get(d,n){return this.a.get(this.b(d,n))}add(d,n,a){const t=this.b(d,n.uri);if(this.a.has(t))throw new Error(`Document already exists for viewType:${d} resource:${n.uri}`);const g=new b(n,a);return this.a.set(t,g),g}delete(d,n){const a=this.b(d,n.uri);this.a.delete(a)}b(d,n){return`${d}@@@${n}`}}var o;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(o||(o={}));class s{constructor(){this.a=new Map}addTextProvider(d,n,a){return this.b(0,d,n,a)}addCustomProvider(d,n,a){return this.b(1,d,n,a)}get(d){return this.a.get(d)}b(d,n,a,t){if(this.a.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this.a.set(n,{type:d,extension:a,provider:t}),new f.Disposable(()=>this.a.delete(n))}}class h{constructor(d,n,a,t,g){this.d=n,this.f=a,this.g=t,this.h=g,this.b=new s,this.c=new m,this.a=d.getProxy(E.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(d,n,a,t){const g=new D.DisposableStore;return w(a)?(g.add(this.b.addTextProvider(n,d,a)),this.a.$registerTextEditorProvider((0,T.toExtensionData)(d),n,t.webviewOptions||{},{supportsMove:!!a.moveCustomTextEditor},(0,T.shouldSerializeBuffersForPostMessage)(d))):(g.add(this.b.addCustomProvider(n,d,a)),p(a)&&g.add(a.onDidChangeCustomDocument(c=>{const u=this.i(n,c.document.uri);if(A(c)){const l=u.addEdit(c);this.a.$onDidEdit(c.document.uri,n,l,c.label)}else this.a.$onContentChange(c.document.uri,n)})),this.a.$registerCustomEditorProvider((0,T.toExtensionData)(d),n,t.webviewOptions||{},!!t.supportsMultipleEditorsPerDocument,(0,T.shouldSerializeBuffersForPostMessage)(d))),f.Disposable.from(g,new f.Disposable(()=>{this.a.$unregisterEditorProvider(n)}))}async $createCustomDocument(d,n,a,t,g){const c=this.b.get(n);if(!c)throw new Error(`No provider found for '${n}'`);if(c.type!==1)throw new Error(`Invalid provide type for '${n}'`);const u=O.URI.revive(d),l=await c.provider.openCustomDocument(u,{backupId:a,untitledDocumentData:t?.buffer},g);let C;return p(c.provider)&&this.f&&(C=this.f.workspaceValue(c.extension)??this.f.globalValue(c.extension)),this.c.add(n,l,C),{editable:p(c.provider)}}async $disposeCustomDocument(d,n){const a=this.b.get(n);if(!a)throw new Error(`No provider found for '${n}'`);if(a.type!==1)throw new Error(`Invalid provider type for '${n}'`);const t=O.URI.revive(d),{document:g}=this.i(n,t);this.c.delete(n,g),g.dispose()}async $resolveCustomEditor(d,n,a,t,g,c){const u=this.b.get(a);if(!u)throw new Error(`No provider found for '${a}'`);const l=y.ViewColumn.to(g),C=this.g.createNewWebview(n,t.contentOptions,u.extension),R=this.h.createNewWebviewPanel(n,a,t.title,l,t.options,C,!0),V=O.URI.revive(d);switch(u.type){case 1:{const{document:ee}=this.i(a,V);return u.provider.resolveCustomEditor(ee,R,c)}case 0:{const ee=this.d.getDocument(V);return u.provider.resolveCustomTextEditor(ee,R,c)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(d,n,a){this.i(n,d).disposeEdits(a)}async $onMoveCustomEditor(d,n,a){const t=this.b.get(a);if(!t)throw new Error(`No provider found for '${a}'`);if(!t.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${a}'`);const g=this.h.getWebviewPanel(d);if(!g)throw new Error("No webview found");const c=O.URI.revive(n),u=this.d.getDocument(c);await t.provider.moveCustomTextEditor(u,g,r.CancellationToken.None)}async $undo(d,n,a,t){return this.i(n,d).undo(a,t)}async $redo(d,n,a,t){return this.i(n,d).redo(a,t)}async $revert(d,n,a){const t=this.i(n,d);await this.j(n).revertCustomDocument(t.document,a),t.disposeBackup()}async $onSave(d,n,a){const t=this.i(n,d);await this.j(n).saveCustomDocument(t.document,a),t.disposeBackup()}async $onSaveAs(d,n,a,t){const g=this.i(n,d);return this.j(n).saveCustomDocumentAs(g.document,O.URI.revive(a),t)}async $backup(d,n,a){const t=this.i(n,d),c=await this.j(n).backupCustomDocument(t.document,{destination:t.getNewBackupUri()},a);return t.updateBackup(c),c.id}i(d,n){const a=this.c.get(d,O.URI.revive(n));if(!a)throw new Error("No custom document found");return a}j(d){const a=this.b.get(d)?.provider;if(!a||!p(a))throw new Error("Custom document is not editable");return a}}e.ExtHostCustomEditors=h;function p(i){return!!i.onDidChangeCustomDocument}function w(i){return typeof i.resolveCustomTextEditor=="function"}function A(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function v(i){const d=i.scheme===M.Schemas.file||i.scheme===M.Schemas.untitled?i.fsPath:i.toString();return(0,k.hash)(d)+""}});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!D:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(ie,r):D?D.value=r:e.set(ie,r),r},Le=this&&this.__classPrivateFieldGet||function(ie,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(ie):k?k.value:e.get(ie)};define(Ce[236],ke([1,0,4,6,2,34,8,61,5,7]),function(ie,e,r,k,D,M,S,O,y,T){"use strict";var N,E,f,b,m,o,s,h,p,w,A,v,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class d extends k.Disposable{constructor(g,c,u,l){super(),N.set(this,void 0),E.set(this,void 0),f.set(this,void 0),b.set(this,void 0),m.set(this,void 0),o.set(this,void 0),s.set(this,void 0),h.set(this,void 0),p.set(this,!0),w.set(this,void 0),A.set(this,!1),v.set(this,this.B(new r.Emitter)),this.onDidDispose=Le(this,v,"f").event,i.set(this,this.B(new r.Emitter)),this.onDidChangeViewState=Le(this,i,"f").event,Je(this,N,g,"f"),Je(this,E,c,"f"),Je(this,b,u,"f"),Je(this,f,l.viewType,"f"),Je(this,m,l.panelOptions,"f"),Je(this,h,l.viewColumn,"f"),Je(this,o,l.title,"f"),Je(this,w,l.active,"f")}dispose(){Le(this,A,"f")||(Je(this,A,!0,"f"),Le(this,v,"f").fire(),Le(this,E,"f").$disposeWebview(Le(this,N,"f")),Le(this,b,"f").dispose(),super.dispose())}get webview(){return this.c(),Le(this,b,"f")}get viewType(){return this.c(),Le(this,f,"f")}get title(){return this.c(),Le(this,o,"f")}set title(g){this.c(),Le(this,o,"f")!==g&&(Je(this,o,g,"f"),Le(this,E,"f").$setTitle(Le(this,N,"f"),g))}get iconPath(){return this.c(),Le(this,s,"f")}set iconPath(g){this.c(),Le(this,s,"f")!==g&&(Je(this,s,g,"f"),Le(this,E,"f").$setIconPath(Le(this,N,"f"),D.URI.isUri(g)?{light:g,dark:g}:g))}get options(){return Le(this,m,"f")}get viewColumn(){if(this.c(),!(typeof Le(this,h,"f")=="number"&&Le(this,h,"f")<0))return Le(this,h,"f")}get active(){return this.c(),Le(this,w,"f")}get visible(){return this.c(),Le(this,p,"f")}_updateViewState(g){Le(this,A,"f")||(this.active!==g.active||this.visible!==g.visible||this.viewColumn!==g.viewColumn)&&(Je(this,w,g.active,"f"),Je(this,p,g.visible,"f"),Je(this,h,g.viewColumn,"f"),Le(this,i,"f").fire({webviewPanel:this}))}reveal(g,c){this.c(),Le(this,E,"f").$reveal(Le(this,N,"f"),{viewColumn:typeof g>"u"?void 0:S.ViewColumn.from(g),preserveFocus:!!c})}c(){if(Le(this,A,"f"))throw new Error("Webview is disposed")}}N=new WeakMap,E=new WeakMap,f=new WeakMap,b=new WeakMap,m=new WeakMap,o=new WeakMap,s=new WeakMap,h=new WeakMap,p=new WeakMap,w=new WeakMap,A=new WeakMap,v=new WeakMap,i=new WeakMap;class n{static c(){return(0,M.generateUuid)()}constructor(g,c,u){this.g=c,this.h=u,this.e=new Map,this.f=new Map,this.d=g.getProxy(y.MainContext.MainThreadWebviewPanels)}createWebviewPanel(g,c,u,l,C={}){const R=typeof l=="object"?l.viewColumn:l,V={viewColumn:S.ViewColumn.from(R),preserveFocus:typeof l=="object"&&!!l.preserveFocus},ee=(0,O.shouldSerializeBuffersForPostMessage)(g),K=n.c();this.d.$createWebviewPanel((0,O.toExtensionData)(g),K,c,{title:u,panelOptions:a(C),webviewOptions:(0,O.serializeWebviewOptions)(g,this.h,C),serializeBuffersForPostMessage:ee},V);const L=this.g.createNewWebview(K,C,g);return this.createNewWebviewPanel(K,c,u,R,C,L,!0)}$onDidChangeWebviewPanelViewStates(g){const c=Object.keys(g);c.sort((u,l)=>{const C=g[u],R=g[l];return C.active?1:R.active?-1:+C.visible-+R.visible});for(const u of c){const l=this.getWebviewPanel(u);if(!l)continue;const C=g[u];l._updateViewState({active:C.active,visible:C.visible,viewColumn:S.ViewColumn.to(C.position)})}}async $onDidDisposeWebviewPanel(g){this.getWebviewPanel(g)?.dispose(),this.e.delete(g),this.g.deleteWebview(g)}registerWebviewPanelSerializer(g,c,u){if(this.f.has(c))throw new Error(`Serializer for '${c}' already registered`);return this.f.set(c,{serializer:u,extension:g}),this.d.$registerSerializer(c,{serializeBuffersForPostMessage:(0,O.shouldSerializeBuffersForPostMessage)(g)}),new T.Disposable(()=>{this.f.delete(c),this.d.$unregisterSerializer(c)})}async $deserializeWebviewPanel(g,c,u,l){const C=this.f.get(c);if(!C)throw new Error(`No serializer found for '${c}'`);const{serializer:R,extension:V}=C,ee=this.g.createNewWebview(g,u.webviewOptions,V),K=this.createNewWebviewPanel(g,c,u.title,l,u.panelOptions,ee,u.active);await R.deserializeWebviewPanel(K,u.state)}createNewWebviewPanel(g,c,u,l,C,R,V){const ee=new d(g,this.d,R,{viewType:c,title:u,viewColumn:l,panelOptions:C,active:V});return this.e.set(g,ee),ee}getWebviewPanel(g){return this.e.get(g)}}e.ExtHostWebviewPanels=n;function a(t){return{enableFindWidget:t.enableFindWidget,retainContextWhenHidden:t.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!D:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(ie,r):D?D.value=r:e.set(ie,r),r},Le=this&&this.__classPrivateFieldGet||function(ie,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(ie):k?k.value:e.get(ie)};define(Ce[237],ke([1,0,4,6,61,8,5,7]),function(ie,e,r,k,D,M,S,O){"use strict";var y,T,N,E,f,b,m,o,s,h,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends k.Disposable{constructor(i,d,n,a,t,g){super(),y.set(this,void 0),T.set(this,void 0),N.set(this,void 0),E.set(this,void 0),f.set(this,!1),b.set(this,void 0),m.set(this,void 0),o.set(this,void 0),s.set(this,void 0),h.set(this,this.B(new r.Emitter)),this.onDidChangeVisibility=Le(this,h,"f").event,p.set(this,this.B(new r.Emitter)),this.onDidDispose=Le(this,p,"f").event,Je(this,N,n,"f"),Je(this,m,a,"f"),Je(this,y,i,"f"),Je(this,T,d,"f"),Je(this,E,t,"f"),Je(this,b,g,"f")}dispose(){Le(this,f,"f")||(Je(this,f,!0,"f"),Le(this,p,"f").fire(),Le(this,E,"f").dispose(),super.dispose())}get title(){return this.a(),Le(this,m,"f")}set title(i){this.a(),Le(this,m,"f")!==i&&(Je(this,m,i,"f"),Le(this,T,"f").$setWebviewViewTitle(Le(this,y,"f"),i))}get description(){return this.a(),Le(this,o,"f")}set description(i){this.a(),Le(this,o,"f")!==i&&(Je(this,o,i,"f"),Le(this,T,"f").$setWebviewViewDescription(Le(this,y,"f"),i))}get visible(){return Le(this,b,"f")}get webview(){return Le(this,E,"f")}get viewType(){return Le(this,N,"f")}_setVisible(i){i===Le(this,b,"f")||Le(this,f,"f")||(Je(this,b,i,"f"),Le(this,h,"f").fire())}get badge(){return this.a(),Le(this,s,"f")}set badge(i){this.a(),!(i?.value===Le(this,s,"f")?.value&&i?.tooltip===Le(this,s,"f")?.tooltip)&&(Je(this,s,M.ViewBadge.from(i),"f"),Le(this,T,"f").$setWebviewViewBadge(Le(this,y,"f"),i))}show(i){this.a(),Le(this,T,"f").$show(Le(this,y,"f"),!!i)}a(){if(Le(this,f,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,T=new WeakMap,N=new WeakMap,E=new WeakMap,f=new WeakMap,b=new WeakMap,m=new WeakMap,o=new WeakMap,s=new WeakMap,h=new WeakMap,p=new WeakMap;class A{constructor(i,d){this.d=d,this.b=new Map,this.c=new Map,this.a=i.getProxy(S.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(i,d,n,a){if(this.b.has(d))throw new Error(`View provider for '${d}' already registered`);return this.b.set(d,{provider:n,extension:i}),this.a.$registerWebviewViewProvider((0,D.toExtensionData)(i),d,{retainContextWhenHidden:a?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(i)}),new O.Disposable(()=>{this.b.delete(d),this.a.$unregisterWebviewViewProvider(d)})}async $resolveWebviewView(i,d,n,a,t){const g=this.b.get(d);if(!g)throw new Error(`No view provider found for '${d}'`);const{provider:c,extension:u}=g,l=this.d.createNewWebview(i,{},u),C=new w(i,this.a,d,n,l,!0);this.c.set(i,C),await c.resolveWebviewView(C,{state:a},t)}async $onDidChangeWebviewViewVisibility(i,d){this.e(i)._setVisible(d)}async $disposeWebviewView(i){const d=this.e(i);this.c.delete(i),d.dispose(),this.d.deleteWebview(i)}e(i){const d=this.c.get(i);if(!d)throw new Error("No webview found");return d}}e.ExtHostWebviewViews=A}),define(Ce[104],ke([1,0,4,5,2,15,10,3,17]),function(ie,e,r,k,D,M,S,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let T=class an{get state(){return this.d}constructor(E){this.c=new r.Emitter,this.onDidChangeWindowState=this.c.event,this.d=an.a,this.b=E.getProxy(k.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(f=>this.$onDidChangeWindowFocus(f))}$onDidChangeWindowFocus(E){E!==this.d.focused&&(this.d={...this.d,focused:E},this.c.fire(this.d))}openUri(E,f){let b;if(typeof E=="string"){b=E;try{E=D.URI.parse(E)}catch{return Promise.reject(`Invalid uri - '${E}'`)}}return(0,S.isFalsyOrWhitespace)(E.scheme)?Promise.reject("Invalid scheme - cannot be empty"):E.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${E.scheme}'`):this.b.$openUri(E,b,f)}async asExternalUri(E,f){if((0,S.isFalsyOrWhitespace)(E.scheme))return Promise.reject("Invalid scheme - cannot be empty");const b=await this.b.$asExternalUri(E,f);return D.URI.from(b)}};T.a={focused:!0},T=qe([je(0,y.IExtHostRpcService)],T),e.ExtHostWindow=T,e.IExtHostWindow=(0,O.createDecorator)("IExtHostWindow")}),define(Ce[238],ke([1,0,208,26,17]),function(ie,e,r,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let M=class extends r.AbstractExtHostConsoleForwarder{constructor(O,y){super(O,y)}f(O,y,T){y.apply(console,T)}};M=qe([je(0,D.IExtHostRpcService),je(1,k.IExtHostInitDataService)],M),e.ExtHostConsoleForwarder=M}),define(Ce[239],ke([1,0,16,23,21,12,4,6,127,202,45]),function(ie,e,r,k,D,M,S,O,y,T,N){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function f(C,R){try{return JSON.stringify(C,R)}catch{return"null"}}const b="$$ref$$",m={[b]:-1};class o{constructor(R,V){this.jsonString=R,this.referencedBuffers=V}}function s(C,R=null,V=!1){const ee=[];return{jsonString:(V?f:JSON.stringify)(C,(L,B)=>{if(typeof B>"u")return m;if(typeof B=="object"){if(B instanceof k.VSBuffer){const P=ee.push(B)-1;return{[b]:P}}if(R)return R(L,B)}return B}),referencedBuffers:ee}}e.stringifyJsonWithBufferRefs=s;function h(C,R,V){return JSON.parse(C,(ee,K)=>{if(K){const L=K[b];if(typeof L=="number")return R[L];if(V&&K.$mid===1)return V.transformIncoming(K)}return K})}e.parseJsonAndRestoreBufferRefs=h;function p(C,R){return JSON.stringify(C,R)}function w(C){return C?(R,V)=>V&&V.$mid===1?C.transformOutgoing(V):V:null}var A;(function(C){C[C.LocalSide=0]="LocalSide",C[C.OtherSide=1]="OtherSide"})(A=e.RequestInitiator||(e.RequestInitiator={}));var v;(function(C){C[C.Responsive=0]="Responsive",C[C.Unresponsive=1]="Unresponsive"})(v=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},d=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class a extends O.Disposable{constructor(R,V=null,ee=null){super(),this[E]=!0,this.b=this.B(new S.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=R,this.f=V,this.g=ee,this.h=w(this.g),this.j=!1,this.k=[],this.l=[];for(let K=0,L=N.ProxyIdentifier.count;K<L;K++)this.k[K]=null,this.l[K]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new r.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(K=>this.G(K))}dispose(){this.j=!0,Object.keys(this.s).forEach(R=>{this.s[R].resolveErr(M.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(R){this.u===0&&(this.v=Date.now()+a.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(R){this.v=Date.now()+a.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(R){this.t!==R&&(this.t=R,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(R){return this.g?(0,y.transformIncomingURIs)(R,this.g):R}getProxy(R){const{nid:V,sid:ee}=R;return this.l[V]||(this.l[V]=this.F(V,ee)),this.l[V]}F(R,V){const ee={get:(K,L)=>(typeof L=="string"&&!K[L]&&L.charCodeAt(0)===36&&(K[L]=(...B)=>this.O(R,L,B)),L===n?V:K[L])};return new Proxy(Object.create(null),ee)}set(R,V){return this.k[R.nid]=V,V}assertRegistered(R){for(let V=0,ee=R.length;V<ee;V++){const K=R[V];if(!this.k[K.nid])throw new Error(`Missing proxy instance ${K.sid}`)}}G(R){if(this.j)return;const V=R.byteLength,ee=t.read(R,0),K=ee.readUInt8(),L=ee.readUInt32();switch(K){case 1:case 2:{let{rpcId:B,method:P,args:F}=c.deserializeRequestJSONArgs(ee);this.g&&(F=(0,y.transformIncomingURIs)(F,this.g)),this.H(V,L,B,P,F,K===2);break}case 3:case 4:{let{rpcId:B,method:P,args:F}=c.deserializeRequestMixedArgs(ee);this.g&&(F=(0,y.transformIncomingURIs)(F,this.g)),this.H(V,L,B,P,F,K===4);break}case 5:{this.f?.logIncoming(V,L,0,"ack"),this.z(L);break}case 6:{this.I(V,L);break}case 7:{this.J(V,L,void 0);break}case 9:{let B=c.deserializeReplyOKJSON(ee);this.g&&(B=(0,y.transformIncomingURIs)(B,this.g)),this.J(V,L,B);break}case 10:{const B=c.deserializeReplyOKJSONWithBuffers(ee,this.g);this.J(V,L,B);break}case 8:{const B=c.deserializeReplyOKVSBuffer(ee);this.J(V,L,B);break}case 11:{let B=c.deserializeReplyErrError(ee);this.g&&(B=(0,y.transformIncomingURIs)(B,this.g)),this.L(V,L,B);break}case 12:{this.L(V,L,void 0);break}default:console.error("received unexpected message"),console.error(R)}}H(R,V,ee,K,L,B){this.f?.logIncoming(R,V,1,`receiveRequest ${(0,N.getStringIdentifierForProxy)(ee)}.${K}(`,L);const P=String(V);let F,H;if(B){const le=new D.CancellationTokenSource;L.push(le.token),F=this.M(ee,K,L),H=()=>le.cancel()}else F=this.M(ee,K,L),H=i;this.p[P]=H;const j=c.serializeAcknowledged(V);this.f?.logOutgoing(j.byteLength,V,1,"ack"),this.c.send(j),F.then(le=>{delete this.p[P];const _=c.serializeReplyOK(V,le,this.h);this.f?.logOutgoing(_.byteLength,V,1,"reply:",le),this.c.send(_)},le=>{delete this.p[P];const _=c.serializeReplyErr(V,le);this.f?.logOutgoing(_.byteLength,V,1,"replyErr:",le),this.c.send(_)})}I(R,V){this.f?.logIncoming(R,V,1,"receiveCancel");const ee=String(V);this.p[ee]?.()}J(R,V,ee){this.f?.logIncoming(R,V,0,"receiveReply:",ee);const K=String(V);if(!this.s.hasOwnProperty(K))return;const L=this.s[K];delete this.s[K],L.resolveOk(ee)}L(R,V,ee){this.f?.logIncoming(R,V,0,"receiveReplyErr:",ee);const K=String(V);if(!this.s.hasOwnProperty(K))return;const L=this.s[K];delete this.s[K];let B;ee&&(ee.$isError?(B=new Error,B.name=ee.name,B.message=ee.message,B.stack=ee.stack):B=ee),L.resolveErr(B)}M(R,V,ee){try{return Promise.resolve(this.N(R,V,ee))}catch(K){return Promise.reject(K)}}N(R,V,ee){const K=this.k[R];if(!K)throw new Error("Unknown actor "+(0,N.getStringIdentifierForProxy)(R));const L=K[V];if(typeof L!="function")throw new Error("Unknown method "+V+" on actor "+(0,N.getStringIdentifierForProxy)(R));return L.apply(K,ee)}O(R,V,ee){if(this.j)return new T.CanceledLazyPromise;let K=null;if(ee.length>0&&D.CancellationToken.isCancellationToken(ee[ee.length-1])&&(K=ee.pop()),K&&K.isCancellationRequested)return Promise.reject(M.canceled());const L=c.serializeRequestArguments(ee,this.h),B=++this.m,P=String(B),F=new T.LazyPromise;K&&K.onCancellationRequested(()=>{const j=c.serializeCancel(B);this.f?.logOutgoing(j.byteLength,B,0,"cancel"),this.c.send(c.serializeCancel(B))}),this.s[P]=F,this.y(B);const H=c.serializeRequest(B,R,V,L,!!K);return this.f?.logOutgoing(H.byteLength,B,0,`request: ${(0,N.getStringIdentifierForProxy)(R)}.${V}(`,ee),this.c.send(H),F}}e.RPCProtocol=a,E=d,a.a=3*1e3;class t{static alloc(R,V,ee){const K=new t(k.VSBuffer.alloc(ee+1+4),0);return K.writeUInt8(R),K.writeUInt32(V),K}static read(R,V){return new t(R,V)}get buffer(){return this.a}constructor(R,V){this.a=R,this.b=V}static sizeUInt8(){return 1}writeUInt8(R){this.a.writeUInt8(R,this.b),this.b+=1}readUInt8(){const R=this.a.readUInt8(this.b);return this.b+=1,R}writeUInt32(R){this.a.writeUInt32BE(R,this.b),this.b+=4}readUInt32(){const R=this.a.readUInt32BE(this.b);return this.b+=4,R}static sizeShortString(R){return 1+R.byteLength}writeShortString(R){this.a.writeUInt8(R.byteLength,this.b),this.b+=1,this.a.set(R,this.b),this.b+=R.byteLength}readShortString(){const R=this.a.readUInt8(this.b);this.b+=1;const ee=this.a.slice(this.b,this.b+R).toString();return this.b+=R,ee}static sizeLongString(R){return 4+R.byteLength}writeLongString(R){this.a.writeUInt32BE(R.byteLength,this.b),this.b+=4,this.a.set(R,this.b),this.b+=R.byteLength}readLongString(){const R=this.a.readUInt32BE(this.b);this.b+=4;const ee=this.a.slice(this.b,this.b+R).toString();return this.b+=R,ee}writeBuffer(R){this.a.writeUInt32BE(R.byteLength,this.b),this.b+=4,this.a.set(R,this.b),this.b+=R.byteLength}static sizeVSBuffer(R){return 4+R.byteLength}writeVSBuffer(R){this.a.writeUInt32BE(R.byteLength,this.b),this.b+=4,this.a.set(R,this.b),this.b+=R.byteLength}readVSBuffer(){const R=this.a.readUInt32BE(this.b);this.b+=4;const V=this.a.slice(this.b,this.b+R);return this.b+=R,V}static sizeMixedArray(R){let V=0;V+=1;for(let ee=0,K=R.length;ee<K;ee++){const L=R[ee];switch(V+=1,L.type){case 1:V+=this.sizeLongString(L.value);break;case 2:V+=this.sizeVSBuffer(L.value);break;case 3:V+=this.sizeUInt32,V+=this.sizeLongString(L.value);for(let B=0;B<L.buffers.length;++B)V+=this.sizeVSBuffer(L.buffers[B]);break;case 4:break}}return V}writeMixedArray(R){this.a.writeUInt8(R.length,this.b),this.b+=1;for(let V=0,ee=R.length;V<ee;V++){const K=R[V];switch(K.type){case 1:this.writeUInt8(1),this.writeLongString(K.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(K.value);break;case 3:this.writeUInt8(3),this.writeUInt32(K.buffers.length),this.writeLongString(K.value);for(let L=0;L<K.buffers.length;++L)this.writeBuffer(K.buffers[L]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const R=this.a.readUInt8(this.b);this.b+=1;const V=new Array(R);for(let ee=0;ee<R;ee++)switch(this.readUInt8()){case 1:V[ee]=this.readLongString();break;case 2:V[ee]=this.readVSBuffer();break;case 3:{const L=this.readUInt32(),B=this.readLongString(),P=[];for(let F=0;F<L;++F)P.push(this.readVSBuffer());V[ee]=new N.SerializableObjectWithBuffers(h(B,P,null));break}case 4:V[ee]=void 0;break}return V}}t.sizeUInt32=4;var g;(function(C){C[C.Simple=0]="Simple",C[C.Mixed=1]="Mixed"})(g||(g={}));class c{static a(R){for(let V=0,ee=R.length;V<ee;V++)if(R[V]instanceof k.VSBuffer||R[V]instanceof N.SerializableObjectWithBuffers||typeof R[V]>"u")return!0;return!1}static serializeRequestArguments(R,V){if(this.a(R)){const ee=[];for(let K=0,L=R.length;K<L;K++){const B=R[K];if(B instanceof k.VSBuffer)ee[K]={type:2,value:B};else if(typeof B>"u")ee[K]={type:4};else if(B instanceof N.SerializableObjectWithBuffers){const{jsonString:P,referencedBuffers:F}=s(B.value,V);ee[K]={type:3,value:k.VSBuffer.fromString(P),buffers:F}}else ee[K]={type:1,value:k.VSBuffer.fromString(p(B,V))}}return{type:1,args:ee}}return{type:0,args:p(R,V)}}static serializeRequest(R,V,ee,K,L){switch(K.type){case 0:return this.b(R,V,ee,K.args,L);case 1:return this.c(R,V,ee,K.args,L)}}static b(R,V,ee,K,L){const B=k.VSBuffer.fromString(ee),P=k.VSBuffer.fromString(K);let F=0;F+=t.sizeUInt8(),F+=t.sizeShortString(B),F+=t.sizeLongString(P);const H=t.alloc(L?2:1,R,F);return H.writeUInt8(V),H.writeShortString(B),H.writeLongString(P),H.buffer}static deserializeRequestJSONArgs(R){const V=R.readUInt8(),ee=R.readShortString(),K=R.readLongString();return{rpcId:V,method:ee,args:JSON.parse(K)}}static c(R,V,ee,K,L){const B=k.VSBuffer.fromString(ee);let P=0;P+=t.sizeUInt8(),P+=t.sizeShortString(B),P+=t.sizeMixedArray(K);const F=t.alloc(L?4:3,R,P);return F.writeUInt8(V),F.writeShortString(B),F.writeMixedArray(K),F.buffer}static deserializeRequestMixedArgs(R){const V=R.readUInt8(),ee=R.readShortString(),K=R.readMixedArray(),L=new Array(K.length);for(let B=0,P=K.length;B<P;B++){const F=K[B];typeof F=="string"?L[B]=JSON.parse(F):L[B]=F}return{rpcId:V,method:ee,args:L}}static serializeAcknowledged(R){return t.alloc(5,R,0).buffer}static serializeCancel(R){return t.alloc(6,R,0).buffer}static serializeReplyOK(R,V,ee){if(typeof V>"u")return this.d(R);if(V instanceof k.VSBuffer)return this.e(R,V);if(V instanceof N.SerializableObjectWithBuffers){const{jsonString:K,referencedBuffers:L}=s(V.value,ee,!0);return this.g(R,K,L)}else return this.f(R,f(V,ee))}static d(R){return t.alloc(7,R,0).buffer}static e(R,V){let ee=0;ee+=t.sizeVSBuffer(V);const K=t.alloc(8,R,ee);return K.writeVSBuffer(V),K.buffer}static deserializeReplyOKVSBuffer(R){return R.readVSBuffer()}static f(R,V){const ee=k.VSBuffer.fromString(V);let K=0;K+=t.sizeLongString(ee);const L=t.alloc(9,R,K);return L.writeLongString(ee),L.buffer}static g(R,V,ee){const K=k.VSBuffer.fromString(V);let L=0;L+=t.sizeUInt32,L+=t.sizeLongString(K);for(const P of ee)L+=t.sizeVSBuffer(P);const B=t.alloc(10,R,L);B.writeUInt32(ee.length),B.writeLongString(K);for(const P of ee)B.writeBuffer(P);return B.buffer}static deserializeReplyOKJSON(R){const V=R.readLongString();return JSON.parse(V)}static deserializeReplyOKJSONWithBuffers(R,V){const ee=R.readUInt32(),K=R.readLongString(),L=[];for(let B=0;B<ee;++B)L.push(R.readVSBuffer());return new N.SerializableObjectWithBuffers(h(K,L,V))}static serializeReplyErr(R,V){const ee=V?f(M.transformErrorForSerialization(V),null):void 0;if(typeof ee!="string")return this.h(R);const K=k.VSBuffer.fromString(ee);let L=0;L+=t.sizeLongString(K);const B=t.alloc(11,R,L);return B.writeLongString(K),B.buffer}static deserializeReplyErrError(R){const V=R.readLongString();return JSON.parse(V)}static h(R){return t.alloc(12,R,0).buffer}}var u;(function(C){C[C.RequestJSONArgs=1]="RequestJSONArgs",C[C.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",C[C.RequestMixedArgs=3]="RequestMixedArgs",C[C.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",C[C.Acknowledged=5]="Acknowledged",C[C.Cancel=6]="Cancel",C[C.ReplyOKEmpty=7]="ReplyOKEmpty",C[C.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",C[C.ReplyOKJSON=9]="ReplyOKJSON",C[C.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",C[C.ReplyErrError=11]="ReplyErrError",C[C.ReplyErrEmpty=12]="ReplyErrEmpty"})(u||(u={}));var l;(function(C){C[C.String=1]="String",C[C.VSBuffer=2]="VSBuffer",C[C.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",C[C.Undefined=4]="Undefined"})(l||(l={}))}),define(Ce[240],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const r=function(M){const S=O=>{self.removeEventListener("message",S);const y=O.data;Object.defineProperties(self,{postMessage:{value(T,N){y.postMessage(T,N)}},onmessage:{get(){return y.onmessage},set(T){y.onmessage=T}}}),y.addEventListener("message",T=>{self.dispatchEvent(new MessageEvent("message",{data:T.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};self.addEventListener("message",S)}.toString();class k extends EventTarget{constructor(M,S,O){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${r})('${S}'))`,T=new Blob([y],{type:"application/javascript"}),N=URL.createObjectURL(T),E=new MessageChannel,f=N,b={type:"_newWorker",id:f,port:E.port2,url:N,options:O};M(b,[E.port2]),this.postMessage=E.port1.postMessage.bind(E.port1),this.terminate=()=>{M({type:"_terminateWorker",id:f}),URL.revokeObjectURL(N),E.port1.close(),E.port2.close()},Object.defineProperties(this,{onmessage:{get(){return E.port1.onmessage},set(m){E.port1.onmessage=m}},onmessageerror:{get(){return E.port1.onmessageerror},set(m){E.port1.onmessageerror=m}}}),E.port1.addEventListener("messageerror",m=>{const o=new MessageEvent("messageerror",{data:m.data});this.dispatchEvent(o)}),E.port1.addEventListener("message",m=>{const o=new MessageEvent("message",{data:m.data});this.dispatchEvent(o)}),E.port1.start()}}e.NestedWorker=k}),define(Ce[241],ke([1,0,4,30,42,3]),function(ie,e,r,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new D.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new D.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new D.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,M.createDecorator)(e.OUTPUT_SERVICE_ID);var S;(function(y){y[y.Append=1]="Append",y[y.Replace=2]="Replace",y[y.Clear=3]="Clear"})(S=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class O{constructor(){this.a=new Map,this.b=new r.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new r.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(T){this.a.has(T.id)||(this.a.set(T.id,T),this.b.fire(T.id))}getChannels(){const T=[];return this.a.forEach(N=>T.push(N)),T}getChannel(T){return this.a.get(T)}removeChannel(T){this.a.delete(T),this.c.fire(T)}}k.Registry.add(e.Extensions.OutputChannels,new O),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new D.RawContextKey("activeOutputChannel","")}),define(Ce[105],ke([1,0,5,3,17,25,11,241,59,26,36,121,23,9,43,4,6]),function(ie,e,r,k,D,M,S,O,y,T,N,E,f,b,m,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class h extends S.AbstractMessageLogger{get disposed(){return this.l}constructor(v,i,d,n,a){super(),this.id=v,this.name=i,this.m=d,this.n=n,this.extension=a,this.k=0,this.l=!1,this.visible=!1,this.setLevel(d.getLevel()),this.B(d.onDidChangeLogLevel(t=>this.setLevel(t)))}get logLevel(){return this.getLevel()}appendLine(v){this.append(v+`
`)}append(v){this.info(v)}clear(){const v=this.k;this.m.flush(),this.n.$update(this.id,O.OutputChannelUpdateMode.Clear,v)}replace(v){const i=this.k;this.info(v),this.n.$update(this.id,O.OutputChannelUpdateMode.Replace,i),this.visible&&this.m.flush()}show(v,i){this.m.flush(),this.n.$reveal(this.id,!!(typeof v=="boolean"?v:i))}hide(){this.n.$close(this.id)}g(v,i){this.k+=f.VSBuffer.fromString(i).byteLength,(0,S.log)(this.m,v,i),this.visible&&(this.m.flush(),this.n.$update(this.id,O.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class p extends h{appendLine(v){this.append(v)}}let w=class{constructor(v,i,d,n,a,t){this.i=i,this.j=d,this.k=n,this.l=a,this.m=t,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=v.getProxy(r.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,E.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(v){this.h=v;for(const[i,d]of this.g)d.visible=i===this.h}createOutputChannel(v,i,d){if(v=v.trim(),!v)throw new Error("illegal argument `name`. must not be falsy");const n=typeof i=="object"&&i.log,a=(0,b.isString)(i)?i:void 0;if((0,b.isString)(a)&&!a.trim())throw new Error("illegal argument `languageId`. must not be empty");let t;const g=this.i.environment.extensionLogLevel?.find(([u])=>M.ExtensionIdentifier.equals(d.identifier,u))?.[1];g&&(t=(0,S.parseLogLevel)(g));const c=n?this.o(v,t,d):this.n(v,a,d);return c.then(u=>{this.g.set(u.id,u),u.visible=u.id===this.h}),n?this.r(v,t??this.m.getLevel(),c):this.q(v,c)}async n(v,i,d){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const n=await this.c,a=this.k.extUri.joinPath(n,`${this.f++}-${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),t=this.l.createLogger(a,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),g=await this.a.$register(v,a,i,d.identifier.value);return new h(g,v,t,this.a,d)}async o(v,i,d){const n=await this.p(d),a=this.k.extUri.joinPath(n,`${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),t=a.toString(),g=this.l.createLogger(a,{id:t,name:v,logLevel:i,extensionId:d.identifier.value});return new p(t,v,g,this.a,d)}p(v){let i=this.d.get(v.identifier.value);if(!i){const d=this.k.extUri.joinPath(this.i.logsLocation,v.identifier.value);this.d.set(v.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(d)}catch(n){if((0,m.toFileSystemProviderErrorCode)(n)!==m.FileSystemProviderErrorCode.FileExists)throw n}return d})())}return i}q(v,i){let d=!1;const n=()=>{if(d)throw new Error("Channel has been closed")};return{get name(){return v},append(a){n(),i.then(t=>t.append(a))},appendLine(a){n(),i.then(t=>t.appendLine(a))},clear(){n(),i.then(a=>a.clear())},replace(a){n(),i.then(t=>t.replace(a))},show(a,t){n(),i.then(g=>g.show(a,t))},hide(){n(),i.then(a=>a.hide())},dispose(){d=!0,i.then(a=>a.dispose())}}}r(v,i,d){const n=new s.DisposableStore,a=()=>{if(n.isDisposed)throw new Error("Channel has been closed")},t=n.add(new o.Emitter);function g(c){i=c,t.fire(c)}return d.then(c=>{n.add(c),c.logLevel!==i&&g(c.logLevel),n.add(c.onDidChangeLogLevel(u=>g(u)))}),{...this.q(v,d),get logLevel(){return i},onDidChangeLogLevel:t.event,trace(c,...u){a(),d.then(l=>l.trace(c,...u))},debug(c,...u){a(),d.then(l=>l.debug(c,...u))},info(c,...u){a(),d.then(l=>l.info(c,...u))},warn(c,...u){a(),d.then(l=>l.warn(c,...u))},error(c,...u){a(),d.then(l=>l.error(c,...u))},dispose(){n.dispose()}}}};w=qe([je(0,D.IExtHostRpcService),je(1,T.IExtHostInitDataService),je(2,y.IExtHostConsumerFileSystem),je(3,N.IExtHostFileSystemInfo),je(4,S.ILoggerService),je(5,S.ILogService)],w),e.ExtHostOutputService=w,e.IExtHostOutputService=(0,k.createDecorator)("IExtHostOutputService")}),define(Ce[242],ke([1,0,3]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,r.createDecorator)("remoteAgentService")}),define(Ce[243],ke([1,0,40,15,19,20,24,2,3,174,52,190,242]),function(ie,e,r,k,D,M,S,O,y,T,N,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let b=class cn{constructor(o,s,h,p){this.d=o,this.e=s,this.f=h,this.g=p,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const w=await this.e.getEnvironment();return this.c=w?.userHome??o})()}hasValidBasename(o,s,h){return typeof s=="string"||typeof s>"u"?this.a.then(p=>this.h(o,p,s)):this.h(o,s,h)}h(o,s,h){return o.scheme===k.Schemas.file||o.scheme===k.Schemas.vscodeRemote?(0,r.isValidBasename)(h??(0,S.basename)(o),s===1):!0}get defaultUriScheme(){return cn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,s){if(o.remoteAuthority)return k.Schemas.vscodeRemote;const h=(0,T.getVirtualWorkspaceScheme)(s.getWorkspace());if(h)return h;const p=s.getWorkspace().folders[0];if(p)return p.uri.scheme;const w=s.getWorkspace().configuration;return w?w.scheme:k.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===1?D.win32:D.posix)}async fileURI(o){let s="";if(await this.a===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const p=o.indexOf("/",2);p===-1?(s=o.substring(2),o="/"):(s=o.substring(2,p),o=o.substring(p)||"/")}return O.URI.from({scheme:k.Schemas.file,authority:s,path:o,query:"",fragment:""})}};b=qe([je(1,f.IRemoteAgentService),je(2,E.IWorkbenchEnvironmentService),je(3,N.IWorkspaceContextService)],b),e.AbstractPathService=b}),define(Ce[106],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class r{constructor(S,O){this.line=S,this.character=O}isBefore(S){return!1}isBeforeOrEqual(S){return!1}isAfter(S){return!1}isAfterOrEqual(S){return!1}isEqual(S){return!1}compareTo(S){return 0}translate(S,O){return new r(0,0)}with(S){return new r(0,0)}}e.Position=r;class k{constructor(S,O,y,T){this.isEmpty=!1,this.isSingleLine=!1,this.start=new r(S,O),this.end=new r(y,T)}contains(S){return!1}isEqual(S){return!1}intersection(S){}union(S){return new k(0,0,0,0)}with(S){return new k(0,0,0,0)}}e.Range=k;var D;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(D=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ce[46],ke([1,0,18,35,22,40,10,3,19,12,106,16]),function(ie,e,r,k,D,M,S,O,y,T,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return N.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const f="\u27EA ",b=" characters skipped \u27EB",m=(f.length+b.length+5)*2;e.ISearchService=(0,O.createDecorator)("searchService");var o;(function(de){de[de.file=0]="file",de[de.text=1]="text"})(o=e.SearchProviderType||(e.SearchProviderType={}));var s;(function(de){de[de.File=1]="File",de[de.Text=2]="Text"})(s=e.QueryType||(e.QueryType={}));function h(de){return!!de.preview}e.resultIsMatch=h;function p(de){return!!de.resource}e.isFileMatch=p;function w(de){return!!de.message}e.isProgressMessage=w;var A;(function(de){de[de.Normal=0]="Normal",de[de.NewSearchStarted=1]="NewSearchStarted"})(A=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class v{constructor(ue){this.resource=ue,this.results=[]}}e.FileMatch=v;class i{constructor(ue,se,J){this.ranges=se;const X=Array.isArray(se)?se:[se];if(J&&J.matchLines===1&&d(X)){ue=(0,S.getNLines)(ue,J.matchLines);let Z="",he=0,Te=0;const Ne=Math.floor(J.charsPerLine/5),Ke=[];for(const Pe of X){const Se=Math.max(Pe.startColumn-Ne,0),Ie=Pe.startColumn+J.charsPerLine;if(Se>Te+Ne+m){const oe=f+(Se-Te)+b;Z+=oe+ue.slice(Se,Ie),he+=Se-(Te+oe.length)}else Z+=ue.slice(Te,Ie);Ke.push(new a(0,Pe.startColumn-he,Pe.endColumn-he)),Te=Ie}this.preview={text:Z,matches:Array.isArray(this.ranges)?Ke:Ke[0]}}else{const Z=Array.isArray(se)?se[0].startLineNumber:se.startLineNumber;this.preview={text:ue,matches:(0,r.mapArrayOrNot)(se,he=>new n(he.startLineNumber-Z,he.startColumn,he.endLineNumber-Z,he.endColumn))}}}}e.TextSearchMatch=i;function d(de){const ue=de[0].startLineNumber;for(const se of de)if(se.startLineNumber!==ue||se.endLineNumber!==ue)return!1;return!0}class n{constructor(ue,se,J,X){this.startLineNumber=ue,this.startColumn=se,this.endLineNumber=J,this.endColumn=X}}e.SearchRange=n;class a extends n{constructor(ue,se,J){super(ue,se,ue,J)}}e.OneLineRange=a;var t;(function(de){de.List="list",de.Tree="tree"})(t=e.ViewMode||(e.ViewMode={}));var g;(function(de){de.Default="default",de.FileNames="fileNames",de.Type="type",de.Modified="modified",de.CountDescending="countDescending",de.CountAscending="countAscending"})(g=e.SearchSortOrder||(e.SearchSortOrder={}));function c(de,ue=!0){const se=de&&de.files&&de.files.exclude,J=ue&&de&&de.search&&de.search.exclude;if(!se&&!J)return;if(!se||!J)return se||J;let X=Object.create(null);return X=D.mixin(X,D.deepClone(se)),X=D.mixin(X,D.deepClone(J),!0),X}e.getExcludes=c;function u(de,ue){return de.excludePattern&&k.match(de.excludePattern,ue)?!1:de.includePattern||de.usingSearchPaths?de.includePattern&&k.match(de.includePattern,ue)?!0:de.usingSearchPaths?!!de.folderQueries&&de.folderQueries.some(se=>{const J=se.folder.fsPath;if(M.isEqualOrParent(ue,J)){const X=y.relative(J,ue);return!se.includePattern||!!k.match(se.includePattern,X)}else return!1}):!1:!0}e.pathIncludedInQuery=u;var l;(function(de){de[de.unknownEncoding=1]="unknownEncoding",de[de.regexParseError=2]="regexParseError",de[de.globParseError=3]="globParseError",de[de.invalidLiteral=4]="invalidLiteral",de[de.rgProcessError=5]="rgProcessError",de[de.other=6]="other",de[de.canceled=7]="canceled"})(l=e.SearchErrorCode||(e.SearchErrorCode={}));class C extends Error{constructor(ue,se){super(ue),this.code=se}}e.SearchError=C;function R(de){const ue=de.message;if((0,T.isCancellationError)(de))return new C(ue,l.canceled);try{const se=JSON.parse(ue);return new C(se.message,se.code)}catch{return new C(ue,l.other)}}e.deserializeSearchError=R;function V(de){const ue={message:de.message,code:de.code};return new Error(JSON.stringify(ue))}e.serializeSearchError=V;function ee(de){return de.type==="error"?!0:de.type==="success"}e.isSerializedSearchComplete=ee;function K(de){return de.type==="success"}e.isSerializedSearchSuccess=K;function L(de){return!!de.path}e.isSerializedFileMatch=L;function B(de,ue){const se=de.searchPath?de.searchPath:de.relativePath;return(0,S.fuzzyContains)(se,ue)}e.isFilePatternMatch=B;class P{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=P;function F(de,ue){const se={...de||{},...ue||{}};return Object.keys(se).filter(J=>{const X=se[J];return typeof X=="boolean"&&X})}e.resolvePatternsForProvider=F;class H{constructor(ue,se){this.c=null,this.a={...ue.excludePattern||{},...se.excludePattern||{}},this.b=k.parse(this.a);let J=ue.includePattern;se.includePattern&&(J?J={...J,...se.includePattern}:J=se.includePattern),J&&(this.c=k.parse(J))}matchesExcludesSync(ue,se,J){return!!(this.b&&this.b(ue,se,J))}includedInQuerySync(ue,se,J){return!(this.b&&this.b(ue,se,J)||this.c&&!this.c(ue,se,J))}includedInQuery(ue,se,J){const X=this.b(ue,se,J),Z=()=>this.c?!!this.c(ue,se,J):!0;return(0,E.isThenable)(X)?X.then(he=>he?!1:Z()):Z()}hasSiblingExcludeClauses(){return j(this.a)}}e.QueryGlobTester=H;function j(de){for(const ue in de)if(typeof de[ue]!="boolean")return!0;return!1}function le(de){if(!de)return;let ue;return se=>(ue||(ue=(de()||Promise.resolve([])).then(J=>J?be(J):{})),ue.then(J=>!!J[se]))}e.hasSiblingPromiseFn=le;function _(de){if(!de)return;let ue;return se=>{if(!ue){const J=de();ue=J?be(J):{}}return!!ue[se]}}e.hasSiblingFn=_;function be(de){const ue={};for(const se of de)ue[se]=!0;return ue}}),define(Ce[31],ke([1,0,18,16,21,4,6,47,15,113,24,10,9,2,145,3,11,162,52,36,26,17,8,7,54,46,5]),function(ie,e,r,k,D,M,S,O,y,T,N,E,f,b,m,o,s,h,p,w,A,v,i,d,n,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function g(K,L,B){return new N.ExtUri(P=>C(P,B)).isEqual(K,L)}function c(K,L,B){return g(K.uri,L.uri,B)?0:(0,E.compare)(K.uri.toString(),L.uri.toString())}function u(K,L,B){return K.index!==L.index?K.index<L.index?-1:1:g(K.uri,L.uri,B)?(0,E.compare)(K.name,L.name):(0,E.compare)(K.uri.toString(),L.uri.toString())}function l(K,L,B,P){const F=K.slice(0).sort((j,le)=>B(j,le,P)),H=L.slice(0).sort((j,le)=>B(j,le,P));return(0,r.delta)(F,H,(j,le)=>B(j,le,P))}function C(K,L){const B=L.getCapabilities(K.scheme);return!(B&&B&1024)}class R extends p.Workspace{static toExtHostWorkspace(L,B,P,F){if(!L)return{workspace:null,added:[],removed:[]};const{id:H,name:j,folders:le,configuration:_,transient:be,isUntitled:de}=L,ue=[],se=B;B?le.forEach((he,Te)=>{const Ne=b.URI.revive(he.uri),Ke=R.o(P||B,Ne,F);Ke?(Ke.name=he.name,Ke.index=he.index,ue.push(Ke)):ue.push({uri:Ne,name:he.name,index:Te})}):ue.push(...le.map(({uri:he,name:Te,index:Ne})=>({uri:b.URI.revive(he),name:Te,index:Ne}))),ue.sort((he,Te)=>he.index<Te.index?-1:1);const J=new R(H,j,ue,!!be,_?b.URI.revive(_):null,!!de,he=>C(he,F)),{added:X,removed:Z}=l(se?se.workspaceFolders:[],J.workspaceFolders,c,F);return{workspace:J,added:X,removed:Z}}static o(L,B,P){for(let F=0;F<L.folders.length;F++){const H=L.workspaceFolders[F];if(g(H.uri,B,P))return H}}constructor(L,B,P,F,H,j,le){super(L,P.map(_=>new p.WorkspaceFolder(_)),F,H,le),this.t=B,this.u=j,this.q=[],this.s=O.TernarySearchTree.forUris(le),P.forEach(_=>{this.q.push(_),this.s.set(_.uri,_)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(L,B){return B&&this.s.get(L)&&(L=(0,N.dirname)(L)),this.s.findSubstr(L)}resolveWorkspaceFolder(L){return this.s.get(L)}}let V=class{constructor(L,B,P,F,H){this.c=new M.Emitter,this.onDidChangeWorkspace=this.c.event,this.g=new M.Emitter,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new M.AsyncEmitter,this.h=F,this.s=P,this.t=H,this.j=new T.Counter,this.k=new k.Barrier,this.o=L.getProxy(t.MainContext.MainThreadWorkspace),this.q=L.getProxy(t.MainContext.MainThreadMessageService);const j=B.workspace;this.l=j?new R(j.id,j.name,[],!!j.transient,j.configuration?b.URI.revive(j.configuration):null,!!j.isUntitled,le=>C(le,P)):void 0}$initializeWorkspace(L,B){this.v=B,this.$acceptWorkspaceData(L),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?b.URI.from({scheme:y.Schemas.untitled,path:(0,N.basename)((0,N.dirname)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(!!this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(L,B,P,...F){const H=[];if(Array.isArray(F)&&F.forEach(de=>{b.URI.isUri(de.uri)&&!H.some(ue=>g(ue.uri,de.uri,this.s))&&H.push({uri:de.uri,name:de.name||(0,N.basenameOrAuthority)(de.uri)})}),this.n||[B,P].some(de=>typeof de!="number"||de<0)||P===0&&H.length===0)return!1;const j=this.x?this.x.workspaceFolders:[];if(B+P>j.length)return!1;const le=j.slice(0);le.splice(B,P,...H.map(de=>({uri:de.uri,name:de.name||(0,N.basenameOrAuthority)(de.uri),index:void 0})));for(let de=0;de<le.length;de++){const ue=le[de];if(le.some((se,J)=>J!==de&&g(ue.uri,se.uri,this.s)))return!1}le.forEach((de,ue)=>de.index=ue);const{added:_,removed:be}=l(j,le,u,this.s);if(_.length===0&&be.length===0)return!1;if(this.o){const de=L.displayName||L.name;this.o.$updateWorkspaceFolders(de,B,P,H).then(void 0,ue=>{this.n=void 0;const se={source:{identifier:L.identifier,label:L.displayName||L.name}};this.q.$showMessage(h.Severity.Error,(0,m.localize)(0,null,de,ue.toString()),se,[])})}return this.y(le),!0}getWorkspaceFolder(L,B){if(!!this.x)return this.x.getWorkspaceFolder(L,B)}async getWorkspaceFolder2(L,B){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(L,B)}async resolveWorkspaceFolder(L){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(L)}getPath(){if(!this.x)return;const{folders:L}=this.x;if(L.length!==0)return L[0].uri.fsPath}getRelativePath(L,B){let P,F="";if(typeof L=="string"?(P=b.URI.file(L),F=L):typeof L<"u"&&(P=L,F=L.fsPath),!P)return F;const H=this.getWorkspaceFolder(P,!0);if(!H)return F;typeof B>"u"&&this.x&&(B=this.x.folders.length>1);let j=(0,N.relativePath)(H.uri,P);return B&&H.name&&(j=`${H.name}/${j}`),j}y(L){this.x&&(this.n=R.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:L,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:B,added:P,removed:F}=R.toExtHostWorkspace(L,this.l,this.n,this.s);this.l=B||void 0,this.n=void 0,this.c.fire(Object.freeze({added:P,removed:F}))}findFiles(L,B,P,F,H=D.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let j;if(B===null?j=!1:B&&(typeof B=="string"?j=B:j=B.pattern),H&&H.isCancellationRequested)return Promise.resolve([]);const{includePattern:le,folder:_}=ee(i.GlobPattern.from(L));return this.o.$startFileSearch((0,f.withUndefinedAsNull)(le),(0,f.withUndefinedAsNull)(_),(0,f.withUndefinedAsNull)(j),(0,f.withUndefinedAsNull)(P),H).then(be=>Array.isArray(be)?be.map(de=>b.URI.revive(de)):[])}async findTextInFiles(L,B,P,F,H=D.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const j=this.j.getNext(),le=typeof B.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:_,folder:be}=ee(i.GlobPattern.from(B.include)),de=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,ue={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof B.useParentIgnoreFiles=="boolean"?!B.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:le,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:_,excludePattern:de},se=!1;if(this.u[j]=J=>{if(se)return;const X=b.URI.revive(J.resource);J.results.forEach(Z=>{(0,a.resultIsMatch)(Z)?P({uri:X,preview:{text:Z.preview.text,matches:(0,r.mapArrayOrNot)(Z.preview.matches,he=>new d.Range(he.startLineNumber,he.startColumn,he.endLineNumber,he.endColumn))},ranges:(0,r.mapArrayOrNot)(Z.ranges,he=>new d.Range(he.startLineNumber,he.startColumn,he.endLineNumber,he.endColumn))}):P({uri:X,text:Z.text,lineNumber:Z.lineNumber})})},H.isCancellationRequested)return{};try{const J=await this.o.$startTextSearch(L,(0,f.withUndefinedAsNull)(be),ue,j,H);return delete this.u[j],J||{}}catch(J){throw delete this.u[j],J}}$handleTextSearchResult(L,B){this.u[B]?.(L)}saveAll(L){return this.o.$saveAll(L)}resolveProxy(L){return this.o.$resolveProxy(L)}get trusted(){return this.v}requestWorkspaceTrust(L){return this.o.$requestWorkspaceTrust(L)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(L,B){if(this.w.has(L))throw new Error(`A provider has already been registered for scheme ${L}`);this.w.set(L,B);const P=this.t.transformOutgoingScheme(L),F=this.z++;return this.o.$registerEditSessionIdentityProvider(F,P),(0,S.toDisposable)(()=>{this.w.delete(L),this.o.$unregisterEditSessionIdentityProvider(F)})}async $getEditSessionIdentifier(L,B){this.h.info("Getting edit session identifier for workspaceFolder",L);const P=await this.resolveWorkspaceFolder(b.URI.revive(L));if(!P){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",P);const F=this.w.get(P.uri.scheme);if(this.h.info(`Provider for scheme ${P.uri.scheme} is defined: `,!!F),!F)return;const H=await F.provideEditSessionIdentity(P,B);if(this.h.info("Provider returned edit session identifier: ",H),!!H)return H}async $provideEditSessionIdentityMatch(L,B,P,F){this.h.info("Getting edit session identifier for workspaceFolder",L);const H=await this.resolveWorkspaceFolder(b.URI.revive(L));if(!H){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",H);const j=this.w.get(H.uri.scheme);if(this.h.info(`Provider for scheme ${H.uri.scheme} is defined: `,!!j),!j)return;const le=await j.provideEditSessionIdentityMatch?.(B,P,F);if(this.h.info("Provider returned edit session identifier match result: ",le),!!le)return le}getOnWillCreateEditSessionIdentityEvent(L){return(B,P,F)=>{const H=function(le){B.call(P,le)};return H.extension=L,this.A.event(H,void 0,F)}}async $onWillCreateEditSessionIdentity(L,B,P){const F=await this.resolveWorkspaceFolder(b.URI.revive(L));if(F===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:F},B,async(H,j)=>{const le=Date.now();await Promise.resolve(H),Date.now()-le>P&&this.h.warn("SLOW edit session create-participant",j.extension.identifier)}),B.isCancellationRequested}};V=qe([je(0,v.IExtHostRpcService),je(1,A.IExtHostInitDataService),je(2,w.IExtHostFileSystemInfo),je(3,s.ILogService),je(4,n.IURITransformerService)],V),e.ExtHostWorkspace=V,e.IExtHostWorkspace=(0,o.createDecorator)("IExtHostWorkspace");function ee(K){let L,B;return K&&(typeof K=="string"?L=K:(L=K.pattern,B=b.URI.revive(K.baseUri))),{includePattern:L,folder:B}}}),define(Ce[32],ke([1,0,22,4,31,5,7,165,93,9,16,3,17,11,2]),function(ie,e,r,k,D,M,S,O,y,T,N,E,f,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function o(d,n){if(n){const a=n.split(".");let t=d;for(let g=0;t&&g<a.length;g++)t=t[a[g]];return t}}function s(d){return d instanceof m.URI}function h(d){return d&&d.uri instanceof m.URI&&d.languageId&&typeof d.languageId=="string"}function p(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function w(d){return d&&d.uri instanceof m.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function A(d){if(s(d))return{resource:d};if(h(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(p(d))return{overrideIdentifier:d.languageId};if(w(d))return{resource:d.uri};if(d===null)return{resource:null}}let v=class{constructor(n,a,t){this.a=n.getProxy(M.MainContext.MainThreadConfiguration),this.c=a,this.b=t,this.d=new N.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(n=>this.e)}$initializeConfiguration(n){this.e=new i(this.a,this.c,n,this.b),this.d.open()}$acceptConfigurationChanged(n,a){this.getConfigProvider().then(t=>t.$acceptConfigurationChanged(n,a))}};v=qe([je(0,f.IExtHostRpcService),je(1,D.IExtHostWorkspace),je(2,b.ILogService)],v),e.ExtHostConfiguration=v;class i{constructor(n,a,t,g){this.a=new k.Emitter,this.b=n,this.f=g,this.c=a,this.e=O.Configuration.parse(t),this.d=this.k(t.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(n,a){const t={data:this.e.toData(),workspace:this.c.workspace};this.e=O.Configuration.parse(n),this.d=this.k(n.configurationScopes),this.a.fire(this.j(a,t))}getConfiguration(n,a,t){const g=A(a)||{},c=this.g(n?o(this.e.getValue(void 0,g,this.c.workspace),n):this.e.getValue(void 0,g,this.c.workspace));n&&this.h(n,g,t?.identifier);function u(C){if(C==null)return null;if(typeof C=="boolean")return C?2:5;switch(C){case S.ConfigurationTarget.Global:return 2;case S.ConfigurationTarget.Workspace:return 5;case S.ConfigurationTarget.WorkspaceFolder:return 6}}const l={has(C){return typeof o(c,C)<"u"},get:(C,R)=>{this.h(n?`${n}.${C}`:C,g,t?.identifier);let V=o(c,C);if(typeof V>"u")V=R;else{let ee;const K=(L,B)=>{let P;const F=()=>{ee=ee||(0,r.deepClone)(c),P=P||o(ee,B)};return(0,T.isObject)(L)?new Proxy(L,{get:(H,j)=>{if(typeof j=="string"&&j.toLowerCase()==="tojson")return F(),()=>P;if(ee)return P=P||o(ee,B),P[j];const le=H[j];return typeof j=="string"?K(le,`${B}.${j}`):le},set:(H,j,le)=>(F(),P&&(P[j]=le),!0),deleteProperty:(H,j)=>(F(),P&&delete P[j],!0),defineProperty:(H,j,le)=>(F(),P&&Object.defineProperty(P,j,le),!0)}):L};V=K(V,C)}return V},update:(C,R,V,ee)=>{C=n?`${n}.${C}`:C;const K=u(V);return R!==void 0?this.b.$updateConfigurationOption(K,C,R,g,ee):this.b.$removeConfigurationOption(K,C,g,ee)},inspect:C=>{C=n?`${n}.${C}`:C;const R=this.e.inspect(C,g,this.c.workspace);if(R)return{key:C,defaultValue:(0,r.deepClone)(R.policy?.value??R.default?.value),globalValue:(0,r.deepClone)(R.user?.value??R.application?.value),workspaceValue:(0,r.deepClone)(R.workspace?.value),workspaceFolderValue:(0,r.deepClone)(R.workspaceFolder?.value),defaultLanguageValue:(0,r.deepClone)(R.default?.override),globalLanguageValue:(0,r.deepClone)(R.user?.override??R.application?.override),workspaceLanguageValue:(0,r.deepClone)(R.workspace?.override),workspaceFolderLanguageValue:(0,r.deepClone)(R.workspaceFolder?.override),languageIds:(0,r.deepClone)(R.overrideIdentifiers)}}};return typeof c=="object"&&(0,r.mixin)(l,c,!1),Object.freeze(l)}g(n){const a=t=>(0,T.isObject)(t)?new Proxy(t,{get:(g,c)=>a(g[c]),set:(g,c,u)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(g,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(g,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:g=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):t;return a(n)}h(n,a,t){const g=y.OVERRIDE_PROPERTY_REGEX.test(n)?4:this.d.get(n),c=t?`[${t.value}] `:"";if(g===4){typeof a?.resource>"u"&&this.f.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(g===3){a?.resource&&this.f.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(n,a){const t=new O.ConfigurationChangeEvent(n,a,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(g,c)=>t.affectsConfiguration(g,A(c))})}k(n){return n.reduce((a,t)=>(a.set(t[0],t[1]),a),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,E.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!D:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(ie,r):D?D.value=r:e.set(ie,r),r},Le=this&&this.__classPrivateFieldGet||function(ie,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(ie):k?k.value:e.get(ie)};define(Ce[107],ke([1,0,2,16,4,5,7,31,57,32,21,60,17,26,3,15,20,11,76,201,12]),function(ie,e,r,k,D,M,S,O,y,T,N,E,f,b,m,o,s,h,p,w,A){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var i;(function(L){function B(F){if(F!=null)return F}L.from=B;function P(F){if(F!=null)return F}L.to=P})(i||(i={}));var d;(function(L){function B(F){if(F!=null)return F}L.from=B;function P(F){if(F!=null)return F}L.to=P})(d||(d={}));var n;(function(L){function B(F){if(F!=null)return F}L.from=B;function P(F){if(F!=null)return F}L.to=P})(n||(n={}));var a;(function(L){function B(H){if(H){const j=H;return j&&!!j.process}else return!1}L.is=B;function P(H){if(H==null)return;const j={process:H.process,args:H.args};return H.options&&(j.options=n.from(H.options)),j}L.from=P;function F(H){if(H!=null)return new S.ProcessExecution(H.process,H.args,H.options)}L.to=F})(a||(a={}));var t;(function(L){function B(F){if(F!=null)return F}L.from=B;function P(F){if(F!=null)return F}L.to=P})(t||(t={}));var g;(function(L){function B(H){if(H){const j=H;return j&&(!!j.commandLine||!!j.command)}else return!1}L.is=B;function P(H){if(H==null)return;const j={};return H.commandLine!==void 0?j.commandLine=H.commandLine:(j.command=H.command,j.args=H.args),H.options&&(j.options=t.from(H.options)),j}L.from=P;function F(H){if(!(H==null||H.command===void 0&&H.commandLine===void 0))return H.commandLine?new S.ShellExecution(H.commandLine,H.options):new S.ShellExecution(H.command,H.args?H.args:[],H.options)}L.to=F})(g||(g={}));var c;(function(L){function B(H){if(H){const j=H;return j&&j.customExecution==="customExecution"}else return!1}L.is=B;function P(H){return{customExecution:"customExecution"}}L.from=P;function F(H,j){return j.get(H)}L.to=F})(c=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var u;(function(L){function B(P,F){let H;return P.scope!==void 0&&typeof P.scope!="number"?H=P.scope.uri:P.scope!==void 0&&typeof P.scope=="number"&&(P.scope===S.TaskScope.Workspace&&F&&F.workspaceFile?H=F.workspaceFile:H=w.USER_TASKS_GROUP_KEY),{id:P._id,workspaceFolder:H}}L.from=B})(u=e.TaskHandleDTO||(e.TaskHandleDTO={}));var l;(function(L){function B(P){if(P!=null)return{_id:P.id,isDefault:P.isDefault}}L.from=B})(l||(l={}));var C;(function(L){function B(H,j){if(H==null)return[];const le=[];for(const _ of H){const be=P(_,j);be&&le.push(be)}return le}L.fromMany=B;function P(H,j){if(H==null)return;let le;H.execution instanceof S.ProcessExecution?le=a.from(H.execution):H.execution instanceof S.ShellExecution?le=g.from(H.execution):H.execution&&H.execution instanceof S.CustomExecution&&(le=c.from(H.execution));const _=i.from(H.definition);let be;return H.scope?typeof H.scope=="number"?be=H.scope:be=H.scope.uri:be=S.TaskScope.Workspace,!_||!be?void 0:{_id:H._id,definition:_,name:H.name,source:{extensionId:j.identifier.value,label:H.source,scope:be},execution:le,isBackground:H.isBackground,group:l.from(H.group),presentationOptions:d.from(H.presentationOptions),problemMatchers:H.problemMatchers,hasDefinedMatchers:H.hasDefinedMatchers,runOptions:H.runOptions?H.runOptions:{reevaluateOnRerun:!0},detail:H.detail}}L.from=P;async function F(H,j,le){if(H==null)return;let _;a.is(H.execution)?_=a.to(H.execution):g.is(H.execution)?_=g.to(H.execution):c.is(H.execution)&&(_=c.to(H._id,le));const be=i.to(H.definition);let de;if(H.source&&(H.source.scope!==void 0?typeof H.source.scope=="number"?de=H.source.scope:de=await j.resolveWorkspaceFolder(r.URI.revive(H.source.scope)):de=S.TaskScope.Workspace),!be||!de)return;const ue=new S.Task(be,de,H.name,H.source.label,_,H.problemMatchers);return H.isBackground!==void 0&&(ue.isBackground=H.isBackground),H.group!==void 0&&(ue.group=S.TaskGroup.from(H.group._id),ue.group&&H.group.isDefault&&(ue.group=new S.TaskGroup(ue.group.id,ue.group.label),H.group.isDefault===!0&&(ue.group.isDefault=H.group.isDefault))),H.presentationOptions&&(ue.presentationOptions=d.to(H.presentationOptions)),H._id&&(ue._id=H._id),H.detail&&(ue.detail=H.detail),ue}L.to=F})(C=e.TaskDTO||(e.TaskDTO={}));var R;(function(L){function B(F){return F}L.from=B;function P(F){if(!!F)return Object.assign(Object.create(null),F)}L.to=P})(R||(R={}));class V{constructor(B,P,F){this._id=P,this.a=F,v.set(this,void 0),Je(this,v,B,"f")}get task(){return this.a}terminate(){Le(this,v,"f").terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}v=new WeakMap;let ee=class{constructor(B,P,F,H,j,le,_,be){this.q=new D.Emitter,this.r=new D.Emitter,this.s=new D.Emitter,this.t=new D.Emitter,this.a=B.getProxy(M.MainContext.MainThreadTask),this.b=F,this.c=H,this.d=j,this.e=le,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=_,this.g=be,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(B,P,F){if(!F)return new S.Disposable(()=>{});const H=this.w();return this.j.set(H,{type:P,provider:F,extension:B}),this.a.$registerTaskProvider(H,P),new S.Disposable(()=>{this.j.delete(H),this.a.$unregisterTaskProvider(H)})}registerTaskSystem(B,P){this.a.$registerTaskSystem(B,P)}fetchTasks(B){return this.a.$fetchTasks(R.from(B)).then(async P=>{const F=[];for(const H of P){const j=await C.to(H,this.b,this.m);j&&F.push(j)}return F})}get taskExecutions(){const B=[];return this.k.forEach(P=>B.push(P)),B}terminateTask(B){if(!(B instanceof V))throw new Error("No valid task execution provided");return this.a.$terminateTask(B._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(B,P,F){const H=this.m.get(B.id);H&&(this.o.set(B.id,H),this.e.attachPtyToTerminal(P,await H.callback(F))),this.p=B.id,this.q.fire({execution:await this.y(B)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(B){const P=await this.y(B);this.l.delete(B.id),this.k.delete(B.id),this.A(B),this.r.fire({execution:P})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(B){const P=await this.y(B.id);this.s.fire({execution:P,processId:B.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(B){const P=await this.y(B.id);this.t.fire({execution:P,exitCode:B.exitCode})}$provideTasks(B,P){const F=this.j.get(B);if(!F)return Promise.reject(new Error("no handler found"));const H=[],j=(0,k.asPromise)(()=>F.provider.provideTasks(N.CancellationToken.None)).then(le=>this.u(P,H,F,le));return new Promise(le=>{j.then(_=>{Promise.all(H).then(()=>{le(_)})})})}async $resolveTask(B,P){const F=this.j.get(B);if(!F)return Promise.reject(new Error("no handler found"));if(P.definition.type!==F.type)throw new Error(`Unexpected: Task of type [${P.definition.type}] cannot be resolved by provider of type [${F.type}].`);const H=await C.to(P,this.b,this.m);if(!H)throw new Error("Unexpected: Task cannot be resolved.");const j=await F.provider.resolveTask(H,N.CancellationToken.None);if(!j)return;this.z(j,F);const le=C.from(j,F.extension);if(!le)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==H.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(le.execution)&&await this.x(le,j,!0),await this.v(le)}w(){return this.h++}async x(B,P,F){const H=await this.a.$createTaskId(B);!F&&!this.m.has(H)&&(this.n.add(H),this.o.set(H,P.execution)),this.m.set(H,P.execution)}async y(B,P){if(typeof B=="string"){const j=this.l.get(B);if(!j)throw new A.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return j}const F=this.l.get(B.id);if(F)return F;const H=new Promise((j,le)=>{function _(be,de,ue){ue?j(new V(be,de.id,ue)):le("Unexpected: Task does not exist.")}P?_(this,B,P):C.to(B.task,this.b,this.m).then(be=>_(this,B,be))});return this.l.set(B.id,H),H.then(j=>(this.k.set(B.id,j),j),j=>Promise.reject(j))}z(B,P){B._deprecated&&this.g.report("Task.constructor",P.extension,"Use the Task constructor that takes a `scope` instead.")}A(B){this.o.get(B.id)&&this.o.delete(B.id),this.n.has(B.id)&&this.p!==B.id&&(this.m.delete(B.id),this.n.delete(B.id));const F=this.n.values();let H=F.next();for(;!H.done;)!this.o.has(H.value)&&this.p!==H.value&&(this.m.delete(H.value),this.n.delete(H.value)),H=F.next()}};ee=qe([je(0,f.IExtHostRpcService),je(1,b.IExtHostInitDataService),je(2,O.IExtHostWorkspace),je(3,y.IExtHostDocumentsAndEditors),je(4,T.IExtHostConfiguration),je(5,E.IExtHostTerminalService),je(6,h.ILogService),je(7,p.IExtHostApiDeprecationService)],ee),e.ExtHostTaskBase=ee;let K=class extends ee{constructor(B,P,F,H,j,le,_,be){super(B,P,F,H,j,le,_,be),this.registerTaskSystem(o.Schemas.vscodeRemote,{scheme:o.Schemas.vscodeRemote,authority:"",platform:s.PlatformToString(0)})}async executeTask(B,P){if(!P.execution)throw new Error("Tasks to execute must include an execution");const F=C.from(P,B);if(F===void 0)throw new Error("Task is not valid");if(c.is(F.execution))await this.x(F,P,!1);else throw new A.NotSupportedError;const H=await this.y(await this.a.$getTaskExecution(F),P);return this.a.$executeTask(F).catch(j=>{throw new Error(j)}),H}u(B,P,F,H){const j=[];if(H)for(const le of H){this.z(le,F),(!le.definition||!B[le.definition.type])&&this.f.warn(`The task [${le.source}, ${le.name}] uses an undefined task type. The task will be ignored in the future.`);const _=C.from(le,F.extension);_&&c.is(_.execution)?(j.push(_),P.push(this.x(_,le,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:j,extension:F.extension}}async v(B){if(c.is(B.execution))return B;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(B,P){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(B,P,F){}};K=qe([je(0,f.IExtHostRpcService),je(1,b.IExtHostInitDataService),je(2,O.IExtHostWorkspace),je(3,y.IExtHostDocumentsAndEditors),je(4,T.IExtHostConfiguration),je(5,E.IExtHostTerminalService),je(6,h.ILogService),je(7,p.IExtHostApiDeprecationService)],K),e.WorkerExtHostTask=K,e.IExtHostTask=(0,m.createDecorator)("IExtHostTask")}),define(Ce[244],ke([1,0,19,21,39,35,24,77,46]),function(ie,e,r,k,D,M,S,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class T{constructor(f,b,m){this.k=f,this.l=b,this.o=m,this.e=!1,this.f=0,this.g=!1,this.a=f.filePattern,this.b=f.includePattern&&M.parse(f.includePattern),this.c=f.maxResults||void 0,this.d=f.exists,this.h=new Set,this.j=f.excludePattern&&M.parse(f.excludePattern)}cancel(){this.g=!0,this.h.forEach(f=>f.cancel()),this.h=new Set}search(f){const b=this.k.folderQueries||[];return new Promise((m,o)=>{const s=h=>{this.f++,f(h)};if(this.g)return m({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(h=>{const p=h.toString(),w=r.basename(p);this.j&&this.j(p,w)||this.v(s,{base:h,basename:w})}),Promise.all(b.map(h=>this.p(h,s))).then(h=>{m({limitHit:this.e,stats:h[0]||void 0})},h=>{o(new Error((0,D.toErrorMessage)(h)))})})}async p(f,b){const m=new k.CancellationTokenSource,o=this.q(f),s=this.r(),h=new y.QueryGlobTester(this.k,f),p=!h.hasSiblingExcludeClauses();let w;try{this.h.add(m),w=O.StopWatch.create();const A=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},o,m.token),v=w.elapsed(),i=O.StopWatch.create();return this.g&&!this.e||(A&&A.forEach(d=>{const n=r.posix.relative(f.folder.path,d.path);if(p){const a=r.basename(d.path);this.v(b,{base:f.folder,relativePath:n,basename:a});return}this.s(s,f.folder,n,b)}),this.g&&!this.e)?null:(this.u(s,h,b),{providerTime:v,postProcessTime:i.elapsed()})}finally{m.dispose(),this.h.delete(m)}}q(f){const b=(0,y.resolvePatternsForProvider)(this.k.includePattern,f.includePattern),m=(0,y.resolvePatternsForProvider)(this.k.excludePattern,f.excludePattern);return{folder:f.folder,excludes:m,includes:b,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!f.disregardParentIgnoreFiles,followSymlinks:!f.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const f={rootEntries:[],pathToEntries:Object.create(null)};return f.pathToEntries["."]=f.rootEntries,f}s({pathToEntries:f},b,m,o){if(m===this.a){const h=r.basename(this.a);this.v(o,{base:b,relativePath:this.a,basename:h})}function s(h){const p=r.basename(h),w=r.dirname(h);let A=f[w];A||(A=f[w]=[],s(w)),A.push({base:b,relativePath:h,basename:p})}s(m)}u({rootEntries:f,pathToEntries:b},m,o){const s=this,h=this.a;function p(w){const A=(0,y.hasSiblingFn)(()=>w.map(v=>v.basename));for(let v=0,i=w.length;v<i;v++){const d=w[v],{relativePath:n,basename:a}=d;if(m.matchesExcludesSync(n,a,h!==a?A:void 0))continue;const t=b[n];if(t)p(t);else{if(n===h)continue;s.v(o,d)}if(s.e)break}}p(f)}v(f,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||f(b))}}class N{constructor(){this.b=new Map}fileSearch(f,b,m,o){const s=this.c(f.cacheKey),h=new T(f,b,s&&s.token);let p=0;const w=A=>{p+=A.length,m(A.map(v=>this.d(v)))};return this.e(h,N.a,w,o).then(A=>({limitHit:A.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:p,detailStats:A.stats}}))}clearCache(f){this.c(f)?.cancel()}c(f){if(!!f)return this.b.has(f)||this.b.set(f,new k.CancellationTokenSource),this.b.get(f)}d(f){return f.relativePath?{resource:S.joinPath(f.base,f.relativePath)}:{resource:f.base}}e(f,b,m,o){o.onCancellationRequested(()=>{f.cancel()});const s=p=>{p&&(h.push(p),b>0&&h.length>=b&&(m(h),h=[]))};let h=[];return f.search(s).then(p=>(h.length&&m(h),p),p=>(h.length&&m(h),Promise.reject(p)))}}e.FileSearchManager=N,N.a=512}),define(Ce[245],ke([1,0,18,62,35,87,28,15,19,24,10,9,2,261,154,41,11,52,97,243,46]),function(ie,e,r,k,D,M,S,O,y,T,N,E,f,b,m,o,s,h,p,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let v=class{constructor(l,C,R,V,ee){this.a=l,this.b=C,this.c=R,this.d=V,this.e=ee}text(l,C,R={}){l=this.f(l,R);const V=this.a.getValue(),ee=C&&C.some(L=>!this.a.getValue({resource:L}).search.useRipgrep);return{...this.h(C?.map(h.toWorkspaceFolder),R),type:2,contentPattern:l,previewOptions:R.previewOptions,maxFileSize:R.maxFileSize,usePCRE2:V.search.usePCRE2||ee||!1,beforeContext:R.beforeContext,afterContext:R.afterContext,userDisabledExcludesAndIgnoreFiles:R.disregardExcludeSettings&&R.disregardIgnoreFiles}}f(l,C){const R=this.a.getValue();l.isRegExp&&(l.pattern=l.pattern.replace(/\r?\n/g,"\\n"));const V={...l,wordSeparators:R.editor.wordSeparators};return this.j(l,C)&&(V.isCaseSensitive=!0),this.k(l)&&(V.isMultiline=!0),V}file(l,C={}){return{...this.h(l,C),type:1,filePattern:C.filePattern?C.filePattern.trim():C.filePattern,exists:C.exists,sortByScore:C.sortByScore,cacheKey:C.cacheKey}}g(l,C){return l?(l=Array.isArray(l)?l.map(t):t(l),C?this.parseSearchPaths(l):{pattern:d(...Array.isArray(l)?l:[l])}):{}}h(l=[],C={}){const R=this.g(C.includePattern,C.expandPatterns),V=this.g(C.excludePattern,C.expandPatterns),ee=l.length>1,K=(R.searchPaths&&R.searchPaths.length?R.searchPaths.map(P=>this.q(P,C,V)):l.map(P=>this.r(P,C,V,ee))).filter(P=>!!P),L={_reason:C._reason,folderQueries:K,usingSearchPaths:!!(R.searchPaths&&R.searchPaths.length),extraFileResources:C.extraFileResources,excludePattern:V.pattern,includePattern:R.pattern,onlyOpenEditors:C.onlyOpenEditors,maxResults:C.maxResults};if(C.onlyOpenEditors){const P=r.coalesce(r.flatten(this.c.groups.map(j=>j.editors.map(le=>le.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(P));const F=P.filter(j=>(0,A.pathIncludedInQuery)(L,j.fsPath)),H=this.i(F);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(H)),{...L,...H}}const B=C.extraFileResources&&C.extraFileResources.filter(P=>(0,A.pathIncludedInQuery)(L,P.fsPath));return L.extraFileResources=B&&B.length?B:void 0,L}i(l){const C=[],R=new S.ResourceMap,V={};let ee=!1;return l.forEach(K=>{if(K.scheme===O.Schemas.walkThrough)return;if((0,T.isAbsolutePath)(K)){const B=this.b.getWorkspaceFolder(K)?.uri??K.with({path:y.dirname(K.fsPath)});let P=R.get(B);P||(ee=!0,P={folder:B,includePattern:{}},C.push(P),R.set(B,P));const F=y.relative(B.fsPath,K.fsPath);(0,E.assertIsDefined)(P.includePattern)[F.replace(/\\/g,"/")]=!0}else K.fsPath&&(ee=!0,V[K.fsPath]=!0)}),{folderQueries:C,includePattern:V,usingSearchPaths:!0,excludePattern:ee?void 0:{"**/*":!0}}}j(l,C){if(C.isSmartCase){if(l.isRegExp){if(N.containsUppercaseCharacter(l.pattern,!0))return!0}else if(N.containsUppercaseCharacter(l.pattern))return!0}return!!l.isCaseSensitive}k(l){return l.isMultiline||l.isRegExp&&(0,b.isMultilineRegexSource)(l.pattern)||l.pattern.indexOf(`
`)>=0?!0:!!l.isMultiline}parseSearchPaths(l){const C=H=>y.isAbsolute(H)||/^\.\.?([\/\\]|$)/.test(H),V=(Array.isArray(l)?l:n(l)).map(H=>{const j=this.e.resolvedUserHome;return j?(0,M.untildify)(H,j.scheme===O.Schemas.file?j.fsPath:j.path):H}),ee=k.groupBy(V,H=>C(H)?"searchPaths":"exprSegments"),K=(ee.exprSegments||[]).map(H=>N.rtrim(H,"/")).map(H=>N.rtrim(H,"\\")).map(H=>(H[0]==="."&&(H="*"+H),a(H))),L={},B=this.m(ee.searchPaths||[]);B&&B.length&&(L.searchPaths=B);const P=r.flatten(K),F=d(...P);return F&&(L.pattern=F),L}l(l,C){return C.disregardExcludeSettings?void 0:(0,A.getExcludes)(l,!C.disregardSearchExcludeSettings)}m(l){if(!l||!l.length)return[];const C=l.flatMap(V=>{let{pathPortion:ee,globPortion:K}=i(V);return K&&(K=g(K)),this.n(ee).flatMap(B=>this.o(B,K))}),R=new Map;return C.forEach(V=>{const ee=V.searchPath.toString(),K=R.get(ee);K?V.pattern&&(K.pattern=K.pattern||{},K.pattern[V.pattern]=!0):R.set(ee,{searchPath:V.searchPath,pattern:V.pattern?d(V.pattern):void 0})}),Array.from(R.values())}n(l){if(y.isAbsolute(l)){const C=this.b.getWorkspace().folders;return C[0]&&C[0].uri.scheme!==O.Schemas.file?[{searchPath:C[0].uri.with({path:l})}]:[{searchPath:f.URI.file(y.normalize(l))}]}if(this.b.getWorkbenchState()===2){const C=this.b.getWorkspace().folders[0].uri;if(l=t(l),l.startsWith("../")||l===".."){const V=y.posix.resolve(C.path,l);return[{searchPath:C.with({path:V})}]}const R=g(l);return[{searchPath:C,pattern:R}]}else{if(l==="./"||l===".\\")return[];{const C=l.replace(/^\.[\/\\]/,""),V=this.b.getWorkspace().folders.map(ee=>{const K=C.match(new RegExp(`^${N.escapeRegExpCharacters(ee.name)}(?:/(.*)|$)`));return K?{match:K,folder:ee}:null}).filter(E.isDefined);if(V.length)return V.map(ee=>{const K=ee.match[1];return{searchPath:ee.folder.uri,pattern:K&&g(K)}});{const ee=l.match(/\.[\/\\](.+)[\/\\]?/),K=ee?ee[1]:l,L=m.localize(0,null,K);throw new Error(L)}}}}o(l,C){const R=l.pattern&&C?`${l.pattern}/${C}`:l.pattern||C,V=[{searchPath:l.searchPath,pattern:R}];return R&&!R.endsWith("**")&&V.push({searchPath:l.searchPath,pattern:R+"/**"}),V}q(l,C,R){const V=this.r((0,h.toWorkspaceFolder)(l.searchPath),C,R,!1);return V?{...V,includePattern:l.pattern}:null}r(l,C,R,V){let ee;const K=f.URI.isUri(l)?l:l.uri;if(R.searchPaths){const H=R.searchPaths.filter(j=>(0,T.isEqual)(j.searchPath,K))[0];if(H&&!H.pattern)return null;H&&(ee=H.pattern)}const L=this.a.getValue({resource:K}),P={...this.l(L,C)||{},...ee||{}},F=f.URI.isUri(l)?(0,T.basename)(l):l.name;return{folder:K,folderName:V?F:void 0,excludePattern:Object.keys(P).length>0?P:void 0,fileEncoding:L.files&&L.files.encoding,disregardIgnoreFiles:typeof C.disregardIgnoreFiles=="boolean"?C.disregardIgnoreFiles:!L.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof C.disregardGlobalIgnoreFiles=="boolean"?C.disregardGlobalIgnoreFiles:!L.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof C.disregardParentIgnoreFiles=="boolean"?C.disregardParentIgnoreFiles:!L.search.useParentIgnoreFiles,ignoreSymlinks:typeof C.ignoreSymlinks=="boolean"?C.ignoreSymlinks:!L.search.followSymlinks}}};v=qe([je(0,o.IConfigurationService),je(1,h.IWorkspaceContextService),je(2,p.IEditorGroupsService),je(3,s.ILogService),je(4,w.IPathService)],v),e.QueryBuilder=v;function i(u){const l=u.match(/[\*\{\}\(\)\[\]\?]/);if(l){const C=l.index,R=u.substr(0,C).match(/[/|\\][^/\\]*$/);if(R){let V=u.substr(0,R.index);return V.match(/[/\\]/)||(V+="/"),{pathPortion:V,globPortion:u.substr((R.index||0)+1)}}}return{pathPortion:u}}function d(...u){return u.length?u.reduce((l,C)=>(l[C]=!0,l),Object.create(null)):void 0}function n(u){return D.splitGlobAware(u,",").map(l=>l.trim()).filter(l=>!!l.length)}function a(u){return[`**/${u}/**`,`**/${u}`].map(C=>C.replace(/\*\*\/\*\*/g,"**"))}function t(u){return u.replace(/\\/g,"/")}function g(u){return t(u).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(u,l){u=r.distinct(u,V=>V.toString());const C=[],R=l.getWorkspace();return u&&u.forEach(V=>{let ee;if(l.getWorkbenchState()===2)ee=(0,T.relativePath)(R.folders[0].uri,V),ee&&ee!=="."&&(ee="./"+ee);else{const K=l.getWorkspaceFolder(V);if(K){const L=K.name;if(R.folders.filter(P=>P.name===L).length===1){const P=(0,T.relativePath)(K.uri,V);P===""?ee=`./${K.name}`:ee=`./${K.name}/${P}`}else ee=V.fsPath}}ee&&C.push(ee)}),C}e.resolveResourcesForSearchIncludes=c}),define(Ce[246],ke([1,0,24,2,21,12,3,245,46,52]),function(ie,e,r,k,D,M,S,O,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const N=7e3;function E(o,s){const h=s.activationEvents;if(!h)return Promise.resolve(void 0);const p=[],w=[];for(const a of h)if(/^workspaceContains:/.test(a)){const t=a.substr(18);t.indexOf("*")>=0||t.indexOf("?")>=0||o.forceUsingSearch?w.push(t):p.push(t)}if(p.length===0&&w.length===0)return Promise.resolve(void 0);let A;const v=new Promise((a,t)=>{A=a}),i=a=>A({activationEvent:a}),d=Promise.all(p.map(a=>f(o,a,i))).then(()=>{}),n=b(o,s.identifier,w,i);return Promise.all([d,n]).then(()=>{A(void 0)}),v}e.checkActivateWorkspaceContainsExtension=E;async function f(o,s,h){for(const p of o.folders)if(await o.exists(r.joinPath(k.URI.revive(p),s))){h(`workspaceContains:${s}`);return}}async function b(o,s,h,p){if(h.length===0)return Promise.resolve(void 0);const w=new D.CancellationTokenSource,A=o.checkExists(o.folders,h,w.token),v=setTimeout(async()=>{w.cancel(),o.logService.info(`Not activating extension '${s.value}': Timed out while searching for 'workspaceContains' pattern ${h.join(",")}`)},N);let i=!1;try{i=await A}catch(d){M.isCancellationError(d)||M.onUnexpectedError(d)}w.dispose(),clearTimeout(v),i&&p(`workspaceContains:${h.join(",")}`)}function m(o,s,h,p){const w=o.get(S.IInstantiationService),A=o.get(y.ISearchService),i=w.createInstance(O.QueryBuilder).file(s.map(d=>(0,T.toWorkspaceFolder)(k.URI.revive(d))),{_reason:"checkExists",includePattern:h,exists:!0});return A.fileSearch(i,p).then(d=>!!d.limitHit,d=>M.isCancellationError(d)?!1:Promise.reject(d))}e.checkGlobFileExists=m});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!D:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(ie,r):D?D.value=r:e.set(ie,r),r},Le=this&&this.__classPrivateFieldGet||function(ie,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(ie):k?k.value:e.get(ie)};define(Ce[33],ke([1,0,140,19,82,24,16,6,47,2,11,5,32,191,80,31,27,98,12,25,23,176,7,94,3,26,81,17,67,69,60,4,246,79,178,15,78,77]),function(ie,e,r,k,D,M,S,O,y,T,N,E,f,b,m,o,s,h,p,w,A,v,i,d,n,a,t,g,c,u,l,C,R,V,ee,K,L,B){"use strict";var P,F,H;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,n.createDecorator)("IHostUtils");let j=class Ui extends O.Disposable{constructor(se,J,X,Z,he,Te,Ne,Ke,Pe,Se,Ie){super(),this.a=this.B(new C.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=J,this.g=X,this.f=Ne,this.j=Z,this.k=he,this.l=Te,this.m=Pe,this.p=Se,this.s=Ie,this.t=this.g.getProxy(E.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(E.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(E.MainContext.MainThreadExtensionService),this.w=new S.Barrier,this.y=new S.Barrier,this.z=new S.Barrier,this.C=new S.Barrier,this.F=new h.ExtensionDescriptionRegistry(this.f.allExtensions);const oe=(0,s.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new h.ExtensionDescriptionRegistry(be(this.F,oe)),this.G=new m.ExtHostStorage(this.g,this.l),this.H=new V.ExtHostSecretState(this.g),this.I=Ke,this.h=se.createChild(new c.ServiceCollection([m.IExtHostStorage,this.G],[V.IExtHostSecretState,this.H])),this.J=this.B(new b.ExtensionsActivator(this.D,this.F,{onExtensionActivationError:(ce,Y,I)=>{this.v.$onExtensionActivationError(ce,p.transformErrorForSerialization(Y),I)},actualActivateExtension:async(ce,Y)=>{if(h.ExtensionDescriptionRegistry.isHostExtension(ce,this.D,this.F))return await this.v.$activateExtension(ce,Y),new b.HostExtension;const I=this.D.getExtensionDescription(ce);return this.Y(I,Y)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.nb(),this.w.open(),await this.j.waitForInitializeCall(),D.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.kb()}catch(se){p.onUnexpectedError(se)}}async Q(){this.I.onWillDeactivateAll();let se=[];try{se=this.D.getAllExtensionDescriptions().map(he=>he.identifier).filter(he=>this.isActivated(he)).map(he=>this.X(he))}catch{}await Promise.all(se)}terminate(se,J=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${se}`),this.l.flush(),this.p.dispose(),this.J.dispose(),p.setUnexpectedErrorHandler(Z=>{this.l.error(Z)}),this.g.dispose();const X=this.Q();Promise.race([(0,S.timeout)(5e3),X]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${J}`):this.l.info(`Extension host exiting with code ${J}`),this.l.flush(),this.l.dispose(),this.c.exit(J)})}isActivated(se){return this.z.isOpen()?this.J.isActivated(se):!1}async getExtension(se){const J=await this.v.$getExtension(se);let X;if(J?.browserNlsBundleUris){X={};for(const Z of Object.keys(J.browserNlsBundleUris))X[Z]=T.URI.revive(J.browserNlsBundleUris[Z])}return J&&{...J,identifier:new w.ExtensionIdentifier(J.identifier.value),extensionLocation:T.URI.revive(J.extensionLocation),browserNlsBundleUris:X}}R(se,J){return this.J.activateByEvent(se,J)}S(se,J){return this.J.activateById(se,J)}activateByIdWithErrors(se,J){return this.S(se,J).then(()=>{const X=this.J.getActivatedExtension(se);if(X.activationFailed)return Promise.reject(X.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(se=>this.D)}getExtensionExports(se){return this.z.isOpen()?this.J.getActivatedExtension(se).exports:null}async U(se){if(se.scheme!==K.Schemas.file)return se;const J=await this.c.realpath(se.fsPath);return T.URI.file(J)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(se=>new de(se))),this.L}async W(se){const J=y.TernarySearchTree.forUris(X=>M.extUriBiasedIgnorePathCase.ignorePathCasing(X));return await Promise.all(se.map(async X=>{if(this.ob(X)){const Z=await this.U(X.extensionLocation);J.set(Z,X)}})),J}X(se){let J=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(se))return J;const X=this.J.getActivatedExtension(se);if(!X)return J;try{typeof X.module.deactivate=="function"&&(J=Promise.resolve(X.module.deactivate()).then(void 0,Z=>(this.l.error(Z),Promise.resolve(void 0))))}catch(Z){this.l.error(`An error occurred when deactivating the extension '${se.value}':`),this.l.error(Z)}try{(0,O.dispose)(X.subscriptions)}catch(Z){this.l.error(`An error occurred when deactivating the subscriptions for extension '${se.value}':`),this.l.error(Z)}return J}async Y(se,J){return this.f.remote.isRemote?this.v.$onWillActivateExtension(se.identifier):await this.v.$onWillActivateExtension(se.identifier),this.ab(se,J).then(X=>{const Z=X.activationTimes;return this.v.$onDidActivateExtension(se.identifier,Z.codeLoadingTime,Z.activateCallTime,Z.activateResolvedTime,J),this.Z(se,J,"success",Z),X},X=>{throw this.Z(se,J,"failure"),X})}Z(se,J,X,Z){const he=le(se,J);this.u.$publicLog2("extensionActivationTimes",{...he,...Z||{},outcome:X})}ab(se,J){const X=le(se,J);this.u.$publicLog2("activatePlugin",X);const Z=this.ob(se);if(!Z)return Promise.resolve(new b.EmptyExtension(b.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${se.identifier.value}, startup: ${J.startup}, activationEvent: '${J.activationEvent}'${se.identifier.value!==J.extensionId.value?`, root cause: ${J.extensionId.value}`:""}`),this.l.flush();const he=new b.ExtensionActivationTimesBuilder(J.startup);return Promise.all([this.pb(se,(0,M.joinPath)(se.extensionLocation,Z),he),this.bb(se)]).then(Te=>(D.mark(`code/extHost/willActivateExtension/${se.identifier.value}`),Ui.cb(this.l,se.identifier,Te[0],Te[1],he))).then(Te=>(D.mark(`code/extHost/didActivateExtension/${se.identifier.value}`),Te))}bb(se){const J=new v.ExtensionGlobalMemento(se,this.G),X=new v.ExtensionMemento(se.identifier.value,!1,this.G),Z=new ee.ExtensionSecrets(se,this.H),he=se.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Te=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${se.identifier.value}`),Promise.all([J.whenReady,X.whenReady,this.I.whenReady]).then(()=>{const Ne=this;let Ke,Pe;const Se=(0,s.isProposedApiEnabled)(se,"ipc")?this.f.messagePorts?.get(w.ExtensionIdentifier.toKey(se.identifier)):void 0;return Object.freeze({globalState:J,workspaceState:X,secrets:Z,subscriptions:[],get extensionUri(){return se.extensionLocation},get extensionPath(){return se.extensionLocation.fsPath},asAbsolutePath(Ie){return k.join(se.extensionLocation.fsPath,Ie)},get storagePath(){return Ne.I.workspaceValue(se)?.fsPath},get globalStoragePath(){return Ne.I.globalValue(se).fsPath},get logPath(){return k.join(Ne.f.logsLocation.fsPath,se.identifier.value)},get logUri(){return T.URI.joinPath(Ne.f.logsLocation,se.identifier.value)},get storageUri(){return Ne.I.workspaceValue(se)},get globalStorageUri(){return Ne.I.globalValue(se)},get extensionMode(){return he},get extension(){return Ke===void 0&&(Ke=new _(Ne,se.identifier,se,Te,!1)),Ke},get extensionRuntime(){return(0,s.checkProposedApiEnabled)(se,"extensionRuntime"),Ne.extensionRuntime},get environmentVariableCollection(){return Ne.p.getEnvironmentVariableCollection(se)},get messagePassingProtocol(){if(!Pe){if(!Se)return;const Ie=C.Event.buffer(C.Event.fromDOMEventEmitter(Se,"message",oe=>oe.data));Se.start(),Pe={onDidReceiveMessage:Ie,postMessage:Se.postMessage.bind(Se)}}return Pe}})})}static cb(se,J,X,Z,he){return X=X||{activate:void 0,deactivate:void 0},this.db(se,J,X,Z,he).then(Te=>new b.ActivatedExtension(!1,null,he.build(),X,Te,Z.subscriptions))}static db(se,J,X,Z,he){if(typeof X.activate=="function")try{he.activateCallStart(),se.trace(`ExtensionService#_callActivateOptional ${J.value}`);const Te=typeof global=="object"?global:self,Ne=X.activate.apply(Te,[Z]);return he.activateCallStop(),he.activateResolveStart(),Promise.resolve(Ne).then(Ke=>(he.activateResolveStop(),Ke))}catch(Te){return Promise.reject(Te)}else return Promise.resolve(X)}eb(se,J){this.S(se.identifier,{startup:!1,extensionId:se.identifier,activationEvent:J}).then(void 0,X=>{this.l.error(X)})}fb(){this.v.$setPerformanceMarks(D.getMarks());for(const se of this.D.getAllExtensionDescriptions())if(se.activationEvents)for(const J of se.activationEvents)J==="onStartupFinished"&&this.eb(se,J)}gb(){const se=this.R("*",!0).then(void 0,he=>{this.l.error(he)});this.B(this.j.onDidChangeWorkspace(he=>this.hb(he.added)));const J=this.j.workspace?this.j.workspace.folders:[],X=this.hb(J),Z=Promise.all([se,X]).then(()=>{});return Promise.race([Z,(0,S.timeout)(1e4)]).then(()=>{this.fb()}),Z}hb(se){return se.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(J=>this.ib(se,J))).then(()=>{})}async ib(se,J){if(this.isActivated(J.identifier))return;const X=!this.f.remote.isRemote&&!!this.f.remote.authority,Z={logService:this.l,folders:se.map(Te=>Te.uri),forceUsingSearch:X,exists:Te=>this.c.exists(Te.fsPath),checkExists:(Te,Ne,Ke)=>this.t.$checkExists(Te,Ne,Ke)},he=await(0,R.checkActivateWorkspaceContainsExtension)(Z,J);if(!!he)return this.S(J.identifier,{startup:!0,extensionId:J.identifier,activationEvent:he.activationEvent}).then(void 0,Te=>this.l.error(Te))}async $extensionTestsExecute(){await this.C.wait();try{return await this.jb()}catch(se){throw console.error(se),se}}async jb(){const{extensionDevelopmentLocationURI:se,extensionTestsLocationURI:J}=this.f.environment;if(!se||!J)throw new Error(r.localize(0,null));const X=await this.pb(null,J,new b.ExtensionActivationTimesBuilder(!1));if(!X||typeof X.run!="function")throw new Error(r.localize(1,null,J.toString()));return new Promise((Z,he)=>{const Te=(Pe,Se)=>{Pe?he(Pe):Z(typeof Se=="number"&&Se>0?1:0)},Ne=(0,M.originalFSPath)(J),Ke=X.run(Ne,Te);Ke&&Ke.then&&Ke.then(()=>{Z(0)}).catch(Pe=>{he(Pe instanceof Error&&Pe.stack?Pe.stack:String(Pe))})})}kb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.gb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(se,J){return this.M[se]=J,(0,O.toDisposable)(()=>{delete this.M[se]})}async lb(se){const J=se.indexOf("+");if(J===-1)throw new Error("Not an authority that can be resolved!");const X=se.substr(0,J);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${X}`,!1),{authorityPrefix:X,resolver:this.M[X]}}async $resolveAuthority(se,J){const X=B.StopWatch.create(!1),Z=()=>`[resolveAuthority(${(0,d.getRemoteAuthorityPrefix)(se)},${J})][${X.elapsed()}ms] `,he=Se=>this.l.info(`${Z()}${Se}`),Te=(Se,Ie=void 0)=>this.l.error(`${Z()}${Se}`,Ie);he("activating resolver...");const{authorityPrefix:Ne,resolver:Ke}=await this.lb(se);if(!Ke)return Te("no resolver"),{type:"error",error:{code:d.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Ne}.`,detail:void 0}};const Pe=new S.IntervalTimer;try{he("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(Ke)),Pe.cancelAndSet(()=>he("waiting..."),1e3),he("invoking resolve()..."),D.mark(`code/extHost/willResolveAuthority/${Ne}`);const Se=await Ke.resolve(se,{resolveAttempt:J});D.mark(`code/extHost/didResolveAuthorityOK/${Ne}`),Pe.dispose(),he(`returned ${Se.host}:${Se.port}`);const Ie={authority:se,host:Se.host,port:Se.port,connectionToken:Se.connectionToken},oe={extensionHostEnv:Se.extensionHostEnv,isTrusted:Se.isTrusted,authenticationSession:Se.authenticationSessionForInitializingExtensions?{id:Se.authenticationSessionForInitializingExtensions.id,providerId:Se.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Ie,options:oe,tunnelInformation:{environmentTunnels:Se.environmentTunnels,features:Se.tunnelFeatures}}}}catch(Se){if(D.mark(`code/extHost/didResolveAuthorityError/${Ne}`),Pe.dispose(),Te("returned an error",Se),Se instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:Se._code,message:Se._message,detail:Se._detail}};throw Se}}async $getCanonicalURI(se,J){this.l.info(`$getCanonicalURI invoked for authority (${(0,d.getRemoteAuthorityPrefix)(se)})`);const{resolver:X}=await this.lb(se);if(!X)return null;const Z=T.URI.revive(J);if(typeof X.getCanonicalURI>"u")return Z;const he=await(0,S.asPromise)(()=>X.getCanonicalURI(Z));return he||Z}static mb(se,J,X){const Z=new h.ExtensionDescriptionRegistry(se.getAllExtensionDescriptions());Z.deltaExtensions(X.toAdd,X.toRemove);const he=(0,s.extensionIdentifiersArrayToSet)(J.getAllExtensionDescriptions().map(Ne=>Ne.identifier));for(const Ne of X.myToRemove)he.delete(w.ExtensionIdentifier.toKey(Ne));for(const Ne of X.myToAdd)he.add(w.ExtensionIdentifier.toKey(Ne));const Te=be(Z,he);return{globalRegistry:Z,myExtensions:Te}}$startExtensionHost(se){se.toAdd.forEach(Z=>Z.extensionLocation=T.URI.revive(Z.extensionLocation));const{globalRegistry:J,myExtensions:X}=Ui.mb(this.F,this.D,se);return this.F.set(J.getAllExtensionDescriptions()),this.D.set(X),this.kb()}$activateByEvent(se,J){return J===1?this.R(se,!1):this.z.wait().then(X=>this.R(se,!1))}async $activate(se,J){return await this.z.wait(),this.D.getExtensionDescription(se)?(await this.S(se,J),!0):!1}async $deltaExtensions(se){se.toAdd.forEach(Te=>Te.extensionLocation=T.URI.revive(Te.extensionLocation));const{globalRegistry:J,myExtensions:X}=Ui.mb(this.F,this.D,se),Z=await this.W(X);return(await this.getExtensionPathIndex()).setSearchTree(Z),this.F.set(J.getAllExtensionDescriptions()),this.D.set(X),Promise.resolve(void 0)}async $test_latency(se){return se}async $test_up(se){return se.byteLength}async $test_down(se){const J=A.VSBuffer.alloc(se),X=Math.random()%256;for(let Z=0;Z<se;Z++)J.writeUInt8(X,Z);return J}async $updateRemoteConnectionData(se){this.P=se,this.a.fire()}};j=qe([je(0,n.IInstantiationService),je(1,e.IHostUtils),je(2,g.IExtHostRpcService),je(3,o.IExtHostWorkspace),je(4,f.IExtHostConfiguration),je(5,N.ILogService),je(6,a.IExtHostInitDataService),je(7,t.IExtensionStoragePaths),je(8,u.IExtHostTunnelService),je(9,l.IExtHostTerminalService),je(10,L.IExtHostLocalizationService)],j),e.AbstractExtHostExtensionService=j;function le(ue,se){return{id:ue.identifier.value,name:ue.name,extensionVersion:ue.version,publisherDisplayName:ue.publisher,activationEvents:ue.activationEvents?ue.activationEvents.join(","):null,isBuiltin:ue.isBuiltin,reason:se.activationEvent,reasonId:se.extensionId.value}}e.IExtHostExtensionService=(0,n.createDecorator)("IExtHostExtensionService");class _{constructor(se,J,X,Z,he){P.set(this,void 0),F.set(this,void 0),H.set(this,void 0),Je(this,P,se,"f"),Je(this,F,J,"f"),Je(this,H,X.identifier,"f"),this.id=X.identifier.value,this.extensionUri=X.extensionLocation,this.extensionPath=k.normalize((0,M.originalFSPath)(X.extensionLocation)),this.packageJSON=X,this.extensionKind=Z,this.isFromDifferentExtensionHost=he}get isActive(){return Le(this,P,"f").isActivated(Le(this,H,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Le(this,P,"f").getExtensionExports(Le(this,H,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Le(this,P,"f").activateByIdWithErrors(Le(this,H,"f"),{startup:!1,extensionId:Le(this,F,"f"),activationEvent:"api"}),this.exports}}e.Extension=_,P=new WeakMap,F=new WeakMap,H=new WeakMap;function be(ue,se){return ue.getAllExtensionDescriptions().filter(J=>se.has(w.ExtensionIdentifier.toKey(J.identifier)))}class de{constructor(se){this.a=se}setSearchTree(se){this.a=se}findSubstr(se){return this.a.findSubstr(se)}forEach(se){return this.a.forEach(se)}}e.ExtensionPaths=de}),define(Ce[247],ke([1,0,82,2,5,32,27,25,17,26,3,33,50,11,10]),function(ie,e,r,k,D,M,S,O,y,T,N,E,f,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let o=class{constructor(v,i,d,n,a,t,g){this.c=v,this.d=i,this.e=d,this.f=n,this.g=a,this.h=t,this.i=g,this.a=new Map,this.b=[]}async install(){this.j(),r.mark("code/extHost/willWaitForConfig");const v=await this.f.getConfigProvider();r.mark("code/extHost/didWaitForConfig");const i=await this.g.getExtensionPathIndex();this.register(new h(this.c,i,this.d,v,this.i)),this.register(this.e.createInstance(p,i)),this.register(this.e.createInstance(s)),this.h.remote.isRemote&&this.register(this.e.createInstance(w,i,this.h.environment.appUriScheme))}register(v){if("nodeModuleName"in v)if(Array.isArray(v.nodeModuleName))for(const i of v.nodeModuleName)this.a.set(i,v);else this.a.set(v.nodeModuleName,v);typeof v.alternativeModuleName=="function"&&this.b.push(i=>v.alternativeModuleName(i))}};o=qe([je(2,N.IInstantiationService),je(3,M.IExtHostConfiguration),je(4,E.IExtHostExtensionService),je(5,T.IExtHostInitDataService),je(6,b.ILogService)],o),e.RequireInterceptor=o;let s=class rn{constructor(v){if(v.environment.appRoot&&rn.a.size){const i=(0,m.escapeRegExpCharacters)(this.c(v.environment.appRoot.fsPath)),d="[a-z0-9_.-]",n=`@${d}+\\/${d}+|${d}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${i}/${a}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(v){if(!this.b)return;const i=this.b.exec(this.c(v));if(!i)return;const[,d,n,a]=i,t=rn.a.get(n);if(t!==void 0)return console.warn(`${n} as been renamed to ${t}, please update your imports`),d+t+a}c(v){return v.replace(/\\/g,"/")}};s.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),s=qe([je(0,T.IExtHostInitDataService)],s);class h{constructor(v,i,d,n,a){this.c=v,this.d=i,this.e=d,this.f=n,this.g=a,this.nodeModuleName="vscode",this.a=new Map}load(v,i){const d=this.d.findSubstr(i);if(d){let n=this.a.get(O.ExtensionIdentifier.toKey(d.identifier));return n||(n=this.c(d,this.e,this.f),this.a.set(O.ExtensionIdentifier.toKey(d.identifier),n)),n}if(!this.b){let n="";this.d.forEach((a,t)=>n+=`	${t} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${n}`),this.b=this.c(S.nullExtensionDescription,this.e,this.f)}return this.b}}let p=class{constructor(v,i,d){this.d=v,this.nodeModuleName="keytar",this.a=i.getProxy(D.MainContext.MainThreadTelemetry);const{environment:n}=d,a=i.getProxy(D.MainContext.MainThreadKeytar);if(n.appRoot){let t=n.appRoot.fsPath;f.platform==="win32"&&(t=t.replace(/\\/g,"/")),t[t.length-1]==="/"&&(t=t.substr(0,t.length-1)),this.b=new Set,this.b.add(`${t}/node_modules.asar/keytar`),this.b.add(`${t}/node_modules/keytar`)}this.c={getPassword:(t,g)=>a.$getPassword(t,g),setPassword:(t,g,c)=>a.$setPassword(t,g,c),deletePassword:(t,g)=>a.$deletePassword(t,g),findPassword:t=>a.$findPassword(t),findCredentials(t){return a.$findCredentials(t)}}}load(v,i){const d=this.d.findSubstr(i);return this.a.$publicLog2("shimming.keytar",{extension:d?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(v){const i=v.length;if(i<=7||!this.b)return;const d=i-7;if((v.charAt(d)==="/"||v.charAt(d)==="\\")&&v.endsWith("keytar")&&(v=v.replace(/\\/g,"/"),this.b.has(v)))return"keytar"}};p=qe([je(1,y.IExtHostRpcService),je(2,T.IExtHostInitDataService)],p);let w=class{constructor(v,i,d){this.e=v,this.f=i,this.nodeModuleName=["open","opn"],this.d=d.getProxy(D.MainContext.MainThreadTelemetry);const n=d.getProxy(D.MainContext.MainThreadWindow);this.c=(a,t)=>{const g=k.URI.parse(a);return t?this.g(a,t):g.scheme==="http"||g.scheme==="https"?n.$openUri(g,a,{allowTunneling:!0}):g.scheme==="mailto"||g.scheme===this.f?n.$openUri(g,a,{}):this.g(a,t)}}load(v,i,d){const n=this.e.findSubstr(i);return n&&(this.a=n.identifier.value,this.h()),this.b=d(v),this.c}g(v,i){return this.i(),this.b(v,i)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};w=qe([je(2,y.IExtHostRpcService)],w)}),define(Ce[108],ke([1,0,85,6,19,50,3,57,58,33,7,31,188,32]),function(ie,e,r,k,D,M,S,O,y,T,N,E,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,S.createDecorator)("IExtHostVariableResolverProvider");class m extends f.AbstractVariableResolverService{constructor(h,p,w,A,v,i,d){function n(){if(w){const a=w.activeEditor();if(a)return a.document.uri;const t=A.tabGroups.all.find(g=>g.isActive)?.activeTab;if(t!==void 0){if(t.input instanceof N.TextDiffTabInput||t.input instanceof N.NotebookDiffEditorTabInput)return t.input.modified;if(t.input instanceof N.TextTabInput||t.input instanceof N.NotebookEditorTabInput||t.input instanceof N.CustomEditorTabInput)return t.input.uri}}}super({getFolderUri:a=>{const t=i.folders.filter(g=>g.name===a);if(t&&t.length>0)return t[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(a,t)=>v.getConfiguration(void 0,a).get(t),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const a=n();if(a)return D.normalize(a.fsPath)},getWorkspaceFolderPathForFile:()=>{if(p){const a=n();if(a){const t=p.getWorkspaceFolder(a);if(t)return D.normalize(t.uri.fsPath)}}},getSelectedText:()=>{if(w){const a=w.activeEditor();if(a&&!a.selection.isEmpty)return a.document.getText(a.selection)}},getLineNumber:()=>{if(w){const a=w.activeEditor();if(a)return String(a.selection.end.line+1)}},getExtension:a=>h.getExtension(a)},void 0,d?Promise.resolve(d):void 0,Promise.resolve(M.env))}}let o=class extends k.Disposable{constructor(h,p,w,A,v){super(),this.b=h,this.c=p,this.g=w,this.h=A,this.i=v,this.a=new r.Lazy(async()=>{const i=await this.h.getConfigProvider(),n={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async a=>{n.folders=await this.c.getWorkspaceFolders2()||[]})),new m(this.b,this.c,this.g,this.i,i,n,this.j())})}getResolver(){return this.a.value}j(){}};o=qe([je(0,T.IExtHostExtensionService),je(1,E.IExtHostWorkspace),je(2,O.IExtHostDocumentsAndEditors),je(3,b.IExtHostConfiguration),je(4,y.IExtHostEditorTabs)],o),e.ExtHostVariableResolverProviderService=o}),define(Ce[109],ke([1,0,16,4,9,2,3,5,58,33,17,7,31,181,183,32,108]),function(ie,e,r,k,D,M,S,O,y,T,N,E,f,b,m,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,S.createDecorator)("IExtHostDebugService");let h=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(n,a,t,g,c,u){this.D=a,this.E=t,this.F=g,this.G=c,this.H=u,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new k.Emitter,this.n=new k.Emitter,this.o=new k.Emitter,this.u=new k.Emitter,this.k=n.getProxy(O.MainContext.MainThreadDebugService),this.z=new k.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new w(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(l=>{l.onDidChange(C=>{this.I(l)}),this.I(l)})}asDebugSourceUri(n,a){const t=n;if(typeof t.sourceReference=="number"&&t.sourceReference>0){let g=`debug:${encodeURIComponent(t.path||"")}`,c="?";return a&&(g+=`${c}session=${encodeURIComponent(a.id)}`,c="&"),g+=`${c}ref=${t.sourceReference}`,M.URI.parse(g)}else{if(t.path)return M.URI.file(t.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(n){const a=[];for(const t of n.getAllExtensionDescriptions())if(t.contributes){const g=t.contributes.debuggers;if(g&&g.length>0)for(const c of g)(0,m.isDebuggerMainContribution)(c)&&a.push(c.type)}this.k.$registerDebugTypes(a)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const n=[];return this.w.forEach(a=>n.push(a)),n}addBreakpoints(n){this.T();const a=n.filter(c=>{const u=c.id;return this.w.has(u)?!1:(this.w.set(u,c),!0)});this.U(a,[],[]);const t=[],g=new Map;for(const c of a)if(c instanceof E.SourceBreakpoint){let u=g.get(c.location.uri.toString());u||(u={type:"sourceMulti",uri:c.location.uri,lines:[]},g.set(c.location.uri.toString(),u),t.push(u)),u.lines.push({id:c.id,enabled:c.enabled,condition:c.condition,hitCondition:c.hitCondition,logMessage:c.logMessage,line:c.location.range.start.line,character:c.location.range.start.character})}else c instanceof E.FunctionBreakpoint&&t.push({type:"function",id:c.id,enabled:c.enabled,hitCondition:c.hitCondition,logMessage:c.logMessage,condition:c.condition,functionName:c.functionName});return this.k.$registerBreakpoints(t)}removeBreakpoints(n){this.T();const a=n.filter(u=>this.w.delete(u.id));this.U([],a,[]);const t=a.filter(u=>u instanceof E.SourceBreakpoint).map(u=>u.id),g=a.filter(u=>u instanceof E.FunctionBreakpoint).map(u=>u.id),c=a.filter(u=>u instanceof E.DataBreakpoint).map(u=>u.id);return this.k.$unregisterBreakpoints(t,g,c)}startDebugging(n,a,t){return this.k.$startDebugging(n?n.uri:void 0,a,{parentSessionID:t.parentSession?t.parentSession.id:void 0,lifecycleManagedByParent:t.lifecycleManagedByParent,repl:t.consoleMode===E.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:t.noDebug,compact:t.compact,suppressSaveBeforeStart:t.suppressSaveBeforeStart,suppressDebugStatusbar:t.suppressDebugStatusbar??t.debugUI?.simple,suppressDebugToolbar:t.suppressDebugToolbar??t.debugUI?.simple,suppressDebugView:t.suppressDebugView??t.debugUI?.simple})}stopDebugging(n){return this.k.$stopDebugging(n?n.id:void 0)}registerDebugConfigurationProvider(n,a,t){if(!a)return new E.Disposable(()=>{});const g=this.d++;return this.f.push({type:n,handle:g,provider:a}),this.k.$registerDebugConfigurationProvider(n,t,!!a.provideDebugConfigurations,!!a.resolveDebugConfiguration,!!a.resolveDebugConfigurationWithSubstitutedVariables,g),new E.Disposable(()=>{this.f=this.f.filter(c=>c.provider!==a),this.k.$unregisterDebugConfigurationProvider(g)})}registerDebugAdapterDescriptorFactory(n,a,t){if(!t)return new E.Disposable(()=>{});if(!this.P(n,a))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${a}' debugger.`);if(this.M(a))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const g=this.g++;return this.h.push({type:a,handle:g,factory:t}),this.k.$registerDebugAdapterDescriptorFactory(a,g),new E.Disposable(()=>{this.h=this.h.filter(c=>c.factory!==t),this.k.$unregisterDebugAdapterDescriptorFactory(g)})}registerDebugAdapterTrackerFactory(n,a){if(!a)return new E.Disposable(()=>{});const t=this.i++;return this.j.push({type:n,handle:t,factory:a}),new E.Disposable(()=>{this.j=this.j.filter(g=>g.factory!==a)})}async $runInTerminal(n,a){return Promise.resolve(void 0)}async $substituteVariables(n,a){let t;const g=await this.W(n);return g&&(t={uri:g.uri,name:g.name,index:g.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(t,a)}J(n,a){if(n.type==="implementation")return new v(n.implementation)}K(){}async $startDASession(n,a){const t=this,g=await this.V(a);return this.R(this.M(g.type),g).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}' (extension might have failed to activate)`);const u=this.L(c),l=this.J(u,g);if(!l)throw new Error(`Couldn't create a debug adapter for type '${g.type}'.`);const C=l;return this.A.set(n,C),this.Q(g).then(R=>(R&&this.B.set(n,R),C.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const ee=V,K={type:"response",seq:0,command:ee.command,request_seq:ee.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const L=await this.C.sign(ee.arguments.value);K.body={signature:L},C.sendResponse(K)}else throw new Error("no signer")}catch(L){K.success=!1,K.message=L.message,C.sendResponse(K)}}else R&&R.onDidSendMessage&&R.onDidSendMessage(V),V=(0,m.convertToVSCPaths)(V,!0),t.k.$acceptDAMessage(n,V)}),C.onError(V=>{R&&R.onError&&R.onError(V),this.k.$acceptDAError(n,V.name,V.message,V.stack)}),C.onExit(V=>{R&&R.onExit&&R.onExit((0,D.withNullAsUndefined)(V),void 0),this.k.$acceptDAExit(n,(0,D.withNullAsUndefined)(V),void 0)}),R&&R.onWillStartSession&&R.onWillStartSession(),C.startSession()))})}$sendDAMessage(n,a){a=(0,m.convertToDAPaths)(a,!1);const t=this.B.get(n);t&&t.onWillReceiveMessage&&t.onWillReceiveMessage(a),this.A.get(n)?.sendMessage(a)}$stopDASession(n){const a=this.B.get(n);this.B.delete(n),a&&a.onWillStopSession&&a.onWillStopSession();const t=this.A.get(n);return this.A.delete(n),t?t.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(n){const a=[],t=[],g=[];if(n.added)for(const c of n.added){const u=c.id;if(u&&!this.w.has(u)){let l;if(c.type==="function")l=new E.FunctionBreakpoint(c.functionName,c.enabled,c.condition,c.hitCondition,c.logMessage);else if(c.type==="data")l=new E.DataBreakpoint(c.label,c.dataId,c.canPersist,c.enabled,c.hitCondition,c.condition,c.logMessage);else{const C=M.URI.revive(c.uri);l=new E.SourceBreakpoint(new E.Location(C,new E.Position(c.line,c.character)),c.enabled,c.condition,c.hitCondition,c.logMessage)}(0,E.setBreakpointId)(l,u),this.w.set(u,l),a.push(l)}}if(n.removed)for(const c of n.removed){const u=this.w.get(c);u&&(this.w.delete(c),t.push(u))}if(n.changed){for(const c of n.changed)if(c.id){const u=this.w.get(c.id);if(u){if(u instanceof E.FunctionBreakpoint&&c.type==="function"){const l=u;l.enabled=c.enabled,l.condition=c.condition,l.hitCondition=c.hitCondition,l.logMessage=c.logMessage,l.functionName=c.functionName}else if(u instanceof E.SourceBreakpoint&&c.type==="source"){const l=u;l.enabled=c.enabled,l.condition=c.condition,l.hitCondition=c.hitCondition,l.logMessage=c.logMessage,l.location=new E.Location(M.URI.revive(c.uri),new E.Position(c.line,c.character))}g.push(u)}}}this.U(a,t,g)}$provideDebugConfigurations(n,a,t){return(0,r.asPromise)(async()=>{const g=this.O(n);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const c=await this.W(a);return g.provideDebugConfigurations(c,t)}).then(g=>{if(!g)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return g})}$resolveDebugConfiguration(n,a,t,g){return(0,r.asPromise)(async()=>{const c=this.O(n);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const u=await this.W(a);return c.resolveDebugConfiguration(u,t,g)})}$resolveDebugConfigurationWithSubstitutedVariables(n,a,t,g){return(0,r.asPromise)(async()=>{const c=this.O(n);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const u=await this.W(a);return c.resolveDebugConfigurationWithSubstitutedVariables(u,t,g)})}async $provideDebugAdapter(n,a){const t=this.N(n);if(!t)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const g=await this.V(a);return this.R(t,g).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}'`);return this.L(c)})}async $acceptDebugSessionStarted(n){const a=await this.V(n);this.m.fire(a)}async $acceptDebugSessionTerminated(n){const a=await this.V(n);a&&(this.n.fire(a),this.l.delete(a.id))}async $acceptDebugSessionActiveChanged(n){this.q=n?await this.V(n):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(n,a){(await this.V(n))?._acceptNameChanged(a)}async $acceptDebugSessionCustomEvent(n,a){const g={session:await this.V(n),event:a.event,body:a.body};this.u.fire(g)}L(n){if(n instanceof E.DebugAdapterExecutable)return{type:"executable",command:n.command,args:n.args,options:n.options};if(n instanceof E.DebugAdapterServer)return{type:"server",port:n.port,host:n.host};if(n instanceof E.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:n.path};if(n instanceof E.DebugAdapterInlineImplementation)return{type:"implementation",implementation:n.implementation};throw new Error("convertToDto unexpected type")}M(n){const a=this.h.filter(t=>t.type===n);if(a.length>0)return a[0].factory}N(n){const a=this.h.filter(t=>t.handle===n);if(a.length>0)return a[0].factory}O(n){const a=this.f.filter(t=>t.handle===n);if(a.length>0)return a[0].provider}P(n,a){if(n.contributes){const t=n.contributes.debuggers;if(t&&t.length>0){for(const g of t)if(g.label&&g.type&&g.type===a)return!0}}return!1}Q(n){const t=n.configuration.type,g=this.j.filter(c=>c.type===t||c.type==="*").map(c=>(0,r.asPromise)(()=>c.factory.createDebugAdapterTracker(n)).then(u=>u,u=>null));return Promise.race([Promise.all(g).then(c=>{const u=c.filter(l=>!!l);if(u.length>0)return new A(u)}),new Promise(c=>setTimeout(()=>c(void 0),1e3))]).catch(c=>{})}async R(n,a){const t=a.configuration.debugServer;if(typeof t=="number")return Promise.resolve(new E.DebugAdapterServer(t));if(n){const c=await this.E.getExtensionRegistry();return(0,r.asPromise)(()=>n.createDebugAdapterDescriptor(a,this.S(a,c))).then(u=>{if(u)return u})}const g=await this.E.getExtensionRegistry();return Promise.resolve(this.S(a,g))}S(n,a){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(n,a,t){(n.length>0||a.length>0||t.length>0)&&this.z.fire(Object.freeze({added:n,removed:a,changed:t}))}async V(n){if(n)if(typeof n=="string"){const a=this.l.get(n);if(a)return a}else{let a=this.l.get(n.id);if(!a){const t=await this.W(n.folderUri),g=n.parent?this.l.get(n.parent):void 0;a=new p(this.k,n.id,n.type,n.name,t,n.configuration,g),this.l.set(a.id,a),this.k.$sessionCached(a.id)}return a}throw new Error("cannot find session")}W(n){if(n){const a=M.URI.revive(n);return this.D.resolveWorkspaceFolder(a)}return Promise.resolve(void 0)}};h=qe([je(0,N.IExtHostRpcService),je(1,f.IExtHostWorkspace),je(2,T.IExtHostExtensionService),je(3,o.IExtHostConfiguration),je(4,y.IExtHostEditorTabs),je(5,s.IExtHostVariableResolverProvider)],h),e.ExtHostDebugServiceBase=h;class p{constructor(n,a,t,g,c,u,l){this.d=n,this.f=a,this.g=t,this.h=g,this.i=c,this.j=u,this.k=l}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(n){this.h=n,this.d.$setDebugSessionName(this.f,n)}get parentSession(){return this.k}_acceptNameChanged(n){this.h=n}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(n,a){return this.d.$customDebugAdapterRequest(this.f,n,a)}getDebugProtocolBreakpoint(n){return this.d.$getDebugProtocolBreakpoint(this.f,n.id)}}e.ExtHostDebugSession=p;class w{constructor(n){this.value=Object.freeze({append(a){n.$appendDebugConsole(a)},appendLine(a){this.append(a+`
`)}})}}e.ExtHostDebugConsole=w;class A{constructor(n){this.d=n}onWillStartSession(){this.d.forEach(n=>n.onWillStartSession?n.onWillStartSession():void 0)}onWillReceiveMessage(n){this.d.forEach(a=>a.onWillReceiveMessage?a.onWillReceiveMessage(n):void 0)}onDidSendMessage(n){this.d.forEach(a=>a.onDidSendMessage?a.onDidSendMessage(n):void 0)}onWillStopSession(){this.d.forEach(n=>n.onWillStopSession?n.onWillStopSession():void 0)}onError(n){this.d.forEach(a=>a.onError?a.onError(n):void 0)}onExit(n,a){this.d.forEach(t=>t.onExit?t.onExit(n,a):void 0)}}class v extends b.AbstractDebugAdapter{constructor(n){super(),this.h=n,n.onDidSendMessage(a=>{this.acceptMessage(a)})}startSession(){return Promise.resolve(void 0)}sendMessage(n){this.h.handleMessage(n)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let i=class extends h{constructor(n,a,t,g,c,u){super(n,a,t,g,c,u)}};i=qe([je(0,N.IExtHostRpcService),je(1,f.IExtHostWorkspace),je(2,T.IExtHostExtensionService),je(3,o.IExtHostConfiguration),je(4,y.IExtHostEditorTabs),je(5,s.IExtHostVariableResolverProvider)],i),e.WorkerExtHostDebugService=i}),define(Ce[248],ke([1,0,12,82,2,5,239,11,66,67,26,159,17,54,33,74]),function(ie,e,r,k,D,M,S,O,y,T,N,E,f,b,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class s{static async installEarlyHandler(w){const A=w.get(O.ILogService),i=w.get(f.IExtHostRpcService).getProxy(M.MainContext.MainThreadErrors);r.setUnexpectedErrorHandler(d=>{A.error(d);const n=r.transformErrorForSerialization(d);i.$onUnexpectedError(n)})}static async installFullHandler(w){const A=w.get(O.ILogService),v=w.get(f.IExtHostRpcService),i=w.get(m.IExtHostExtensionService),d=w.get(o.IExtHostTelemetry),n=v.getProxy(M.MainContext.MainThreadExtensionService),a=v.getProxy(M.MainContext.MainThreadErrors),t=await i.getExtensionPathIndex(),g=new WeakMap;Error.prepareStackTrace=(c,u)=>{let l="",C,R;for(const V of u)l+=`
	at ${V.toString()}`,R=V.getFileName(),!C&&R&&(C=t.findSubstr(D.URI.file(R)));return g.set(c,C?.identifier),`${c.name||"Error"}: ${c.message||""}${l}`},r.setUnexpectedErrorHandler(c=>{A.error(c);const u=r.transformErrorForSerialization(c),l=g.get(c);if(!l){a.$onUnexpectedError(u);return}n.$onExtensionRuntimeError(l,u);const C=d.onExtensionError(l,c);A.trace("forwarded error to extension?",C,l)})}}Error.stackTraceLimit=100;class h{constructor(w,A,v,i,d){this.a=v,this.b=new S.RPCProtocol(w,null,i),A=h.e(A,this.b);const n=new T.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());n.set(N.IExtHostInitDataService,{_serviceBrand:void 0,...A,messagePorts:d}),n.set(f.IExtHostRpcService,new f.ExtHostRpcService(this.b)),n.set(b.IURITransformerService,new b.URITransformerService(i)),n.set(m.IHostUtils,v);const a=new E.InstantiationService(n,!0);a.invokeFunction(s.installEarlyHandler),this.d=a.invokeFunction(t=>t.get(O.ILogService)),k.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",A),this.c=a.invokeFunction(t=>t.get(m.IExtHostExtensionService)),this.c.initialize(),a.invokeFunction(s.installFullHandler)}async asBrowserUri(w){const A=this.b.getProxy(M.MainContext.MainThreadExtensionService);return D.URI.revive(await A.$asBrowserUri(w))}terminate(w){this.c.terminate(w)}static e(w,A){w.allExtensions.forEach(i=>{i.extensionLocation=D.URI.revive(A.transformIncomingURIs(i.extensionLocation));const d={};i.browserNlsBundleUris&&(Object.keys(i.browserNlsBundleUris).forEach(n=>d[n]=D.URI.revive(A.transformIncomingURIs(i.browserNlsBundleUris[n]))),i.browserNlsBundleUris=d)}),w.environment.appRoot=D.URI.revive(A.transformIncomingURIs(w.environment.appRoot));const v=w.environment.extensionDevelopmentLocationURI;return v&&(w.environment.extensionDevelopmentLocationURI=v.map(i=>D.URI.revive(A.transformIncomingURIs(i)))),w.environment.extensionTestsLocationURI=D.URI.revive(A.transformIncomingURIs(w.environment.extensionTestsLocationURI)),w.environment.globalStorageHome=D.URI.revive(A.transformIncomingURIs(w.environment.globalStorageHome)),w.environment.workspaceStorageHome=D.URI.revive(A.transformIncomingURIs(w.environment.workspaceStorageHome)),w.environment.extensionTelemetryLogResource=D.URI.revive(A.transformIncomingURIs(w.environment.extensionTelemetryLogResource)),w.nlsBaseUrl=D.URI.revive(A.transformIncomingURIs(w.nlsBaseUrl)),w.logsLocation=D.URI.revive(A.transformIncomingURIs(w.logsLocation)),w.logFile=D.URI.revive(A.transformIncomingURIs(w.logFile)),w.workspace=A.transformIncomingURIs(w.workspace),w}}e.ExtensionHostMain=h}),define(Ce[249],ke([1,0,18,16,21,39,15,19,24,2,46]),function(ie,e,r,k,D,M,S,O,y,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class E{constructor(p,w,A,v){this.d=p,this.e=w,this.f=A,this.g=v,this.a=null,this.b=!1,this.c=0}search(p,w){const A=this.d.folderQueries||[],v=new D.CancellationTokenSource;return w.onCancellationRequested(()=>v.cancel()),new Promise((i,d)=>{this.a=new b(p);let n=!1;const a=(t,g)=>{if(!n&&!this.b){const c=this.h(t);o(t)&&typeof this.d.maxResults=="number"&&this.c+c>this.d.maxResults&&(this.b=!0,n=!0,v.cancel(),t=this.j(t,this.d.maxResults-this.c));const u=this.h(t);this.c+=u,(u>0||!o(t))&&this.a.add(t,g)}};Promise.all(A.map((t,g)=>this.k(t,c=>a(c,g),v.token))).then(t=>{v.dispose(),this.a.flush();const g=t.some(c=>!!c&&!!c.limitHit);i({limitHit:this.b||g,messages:(0,r.flatten)(t.map(c=>c?.message?Array.isArray(c.message)?c.message:[c.message]:[])),stats:{type:this.g}})},t=>{v.dispose();const g=(0,M.toErrorMessage)(t);d(new Error(g))})})}h(p){return o(p)?Array.isArray(p.ranges)?p.ranges.length:1:0}j(p,w){const A=Array.isArray(p.ranges)?p.ranges:[p.ranges],v=Array.isArray(p.preview.matches)?p.preview.matches:[p.preview.matches];return{ranges:A.slice(0,w),preview:{matches:v.slice(0,w),text:p.preview.text},uri:p.uri}}async k(p,w,A){const v=new N.QueryGlobTester(this.d,p),i=[],d={report:t=>{if(!this.l(t))return;const g=p.folder.scheme===S.Schemas.file?(0,N.hasSiblingPromiseFn)(()=>this.f.readdir(y.dirname(t.uri))):void 0,c=y.relativePath(p.folder,t.uri);if(c){const u=v.includedInQuery(c,O.basename(c),g);(0,k.isThenable)(u)?i.push(u.then(l=>{l&&w(t)})):u&&w(t)}}},n=this.n(p),a=await this.e.provideTextSearchResults(f(this.d.contentPattern),n,d,A);return i.length&&await Promise.all(i),a}l(p){if(o(p)){if(Array.isArray(p.ranges)){if(!Array.isArray(p.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(p.preview.matches.length!==p.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(p.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(p){const w=(0,N.resolvePatternsForProvider)(this.d.includePattern,p.includePattern),A=(0,N.resolvePatternsForProvider)(this.d.excludePattern,p.excludePattern),v={folder:T.URI.from(p.folder),excludes:A,includes:w,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,encoding:p.fileEncoding&&this.f.toCanonicalName(p.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return v.usePCRE2=this.d.usePCRE2,v}}e.TextSearchManager=E;function f(h){return{isCaseSensitive:h.isCaseSensitive||!1,isRegExp:h.isRegExp||!1,isWordMatch:h.isWordMatch||!1,isMultiline:h.isMultiline||!1,pattern:h.pattern}}class b{constructor(p){this.e=p,this.b=-1,this.d=null,this.a=new s(512,w=>this.g(w))}add(p,w){this.d&&(this.b!==w||!y.isEqual(this.c,p.uri))&&(this.f(),this.d=null),this.d||(this.b=w,this.d={resource:p.uri,results:[]}),this.d.results.push(m(p))}f(){const p=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,p)}flush(){this.f(),this.a.flush()}g(p){this.e(p)}}e.TextSearchResultsCollector=b;function m(h){return o(h)?{preview:{matches:(0,r.mapArrayOrNot)(h.preview.matches,p=>({startLineNumber:p.start.line,startColumn:p.start.character,endLineNumber:p.end.line,endColumn:p.end.character})),text:h.preview.text},ranges:(0,r.mapArrayOrNot)(h.ranges,p=>({startLineNumber:p.start.line,startColumn:p.start.character,endLineNumber:p.end.line,endColumn:p.end.character}))}:{text:h.text,lineNumber:h.lineNumber}}function o(h){return!!h.preview}e.extensionResultIsMatch=o;class s{constructor(p,w){this.g=p,this.h=w,this.c=0,this.d=[],this.e=0}addItem(p,w){!p||this.j(p,w)}addItems(p,w){!p||this.k(p,w)}j(p,w){this.d.push(p),this.e+=w,this.l()}k(p,w){this.d=this.d.concat(p),this.e+=w,this.l()}l(){this.c<s.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},s.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.BatchedCollector=s,s.a=4e3,s.b=50}),define(Ce[110],ke([1,0,6,5,3,244,17,54,11,2,249]),function(ie,e,r,k,D,M,S,O,y,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let E=class{constructor(o,s,h){this.k=o,this.l=s,this.n=h,this.c=this.k.getProxy(k.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new M.FileSearchManager}o(o){return this.l.transformOutgoingScheme(o)}registerTextSearchProvider(o,s){if(this.g.has(o))throw new Error(`a text search provider for the scheme '${o}' is already registered`);this.g.add(o);const h=this.d++;return this.e.set(h,s),this.c.$registerTextSearchProvider(h,this.o(o)),(0,r.toDisposable)(()=>{this.g.delete(o),this.e.delete(h),this.c.$unregisterProvider(h)})}registerFileSearchProvider(o,s){if(this.i.has(o))throw new Error(`a file search provider for the scheme '${o}' is already registered`);this.i.add(o);const h=this.d++;return this.h.set(h,s),this.c.$registerFileSearchProvider(h,this.o(o)),(0,r.toDisposable)(()=>{this.i.delete(o),this.h.delete(h),this.c.$unregisterProvider(h)})}$provideFileSearchResults(o,s,h,p){const w=f(h),A=this.h.get(o);if(A)return this.j.fileSearch(w,A,v=>{this.c.$handleFileMatch(o,s,v.map(i=>i.resource))},p);throw new Error("unknown provider: "+o)}$clearCache(o){return this.j.clearCache(o),Promise.resolve(void 0)}$provideTextSearchResults(o,s,h,p){const w=this.e.get(o);if(!w||!w.provideTextSearchResults)throw new Error(`Unknown provider ${o}`);const A=f(h);return this.q(A,w).search(i=>this.c.$handleTextMatch(o,s,i),p)}$enableExtensionHostSearch(){}q(o,s){return new N.TextSearchManager(o,s,{readdir:h=>Promise.resolve([]),toCanonicalName:h=>h},"textSearchProvider")}};E=qe([je(0,S.IExtHostRpcService),je(1,O.IURITransformerService),je(2,y.ILogService)],E),e.ExtHostSearch=E;function f(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(b),extraFileResources:m.extraFileResources&&m.extraFileResources.map(o=>T.URI.revive(o))}}e.reviveQuery=f;function b(m){return{...m,folder:T.URI.revive(m.folder)}}}),define(Ce[250],ke([1,0,66,105,31,103,32,37,57,60,107,109,110,80,69,76,104,59,36,79,74,58,219,11,175,108,78]),function(ie,e,r,k,D,M,S,O,y,T,N,E,f,b,m,o,s,h,p,w,A,v,i,d,n,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.registerSingleton)(t.IExtHostLocalizationService,t.ExtHostLocalizationService,1),(0,r.registerSingleton)(d.ILoggerService,i.ExtHostLoggerService,1),(0,r.registerSingleton)(d.ILogService,n.ExtHostLogService,1),(0,r.registerSingleton)(o.IExtHostApiDeprecationService,o.ExtHostApiDeprecationService,1),(0,r.registerSingleton)(O.IExtHostCommands,O.ExtHostCommands,0),(0,r.registerSingleton)(S.IExtHostConfiguration,S.ExtHostConfiguration,0),(0,r.registerSingleton)(h.IExtHostConsumerFileSystem,h.ExtHostConsumerFileSystem,0),(0,r.registerSingleton)(E.IExtHostDebugService,E.WorkerExtHostDebugService,0),(0,r.registerSingleton)(M.IExtHostDecorations,M.ExtHostDecorations,0),(0,r.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,0),(0,r.registerSingleton)(p.IExtHostFileSystemInfo,p.ExtHostFileSystemInfo,0),(0,r.registerSingleton)(k.IExtHostOutputService,k.ExtHostOutputService,1),(0,r.registerSingleton)(f.IExtHostSearch,f.ExtHostSearch,0),(0,r.registerSingleton)(b.IExtHostStorage,b.ExtHostStorage,0),(0,r.registerSingleton)(N.IExtHostTask,N.WorkerExtHostTask,0),(0,r.registerSingleton)(T.IExtHostTerminalService,T.WorkerExtHostTerminalService,0),(0,r.registerSingleton)(m.IExtHostTunnelService,m.ExtHostTunnelService,0),(0,r.registerSingleton)(s.IExtHostWindow,s.ExtHostWindow,0),(0,r.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace,0),(0,r.registerSingleton)(w.IExtHostSecretState,w.ExtHostSecretState,0),(0,r.registerSingleton)(A.IExtHostTelemetry,A.ExtHostTelemetry,0),(0,r.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs,0),(0,r.registerSingleton)(a.IExtHostVariableResolverProvider,a.ExtHostVariableResolverProviderService,0)}),define(Ce[251],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class r{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(D){if(D&&this.a.has(D)){const M=this.a.get(D);return this.a.delete(D),M}}addDragOperationTransfer(D,M){this.a.set(D,M)}getRenderedTreeElement(D){if(this.b.has(D))return this.b.get(D)}addRenderedTreeItemElement(D,M){this.b.set(D,M)}removeRenderedTreeItemElement(D){this.b.has(D)&&this.b.delete(D)}}e.TreeviewsService=r}),define(Ce[252],ke([1,0,144,7,24,2,4,6,180,16,7,9,18,8,21,251,27]),function(ie,e,r,k,D,M,S,O,y,T,N,E,f,b,m,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(A,v){if((0,E.isString)(A))return{label:A};if(A&&typeof A=="object"&&typeof A.label=="string"){let i;return Array.isArray(A.highlights)&&(i=A.highlights.filter(d=>d.length===2&&typeof d[0]=="number"&&typeof d[1]=="number"),i=i.length?i:void 0),{label:A.label,highlights:i}}}class p{constructor(v,i,d){this.d=v,this.e=i,this.f=d,this.a=new Map,this.b=new o.TreeviewsService;function n(a){return a&&a.$treeViewId&&(a.$treeItemHandle||a.$selectedTreeItems||a.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:a=>n(a)?this.i(a):Array.isArray(a)&&a.length>0?a.map(t=>n(t)?this.i(t):t):a})}registerTreeDataProvider(v,i,d){const n=this.createTreeView(v,{treeDataProvider:i},d);return{dispose:()=>n.dispose()}}createTreeView(v,i,d){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const n=i.dragAndDropController?.dropMimeTypes??[],a=i.dragAndDropController?.dragMimeTypes??[],t=!!i.dragAndDropController?.handleDrag,g=!!i.dragAndDropController?.handleDrop,c=this.h(v,i,d),u=this.d.$registerTreeViewDataProvider(v,{showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:n,dragMimeTypes:a,hasHandleDrag:t,hasHandleDrop:g});return{get onDidCollapseElement(){return c.onDidCollapseElement},get onDidExpandElement(){return c.onDidExpandElement},get selection(){return c.selectedElements},get onDidChangeSelection(){return c.onDidChangeSelection},get visible(){return c.visible},get onDidChangeVisibility(){return c.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,s.checkProposedApiEnabled)(d,"treeItemCheckbox"),c.onDidChangeCheckboxState},get message(){return c.message},set message(l){c.message=l},get title(){return c.title},set title(l){c.title=l},get description(){return c.description},set description(l){c.description=l},get badge(){return c.badge},set badge(l){l!==void 0&&N.ViewBadge.isViewBadge(l)?c.badge={value:Math.floor(Math.abs(l.value)),tooltip:l.tooltip}:l===void 0&&(c.badge=void 0)},reveal:(l,C)=>c.reveal(l,C),dispose:async()=>{await u,this.a.delete(v),c.dispose()}}}$getChildren(v,i){const d=this.a.get(v);return d?d.getChildren(i):Promise.reject(new y.NoTreeViewError(v))}async $handleDrop(v,i,d,n,a,t,g,c){const u=this.a.get(v);if(!u)return Promise.reject(new y.NoTreeViewError(v));const l=b.DataTransfer.toDataTransfer(d,async C=>(await this.d.$resolveDropFileData(v,i,C)).buffer);return g===v&&c&&await this.g(l,u,c,a,t),u.onDrop(l,n,a)}async g(v,i,d,n,a){const t=this.b.removeDragOperationTransfer(a);if(t)(await t)?.forEach((g,c)=>{g&&v.set(c,g)});else if(a&&i.handleDrag){const g=i.handleDrag(d,v,n);this.b.addDragOperationTransfer(a,g),await g}return v}async $handleDrag(v,i,d,n){const a=this.a.get(v);if(!a)return Promise.reject(new y.NoTreeViewError(v));const t=await this.g(new k.DataTransfer,a,i,n,d);if(!!t)return b.DataTransfer.toDataTransferDTO(t)}async $hasResolve(v){const i=this.a.get(v);if(!i)throw new y.NoTreeViewError(v);return i.hasResolve}$resolve(v,i,d){const n=this.a.get(v);if(!n)throw new y.NoTreeViewError(v);return n.resolveTreeItem(i,d)}$setExpanded(v,i,d){const n=this.a.get(v);if(!n)throw new y.NoTreeViewError(v);n.setExpanded(i,d)}$setSelection(v,i){const d=this.a.get(v);if(!d)throw new y.NoTreeViewError(v);d.setSelection(i)}$setFocus(v,i){const d=this.a.get(v);if(!d)throw new y.NoTreeViewError(v);d.setFocus(i)}$setVisible(v,i){const d=this.a.get(v);if(!d)throw new y.NoTreeViewError(v);d.setVisible(i)}$changeCheckboxState(v,i){const d=this.a.get(v);if(!d)throw new y.NoTreeViewError(v);d.setCheckboxState(i)}h(v,i,d){const n=new w(v,i,this.d,this.e.converter,this.f,d);return this.a.set(v,n),n}i(v){const i=this.a.get(v.$treeViewId);return i&&"$treeItemHandle"in v?i.getExtensionElement(v.$treeItemHandle):i&&"$focusedTreeItem"in v&&v.$focusedTreeItem?i.focusedElement:null}}e.ExtHostTreeViews=p;class w extends O.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(v=>this.getExtensionElement(v)).filter(v=>!(0,E.isUndefinedOrNull)(v))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(v,i,d,n,a,t){if(super(),this.C=v,this.D=d,this.F=n,this.G=a,this.H=t,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new S.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new S.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new S.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new S.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new S.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new S.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new m.CancellationTokenSource,t.contributes&&t.contributes.views)for(const u in t.contributes.views)for(const l of t.contributes.views[u])l.id===v&&(this.J=l.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(u=>this.w.fire({message:!1,element:u})));let g,c;this.B(S.Event.debounce(this.w.event,(u,l)=>(u||(u={message:!1,elements:[]}),l.element!==!1&&(g||(g=new Promise(C=>c=C),this.y=this.y.then(()=>g)),Array.isArray(l.element)?u.elements.push(...l.element):u.elements.push(l.element)),l.message&&(u.message=!0),u),200,!0)(({message:u,elements:l})=>{l.length&&(this.z=this.z.then(()=>{const C=c;return g=null,this.U(l).then(()=>C())})),u&&this.D.$setMessage(this.C,this.I)}))}async getChildren(v){const i=v?this.getExtensionElement(v):void 0;if(v&&!i)return this.G.error(`No tree item with id '${v}' found.`),Promise.resolve([]);let d=this.Q(v);return d||(d=await this.R(i)),d?d.map(n=>n.item):void 0}getExtensionElement(v){return this.i.get(v)}reveal(v,i){i=i||{select:!0,focus:!1};const d=(0,E.isUndefinedOrNull)(i.select)?!0:i.select,n=(0,E.isUndefinedOrNull)(i.focus)?!1:i.focus,a=(0,E.isUndefinedOrNull)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.y.then(()=>this.N(v)).then(t=>this.P(v,t[t.length-1]).then(g=>this.D.$reveal(this.C,{item:g.item,parentChain:t.map(c=>c.item)},{select:d,focus:n,expand:a})),t=>this.G.error(t)):this.D.$reveal(this.C,void 0,{select:d,focus:n,expand:a})}get message(){return this.I}set message(v){this.I=v,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(v){this.J=v,this.D.$setTitle(this.C,v,this.L)}get description(){return this.L}set description(v){this.L=v,this.D.$setTitle(this.C,this.J,v)}get badge(){return this.M}set badge(v){this.M?.value===v?.value&&this.M?.tooltip===v?.tooltip||(this.M=b.ViewBadge.from(v),this.D.$setBadge(this.C,v))}setExpanded(v,i){const d=this.getExtensionElement(v);d&&(i?this.r.fire(Object.freeze({element:d})):this.s.fire(Object.freeze({element:d})))}setSelection(v){(0,f.equals)(this.l,v)||(this.l=v,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(v){this.m=v}setVisible(v){v!==this.k&&(this.k=v,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(v){const i=(await Promise.all(v.map(async d=>{const n=this.getExtensionElement(d.treeItemHandle);return n?{extensionItem:n,treeItem:await this.f.getTreeItem(n),newState:d.newState?N.TreeItemCheckboxState.Checked:N.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(d=>d!==void 0);i.forEach(d=>{d.treeItem.checkboxState=d.newState?N.TreeItemCheckboxState.Checked:N.TreeItemCheckboxState.Unchecked}),this.v.fire({items:i.map(d=>[d.extensionItem,d.newState])})}async handleDrag(v,i,d){const n=[];for(const a of v){const t=this.getExtensionElement(a);t&&n.push(t)}if(!(!this.g?.handleDrag||n.length===0))return await this.g.handleDrag(n,i,d),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(v,i,d){const n=i?this.getExtensionElement(i):void 0;if(!(!n&&i||!this.g?.handleDrop))return(0,T.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(n,v,d):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(v,i){if(!this.f.resolveTreeItem)return;const d=this.i.get(v);if(d){const n=this.j.get(d);if(n){const a=await this.f.resolveTreeItem(n.extensionItem,d,i)??n.extensionItem;return this.db(a),n.item.tooltip=this.ab(a.tooltip),n.item.command=this.bb(n.disposableStore,a.command),n.item}}}N(v){return this.O(v).then(i=>i?this.N(i).then(d=>this.P(i,d[d.length-1]).then(n=>(d.push(n),d))):Promise.resolve([]))}O(v){const i=this.j.get(v);return i?Promise.resolve(i.parent?this.i.get(i.parent.item.handle):void 0):(0,T.asPromise)(()=>this.f.getParent(v))}P(v,i){const d=this.j.get(v);return d?Promise.resolve(d):(0,T.asPromise)(()=>this.f.getTreeItem(v)).then(n=>this.gb(v,n,i,!0)).then(n=>this.getChildren(i?i.item.handle:void 0).then(()=>{const a=this.getExtensionElement(n);if(a){const t=this.j.get(a);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${n}`)}))}Q(v){if(v){let i;if(typeof v=="string"){const d=this.getExtensionElement(v);i=d?this.j.get(d):void 0}else i=v;return i&&i.children||void 0}return this.h}async R(v){this.nb(v);const i=new m.CancellationTokenSource(this.S.token);try{const d=v?this.j.get(v):void 0,n=await this.f.getChildren(v);if(i.token.isCancellationRequested)return;const a=await Promise.all((0,f.coalesce)(n||[]).map(async t=>{const g=await this.f.getTreeItem(t);return g&&!i.token.isCancellationRequested?this.Z(t,g,d):null}));return i.token.isCancellationRequested?void 0:(0,f.coalesce)(a)}finally{i.dispose()}}U(v){if(v.some(d=>!d))return this.S.dispose(!0),this.S=new m.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const d=this.W(v);if(d.length)return this.X(d)}return Promise.resolve(void 0)}W(v){const i=new Set,d=v.map(a=>this.j.get(a));for(const a of d)if(a&&!i.has(a.item.handle)){let t=a;for(;t&&t.parent&&d.findIndex(g=>t&&t.parent&&g&&g.item.handle===t.parent.item.handle)===-1;){const g=this.i.get(t.parent.item.handle);t=g?this.j.get(g):void 0}t&&!t.parent&&i.add(a.item.handle)}const n=[];return i.forEach(a=>{const t=this.i.get(a);if(t){const g=this.j.get(t);g&&(!g.parent||!i.has(g.parent.item.handle))&&n.push(a)}}),n}X(v){const i={};return Promise.all(v.map(d=>this.Y(d).then(n=>{n&&(i[d]=n.item)}))).then(()=>Object.keys(i).length?this.D.$refresh(this.C,i):void 0)}Y(v){const i=this.getExtensionElement(v);if(i){const d=this.j.get(i);if(d)return this.nb(i),(0,T.asPromise)(()=>this.f.getTreeItem(i)).then(n=>{if(n){const a=this.eb(i,n,d.parent);return this.lb(i,a,d,d.parent),d.dispose(),a}return null})}return Promise.resolve(null)}Z(v,i,d){const n=this.eb(v,i,d);if(i.id&&this.i.has(n.item.handle))throw new Error((0,r.localize)(0,null,i.id));return this.kb(v,n),this.mb(n,d),n}ab(v){return N.MarkdownString.isMarkdownString(v)?b.MarkdownString.from(v):v}bb(v,i){return i?{...this.F.toInternal(i,v),originalId:i.command}:void 0}cb(v){if(!v.checkboxState)return;let i,d;return typeof v.checkboxState=="number"?i=v.checkboxState:(i=v.checkboxState.state,d=v.checkboxState.tooltip),{isChecked:i===N.TreeItemCheckboxState.Checked,tooltip:d}}db(v){if(!N.TreeItem.isTreeItem(v,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(v,i,d){this.db(i);const n=new O.DisposableStore,a=this.gb(v,i,d),t=this.hb(i);return{item:{handle:a,parentHandle:d?d.item.handle:void 0,label:h(i.label,this.H),description:i.description,resourceUri:i.resourceUri,tooltip:this.ab(i.tooltip),command:this.bb(n,i.command),contextValue:i.contextValue,icon:t,iconDark:this.ib(i)||t,themeIcon:this.fb(i),collapsibleState:(0,E.isUndefinedOrNull)(i.collapsibleState)?N.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.cb(i)},extensionItem:i,parent:d,children:void 0,disposableStore:n,dispose(){n.dispose()}}}fb(v){return v.iconPath instanceof N.ThemeIcon?v.iconPath:void 0}gb(v,{id:i,label:d,resourceUri:n},a,t){if(i)return`${w.b}/${i}`;const g=h(d,this.H),c=a?a.item.handle:w.a;let u=g?g.label:n?(0,D.basename)(n):"";u=u.indexOf("/")!==-1?u.replace("/","//"):u;const l=this.j.has(v)?this.j.get(v).item.handle:void 0,C=this.Q(a)||[];let R,V=0;do{if(R=`${c}/${V}:${u}`,t||!this.i.has(R)||l===R)break;V++}while(V<=C.length);return R}hb(v){if(v.iconPath&&!(v.iconPath instanceof N.ThemeIcon))return typeof v.iconPath=="string"||M.URI.isUri(v.iconPath)?this.jb(v.iconPath):this.jb(v.iconPath.light)}ib(v){if(v.iconPath&&!(v.iconPath instanceof N.ThemeIcon)&&v.iconPath.dark)return this.jb(v.iconPath.dark)}jb(v){return M.URI.isUri(v)?v:M.URI.file(v)}kb(v,i){this.i.set(i.item.handle,v),this.j.set(v,i)}lb(v,i,d,n){this.i.delete(i.item.handle),this.j.delete(v),i.item.handle!==d.item.handle&&this.i.delete(d.item.handle),this.kb(v,i);const a=this.Q(n)||[],t=a.filter(g=>g.item.handle===d.item.handle)[0];t&&a.splice(a.indexOf(t),1,i)}mb(v,i){i?(i.children||(i.children=[]),i.children.push(v)):(this.h||(this.h=[]),this.h.push(v))}nb(v){if(v){const i=this.j.get(v);if(i){if(i.children)for(const d of i.children){const n=this.i.get(d.item.handle);n&&this.ob(n)}i.children=void 0}}else this.pb()}ob(v){const i=this.j.get(v);if(i){if(i.children)for(const d of i.children){const n=this.i.get(d.item.handle);n&&this.ob(n)}this.j.delete(v),this.i.delete(i.item.handle),i.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(v=>v.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}w.a="0",w.b="1"}),define(Ce[253],ke([1,0,21,12,4,29,2,130,262,118,128,43,5,73,206,205,37,207,32,209,210,211,194,212,57,33,213,214,217,218,220,105,197,226,227,228,80,60,231,252,8,7,51,234,61,104,31,186,216,49,103,107,109,110,11,54,17,26,221,192,69,76,203,232,81,59,237,235,236,204,36,229,233,79,58,74,222,106,223,15,92,196,177,215,6,27,182,78,173,224,225]),function(ie,e,r,k,D,M,S,O,y,T,N,E,f,b,m,o,s,h,p,w,A,v,i,d,n,a,t,g,c,u,l,C,R,V,ee,K,L,B,P,F,H,j,le,_,be,de,ue,se,J,X,Z,he,Te,Ne,Ke,Pe,Se,Ie,oe,ce,Y,I,$,W,q,te,fe,ye,ae,ve,Ee,We,He,tt,Xe,et,it,dt,Fe,ot,Q,x,pe,Me,ze,Ve,_e,nt,vt,wt,Ct){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function jt(rt){const mt=rt.get(Ie.IExtHostInitDataService),Ft=rt.get(Ee.IExtHostFileSystemInfo),xt=rt.get(te.IExtHostConsumerFileSystem),Pt=rt.get(a.IExtHostExtensionService),ht=rt.get(ue.IExtHostWorkspace),kt=rt.get(et.IExtHostTelemetry),$t=rt.get(p.IExtHostConfiguration),Ot=rt.get(Pe.IURITransformerService),xe=rt.get(Se.IExtHostRpcService),Nt=rt.get(L.IExtHostStorage),Mt=rt.get(q.IExtensionStoragePaths),zt=rt.get(Ke.ILoggerService),ft=rt.get(Ke.ILogService),De=rt.get(Y.IExtHostTunnelService),Ae=rt.get(I.IExtHostApiDeprecationService),ge=rt.get(de.IExtHostWindow),G=rt.get(tt.IExtHostSecretState),Re=rt.get(Xe.IExtHostEditorTabs);xe.set(f.ExtHostContext.ExtHostFileSystemInfo,Ft),xe.set(f.ExtHostContext.ExtHostLogLevelServiceShape,zt),xe.set(f.ExtHostContext.ExtHostWorkspace,ht),xe.set(f.ExtHostContext.ExtHostConfiguration,$t),xe.set(f.ExtHostContext.ExtHostExtensionService,Pt),xe.set(f.ExtHostContext.ExtHostStorage,Nt),xe.set(f.ExtHostContext.ExtHostTunnelService,De),xe.set(f.ExtHostContext.ExtHostWindow,ge),xe.set(f.ExtHostContext.ExtHostSecretState,G),xe.set(f.ExtHostContext.ExtHostTelemetry,kt),xe.set(f.ExtHostContext.ExtHostEditorTabs,Re);const $e=xe.set(f.ExtHostContext.ExtHostDecorations,rt.get(Z.IExtHostDecorations)),Qe=xe.set(f.ExtHostContext.ExtHostDocumentsAndEditors,rt.get(n.IExtHostDocumentsAndEditors)),Be=xe.set(f.ExtHostContext.ExtHostCommands,rt.get(s.IExtHostCommands)),Ze=xe.set(f.ExtHostContext.ExtHostTerminalService,rt.get(B.IExtHostTerminalService)),ct=xe.set(f.ExtHostContext.ExtHostDebugService,rt.get(Te.IExtHostDebugService)),Tt=xe.set(f.ExtHostContext.ExtHostSearch,rt.get(Ne.IExtHostSearch)),bt=xe.set(f.ExtHostContext.ExtHostTask,rt.get(he.IExtHostTask)),Et=xe.set(f.ExtHostContext.ExtHostOutputService,rt.get(C.IExtHostOutputService)),It=xe.set(f.ExtHostContext.ExtHostLocalization,rt.get(nt.IExtHostLocalizationService)),St=xe.set(f.ExtHostContext.ExtHostUrls,new _.ExtHostUrls(xe)),yt=xe.set(f.ExtHostContext.ExtHostDocuments,new d.ExtHostDocuments(xe,Qe)),qt=xe.set(f.ExtHostContext.ExtHostDocumentContentProviders,new v.ExtHostDocumentContentProvider(xe,Qe,ft)),Jt=xe.set(f.ExtHostContext.ExtHostDocumentSaveParticipant,new i.ExtHostDocumentSaveParticipant(ft,yt,xe.getProxy(f.MainContext.MainThreadBulkEdits))),pt=xe.set(f.ExtHostContext.ExtHostNotebook,new oe.ExtHostNotebookController(xe,Be,Qe,yt)),si=xe.set(f.ExtHostContext.ExtHostNotebookDocuments,new pe.ExtHostNotebookDocuments(pt)),oi=xe.set(f.ExtHostContext.ExtHostNotebookEditors,new x.ExtHostNotebookEditors(ft,pt)),Zt=xe.set(f.ExtHostContext.ExtHostNotebookKernels,new it.ExtHostNotebookKernels(xe,mt,pt,Be,ft)),vi=xe.set(f.ExtHostContext.ExtHostNotebookRenderers,new Fe.ExtHostNotebookRenderers(xe,pt)),At=xe.set(f.ExtHostContext.ExtHostEditors,new P.ExtHostEditors(xe,Qe)),Wt=xe.set(f.ExtHostContext.ExtHostTreeViews,new F.ExtHostTreeViews(xe.getProxy(f.MainContext.MainThreadTreeViews),Be,ft)),bi=xe.set(f.ExtHostContext.ExtHostEditorInsets,new se.ExtHostEditorInsets(xe.getProxy(f.MainContext.MainThreadEditorInsets),At,mt.remote)),ai=xe.set(f.ExtHostContext.ExtHostDiagnostics,new w.ExtHostDiagnostics(xe,ft,Ft,Qe)),ei=xe.set(f.ExtHostContext.ExtHostLanguages,new u.ExtHostLanguages(xe,yt,Be.converter,Ot)),ut=xe.set(f.ExtHostContext.ExtHostLanguageFeatures,new c.ExtHostLanguageFeatures(xe,Ot,yt,Be,ai,ft,Ae,kt)),$i=xe.set(f.ExtHostContext.ExtHostFileSystem,new t.ExtHostFileSystem(xe,ut)),Ut=xe.set(f.ExtHostContext.ExtHostFileSystemEventService,new g.ExtHostFileSystemEventService(xe,ft,Qe)),Qt=xe.set(f.ExtHostContext.ExtHostQuickOpen,(0,V.createExtHostQuickOpen)(xe,ht,Be)),ci=xe.set(f.ExtHostContext.ExtHostSCM,new ee.ExtHostSCM(xe,Be,ft)),Ei=xe.set(f.ExtHostContext.ExtHostQuickDiff,new Ct.ExtHostQuickDiff(xe,Ot)),wi=xe.set(f.ExtHostContext.ExtHostComments,(0,h.createExtHostComments)(xe,Be,yt)),ui=xe.set(f.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(xe.getProxy(f.MainContext.MainThreadProgress))),Si=xe.set(f.ExtHostContext.ExtHosLabelService,new J.ExtHostLabelService(xe)),li=xe.set(f.ExtHostContext.ExtHostTheming,new ce.ExtHostTheming(xe)),ti=xe.set(f.ExtHostContext.ExtHostAuthentication,new $.ExtHostAuthentication(xe)),Bi=xe.set(f.ExtHostContext.ExtHostTimeline,new W.ExtHostTimeline(xe,Be)),ii=xe.set(f.ExtHostContext.ExtHostWebviews,new be.ExtHostWebviews(xe,mt.remote,ht,ft,Ae)),ni=xe.set(f.ExtHostContext.ExtHostWebviewPanels,new ae.ExtHostWebviewPanels(xe,ii,ht)),yi=xe.set(f.ExtHostContext.ExtHostCustomEditors,new ye.ExtHostCustomEditors(xe,yt,Mt,ii,ni)),Di=xe.set(f.ExtHostContext.ExtHostWebviewViews,new fe.ExtHostWebviewViews(xe,ii)),ri=xe.set(f.ExtHostContext.ExtHostTesting,new We.ExtHostTesting(xe,Be,Qe)),Ii=xe.set(f.ExtHostContext.ExtHostUriOpeners,new He.ExtHostUriOpeners(xe)),Ci=xe.set(f.ExtHostContext.ExtHostProfileContentHandlers,new wt.ExtHostProfileContentHandlers(xe));xe.set(f.ExtHostContext.ExtHostInteractive,new Me.ExtHostInteractive(xe,pt,Qe,Be,ft));const zi=Object.values(f.ExtHostContext);xe.assertRegistered(zi);const Wi=new ve.ExtHostBulkEdits(xe,Qe),Hi=new o.ExtHostClipboard(xe),ki=new l.ExtHostMessageService(xe,ft),Ri=new A.ExtHostDialogs(xe),Oi=new K.ExtHostStatusBar(xe,Be.converter);return m.ExtHostApiCommands.register(Be),function(Ue,Ht,Li){const gt=function(){let re=!Ue.isUnderDevelopment;function me(){re||(ft.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function Oe(st){if(Array.isArray(st))st.forEach(Oe);else if(typeof st=="string")me();else{const Dt=st;typeof Dt.scheme>"u"&&me(),typeof Dt.exclusive=="boolean"&&(0,Ve.checkProposedApiEnabled)(Ue,"documentFiltersExclusive")}return st}}(),Vi={getSession(re,me,Oe){return ti.getSession(Ue,re,me,Oe)},async hasSession(re,me){return(0,Ve.checkProposedApiEnabled)(Ue,"authSession"),!!await ti.getSession(Ue,re,me,{silent:!0})},get onDidChangeSessions(){return ti.onDidChangeSessions},registerAuthenticationProvider(re,me,Oe,st){return ti.registerAuthenticationProvider(re,me,Oe,st)}},di={registerCommand(re,me,Oe){return Be.registerCommand(!0,re,me,Oe,void 0,Ue)},registerTextEditorCommand(re,me,Oe){return Be.registerCommand(!0,re,(...st)=>{const Dt=At.getActiveTextEditor();if(!Dt){ft.warn("Cannot execute "+re+" because there is no active text editor.");return}return Dt.edit(Rt=>{me.apply(Oe,[Dt,Rt,...st])}).then(Rt=>{Rt||ft.warn("Edits from command "+re+" were not applied.")},Rt=>{ft.warn("An error occurred while running command "+re,Rt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(re,me,Oe)=>((0,Ve.checkProposedApiEnabled)(Ue,"diffCommand"),Be.registerCommand(!0,re,async(...st)=>{const Dt=Qe.activeEditor(!0);if(!Dt){ft.warn("Cannot execute "+re+" because there is no active text editor.");return}const Rt=await At.getDiffInformation(Dt.id);me.apply(Oe,[Rt,...st])},void 0,void 0,Ue)),executeCommand(re,...me){return Be.executeCommand(re,...me)},getCommands(re=!1){return Be.getCommands(re)}},Fi={get machineId(){return mt.telemetryInfo.machineId},get sessionId(){return mt.telemetryInfo.sessionId},get language(){return mt.environment.appLanguage},get appName(){return mt.environment.appName},get appRoot(){return mt.environment.appRoot?.fsPath??""},get appHost(){return mt.environment.appHost},get uriScheme(){return mt.environment.appUriScheme},get clipboard(){return Hi.value},get shell(){return Ze.getDefaultShell(!1)},get onDidChangeShell(){return(0,Ve.checkProposedApiEnabled)(Ue,"envShellEvent"),Ze.onDidChangeShell},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(Ue,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(Ue,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.isNewAppInstall)(mt.telemetryInfo.firstSessionDate)},createTelemetryLogger(re){return et.ExtHostTelemetryLogger.validateSender(re),kt.instantiateLogger(Ue,re)},openExternal(re,me){return ge.openUri(re,{allowTunneling:!!mt.remote.authority,allowContributedOpeners:me?.allowContributedOpeners})},async asExternalUri(re){if(re.scheme===mt.environment.appUriScheme)return St.createAppUri(re);try{return await ge.asExternalUri(re,{allowTunneling:!!mt.remote.authority})}catch(me){if((0,Q.matchesScheme)(re,ot.Schemas.http)||(0,Q.matchesScheme)(re,ot.Schemas.https))return re;throw me}},get remoteName(){return(0,X.getRemoteName)(mt.remote.authority)},get remoteAuthority(){return(0,Ve.checkProposedApiEnabled)(Ue,"resolvers"),mt.remote.authority},get uiKind(){return mt.uiKind},get logLevel(){return ft.getLevel()},get onDidChangeLogLevel(){return ft.onDidChangeLogLevel}};mt.environment.extensionTestsLocationURI||Object.freeze(Fi);const ji={createTestController(re,me,Oe){return ri.createTestController(Ue,re,me,Oe)},createTestObserver(){return(0,Ve.checkProposedApiEnabled)(Ue,"testObserver"),ri.createTestObserver()},runTests(re){return(0,Ve.checkProposedApiEnabled)(Ue,"testObserver"),ri.runTests(re)},get onDidChangeTestResults(){return(0,Ve.checkProposedApiEnabled)(Ue,"testObserver"),ri.onResultsChanged},get testResults(){return(0,Ve.checkProposedApiEnabled)(Ue,"testObserver"),ri.results}},hi=mt.remote.isRemote?j.ExtensionKind.Workspace:j.ExtensionKind.UI,qi={getExtension(re,me){(0,Ve.isProposedApiEnabled)(Ue,"extensionsAny")||(me=!1);const Oe=Ht.mine.getExtensionDescription(re);if(Oe)return new a.Extension(Pt,Ue.identifier,Oe,hi,!1);if(me){const st=Ht.all.getExtensionDescription(re);if(st)return new a.Extension(Pt,Ue.identifier,st,hi,!0)}},get all(){const re=[];for(const me of Ht.mine.getAllExtensionDescriptions())re.push(new a.Extension(Pt,Ue.identifier,me,hi,!1));return re},get allAcrossExtensionHosts(){(0,Ve.checkProposedApiEnabled)(Ue,"extensionsAny");const re=new Ve.ExtensionIdentifierSet(Ht.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),me=[];for(const Oe of Ht.all.getAllExtensionDescriptions()){const st=!re.has(Oe.identifier);me.push(new a.Extension(Pt,Ue.identifier,Oe,hi,st))}return me},get onDidChange(){return(0,Ve.isProposedApiEnabled)(Ue,"extensionsAny")?D.Event.any(Ht.mine.onDidChange,Ht.all.onDidChange):Ht.mine.onDidChange}},Ti={createDiagnosticCollection(re){return ai.createDiagnosticCollection(Ue.identifier,re)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:re=>ai.getDiagnostics(re),getLanguages(){return ei.getLanguages()},setTextDocumentLanguage(re,me){return ei.changeLanguage(re.uri,me)},match(re,me){const Oe=yt.getDocumentData(me.uri)?.notebook;return(0,N.score)(H.LanguageSelector.from(re),me.uri,me.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(re,me,Oe){return ut.registerCodeActionProvider(Ue,gt(re),me,Oe)},registerDocumentPasteEditProvider(re,me,Oe){return(0,Ve.checkProposedApiEnabled)(Ue,"documentPaste"),ut.registerDocumentPasteEditProvider(Ue,gt(re),me,Oe)},registerCodeLensProvider(re,me){return ut.registerCodeLensProvider(Ue,gt(re),me)},registerDefinitionProvider(re,me){return ut.registerDefinitionProvider(Ue,gt(re),me)},registerDeclarationProvider(re,me){return ut.registerDeclarationProvider(Ue,gt(re),me)},registerImplementationProvider(re,me){return ut.registerImplementationProvider(Ue,gt(re),me)},registerTypeDefinitionProvider(re,me){return ut.registerTypeDefinitionProvider(Ue,gt(re),me)},registerHoverProvider(re,me){return ut.registerHoverProvider(Ue,gt(re),me,Ue.identifier)},registerEvaluatableExpressionProvider(re,me){return ut.registerEvaluatableExpressionProvider(Ue,gt(re),me,Ue.identifier)},registerInlineValuesProvider(re,me){return ut.registerInlineValuesProvider(Ue,gt(re),me,Ue.identifier)},registerDocumentHighlightProvider(re,me){return ut.registerDocumentHighlightProvider(Ue,gt(re),me)},registerLinkedEditingRangeProvider(re,me){return ut.registerLinkedEditingRangeProvider(Ue,gt(re),me)},registerReferenceProvider(re,me){return ut.registerReferenceProvider(Ue,gt(re),me)},registerRenameProvider(re,me){return ut.registerRenameProvider(Ue,gt(re),me)},registerDocumentSymbolProvider(re,me,Oe){return ut.registerDocumentSymbolProvider(Ue,gt(re),me,Oe)},registerWorkspaceSymbolProvider(re){return ut.registerWorkspaceSymbolProvider(Ue,re)},registerDocumentFormattingEditProvider(re,me){return ut.registerDocumentFormattingEditProvider(Ue,gt(re),me)},registerDocumentRangeFormattingEditProvider(re,me){return ut.registerDocumentRangeFormattingEditProvider(Ue,gt(re),me)},registerOnTypeFormattingEditProvider(re,me,Oe,...st){return ut.registerOnTypeFormattingEditProvider(Ue,gt(re),me,[Oe].concat(st))},registerDocumentSemanticTokensProvider(re,me,Oe){return ut.registerDocumentSemanticTokensProvider(Ue,gt(re),me,Oe)},registerDocumentRangeSemanticTokensProvider(re,me,Oe){return ut.registerDocumentRangeSemanticTokensProvider(Ue,gt(re),me,Oe)},registerSignatureHelpProvider(re,me,Oe,...st){return typeof Oe=="object"?ut.registerSignatureHelpProvider(Ue,gt(re),me,Oe):ut.registerSignatureHelpProvider(Ue,gt(re),me,typeof Oe>"u"?[]:[Oe,...st])},registerCompletionItemProvider(re,me,...Oe){return ut.registerCompletionItemProvider(Ue,gt(re),me,Oe)},registerInlineCompletionItemProvider(re,me){return me.handleDidShowCompletionItem&&(0,Ve.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(Ue,gt(re),me)},registerDocumentLinkProvider(re,me){return ut.registerDocumentLinkProvider(Ue,gt(re),me)},registerColorProvider(re,me){return ut.registerColorProvider(Ue,gt(re),me)},registerFoldingRangeProvider(re,me){return ut.registerFoldingRangeProvider(Ue,gt(re),me)},registerSelectionRangeProvider(re,me){return ut.registerSelectionRangeProvider(Ue,re,me)},registerCallHierarchyProvider(re,me){return ut.registerCallHierarchyProvider(Ue,re,me)},registerTypeHierarchyProvider(re,me){return ut.registerTypeHierarchyProvider(Ue,re,me)},setLanguageConfiguration:(re,me)=>ut.setLanguageConfiguration(Ue,re,me),getTokenInformationAtPosition(re,me){return(0,Ve.checkProposedApiEnabled)(Ue,"tokenInformation"),ei.tokenAtPosition(re,me)},registerInlayHintsProvider(re,me){return ut.registerInlayHintsProvider(Ue,re,me)},createLanguageStatusItem(re,me){return ei.createLanguageStatusItem(Ue,re,me)},registerDocumentDropEditProvider(re,me){return ut.registerDocumentOnDropEditProvider(Ue,re,me)}},Ki={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return Ze.activeTerminal},get terminals(){return Ze.terminals},async showTextDocument(re,me,Oe){const st=await(S.URI.isUri(re)?Promise.resolve(Kt.openTextDocument(re)):Promise.resolve(re));return At.showTextDocument(st,me,Oe)},createTextEditorDecorationType(re){return At.createTextEditorDecorationType(Ue,re)},onDidChangeActiveTextEditor(re,me,Oe){return At.onDidChangeActiveTextEditor(re,me,Oe)},onDidChangeVisibleTextEditors(re,me,Oe){return At.onDidChangeVisibleTextEditors(re,me,Oe)},onDidChangeTextEditorSelection(re,me,Oe){return At.onDidChangeTextEditorSelection(re,me,Oe)},onDidChangeTextEditorOptions(re,me,Oe){return At.onDidChangeTextEditorOptions(re,me,Oe)},onDidChangeTextEditorVisibleRanges(re,me,Oe){return At.onDidChangeTextEditorVisibleRanges(re,me,Oe)},onDidChangeTextEditorViewColumn(re,me,Oe){return At.onDidChangeTextEditorViewColumn(re,me,Oe)},onDidCloseTerminal(re,me,Oe){return Ze.onDidCloseTerminal(re,me,Oe)},onDidOpenTerminal(re,me,Oe){return Ze.onDidOpenTerminal(re,me,Oe)},onDidChangeActiveTerminal(re,me,Oe){return Ze.onDidChangeActiveTerminal(re,me,Oe)},onDidChangeTerminalDimensions(re,me,Oe){return(0,Ve.checkProposedApiEnabled)(Ue,"terminalDimensions"),Ze.onDidChangeTerminalDimensions(re,me,Oe)},onDidChangeTerminalState(re,me,Oe){return Ze.onDidChangeTerminalState(re,me,Oe)},onDidWriteTerminalData(re,me,Oe){return(0,Ve.checkProposedApiEnabled)(Ue,"terminalDataWriteEvent"),Ze.onDidWriteTerminalData(re,me,Oe)},get state(){return ge.state},onDidChangeWindowState(re,me,Oe){return ge.onDidChangeWindowState(re,me,Oe)},showInformationMessage(re,...me){return ki.showMessage(Ue,M.default.Info,re,me[0],me.slice(1))},showWarningMessage(re,...me){return ki.showMessage(Ue,M.default.Warning,re,me[0],me.slice(1))},showErrorMessage(re,...me){return ki.showMessage(Ue,M.default.Error,re,me[0],me.slice(1))},showQuickPick(re,me,Oe){return Qt.showQuickPick(re,me,Oe)},showWorkspaceFolderPick(re){return Qt.showWorkspaceFolderPick(re)},showInputBox(re,me){return Qt.showInput(re,me)},showOpenDialog(re){return Ri.showOpenDialog(re)},showSaveDialog(re){return Ri.showSaveDialog(re)},createStatusBarItem(re,me,Oe){let st,Dt,Rt;return typeof re=="string"?(st=re,Dt=me,Rt=Oe):(Dt=re,Rt=me),Oi.createStatusBarEntry(Ue,st,Dt,Rt)},setStatusBarMessage(re,me){return Oi.setStatusBarMessage(re,me)},withScmProgress(re){return Ae.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),ui.withProgress(Ue,{location:j.ProgressLocation.SourceControl},(me,Oe)=>re({report(st){}}))},withProgress(re,me){return ui.withProgress(Ue,re,me)},createOutputChannel(re,me){return Et.createOutputChannel(re,me,Ue)},createWebviewPanel(re,me,Oe,st){return ni.createWebviewPanel(Ue,re,me,Oe,st)},createWebviewTextEditorInset(re,me,Oe,st){return(0,Ve.checkProposedApiEnabled)(Ue,"editorInsets"),bi.createWebviewEditorInset(re,me,Oe,st,Ue)},createTerminal(re,me,Oe){return typeof re=="object"?"pty"in re?Ze.createExtensionTerminal(re):Ze.createTerminalFromOptions(re):Ze.createTerminal(re,me,Oe)},registerTerminalLinkProvider(re){return Ze.registerLinkProvider(re)},registerTerminalProfileProvider(re,me){return Ze.registerProfileProvider(Ue,re,me)},registerTerminalQuickFixProvider(re,me){return(0,Ve.checkProposedApiEnabled)(Ue,"terminalQuickFixProvider"),Ze.registerTerminalQuickFixProvider(re,Ue.identifier.value,me)},registerTreeDataProvider(re,me){return Wt.registerTreeDataProvider(re,me,Ue)},createTreeView(re,me){return Wt.createTreeView(re,me,Ue)},registerWebviewPanelSerializer:(re,me)=>ni.registerWebviewPanelSerializer(Ue,re,me),registerCustomEditorProvider:(re,me,Oe={})=>yi.registerCustomEditorProvider(Ue,re,me,Oe),registerFileDecorationProvider(re){return $e.registerFileDecorationProvider(re,Ue)},registerUriHandler(re){return St.registerUriHandler(Ue.identifier,re)},createQuickPick(){return Qt.createQuickPick(Ue)},createInputBox(){return Qt.createInputBox(Ue)},get activeColorTheme(){return li.activeColorTheme},onDidChangeActiveColorTheme(re,me,Oe){return li.onDidChangeActiveColorTheme(re,me,Oe)},registerWebviewViewProvider(re,me,Oe){return Di.registerWebviewViewProvider(Ue,re,me,Oe?.webviewOptions)},get activeNotebookEditor(){return pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,me,Oe){return pt.onDidChangeActiveNotebookEditor(re,me,Oe)},get visibleNotebookEditors(){return pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return pt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(re,me,Oe){return oi.onDidChangeNotebookEditorSelection(re,me,Oe)},onDidChangeNotebookEditorVisibleRanges(re,me,Oe){return oi.onDidChangeNotebookEditorVisibleRanges(re,me,Oe)},showNotebookDocument(re,me){return pt.showNotebookDocument(re,me)},registerExternalUriOpener(re,me,Oe){return(0,Ve.checkProposedApiEnabled)(Ue,"externalUriOpener"),Ii.registerExternalUriOpener(Ue.identifier,re,me,Oe)},registerProfileContentHandler(re,me){return(0,Ve.checkProposedApiEnabled)(Ue,"profileContentHandlers"),Ci.registrProfileContentHandler(Ue,re,me)},registerQuickDiffProvider(re,me,Oe,st){return(0,Ve.checkProposedApiEnabled)(Ue,"quickDiffProvider"),Ei.registerQuickDiffProvider(gt(re),me,Oe,st)},get tabGroups(){return Re.tabGroups}},Kt={get rootPath(){return Ae.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(re){throw k.readonly()},getWorkspaceFolder(re){return ht.getWorkspaceFolder(re)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(re){throw k.readonly()},get workspaceFile(){return ht.workspaceFile},set workspaceFile(re){throw k.readonly()},updateWorkspaceFolders:(re,me,...Oe)=>ht.updateWorkspaceFolders(Ue,re,me||0,...Oe),onDidChangeWorkspaceFolders:function(re,me,Oe){return ht.onDidChangeWorkspace(re,me,Oe)},asRelativePath:(re,me)=>ht.getRelativePath(re,me),findFiles:(re,me,Oe,st)=>ht.findFiles(re,me,Oe,Ue.identifier,st),findTextInFiles:(re,me,Oe,st)=>{(0,Ve.checkProposedApiEnabled)(Ue,"findTextInFiles");let Dt,Rt;return typeof me=="object"?(Dt=me,Rt=Oe):(Dt={},Rt=me,st=Oe),ht.findTextInFiles(re,Dt||{},Rt,Ue.identifier,st)},saveAll:re=>ht.saveAll(re),applyEdit(re,me){return Wi.applyWorkspaceEdit(re,Ue,me)},createFileSystemWatcher:(re,me,Oe,st)=>Ut.createFileSystemWatcher(ht,Ue,re,me,Oe,st),get textDocuments(){return yt.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw k.readonly()},openTextDocument(re){let me;const Oe=re;if(typeof re=="string")me=Promise.resolve(S.URI.file(re));else if(S.URI.isUri(re))me=Promise.resolve(re);else if(!Oe||typeof Oe=="object")me=yt.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return me.then(st=>yt.ensureDocumentData(st).then(Dt=>Dt.document))},onDidOpenTextDocument:(re,me,Oe)=>yt.onDidAddDocument(re,me,Oe),onDidCloseTextDocument:(re,me,Oe)=>yt.onDidRemoveDocument(re,me,Oe),onDidChangeTextDocument:(re,me,Oe)=>yt.onDidChangeDocument(re,me,Oe),onDidSaveTextDocument:(re,me,Oe)=>yt.onDidSaveDocument(re,me,Oe),onWillSaveTextDocument:(re,me,Oe)=>Jt.getOnWillSaveTextDocumentEvent(Ue)(re,me,Oe),get notebookDocuments(){return pt.notebookDocuments.map(re=>re.apiNotebook)},async openNotebookDocument(re,me){let Oe;if(S.URI.isUri(re))Oe=re,await pt.openNotebookDocument(re);else if(typeof re=="string")Oe=S.URI.revive(await pt.createNotebookDocument({viewType:re,content:me}));else throw new Error("Invalid arguments");return pt.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(re,me,Oe){return si.onDidSaveNotebookDocument(re,me,Oe)},onDidChangeNotebookDocument(re,me,Oe){return si.onDidChangeNotebookDocument(re,me,Oe)},get onDidOpenNotebookDocument(){return pt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return pt.onDidCloseNotebookDocument},registerNotebookSerializer(re,me,Oe,st){return pt.registerNotebookSerializer(Ue,re,me,Oe,(0,Ve.isProposedApiEnabled)(Ue,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(re,me,Oe)=>Li.onDidChangeConfiguration(re,me,Oe),getConfiguration(re,me){return me=arguments.length===1?void 0:me,Li.getConfiguration(re,me,Ue)},registerTextDocumentContentProvider(re,me){return qt.registerTextDocumentContentProvider(re,me)},registerTaskProvider:(re,me)=>(Ae.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),bt.registerTaskProvider(Ue,re,me)),registerFileSystemProvider(re,me,Oe){return(0,ze.combinedDisposable)($i.registerFileSystemProvider(Ue,re,me,Oe),xt.addFileSystemProvider(re,me))},get fs(){return xt.value},registerFileSearchProvider:(re,me)=>((0,Ve.checkProposedApiEnabled)(Ue,"fileSearchProvider"),Tt.registerFileSearchProvider(re,me)),registerTextSearchProvider:(re,me)=>((0,Ve.checkProposedApiEnabled)(Ue,"textSearchProvider"),Tt.registerTextSearchProvider(re,me)),registerRemoteAuthorityResolver:(re,me)=>((0,Ve.checkProposedApiEnabled)(Ue,"resolvers"),Pt.registerRemoteAuthorityResolver(re,me)),registerResourceLabelFormatter:re=>((0,Ve.checkProposedApiEnabled)(Ue,"resolvers"),Si.$registerResourceLabelFormatter(re)),onDidCreateFiles:(re,me,Oe)=>Ut.onDidCreateFile(re,me,Oe),onDidDeleteFiles:(re,me,Oe)=>Ut.onDidDeleteFile(re,me,Oe),onDidRenameFiles:(re,me,Oe)=>Ut.onDidRenameFile(re,me,Oe),onWillCreateFiles:(re,me,Oe)=>Ut.getOnWillCreateFileEvent(Ue)(re,me,Oe),onWillDeleteFiles:(re,me,Oe)=>Ut.getOnWillDeleteFileEvent(Ue)(re,me,Oe),onWillRenameFiles:(re,me,Oe)=>Ut.getOnWillRenameFileEvent(Ue)(re,me,Oe),openTunnel:re=>((0,Ve.checkProposedApiEnabled)(Ue,"tunnels"),De.openTunnel(Ue,re).then(me=>{if(!me)throw new Error("cannot open tunnel");return me})),get tunnels(){return(0,Ve.checkProposedApiEnabled)(Ue,"tunnels"),De.getTunnels()},onDidChangeTunnels:(re,me,Oe)=>((0,Ve.checkProposedApiEnabled)(Ue,"tunnels"),De.onDidChangeTunnels(re,me,Oe)),registerPortAttributesProvider:(re,me)=>((0,Ve.checkProposedApiEnabled)(Ue,"portsAttributes"),De.registerPortsAttributesProvider(re,me)),registerTimelineProvider:(re,me)=>((0,Ve.checkProposedApiEnabled)(Ue,"timeline"),Bi.registerTimelineProvider(re,me,Ue.identifier,Be.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:re=>((0,Ve.checkProposedApiEnabled)(Ue,"workspaceTrust"),ht.requestWorkspaceTrust(re)),onDidGrantWorkspaceTrust:(re,me,Oe)=>ht.onDidGrantWorkspaceTrust(re,me,Oe),registerEditSessionIdentityProvider:(re,me)=>((0,Ve.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(re,me)),onWillCreateEditSessionIdentity:(re,me,Oe)=>((0,Ve.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),ht.getOnWillCreateEditSessionIdentityEvent(Ue)(re,me,Oe))},fi={get inputBox(){return Ae.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),ci.getLastInputBox(Ue)},createSourceControl(re,me,Oe){return ci.createSourceControl(Ue,re,me,Oe)}},Gi={createCommentController(re,me){return wi.createCommentController(Ue,re,me)}},Bt={get activeDebugSession(){return ct.activeDebugSession},get activeDebugConsole(){return ct.activeDebugConsole},get breakpoints(){return ct.breakpoints},onDidStartDebugSession(re,me,Oe){return ct.onDidStartDebugSession(re,me,Oe)},onDidTerminateDebugSession(re,me,Oe){return ct.onDidTerminateDebugSession(re,me,Oe)},onDidChangeActiveDebugSession(re,me,Oe){return ct.onDidChangeActiveDebugSession(re,me,Oe)},onDidReceiveDebugSessionCustomEvent(re,me,Oe){return ct.onDidReceiveDebugSessionCustomEvent(re,me,Oe)},onDidChangeBreakpoints(re,me,Oe){return ct.onDidChangeBreakpoints(re,me,Oe)},registerDebugConfigurationProvider(re,me,Oe){return ct.registerDebugConfigurationProvider(re,me,Oe||_e.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,me){return ct.registerDebugAdapterDescriptorFactory(Ue,re,me)},registerDebugAdapterTrackerFactory(re,me){return ct.registerDebugAdapterTrackerFactory(re,me)},startDebugging(re,me,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?ct.startDebugging(re,me,{parentSession:Oe}):ct.startDebugging(re,me,Oe||{})},stopDebugging(re){return ct.stopDebugging(re)},addBreakpoints(re){return ct.addBreakpoints(re)},removeBreakpoints(re){return ct.removeBreakpoints(re)},asDebugSourceUri(re,me){return ct.asDebugSourceUri(re,me)}},mi={registerTaskProvider:(re,me)=>bt.registerTaskProvider(Ue,re,me),fetchTasks:re=>bt.fetchTasks(re),executeTask:re=>bt.executeTask(Ue,re),get taskExecutions(){return bt.taskExecutions},onDidStartTask:(re,me,Oe)=>bt.onDidStartTask(re,me,Oe),onDidEndTask:(re,me,Oe)=>bt.onDidEndTask(re,me,Oe),onDidStartTaskProcess:(re,me,Oe)=>bt.onDidStartTaskProcess(re,me,Oe),onDidEndTaskProcess:(re,me,Oe)=>bt.onDidEndTaskProcess(re,me,Oe)},xi={createNotebookController(re,me,Oe,st,Dt){return Zt.createNotebookController(Ue,re,me,Oe,st,(0,Ve.isProposedApiEnabled)(Ue,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(re,me)=>pt.registerNotebookCellStatusBarItemProvider(Ue,re,me),createRendererMessaging(re){return vi.createRendererMessaging(Ue,re)},createNotebookControllerDetectionTask(re){return(0,Ve.checkProposedApiEnabled)(Ue,"notebookKernelSource"),Zt.createNotebookControllerDetectionTask(Ue,re)},registerKernelSourceActionProvider(re,me){return(0,Ve.checkProposedApiEnabled)(Ue,"notebookKernelSource"),Zt.registerKernelSourceActionProvider(Ue,re,me)},onDidChangeNotebookCellExecutionState(re,me,Oe){return(0,Ve.checkProposedApiEnabled)(Ue,"notebookCellExecutionState"),Zt.onDidChangeNotebookCellExecutionState(re,me,Oe)}},Xi={t(...re){if(typeof re[0]=="string"){const me=re.shift(),Oe=!re||typeof re[0]!="object"?re:re[0];return It.getMessage(Ue.identifier.value,{message:me,args:Oe})}return It.getMessage(Ue.identifier.value,re[0])},get bundle(){return It.getBundle(Ue.identifier.value)},get uri(){return It.getBundleUri(Ue.identifier.value)}};return{version:mt.version,authentication:Vi,commands:di,comments:Gi,debug:Bt,env:Fi,extensions:qi,l10n:Xi,languages:Ti,notebooks:xi,scm:fi,tasks:mi,tests:ji,window:Ki,workspace:Kt,Breakpoint:j.Breakpoint,TerminalOutputAnchor:j.TerminalOutputAnchor,CallHierarchyIncomingCall:j.CallHierarchyIncomingCall,CallHierarchyItem:j.CallHierarchyItem,CallHierarchyOutgoingCall:j.CallHierarchyOutgoingCall,CancellationError:k.CancellationError,CancellationTokenSource:r.CancellationTokenSource,CandidatePortSource:f.CandidatePortSource,CodeAction:j.CodeAction,CodeActionKind:j.CodeActionKind,CodeActionTriggerKind:j.CodeActionTriggerKind,CodeLens:j.CodeLens,Color:j.Color,ColorInformation:j.ColorInformation,ColorPresentation:j.ColorPresentation,ColorThemeKind:j.ColorThemeKind,CommentMode:j.CommentMode,CommentThreadCollapsibleState:j.CommentThreadCollapsibleState,CommentThreadState:j.CommentThreadState,CompletionItem:j.CompletionItem,CompletionItemKind:j.CompletionItemKind,CompletionItemTag:j.CompletionItemTag,CompletionList:j.CompletionList,CompletionTriggerKind:j.CompletionTriggerKind,ConfigurationTarget:j.ConfigurationTarget,CustomExecution:j.CustomExecution,DebugAdapterExecutable:j.DebugAdapterExecutable,DebugAdapterInlineImplementation:j.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:j.DebugAdapterNamedPipeServer,DebugAdapterServer:j.DebugAdapterServer,DebugConfigurationProviderTriggerKind:_e.DebugConfigurationProviderTriggerKind,DebugConsoleMode:j.DebugConsoleMode,DecorationRangeBehavior:j.DecorationRangeBehavior,Diagnostic:j.Diagnostic,DiagnosticRelatedInformation:j.DiagnosticRelatedInformation,DiagnosticSeverity:j.DiagnosticSeverity,DiagnosticTag:j.DiagnosticTag,Disposable:j.Disposable,DocumentHighlight:j.DocumentHighlight,DocumentHighlightKind:j.DocumentHighlightKind,DocumentLink:j.DocumentLink,DocumentSymbol:j.DocumentSymbol,EndOfLine:j.EndOfLine,EnvironmentVariableMutatorType:j.EnvironmentVariableMutatorType,EvaluatableExpression:j.EvaluatableExpression,InlineValueText:j.InlineValueText,InlineValueVariableLookup:j.InlineValueVariableLookup,InlineValueEvaluatableExpression:j.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:j.InlineCompletionTriggerKind,EventEmitter:D.Emitter,ExtensionKind:j.ExtensionKind,ExtensionMode:j.ExtensionMode,ExternalUriOpenerPriority:j.ExternalUriOpenerPriority,FileChangeType:j.FileChangeType,FileDecoration:j.FileDecoration,FileDecoration2:j.FileDecoration,FileSystemError:j.FileSystemError,FileType:E.FileType,FilePermission:E.FilePermission,FoldingRange:j.FoldingRange,FoldingRangeKind:j.FoldingRangeKind,FunctionBreakpoint:j.FunctionBreakpoint,InlineCompletionItem:j.InlineSuggestion,InlineCompletionList:j.InlineSuggestionList,Hover:j.Hover,IndentAction:T.IndentAction,Location:j.Location,MarkdownString:j.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:j.ParameterInformation,PortAutoForwardAction:j.PortAutoForwardAction,Position:j.Position,ProcessExecution:j.ProcessExecution,ProgressLocation:j.ProgressLocation,QuickInputButtons:j.QuickInputButtons,Range:j.Range,RelativePattern:j.RelativePattern,Selection:j.Selection,SelectionRange:j.SelectionRange,SemanticTokens:j.SemanticTokens,SemanticTokensBuilder:j.SemanticTokensBuilder,SemanticTokensEdit:j.SemanticTokensEdit,SemanticTokensEdits:j.SemanticTokensEdits,SemanticTokensLegend:j.SemanticTokensLegend,ShellExecution:j.ShellExecution,ShellQuoting:j.ShellQuoting,SignatureHelp:j.SignatureHelp,SignatureHelpTriggerKind:j.SignatureHelpTriggerKind,SignatureInformation:j.SignatureInformation,SnippetString:j.SnippetString,SourceBreakpoint:j.SourceBreakpoint,StandardTokenType:j.StandardTokenType,StatusBarAlignment:j.StatusBarAlignment,SymbolInformation:j.SymbolInformation,SymbolKind:j.SymbolKind,SymbolTag:j.SymbolTag,Task:j.Task,TaskGroup:j.TaskGroup,TaskPanelKind:j.TaskPanelKind,TaskRevealKind:j.TaskRevealKind,TaskScope:j.TaskScope,TerminalLink:j.TerminalLink,TerminalQuickFixCommand:j.TerminalQuickFixCommand,TerminalQuickFixOpener:j.TerminalQuickFixOpener,TerminalLocation:j.TerminalLocation,TerminalProfile:j.TerminalProfile,TerminalExitReason:j.TerminalExitReason,TerminalQuickFixType:j.TerminalQuickFixType,TextDocumentSaveReason:j.TextDocumentSaveReason,TextEdit:j.TextEdit,SnippetTextEdit:j.SnippetTextEdit,TextEditorCursorStyle:O.TextEditorCursorStyle,TextEditorLineNumbersStyle:j.TextEditorLineNumbersStyle,TextEditorRevealType:j.TextEditorRevealType,TextEditorSelectionChangeKind:j.TextEditorSelectionChangeKind,TextDocumentChangeReason:j.TextDocumentChangeReason,ThemeColor:j.ThemeColor,ThemeIcon:j.ThemeIcon,TreeItem:j.TreeItem,TreeItem2:j.TreeItem,TreeItemCheckboxState:j.TreeItemCheckboxState,TreeItemCollapsibleState:j.TreeItemCollapsibleState,TypeHierarchyItem:j.TypeHierarchyItem,UIKind:b.UIKind,Uri:S.URI,ViewColumn:j.ViewColumn,WorkspaceEdit:j.WorkspaceEdit,DocumentDropEdit:j.DocumentDropEdit,DocumentPasteEdit:j.DocumentPasteEdit,InlayHint:j.InlayHint,InlayHintLabelPart:j.InlayHintLabelPart,InlayHintKind:j.InlayHintKind,RemoteAuthorityResolverError:j.RemoteAuthorityResolverError,ResolvedAuthority:j.ResolvedAuthority,SourceControlInputBoxValidationType:j.SourceControlInputBoxValidationType,ExtensionRuntime:j.ExtensionRuntime,TimelineItem:j.TimelineItem,NotebookRange:j.NotebookRange,NotebookCellKind:j.NotebookCellKind,NotebookCellExecutionState:j.NotebookCellExecutionState,NotebookCellData:j.NotebookCellData,NotebookData:j.NotebookData,NotebookRendererScript:j.NotebookRendererScript,NotebookCellStatusBarAlignment:j.NotebookCellStatusBarAlignment,NotebookEditorRevealType:j.NotebookEditorRevealType,NotebookCellOutput:j.NotebookCellOutput,NotebookCellOutputItem:j.NotebookCellOutputItem,NotebookCellStatusBarItem:j.NotebookCellStatusBarItem,NotebookControllerAffinity:j.NotebookControllerAffinity,NotebookControllerAffinity2:j.NotebookControllerAffinity2,NotebookEdit:j.NotebookEdit,NotebookKernelSourceAction:j.NotebookKernelSourceAction,PortAttributes:j.PortAttributes,LinkedEditingRanges:j.LinkedEditingRanges,TestResultState:j.TestResultState,TestRunRequest:j.TestRunRequest,TestRunRequest2:j.TestRunRequest2,TestMessage:j.TestMessage,TestTag:j.TestTag,TestRunProfileKind:j.TestRunProfileKind,TextSearchCompleteMessageType:dt.TextSearchCompleteMessageType,DataTransfer:j.DataTransfer,DataTransferItem:j.DataTransferItem,CoveredCount:j.CoveredCount,FileCoverage:j.FileCoverage,StatementCoverage:j.StatementCoverage,BranchCoverage:j.BranchCoverage,FunctionCoverage:j.FunctionCoverage,WorkspaceTrustState:j.WorkspaceTrustState,LanguageStatusSeverity:j.LanguageStatusSeverity,QuickPickItemKind:j.QuickPickItemKind,InputBoxValidationSeverity:j.InputBoxValidationSeverity,TabInputText:j.TextTabInput,TabInputTextDiff:j.TextDiffTabInput,TabInputTextMerge:j.TextMergeTabInput,TabInputCustom:j.CustomEditorTabInput,TabInputNotebook:j.NotebookEditorTabInput,TabInputNotebookDiff:j.NotebookDiffEditorTabInput,TabInputWebview:j.WebviewEditorTabInput,TabInputTerminal:j.TerminalEditorTabInput,TabInputInteractiveWindow:j.InteractiveWindowInput,TelemetryTrustedValue:le.TelemetryTrustedValue,LogLevel:Ke.LogLevel,EditSessionIdentityMatch:vt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=jt}),define(Ce[254],ke([1,0,253,33,2,247,7,16,238]),function(ie,e,r,k,D,M,S,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class T extends M.RequireInterceptor{j(){}getModule(b,m){for(const o of this.b){const s=o(b);if(s){b=s;break}}if(this.a.has(b))return this.a.get(b).load(b,m,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class N extends k.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=S.ExtensionRuntime.Webworker}async nb(){this.h.createInstance(y.ExtHostConsoleForwarder);const b=this.h.invokeFunction(r.createApiFactoryAndRegisterActors);this.r=this.h.createInstance(T,b,{mine:this.D,all:this.F}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.tb()}ob(b){return b.browser}async pb(b,m,o){m=m.with({path:E(m.path,".js")});const s=b?.identifier.value;s&&performance.mark(`code/extHost/willFetchExtensionCode/${s}`);const h=D.URI.revive(await this.v.$asBrowserUri(m)),p=await fetch(h.toString(!0));if(s&&performance.mark(`code/extHost/didFetchExtensionCode/${s}`),p.status!==200)throw new Error(p.statusText);const w=await p.text(),A=`${m.toString(!0)}#vscode-extension`,v=`${w}
//# sourceURL=${A}`;let i;try{i=new Function("module","exports","require",v)}catch(t){throw console.error(s?`Loading code for extension ${s} failed: ${t.message}`:`Loading code failed: ${t.message}`),console.error(`${m.toString(!0)}${typeof t.line=="number"?` line ${t.line}`:""}${typeof t.column=="number"?` column ${t.column}`:""}`),console.error(t),t}b&&await this.s.initializeLocalizedMessages(b);const d={},n={exports:d},a=t=>{const g=this.r.getModule(t,m);if(g===void 0)throw new Error(`Cannot load module '${t}'`);return g};try{return o.codeLoadingStart(),s&&performance.mark(`code/extHost/willLoadExtensionCode/${s}`),i(n,d,a),n.exports!==d?n.exports:d}finally{s&&performance.mark(`code/extHost/didLoadExtensionCode/${s}`),o.codeLoadingStop()}}async $setRemoteEnvironment(b){}async tb(b=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const m=Date.now()+b;for(;Date.now()<m&&!("__jsDebugIsReady"in globalThis);)await(0,O.timeout)(10)}}e.ExtHostExtensionService=N;function E(f,b){return f.endsWith(b)?f:f+b}}),define(Ce[255],ke([1,0,66,33,81,254]),function(ie,e,r,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.registerSingleton)(k.IExtHostExtensionService,M.ExtHostExtensionService,0),(0,r.registerSingleton)(D.IExtensionStoragePaths,D.ExtensionStoragePaths,0)}),define(Ce[263],ke([1,0,23,4,73,248,240,19,82,15,2,250,255]),function(ie,e,r,k,D,M,S,O,y,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const E=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const f=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(i){return/^(file|vscode-remote):/i.test(i)}const m=fetch.bind(self);function o(i){self.fetch=async function(d,n){return d instanceof Request||b(String(d))&&(d=(await i(N.URI.parse(String(d)))).toString(!0)),m(d,n)},self.XMLHttpRequest=class extends XMLHttpRequest{open(d,n,a,t,g){(async()=>(b(n.toString())&&(n=(await i(N.URI.parse(n.toString()))).toString(!0)),super.open(d,n,a??!0,t,g)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(d,n){if(/^file:/i.test(d.toString()))d=T.FileAccess.uriToBrowserUri(N.URI.parse(d.toString())).toString(!0);else if(/^vscode-remote:/i.test(d.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const t=`(${function(l){function C(ee){return typeof ee=="string"||ee instanceof URL?String(ee).replace(/^file:\/\//i,"vscode-file://vscode-app"):ee}const R=fetch.bind(self);self.fetch=function(ee,K){return ee instanceof Request?R(ee,K):R(C(ee),K)},self.XMLHttpRequest=class extends XMLHttpRequest{open(ee,K,L,B,P){return super.open(ee,C(K),L??!0,B,P)}};const V=importScripts.bind(self);self.importScripts=(...ee)=>{V(...ee.map(C))},V(l)}.toString()}('${d}'))`;n=n||{},n.name=n.name||O.basename(d.toString());const g=new Blob([t],{type:"application/javascript"}),c=URL.createObjectURL(g);return new i(c,n)}}else self.Worker=class extends S.NestedWorker{constructor(i,d){super(f,i,{name:O.basename(i.toString()),...d})}};const s=new class{constructor(){this.pid=void 0}exit(i){E()}async exists(i){return!0}async realpath(i){return i}};class h{constructor(){const d=new MessageChannel,n=new k.Emitter;let a=!1;f(d.port2,[d.port2]),d.port1.onmessage=t=>{const{data:g}=t;if(!(g instanceof ArrayBuffer)){console.warn("UNKNOWN data received",g);return}const c=r.VSBuffer.wrap(new Uint8Array(g,0,g.byteLength));if((0,D.isMessageOfType)(c,2)){a=!0,w("received terminate message from renderer");return}n.fire(c)},this.protocol={onMessage:n.event,send:t=>{if(!a){const g=t.buffer.buffer.slice(t.buffer.byteOffset,t.buffer.byteOffset+t.buffer.byteLength);d.port1.postMessage(g,[g])}}}}}function p(i){return new Promise(d=>{const n=i.onMessage(a=>{n.dispose();const t=JSON.parse(a.toString());i.send((0,D.createMessageOfType)(0)),d({protocol:i,initData:t})});i.send((0,D.createMessageOfType)(1))})}let w=i=>E();function A(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function v(){y.mark("code/extHost/willConnectToRenderer");const i=new h;return{onmessage(d){!A(d)||p(i.protocol).then(n=>{y.mark("code/extHost/didWaitForInitData");const a=new M.ExtensionHostMain(n.protocol,n.initData,s,null,d.data);o(t=>a.asBrowserUri(t)),w=t=>a.terminate(t)})}}}e.create=v})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f1b09237cd400d92987cf7a9681995e8011ef54c/core/vs/workbench/api/worker/extensionHostWorker.js.map
